  subroutine maincl_new(kaction,iprin)
  USE atomi
  USE General, only: cell,spacegr,celem,vetint,neutro
  USE atom_type_util
  USE variables
  USE connect_mod
  USE molpnew
  USE unit_cell
  USE elements
  USE sinterface, only: fillatom
  implicit none
  integer, intent(in) :: kaction,iprin
  type(atom_type), dimension(:), allocatable :: atom
  integer :: i,nat
  type(cell_type) :: cellt
  logical :: move
!
  call xyz_to_atom(atom,xyzs(:3,:nats),bfac,occr=xyzs(5,:),occh=occpch,nz=nz,lab=aLab,elem=celem)
  nat = numatoms(atom)
  atom%inte = vetint(:nat)
  do i=1,nat
     if (atom(i)%get_nz() < NZCONST .and. atom(i)%get_nz() /= 0) then
         !call atom(i)%set_specie_from_el(1,celem)
         call make_specie(atom,spacegr,celem,neutro)
         exit
     endif
  enddo
  nz(:nat) = atom(:)%get_nz()
  call atom_string(atom,celem)
  cellt = set_cell_type(cell)
  call calcola_occ(atom,spacegr,cellt)
  move = any(kblock(:nat) == 0)
  call create_connectivity(atom,lconn,set_cell_type(cell),spacegr,move=move)
  call bond_to_iconn(lconn,iconn)
  izpk(:numatoms(atom)) = (numelem(celem) - atom(:)%kscatt() + 1)*NZCONST
  call fillatom(atom)
!!!!Fill tabdst: lconn%n1,lconn%n2,teor. dist, current dist., or use conn_to_restraints
!!!!TODO: check atoms with unresonable distance
!
  end subroutine maincl_new

  subroutine maincl(kaction,iprin)
  USE atomi
  USE General, only: vetint
  implicit none
  integer, intent(in) :: kaction,iprin
  integer :: i
  logical :: kpr = .false.
  call maincl_old(kaction,iprin)
  if (kpr) then
      write(6,*)'===============================CALL MAINCL'
  endif
  !call maincl_new(kaction,iprin)
  if (kpr) then
      write(6,*)'AT,izpk,nz,xyzs()'
      do i=1,nats
         write(6,'(i5,i5,i5,5f10.3,2x,a,f10.3)')i,izpk(i),nz(i),xyzs(:5,i),aLab(i),vetint(i)
      enddo
      write(6,*)'===============================CALL MAINCL'
  endif
  end subroutine maincl
