   subroutine open_diffraction_patt(filnam, ier)
   USE fileutil
   USE General, only: StructureName, fname, ext, INP_FILE, OUT_FILE     !!!!!, alambda
   USE datasetmod
   USE molcom, only:ifProject
   USE strutil
   USE General, only:lo
   USE variables, only: dataset,cryst
   implicit none
   character*(*), intent(in) :: filnam
   integer                   :: ier
   integer                   :: iflag
   integer                   :: itype, iform, nlenn, jop, jopen, ier2
   integer                   :: i
   type(dataset_type) :: datas
!
!corr   call resize_dataset(dataset,1)
   call datas%open_file(filnam,ier) 
   if (ier == 0) then
       if (ifProject.ne.0) then   ! importante se esegui run successivi
           iflag = 2
!          comment the next line to add pattern
           call chiudi_bin(iflag) ! call InitExpo
       endif
       StructureName = file_rem_ext(file_get_name(filnam))
       call cryst(1)%set_name(StructureName)
       do i=1,size(fname)
          if (i /= INP_FILE .and. i /= OUT_FILE) then
              fname(i) = s_blank_delete(trim(StructureName)//ext(i))
          endif
       enddo
       fname(INP_FILE) = trim(filnam)
       fname(OUT_FILE) = trim(file_rem_ext(filnam))//ext(OUT_FILE)
!
       close(lo,iostat=ier)
       itype = 0
       iform = 1
       nlenn = 80
       jop = jopen(lo,fname(OUT_FILE),itype,iform,ier2)
!
       call push_back_dataset(dataset,datas)
       call work_on_pattern(dataset(1),filnam)
!
   endif
!
   return
   end

!---------------------------------------------------------------------------

   subroutine open_pattern(filnam,wavel,ier)
   USE datasetmod, only: ndataset,resize_dataset
   USE General, only: StructureName
   USE fileutil, only: file_get_name, file_rem_ext
   USE variables, only: dataset,cryst
   implicit none
   character(len=*), intent(in) :: filnam
   real, intent(in)             :: wavel
   integer, intent(out)         :: ier
   integer                      :: ndat
!
   call resize_dataset(dataset,1)
!corr   call push_back(dataset)
   ndat = ndataset(dataset)
   call dataset(ndat)%open_file(filnam,ier,wavel)
   if (ier == 0) then
       StructureName = file_rem_ext(file_get_name(filnam))
       call cryst(1)%set_name(StructureName)
       call work_on_pattern(dataset(ndat),filnam)
   endif
!
   end subroutine open_pattern

!---------------------------------------------------------------------------

   subroutine work_on_pattern(datas,filnam)
   USE Conteggi, only: npunti
   USE view, only: vedinew
   USE messagemod
   USE enable_amb
   USE datasetmod, only: dataset_type
   USE molcom, only: jscreen
   implicit none
   type(dataset_type), intent(in) :: datas
   character(len=*), intent(in)   :: filnam
!
   call dataset_to_expo(datas)

   if (jscreen > 0) then
       call AbilitaPaned(1)
       call init_messages()
       call write_message_pattern(filnam)
       call vedinew(8,1,npunti)
       call abilita_tasti('pattern')
              call wmenu_set_state('Range'//char(0),1)
       call SetWindowTitle(filnam)
!corr       call abilita_tasti('structure')
       call toolbar_set_state('continue'//char(0),2)
   endif

   call init_dati()
!
!  create background FIXME-non serve se fai una open_background
!   call fillcounts()
!   call back_for_peaksearch()
!!!!!test peak search
   !     call test_peaksearch()
!!!!!test peak search

!!!!!!!!!!!!!!!prova index
      !call run_indexing(filehpow, alambda, 'mcmaille')
      !call run_indexation(filehpow, alambda, 'dicvol')
      !call run_indexation(filehpow, alambda, 'ntreor')
!!!!!!!!!!!!!!!prova index

   end subroutine work_on_pattern
!---------------------------------------------------------------------------

!   subroutine test_peaksearch()
!   USE peak_mod
!   USE messagemod
!   USE Conteggi
!   USE view
!   USE proginterface, only:fillcounts
!!corr   USE indexing
!   integer :: ier
!   common /ksearch/ ksearch
!   integer :: ksearch
!   call fillcounts()
!   call back_for_peaksearch()
!   !call peaksearch(shiftzero,ier)
!   ksearch = 1
!   call peak1(ier)
!   call vedinew(5,1,npunti)
!   call write_message('Number of peaks: ',inum=npk,pos=2)
!   end subroutine test_peaksearch

!---------------------------------------------------------------------------
   
   subroutine dataset_to_expo(datas)
   USE datasetmod, only: dataset_type
   USE General, only:alambda, neutro, nsyn
   USE patternref, only:filehpow
   USE arrayutil
   USE indexing
   implicit none
   type(dataset_type), intent(in) :: datas
!
   if (size_array(datas%x) > 0) then
       call dataset_to_thetaint(datas)
       alambda = datas%wave(1)
       call init_indexation(alambda)
       filehpow = trim(datas%fname)
       neutro = datas%radtype
       if (datas%sync) then
           nsyn = 1
       else
           nsyn = 0
       endif
   endif
   end subroutine dataset_to_expo

!---------------------------------------------------------------------------

   subroutine dataset_to_thetaint(dataset)
   USE Conteggi
   USE PatternRef
   USE arrayutil
   USE datasetmod, only: dataset_type
   implicit none
   type(dataset_type), intent(in) :: dataset
!
   call AllocaConteggi(2)
   npunti = size_array(dataset%x)
   call AllocaConteggi(1)
   theta_int(:,1) = dataset%x
   theta_int(:,2) = dataset%y
   theta_int(:,7) = theta_int(:,1)
   theta_int(:,3:6) = 0.0
   thstep = dataset%tstep
   thmin = dataset%tmin
   thmax = dataset%tmax
!
   end subroutine dataset_to_thetaint


!---------------------------------------------------------------------------
   subroutine GenInfoV2
   USE General, only: knw,nrefl,cell,celem,spacegr,alambda,iscra,neutro,slopeWils,bt
   USE PhaseModule, only: numset,nset,erre
   USE Conteggi, only:npunti
   USE spginfom
   USE strutil
   USE elements
   USE atom_type_util
   USE variables, only:atm,ref
   USE stat
   USE reflection_type_util, only: fcalcang
   USE Patternref, only: thmin,thmax,thstep
   USE unit_cell
!
   implicit none
   dimension ipos(302),cfom(302),fom(11),ep(2000),iphb(2000)
   real :: fom,cfom,ep,vcell
   integer :: lsn,lfw,llw,lpb,ll16,ipos,iphb
   integer :: i,j,natom
   type(element_type), dimension(:), allocatable :: elem1
!
   write(iscra,'(" Pattern information:")')
   write(iscra,'(" Nr. of counts =",i6)')npunti
   write(iscra,'(" 2thetamin =",f9.3," 2thetamax =",f9.3," step =",f9.3)')thmin,thmax,thstep
   write(iscra,'(" Wavelength =",f10.6)') alambda
   write(iscra,*)
!
   if (all(cell(1:6) > 0)) then
       call print_cell(cell,kpr=iscra)
       write(iscra,*)
   endif
!
   call spacegr%prn(iscra,prlevel=1)
   write(iscra,*)
!
   natom = numatoms(atm)
   if(numelem(celem) > 0) then
      if (natom > 0) then
          call copy_elem(elem1,celem)
          call compute_content(atm,elem1,spacegr)
          call print_elements(elem1,iscra,neutro)
      else
          call print_elements(celem,iscra,neutro)
      endif
      write(iscra,*)
   endif
!
   if(abs(slopeWils).gt.0.0) then
       write(iscra,'(" Wilson Thermal Factor B(iso) = ",f7.3)') bt
       write(iscra,*)
   endif
!
   if (numset > 0) then
       call srlin(16,lsn,lfw,llw,lpb,ll16)
       if (lfw.gt.0) then
           write(iscra,'("                        Figures of Merit")')
           write(iscra,'("   Set  (trial)",1x,"  mabs  alcomb R(x,y)"," cphase  cfom",3x,"nund")')
           call ysfl16(cfom,ipos,nset)
           do j=1,nset
              i = ipos(j)
              call snr16(i,fom,ep,iphb)
              write(iscra,'(i6,"  (",i5,")",5f7.3,i6)') j,nint(fom(10)),(fom(i),i=1,5),nint(fom(6))
           enddo
       endif
       write(iscra,*)
   endif
!
   if (natom > 0) then  
       write(iscra,'(" Nr. of atoms in the asymmetric unit: ",i0)')natom
       if (nrefl > 0 .and. allocated(ref)) then
           call fcalcang(ref,atm,spacegr,celem)
           if (knw == 1) then
               erre = Rvalue(ref%fv,ref%fc)
           else
               erre = Rvalue(ref%fo,ref%fc)
           endif
           write(iscra,'(" R-f Fit: ",f0.3)') erre
       endif
       call print_atoms(atm,height=.true.,kpr=iscra)
       vcell = cell_volume(cell)
       write(iscra,'(" Volume per atom: ",f0.2," °A3")')volume_per_atom(atm,spacegr%nsymop,vcell)
       write(iscra,'(" Density:         ",f0.2," g/cm3")')    &
       density_value(molecular_weight(atm%ptab,atm%och*atm%ocry),vcell,spacegr%nsymop)
   endif
!
   end subroutine GenInfoV2

! -----------------------------------------------------------------

   subroutine run_indexing(sprog)
   USE indexing
   USE timer
   USE general, only: lo
   USE progtype, only: DISTRIBUTED_VER
   implicit none
   character(len=*), intent(in)                    :: sprog
   type(cell_info_type), dimension(:), allocatable :: pcell
   integer                                         :: ier
   logical                                         :: test = .true.
   type(timer_type)                                :: timeind
!   
   call timeind%set_as_elapsed()
   call timeind%tic()
   select case (sprog)
      case ('dicvol')
        call timeind%set_name(PINDEX_NAME(DICVOL06_PROG))
        call run_dicvol(indx_set(DICVOL06_PROG),pcell)
        call add_to_cell_list(cell_list,pcell)
      case ('mcmaille')
        call timeind%set_name(PINDEX_NAME(MCMAILLE_PROG))
        call run_mcmaille(indx_set(MCMAILLE_PROG),pcell)
        call add_to_cell_list(cell_list,pcell)
      case default
        !call ntreor(.false.,ier)
        !    write(0,*)'NTTREOR run'
        call timeind%set_name(PINDEX_NAME(NTREOR09_PROG))
        call run_ntreor(.false.,ier)
   end select
   call timeind%toc()
   call timeind%tprint(lo)
   call timeind%tprint(0)
!
   if (test .and. .not.DISTRIBUTED_VER) call test_indexing(cell_list)
!    
   end subroutine run_indexing

! -----------------------------------------------------------------

   subroutine save_cell_list(filnam)
!
!  Save cell list in a exp or txt file
!
   USE indexing
   USE fileutil
   USE strutil
   USE programinput
   implicit none
   character (len=*) :: filnam
   type(file_handle) :: cf
!
   filnam = remc0(filnam)
   if (s_eqi(get_extension(filnam),'exp')) then
       call write_input_file(input_file_create(filnam),'space',cell_list) 
   else
       call cf%fopen(filnam,'w')
       call print_cell_list(cell_list,cf%handle())
       call cf%fclose()
   endif
!
   end subroutine save_cell_list

MODULE datamod

   implicit none

CONTAINS

   subroutine manage_filefc(refob,ier)   
   USE General, only:nrefl, alambda, fname, FC_FILE, dtor, neutro, celem, lo, spacegr
   USE filereading
   !USE errormod
   !USE importexport
   USE fileutil
   USE TestModel
   USE reflection_type_util
   USE atom_type_util
   USE strutil
   USE elements, only:H_at
   USE connect_mod
   USE errormod
   USE fra_frm
   USE spginfom
   USE variables, only: cryst
   USE gen_frm
   USE unit_cell
   implicit none
   type(reflection_type), dimension(:), intent(inout) :: refob
   integer, intent(out)                               :: ier
   type(reflection_type), allocatable, dimension(:)   :: reffc
   type(error_type)                                   :: error
   integer                                            :: nrfc
   integer                                            :: fase
   integer                                            :: i,j
   type(bond_type), dimension(:), allocatable         :: legpub
   integer, dimension(3)                              :: hkl
   integer                                            :: is
   type(spaceg_type)                                  :: spgfc
   type(cell_type)                                    :: cellpub
   logical                                            :: is_bfac,is_occ,has_symmetry
!
   ier = 0
   if (s_eqi(get_extension(fname(FC_FILE)),'fc')) then    ! read F from .fc file
       refob(:)%fv = 0
       call read_reflection_file(fname(FC_FILE),reffc,nrfc,'fc',error)
       if (error%signal) then
           call error%print()
           ier = 1
       else
           do i=1,nrfc
              loop_sym: do is=1,spacegr%nsymop
                 !hkl(:) = matmul(reffc(i)%hkl,kmat(is,:,:))
                 hkl(:) = matmul(reffc(i)%hkl,spacegr%symop(is)%rot)
                 do j=1,nrefl
                    if (all(hkl == refob(j)%hkl)) then
                        fase=mod(reffc(i)%ph,360)
                        if(fase <= 0)fase=fase+360
                        refob(j)%fv = reffc(i)%fc
                        refob(j)%phv=refob(j)%phv+fase*32
                        exit loop_sym
                    endif
                 enddo
              enddo loop_sym
           enddo
!
!          read file .fra
           call read_fra_file(file_rem_ext(fname(FC_FILE))//'.fra',atmpub,is_bfac,is_occ,error)
           if (error%signal) then
               write(lo,'(a)')trim(error%message)
               write(lo,'(a)')'Match between Expo model and fragment is not possible!'
               return
           endif
           call specie_from_ptab(atmpub,celem)
       endif
   else                                                   ! try to read structure file
       allocate(reffc(nrefl))
       reffc(:) = refob(:nrefl)
       reffc(:)%slaq = (sin(0.5*refob(:nrefl)%tthd*dtor)/alambda)**2
       !has_symmetry = is_cell_defined_list()
       !  write(0,*)'CELL P=',cell(1:6)
       has_symmetry = .false.
         !write(0,*)'CELL P=',cryst(1)%get_cellpar()
         !write(0,*)'CELL P=',cryst(1)%get_cellpar()
       !call import_structure(fname(FC_FILE),0,atmpub,legpub,celem,cellfc,spgfc,.false.,has_symmetry,error)
       call import_crystal(fname(FC_FILE),ALL_FILES,atmpub,legpub,celem,cellpub,spgfc,has_symmetry,neutro,.false.,error)
       call cryst(1)%set_scattering(celem) ! update elements, published model could have different contents
         !write(0,*)'CELL D=',cell(1:6)
         !write(0,*)'CELL D=',cryst(1)%get_cellpar()
       if (error%signal) then
           ier = 1
       else           ! now compute fc
           call fcalcang(reffc,atmpub,spacegr,celem)
           do i=1,nrefl
              fase=mod(reffc(i)%ph,360)
              if(fase <= 0)fase=fase+360
              refob(i)%fv=reffc(i)%fc
              refob(i)%phv=refob(i)%phv+fase*32
           enddo
           if (neutro == 0) call remove_atoms_from_list(atmpub,atmpub%ptab,H_at)  ! remove H atoms
       endif
   endif
!
   end subroutine manage_filefc

!--------------------------------------------------------------------------------------

   subroutine set_wavelength(iwave,wavelength)
   USE General, only:alambda, ERR_WINDOW
   USE indexing
   integer, intent(inout) :: iwave      ! 1 if wavelength exists
   real, intent(in)       :: wavelength
   integer                :: exitcode
   if (iwave == 0 .and. wavelength > 0) then
       alambda = wavelength
       iwave = 1
       call init_indexation(alambda)
   endif
   if (iwave == 0) then
       call MsgWinErr('ERROR','No wavelength supplied',ERR_WINDOW,exitcode)
   endif
   end subroutine set_wavelength

!---------------------------------------------------------------------------

   subroutine expo_to_dataset(dataset)
   USE datasetmod
   USE Conteggi
   USE General, only:alambda,nsyn,neutro
   USE patternref, only:thmin,thmax,filehpow,thstep
   implicit none
   type(dataset_type), intent(inout) :: dataset
   if (npunti == 0) return
   call dataset%set_data(theta_int(:,1), theta_int(:,2),npunti,filehpow,POW_DATA)
   dataset%wave = alambda
   dataset%tstep = thstep
   dataset%sync = nsyn == 1
   dataset%radtype = neutro
   end subroutine expo_to_dataset

END MODULE datamod

   subroutine run_peaksearch()
   USE Conteggi, only: npunti, theta_int
   USE counts, only:deltatval,deltadval,delta_from_lambda
   USE peak_mod
   USE proginterface, only:fillcounts
   USE General, only:alambda
   USE variables, only: dataset
   USE arrayutil
   implicit none
   real, dimension(:), allocatable :: yc
   real, parameter                 :: SRANGE = 0.15 ! 2theta-range for peak_search at 1.54056
!
!  Subtract background
!corr   if (.not.allocated(dataset(1)%yb)) then
   if (size_array(dataset(1)%yb) /= npunti) then
       !call fillcounts()
       call dataset_to_thetaint(dataset(1))
       call back_for_peaksearch(.true.)
   endif
   allocate(yc(npunti))
   !where (backgr(:) > theta_int(:,2)) 
   !       yc(:) = 0
   !elsewhere
           yc(:) = theta_int(:,2) - dataset(1)%yb(:)
   !endwhere
!
!  compute srange
   !pkcond%srange = init_peak_range(theta_int(:,1),theta_int(:,2),alambda)
   pkcond%srange = init_peak_range(theta_int(:,1),yc,alambda)
   !write(0,*)'SRANGE =',pkcond%srange
!
   call peak_create(theta_int(:,1),yc,pkind,pkcond,pkindtot)
   pkcond%maxpk = -1 ! unset max number of peaks for GUI
   pkcond%minpk = -1 ! unset min number of peaks for GUI
!
   call update_peak_graph()
!
   end subroutine run_peaksearch

! ---------------------------------------------------------------------

   subroutine run_peaksearchwin()
!
!  When the user press the button 'Pattern' > 'Peak search'
!
   USE patternref, only: thmin,thmax
   USE peak_mod
!
!  Reset the range to create the array pkindtot
   pkcond%minp = thmin
   pkcond%maxp = thmax
!
   call run_peaksearch()
   end subroutine run_peaksearchwin

! ---------------------------------------------------------------------

   subroutine update_peak_graph()
   USE molcom, only: jscreen
   USE enable_amb
   USE messagemod
   !USE peak_util
   USE peak_mod
   USE view
!
   call write_message('Number of peaks: ',inum=numpeaks(pkind),pos=2)
!
   if (jscreen > 0) then
       call update_peak_list()
       call abilita_tasti('peaks',state=1)
       call vedinew(5)   !!!!,1,npunti)
   endif
!
   end subroutine update_peak_graph

! ---------------------------------------------------------------------

   subroutine search_peaks(iAction,statomin,statomax,search_value)
   USE VIEW
   USE General, only: alambda
   USE PatternRef
   USE peak_mod
   USE messagemod
   USE conteggi
!corr   USE counts
   USE variables, only: dataset
!
   implicit none
   integer                                          :: iAction
   real                                             :: statomin,statomax
   real, dimension(5)                               :: search_value
   type(peak_type), dimension(:), allocatable, save :: pksav
   type(peaks_condition_type), save                 :: pkconds
   type(peaks_condition_type)                       :: pkcond_def
   real                                             :: scaln
   integer :: npeak
!
   select case (iAction)
      case (0)    ! Cancel (reset the conditions)
        pkcond = pkconds
        call peak_copy(pkind,pksav)
        call write_message('Number of peaks: ',inum=numpeaks(pkind),pos=2)
        call vedinew()

      case (1)    ! Open window, pass variables to graphic, save settings
        if (.not.allocated(pkindtot)) then  
            if (.not.allocated(pkind)) then ! Peak search has been not performed
                call run_peaksearch()
            else                            ! Peaks from external file: create only array pkindtot
                pkcond%srange = init_peak_range(theta_int(:,1),theta_int(:,2),alambda)
                call peak_create(theta_int(:,1),theta_int(:,2)-dataset(1)%yb(:),pksav,pkcond,pkindtot)
            endif
        endif
        pkconds = pkcond
        call peak_copy(pksav,pkind)
        statomin = thmin
        statomax = thmax
        if (pkcond%minp > 0) then
            search_value(1) = pkcond%minp
        else
            search_value(1) = thmin
        endif
        if (pkcond%maxp > 0) then
            search_value(2) = pkcond%maxp
        else
            search_value(2) = thmax
        endif
        search_value(3) = pkcond%amp
        search_value(4) = numpeaks(pkind)
        search_value(5) = numpeaks(pkindtot)

      case (2:6)   ! Performe new peak search
!
        if (iAction == 6) then ! Default required by user
            search_value(1) = max(pkcond_def%minp,thmin)
            search_value(2) = max(pkcond_def%maxp,thmax)
            search_value(3) = pkcond_def%amp
        endif
        pkcond%minp = search_value(1)
        pkcond%maxp = search_value(2)
        pkcond%amp = search_value(3)
        if (numpeaks(pkindtot) == 0) return

        select case (iAction)
          case (2,3,4,6)        ! range (2,3), threshold (4),  default(6)
            call peak_copy(pkind,pkindtot)
            call filtrasog(pkind,pkcond%amp/100,npeak,code=1)
            call peak_select(pkind,pkcond%minp,pkcond%maxp,DELETE_PEAK,outside=.true.)
            call peak_delete_selected(pkind)
            call peak_sort(pkind,ORD_BY_X)
!corr            if (numpeaks(pkind) > 0) call set_intensities(pkind,theta_int(:,7),theta_int(:,2),backgr)
            search_value(4) = numpeaks(pkind)   ! force update of num. of peaks
            call update_peak_graph()

          case (5)            ! number of peaks was changed
            pkcond%maxpk = int(search_value(4))
            if (pkcond%maxpk == numpeaks(pkind)) return
            pkcond%amp = 0  
!
!           Recover peaks and intensities for compute new amp (necessary also if maxpk < numpeaks)
            call peak_copy(pkind,pkindtot)
            call filtrasog(pkind,pkcond%amp/100,npeak,code=1)
            call peak_select(pkind,pkcond%minp,pkcond%maxp,DELETE_PEAK,outside=.true.)
            call peak_delete_selected(pkind)
!
!           Select nmaxpk peaks for intensities
            call peak_sort(pkind,-ORD_BY_Y)
            scaln = 100 / maxval(pkindtot%gety())             ! recompute scale on all peaks
            if (numpeaks(pkind) > pkcond%maxpk) then
                pkcond%amp = pkind(pkcond%maxpk+1)%gety()*scaln   ! define new threshold
                search_value(3) = pkcond%amp                 ! force update of num. of peaks
                call reallocate_peaks(pkind,pkcond%maxpk)
            else   ! too peaks required!
                pkcond%amp = pkind(numpeaks(pkind))%gety()*scaln   ! define new threshold
                search_value(3) = pkcond%amp        ! force update of amplitude
                search_value(4) = numpeaks(pkind)   ! force update of num. of peaks
            endif
            call peak_sort(pkind,ORD_BY_X)
!corr            if (numpeaks(pkind) > 0) call set_intensities(pkind,theta_int(:,7),theta_int(:,2),backgr)
            call update_peak_graph()
         
        end select

   end select

   end subroutine search_peaks

! ---------------------------------------------------------------------

   subroutine cell_dialog(ier)
   USE PatternRef
   USE General, only: POW_FILE,ifAutomatic,lo,cell
   USE enable_amb
   USE commandsmod
   USE comandiexpo, only:icomat
   USE strutil, only:cutst,remc0,addc0
   USE sinterface
   USE molcom, only: jscreen
   USE indexing
   USE spginfom
   USE unit_cell
!
   implicit none
   integer, intent(out) :: ier
   common/spaceindexing /ispaceindexing,fspaceindex(660),    &
                      ntotmult1,ntotmult2,percind(660),errespac(660),lauecell(660)
   integer :: ispaceindexing,ntotmult1,ntotmult2
   real    :: percind,errespac,fspaceindex
   character(len=20) :: lauecell
   common/iesext/iesext
   integer :: iesext
   common /ksearch/ ksearch
   integer :: ksearch
   common /definespac/iesspacesav,itrial,irunextra,nlin
   integer :: iesspacesav,itrial,irunextra,nlin
   common /spacegroup/iesspace,shiftzero
   integer :: iesspace
   real :: shiftzero
   common /centering/CellType,CellAxis,nruntre,iesdircell
   integer :: nruntre,iesdircell
   character CellType,CellAxis*3
   common /prova_kalpha/ kalphasav
   integer :: kalphasav
   integer :: kfindspace
   character(len=:), allocatable  :: line
   integer :: ncell, icell
   type(spaceg_type) :: spgtemp
!
   ier = 0
   call ClearMessage()
!
   kcount_status = 1  ! attiva info riflessi sulla statusbar
   call print_cell_list(cell_list,lo,'List of plausible cell parameters:')
   if (ifAutomatic == 1 .or. jscreen == 0) then
       icell = 1     ! select the first cell
       call viewrefcell(icell)  
   else
       call toolbar_set_state('continue'//char(0),0)
       call abilita_tasti('indexwin',0)
       call abilita_tasti('peaks',0)
       ncell = number_of_cells(cell_list)
       kexitrun = 0
       call open_cell_dialog(ncell, cell_list, icell)
       call abilita_tasti('indexwin',1)
       call abilita_tasti('peaks',1)
       if (kexitrun /= 0) return  ! exit from File > Exit !!!!FIXME - non funziona se fai Pattern > Indexing
   endif
!
!  Exit for 'cancel' (icell=0); %end with -nogui or -auto; index is last command with -nogui or -auto
   if (icell == 0 .or. ( (jscreen == 0 .or. ifAutomatic == 1) .and.   &
      (next_command_is(commands,icomat,'end') .or. (icomat == ncommands(commands))))) then
       !call abilita_tasti('pattern')
       !call abilita_tasti('peaks',1)   !!!add abilita index
       if (jscreen > 0) call toolbar_set_state('continue'//char(0),2)
!!! reset this variables to avoid problems in data1 for new run with ntreor
!!!FIXME - check is necessary also for ntreor after structure solution
       irunextra = 0
       iesspacesav = 1
       itrial = 1
       kexitrun = 2  ! force exit from loop in gescom
       return
   endif
   if (jscreen > 0) call toolbar_set_state('continue'//char(0),1)
   write(lo,'(//a)')'       The following cell has been selected: '
   call print_cell(cell_list(icell)%par,cell_list(icell)%sd,cell_list(icell)%sys,kpr=lo)
!
   ispaceindexing = -1
   ksearch = 0
   iesdircell = 1
   iesext = 0
   iesspace = 1
   iesspacesav = 1
!
!  Recupera il gruppo spaziale se è presente la direttiva space
   line = get_string_directive(commands,'space')
   kfindspace = 1   ! forza check sul gruppo spaziale
   if (len_trim(line) > 0) then
!
!      Check compatibility between spg in input file and new cell
       spgtemp = init_spaceg_type(line)
       if (csys_from_cell(cell) == spgtemp%csys_code) then
           call set_spaceg(line)  ! spacegr is now defined
           call yfrm02
           kfindspace = 0 
       endif
   endif
!
   call cell_spg_dialog(kfindspace)
   if (kexitrun /= 0) return
!
   if (kfindspace == 1) then
!      findspace+export del file nome1.exp
!      nota che findspace azzera isspace
!      se ho dato peaksearch + findspace non rifaccio correzione kalpha
       kalphasav = 0
       if (kalpha.gt.0) then
           kalpha = 0
           kalphasav = 1
       endif
       call datanew(POW_FILE,.true.,.true.,ier)
!corr       if (kexitrun > 0 .or. ier /= 0) return
   endif
!
   kcount_status = 0
!
   return
   end subroutine cell_dialog

!-----------------------------------------------------------------------

   subroutine cell_spg_dialog(kfindspace)
   USE General, only: cell,celem,ifAutomatic,neutro,POW_FILE
   USE elements
   USE sinterface, only: spaceg_string
   USE commandsmod
   USE molcom, only: jscreen
   USE strutil
   USE PatternRef, only: kexitrun
   USE variables, only: cryst
   USE crystal_phase, only: get_strelem
   USE errormod
   USE unit_cell
   implicit none
   integer, intent(in) :: kfindspace
   character(len=18)  :: spacechar, spacecharold
   real, dimension(6) :: cellold
   type(element_type), dimension(:), allocatable :: elem,elemold
   character(len=256)    :: contentC
   integer :: i,iflagref,len_cont,kreturn,ier,npq
   common /definespac/iesspacesav,itrial,irunextra,nlin
   integer :: iesspacesav,itrial,irunextra,nlin
   common /spacegroup/iesspace,shiftzero
   integer :: iesspace
   real :: shiftzero
   common /centering/CellType,CellAxis,nruntre,iesdircell
   character CellType,CellAxis*3
   common/spaceindexing /ispaceindexing,fspaceindex(660),    &
          ntotmult1,ntotmult2,percind(660),errespac(660),lauecell(660)
   integer :: ispaceindexing,ntotmult1,ntotmult2
   real    :: percind,errespac,fspaceindex
   character(len=20) :: lauecell
   integer :: nruntre,iesdircell
   logical :: kgener
   type(error_type) :: err
!
   spacechar = spaceg_string()
!
!  Salva i vecchi valori delle variabili
   cellold(1:6) = cell(1:6)
   spacecharold = spacechar
   call copy_elem(elemold,celem)
!
!  Apri la finestra per modificare cella,gruppo spaziale, contenuto
   spacechar = trim(spacechar) // char(0)
   contentC = cryst(1)%get_strelem()
   if (len_trim(contentC) == 0) contentC = trim(get_string_directive(commands,'cont')) !!!corr //char(0)    !find content in input file
   if (len_trim(contentC) == 0) call chemical_formula(celem,contentC) !extract from celem if content is not in input file
   contentC = trim(contentC)//char(0)   !!FIXME - chiedi a rosi se serve
   !if (.not.(ifAutomatic == 1 .or. jscreen == 0)) then  !if auto or nogui jump this part
   if (ifAutomatic == 0 .and. jscreen /= 0) then  !if auto or nogui jump this part
       len_cont = 256
       call cell_parameters_dlg(cell,kfindspace,spacechar,contentC,kreturn,len_cont)
       if (kreturn == 0) then
           call toolbar_set_state('continue'//char(0),0)
           kexitrun = 2
           return  ! exit required by user
       endif
   endif
   iesspace = kfindspace
   spacechar = remc0(spacechar)
   iesspacesav = iesspace
!
!  Convert string in new cell content
   call read_chemformula(remc0(contentC),ier,elem=elem)
   if (ier > 0 .or. numelem(elem) == 0) then
       kexitrun = 1
       return 
   else
       call elem_set_radiation(elem,neutro)
       call ordina_elements(elem,neutro)
   endif
!
!  update content if it has changed in type or number
   if (.not.equal_elements(elemold,elem)) then
       call copy_elem(celem,elem)
       call cryst(1)%set_scattering(celem)
       call cryst(1)%set_strelem(remc0(contentC))
       call WriteContInfo(npq,ier)    !!!FIXME
   endif
!
!  cell has been changed ...
   kgener = .false.
   if (.not.cryst(1)%is_cell()) then
!      cell may be undef. if Import xpd > Pattern > Space Group Determ.
       call frm01( (/(cell(i),i=1,6),(0.0,i=7,13)/) )
       call cryst(1)%set_unit_cell(set_cell_type(cell))
       iesdircell = 1
       kgener = .true.
   else
       if (any(abs(cellold(:) - cell(1:6)) > epsilon(1.0))) then   ! da migliorare
           call frm01( (/(cell(i),i=1,6),(0.0,i=7,13)/) )
           call cryst(1)%set_unit_cell(set_cell_type(cell))
           iesdircell = 1
           kgener = .true.
       endif
   endif
!
   if (kfindspace == 0) then
!
!      Prendi il gruppo spaziale dell'utente
       call make_new_spg(spacechar,1,err)
       if (err%signal) then
           call err%print()
           kexitrun = 1
           return
       endif
       call yfl02
!
       ispaceindexing = 0
!
       call gener(iflagref,1)
       call datanew(POW_FILE,.true.,.true.,ier) ! rigenera i riflessi
       call export_file_exp()

   else
!
!      spg may be undef. if Import xpd > Pattern > Space Group Determ.
       if (.not.cryst(1)%is_spg()) then
           call gener_findspace(ier)
           kgener = .true.
       endif
   endif
   if (kgener) call gener(iflagref,1)
!
   end subroutine cell_spg_dialog

!-----------------------------------------------------------------------
   subroutine gener(iflagref,kpr)
   USE Riflessi
   USE General, only:ihmx,rhomin,rhomax,dtor,lo,cell,nrefl,knw,alambda,spacegr
   USE Symmetry, only: kmat,tmat,nsym,icent,latt,jsys
   USE datamod, only: manage_filefc
   USE reflection_type_util, only:create_reflections, reflection_type
   USE counts, only: dvalue
   USE variables, only: cryst
   USE PatternRef, only: thmax,thmin
   implicit none
   integer, intent(out) :: iflagref
   integer, intent(in)  :: kpr
!corr   common/genob2/thmin,thmax,thstep
!corr   common/atomi_au/resoluz
   integer :: i,ier
!corr   real :: thmin,thmax,thstep,resoluz
   type(reflection_type), dimension(:), allocatable :: refob
   integer                                          :: nrefob
!
!corr   resoluz = dvalue(thmax)
!corr   rhomax = 1. / (2*resoluz)**2
   rhomax = 1. / (2*dvalue(thmax))**2
   rhomin = 1. / (2*dvalue(thmin))**2
!
   iflagref = 0
   call create_reflections(rhomin,rhomax,cell(:6),spacegr,kmat,tmat,nsym,jsys,icent,latt,alambda,refob,nrefob,ihmx)
!
   call AllocaRiflessi(2)
   nrefl = nrefob
   call AllocaRiflessi(1)
   if (knw > 0) then
       call manage_filefc(refob,ier)
       if (ier /= 0) knw = 0
   endif
   do i=1,nrefl
      IndHKL(i,1:3) = refob(i)%hkl(:)
      IndHKL(i,4) = 1
      IndHKL(i,5) = refob(i)%phv
      SetFob(i,1) = 0.0
      SetFob(i,2) = 0.0
      SetFob(i,3) = 0.0
      SetFob(i,4) = 0.0001
      TThet (i)   = refob(i)%tthd
      Mult  (i)   = refob(i)%m
      WHM   (i)   = 0.0
         !write(6,*)'REF=',IndHKL(i,:3),TThet(i),mult(i)
   enddo
   if (knw > 0) fxsav(:) = refob(:nrefl)%fv   ! :nrefl because refob is not reallocated
   nrefl = nrefob  ! set global varible nrefl after AllocaRiflessi
!
   if (nrefl > 3000) iflagref = 1             ! segnala che ci sono + di 3000 riflessi
   if (kpr > 0) then
       write(lo, '(16x,"*",7x,"Generated reflections information",10x,"*")')
       write(lo, '(16x,"*",50x,"*")')
       write(lo, '(16x,"*",9x,"rho min         = ",f8.5,15x,"*")') rhomin
       write(lo, '(16x,"*",9x,"rho max         = ",f8.5,15x,"*")') rhomax
!corr       write(lo, '(16x,"*",9x,"d (resolution)  = ",f8.5,15x,"*")') resoluz
       write(lo, '(16x,"*",9x,"d (resolution)  = ",f8.5,15x,"*")') dvalue(thmax)
       write(lo,'(16x,"*",9x,"reflections nr. = ",i8,15x, "*",/,16x,"*",9x,"h k l (max)     = ",3i4,11x,"*",/,16x,52("*"))') &
       nrefl,(ihmx(i),i=1,3)
   endif
   call cryst(1)%set_reflections(refob)
   end subroutine gener

!-----------------------------------------------------------------------

   subroutine unpack (ind,ih,kk,il)
   implicit none
   integer, intent(in)  :: ind
   integer, intent(out) :: ih, kk, il
   integer              :: is
   ih = ind/262144
   is = ind - 262144*ih
   kk = is/512-256
   il = is-512*(kk+256)-256
   return
   end

!----------------------------------------------------------------------
   real function rhof(p,jh,jk,jl)
   implicit none
   real, dimension(6), intent(in) :: p
   integer, intent(in)            :: jh,jk,jl
   real                           :: rho2
   rho2=p(1)*float(jh*jh)+p(2)*float(jk*jk)   &
    +p(3)*float(jl*jl)+p(4)*float(jh*jk)      &
    +p(5)*float(jh*jl)+p(6)*float(jk*jl)
   rhof=sqrt(rho2)
   end function rhof

!-----------------------------------------------------------------------

   real function ctheta(rho)
!
!-- compute 2-Theta value from ( sin(theta)/lambda ) ** 2
   USE General, only: alambda
   USE trig_constants
   implicit none
   real, intent(in) :: rho
   real :: theta
   theta=sqrt(rho)*alambda
   if (theta.gt.1.) theta=1.
   theta=asin(theta)*rtod
   ctheta=2.0*theta
   return
   end

!-----------------------------------------------------------------------

   subroutine open_cell_list()
   USE patternref, only: kexitrun
   USE indexing
   USE Conteggi, only: npunti
   USE variables, only: dataset
   implicit none
   integer :: ier
!
   if (number_of_cells(cell_list) == 0) return
!
!  scarica in theta_int
   call dataset_to_thetaint(dataset(1))
   call ysfr37(npunti)  ! for extra
!
   call init_recycle()  ! init for extra in cell_dialog (find space g.) and gescom
   call cell_dialog(ier)
   if (kexitrun > 0) return
   call restart_command()
!
   end subroutine open_cell_list

!---------------------------------------------------------------------

   subroutine restart_command()
   USE General, only: POW_FILE, card
   USE commandsmod
   USE comandiexpo
   USE molcom, only: jscreen
   implicit none
   integer :: iEnd, ier
   integer :: ip
!
   ip = command_position(commands,'data',back=.true.)
   call add_continue(commands,ip)
!
   !call print_commands(commands,0)
   Messages(:) = ' ' ! reset all messagges for sub. scr2
   call create_expo_commands(commands,ipcom,icomq,card)
   icomat = ip
   ipdir = sum(commands(:ip)%ndir)
   if (jscreen > 0) call WaitCursorOn()
   call gescom(POW_FILE,iEnd,ier)
   if (jscreen > 0) call WaitCursorOff()
!
   end subroutine restart_command
