#include "mrconfig.h"
#include "forcomm2.h"
#include "callbacks.h"

static char *speciell[NUMSPECIES];
static char *Species[NUMSPECIES];
static int   nspecpes;
extern char *fontn;
extern DIRECTinfo *cdirectgtk;
extern _Dialogo *dialogo;
//extern int kptr[1000];

static GtkWidget *labelling_dialog = NULL;
static GtkWidget *polpo_dialog = NULL;
static int val_coord = 0;
static int val_coord_p1 = 0;
static int val_coord_p2 = 0;
static int nspec_lab;
static int vspace = 4;
static const char *coordination[] = {"tetrahedric","octahedric"};
static const char *poliedro[] = {"tetrahedron","octahedron"};
//static float stato_lab[] = {2.50f, 0.5f, 1.80f, 0.5f};
static float stato_lab[] = {3.00f, 0.5f, 1.50, 0.5f};
static float stato_polpo[] = {1.60f, 0.2f, 0.2f};
//static char *Selection[] = {"Select by list","Select by mouse click"};
static int nats;
static char *Atomi[500];
static int gia_selezionato[500];
static GtkWidget *mainwin;
static int atompos;
static int num_atom_p1;
static int num_atom_p2;
static int select_polpo;
static int nscelte = 0;
static int spec_polpo2;
static int atomo1_polpo2;
static int atomo2_polpo2;

void set_line(GtkWidget *list, gpointer line, int nrow);
extern "C" int getnkno_(int no[]);
extern "C" void prendi_speciepes_(int *nspecpes, int *natsfort, int *ilim);
void reset_values_lab (GtkWidget *dlg)
{

    GtkWidget *framel, *radio, *list, *spin;

    framel = get_widget(dlg, "frame_value_lab");
    gtk_widget_set_sensitive(framel,FALSE);

    radio = get_widget(dlg, "hidden_radio");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);

    spin = get_widget(dlg, "spin_peaks");
    spin_button_set_value(spin,1);

    spin = get_widget(dlg, "spin_hhd");
    spin_button_set_value(spin,stato_lab[0]);

    spin = get_widget(dlg, "tollerance_hhd");
    spin_button_set_value(spin,stato_lab[1]);

    spin = get_widget(dlg,"spin_hld");
    spin_button_set_value(spin,stato_lab[2]);

    spin = get_widget(dlg, "tollerance_hld");
    spin_button_set_value(spin,stato_lab[3]);

    list = get_widget(dlg, "listaAtoms_lab");
    clear_list(list);

    list = get_widget(dlg,"listaAtomsSet");
    unselect_all(GTK_TREE_VIEW(list));
}

void
ok_labelling                              (GtkButton       *button,
                                        gpointer         user_data)
{
    GtkWidget *dlg;
    int ier;

    dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));

    if (nspec_lab == 0)
        {
           gtk_widget_set_sensitive(dlg,FALSE);
           ier = cMsgWinErr("WARNING", " One species must be selected! ",
                             WARN_WINDOW);
           if (ier == 1)
              gtk_widget_set_sensitive(dlg,TRUE);
        }
    else
        {

           reset_values_lab(dlg);
           gtk_widget_hide (dlg);
           finestra_modale_chiusa2();
           fortran_al_lavoro();
           cdirectgtk->nspec_lab = nspec_lab;
           c_startlabelling ();
           fine_lavoro();
        }
}

void
cancel_labelling                              (GtkButton       *button,
                                        gpointer         user_data)
{
    GtkWidget *dlg;
 
    dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
    
    reset_values_lab(dlg);
    gtk_widget_hide (dlg);
    finestra_modale_chiusa2();
}

//void call_openfile (GtkButton *button, gpointer user_data)
//{
//   open_file(NULL,user_data);       
//}

void accept_val_label(GtkButton *button, gpointer data)
{
   GtkWidget *framel, *radio, *list, *dlg, *spin;
   int ier = 0;
   char *riga;

   dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
   if (val_coord == 0)
        {
           gtk_widget_set_sensitive(dlg,FALSE);
           ier = cMsgWinErr("WARNING", "You should select coordination!",
                             WARN_WINDOW);
           if (ier == 1)
              gtk_widget_set_sensitive(dlg,TRUE);
         
        }
   else 
        {
           spin = get_widget(dlg, "spin_peaks");
           cdirectgtk->npeaks_lab[nspec_lab] = spin_button_get_value_as_int(spin);
//         g_print("Numero di picchi per la specie %d = %d\n",
//                             nspec_lab+1,cdirectgtk->npeaks_lab[nspec_lab]);

           if (nspec_lab == 0)
           {
              spin = get_widget(dlg, "spin_hhd");
              cdirectgtk->valori_lab[0] = (float) spin_button_get_value(spin);
//            g_print("Distanza pesante-pesante per la specie %d = %f\n",
//                             nspec_lab+1,cdirectgtk->valori_lab[0]);

              spin = get_widget(dlg, "tollerance_hhd");
              cdirectgtk->valori_lab[1] = (float) spin_button_get_value(spin);
//            g_print("Tolleranza pesante-pesante per la specie %d = %f\n",
//                             nspec_lab+1,cdirectgtk->valori_lab[1]);

              spin = get_widget(dlg, "spin_hld");
              cdirectgtk->valori_lab[2] = (float) spin_button_get_value(spin);
//            g_print("Distanza pesante-leggero per la specie %d = %f\n",
//                             nspec_lab+1,cdirectgtk->valori_lab[2]);

              spin = get_widget(dlg, "tollerance_hld");
              cdirectgtk->valori_lab[3] = (float) spin_button_get_value(spin);
//            g_print("Tolleranza pesante-leggero per la specie %d = %f\n",
//                             nspec_lab+1,cdirectgtk->valori_lab[3]);    
           }

           cdirectgtk->ncoord_lab[nspec_lab] = val_coord; 

           radio = get_widget(dlg, "hidden_radio");
           gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);

           framel = get_widget(dlg, "frame_lab");
           gtk_widget_set_sensitive(framel,FALSE);

           framel = get_widget(dlg, "frame_value_lab");
           gtk_widget_set_sensitive(framel,FALSE);
      
           list = get_widget(dlg, "listaAtoms_lab");
           riga = g_strdup_printf("Relabel %d %-5s %-11s h.h.d.= %.2f (%.2f)  h.l.d. = %.2f (%.2f)",
           cdirectgtk->npeaks_lab[nspec_lab],speciell[cdirectgtk->ispecie_lab[nspec_lab]-1],
           coordination[val_coord-1],
           cdirectgtk->valori_lab[0],cdirectgtk->valori_lab[1],
           cdirectgtk->valori_lab[2],cdirectgtk->valori_lab[3]);
           add_line_to_list(list, (gpointer) riga);

           nspec_lab++;
           val_coord = 0;
        }
}

void sel_to_label (GtkTreeSelection *selec, gpointer data)
{
   int ier = 0;
   GtkWidget *framel, *dlg;
   int isel, row = row_selected(selec);

   isel = (row != -1);
   
   dlg = gtk_widget_get_toplevel((GtkWidget *)data);
   if (isel)
   {
      if (nspec_lab == 2)
      {
           gtk_widget_set_sensitive(dlg,FALSE);
           ier = cMsgWinErr("WARNING", "Scemo! Solo due specie.",
                             WARN_WINDOW);
           if (ier == 1)
              gtk_widget_set_sensitive(dlg,TRUE);
         
      }
      else
      {
           cdirectgtk->ispecie_lab[nspec_lab] = row + 1; 
//         g_print("selezionata specie %d  = %s\n",cdirectgtk->ispecie_lab[nspec_lab],speciell[row]);

           framel = get_widget(dlg, "frame_lab");
           gtk_widget_set_sensitive(framel,TRUE);
           if (nspec_lab == 0)
           {
              framel = get_widget(dlg, "frame_value_lab");
              gtk_widget_set_sensitive(framel,TRUE);
           }

      }
   }
   else 
   {
           framel = get_widget(dlg, "frame_lab");
           gtk_widget_set_sensitive(framel, FALSE);
   }
}

void on_change_coord  (GtkToggleButton *togglebutton, gpointer user_data)
{
        if(gtk_toggle_button_get_active(togglebutton))
        {
           val_coord = GPOINTER_TO_INT(user_data) + 1;
//           cdirectgtk->ncoord_lab[nspec_lab] = val_coord; 
//         g_print("scelta coordinazione %d per specie %d\n",
//                         val_coord,nspec_lab+1);
        }
}

GtkWidget* create_labelling ()
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *hboxp;
  GtkWidget *frame;
  GtkWidget *frame1;
  GtkWidget *frame2;
  GtkWidget *list;
  GtkWidget *list_lab;
  GtkWidget *vbox2;
  GtkWidget *frame3;
  GtkWidget *vbox3;
  GSList *vbox3_group = NULL;
  GtkWidget *radiol[3];
  GtkWidget *table1;
  GObject *spinbuttonp_adj;
  GtkWidget *spinbuttonp;
  GObject *spinbutton1_adj;
  GtkWidget *spinbutton1;
  GObject *spinbutton2_adj;
  GtkWidget *spinbutton2;
  GObject *spinbutton3_adj;
  GtkWidget *spinbutton3;
  GObject *spinbutton4_adj;
  GtkWidget *spinbutton4;
  GtkWidget *label;
  GtkWidget *labelp;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *hbuttonbox1;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkWidget *button3;
  GtkWidget *hseparator1;

  int i;

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  g_object_set_data (G_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "Peak labelling procedure");

  vbox1 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window1), "vbox1", vbox1);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  hbox1 = hbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window1), "hbox1", hbox1);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  frame1 = gtk_frame_new ("Select species");
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (hbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 5);

  list = create_selection (window1, frame1, NULL, "listaAtomsSet", 0);
  set_selection_mode(list, GTK_SELECTION_SINGLE);
  set_widget_font(list, fontn);
  gtk_widget_show (list);
  updclistavec(list, (const gchar **)speciell, nspecpes, 1);

  frame = gtk_frame_new (NULL);
  g_object_set_data (G_OBJECT (window1), "frame_lab", frame);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox1), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 5);
  gtk_widget_set_sensitive(frame,FALSE);

  vbox2 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window1), "vbox2", vbox2);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (frame), vbox2);

  frame1 = NEW_FRAME ("Set value");
  g_object_set_data (G_OBJECT (window1), "frame_value_lab", frame1);
  gtk_widget_show (frame1);
  gtk_container_add (GTK_CONTAINER (vbox2), frame1);
//  gtk_container_set_border_width (GTK_CONTAINER (frame1), 5);
  gtk_widget_set_sensitive(frame1,FALSE);

  table1 = table_new (5, 2, FALSE);
  g_object_set_data (G_OBJECT (window1), "table1", table1);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame1, "align")), table1);
//  gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
  table_set_row_spacings (table1, 6);
  table_set_col_spacings (table1, 6);

  hseparator1 = hseparator_new ();
  gtk_widget_show (hseparator1);
  table_attach (table1, hseparator1, 0, 2, 2, 3, TRUE);

  label1 = gtk_label_new ("heavy atom to heavy atom distance (h.h.d.):");
  g_object_set_data (G_OBJECT (window1), "label1", label1);
  gtk_widget_show (label1);
  table_attach (table1, label1, 0, 1, 0, 1, TRUE);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_RIGHT);
  set_alignment (label1, 1, 0.5); //0.54f, 0.5);

  label2 = gtk_label_new ("tolerance:");
  g_object_set_data (G_OBJECT (window1), "label2", label2);
  gtk_widget_show (label2);
  table_attach (table1, label2, 0, 1, 1, 2, TRUE);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_RIGHT);
  set_alignment (label2, 1, 0.5);

  label3 = gtk_label_new ("heavy atom to light atom distance (h.l.d):");
  g_object_set_data (G_OBJECT (window1), "label3", label3);
  gtk_widget_show (label3);
  table_attach (table1, label3, 0, 1, 3, 4, TRUE);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_RIGHT);
  set_alignment (label3, 1, 0.5);

  label4 = gtk_label_new ("tolerance:");
  g_object_set_data (G_OBJECT (window1), "label4", label4);
  gtk_widget_show (label4);
  table_attach (table1, label4, 0, 1, 4, 5, TRUE);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_RIGHT);
  set_alignment (label4, 1, 0.5);

  spinbutton1_adj = adj_new (stato_lab[0], 1.80f, 5.0f, 0.05f, 0.05f);
  spinbutton1 = spin_button_new (GTK_ADJUSTMENT (spinbutton1_adj), 1, 2);
  g_object_set_data (G_OBJECT (window1), "spin_hhd", spinbutton1);
  gtk_widget_show (spinbutton1);
  table_attach(table1, spinbutton1, 1, 2, 0, 1, TRUE);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton1), 5);

  spinbutton2_adj = adj_new (stato_lab[1], 0.0f, 1.0f, 0.05f, 0.05f);
  spinbutton2 = spin_button_new (GTK_ADJUSTMENT (spinbutton2_adj), 1, 2);
  g_object_set_data (G_OBJECT (window1), "tollerance_hhd", spinbutton2);
  gtk_widget_show (spinbutton2);
  table_attach(table1, spinbutton2, 1, 2, 1, 2, TRUE);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton2), 5);

  spinbutton3_adj = adj_new (stato_lab[2], 1.40f, 5.0f, 0.05f, 0.05f);
  spinbutton3 = spin_button_new (GTK_ADJUSTMENT (spinbutton3_adj), 1, 2);
  g_object_set_data (G_OBJECT (window1), "spin_hld", spinbutton3);
  gtk_widget_show (spinbutton3);
  table_attach(table1, spinbutton3, 1, 2, 3, 4, TRUE);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton3), 5);

  spinbutton4_adj = adj_new (stato_lab[3], 0.0f, 1.0f, 0.05f, 0.05f);
  spinbutton4 = spin_button_new (GTK_ADJUSTMENT (spinbutton4_adj), 1, 2);
  g_object_set_data (G_OBJECT (window1), "tollerance_hld", spinbutton4);
  gtk_widget_show (spinbutton4);
  table_attach(table1, spinbutton4, 1, 2, 4, 5, TRUE); 
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton4), 5);

  frame2 = NEW_FRAME ("Select coordination");
  g_object_set_data (G_OBJECT (window1), "frame2", frame2);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox2), frame2, TRUE, TRUE, 8);
//  gtk_container_set_border_width (GTK_CONTAINER (frame2), 7);

  vbox3 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window1), "vbox3", vbox3);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (get_widget(frame2, "align")), vbox3);

  radiol[0] = RADIO_BUTTON_WITH_LABEL (vbox3_group, "Tetrahedral", LABELCOLOR);
  vbox3_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiol[0]));
  g_object_set_data (G_OBJECT (window1), "radiobutton1", radiol[0]);
  gtk_widget_show (radiol[0]);
  gtk_box_pack_start (GTK_BOX (vbox3), radiol[0], FALSE, FALSE, 0);

  radiol[1] = RADIO_BUTTON_WITH_LABEL (vbox3_group, "Octahedral", LABELCOLOR);
  vbox3_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiol[1]));
  g_object_set_data (G_OBJECT (window1), "radiobutton2", radiol[1]);
  gtk_widget_show (radiol[1]);
  gtk_box_pack_start (GTK_BOX (vbox3), radiol[1], FALSE, FALSE, 0);

  radiol[2] = RADIO_BUTTON_WITH_LABEL (vbox3_group, "", LABELCOLOR);
  vbox3_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiol[2]));
  g_object_set_data (G_OBJECT (window1), "hidden_radio", radiol[2]);
  gtk_box_pack_start (GTK_BOX (vbox3), radiol[2], FALSE, FALSE, 0);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiol[2]), TRUE);

  hboxp = hbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window1), "hboxp", hboxp);
  gtk_widget_show (hboxp);
  gtk_box_pack_start (GTK_BOX (vbox2), hboxp, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hboxp), 6);

  labelp = gtk_label_new ("Number of peaks to relabel:");
  g_object_set_data (G_OBJECT (window1), "labelp", labelp);
  gtk_widget_show (labelp);
  gtk_box_pack_start (GTK_BOX (hboxp), labelp, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (labelp), GTK_JUSTIFY_RIGHT);
  set_alignment (labelp, 0.54, 0.5);

  spinbuttonp_adj = adj_new (1, 1,(float) nats, 1, 10);
  spinbuttonp = spin_button_new (GTK_ADJUSTMENT (spinbuttonp_adj), 1, 0);
  g_object_set_data (G_OBJECT (window1), "spin_peaks", spinbuttonp);
  gtk_widget_show (spinbuttonp);
  gtk_box_pack_start (GTK_BOX (hboxp), spinbuttonp, FALSE, FALSE, 10);

#ifdef IN_GTK3
  label = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
  label = gtk_alignment_new(0.5f, 0.5f, 0.0f, 0.0f);
#endif

  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(vbox2), label, TRUE, TRUE, 0);

  button1 = xpm_button ("accept.xpm");
  g_object_set_data (G_OBJECT (window1), "button1", button1);
  gtk_container_add(GTK_CONTAINER(label), button1);
  gtk_widget_show (button1); 

  frame3 = gtk_frame_new ("List of atoms");
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox1), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 5);

  hbox1 = hbox_new(FALSE, vspace);
  gtk_widget_show(hbox1);
  gtk_container_add(GTK_CONTAINER(frame3), hbox1);

  list_lab = create_selection(window1, hbox1,NULL,"listaAtoms_lab", 0);
  set_widget_font(list_lab, fontn);
//  gtk_clist_set_column_auto_resize (GTK_CLIST(list_lab), 0,TRUE);

  hseparator1 = hseparator_new ();
  g_object_set_data (G_OBJECT (window1), "hseparator1", hseparator1);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, FALSE, FALSE, 0);

  hbuttonbox1 = hbutton_box_new ();
  g_object_set_data (G_OBJECT (window1), "hbuttonbox1", hbuttonbox1);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbuttonbox1, FALSE, TRUE, 10);
  gtk_button_box_set_layout(GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_SPREAD);

  button2 = GO_button();
  g_object_set_data (G_OBJECT (window1), "button2", button2);
  gtk_widget_show (button2);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button2);

  button3 =  CANCEL_button();
  g_object_set_data (G_OBJECT (window1), "button3", button3);
  gtk_widget_show (button3);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button3);

  /*  segnali  */
  g_signal_connect (G_OBJECT(button3), "clicked",
  G_CALLBACK(cancel_labelling), GINT_TO_POINTER(1));

  g_signal_connect(G_OBJECT(gtk_tree_view_get_selection(GTK_TREE_VIEW(list))), 
        "changed", G_CALLBACK(sel_to_label), list);

  g_signal_connect(G_OBJECT(button1), "clicked",
                     G_CALLBACK(accept_val_label), GINT_TO_POINTER(1));

  g_signal_connect(G_OBJECT(button2), "clicked",
                     G_CALLBACK(ok_labelling), GINT_TO_POINTER(1));

  for(i=0; i<2; i++)
  {
    g_signal_connect (G_OBJECT (radiol[i]), "toggled",
                      G_CALLBACK (on_change_coord),
                      GINT_TO_POINTER(i));
  }


  return window1;
}

void c_prendi_speciepes (int *nspecpes,int *natsfort, int *ilim)
{
       prendi_speciepes_(nspecpes,natsfort, ilim);
}

void open_label_dlg(GtkWidget *item, gpointer data)
{
     GtkWidget *list;
//     char sspeciel[80];
//     char *speciel=sspeciel;
     int ilim;
     int natsfort;
     int no[NUMSPECIES];

     nspec_lab = 0;
//     c_prendi_speciepes(&nspecpes,speciel);
     c_prendi_speciepes(&nspecpes,&natsfort,&ilim);
     nats=natsfort;
     if(nspecpes==0)
     {
        cMsgWinErr("ERROR", " No heavy species are present in the unit cell content. The procedure cannot be applied ",
                             WARN_WINDOW);
     }
     else
     {
     int nspec = getnkno_(no);
     int ks=0;
//corr-voglio le specie dalla piu' pesante     for (int nn=0; nn<nspec; nn++)
     for (int nn=nspec-1; nn >= 0; nn--)
     {
          if(no[nn] > ilim)
          {
             speciell[ks] = g_strdup(get_nth_element(no[nn]-1));
             cdirectgtk->npeaks_lab[ks] = 0;
             ks++;
          }
     }

     if(labelling_dialog == NULL)
           labelling_dialog = create_labelling();

     list = get_widget(labelling_dialog,"listaAtomsSet");
     set_widget_font(list, fontn);
     updclistavec(list, (const gchar **)speciell, nspecpes, 1);

     gtk_widget_show(labelling_dialog);
     finestra_modale_aperta2(labelling_dialog);
}
}

/*****************************************************************/
/*              POLPO                                            */
/*****************************************************************/

#if 0
void on_change_selectionp1  (GtkToggleButton *togglebutton, gpointer user_data)
{
     GtkWidget *list, *dlg;
     GtkWidget *framel, *radio;
     GtkWidget *notebook;
     int num_page;

     dlg = gtk_widget_get_toplevel(GTK_WIDGET(togglebutton));

     notebook = get_widget(dlg,"notebook_polpo");
     num_page = gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook));
//   g_print("Sono a pagina %d\n",num_page);

     select_polpo = GPOINTER_TO_INT(user_data); 
     if(gtk_toggle_button_get_active(togglebutton))
     {
        if (select_polpo == 0) 
        {
//          g_print("SELECT BY LIST\n",select_polpo);
            if (num_page == 0)        /* POLPO1 */
            {
              framel = get_widget(dlg, "framelista_polpo1");
              list = get_widget(dlg,"listaAtoms_polpo1");
              set_selection_mode(list, GTK_SELECTION_SINGLE);
            }
            else                      /* POLPO2 */
            {
              framel = get_widget(dlg, "framelista_polpo2");
              list = get_widget(dlg,"listaAtoms_polpo2");
              set_selection_mode(list, GTK_SELECTION_MULTIPLE);
            }
            gtk_widget_set_sensitive(framel,TRUE);
        }
        else
        {
//          g_print("SELECT BY MOUSE CLICK\n",select_polpo);

            if (num_page == 0)       /* POLPO1 */
            {
              framel = get_widget(dlg, "framelista_polpo1");
              gtk_widget_set_sensitive(framel,FALSE);

              g_object_set_data(G_OBJECT(mainwin), "lsq_dlg", dlg);
              mostra_tbg1lsq(mainwin, 2, 4);

//              framel = get_widget(dlg, "frame_polpo1");
//              gtk_widget_set_sensitive(framel,TRUE);

//              framel = get_widget(dlg, "selection_polpo1");
//              gtk_widget_set_sensitive(framel,FALSE);

//              framel = get_widget(dlg, "framelista_polpo1");
                radio = get_widget(dlg, "radio_hidden_selp1");
            }
            else                     /* POLPO2 */
            {
              g_object_set_data(G_OBJECT(mainwin), "lsq_dlg", dlg);
              mostra_tbg1lsq(mainwin, 2, 5);

//              framel = get_widget(dlg, "frame_specie_polpo2");
//              gtk_widget_set_sensitive(framel,TRUE);

//              framel = get_widget(dlg, "framelista_polpo2");
                radio = get_widget(dlg, "radio_hidden_selp2");
            }
              gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);
//            gtk_widget_set_sensitive(framel,FALSE);
        }
     }
}
#endif

static gboolean atoms_polpo1_select_func  (GtkTreeSelection  *selection,
			GtkTreeModel      *model,
			GtkTreePath       *path,
			gboolean           path_currently_selected,
			gpointer           data)
{
  int row = atoi(gtk_tree_path_to_string(path));
  GtkWidget *list = (GtkWidget *)data;

  if(!path_currently_selected && gia_selezionato[row])
     return FALSE;
  if(gia_selezionato[row] == 0)
  {
     gtk_widget_set_sensitive(get_widget(gtk_widget_get_toplevel(list), "frame_polpo1"),TRUE);
     atompos = row;
  }
  else
     gtk_widget_set_sensitive(get_widget(gtk_widget_get_toplevel(list), "frame_polpo1"),FALSE);
  return TRUE;
}
/*
void sel_to_polpo (GtkTreeSelection *selec, gpointer data)
{
   GtkWidget *framep, *dlg, *list = (GtkWidget *)data;
   int isel, row = row_selected(selec);
 
   isel = (row != -1);
   if(!isel)
      return;
   dlg = gtk_widget_get_toplevel(list);
   framep = get_widget(dlg, "frame_polpo1");
   if (gia_selezionato[row] == 0)
   {
      if (isel)
      {
         gtk_widget_set_sensitive(framep,TRUE);
//         g_print("Selezionato atomo : %s\n",Atomi[row]);
         atompos = row;
      }
      else 
      {
        gtk_widget_set_sensitive(framep,FALSE);
      }
   }
   else
   {
        gtk_widget_set_sensitive(framep,FALSE);
   }
}
*/

static gboolean atoms_polpo2_select_func  (GtkTreeSelection  *selection,
			GtkTreeModel      *model,
			GtkTreePath       *path,
			gboolean           path_currently_selected,
			gpointer           data)
{
  int row = atoi(gtk_tree_path_to_string(path));
  GtkWidget *framem, *dlg, *list = (GtkWidget *)data;
  GList *rowsel=NULL;

   rowsel = get_selections(list);
   nscelte = g_list_length(rowsel) + 1;

   if(!path_currently_selected && (nscelte > 2))
   {
       nscelte--;
       gdk_beep();
       return FALSE;
   }
   else
   {
       dlg = gtk_widget_get_toplevel(GTK_WIDGET(list));
       framem = get_widget(dlg, "frame_specie_polpo2");
       if (nscelte == 2)
       {
          gtk_widget_set_sensitive(framem,TRUE);
          atomo2_polpo2 = row+1;
       }
       else if (nscelte == 1)
       {
          gtk_widget_set_sensitive(framem,FALSE);
          atomo1_polpo2 = row+1;
       }
   }
   return TRUE;
}

/*
void sel_to_polpo2 (GtkTreeSelection *selec, gpointer data)
{
   GtkWidget *framem, *dlg, *list = (GtkWidget *) data;
   GList *rowsel=NULL;
   int row = 0;      // VA SISTEMATA!!!!!!!!!!

   rowsel = get_selections(list);
   nscelte = g_list_length(rowsel);

// g_print("NSCELTE = %d\n",nscelte); 
   if (nscelte > 2)
   {
       gdk_beep();
       unselect_row (list, row);
   }
   else
   {
       dlg = gtk_widget_get_toplevel(GTK_WIDGET(list));
       framem = get_widget(dlg, "frame_specie_polpo2");
       if (nscelte == 2)
       {
          gtk_widget_set_sensitive(framem,TRUE);
          atomo2_polpo2 = row+1;
       }
       else if (nscelte == 1)
       {
          gtk_widget_set_sensitive(framem,FALSE);
          atomo1_polpo2 = row+1;
       }
   }
}
*/

void sel_spec_polpo2 (GtkTreeSelection *selec, gpointer data)
{
//   int ier = 0;
   GtkWidget *vbox, *dlg, *list = (GtkWidget *)data;
   int isel, row = row_selected(selec);

   isel = (row != -1);
   dlg = gtk_widget_get_toplevel(GTK_WIDGET(list));
   vbox = get_widget(dlg, "vbox_polpo2");
   if (isel)
   {
      gtk_widget_set_sensitive(vbox,TRUE);
      spec_polpo2 = row+1;
   }
   else 
      gtk_widget_set_sensitive(vbox,FALSE);
}

void on_change_coordp1  (GtkToggleButton *togglebutton, gpointer user_data)
{
        if(gtk_toggle_button_get_active(togglebutton))
        {
           val_coord_p1 = GPOINTER_TO_INT(user_data) + 1;
//         g_print("scelta coordinazione %d per l'atomo %s\n",
//                         val_coord_p1,Atomi[atompos]);
        }
}

void on_change_coordp2  (GtkToggleButton *togglebutton, gpointer user_data)
{
        GtkWidget *button, *dlg;

        if(gtk_toggle_button_get_active(togglebutton))
        {
           val_coord_p2 = GPOINTER_TO_INT(user_data) + 1;
//         g_print("scelta coordinazione %d per l'atomo %s\n",
//                         val_coord_p2,Atomi[atompos]);
           dlg = gtk_widget_get_toplevel(GTK_WIDGET(togglebutton));
           button = get_widget(dlg, "button_accept_p2");
           gtk_widget_set_sensitive(button,TRUE);
        }
}

void on_change_method  (GtkToggleButton *togglebutton, gpointer user_data)
{
        if(gtk_toggle_button_get_active(togglebutton))
        {
          cdirectgtk->kmethod = GPOINTER_TO_INT(user_data);
//          g_print("Scelto metodo n. %d\n",cdirectgtk->kmethod);
        }
}
void accept_polpo1(GtkButton *button, gpointer data)
{
   GtkWidget *framel, *radio, *list, *dlg, *spin1, *spin2, *spin3;
   GtkWidget *list1;
   int ier = 0;
   char *riga;

   dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
   if (val_coord_p1 == 0)
   {
      gtk_widget_set_sensitive(dlg,FALSE);
      ier = cMsgWinErr("WARNING", "You should select coordination!",
                        WARN_WINDOW);
      if (ier == 1)
         gtk_widget_set_sensitive(dlg,TRUE);
    
   }
   else 
   {
      spin1 = get_widget(dlg,"spin_distancep1");
      spin2 = get_widget(dlg,"tolerance_dis_p1");
      spin3 = get_widget(dlg,"tolerance_ang_p1");
      list = get_widget(dlg,"listaAtoms_polpo");

      if (select_polpo == 0)      /* Selezione da lista */ 
      {
          gia_selezionato[atompos] = 1;

          list1 = get_widget(dlg,"listaAtoms_polpo1");
          riga = g_strdup_printf("%-3s (selected)",Atomi[atompos]);
          set_line(list1, (gpointer) riga, atompos);
//????               gtk_clist_set_selectable(GTK_CLIST(list1),atompos,FALSE);
          cdirectgtk->natomo_p1[num_atom_p1] = atompos+1;
          cdirectgtk->ncoord_p1[num_atom_p1] = val_coord_p1;
          cdirectgtk->dist_p1[num_atom_p1] = (float) spin_button_get_value(spin1);
          cdirectgtk->tol_dis_p1[num_atom_p1] = (float) spin_button_get_value(spin2);
          cdirectgtk->tol_ang_p1[num_atom_p1] = (float) spin_button_get_value(spin3);

          riga = g_strdup_printf("Build %-12s around %-3s with distance = %.2f (tol1 = %.2f, tol2 = %.2f)",
             poliedro[val_coord_p1-1],Atomi[atompos],cdirectgtk->dist_p1[num_atom_p1],
             cdirectgtk->tol_dis_p1[num_atom_p1],cdirectgtk->tol_ang_p1[num_atom_p1]);

          add_line_to_list(list, (gpointer) riga);
          unselect_row(list1, atompos);

          num_atom_p1++;
      }
#if 0
      else                       /* Selezione da mouse */
      {
          list1 = get_widget(dlg,"listaAtoms_polpo1");
          set_selection_mode(list1, GTK_SELECTION_SINGLE);
          i = 0;
          while(dialogo->kptrc[i] != 0)
          {
            if (gia_selezionato[dialogo->kptrc[i]-1] == 0)
            {
               gia_selezionato[dialogo->kptrc[i]-1] = 1;

               riga = g_strdup_printf("%-3s (selected)",Atomi[dialogo->kptrc[i]-1]);
               set_line(list1,(gpointer) riga, dialogo->kptrc[i]-1);
               cdirectgtk->natomo_p1[num_atom_p1+i] = dialogo->kptrc[i];
               cdirectgtk->ncoord_p1[num_atom_p1+i] = val_coord_p1;
               cdirectgtk->dist_p1[num_atom_p1+i] = (float) spin_button_get_value(spin1);
               cdirectgtk->tol_dis_p1[num_atom_p1+i] = (float) spin_button_get_value(spin2);
               cdirectgtk->tol_ang_p1[num_atom_p1+i] = (float) spin_button_get_value(spin3);
   
               riga = g_strdup_printf("Build %-12s around %-3s with distance = %.2f (tol1 = %.2f, tol2 = %.2f)",
                  poliedro[val_coord_p1-1],Atomi[dialogo->kptrc[i]-1],cdirectgtk->dist_p1[num_atom_p1],
                  cdirectgtk->tol_dis_p1[num_atom_p1],cdirectgtk->tol_ang_p1[num_atom_p1]);

               unselect_row(list1, dialogo->kptrc[i]-1);
               add_line_to_list(list, (gpointer) riga);
            }
            i++;
          }
          num_atom_p1 = num_atom_p1+i;
      }
#endif

      framel = get_widget(dlg, "frame_polpo1");
      gtk_widget_set_sensitive(framel,FALSE);

      radio = get_widget(dlg, "hidden_radiop1");
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);

      val_coord_p1 = 0;
   }
}

void accept_polpo2(GtkButton *button, gpointer data)
{
   GtkWidget *list, *radio, *dlg, *spin1, *spin2, *spin3;
   char *riga;
//   int ier = 0;

   dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));

   list = get_widget(dlg, "listaAtoms_polpo");
   spin1 = get_widget(dlg,"spin_distancep2");
   spin2 = get_widget(dlg,"tolerance_dis_p2");
   spin3 = get_widget(dlg,"tolerance_ang_p2");

   if (select_polpo == 0)        /* Selezione da lista */
   {
      cdirectgtk->dist_p2[num_atom_p2] = (float) spin_button_get_value(spin1);
      cdirectgtk->tol_dis_p2[num_atom_p2] = (float) spin_button_get_value(spin2);
      cdirectgtk->tol_ang_p2[num_atom_p2] = (float) spin_button_get_value(spin3);
      cdirectgtk->ncoord_p2[num_atom_p2] = val_coord_p2;
      cdirectgtk->nspec_p2[num_atom_p2] = spec_polpo2;
      cdirectgtk->natomo1_p2[num_atom_p2] = atomo1_polpo2;
      cdirectgtk->natomo2_p2[num_atom_p2] = atomo2_polpo2;

   riga = g_strdup_printf("Build %-12s between cations %-3s and %-3s in %-11s with distance = %.2f (tol1 = %.2f, tol2 = %.2f)\n",
          poliedro[val_coord_p2-1],Atomi[atomo1_polpo2-1],Atomi[atomo2_polpo2-1],
          Species[spec_polpo2-1],cdirectgtk->dist_p2[num_atom_p2],
      cdirectgtk->tol_dis_p2[num_atom_p2],cdirectgtk->tol_ang_p2[num_atom_p2]);
      add_line_to_list(list, (gpointer) riga);
   }
#if 0
   else                           /* Selezione da mouse click */
   {
      i = 0;
      j = 0;
      while(dialogo->kptrc[i] != 0)
      {
       cdirectgtk->dist_p2[num_atom_p2+j] = (float) spin_button_get_value(spin1);
       cdirectgtk->tol_dis_p2[num_atom_p2+j] = (float) spin_button_get_value(spin2);
       cdirectgtk->tol_ang_p2[num_atom_p2+j] = (float) spin_button_get_value(spin3);
       cdirectgtk->ncoord_p2[num_atom_p2+j] = val_coord_p2;
       cdirectgtk->nspec_p2[num_atom_p2+j] = spec_polpo2;
       cdirectgtk->natomo1_p2[num_atom_p2+j] = dialogo->kptrc[i];
       cdirectgtk->natomo2_p2[num_atom_p2+j] = dialogo->kptrc[i+1];
   riga = g_strdup_printf("Build %-12s between cations %-3s and %-3s in %-11s with distance = %.2f (tol1 = %.2f, tol2 = %.2f)\n",
          poliedro[val_coord_p2-1],Atomi[dialogo->kptrc[i]-1],Atomi[dialogo->kptrc[i+1]-1],
          Species[spec_polpo2-1],cdirectgtk->dist_p2[num_atom_p2],
      cdirectgtk->tol_dis_p1[num_atom_p2],cdirectgtk->tol_ang_p2[num_atom_p2]);
      add_line_to_list(list, (gpointer) riga);
       i=i+2;
       j++;
      }
   }
#endif

   list = get_widget(dlg, "listaAtoms_polpo2");
   unselect_all(GTK_TREE_VIEW(list));

   list = get_widget(dlg, "listaSpecie_polpo2");
   unselect_all(GTK_TREE_VIEW(list));

   radio = get_widget(dlg, "hidden_radiop2");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);

   gtk_widget_set_sensitive(GTK_WIDGET(button),FALSE);

   num_atom_p2++;
}

void pagepolpo1(GtkWidget *notebook, GtkWidget *window_polpo)
{
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *vbox3;
  GSList *vbox3_group = NULL;
  GtkWidget *hbox1;
  GtkWidget *frame;
  GtkWidget *frame1;
  GtkWidget *frame2;
  GtkWidget *frame_val;
  GtkWidget *list;
  GtkWidget *radiop1[3];
  GtkWidget *table1;
  GtkWidget *label;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  GObject *spinbutton1_adj;
  GtkWidget *spinbutton1;
  GObject *spinbutton2_adj;
  GtkWidget *spinbutton2;
  GObject *spinbutton3_adj;
  GtkWidget *spinbutton3;
  GtkWidget *button1;

  int i;

  vbox1 = vbox_new (FALSE,0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (notebook), vbox1);
  set_tab_label (GTK_NOTEBOOK (notebook), 0, "Polpo 1");

/*
  GtkWidget *hbox3, radio_sel[3];
  GSList *hbox3_group = NULL;
  frame1 = gtk_frame_new ("Select action");
  g_object_set_data (G_OBJECT (window_polpo), "selection_polpo1", frame1);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 5);

  hbox3 = hbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window_polpo), "hbox3", hbox3);
  gtk_widget_show (hbox3);
  gtk_container_add (GTK_CONTAINER (frame1), hbox3);

  radio_sel[0] = RADIO_BUTTON_WITH_LABEL (hbox3_group, "Select by list", LABELCOLOR);
  hbox3_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio_sel[0]));
  g_object_set_data (G_OBJECT (window_polpo), "radiobutton_sel1", radio_sel[0]);
  gtk_widget_show (radio_sel[0]);
  gtk_box_pack_start (GTK_BOX (hbox3), radio_sel[0], TRUE, TRUE, 0);

  radio_sel[1] = RADIO_BUTTON_WITH_LABEL (hbox3_group, "Select by mouse click", LABELCOLOR);
  hbox3_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio_sel[1]));
  g_object_set_data (G_OBJECT (window_polpo), "radiobutton_sel2", radio_sel[1]);
  gtk_widget_show (radio_sel[1]);
  gtk_box_pack_start (GTK_BOX (hbox3), radio_sel[1], TRUE, TRUE, 0);

  radio_sel[2] = RADIO_BUTTON_WITH_LABEL (hbox3_group, "", LABELCOLOR);
  hbox3_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio_sel[2]));
  g_object_set_data (G_OBJECT (window_polpo), "radio_hidden_selp1", radio_sel[2]);
  gtk_box_pack_start (GTK_BOX (hbox3), radio_sel[2], TRUE, TRUE, 0);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio_sel[2]), TRUE);
*/

  hbox1 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  frame1 = NEW_FRAME ("Select atom(s)", true);
  g_object_set_data (G_OBJECT (window_polpo), "framelista_polpo1", frame1);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (hbox1), frame1, TRUE, TRUE, 0);
//  gtk_container_set_border_width (GTK_CONTAINER (frame1), 5);
//  gtk_widget_set_sensitive(frame1,FALSE);
  gtk_widget_set_size_request (frame1, 180, 100);

  list = create_selection (window_polpo, get_widget(frame1, "align"), NULL, "listaAtoms_polpo1", 0);
  set_widget_font(list, fontn);
  gtk_widget_show (list);
  updclistavec(list, (const gchar **)Atomi, nats, 1);
  set_selection_mode(list, GTK_SELECTION_SINGLE);

  frame = gtk_frame_new (NULL);
  g_object_set_data (G_OBJECT (window_polpo), "frame_polpo1",frame);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox1), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 5);
  gtk_widget_set_sensitive(frame,FALSE);

  vbox2 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window_polpo), "vbox2", vbox2);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (frame), vbox2);

  frame2 = NEW_FRAME ("Select coordination");
  g_object_set_data (G_OBJECT (window_polpo), "frame2", frame2);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox2), frame2, FALSE, FALSE, 0);
//  gtk_container_set_border_width (GTK_CONTAINER (frame2), 7);

  vbox3 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window_polpo), "vbox3", vbox3);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (get_widget(frame2, "align")), vbox3);

  radiop1[0] = RADIO_BUTTON_WITH_LABEL (vbox3_group, "Tetrahedral", LABELCOLOR);
  vbox3_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiop1[0]));
  g_object_set_data (G_OBJECT (window_polpo), "radiobutton1", radiop1[0]);
  gtk_widget_show (radiop1[0]);
  gtk_box_pack_start (GTK_BOX (vbox3), radiop1[0], FALSE, FALSE, 0);

  radiop1[1] = RADIO_BUTTON_WITH_LABEL (vbox3_group, "Octahedral", LABELCOLOR);
  vbox3_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiop1[1]));
  g_object_set_data (G_OBJECT (window_polpo), "radiobutton2", radiop1[1]);
  gtk_widget_show (radiop1[1]);
  gtk_box_pack_start (GTK_BOX (vbox3), radiop1[1], FALSE, FALSE, 0);

  radiop1[2] = RADIO_BUTTON_WITH_LABEL (vbox3_group, "", LABELCOLOR);
  vbox3_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiop1[2]));
  g_object_set_data (G_OBJECT (window_polpo), "hidden_radiop1", radiop1[2]);
  gtk_box_pack_start (GTK_BOX (vbox3), radiop1[2], FALSE, FALSE, 0);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiop1[2]), TRUE);

  frame_val = NEW_FRAME ("Set value");
  g_object_set_data (G_OBJECT (window_polpo), "frame_value_polpo1", frame_val);
  gtk_widget_show (frame_val);
  gtk_box_pack_start (GTK_BOX (vbox2), frame_val, FALSE, FALSE, 10);

  table1 = table_new (3, 2, FALSE);
  g_object_set_data (G_OBJECT (window_polpo), "table1", table1);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame_val, "align")), table1);
//  gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
  table_set_row_spacings (table1, 6);
  table_set_col_spacings (table1, 6);

  label1 = gtk_label_new ("distance:");
  g_object_set_data (G_OBJECT (window_polpo), "label1", label1);
  gtk_widget_show (label1);
  table_attach (table1, label1, 0, 1, 0, 1, TRUE);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_RIGHT);
  set_alignment(label1, 1, 0.5);

  label2 = gtk_label_new ("tolerance for distance (tol1):");
  g_object_set_data (G_OBJECT (window_polpo), "label2", label2);
  gtk_widget_show (label2);
  table_attach (table1, label2, 0, 1, 1, 2, TRUE);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_RIGHT);
  set_alignment(label2, 1, 0.5);

  label3 = gtk_label_new ("tolerance for angle (tol2):");
  g_object_set_data (G_OBJECT (window_polpo), "label3", label3);
  gtk_widget_show (label3);
  table_attach (table1, label3, 0, 1, 2, 3, TRUE);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_RIGHT);
  set_alignment(label3, 1, 0.5);

  spinbutton1_adj = adj_new (stato_polpo[0], 0.9f, 3.0f, 0.05f, 0.05f);
  spinbutton1 = spin_button_new (GTK_ADJUSTMENT (spinbutton1_adj), 1, 2);
  g_object_set_data (G_OBJECT (window_polpo), "spin_distancep1", spinbutton1);
  gtk_widget_show (spinbutton1);
  table_attach(table1, spinbutton1, 1, 2, 0, 1);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton1), 5);

  spinbutton2_adj = adj_new (stato_polpo[1], 0.0f, 1.0f, 0.05f, 0.05f);
  spinbutton2 = spin_button_new (GTK_ADJUSTMENT (spinbutton2_adj), 1, 2);
  g_object_set_data (G_OBJECT (window_polpo), "tolerance_dis_p1", spinbutton2);
  gtk_widget_show (spinbutton2);
  table_attach(table1, spinbutton2, 1, 2, 1, 2);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton2), 5);

  spinbutton3_adj = adj_new (stato_polpo[2], 0.0f, 1.0f, 0.05f, 0.05f);
  spinbutton3 = spin_button_new (GTK_ADJUSTMENT (spinbutton3_adj), 1, 2);
  g_object_set_data (G_OBJECT (window_polpo), "tolerance_ang_p1", spinbutton3);
  gtk_widget_show (spinbutton3);
  table_attach(table1, spinbutton3, 1, 2, 2, 3);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton3), 5);

#ifdef IN_GTK3
  label = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
  label = gtk_alignment_new(0.5f, 0.5f, 0.0f, 0.0f);
#endif
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(vbox2), label, TRUE, TRUE, 0);

  button1 = xpm_button ("accept.xpm");
  g_object_set_data (G_OBJECT (window_polpo), "button_accept_p1", button1);
  gtk_container_add(GTK_CONTAINER(label), button1);
  gtk_widget_show (button1); 

//segnali
/*
  for(i=0; i<2; i++)
  {
    g_signal_connect (G_OBJECT (radio_sel[i]), "toggled",
                      G_CALLBACK (on_change_selectionp1),
                      GINT_TO_POINTER(i));
  }
*/

  gtk_tree_selection_set_select_function(gtk_tree_view_get_selection(GTK_TREE_VIEW(list)),
        atoms_polpo1_select_func, list, NULL);

  for(i=0; i<2; i++)
  {
    g_signal_connect (G_OBJECT (radiop1[i]), "toggled",
                      G_CALLBACK (on_change_coordp1),
                      GINT_TO_POINTER(i));
  }

  g_signal_connect(G_OBJECT(button1), "clicked",
                     G_CALLBACK(accept_polpo1), GINT_TO_POINTER(1));
}

void pagepolpo2(GtkWidget *notebook, GtkWidget *window_polpo, int nspec)
{
  GtkWidget *vbox1;
  GtkWidget *vbox3;
  GtkWidget *vbox4;
  GtkWidget *hboxm;
  GSList *hboxm_group = NULL;
  GtkWidget *radiom[3];
  GtkWidget *frame0;
  GtkWidget *frame1;
  GtkWidget *frame3;
  GtkWidget *frame4;
  GtkWidget *frame5;
  GtkWidget *frame6;
  GtkWidget *frame_val;
  GtkWidget *hbox1;
  GtkWidget *list;
  GtkWidget *list1;
  GSList *vbox4_group = NULL;
  GtkWidget *radiop2[3];
  GtkWidget *table1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  GObject *spinbutton1_adj;
  GtkWidget *spinbutton1;
  GObject *spinbutton2_adj;
  GtkWidget *spinbutton2;
  GObject *spinbutton3_adj;
  GtkWidget *spinbutton3;
  GtkWidget *label;
  GtkWidget *button1;

  int i;

  vbox1 = vbox_new (FALSE,0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (notebook), vbox1);
  set_tab_label (GTK_NOTEBOOK (notebook), 1, "Polpo 2");

  frame0 = NEW_FRAME ("Set method");
  gtk_widget_show (frame0);
  gtk_box_pack_start (GTK_BOX (vbox1), frame0, FALSE, FALSE, 0);
//  gtk_container_set_border_width (GTK_CONTAINER (frame0), 5);

  hboxm = hbox_new (FALSE, 0);
  gtk_widget_show (hboxm);
  gtk_container_add (GTK_CONTAINER (get_widget(frame0, "align")), hboxm);

  radiom[0] = RADIO_BUTTON_WITH_LABEL (hboxm_group, "Default", LABELCOLOR);
  hboxm_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiom[0]));
  g_object_set_data (G_OBJECT (window_polpo), "radiobuttonm1", radiom[0]);
  gtk_widget_show (radiom[0]);
  gtk_box_pack_start (GTK_BOX (hboxm), radiom[0], TRUE, TRUE, 0);

  radiom[1] = RADIO_BUTTON_WITH_LABEL (hboxm_group, "Fast", LABELCOLOR);
  hboxm_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiom[1]));
  gtk_widget_show (radiom[1]);
  gtk_box_pack_start (GTK_BOX (hboxm), radiom[1], TRUE, TRUE, 0);

  radiom[2] = RADIO_BUTTON_WITH_LABEL (hboxm_group, "Slow", LABELCOLOR);
  hboxm_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiom[2]));
  gtk_widget_show (radiom[2]);
  gtk_box_pack_start (GTK_BOX (hboxm), radiom[2], TRUE, TRUE, 0);

  frame1 = NEW_FRAME ("Select 2 cations between which the missing cation must be located");
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, TRUE, TRUE, 8);
//  gtk_container_set_border_width (GTK_CONTAINER (frame1), 5);

  hbox1 = hbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window_polpo), "hbox1", hbox1);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame1, "align")), hbox1);

/*
  GtkWidget *frame2, *vbox2, radio_sel[3];
  GSList *vbox2_group = NULL;
  frame2 = gtk_frame_new ("Select action");
  g_object_set_data (G_OBJECT (window_polpo), "selection_polpo2", frame2);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (hbox1), frame2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 5);

  vbox2 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window_polpo), "vbox2", vbox2);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (frame2), vbox2);

  radio_sel[0] = RADIO_BUTTON_WITH_LABEL (vbox2_group, "Select by list", LABELCOLOR);
  vbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio_sel[0]));
  g_object_set_data (G_OBJECT (window_polpo), "radiobutton_sel1", radio_sel[0]);
  gtk_widget_show (radio_sel[0]);
  gtk_box_pack_start (GTK_BOX (vbox2), radio_sel[0], FALSE, FALSE, 0);

  radio_sel[1] = RADIO_BUTTON_WITH_LABEL (vbox2_group, "Select by mouse click", LABELCOLOR);
  vbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio_sel[1]));
  g_object_set_data (G_OBJECT (window_polpo), "radiobutton_sel2", radio_sel[1]);
  gtk_widget_show (radio_sel[1]);
  gtk_box_pack_start (GTK_BOX (vbox2), radio_sel[1], FALSE, FALSE, 0);

  radio_sel[2] = RADIO_BUTTON_WITH_LABEL (vbox2_group,"", LABELCOLOR);
  vbox2_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio_sel[2]));
  g_object_set_data (G_OBJECT (window_polpo), "radio_hidden_selp2", radio_sel[2]);
  gtk_box_pack_start (GTK_BOX (vbox2), radio_sel[2], FALSE, FALSE, 0);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio_sel[2]), TRUE);
*/

  frame3 = gtk_frame_new ("Select two atoms");
  g_object_set_data (G_OBJECT (window_polpo), "framelista_polpo2", frame3);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (hbox1), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 5);
//  gtk_widget_set_sensitive(frame3,FALSE);

  list = create_selection (window_polpo, frame3, NULL, "listaAtoms_polpo2", 0);
  set_widget_font(list, fontn);
  gtk_widget_show (list);
  updclistavec(list, (const gchar **)Atomi, nats, 1);
  set_selection_mode(list, GTK_SELECTION_MULTIPLE);

  frame4 = NEW_FRAME ("Select missing cation");
  g_object_set_data (G_OBJECT (window_polpo), "frame_missing", frame4);
  gtk_widget_show (frame4);
  gtk_box_pack_start (GTK_BOX (vbox1), frame4, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame4), 5);

  hbox1 = hbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window_polpo), "hbox1", hbox1);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame4, "align")), hbox1);

  frame5 = gtk_frame_new ("Select species");
  g_object_set_data (G_OBJECT (window_polpo), "frame_specie_polpo2", frame5);
  gtk_widget_show (frame5);
  gtk_box_pack_start (GTK_BOX (hbox1), frame5, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame5), 5);
  gtk_widget_set_sensitive(frame5,FALSE);

  list1 = create_selection (window_polpo, frame5, NULL, "listaSpecie_polpo2", 0);
  set_selection_mode(list1, GTK_SELECTION_SINGLE);
  set_widget_font(list1, fontn);
  gtk_widget_show (list1);
  updclistavec(list1, (const gchar **)Species, nspec, 1);

  vbox3 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window_polpo), "vbox_polpo2", vbox3);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (hbox1), vbox3);
  gtk_widget_set_sensitive(vbox3,FALSE);

  frame6 = NEW_FRAME ("Select coordination");
  g_object_set_data (G_OBJECT (window_polpo), "frame6", frame6);
  gtk_widget_show (frame6);
  gtk_box_pack_start (GTK_BOX (vbox3), frame6, TRUE, TRUE, 0);
//  gtk_container_set_border_width (GTK_CONTAINER (frame6), 7);

  vbox4 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window_polpo), "vbox4", vbox4);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (get_widget(frame6, "align")), vbox4);

  radiop2[0] = RADIO_BUTTON_WITH_LABEL (vbox4_group, "Tetrahedral", LABELCOLOR);
  vbox4_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiop2[0]));
  g_object_set_data (G_OBJECT (window_polpo), "radiobutton1", radiop2[0]);
  gtk_widget_show (radiop2[0]);
  gtk_box_pack_start (GTK_BOX (vbox4), radiop2[0], FALSE, FALSE, 0);

  radiop2[1] = RADIO_BUTTON_WITH_LABEL (vbox4_group, "Octahedral", LABELCOLOR);
  vbox4_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiop2[1]));
  g_object_set_data (G_OBJECT (window_polpo), "radiobutton2", radiop2[1]);
  gtk_widget_show (radiop2[1]);
  gtk_box_pack_start (GTK_BOX (vbox4), radiop2[1], FALSE, FALSE, 0);

  radiop2[2] = RADIO_BUTTON_WITH_LABEL (vbox4_group,"", LABELCOLOR);
  vbox4_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiop2[2]));
  g_object_set_data (G_OBJECT (window_polpo), "hidden_radiop2", radiop2[2]);
  gtk_box_pack_start (GTK_BOX (vbox4), radiop2[2], FALSE, FALSE, 0);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiop2[2]), TRUE);

  frame_val = NEW_FRAME ("Set value");
  g_object_set_data (G_OBJECT (window_polpo), "frame_value_polpo2", frame_val);
  gtk_widget_show (frame_val);
  gtk_container_add (GTK_CONTAINER (vbox3), frame_val);
//  gtk_container_set_border_width (GTK_CONTAINER (frame_val), 5);

  table1 = table_new (3, 2, FALSE);
  g_object_set_data (G_OBJECT (window_polpo), "table1", table1);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame_val, "align")), table1);
//  gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
  table_set_row_spacings (table1, 6);
  table_set_col_spacings (table1, 6);

  label1 = gtk_label_new ("distance:");
  g_object_set_data (G_OBJECT (window_polpo), "label1", label1);
  gtk_widget_show (label1);
  table_attach (table1, label1, 0, 1, 0, 1, TRUE);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_RIGHT);
  set_alignment(label1, 1, 0.5);

  label2 = gtk_label_new ("tolerance for distance:");
  g_object_set_data (G_OBJECT (window_polpo), "label2", label2);
  gtk_widget_show (label2);
  table_attach (table1, label2, 0, 1, 1, 2, TRUE);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_RIGHT);
  set_alignment(label2, 1, 0.5);

  label3 = gtk_label_new ("tolerance for angle:");
  g_object_set_data (G_OBJECT (window_polpo), "label3", label3);
  gtk_widget_show (label3);
  table_attach (table1, label3, 0, 1, 2, 3, TRUE);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_RIGHT);
  set_alignment(label3, 1, 0.5);

  spinbutton1_adj = adj_new (stato_polpo[0], 0.9f, 3.0f, 0.05f, 0.05f);
  spinbutton1 = spin_button_new (GTK_ADJUSTMENT (spinbutton1_adj), 1, 2);
  g_object_set_data (G_OBJECT (window_polpo), "spin_distancep2", spinbutton1);
  gtk_widget_show (spinbutton1);
  table_attach(table1, spinbutton1, 1, 2, 0, 1);

  spinbutton2_adj = adj_new (stato_polpo[1], 0.0f, 1.0f, 0.05f, 0.05f);
  spinbutton2 = spin_button_new (GTK_ADJUSTMENT (spinbutton2_adj), 1, 2);
  g_object_set_data (G_OBJECT (window_polpo), "tolerance_dis_p2", spinbutton2);
  gtk_widget_show (spinbutton2);
  table_attach(table1, spinbutton2, 1, 2, 1, 2);

  spinbutton3_adj = adj_new (stato_polpo[1], 0.0f, 1.0f, 0.05f, 0.05f);
  spinbutton3 = spin_button_new (GTK_ADJUSTMENT (spinbutton3_adj), 1, 2);
  g_object_set_data (G_OBJECT (window_polpo), "tolerance_ang_p2", spinbutton3);
  gtk_widget_show (spinbutton3);
  table_attach(table1, spinbutton3, 1, 2, 2, 3);

#ifdef IN_GTK3
  label = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
  label = gtk_alignment_new(0.5f, 0.5f, 0.0f, 0.0f);
#endif
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(vbox1), label, TRUE, TRUE, 0);

  button1 = xpm_button ("accept.xpm");
  g_object_set_data (G_OBJECT (window_polpo), "button_accept_p2", button1);
  gtk_container_add(GTK_CONTAINER(label), button1);
  gtk_widget_show (button1); 
  gtk_widget_set_sensitive(button1,FALSE);

//segnali
/*
  for(i=0; i<2; i++)
  {
    g_signal_connect (G_OBJECT (radio_sel[i]), "toggled",
                      G_CALLBACK (on_change_selectionp1),
                      GINT_TO_POINTER(i));
  }
*/
  gtk_tree_selection_set_select_function(gtk_tree_view_get_selection(GTK_TREE_VIEW(list)),
        atoms_polpo2_select_func, list, NULL);

//  g_signal_connect(G_OBJECT(gtk_tree_view_get_selection(GTK_TREE_VIEW(list))),
//       "changed",  G_CALLBACK(sel_to_polpo2), list);

  g_signal_connect(G_OBJECT(gtk_tree_view_get_selection(GTK_TREE_VIEW(list1))),
       "changed",  G_CALLBACK(sel_spec_polpo2), list1);

  for(i=0; i<2; i++)
  {
    g_signal_connect (G_OBJECT (radiop2[i]), "toggled",
                      G_CALLBACK (on_change_coordp2),
                      GINT_TO_POINTER(i));
  }

  for(i=0; i<3; i++)
  {
    g_signal_connect (G_OBJECT (radiom[i]), "toggled",
                      G_CALLBACK (on_change_method),
                      GINT_TO_POINTER(i));
  }

  g_signal_connect(G_OBJECT(button1), "clicked",
                     G_CALLBACK(accept_polpo2), GINT_TO_POINTER(1));
}

void reset_values_polpo (GtkWidget *dlg)
{

    GtkWidget *radio, *list, *button, *notebook, *spin;

    spin = get_widget(dlg,"spin_distancep1");
    spin_button_set_value(spin,stato_polpo[0]);

    spin = get_widget(dlg,"tolerance_dis_p1");
    spin_button_set_value(spin,stato_polpo[1]);

    spin = get_widget(dlg,"tolerance_ang_p1");
    spin_button_set_value(spin,stato_polpo[2]);
 
//   radio = get_widget(dlg, "radio_hidden_selp1");
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);

//    framel = get_widget(dlg, "framelista_polpo1");
//    gtk_widget_set_sensitive(framel,FALSE);

    list = get_widget(dlg,"listaAtoms_polpo1");
    unselect_all(GTK_TREE_VIEW(list));
    updclistavec(list, (const gchar **)Atomi, nats, 1);

//    radio = get_widget(dlg, "hidden_radiop1");
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);


    spin = get_widget(dlg,"spin_distancep2");
    spin_button_set_value(spin,stato_polpo[0]);

    spin = get_widget(dlg,"tolerance_dis_p2");
    spin_button_set_value(spin,stato_polpo[1]);

    spin = get_widget(dlg,"tolerance_ang_p2");
    spin_button_set_value(spin,stato_polpo[2]);

//    radio = get_widget(dlg, "radio_hidden_selp2");
//    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);

//    framel = get_widget(dlg, "framelista_polpo2");
//    gtk_widget_set_sensitive(framel,FALSE);

    list = get_widget(dlg,"listaAtoms_polpo2");
    unselect_all(GTK_TREE_VIEW(list));

    list = get_widget(dlg,"listaSpecie_polpo2");
    unselect_all(GTK_TREE_VIEW(list));

    list = get_widget(dlg,"listaAtoms_polpo");
    clear_list(list);

    radio = get_widget(dlg, "hidden_radiop2");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);

    button = get_widget(dlg, "button_accept_p2");
    gtk_widget_set_sensitive(button,FALSE);

    notebook = get_widget(dlg,"notebook_polpo");
    gtk_notebook_set_current_page(GTK_NOTEBOOK(notebook),0);

    radio = get_widget(dlg, "radiobuttonm1");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);
}

void
ok_polpo                              (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *dlg, *list;
  int ier;

  dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
  if (num_atom_p1 == 0 && num_atom_p2 == 0)
  {
     gtk_widget_set_sensitive(dlg,FALSE);
     ier = cMsgWinErr("WARNING", " No selection! ",
                            WARN_WINDOW);
     if (ier == 1)
        gtk_widget_set_sensitive(dlg,TRUE);
  }
  else 
  {
     gtk_widget_hide (dlg);
     cdirectgtk->num_polpo1 = num_atom_p1;
     cdirectgtk->num_polpo2 = num_atom_p2;
     finestra_modale_chiusa2();
     c_startpolpo ();
     list = get_widget(polpo_dialog,"listaAtoms_polpo");
     clear_list(list);
  }

}


void
cancel_polpo                              (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *dlg;
 
  dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));

  reset_values_polpo(dlg);
  gtk_widget_hide (dlg);
  finestra_modale_chiusa2();
}

GtkWidget* create_polpo (int nspec)
{
  GtkWidget *window_polpo;
  GtkWidget *vbox1;
  GtkWidget *notebook;
  GtkWidget *hbuttonbox1;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;
  GtkWidget *frame3;
  GtkWidget *hbox1;
  GtkWidget *list_polpo;
  GtkWidget *hseparator1;

  window_polpo = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  g_object_set_data (G_OBJECT (window_polpo), "window_polpo", window_polpo);
  gtk_window_set_title (GTK_WINDOW (window_polpo), "POLyedra POwder procedure (POL.PO.)");

  vbox1 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window_polpo), "vbox1", vbox1);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window_polpo), vbox1);

  notebook = NewNotebook (vbox1);
  g_object_set_data (G_OBJECT (window_polpo), "notebook_polpo", notebook);
  //gtk_box_pack_start (GTK_BOX (vbox1), notebook, TRUE, TRUE, 0);
  gtk_widget_show (notebook);

  frame3 = gtk_frame_new ("List of selections");
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox1), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 5);

  hbox1 = hbox_new(TRUE, vspace);
  gtk_widget_show(hbox1);
  gtk_container_add(GTK_CONTAINER(frame3), hbox1);

  list_polpo = create_selection(window_polpo, hbox1,NULL,"listaAtoms_polpo", 0);
  gtk_widget_set_size_request (list_polpo, 80, 100);
//  gtk_clist_set_column_auto_resize (GTK_CLIST(list_polpo), 0,TRUE);

  hseparator1 = hseparator_new ();
  g_object_set_data (G_OBJECT (window_polpo), "hseparator1", hseparator1);
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, FALSE, FALSE, 0);

  hbuttonbox1 = hbutton_box_new ();
  g_object_set_data (G_OBJECT (window_polpo), "hbuttonbox1", hbuttonbox1);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbuttonbox1, FALSE, TRUE, 10);
  gtk_button_box_set_layout(GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_SPREAD);

  ok_button = GO_button();
  g_object_set_data (G_OBJECT (window_polpo), "ok_button", ok_button);
  gtk_widget_show (ok_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), ok_button);

  cancel_button =  CANCEL_button();
  g_object_set_data (G_OBJECT (window_polpo), "cancel_button", cancel_button);
  gtk_widget_show (cancel_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), cancel_button);


  pagepolpo1(notebook, window_polpo);
  pagepolpo2(notebook, window_polpo, nspec);

  /*segnali*/
//  g_signal_connect (G_OBJECT(buttonf), "clicked",
//                     G_CALLBACK(call_openfile), GINT_TO_POINTER(3));

  g_signal_connect(G_OBJECT(ok_button), "clicked",
                     G_CALLBACK(ok_polpo), GINT_TO_POINTER(1));

  g_signal_connect(G_OBJECT(cancel_button), "clicked",
                     G_CALLBACK(cancel_polpo), GINT_TO_POINTER(1));

  return window_polpo;
}

void open_polpo_dlg (GtkWidget *win, char *atoms, int natsfort)
{
  GtkWidget *list;
  int i;
  int   no[NUMSPECIES];
  int nspec = getnkno_(no);

  num_atom_p1 = 0; 
  num_atom_p2 = 0; 
  nats = natsfort;
  string_to_vector(atoms, Atomi);
  mainwin = win; 
  cdirectgtk->kmethod = 0;

  for(i=0; i<500; i++)
  {
    gia_selezionato[i] = 0;
  }

  for (int nn=0; nn<nspec; nn++)
      Species[nn] = g_strdup(get_nth_element_name(no[nn]-1));

  if(polpo_dialog == NULL)
        polpo_dialog = create_polpo(nspec);

  list = get_widget(polpo_dialog,"listaAtoms_polpo1");
  set_widget_font(list, fontn);
  updclistavec(list, (const gchar **)Atomi, nats, 1);

  list = get_widget(polpo_dialog,"listaAtoms_polpo2");
  set_widget_font(list, fontn);
  updclistavec(list, (const gchar **)Atomi, nats, 1);

  list = get_widget(polpo_dialog,"listaSpecie_polpo2");
  set_widget_font(list, fontn);
  updclistavec(list, (const gchar **)Species, nspec, 1);

  list = get_widget(polpo_dialog,"listaAtoms_polpo");
  set_widget_font(list, fontn);
  gtk_widget_show(polpo_dialog);

  finestra_modale_aperta2(polpo_dialog);
}

