#define ENTRY_SIZE 65
#define MESG_SIZE  80

/*--------------------------------------------------------------*/
/*   gtkintf: definition of actions                             */
/*--------------------------------------------------------------*/
/*                                                              */
/* action                                                       */
/*  -1 : Store config-file name in static array                 */
/*   0 : close the window                                       */
/*   1 : open the window                                        */
/*   2 : draw point at xv[0] yv[0]                              */
/*   3 : draw from x1, y1 to x2, y2                             */
/*   4 : draw from x1, y1 to x2, y2, color=*col, pensize=*col1  */
/*   5 : draw dashed line from x1, y1 to x2, y2                 */
/*   6 : draw shading line (x1,y1;x2,y2) color=*col, pensize=*z */
/*   7 : clear screen                                           */
/*   8 : set foreground color to col                            */
/*   9 : draw string (z chars) in position x,y                  */
/*  10 : draw circle center in  x,y ,diameter = z               */
/*  11 : fill circle center in  x,y ,diameter = z               */
/*  12 : draw dashed circle center in  x,y ,diameter = z        */
/*  13 : draw dash arc, center in  x1, y1, radius = z           */
/*  14 : draw z-points polygon using color col                  */
/*  15 : fill z-points polygon using color col                  */
/*  16 : Connect iz points using color = icol                   */
/*  17 : Draw rectangle with col filled with col1               */
/*  18 : Store atomic species in static array                   */
/*  19 : draw a pixmap (string) centered in xb,yb               */
/*  20 : draw ellipse center in  x,y ,hor.ax. x[1]              */
/*       xv[1] = horizontal axis , yv[1] = vertical axis        */
/*       xv[2] = starting angle , yv[2] = arc lenght            */
/*  21 : fill ellipse center in  x,y ,diameter = z              */
/*       xv[1] = horizontal axis , yv[1] = vertical axis        */
/*       xv[2] = starting angle , yv[2] = arc lenght            */
/*  22 : draw ellipse circle center in  x,y ,diameter = z       */
/*       xv[1] = horizontal axis , yv[1] = vertical axis        */
/*       xv[2] = starting angle , yv[2] = arc lenght            */
/*  13 : fill, center in  x1, y1, radius = z                    */
/*  30 : Allocate(*z=0)/Deallocate(*z=1) graphic buffer         */
/*  31 : draw palla for rods or Vandervaals                     */
/*  32 : draw rods                                              */
/*  33:  Draw cross center in x,y with col, size = z            */
/*  34:  Draw cross center in x,y with col, size = z            */
/*  44 : change font iz=1 -> proportional  iz=2 -> Non propor.  */
/*  70 : return in xv[0] the number of pix in string; iz=len(str*/
/*  80 : Rings the Bell                                         */
/*  81 : Change name to the window                              */
/*  82 : set(*z = 1)/unset(*z = 0)  flag grandi strutture       */
/*  83 : define colors in blocks of 3 rgb values                */
/*  85 : enable(*z = 1)/disable(*z = 0)  single iteration       */
/*  86 : makes single iteration                                 */
/*  90 : draw string (z chars) in position x,y                  */
/* 998 : ???????????????? boh ???????????????                   */
/* 999 : start gtk main loop                                    */
/*1000 : get program name                                       */
/*2000 : get input file name                                    */
/*3000 : get output file name                                   */

#include "mrconfig.h"
#include "aliasx.h"
#include "messages.h"
#include "toolbar.h"
#include "menubar.h"
#include "forcomm1.h"
#include <fcntl.h>
#include <locale.h>
#include <sir_application.h>

//mr#ifdef MAC_GTKPLUS
//	#include <sync-menu.h>
//mr	#include "ige-mac-menu.h"
//mr#endif

namespace gtkext {
       extern int default_filter_out;
                  };

static GCallback cb_for_set_tog   = G_CALLBACK(init_toggles);
static GCallback cb_for_mouse_press = G_CALLBACK(button_press);
static GCallback cb_for_mouse_release = G_CALLBACK(button_release);
static GCallback cb_for_mouse_move = G_CALLBACK(button_move);
static GCallback cb_for_delete = G_CALLBACK(on_mainwin_closing);
static GCallback cb_for_configure = G_CALLBACK(configure_area_expo);
static GCallback cb_for_recproj = G_CALLBACK(load_recent_project);

typedef struct {
                  int argc;
                  nomefile arg[3];
               } _args;

extern "C" _args args_;
_args *args = &args_;

typedef union {
                struct { int nogui, autom, indexing; float wavel;};
                struct { int v[3]; float  wavelen;};
              } param_options_type;
extern "C" void  expo2005_(param_options_type *p);

//corr gboolean lista15 = FALSE;
extern char prog_dir[MaxLenFilename];
extern bool ifSannel;
std::string TmpFile("");

//GtkWidget* create_menubar  (GtkWidget *winmain, mr_MenuItem items[]);
void abilitamb(GtkWidget *mwin, int stato);
void salva_stato_mb(GtkWidget *widget, gboolean stato_sav[]);
void set_icon (GtkWidget *window, const gchar *filename);
void getStructName(char *file1, char *file2);
gboolean statoinimb[6][150];

//GtkWidget* create_toolbar  (GtkWidget *winmain, mr_toolbar_entry tbEntries[]);
void abilitatb(GtkWidget *widget, int state);
void salva_stato_tb(GtkWidget *widget, gboolean stato_sav[]);
void quit_program (GtkWidget *widget, gpointer data);
void update_dime(int w, int h);
void open_peeklist(char *Inte, int *NumCan, int *MultiSel, int sel[], 
                  int *iExitC, int nats, char *Msg);
void compare_w(GtkWindow *winmain, const char *filnam, const char *filter, 
               int flags, const char *title);
char *filtrapercb(std::string &s);
void set_save_status(gpointer item2, int stato);

GtkWidget *xpm_checkmenu_item(const gchar *xpm_filename, const gchar *labeltext);

gboolean statoinitb[6][51];
const gchar *toolbarname[5]              = {"toolbar_main",
                                      "toolbar",
                                      "toolbar",
                                      "toolbar",
                                      "toolbar"};
GdkPoint *points;
PangoFontDescription *fontdescN, *fontdescP, *fontdescU;

GdkColor CurrentColor = {0, 1, 1, 1};
enum {crossx, cross, empty_circle, filled_circle,
          empty_square, filled_square};

/*-------------------------------------------------------------*/
/*          Local (private) variables                          */
/*-------------------------------------------------------------*/
char *pathvar;
static int ifProportional;
static GtkWidget *mainwin; 
static GtkWidget *drawingarea;
static GtkWidget *statusbar;
static gboolean allocated_colors = FALSE;
#if 0
static int NMESSAGES=12;
static bool AreaMessaggi = false;
#endif
/*-------------------------------------------------------------*/
/*          Global internal variables                          */
/*-------------------------------------------------------------*/

int Ascent,Descent, larSaveP, larSaveN, altSaveP, altSaveN, altSaveU, larSaveU;
GdkColor *BLACK, *BLUE, *GREEN, *CYAN, *RED, *MAGENTA, *BROWN, *WHITE, *GRAY,
         *LIGHTBLUE, *LIGHTGREEN, *LIGHTCYAN, *LIGHTRED, *LIGHTMAGENTA, 
         *YELLOW, *BRIGHTWHITE;
int      wmenu, hmenu;
int    *finestra;
int    puntatore;
unsigned char   *fbuffer;
extern int    kscrx,kscry, ifMaximized, xstart, ystart;
gpointer initial_pix;
gboolean show_toolbar = TRUE;
int Livcur = 0;
int redmax   = 255;
int greenmax = 255;
int bluemax  = 255;

int jscreen = 0;
int mainloop = 0;
//GtkWidget *viewer_window = NULL;
GdkVisual *visual;
GdkColor color[MAX_COLORS];
GdkColor color_req[MAX_COLORS];

extern char Internet_Browser[MAX_LEN];
extern style_type Style[NITEMS];
extern char myScratchFile[256];
//extern stringa *It;
static int curSmiley = 1;
int   nw[NUMSPECIES];
extern char *fontp;
extern char *fontn;
extern char *fontu;
int numColors;
int naColors;
float c_factor = 257.f;
extern char *filesir, *fileout;
extern char files_dir[256];
extern int  w_env;
gboolean single_it = TRUE;
int nSpec = 0;
GtkWidget *finestre[6];
int win_stack = 0;
int curSmileySav = 1;
signed char dash_list[2] = {'\1','\1'};
GdkCursor *cross_cursor, *default_cursor, *help_cursor, *wait_cursor,
          *hand_cursor, *zoom_cursor, *move_cursor;
GtkWidget *pixsmiley = NULL;
GdkPixbufAnimation *smil_buf[NUM_SMILEY];

static int wPrevious = -1, hPrevious = -1;
extern char *filebin;
extern _Dialogo *dialogo;
extern SWareRC *cSWareRC;
//extern WindoMess *winmess;
extern RecentPr *RP;

/* internally used functions */

int  prendi_parametro();
int get_autoupdate();
int last_update(bool flag);
void set_autoupdate(int val);
void dashed_line (int ix1, int iy1, int ix2, int iy2);
void dashed_circle (int ix, int iy, int ir);
void init_toggles2();
GtkWidget* create_mainwin  (int wi, int he);
gboolean on_configure_event (GtkWidget *widget, GdkEventConfigure *event,
                                 gpointer user_data);
//gboolean on_drawingarea1_expose_event (GtkWidget *widget, gpointer event,
//                                       gpointer user_data);
void mr_setfont(char c, char *fontname);
GtkWidget   *create_image               (const gchar *filename);
void       primecose                  (GtkWidget *mwin);
int altezza_viewer();
GtkWidget *CreateSideFrame(GtkWidget *main_window, int ori);
void do_configure(GtkWidget *widget, int w, int h);

#if 0
typedef struct {
                 GtkWidget *widget;
                 gpointer  pix;
                 char      *title;
                 int       width;
                 int       height;
                 int       ifResize;
                 void      (*cbResize)(int *, int *);
                 void      (*cbZoom)(int *);
               } _Viewer;
GtkWidget *CreateViewer(_Viewer *view);
#endif

extern "C" void mr_setenv_(char *stringa);
extern rgbCol bcolors[16], pal_colors[16];
extern rgbCol fcolors[16];

void ChangeCursor(GtkWidget *w, GdkCursor *cursor)
{
    GdkCursor *current = (GdkCursor *) get_object(w, "current_cursor");
    gdk_window_set_cursor(gtk_widget_get_window(w), cursor);
    g_object_set_data(G_OBJECT(w), "previous_cursor", current);
    g_object_set_data(G_OBJECT(w), "current_cursor", cursor);
}

gpointer getCurrentContext()
{
     if(!G_IS_OBJECT(finestre[0]))
        return NULL;
     return g_object_get_data(G_OBJECT(finestre[0]), 
             "currentContext");
}

gpointer getCurrentPix()
{
     if(!G_IS_OBJECT(finestre[0]))
        return NULL;
     return g_object_get_data(G_OBJECT(finestre[0]), 
             "currentPixmap");
}

gpointer getCurrentWindow()
{
     if(!G_IS_OBJECT(finestre[0]))
        return NULL;
     return  (GObject *) g_object_get_data(G_OBJECT(finestre[0]), 
             "currentWindow");
}

GdkColor *get_color(int new_color)
{
   return &(color[new_color]);
}

float *get_fcolor(int new_color)
{
   float *col = ToColor4f(&(color[new_color]));
   return col;
}

GdkColor get_foreground(int new_color)
{
     GdkColor *c = get_color(new_color);
     GdkColor colore = *c;
     return colore;
}

void setta_foreground(int new_color, gpointer context)
{
     GdkColor gdkcolor;
     gdkcolor = get_foreground(new_color);
     set_foreground(context, &gdkcolor);
}

void c_allocacolori(int flag)
{

    int i, j, ncolors;
    unsigned short red, green, blue;
    GdkColor colore;
//    gboolean success[512];
    

      ncolors = numColors;
//      if(allocated_colors)
//      {
//         ncolors = numColors - 16;
//         gdk_colormap_free_colors(cmap, color, ncolors);
//      }

      for (j = 0; j < 16; j++ )          /*colori di base */
      {
          red   = pal_colors[j].red;
          green = pal_colors[j].green;
          blue  = pal_colors[j].blue;
          color_req[j].red   = red;
          color_req[j].green = green;
          color_req[j].blue  = blue;
      }
      if(!allocated_colors)
      {
         for(i=0; i<16; i++)             /* colori fissi */
         {
             color_req[numColors-16+i].red   =  fcolors[i].red;
             color_req[numColors-16+i].green =  fcolors[i].green;
             color_req[numColors-16+i].blue  =  fcolors[i].blue;
         }
      }
      for(i=0; i<ncolors; i++)
      {
//         colo = g_strdup_printf("#%2.2x%2.2x%2.2x", color_req[i].red,
//                    color_req[i].green, color_req[i].blue);
//         if(gdk_color_parse(colo, &colore))
           {
              colore.red    = (unsigned short)((int)color_req[i].red*
                                   (int)c_factor);
              colore.green  = (unsigned short)((int)color_req[i].green*
                                   (int)c_factor);
              colore.blue   = (unsigned short)((int)color_req[i].blue*
                                   (int)c_factor);
              color[i].red = colore.red;
              color[i].green = colore.green;
              color[i].blue = colore.blue;
              color_req[i].red = colore.red;
              color_req[i].green = colore.green;
              color_req[i].blue = colore.blue;
           }
      }

//#ifdef USE_CMAP
//      naColors = gdk_colormap_alloc_colors (cmap, color,
//#endif                                       ncolors, FALSE, TRUE, success);
      allocated_colors = TRUE;
      dialogo->color_BLACK        = numColors-16;
      dialogo->color_BRIGHTWHITE  = numColors-15;
      dialogo->color_WHITE        = numColors-14;
      dialogo->color_GRAY         = numColors-13;
      dialogo->color_BLUE         = numColors-12;
      dialogo->color_GREEN        = numColors-11;
      dialogo->color_CYAN         = numColors-10;
      dialogo->color_RED          = numColors- 9;
      dialogo->color_MAGENTA      = numColors- 8;
      dialogo->color_BROWN        = numColors- 7;
      dialogo->color_LIGHTBLUE    = numColors- 6;
      dialogo->color_LIGHTGREEN   = numColors- 5;
      dialogo->color_LIGHTCYAN    = numColors- 4;
      dialogo->color_LIGHTRED     = numColors- 3;
      dialogo->color_LIGHTMAGENTA = numColors- 2;
      dialogo->color_YELLOW       = numColors- 1;
      dialogo->color_OBS          = OBS + 1;
      BLACK        = &color[dialogo->color_BLACK];
      BRIGHTWHITE  = &color[dialogo->color_BRIGHTWHITE];
      GRAY         = &color[dialogo->color_GRAY];
      WHITE        = &color[dialogo->color_WHITE];
      BLUE         = &color[dialogo->color_BLUE];
      GREEN        = &color[dialogo->color_GREEN];
      CYAN         = &color[dialogo->color_CYAN];
      RED          = &color[dialogo->color_RED];
      MAGENTA      = &color[dialogo->color_MAGENTA];
      BROWN        = &color[dialogo->color_BROWN];
      LIGHTBLUE    = &color[dialogo->color_LIGHTBLUE];
      LIGHTGREEN   = &color[dialogo->color_LIGHTGREEN];
      LIGHTCYAN    = &color[dialogo->color_LIGHTCYAN];
      LIGHTRED     = &color[dialogo->color_LIGHTRED];
      LIGHTMAGENTA = &color[dialogo->color_LIGHTMAGENTA];
      YELLOW       = &color[dialogo->color_YELLOW];
      if(flag)
         write_palette ();
}

void DrawRectangle(int ixx, int iyy, int w, int h, int filled)
{
     gpointer outPix = getCurrentPix();
     gpointer context = getCurrentContext();
     draw_rectangle (outPix, context, filled, ixx,iyy, w, h);
     if(filled)
        draw_rectangle (outPix, context, FALSE, ixx,iyy, w, h);
}

void draw_crosses(gpointer Pix, gpointer gc, GdkPoint ip[], int size, int np)
{
     GdkSegment *segs = g_new0(GdkSegment, 2*np);
     int i;

     for (i=0; i<np; i++)
     {
          segs[i].x1 = ip[i].x - size;
          segs[i].x2 = ip[i].x + size;
          segs[i].y1 = ip[i].y;
          segs[i].y2 = ip[i].y;
          segs[i+np].x1 = ip[i].x;
          segs[i+np].x2 = ip[i].x;
          segs[i+np].y1 = ip[i].y - size ;
          segs[i+np].y2 = ip[i].y + size;
     }
     draw_segments(Pix, gc, segs, 2*np);
     g_free(segs);
}

void draw_xes(gpointer Pix, gpointer gc, GdkPoint ip[], int size, int np)
{
     GdkSegment *segs = g_new0(GdkSegment, 2*np);
     int i;

     for (i=0; i<np; i++)
     {
          segs[i].x1 = ip[i].x - size;
          segs[i].x2 = ip[i].x + size;
          segs[i].y1 = ip[i].y - size ;
          segs[i].y2 = ip[i].y + size;
          segs[i+np].x1 = ip[i].x + size;
          segs[i+np].x2 = ip[i].x - size;
          segs[i+np].y1 = ip[i].y - size ;
          segs[i+np].y2 = ip[i].y + size;
     }

     draw_segments(Pix, gc, segs, 2*np);
     g_free(segs);
}

void draw_square(gpointer Pix, gpointer gc, int ixx, int iyy, int size, int filled)
{
     GdkPoint points[4];

     points[0].x = ixx-size;
     points[0].y = iyy-size;
     points[1].x = ixx-size;
     points[1].y = iyy+size;
     points[2].x = ixx+size;
     points[2].y = iyy+size;
     points[3].x = ixx+size;
     points[3].y = iyy-size;
     draw_polygon( Pix, gc, filled, points, 4 );
}

void DrawPoints(GtkWidget *window, GdkPoint punti[], int npunti, 
                 GdkColor *color, int markertype, int size)
{
     int i, filled;
     gpointer gc, Pix;
//     GtkWidget *da = get_widget(window, drawingareaname);
//     GdkGC *gc;
//     GdkDrawable *Pix;

     Pix = getCurrentPix();
     gc = getCurrentContext();

//     gc = gdk_gc_new( gtk_widget_get_window(da) );
//     Pix = (GdkPixmap *) get_object(da,"offscreen");

     if(!npunti)
        return;
     set_foreground( gc, color);
     switch(markertype)
     {
     case -1:
          draw_points(Pix, gc, punti, npunti);
          break;
     case crossx:                            /* x */
          draw_xes(Pix, gc, punti, size, npunti);
          break;
     case cross:                            /* cross */
          draw_crosses(Pix, gc, punti, size, npunti);
          break;
     case empty_circle:                            /* empty circle */
     case filled_circle:                           /* filled circle */
          filled = markertype-empty_circle;
          for(i=0; i<npunti; i++)
              draw_circle(Pix, gc, filled, punti[i].x,punti[i].y, size);
          break;
     case empty_square:                            /* empty square */
     case filled_square:                           /* filled square */
          filled = markertype-empty_square;
          for(i=0; i<npunti; i++)
          {
              draw_square(Pix, gc, punti[i].x,punti[i].y, size, filled);
          }
          break;
     }
}

void set_forecolor(int col, gpointer gc)
{
     if(gc == NULL)
        set_foreground( getCurrentContext(), &color[col]);
     else
        set_foreground( gc, &color[col]);
}

void get_drawing_area_size(int *w, int *h)
{
  GtkAllocation allocation;
  gtk_widget_get_allocation(drawingarea, &allocation);
  *w = allocation.width;
  *h = allocation.height;
}

void add_line_to_listM(GtkWidget *list, char *line[])
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    int i, ncol = get_int(list, "formato");

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    gtk_list_store_append (list_store, &iter);
    for(i=0; i<ncol; i++)
       gtk_list_store_set (list_store, &iter, i, line[i],-1);
}

void insert_line(GtkWidget *list, char *line[], int row)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    int i, ncol = get_int(list, "formato");

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    gtk_list_store_insert (list_store, &iter, row);
    for(i=0; i<ncol; i++)
       gtk_list_store_set (list_store, &iter, i, line[i],-1);
}

void set_line(GtkWidget *list, gpointer line, int nrow)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    GtkTreePath *path;
    char num[6];

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    ScriviStringa(num, sizeof(num), "%d", nrow);
    path = gtk_tree_path_new_from_string(num);
    if(gtk_tree_model_get_iter (GTK_TREE_MODEL(list_store), &iter, path))
          gtk_list_store_set (list_store, &iter, 0, line, -1);
}

void modify_line_to_listM(GtkWidget *list, gpointer line, int nrow, int ncol)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    GtkTreePath *path;
    char num[6];

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    ScriviStringa(num, sizeof(num), "%d", nrow);
    path = gtk_tree_path_new_from_string(num);
    if(gtk_tree_model_get_iter (GTK_TREE_MODEL(list_store), &iter, path))
       gtk_list_store_set (list_store, &iter, ncol, line,-1);
}

void append_line(GtkWidget *list, gchar *line)
{
    GtkListStore *list_store;
    GtkTreeIter iter;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    gtk_list_store_append (list_store, &iter);
    gtk_list_store_set (list_store, &iter, 0, line,-1);
}

void populate_list1(GtkTreeView *list, stringa values[], int numval, int ifClear)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    int i;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
    if(ifClear)
       gtk_list_store_clear(GTK_LIST_STORE(list_store));
    for(i=0; i<numval; i++)
    {
        if(values[i] && strlen(values[i]))
        {
           gtk_list_store_append (list_store, &iter);
           gtk_list_store_set (list_store, &iter, 0, values[i],-1);
        }
    }
}

GtkWidget *create_selection(GtkWidget *parent, GtkWidget *parentbox,
                            const char *title, const char *id, int ifpix)
{  
  GtkWidget *scrolledwindow1, *dirsel, *label;
  GtkListStore *store;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
                                   GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrolledwindow1);
  if(parentbox)
  {
     if (GTK_IS_BOX(G_OBJECT(parentbox)))
         gtk_box_pack_start (GTK_BOX (parentbox), scrolledwindow1, TRUE, TRUE, 0);
     else if (GTK_IS_CONTAINER(G_OBJECT(parentbox)))
         gtk_container_add(GTK_CONTAINER(parentbox), scrolledwindow1);
  }
  store = gtk_list_store_new (1, G_TYPE_STRING);
  dirsel = gtk_tree_view_new_with_model(GTK_TREE_MODEL (store));
  g_object_set_data (G_OBJECT (parent), id, dirsel);
  gtk_widget_show (dirsel);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), dirsel);
     renderer = gtk_cell_renderer_text_new ();
     g_object_set (GTK_CELL_RENDERER (renderer),
                "font-desc", fontdescU, NULL);
     column = gtk_tree_view_column_new_with_attributes (title,
						     renderer,
						     "markup",
						     0,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
  gtk_tree_view_column_set_clickable(column, FALSE);
  if(title)
  {
        label = gtk_label_new (title);
        gtk_widget_show (label);
        widget_modify_font(label, fontdescU);
        gtk_tree_view_column_set_widget(column, label);
        g_object_set_data(G_OBJECT(dirsel), "titolo", label);
  }
  else
        gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(dirsel), FALSE);
  return dirsel;
}

gchar *color_markup(char *string, const gchar *color) 
{
    gchar *labelstring;
    size_t sz =  80+strlen(string);

    labelstring = g_new0(char, sz);
    if(color)
       ScriviStringa(labelstring, sz, "<span foreground=\"%s\">"
           "%s </span>", color, string);
    else
       ScriviStringa(labelstring, sz, "%s", string);
    return labelstring;
}

void set_cell_color(GtkWidget *list, int nrow, int ncol, const char *colore)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    GtkTreePath *path;
    gchar *newlin, *line = g_new0(char, 80), *text;
    char num[6];
    size_t sz;
    PangoAttrList *attrs;
    gboolean result;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    ScriviStringa(num, sizeof(num), "%d", nrow);
    path = gtk_tree_path_new_from_string(num);
    if(gtk_tree_model_get_iter (GTK_TREE_MODEL(list_store), &iter, path))
        gtk_tree_model_get (GTK_TREE_MODEL(list_store), &iter, ncol, &line, -1);
    result = pango_parse_markup (line, -1, 0, &attrs, &text, NULL, NULL);
    if(!result)
       text = DuplicaStringa(line);
    sz = strlen(text)+60;
    newlin = g_new0(char, sz);
    ScriviStringa(newlin, sz, "%s", color_markup(text, colore));
    gtk_list_store_set (list_store, &iter, ncol, newlin, -1);
}

void get_cell(GtkWidget *list, gpointer line, int nrow, int ncol)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    GtkTreePath *path;
    char num[6];

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    ScriviStringa(num, sizeof(num), "%d", nrow);
    path = gtk_tree_path_new_from_string(num);
    if(gtk_tree_model_get_iter (GTK_TREE_MODEL(list_store), &iter, path))
        gtk_tree_model_get (GTK_TREE_MODEL(list_store), &iter, ncol, line, -1);
}

#ifdef VERY_LOW_VERSION
#include "gtktreeprivate.h"

GList *
mr_tree_selection_get_selected_rows (GtkTreeSelection   *selection,
                                      GtkTreeModel      **model)
{

  GList *list = NULL;
  GtkRBTree *tree = NULL;
  GtkRBNode *node = NULL;
  GtkTreePath *path;

  g_return_val_if_fail (GTK_IS_TREE_SELECTION (selection), NULL);
  g_return_val_if_fail (selection->tree_view != NULL, NULL);
  g_return_val_if_fail (selection->tree_view->priv->model != NULL, NULL);

  if (selection->tree_view->priv->tree == NULL ||
      selection->tree_view->priv->tree->root == NULL)
    return NULL;

  if (model)
    *model = selection->tree_view->priv->model;

  if (selection->type == GTK_SELECTION_NONE)
    return NULL;
  else if (selection->type != GTK_SELECTION_MULTIPLE)
    {
      GtkTreeIter iter;

      if (gtk_tree_selection_get_selected (selection, NULL, &iter))
        {
	  GtkTreePath *path;

	  path = gtk_tree_model_get_path (selection->tree_view->priv->model, &iter);
	  list = g_list_append (list, path);

	  return list;
	}

      return NULL;
    }

  tree = selection->tree_view->priv->tree;
  node = selection->tree_view->priv->tree->root;

  while (node->left != tree->nil)
    node = node->left;
  path = gtk_tree_path_new_first ();

  do
    {
      if (GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_IS_SELECTED))
	list = g_list_append (list, gtk_tree_path_copy (path));

      if (node->children)
        {
	  tree = node->children;
	  node = tree->root;

	  while (node->left != tree->nil)
	    node = node->left;

	  gtk_tree_path_append_index (path, 0);
	}
      else
        {
	  gboolean done = FALSE;

	  do
	    {
	      node = _gtk_rbtree_next (tree, node);
	      if (node != NULL)
	        {
		  done = TRUE;
		  gtk_tree_path_next (path);
		}
	      else
	        {
		  node = tree->parent_node;
		  tree = tree->parent_tree;

		  if (!tree)
		    {
		      gtk_tree_path_free (path);
		      return list;
		    }

		  gtk_tree_path_up (path);
		}
	    }
	  while (!done);
	}
    }
  while (TRUE);

  gtk_tree_path_free (path);

  return list;
}
#endif

void change_dir(GtkButton *button, GtkWidget *widget)
{
   char *nome = g_new0(char, MaxLenFilename);

   ScriviStringa (nome, MaxLenFilename, "%s", gtk_editable_get_chars(GTK_EDITABLE(widget), 0, -1));
   if((strlen(nome) > 0) && (g_path_get_dirname(nome) != 0))
      (void) dir_set_current(g_path_get_dirname(nome));
}

GtkWidget *entry_for_fileselection(const char *label_string, const char *pix, GCallback cb,
     gpointer data, int ifPreview, int ifBrowse, const gchar *col, const char mod)
{

  GtkWidget *vbox, *hbox, *label, *entry, *button, *image;
  GtkRequisition req;
  int wid;

  if(mod == 'v')
     vbox = vbox_new(FALSE, 0);
  else
     vbox = hbox_new(FALSE, 0);
  gtk_widget_show (vbox);

  hbox = hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
  g_object_set_data(G_OBJECT (vbox), "box1", hbox);

  if(pix)
  {
     image = create_image(pix);
     g_object_ref(G_OBJECT(image));
     gtk_widget_show (image);
     gtk_box_pack_start(GTK_BOX(hbox), image, FALSE, FALSE, 0);
     gtk_box_set_spacing(GTK_BOX(hbox), 20);
  }

  if(label_string && strlen(label_string))
  {
     label = LABEL_BOLD(label_string, col, 1.05f);
     g_object_set_data(G_OBJECT (vbox), "label", label);
     gtk_widget_show (label);
     gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
     set_alignment(label, 0., 0.5);
  }
  else
     label = NULL;

  hbox = hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  g_object_set_data(G_OBJECT (vbox), "box2", hbox);
  if(mod == 'v')
     gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
  else
     gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);

  entry = gtk_entry_new ();
  g_object_set_data(G_OBJECT (vbox), "entry", entry);
  gtk_widget_show (entry);
  gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, TRUE, 0);
  widget_modify_font(entry, fontdescU);
  widget_size_request(entry, &req);
  wid = req.width;
  if (label)
     gtk_label_set_mnemonic_widget(GTK_LABEL(label), entry);

  if(ifPreview)
  {
     if(ifPreview == 1)
        button = xpm_button("preview22.png");
     else
        button = xpm_button("edit.png");
     gtk_widget_show(button);
     gtk_box_pack_end (GTK_BOX (hbox), button, FALSE, FALSE, 0);
     gtk_container_set_border_width (GTK_CONTAINER (button), 4);
     g_object_set_data(G_OBJECT (vbox), "preview", button);
     set_tip (button, "Click to preview");
     g_object_set_data(G_OBJECT (button), "entry", entry);
     widget_size_request(button, &req);
     gtk_widget_set_size_request(entry, wid, req.height-8);
  }

  gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
  if(ifBrowse)
  {
//     button = gtk_button_new_with_label ("...");   //  gianluca 12 10 2004

     button = xpm_button("browse18.png");
     gtk_widget_show (button);
     g_object_set_data(G_OBJECT (vbox), "browse", button);
     g_object_set_data(G_OBJECT (button), "entry", entry);
     g_object_set_data(G_OBJECT (button), "father", vbox);
     g_signal_connect(G_OBJECT (button), "clicked",
                         G_CALLBACK(change_dir), entry);
     g_signal_connect(G_OBJECT (button), "clicked",
                         G_CALLBACK(cb), data);
     gtk_box_pack_end (GTK_BOX (hbox), button, FALSE, FALSE, 0);
     gtk_container_set_border_width (GTK_CONTAINER (button), 4);
     set_tip( button, "Click to browse");
     gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
     widget_size_request(button, &req);
     gtk_widget_set_size_request(entry, wid, req.height-8);
  }
  return vbox;
}

void CheckForUpdates(gpointer item, gpointer data)
{
      int result = last_update(false);
      int flag = get_autoupdate();
      UpdateCheck(finestre[0], result, &flag);
      set_autoupdate(flag);
}

GtkWidget *entry_for_fileselection(const char *label_string, const char *pix, GCallback cb,
                gpointer data, int ifPreview, int ifBrowse, const gchar *col)
{
   return entry_for_fileselection(label_string, pix, cb,
                data, ifPreview, ifBrowse, col, 'v');
}

void  update_menu_recprj(GtkWidget *mainwin, int flag)
{
  int k;
  gchar *item_string, sk[2];
  gpointer item;

  for(k=0; k<RP->nRecentProjects; k++)             /* progetti recenti */
  {
      ScriviStringa(sk, sizeof(sk), "%d", k+1);
      if((item = get_object(mainwin, sk)) != NULL)
      {
         item_string = DuplicaStringa(RP->RecentProj[k]);
         obj_set_label(item,toUTF8(item_string));
         obj_show(item);
      }
  }
}

void UpdateMenu()
{
   update_menu_recprj(mainwin, 1);
}
/*
void  update_menu_recprj(GtkWidget *menubar, int flag)
{
  int k;
  gchar *item_string, sk[2];
  GtkWidget *label, *item;

  for(k=0; k<RP->nRecentProjects; k++)
  {
      ScriviStringa(sk, sizeof(sk), "%d", k+1);
      if((item = get_widget(menubar, sk)) != NULL)
      {
         item_string = DuplicaStringa(RP->RecentProj[k]);
         label = gtk_bin_get_child(GTK_BIN(item));
         gtk_label_set_text(GTK_LABEL(label),item_string);
         gtk_widget_show(item);
      }
  }
}
*/
/*-------------------------------------------------------------*/
/*         routines chiamate dal FORTRAN                       */
/*-------------------------------------------------------------*/
#ifdef __cplusplus
extern "C"  {
#endif

void  c_update_menu_recprj_(void)
{
  GtkWidget *menubar;

  if(ifMenubar && jscreen)
  {
     menubar = lookup_widget(mainwin, "menubar");
     update_menu_recprj(menubar, 0);
  }
}
  
int viewfile_(char *title, char *file, int *tipo)
{
using namespace gtkext;
  struct stat buf;
  int e, flags = 0;
  char *filter = g_new0(char, 6);
  CopiaStringa(filter, 6, "*.");
  AppendiStringa(filter, 6, str_cut(file, "."));
  if(strstr(filter, ".tmp"))
     CopiaStringa(filter, 6, "*.txt");

  if(!jscreen)
     return 0;
  if(single_it)
     while(gtk_events_pending())
         (void) gtk_main_iteration();
  e = stat("tmp.tmp", &buf);
  if(e)
     return 0;
//  if(*tipo == 1)
//  {
//     createHtml();
//     return 0;
//  }
  flags = IFREADONLY;
  if((*tipo) != 5)
     flags += IFSAVEAS;
//  if(*tipo == -1)
//     compare_w (GTK_WINDOW(finestre[0]), file, filter, flags, title);
//  else
     text_window (GTK_WINDOW(finestre[0]), file, filter, flags, title);

  return 0;
}

void c_system_(char *riga)
{
    int ier = system(riga);
    if(ier == -1)
       g_print("Error in c_system\n");

}

/*
void c_peek_list_(char *Inte, int *NumCan, int *MultiSel, int sel[],
                  int *iExitC, int *nats, char *Msg)
{
   fine_lavoro();
   open_peeklist (Inte, NumCan, MultiSel, sel, iExitC, *nats, Msg);
}
*/

#if 0
void get_mess_codes_(void)
{
     GetMessCodes(winmess);
     ScriviStringa(dialogo->PkgName, MaxLenFilename, "%s", MR_PACKAGE);
     dialogo->lPkgName = (int) strlen(dialogo->PkgName);
}
#endif

void expo_log_handler(const gchar *, GLogLevelFlags ,
                      const gchar *message, gpointer )
{
#ifndef NDEBUG
      g_print("%s\n", message);
#endif
}

int gtkintf_(int xv[],int yv[], int *z, int *action, int *col , int *col1 , char *string)
{
using namespace Lista;
  gboolean fontSet;
  int i, np, iz, ncil;
  int xb, yb, start_xlx, start_yly, xlx, yly, dx, dy, asc;
  static gchar *pixmapdir;
  GtkWidget *tb, *mb, *hb;
  PangoFontDescription *fontnew;
  GtkSettings *settings;
  double d, dx1, dy1, m, m2, x1, y1, x2, y2, pensize, sz;
  char **argv;
  GtkAllocation allocation;
  int w, h;
  gpointer mypixmap;
  gpointer outPix = getCurrentPix();
  gpointer context = getCurrentContext();

//  int pango_font_size_factor = MY_FONT_SIZE;

  iz = *z;
  switch(*action)
  {
  case -1:            /*  Store config-file name in static array  */
      break;

  case 0:                                       /* close window */
      if(jscreen)
      {
         jscreen = 0;
         if(*col)
            quit_program(NULL, GINT_TO_POINTER(0));
         else
         {
            gtk_widget_destroy(mainwin);
            while(gtk_events_pending())
               (void) gtk_main_iteration();
            if(mainloop)
               gtk_main_quit();
         }
      }
      break;

  case 1:                                       /* open window */
     dialogo->viewerOpened = FALSE;

      if(jscreen == 0)
      {
         argv = g_new0(char *, args->argc);       //+1);
         for(i=0; i<args->argc; i++)
         {
            argv[i] = g_new0(char, 256);
            CopiaStringa(argv[i], MaxLenFilename, args->arg[i]);
         }

#if 0
         setlocale( LC_ALL, "English" );
         char *sl = setlocale( LC_ALL, "English" );
         if(sl == NULL)
         {
            sl = setlocale( LC_ALL, "C" );
            mr_setenv_(g_strdup("LC_NUMERIC=en_US.UTF-8"));
         }
#endif
         if(!gtk_init_check (&(args->argc), &argv))
	 {
             *z = -1;
             return -1;
	 }
         jscreen = 1;
         //visual = gdk_visual_get_system();
         visual = gdk_screen_get_system_visual(gdk_screen_get_default());
         g_log_set_handler("Gtk", G_LOG_LEVEL_WARNING, expo_log_handler, NULL);
         g_log_set_handler("GLib-GObject", G_LOG_LEVEL_WARNING, expo_log_handler, NULL);


//         if(visual->depth <=8)
//            numColors = 1 << visual->depth;
//         else
//            numColors = 512;
         numColors = 32;

//#ifdef USE_CMAP
//         cmap = gdk_colormap_get_system();
//         gtk_widget_set_default_colormap(cmap);
//#endif
         fontSet = TRUE;

         fontnew  = DefaultFont();
//         pango_font_description_set_size (fontnew, pango_font_size_factor*PANGO_SCALE);
 
#ifndef VERY_LOW_VERSION
         settings = gtk_settings_get_for_screen (gdk_screen_get_default());
#else
         settings = gtk_settings_get_default();
#endif

#ifndef IN_GTK3
         char *fontname = pango_font_description_to_string(fontnew);
         gtk_settings_set_string_property (settings, "gtk-font-name",
                                    fontname, "XProperty");
#endif
          gboolean result = gtk_icon_size_lookup(GTK_ICON_SIZE_MENU, &wmenu, &hmenu); 
//          gboolean result = gtk_icon_size_lookup_for_settings(settings,
//                GTK_ICON_SIZE_MENU, &wmenu, &hmenu);
          if(!result)
          {
             wmenu = 16;
             hmenu = 16;
          }

         if(strlen(fontn) < 2)
         {
//           fontSet = FALSE;
           fontdescN = pango_font_description_from_string ("courier 8");
           fontn = pango_font_description_to_string(fontdescN);
           mr_setfont('N', fontn);
         }
         else
           fontdescN = pango_font_description_from_string (fontn);
         if(strlen(fontp) < 2)
         {
//           fontSet = FALSE;
           fontdescP = DefaultFont();
//           pango_font_description_set_size (fontdescP, pango_font_size_factor*PANGO_SCALE);
           fontp = pango_font_description_to_string(fontdescP);
           mr_setfont('P', fontp);
         }
         else
           fontdescP = pango_font_description_from_string (fontp);
//         if(strlen(fontu) < 2)
         {
           fontdescU = DefaultFont();
//           pango_font_description_set_size (fontdescU, pango_font_size_factor*PANGO_SCALE);
           fontu = pango_font_description_to_string(fontdescU);
           mr_setfont('U', fontu);
         }
//         else
//           fontdescU = pango_font_description_from_string (fontu);
 
         pixmapdir = g_strdup_printf("%s%cpixmaps", files_dir, DIR_SEPAR);
         add_pixmap_directory (pixmapdir);
         //g_print("%s \n", pixmapdir);
         c_allocacolori(0);
#if GTK_MAJOR_VERSION < 3
#ifdef _WIN32
         gtk_rc_parse_string ("style \"expo-window\" { "
                              "   bg[NORMAL] = \"#e6e6e6\"\n"
                              "   bg[INSENSITIVE] = \"#b6b6b6\"\n"
                              "   bg[PRELIGHT] = \"#f6f6f6\"\n"
                              "   fg[PRELIGHT] = \"#000000\"\n"
                              "   bg[SELECTED] = \"#f6f6f6\"\n"
                              "   fg[SELECTED] = \"#000000\"\n"
                              "   bg[ACTIVE] = \"#f6f6f6\"\n"
                              "   fg[ACTIVE] = \"#000000\"\n"
                              "   text[PRELIGHT] = \"#000000\"\n"
                              "   text[NORMAL] = \"#000000\"\n"
                              "   text[INSENSITIVE] = \"#0b0b0b\"\n"
                              "   base[SELECTED] = \"#004080\"\n"
                              "   text[SELECTED] = \"#ffffff\"\n"
                              "}\n"
                              "class \"GtkWidget\" style \"expo-window\"");

#endif

         gtk_rc_parse_string ("style \"expo-window-liste\" { "
                              "   base[SELECTED] = \"#004080\"\n"
                              "   text[SELECTED] = \"#ffffff\"\n"
                              "   base[PRELIGHT] = \"#004080\"\n"
                              "   text[PRELIGHT] = \"#ffffff\"\n"
                              "   base[ACTIVE] = \"#004080\"\n"
                              "   text[ACTIVE] = \"#ffffff\"\n"
                              "}\n"
                              "class \"GtkTreeView\" style \"expo-window-liste\"");
#else
//---------------- CSS -----------------
  GtkCssProvider *provider = gtk_css_provider_new ();
  GdkDisplay *display = gdk_display_get_default ();
  GdkScreen *screen = gdk_display_get_default_screen (display);
  gtk_style_context_add_provider_for_screen (screen, GTK_STYLE_PROVIDER (provider),     GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);

  gsize bytes_written, bytes_read;

  //std::string progdir = get_prog_dir(args->arg[0]);
  //const char *ddir =  get_pkg_dir(progdir.c_str());
  //char *nome = g_build_filename(ddir, "addon.css", NULL);
  nomefile servdir;
  get_servdir(servdir);
  char *nome = g_build_filename(servdir, "addon.css", NULL);

  if(g_file_test(nome, G_FILE_TEST_EXISTS))
  {
     GError *error = 0;
     gtk_css_provider_load_from_path (provider,
                               g_filename_to_utf8(nome, strlen(nome),
                               &bytes_read, &bytes_written, &error),
                               NULL);
     GtkIconTheme *icon_theme = gtk_icon_theme_get_default ();
     //char *directory = g_build_filename(ddir, "pixmaps", NULL);
     char *directory = g_build_filename(servdir, "pixmaps", NULL);
     gtk_icon_theme_append_search_path (icon_theme, directory);
     g_object_unref (provider);
  }
#endif
#ifndef NOIMAGEBUTTON
      g_type_class_unref (g_type_class_ref (GTK_TYPE_BUTTON));
      g_object_set (settings, "gtk-button-images", TRUE, NULL);
#ifdef GTK_TYPE_IMAGE_MENU_ITEM
      g_type_class_unref (g_type_class_ref (GTK_TYPE_IMAGE_MENU_ITEM));
      g_object_set (settings, "gtk-menu-images", TRUE, NULL);
#endif
#endif
         if((xstart == -99) && (ystart == -99))
         {
             GdkRectangle rect;
#if (GTK_MAJOR_VERSION > 2) && (GTK_MINOR_VERSION >= 22)
             GdkMonitor *mon = gdk_display_get_primary_monitor(gdk_display_get_default());
             gdk_monitor_get_geometry(mon, &rect);
#else
             GdkScreen *sc = gdk_screen_get_default();
             gdk_screen_get_monitor_geometry(sc, 0, &rect);
#endif
             int ww = rect.width;
             int hh = rect.height;
             kscrx = ww / 2;
             kscry = hh / 2;
             xstart = kscrx / 2;
             ystart = kscry / 2;
             update_dime(kscrx, kscry);
         }
         mainwin = create_mainwin(kscrx, kscry);
         get_metrics(fontdescP, &larSaveP, &altSaveP);
         get_metrics(fontdescN, &larSaveN, &altSaveN);
         get_metrics(fontdescU, &larSaveU, &altSaveU);
         ifProportional  = 1;

         drawingarea = lookup_widget(mainwin, drawingareaname);
         finestre[0] = mainwin;
         gtk_widget_show (mainwin);
         MyList::SetParent(mainwin);
         if(!ifMaximized)
            gtk_window_move (GTK_WINDOW (mainwin), xstart, ystart);
         else
            gtk_window_maximize(GTK_WINDOW(mainwin));
         gdk_window_set_icon_name (gtk_widget_get_window(mainwin), MR_PACKAGE);
         set_icon(mainwin, program_ico);
         primecose(mainwin);
         drawingarea = lookup_widget(mainwin, drawingareaname);
         if(ifStatusbar)
            statusbar = lookup_widget(mainwin, "statusbar");
         gtk_widget_get_allocation(drawingarea, &allocation);
         w = (int)allocation.width;
         h = (int)allocation.height;

         cross_cursor = create_my_cursor(CROSS_CURSOR);
//       default_cursor  = gdk_cursor_new(GDK_TOP_LEFT_ARROW);
//       help_cursor     = gdk_cursor_new(GDK_QUESTION_ARROW);
         default_cursor  = gdk_cursor_new_for_display(gdk_display_get_default(), GDK_TOP_LEFT_ARROW);
         help_cursor     = gdk_cursor_new_for_display(gdk_display_get_default(), GDK_QUESTION_ARROW);
         wait_cursor     = create_my_cursor(WAIT_CURSOR);
         hand_cursor     = create_my_cursor(HAND_CURSOR);
         move_cursor     = create_my_cursor(MOVE_CURSOR);
         zoom_cursor = create_my_cursor(ZOOM_CURSOR);
         g_object_set_data(G_OBJECT(drawingarea), "previous_cursor",
                          default_cursor);
         ChangeCursor(drawingarea,default_cursor);
         g_object_set_data(G_OBJECT(drawingarea), "def_cursor",
             default_cursor);
         if(!fontSet)
             i = cMsgWinErr("Warning", 
         "You must set fonts!\nClick on Settings->Fonts&Colors->Font, select "
         "Proportional and Non Proportional and click on Apply", WARN_WINDOW);
      }
      if(ifToolbar && show_toolbar)
      {
         tb = lookup_widget(mainwin, "toolbar_main");
         hb = get_widget(tb, "hbox");
         gtk_widget_show(hb);
      }
      if(ifMenubar)
      {
         mb = lookup_widget(mainwin, "menubar");
#ifndef MAC_INTEGRATION
         gtk_widget_show(mb);
#else
         gtk_widget_hide(mb);
         SetMainMenu(mb, true);
#endif
      }
         xv[0]  = w;  /* larghezza area grafica */
         yv[0]  = h; /* altezza area grafica */

         xv[3]  =  2;              /* Valore BackingStore */
         xv[4]  = xv[0];           /* Max larghezza area grafica */
         yv[4]  = yv[0];           /* Max altezza area grafica */

         xv[5] = numColors;
#if (GTK_MAJOR_VERSION == 2) && (GTK_MINOR_VERSION < 22)
         yv[5] = gdk_visual_get_bits_per_rgb(visual);
#else
         gdk_visual_get_blue_pixel_details(visual, NULL, NULL, &yv[5]);
#endif

         yv[7] = Style[STYLE_BG].colline;
         xv[8] = Style[STYLE_OBS].plot_type;
         yv[8] = Style[STYLE_OBS].markertype;
         xv[9] = Style[STYLE_OBS].sizemarker;
         yv[9] = Style[STYLE_LEGEND].vis;

         xv[1]  = larSaveP;         /* larghezza font */
         yv[1]  = altSaveP;         /* altezza font */
         xv[2]  =  0;               /* Ascent font  NOT USED  */
         yv[2]  =  0;               /* Descent font  NOT USED */
         if(get_autoupdate())
         {
            int flag;
            int result = last_update(true);
            if(result > 0)
            {
               UpdateCheck(mainwin, result, &flag);
               set_autoupdate(flag);
            }
            else if(result < 0)
            {
               flag = 0;
               set_autoupdate(flag);
            }
         }
      return 0;
      break;

  case 2:                                /*  draw point at x, y  */
      xlx = xv[0];
      yly = yv[0];
      set_foreground( context, &CurrentColor );
      draw_point( outPix, context, xlx, yly );
      break;

  case 3:                                /*  draw from x1, y1 to x2, y2 */
      start_xlx = xv[0];
      start_yly = yv[0];
      xlx       = xv[1];
      yly       = yv[1];
      dx  = start_xlx - xlx;
      dy  = start_yly - yly;
      set_foreground( context, &CurrentColor );
      if (dx == 0 && dy == 0)
          draw_point( outPix, context,
                        xlx, yly );
       else
          draw_line( outPix, context,
                        xlx, yly, start_xlx, start_yly, *col);
      break;

  case 4:        /* draw from x1, y1 to x2, y2, color=*col, pensize=*col1  */
      pensize = (float) *col1 / 2;
      set_foreground( context, &CurrentColor );
      x1 = (double) xv[0];
      x2 = (double) xv[1];
      y1 = (double) yv[0];
      y2 = (double) yv[1];

      if(MRabs(x2-x1) < 1.)
      {
         dx1 = pensize ;
         dy1 = 0;
      }
      else if(MRabs(y2 - y1) < 1.)
      {
         dx1 = 0;
         dy1 = pensize ;
      }
      else
      {
         m  = (x2 - x1) / (y2 - y1);
         m2 =  m * m + 1;
         dx1 =  pensize / sqrt(m2);
         dy1 =  - m * pensize /  sqrt(m2) ;
      }
      points = g_new0(GdkPoint, 4);
      points[0].x = (int)(x1 - dx1);
      points[1].x = (int)(x1 + dx1);
      points[2].x = (int)(x2 + dx1);
      points[3].x = (int)(x2 - dx1);
      points[0].y = (int)(y1 - dy1);
      points[1].y = (int)(y1 + dy1);
      points[2].y = (int)(y2 + dy1);
      points[3].y = (int)(y2 - dy1);
      draw_polygon( outPix, context, TRUE, points, 4 );
      g_free(points);
      break;

  case 5:                    /* Draw dash line from x1, y1 to x2, y2 */
      start_xlx = xv[0];
      start_yly = yv[0];
      xlx       = xv[1];
      yly       = yv[1];
      dx  = start_xlx - xlx;
      dy  = start_yly - yly;
      set_foreground( context, &CurrentColor );
      if (dx == 0 && dy == 0)
          draw_point( outPix, context, xlx, yly );
      else
          dashed_line(start_xlx, start_yly, xlx, yly);
      break;

  case 6: 
      break;

  case 7:            /* clear screen */
      gtk_widget_get_allocation(drawingarea, &allocation);
      w = (int)allocation.width;
      h = (int)allocation.height;
      set_foreground( context, &CurrentColor );
      draw_rectangle (outPix, context, TRUE, 0,0, w, h);
      break;

  case 8:        /* set foreground color to col  */
      set_foreground( context, &color[*col] );
      memcpy(&CurrentColor, &color[*col], sizeof(GdkColor));
      break;

  case 9:         /*  draw string (z chars) in position x,y  */
      yb = yv[0];
      xb = xv[0];
      fontnew  = pango_font_description_copy(fontdescP);
      sz = (double) pango_font_description_get_size(fontnew); 
      *z = 2;
      switch (*z)
      {
      case 1:                /* size small */
           pango_font_description_set_size (fontnew, (int) (0.66*sz));
           break;
      case 3:                /* size big */
           pango_font_description_set_size (fontnew, (int) (1.5*sz));
           break;
      }

      if ( xb > 0 )
      {
         xb = xb + 50;
         draw_string(outPix, fontnew, context, xb, yb, string, 
               &CurrentColor, NULL);
      }
      else
      {
         xb = - xb + 50;
         draw_string(outPix, fontnew, context, xb, yb, string, 
               &CurrentColor, NULL);
         np=8;
         xb = xb - 30      ;
         asc = Ascent / 3;
         yb = yb - asc;
         points = g_new0(GdkPoint, 8);
         points[0].x = xb;
         points[0].y = yb+asc;
         points[1].x = xb+8;
         points[1].y = yb+asc;
         points[2].x = xb+8;
         points[2].y = yb+2*asc;
         points[3].x = xb+15;
         points[3].y = yb;
         points[4].x = xb+8;
         points[4].y = yb-2*asc;
         points[5].x = xb+8;
         points[5].y = yb-asc;
         points[6].x = xb;
         points[6].y = yb-asc;
         points[7].x = xb;
         points[7].y = yb+asc;
         draw_polygon( outPix, context, TRUE, points, np );
         g_free(points);
      }
      pango_font_description_free(fontnew);
      break;

  case 10:        /* draw circle center in  x,y ,radius = z  */
      yb = yv[0];
      xb = xv[0];
      iz = *z;
      set_foreground( context, &CurrentColor);
      draw_circle( outPix, context, FALSE, xb, yb, iz);
      break;

  case 11:        /* fill circle center in  x,y ,radius = z  */
      yb = yv[0];
      xb = xv[0];
      set_foreground( context, &CurrentColor);
      draw_circle( outPix, context, TRUE, xb, yb, iz);
      break;

  case 12:              /* Draw dash circle, center in  x1, y1, radius = z */
      yb = yv[0];
      xb = xv[0];
      iz = *z;
      set_foreground( context, &CurrentColor);
      set_dash_style(context);
      draw_circle( outPix, context, FALSE, xb, yb, iz);
      reset_style(context);
    break;

  case 13:              /* Draw dash arc, center in  x1, y1, radius = z */
      yb = yv[0];
      xb = xv[0];
      iz = *z;
      set_foreground( context, &CurrentColor );
      set_dash_style(context);
      draw_arc( outPix, context, FALSE, xb, yb, iz, xv[1]*64, yv[1]*64 );
      reset_style(context);
      break;

  case 14:        /* draw z-points polygon using color col  */
      set_foreground( context, &CurrentColor );
      points = g_new0(GdkPoint, iz);
      for (np=0;np<*z;np++)
      {
         points[np].x = xv[np];
         points[np].y = yv[np];
      }
      draw_polygon( outPix, context, FALSE, points, iz );
      g_free(points);
      break;

  case 15:        /* fill z-points polygon using color col  */
      set_foreground( context, &CurrentColor );
      points = g_new0(GdkPoint, iz);
      for (np=0;np<*z;np++)
      {
         points[np].x = xv[np];
         points[np].y = yv[np];
      }
      draw_polygon( outPix, context, TRUE, points, iz );
      draw_polygon (outPix, context, FALSE, points, iz);
      g_free(points);
      break;

   case 16:                     /* Connect iz points using color icol */
      set_foreground( context, &CurrentColor );
      points = g_new0(GdkPoint, iz);
      for (np=0;np<*z;np++)
      {
         points[np].x = xv[np];
         points[np].y = yv[np];
      }
      draw_lines( outPix, context, points, *z);
      g_free(points);
      break;

  case 17:        /* Draw rectangle with col filled with col1 */
      xb = xv[0];
      yb = yv[0];
      xlx = xv[1] - xv[0];
      yly = yv[1] - yv[0];
      if ( *col1  >= 0 )
      {
          set_foreground( context, &CurrentColor);
          draw_rectangle(outPix, context, TRUE,
                             xb+1, yb+1, xlx-1, yly-1 );
      }
      set_foreground( context, &CurrentColor);
      draw_rectangle(outPix, context, FALSE,
                         xb, yb, xlx, yly );
      break;

  case 18:
      break;

  case 19:        /* Draw a pixmap (string) centered in xb,yb */
      xb = xv[0];
      yb = yv[0];
      mypixmap = create_initial_pix(string);
      disegna_pix(outPix, context, mypixmap, xb, yb);
      break;

  case 23:              /* Fill arc, center in  x1, y1, radius = z */
      yb = yv[0];
      xb = xv[0];
      iz = *z;
      set_foreground( context, &CurrentColor );

      draw_arc( outPix, context, TRUE, xb, yb, iz, xv[1]*64, yv[1]*64 );
      break;

  case 25:                 /* Draw small spheres from x1, y1 to x2, y2 */
      start_xlx = xv[0];
      start_yly = yv[0];
      xlx       = xv[1];
      yly       = yv[1];
      dx  = start_xlx - xlx;
      dy  = start_yly - yly;
      d = sqrt((double)(dx*dx) + (double)(dy*dy));
      set_foreground( context, &CurrentColor );
      if(d == 0)
      {
         draw_point( outPix, context, xlx, yly );
         return 0;
      }
      ncil = (int) (d / 12.);
      if(ncil == 0)
      {
         draw_circle( outPix, context, TRUE, xlx, yly, 6);
         return 0;
      }
      dx /= ncil;
      dy /= ncil;
      for(i=0; i<ncil; i++)
      {
         draw_circle( outPix, context, TRUE, xlx, yly, 6);
         xlx += dx;
         yly += dy;
      }
      break;

  case 29:         //  draw vertical string (z chars) in position x,y  
                   //  xv[1] = -1 bottom aligned
                   //  xv[1] =  0 centre aligned
                   //  xv[1] =  1 top aligned
      yb = yv[0];
      xb = xv[0];
      fontnew  = pango_font_description_copy(fontdescP);
      sz = (double) pango_font_description_get_size(fontnew);
      switch (*z)
      {
      case 1:                // size small 
           pango_font_description_set_size (fontnew, (int) (0.66*sz));
           break;
      case 3:                // size big 
           pango_font_description_set_size (fontnew, (int) (1.5*sz));
           break;
      }

      if ( xb > 0 )
         draw_Vstring(outPix, fontnew, context, xb, yb, string,
//corr               &color[*col], xv[1]);
               &CurrentColor, xv[1]);
      break;

  case 30:
  case 31:
  case 32:
      break;

  case 33:        /* Draw cross center in x,y with col, size = z */
      yb = yv[0];
      xb = xv[0];
      iz = *z;
      set_foreground( context, &CurrentColor);
      draw_line(outPix, context, xb-iz, yb, xb+iz, yb);
      draw_line(outPix, context, xb, yb-iz, xb, yb+iz);
      break;

  case 34:        /* Draw cross center in x,y with col, size = z */
      yb = yv[0];
      xb = xv[0];
      iz = *z;
      set_foreground( context, &CurrentColor);
      draw_line(outPix, context, xb-iz, yb-iz, xb+iz, yb+iz);
      draw_line(outPix, context, xb-iz, yb+iz, xb+iz, yb-iz);
      break;

  case 40:                         /*  draw star at x1, y1  */
      dx = xv[0];
      dy = yv[0];
      draw_stella(dx, dy, *col, context, outPix);
      break;

   case 44:                     /* change font */
      if ( *z  == 1 )
       {
           ifProportional  = 1;
           xv[0] = larSaveP ;
           yv[0] = altSaveP ;
       }
       else
       {
           ifProportional  = 0;
           xv[0] = larSaveN ;
           yv[0] = altSaveN ;
       }
       break;

   case 70:
      i = xv[0];
      if ( ifProportional  == 1 )
           fontnew  = pango_font_description_copy(fontdescP);
      else
           fontnew  = pango_font_description_copy(fontdescN);
      sz = (double) pango_font_description_get_size(fontnew); 
      switch (i)
      {
      case 1:                /* size small */
           pango_font_description_set_size (fontnew, (int) (0.66*sz));
           break;
      case 3:                /* size big */
           pango_font_description_set_size (fontnew, (int) (1.5*sz));
           break;
      }
      xv[0] = gtkext::text_width(fontnew, string);
      pango_font_description_free(fontnew);
      break;

  case 80:                                /* rings a bell */
      gdk_beep();
      break;

  case 81:
      gtk_window_set_title (GTK_WINDOW(mainwin), toUTF8(string));
      break;

  case 83:            /* color definition */
//      c_allocacolori(0);         //obsoleto
      break;

   case 85:                     /* enable/disable  single iteration*/

      if ( *z  == 0 )
            single_it = FALSE;
      else
            single_it = TRUE;
      break;

  case 86:

      while(gtk_events_pending())
         (void) gtk_main_iteration();
      break;

  case 90:         /*  draw string (z chars) in position x,y  */
      fontnew  = pango_font_description_copy(fontdescP);
      sz = (double) pango_font_description_get_size(fontnew); 
      *z = 2;
      switch (*z)
      {
      case 1:                /* size small */
           pango_font_description_set_size (fontnew, (int) (0.66*sz));
           break;
      case 3:                /* size big */
           pango_font_description_set_size (fontnew, (int) (1.5*sz));
           break;
      }

      yb = yv[0]-altSaveP;
      xb = xv[0];
      draw_string(outPix, fontnew, context, xb, yb, string, 
               &CurrentColor, NULL);
      pango_font_description_free(fontnew);
      break;

  case 998:
      abilitamb(mainwin, 0);
      tb = lookup_widget(mainwin, "toolbar_main");
      abilitatb(tb, 0);
      if(single_it)
         while(gtk_events_pending())
      gtk_main_iteration();
      break;

  case 999:
      if(cStartMainLoop(*col))
      {
        mainloop = 1;
        if(ifSannel)
        {
           c_globalopt(NULL, NULL);
           ifSannel = false;
        }
        fine_elaborazione();
        gtk_main ();
        mainloop = 0;
      }
      break;

  case 1000:                                   /* program name */
//      if(prendi_parametro(string))
//         return -1;
      break;

  case 2000:                                   /* first parameter */
      {
      FILE *fp1=fOpen(string, "r");
      if(!fp1 && (strstr(string, ".exp") == 0))
         ScriviStringa(filesir, MaxLenFilename, "%s.exp", string);
      else
          CopiaStringa(filesir, MaxLenFilename, string);
      if(fp1)
         fclose(fp1);
      getStructName(filesir, filebin);
      AppendiStringa(filebin, MaxLenFilename, ".bin");
      fortran_al_lavoro();
      }
      break;

  case 3000:                                   /* second parameter */
      (void) CopiaStringa(fileout, MaxLenFilename, string);
      break;

  default:
      (void) printf("caso non gestito %d \n", *action);
      quit_program(NULL, GINT_TO_POINTER(-1));
  }
  return 0;
}

void c_getrgb_(int *indice, float rgb[3])
{
  rgb[0] = (float)color[*indice].red/65535.f; 
  rgb[1] = (float)color[*indice].green/65535.f; 
  rgb[2] = (float)color[*indice].blue/65535.f; 
}

void cflush_(void)
{
      gpointer outWindow = getCurrentWindow();
      gpointer outPix = getCurrentPix();
      gpointer context = getCurrentContext();
      flush_os(outPix, outWindow, context);
}

void cpunto_e_basta_(int *X, int *Y)
{
      gpointer outPix = getCurrentPix();
      gpointer context = getCurrentContext();
      draw_point( outPix, context, *X, *Y );
}


void csfumapallefast_(int *X11, int *Y11, int *irp, int *iFC)
{
}

void csfumapalle_(int *X11, int *Y11, int *irp, int *iFC)
{
}

int c_barradistato_(int *z, int *action, int *x , int *y , char *string)
{
  int xb, yb;
  float percentage;
  GtkWidget *progressbar;

  if(!jscreen)
     return 0;
  if(single_it)
     while(gtk_events_pending())
         (void) gtk_main_iteration();
  if(!ifStatusbar)
     return 0;
  switch(*action)
  {
  case 1:        /* Manage Progress Bar */
      xb = *x;
      yb = *y;
      percentage = (float) xb / (float) yb ;
      if(percentage >1.0) percentage = 1.0;
      if(percentage <0.0) percentage = 0.0;
      progressbar = lookup_widget(mainwin, "progressbar");
      gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progressbar), percentage);   
//      gtk_widget_draw(progressbar, NULL);
      break;

  case 2:        /* Show Progress Bar */
      progressbar = lookup_widget(mainwin, "progressbar");
      gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progressbar), 0.0f);   
      gtk_widget_show(progressbar);
//      gtk_widget_draw(progressbar, NULL);
      break;

  case 3:        /* Hide Progress Bar */
      progressbar = lookup_widget(mainwin, "progressbar");
      gtk_widget_hide(progressbar);
      break;

  case 4:       /* Message on the progress bar */
//      print_mess(string);
      progressbar = lookup_widget(mainwin, "progressbar");
      gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progressbar), string);
      gtk_widget_show(progressbar);
      break;

  }
  return 0;
}

void msgwinerrc_ (char *inte, char *msg, int *tipo, int *exitC)
{   
    if(jscreen)
       *exitC = cMsgWinErr(inte, msg, *tipo);
}

void msgwinc_ (char *inte, char *msg, int *tipo, int *exitC)
{   
    GtkWidget *dlg;
    int ctempo;

    if(jscreen)
    {
       ctempo = *exitC;
       dlg =  cMsgWin(inte, msg, *tipo, ctempo);

       if((ctempo > 10000))
           ctempo = 5000;
       if(ctempo > 0)
           (void) g_timeout_add(ctempo, chiudi_dlg, dlg);
    }
}

void mrwinnew_(int xv1[], int yv1[], int xv2[], int yv2[], int xv3[], int yv3[],
              int col1[], int col2[], int *z, int *ifclear)
{

      int np, new_color, old_color;
      gpointer outPix = getCurrentPix();
      gpointer plot_gc = getCurrentContext();

      GtkAllocation allocation;
      gtk_widget_get_allocation(drawingarea, &allocation);
      if(*ifclear)
      {
         set_foreground( plot_gc, &color[Style[STYLE_BG].colline]);
         draw_rectangle (outPix, plot_gc, TRUE, 0,0,
                        (int)allocation.width,
                        (int)allocation.height);
      }
      old_color = 0;
      for (np=0;np<*z;np++)
      {
         new_color = col1[np];
         if ( new_color != old_color ) 
         {
           old_color = new_color;
                 set_foreground( plot_gc, &color[new_color]);
         }
         draw_line( outPix,    plot_gc, xv1[np], yv1[np], xv2[np], yv2[np]);

         new_color = col2[np];
         if ( new_color != old_color ) 
         {
           old_color = new_color;
                 set_foreground( plot_gc, &color[new_color]);
         }
         draw_line( outPix,    plot_gc, xv2[np], yv2[np], xv3[np], yv3[np]);
      }
}
void mrwinnew2_(int xv1[], int yv1[], int xv2[], int yv2[], int col1[], int *z)
{

   int np, new_color, old_color;
   gpointer outPix = getCurrentPix();
   gpointer plot_gc = getCurrentContext();

      old_color = 0;
      for (np=0;np<*z;np++)
      {
         new_color = col1[np];
         if ( new_color != old_color ) 
         {
           old_color = new_color;
                 set_foreground( plot_gc, &color[new_color]);
         }
         draw_point( outPix, plot_gc, xv1[np], yv1[np]);
      }

}

//mr void mrwinnew3_(int *nlim1,int *nlim2,int *iColor,int kpix[], int kpiy[], int *d)
void mrwinnew3_(int *nlim1,int *nlim2,int kpix[], int kpiy[], int *d, int *wt)
{
   int npoints,np;
   int ifdash = *d;
   gpointer outPix = getCurrentPix();
   gpointer plot_gc = getCurrentContext();

   npoints = -1;
   points = g_new0(GdkPoint, (*nlim2 - *nlim1 + 2)*sizeof(GdkPoint));
   for (np=*nlim1-1;np<*nlim2;np++)
   {
         npoints++;
         points[npoints].x = kpix[np];
         points[npoints].y = kpiy[np];
   }

   npoints++;
   set_foreground( plot_gc, &CurrentColor);
   if(ifdash == 2)
      set_dash_style(plot_gc);
   draw_lines( outPix, plot_gc, points, npoints, *wt);
   if(ifdash == 2)
      reset_style(plot_gc);
   g_free(points);
}

void c_fine_lavoro_(int *flag)
{
   if(!jscreen)
      return;
   if(*flag)
   {
      GtkWidget *tb = lookup_widget(finestre[0], toolbarname[Livcur]);
      GtkWidget *hbox = get_widget(tb, "hbox");
      gtk_widget_set_sensitive(hbox, TRUE);
      abilitamb(finestre[0], 1);
      if(strstr(toolbarname[Livcur],"main"))
         abilitatb(tb, 1);
   }
   fine_lavoro();
}

void c_fortran_al_lavoro_(int *flag)
{
   if(!jscreen)
      return;
   if(*flag)
   {
      GtkWidget *tb = lookup_widget(finestre[0], toolbarname[Livcur]);
      GtkWidget *hbox = get_widget(tb, "hbox");
      gtk_widget_set_sensitive(hbox, FALSE);
      abilitamb(finestre[0], 0);
   }
   fortran_al_lavoro();
}

#ifdef __cplusplus
}
#endif

/***************************************************************************/
extern "C" void cprintmessage_(char *riga)
{
   std::string messaggio(riga);
   print_mess(messaggio.c_str());
}

void print_mess(const char *riga)
{
    gtk_statusbar_pop(GTK_STATUSBAR(statusbar), 1);
    (void) gtk_statusbar_push(GTK_STATUSBAR(statusbar), 1,riga);
}

void mr_setfont(char c, char *fontname)
{
    size_t sz = strlen(fontname) + 1;
    switch(c)
    {
    case 'P':
        fontp = g_new0(char, sz);
        (void) CopiaStringa(fontp, sz, fontname);
        fontdescP = pango_font_description_from_string (fontp);
        get_metrics(fontdescP, &larSaveP, &altSaveP);
        update_fonts();
        break;
    case 'N':
        fontn = g_new0(char, sz);
        (void) CopiaStringa(fontn, sz, fontname);
        fontdescN = pango_font_description_from_string (fontn);
        get_metrics(fontdescN, &larSaveN, &altSaveN);
        update_fonts();
        break;
    case 'U':
        fontu = g_new0(char, sz);
        (void) CopiaStringa(fontu, sz, fontname);
        fontdescU = pango_font_description_from_string (fontu);
        get_metrics(fontdescU, &larSaveU, &altSaveU);
        update_fonts();
        break;
    }
}

void draw_cross(int ixx, int iyy, int col)
{
     gpointer outPix = getCurrentPix();
     gpointer outWindow = getCurrentWindow();
     gpointer plot_gc = getCurrentContext();
     set_foreground( plot_gc, &color[col]);
     draw_line(outWindow, plot_gc, ixx-6, iyy, ixx+6, iyy);
     draw_line(outPix, plot_gc, ixx-6, iyy, ixx+6, iyy);
     draw_line(outWindow, plot_gc, ixx, iyy-6, ixx, iyy+6);
     draw_line(outPix, plot_gc, ixx, iyy-6, ixx, iyy+6);
}

int tog_button(GtkWidget *widget, int count)
{
   GtkWidget *widpix, *icon;

   count = 1 - count;

   widpix = gtk_bin_get_child(GTK_BIN(widget));
   gtk_container_remove(GTK_CONTAINER(widget), widpix);
   if (count == 1)
      icon = get_widget(widget, "icon2");
   else                                    /* toggle button up */
      icon = get_widget(widget, "icon1");
   gtk_container_add(GTK_CONTAINER(widget), icon);
   gtk_widget_show(icon);

   return count;
}

GtkWidget *xpm_square_button( GtkWidget *parent,
                          gchar  *xpm_filename)
{
    GtkWidget *button;
    GtkWidget *pixmapwid;

    /* Now on to the xpm stuff */
    pixmapwid = create_image (xpm_filename);
    gtk_widget_show(pixmapwid);

    /* Create a new button */
    button = gtk_button_new ();
    gtk_widget_set_size_request(button, 28, 28);

    gtk_container_add (GTK_CONTAINER (button), pixmapwid);
    gtk_widget_show(button);
    return button;
}

GtkWidget *LABEL_WITH_ENTRY(char *string, gchar *colore)
{
    GtkWidget *label, *entry, *box;

    box = hbox_new(FALSE, 0);
    label = LABEL_NEW(string, colore);
    set_alignment(label, 0.0, 0.5);
    gtk_box_pack_start(GTK_BOX(box), label,FALSE, FALSE, 2);
    entry = gtk_entry_new();
    widget_modify_font(entry, fontdescU);
    gtk_widget_set_size_request(entry, ENTRY_SIZE, 20);
    gtk_box_pack_start(GTK_BOX(box), entry, FALSE, FALSE, 2);
    gtk_label_set_mnemonic_widget(GTK_LABEL(label), entry);
    g_object_set_data(G_OBJECT(box), "label", label);
    g_object_set_data(G_OBJECT(box), "entry", entry);

    return box;
}

void quit_program (GtkWidget *widget, gpointer data)
{
    (void) Cancella("tmp.tmp");
//    gtk_exit(GPOINTER_TO_INT(data));
    exit(GPOINTER_TO_INT(data));
}

static int answer;

void set_answer (GtkButton *button, gpointer data)
{
     answer = GPOINTER_TO_INT(data);
     gtk_main_quit();
}


GtkWidget* cMsgWin(char *title, char *cmsg, int type, int timeout)
{
   DlgItem it;
   GtkWidget *my_dlg;
   char *messaggio, *msgtot;
   int nmsg;
   size_t sz;
   
   if(type >= 10)
   {
       nmsg = abs(type)/10;
       type %= 10;
       msgtot = g_strdup_printf(message[nmsg], cmsg);
   }
   else
   {
       sz          = strlen(cmsg) + 1;
       msgtot      = g_new0(char, sz);
       (void) CopiaStringa(msgtot, sz, cmsg);
   }
//   if(type >= SEVERE_ERR_WINDOW)
//       msgtot = g_strdup_printf("%s\n%s will be terminated!!!",
//                        msgtot, MR_PACKAGE);
       
   if(!jscreen)
   {
        cpause(msgtot);
        my_dlg  = NULL;
        if(type >= SEVERE_ERR_WINDOW)
           exit(-1);
        else
           return my_dlg;
   }
   sz = strlen(msgtot) + 20;
   messaggio = g_new0(char, sz);
   formatta_msg(messaggio, sz, msgtot, MESG_SIZE);
   it.label1           = "   _OK";
   it.image1           = "ok.png";
   it.label2           = " _Cancel";
   it.image2           = "cancel.png";
   it.cb_func1         = G_CALLBACK(close_dlg);
   it.cb_func2         = G_CALLBACK(close_dlg);
   it.text             = messaggio;

   if(timeout > 0)
   {
      it.cb_data1         = GINT_TO_POINTER(0);
      it.cb_data2         = GINT_TO_POINTER(0);
   }
   else
   {
      it.cb_data1         = GINT_TO_POINTER(10);
      it.cb_data2         = GINT_TO_POINTER(10);
   }

   switch(type)
   {
   case SEVERE_ERR_WINDOW:
        it.nButtons         = 1;
        it.focus            = 1;
        it.image            = "error.xpm";
        it.format           = 1;
        it.title            = title;
        it.cb_func1         = G_CALLBACK(quit_program);
        it.cb_data1         = NULL;
        break;

   case ERR_WINDOW:
        it.nButtons         = 1;
        it.focus            = 1;
        it.image            = "error.xpm";
        it.format           = 1;
        it.title            = title;
        break;

   case WARN_WINDOW:
        it.nButtons         = 1;
        it.focus            = 1;
        it.image            = DuplicaStringa("warning.xpm");
        it.format           = 1;
        it.title            = title;
        break;

   case INFO_WINDOW:
        it.nButtons         = 1;
        it.focus            = 1;
        it.image            = DuplicaStringa("infoico.xpm");
        it.format           = 1;
        it.title            = title;
        break;

   case QUEST_WINDOW:
        it.nButtons         = 2;
        it.focus            = 1;
        it.image            = "question.xpm";
        it.format           = 1;
        it.title            = title;
        break;

   }
   my_dlg              = create_dialog(NULL, &it);
   gtk_widget_show_all(my_dlg);
//   if((type == ERR_WINDOW) || (type == SEVERE_ERR_WINDOW))
//     curSmiley = 2;
//   else
//      curSmiley = 1;
//   curSmileySav = curSmiley;

   return my_dlg;
}

int cMsgWinErr(const char *title, const char *cmsg, int type)
{
   DlgItem it;
   GtkWidget *my_dlg, *button;
   char *messaggio, *msgtot;
   int nmsg;
   size_t sz;

   if(type >= 10)
   {
       nmsg = type/10;
       type %= 10;
       msgtot = g_new0(char, 500);
       ScriviStringa(msgtot, 500, message[nmsg], cmsg);
   }
   else
   {
       sz = strlen(cmsg) + 1;
       msgtot          = g_new0(char, sz);
       (void) CopiaStringa(msgtot, sz, cmsg);
   }
       
   if(!jscreen)
   {
        cpause(msgtot);
        answer  = 0;
        if(type >= SEVERE_ERR_WINDOW)
           exit(-1);
        else
           return answer;
   }
   sz = strlen(msgtot) + 50;
   messaggio = g_new0(char, sz);
   memset(messaggio, 0, strlen(msgtot)+50); 
   formatta_msg(messaggio, sz, msgtot, MESG_SIZE);
   g_free(msgtot);
//   std::string msgstr  = messaggio;
//   g_free(messaggio);
   it.label1           = "   _OK";
   it.image1           = "ok.png";
   it.label2           = " _Cancel";
   it.image2           = "cancel.png";
   it.label3           = "   _Stop";
   it.image3           = "stopr.png";
   it.cb_func1         = G_CALLBACK(close_dlg);
   it.cb_data1         = GINT_TO_POINTER(11);
   it.cb_func2         = G_CALLBACK(close_dlg);
   it.cb_data2         = GINT_TO_POINTER(11);
   it.cb_func3         = G_CALLBACK(close_dlg);
   it.cb_data3         = NULL;
//   it.text             = filtrapercb(msgstr);
   it.text             = DuplicaStringa(messaggio);
   g_free(messaggio);

   switch(type)
   {
   case SEVERE_ERR_WINDOW:
        it.nButtons         = 1;
        it.focus            = 1;
        it.image            = DuplicaStringa("error.xpm");
        it.format           = 1;
        it.title            = DuplicaStringa(title);
        it.cb_func1         = G_CALLBACK(quit_program);
        it.cb_data1         = NULL;
        break;

   case ERR_WINDOW:
        it.nButtons         = 1;
        it.focus            = 1;
        it.image            = DuplicaStringa("error.xpm");
        it.format           = 1;
        it.title            = DuplicaStringa(title);
        break;

   case WARN_WINDOW:
        it.nButtons         = 1;
        it.focus            = 1;
        it.image            = DuplicaStringa("warning.xpm");
        it.format           = 1;
        it.title            = DuplicaStringa(title);
        break;

   default:
   case INFO_WINDOW:
        it.nButtons         = 1;
        it.focus            = 1;
        it.image            = "infoico.xpm";
        it.format           = 1;
        it.title            = title;
        break;

   case QUEST_WINDOW:
        it.nButtons         = 2;
        it.focus            = 1;
        it.image            = "question.xpm";
        it.format           = 1;
        it.title            = title;
        break;

   case QUEST_WINDOW_R:
        it.nButtons         = 2;
        it.focus            = 2;
        it.image            = "question.xpm";
        it.format           = 1;
        it.title            = title;
        break;

   case QUEST_WINDOW_YES_NO:
        it.nButtons         = 2;
        it.focus            = 1;
        it.image            = "question.xpm";
        it.format           = 1;
        it.title            = title;
        it.image1           = "apply.png";
        it.image2           = "cancel.png";
        it.label1           = "   _Yes";
        it.label2           = "    _No";
        break;

   case QUEST_WINDOW_NO_YES:
        it.nButtons         = 2;
        it.focus            = 2;
        it.image            = "question.xpm";
        it.format           = 1;
        it.title            = title;
        it.image1           = "apply.png";
        it.image2           = "cancel.png";
        it.label1           = "   _Yes";
        it.label2           = "    _No";
        break;

   case THREE_BUTTONS:
        it.nButtons         = 3;
        it.image            = "question.xpm";
        it.format           = 1;
        it.title            = title;
        break;

   }
   my_dlg              = create_dialog(NULL, &it);
   button = get_widget(my_dlg,"button1");
   (void) g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK (set_answer), GINT_TO_POINTER(1));
   if(it.nButtons >= 2)
   {
      button = get_widget(my_dlg, "button2");
      (void) g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK (set_answer), GINT_TO_POINTER(2));
   }
   if(it.nButtons >= 3)
   {
      button = get_widget(my_dlg, "button3");
      (void) g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK (set_answer), GINT_TO_POINTER(3));
   }
   gtk_window_set_resizable(GTK_WINDOW(my_dlg), FALSE);
   gtk_window_set_transient_for(GTK_WINDOW(my_dlg), GTK_WINDOW(mainwin));
   gtk_widget_show_all(my_dlg);
   if((type == ERR_WINDOW) || (type == SEVERE_ERR_WINDOW))
   {
      clear_status_bar();
      fine_lavoro();
   }
   finestra_modale_aperta2(my_dlg);
   gtk_main();

   return answer;
}

int save_restore_pm(int type)
{
  GtkWidget *dialog, *box1, *box2, *label1, *label2, *button;

  dialog = gtk_dialog_new();
  gtk_container_set_border_width (GTK_CONTAINER (dialog), 7);
  gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_MOUSE);

  box1 = gtk_dialog_get_content_area(GTK_DIALOG(dialog));

  box2 = hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(box1), box2, TRUE, TRUE, 4);
  if(type == 1)
     button = xpm_button("savebin.xpm");
  else
     button = xpm_button("restorebin.xpm");
  gtk_box_pack_start(GTK_BOX(box2), button, FALSE, FALSE, 4);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK (set_answer), GINT_TO_POINTER(1));
  (void) g_signal_connect_after(G_OBJECT(button), "clicked",
           G_CALLBACK (close_dlg), GINT_TO_POINTER(11));
  gtk_widget_grab_focus (button);
  label1 = gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(box2), label1, TRUE, TRUE, 4);

  box2 = hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(box1), box2, TRUE, TRUE, 4);
  if(type == 1)
     button = xpm_button("savemdl.xpm");
  else
     button = xpm_button("restoremdl.xpm");
  gtk_box_pack_start(GTK_BOX(box2), button, FALSE, FALSE, 4);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK (set_answer), GINT_TO_POINTER(2));
  (void) g_signal_connect_after(G_OBJECT(button), "clicked",
           G_CALLBACK (close_dlg), GINT_TO_POINTER(11));
  label2 = gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(box2), label2, TRUE, TRUE, 4);

  button =  CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog), button, 1);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK (set_answer), GINT_TO_POINTER(3));
  (void) g_signal_connect_after(G_OBJECT(button), "clicked",
           G_CALLBACK (close_dlg), GINT_TO_POINTER(11));

  (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
   (void) g_signal_connect (G_OBJECT (dialog), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  if(type == 1)                   // Save
  {
     gtk_window_set_title (GTK_WINDOW (dialog), "Save");
     gtk_label_set_text(GTK_LABEL(label1), "Save project file");
     gtk_label_set_text(GTK_LABEL(label2), "Save model");
  }
  else
  {
     gtk_window_set_title (GTK_WINDOW (dialog), "Restore");
     gtk_label_set_text(GTK_LABEL(label1), "Restore project file");
     gtk_label_set_text(GTK_LABEL(label2), "Restore model");
  }
  gtk_widget_show_all(dialog);
  finestra_modale_aperta2(dialog);
  gtk_main();
 
   return answer;
}

GtkWidget *window_tip (gchar  *string, int lriga)
{
    GtkWidget *frame, *label;
    char *text;
    size_t sz = strlen(string) + 20;

    text = g_new0(char, sz);
    formatta_msg(text, sz, string, lriga);
    frame = gtk_frame_new (NULL);
    gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
    label = gtk_label_new (text);
    set_alignment(label, 0.5, 0.5);
    set_margins (label, 4, 4, 4, 4);
    gtk_container_add (GTK_CONTAINER (frame), label);
    gtk_widget_show (label);
    gtk_widget_show (frame);
    return frame;
}

void string_to_vector (char *string, char* vecstr[])
{
   if(strlen(string) > 0)
   {
       GList *lista = fill_list(string, "@");
       size_t sz;
       if(lista)
       {
          int nsc = (int) g_list_length(lista);
          int i;
          for(i=0; i<nsc; i++)
          {
              char *pstr = (char *)g_list_nth_data(lista, i);
              sz = strlen(g_strstrip(pstr)) + 1;
              vecstr[i] = g_new0(char, sz);
              (void) CopiaStringa(vecstr[i], sz, g_strstrip(pstr));
          }
          g_list_free(lista);
       }
    }
}

void string_to_vector2 (char *string, char* vecstr[], const char *delim, int ifstrip)
{
   if(strlen(string) > 0)
   {
       GList *lista = fill_list(string, delim);
       if(lista)
       {
          int nsc = (int) g_list_length(lista);
          int i;
          size_t sz;
          for(i=0; i<nsc; i++)
          {
              char *pstr = (char *)g_list_nth_data(lista, i);
              if(ifstrip)
              {
                 sz =  strlen(g_strstrip(pstr)) + 1;
                 vecstr[i] = g_new0(char, sz);
                 (void) CopiaStringa(vecstr[i], sz, g_strstrip(pstr));
              }
              else
              {
                 sz =  strlen(pstr) + 1;
                 vecstr[i] = g_new0(char, sz);
                 (void) CopiaStringa(vecstr[i], sz, pstr);
              }
          }
          g_list_free(lista);
       }
    }
}

void stringatovector(char *str, char *strvec[], int nElem, int lung)
{
   int i;
   size_t sz = lung+1;

   for(i=0; i<nElem; i++)
   {
       strvec[i] = g_new0(char, sz);
       (void) CopiaStringa(strvec[i], sz, "\0");
       (void) AppendiStringan(strvec[i], sz, str+lung*i, lung);
   }
}

double Fr(double r, int type)
{
   int i;

   if(type == 0)
      return sqrt(r);
   for(i=0; i<type-1; i++)
       r *= r;
   return r;
}

GdkPoint stella[11] = {{7,1},{9,6},{13,6},{9,9},{12,14},{7,12},
                       {2,14},{5,9},{1,6},{5,6},{7,7}};
void draw_stella(int dx, int dy, int ic, gpointer plot_gc, gpointer outPix)
{
      int i;
      GdkPoint pstella[10];

      dx -= stella[10].x;
      dy -= stella[10].y;
      
      for(i=0; i<10; i++)
      {
          pstella[i].x = stella[i].x+dx;
          pstella[i].y = stella[i].y+dy;
      }
      set_foreground( plot_gc, &color[Style[STYLE_BG].colline] );
      draw_polygon( outPix, plot_gc, TRUE, pstella, 10 );
      set_foreground( plot_gc, &color[ic] );
      draw_polygon( outPix, plot_gc, FALSE, pstella, 10 );
}

gpointer linea_spessa (int x1, int y1, int x2, int y2, 
                 int spessore, gpointer context, GdkWindow *win, int iColor)
{
     GdkPoint xy[4];
     double m, m2, dx1, dy1;
     gpointer region = region_new();

     set_foreground( context,  &color[iColor]);
     if(MRabs(x2-x1) < 1.)
     {
        dx1 = spessore ;
        dy1 = 0;
     }
     else if(MRabs(y2 - y1) < 1.)
     {
        dx1 = 0;
        dy1 = spessore ;
     }
     else
     {
        m  = (x2 - x1) / (y2 - y1);
        m2 =  m * m + 1;
        dx1 =  spessore / sqrt(m2);
        dy1 =  - m * dx1 ;
     }
     xy[0].x = (int)(x1 - dx1);
     xy[1].x = (int)(x1 + dx1);
     xy[2].x = (int)(x2 + dx1);
     xy[3].x = (int)(x2 - dx1);
     xy[0].y = (int)(y1 - dy1);
     xy[1].y = (int)(y1 + dy1);
     xy[2].y = (int)(y2 + dy1);
     xy[3].y = (int)(y2 - dy1);
     draw_polygon( win, context, FALSE, xy, 4 );
     return region;
}

void dashed_line (int ix1, int iy1, int ix2, int iy2)
{
      double tratto, x1, y1, x2, y2, dist, dx, dy, 
          xm, alfa, seno, coseno;
      int i, j, xrb, yrb, tratti;
      gpointer outPix = getCurrentPix();
      gpointer plot_gc = getCurrentContext();

      tratto = 6.0;
      x1 = (double) ix1;
      x2 = (double) ix2;
      y1 = (double) iy1;
      y2 = (double) iy2;
      dx = x2 - x1;
      dy = y2 - y1;

      dist = sqrt(dx*dx + dy*dy); 
      if(dist > 0.1) 
      {
         alfa = atan2(y2-y1, x2-x1);
         coseno = cos(alfa);
         seno = sin(alfa);

	  tratti = (int) (dist / tratto);
         xm = 0;
         for(i=0; i<tratti; i+=2)
         {
             for(j=1; j<=(int)(tratto/2.); j++)
             {
                 xrb = (int) (x1 + xm * coseno);
                 yrb = (int) (y1 + xm * seno);
                 draw_point( outPix, plot_gc, xrb, yrb );
                 xm++;
             }
             xm += 1.5*tratto;
         } 
      }
}

void dashed_rectangle (int ix, int iy, int w, int h)
{
     int x, y;
     gpointer outWindow = getCurrentWindow();
     gpointer plot_gc;

#if (GTK_MAJOR_VERSION > 2) && (GTK_MINOR_VERSION >= 22)
       GdkRectangle rect;
       rect.width= gdk_window_get_width (GDK_WINDOW(outWindow));
       rect.height = gdk_window_get_height (GDK_WINDOW(outWindow));
       gdk_window_get_position (GDK_WINDOW(outWindow), &rect.x, &rect.y);
       cairo_region_t *reg = (cairo_region_t *)region_rectangle(&rect);
       GdkDrawingContext *dc = gdk_window_begin_draw_frame
           (GDK_WINDOW(outWindow), reg);
       cairo_t *tgc = gdk_drawing_context_get_cairo_context(dc);
       plot_gc = (gpointer)tgc;
#elif defined(USE_CAIRO)
       cairo_t *cr;
       cr =  gdk_cairo_create((GdkWindow *)outWindow);
       cairo_set_line_width(cr, 1.0);
       plot_gc = (gpointer) cr;
#else
       plot_gc = (gpointer)gdk_gc_new((GdkDrawable *)outWindow);
#endif

     for(x=ix; x<ix+w; x+=10)
     {
         draw_line( outWindow, plot_gc, x, iy, x+3, iy);
         draw_line( outWindow, plot_gc, x, iy+h-1, x+3, iy+h-1);
     }

     for(y=iy; y<iy+h; y+=10)
     {
         draw_line( outWindow, plot_gc, ix, y, ix, y+3);
         draw_line( outWindow, plot_gc, ix+w-1, y, ix+w-1, y+3);
     }
#if (GTK_MAJOR_VERSION > 2) && (GTK_MINOR_VERSION >= 22)
     gdk_window_end_draw_frame(GDK_WINDOW(outWindow), dc);
#elif defined(USE_CAIRO)
     cairo_destroy((cairo_t *) plot_gc);
#endif
}

void DrawLine(int x1, int y1, int x2, int y2, GdkColor *color, int lw)
{
     gpointer outPix = getCurrentPix();
     gpointer plot_gc = getCurrentContext();

     set_foreground( plot_gc, color);
     draw_line( outPix, plot_gc, x1, y1, x2, y2, lw);
}

void dashed_circle (int ix, int iy, int ir)
{
     int x, x2, y, r2;
     gpointer outPix = getCurrentPix();
     gpointer plot_gc = getCurrentContext();

     r2 = ir*ir;
     for(x=0; x<=ir; x+=5)
     {
         x2 = x * x;
         y = (int)( sqrt((double)(r2 - x2)) + 0.5);
         draw_point( outPix, plot_gc, ix-x, iy+y );
         draw_point( outPix, plot_gc, ix+x, iy+y );
         draw_point( outPix, plot_gc, ix-x, iy-y );
         draw_point( outPix, plot_gc, ix+x, iy-y );
     }
     for(y=0; y<=ir; y+=5)
     {
         x2 = y * y;
         x = (int)( sqrt((double)(r2 - x2)) + 0.5);
         draw_point( outPix, plot_gc, ix+x, iy-y );
         draw_point( outPix, plot_gc, ix+x, iy+y );
         draw_point( outPix, plot_gc, ix-x, iy-y );
         draw_point( outPix, plot_gc, ix-x, iy+y );
     }

}

void finestra_modale_aperta2(GtkWidget *widget)
{
    GtkWidget *tb, *mb;//, *hbox;     27.11

    if(win_stack < 0)
    {
       gdk_beep();
       (void) printf("win_stack error\n");
       quit_program(NULL, GINT_TO_POINTER(-1));
    }
    win_stack++;
    finestre[win_stack] = widget;
    if(ifMenubar)
    {
       mb = lookup_widget(finestre[0], "menubar");
       salva_stato_mb(mb, statoinimb[win_stack]);
       abilitamb(finestre[0], 0);
    }
    if(ifToolbar && show_toolbar)
    {
       tb = lookup_widget(finestre[0], toolbarname[Livcur]);
       salva_stato_tb(tb, statoinitb[win_stack]);
       abilitatb(tb, 0);
    }
    if(curSmiley != 5)
       curSmileySav = curSmiley;
    curSmiley = 5;
    set_smiley(curSmiley);
//    gtk_window_set_transient_for(finestre[win_stack],
//             finestre[win_stack-1]);
}

void finestra_modale_chiusa2(void)
{
    GtkWidget *tb;//, *hbox;     27.11

    if(ifMenubar)
       abilitamb(finestre[0], -2);
    if(ifToolbar && show_toolbar)
    {
       tb = lookup_widget(finestre[0], toolbarname[Livcur]);
       abilitatb(tb, -2);
    }
    win_stack--;
    if(win_stack == 0)
       curSmiley = curSmileySav;
    else if(win_stack > 0)
       curSmiley = 5;
    else
       curSmiley = 4;
    set_smiley(curSmiley);
}

gboolean finestra_modale_up(GtkWidget *wid, GdkEvent *ev, gpointer data)
{
    if(finestre[win_stack])
       gdk_window_raise(gtk_widget_get_window(finestre[win_stack]));
    return TRUE;
}


void fortran_al_lavoro(void)
{
   if(!jscreen)
      return;
   if(ifStatusbar)
      set_smiley(3);
   curSmiley = 1;

   single_it = TRUE;
}

void fine_lavoro(void)
{
   if(!jscreen)
      return;
   set_smiley(curSmiley);
   single_it = FALSE;
}

void set_smiley (int come)
{
   if(ifStatusbar)
   {
      if(gdk_pixbuf_animation_is_static_image(smil_buf[come]))
         gtk_image_set_from_pixbuf(GTK_IMAGE(pixsmiley), 
               gdk_pixbuf_animation_get_static_image(smil_buf[come]));
      else
         gtk_image_set_from_animation(GTK_IMAGE(pixsmiley), smil_buf[come]);
   }
   if(come == 5)
      enable_tip(get_widget(finestre[0], "ebox"), TRUE);
   else
      enable_tip(get_widget(finestre[0], "ebox"), FALSE);
}

void clear_status_bar(void)
{
     if(ifStatusbar)
     {
        print_mess(" ");
        if(win_stack == 0)
        {
           curSmiley = 1;
           curSmileySav = 1;
           set_smiley(curSmiley);
        }
     }
}

gboolean ManageExpose (GtkWidget *widget, gpointer obj, gpointer )
{
    gpointer pix = get_object(widget, "offscreen");

#ifdef IN_GTK3
    cairo_surface_t *image = (cairo_surface_t *)pix;
    cairo_set_source_surface ((cairo_t *) obj, image, 0, 0);
    cairo_paint ((cairo_t *) obj);
#else
    gpointer context = get_object(widget, "context");
    GdkEventExpose *event = ( GdkEventExpose * ) obj;
    if(event->count > 1)
       return TRUE;
    draw_drawable(gtk_widget_get_window(widget),
                  context,
                  pix,
                  event->area.x, event->area.y,
                  0, 0,
                  event->area.width, event->area.height);
#endif
  return FALSE;
}

static gboolean on_state_event (GtkWidget *widget,
                    GdkEventWindowState *event, gpointer data)
{
//11112014  ifMaximized = 0;
//#ifdef _WIN32
  if (event->changed_mask & (GDK_WINDOW_STATE_MAXIMIZED |
                             GDK_WINDOW_STATE_FULLSCREEN))
    {
      gboolean maximized;

      maximized = event->new_window_state & (GDK_WINDOW_STATE_MAXIMIZED |
                                             GDK_WINDOW_STATE_FULLSCREEN);
      ifMaximized = (maximized > 0);
    }
//#endif
   return FALSE;
}

void init_toggles(GtkWidget *tb, gpointer data)
{
   gpointer widget = get_object(finestre[0], "legendTog");
   obj_set_active(widget, !Style[STYLE_LEGEND].vis, true);
}

#ifdef USE_ACTIONS
void finish_ui_manager(GtkUIManager *merge, mr_action_entry entries[],
          guint n_entries, const char *base, GtkWidget *window)
{
    std::string nome(base);
    GtkWidget *tb = gtk_ui_manager_get_widget (merge, base);
    for(guint i=0; i<n_entries; i++)
    {
        mr_action_entry entry = entries[i];
        bool can_focus = false;
        bool ifShow = true;
        if(str_white(entry.name))
           continue;
        if(entry.type < 0)
        {
            ifShow = false;
            entry.type = -entry.type;
        }
        if((entry.type >20) && (entry.type <=30))
        {
            can_focus = true;
            entry.type -= 20;
        }
        nome.assign(base);
        nome.append(entry.name);
        GtkWidget *toolitem = gtk_ui_manager_get_widget (merge, nome.c_str());
        if(toolitem == NULL)
           continue;
        GtkWidget *button = NULL;
        gpointer data;
        if(entry.cb)
        {
           if(entry.num == -2)
              data = (gpointer) window;
           else if(entry.num == -1)
              data = (gpointer) entry.name;
           else
              data = GINT_TO_POINTER(entry.num);
        }

        switch(entry.type)
        {
        default:
             break;
        case 7:
             button = myimage_button(entry.string, entry.icon);
             gtk_button_set_relief (GTK_BUTTON(button), GTK_RELIEF_NONE);
             gtk_widget_set_can_focus (button, can_focus);
             if(entry.cb)
                g_signal_connect ((gpointer) button, "clicked",
                     entry.cb , data);
             break;
          
        case 50:
             button = create_image(entry.icon);
             break;

        case 80:
             gtk_tool_item_set_expand(GTK_TOOL_ITEM(toolitem), TRUE);
             break;
       }
       if(button != NULL)
       {
          gtk_widget_show_all(button);
          gtk_widget_set_visible(toolitem, ifShow);
          g_object_set_data (G_OBJECT (window), entry.name, toolitem);
          g_object_set_data (G_OBJECT (tb), entry.name, toolitem);
          gtk_container_add(GTK_CONTAINER(toolitem), button);
       }
    }
}
#endif

gboolean event_openfile (GtkWidget *widget, GdkEventAny *event, gpointer data)
{
    if(event->send_event)
    {   
       const char *fileinp = (const char*) g_object_get_data(G_OBJECT(widget), "inpfile");
       const char *fileout = (const char*) g_object_get_data(G_OBJECT(widget), "outfile");
       if(!fileinp || !fileout)
          return FALSE;
       call_fortran(fileinp, fileout, "sir");
       return TRUE;
    }
    return FALSE;
}

GtkWidget* create_mainwin (int WINDWID, int WINDHEI)
{
  GtkWidget *main_window;
  GtkWidget *vbox;
  GtkWidget *ebox;
  GtkWidget *menubar;
  GtkWidget *frame;
  GtkWidget *drawingarea;
  GtkWidget *statusb;
  GtkWidget *pixsmiley;
  GtkWidget *hboxsotto;
  GtkWidget *progressbar;
  GtkWidget *toolbar;
  GtkWidget *hbox;
  int       ori = 'v';

  main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  finestre[0] = main_window;
  g_object_set_data (G_OBJECT (main_window), "mainwindow", main_window);
  gtk_window_set_title (GTK_WINDOW (main_window), MR_PACKAGE);
  gtk_window_set_default_size(GTK_WINDOW (main_window), WINDWID, WINDHEI);

#ifndef GTK_TOOLTIP
  GtkTooltips *tooltips = gtk_tooltips_new ();
  GtkTooltips *smile_tooltips = gtk_tooltips_new ();
  set_win_main(main_window);
  g_object_set_data(G_OBJECT(main_window), "tt", tooltips);
  g_object_set_data(G_OBJECT(main_window), "smilett", smile_tooltips);
#endif

  vbox = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (main_window), "vbox", vbox);
  gtk_container_add (GTK_CONTAINER (main_window), vbox);
  gtk_widget_show (vbox);

#ifdef USE_ACTIONS
  GtkActionGroup *group = CreateActionGroup(main_window,
                      n_menu_items, (mr_action_entry *) menuitems,"MenuBar");
#else
  menubar = CreateMenubar(main_window, (mr_action_entry *) menuitems, n_menu_items);
#endif
  if(ifToolbar)
  {
         hbox = hbox_new (FALSE, 0);
         gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
         g_object_set_data (G_OBJECT (main_window), "hbox", hbox);
#ifdef USE_ACTIONS
         CreateActionGroup(main_window, n_entries,
                   (mr_action_entry *)toolbaritems, Nomi);
#else
         toolbar = CreateToolbar(main_window, 0,
                   (mr_action_entry *)toolbaritems, n_entries);
         g_object_set_data (G_OBJECT (main_window), Nomi, toolbar);
         g_object_set_data(G_OBJECT(toolbar), "tb", toolbar);
#endif
   }
#ifdef USE_ACTIONS
     GtkUIManager *merge = gtk_ui_manager_new ();
     gtk_ui_manager_insert_action_group (merge, group, -1);
     gtk_window_add_accel_group (GTK_WINDOW (main_window),
                                  gtk_ui_manager_get_accel_group (merge));
     g_object_set_data_full (G_OBJECT (main_window), "ui-manager", merge,
                              g_object_unref);
     menubar = CreateMenubar(main_window, menu_info, merge, group);
     set_tooltips_on_menu(main_window, n_menu_items,
            (mr_action_entry *) menuitems);
     if(ifToolbar)
     {
        toolbar = CreateToolbar(main_window, tbui_info, merge, group,
                        Nomi);
        g_object_set_data (G_OBJECT (main_window), Nomi, toolbar);\
        g_object_set_data(G_OBJECT(toolbar), "tb", toolbar);
        std::string nome = "/";
        nome.append(Nomi);
        nome.append("/");
        finish_ui_manager(merge, (mr_action_entry *)toolbaritems,
                n_entries, nome.c_str(), main_window);
        g_object_set_data (G_OBJECT (main_window), Nomi, toolbar);
#ifdef USE_TOOLBAR
        gtk_toolbar_set_show_arrow(GTK_TOOLBAR(toolbar), FALSE);
#endif
    }
#endif

  if(ifMenubar)
  {
     gtk_box_pack_start (GTK_BOX (vbox), menubar, FALSE, TRUE, 0);
     g_object_set_data (G_OBJECT (main_window), "menubar", menubar);
     update_menu_recprj(main_window, 1);

      int nRecProj = RP->nRecentProjects;
      for(int k=0; k<MAXPROJ; k++)
      {
          gpointer item;
          gchar sk[2];
          ScriviStringa(sk, sizeof(sk), "%d", k+1);
          if((item = get_object(main_window, sk)) != NULL)
              (void) g_signal_connect( G_OBJECT(item), "activate",
                     cb_for_recproj, (gpointer) "recprj");
      }
      for(int k=nRecProj; k<MAXPROJ; k++)
      {
          gpointer item;
          gchar sk[2];
          ScriviStringa(sk, sizeof(sk), "%d", k+1);
          if((item = get_object(main_window, sk)) != NULL)
              obj_hide(item);
      }
      salva_stato_mb(menubar, statoinimb[0]);
      g_object_set_data(G_OBJECT(menubar), "mainwindow", main_window);
  }

  if(ifToolbar)
  {
      {
         hbox = hbox_new (FALSE, 0);
         gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
         g_object_set_data (G_OBJECT (main_window), "hbox", hbox);
         g_object_set_data (G_OBJECT (toolbar), "hbox", hbox);
         salva_stato_tb(toolbar, statoinitb[0]);
         (void) g_signal_connect_after(G_OBJECT(hbox), "show", 
                G_CALLBACK(cb_for_set_tog), NULL);
         gtk_box_pack_start (GTK_BOX (hbox), toolbar, TRUE, TRUE, 0);
         gtk_widget_show (toolbar);
         gtk_widget_show (hbox);
      }
  }
//  frame = hbox_new(FALSE, 0);
//  g_object_set_data (G_OBJECT (main_window), "DAbox",frame);
//  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
//  gtk_widget_show (frame);

  if(ori == 'v')
     frame = vpaned_new();
  else
     frame = hpaned_new();
  g_object_set_data (G_OBJECT (main_window), "DAbox",frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
  gtk_widget_show (frame);

  drawingarea = gtk_drawing_area_new ();
  g_object_set_data (G_OBJECT (main_window), drawingareaname, 
              drawingarea);
  gtk_paned_pack1((GtkPaned *)frame, drawingarea, TRUE, FALSE);
  g_object_set_data(G_OBJECT(drawingarea), "offscreen", NULL);
  gtk_widget_set_size_request(drawingarea, 200, 200); //WINDWID-3, WINDHEI-88);
  gtk_widget_show (drawingarea);

  GtkWidget *sideframe = CreateSideFrame(main_window, ori);
  gtk_paned_pack2((GtkPaned *)frame, sideframe, TRUE, TRUE);

  if(ifStatusbar)
  {
     hboxsotto = hbox_new (FALSE, 0);
     gtk_container_set_border_width ( GTK_CONTAINER (hboxsotto) , 0 );
     g_object_set_data (G_OBJECT (main_window), "hboxsotto", hboxsotto);
     gtk_widget_show (hboxsotto);
     gtk_box_pack_start (GTK_BOX (vbox), hboxsotto, FALSE, FALSE, 2);

     ebox = gtk_event_box_new();
     g_object_set_data (G_OBJECT (main_window), "ebox", ebox);
     gtk_box_pack_start (GTK_BOX (hboxsotto), ebox, FALSE, FALSE, 2);
     gtk_widget_show (ebox);
     set_tip(ebox, "Click to raise the obscured window");

     pixsmiley = create_image ("smil0.gif");
     if(pixsmiley)
     {
        g_object_set_data (G_OBJECT (main_window), "smiley", 
          pixsmiley);
        g_object_ref(pixsmiley);
//     gtk_widget_set_size_request(pixsmiley, 18, 18);
        gtk_widget_set_size_request(pixsmiley, 40, 20);
        set_alignment (pixsmiley, 0.5, 0.5);
        gtk_container_add(GTK_CONTAINER(ebox), pixsmiley);
        gtk_widget_show (pixsmiley);
     }

     statusb = gtk_statusbar_new ();
     g_object_set_data (G_OBJECT (main_window), "statusbar", statusb);
     gtk_widget_show (statusb);
     set_widget_font(gtk_statusbar_get_message_area(GTK_STATUSBAR(statusb)), fontu);
     gtk_box_pack_start (GTK_BOX (hboxsotto), statusb, TRUE, TRUE, 2);

     progressbar = gtk_progress_bar_new ();
     g_object_set_data (G_OBJECT (main_window), "progressbar", 
           progressbar);
     gtk_widget_set_size_request(progressbar, WINDWID/4, 18);
/*
     newstyle = gtk_style_copy(gtk_widget_get_default_style());
     newstyle->bg[GTK_STATE_PRELIGHT] = *LIGHTBLUE;
     gtk_widget_ensure_style(progressbar);
     gtk_widget_set_style(progressbar, newstyle);
*/
//corr     g_object_set(G_OBJECT(progressbar), "bar-style",
//corr         GINT_TO_POINTER(GTK_PROGRESS_DISCRETE), NULL);
//     g_object_set(G_OBJECT(progressbar), "discrete-blocks",
//         GINT_TO_POINTER(20), NULL);
     gtk_box_pack_start (GTK_BOX (hboxsotto), progressbar, FALSE,FALSE, 2);
     (void) g_signal_connect (G_OBJECT (ebox), "button_press_event",
                      G_CALLBACK (finestra_modale_up), NULL);
     gtk_widget_set_events(ebox, GDK_BUTTON_PRESS_MASK );
  }

  (void) g_signal_connect (G_OBJECT (drawingarea), "configure_event",
                      G_CALLBACK (on_configure_event), NULL);
  (void) g_signal_connect_after (G_OBJECT (drawingarea), "configure_event",
                      G_CALLBACK (cb_for_configure), NULL);

#if 0
  (void) g_signal_connect (G_OBJECT (drawingarea), DRAW_EVENT,
                      G_CALLBACK (on_drawingarea1_expose_event),
                      NULL);
#endif
  (void) g_signal_connect (G_OBJECT (drawingarea), DRAW_EVENT,
                      G_CALLBACK (ManageExpose),
                      NULL);
  (void) g_signal_connect (G_OBJECT (drawingarea), "button_press_event",
                      G_CALLBACK (cb_for_mouse_press), NULL);
  (void) g_signal_connect (G_OBJECT (drawingarea), "button_release_event",
                      G_CALLBACK (cb_for_mouse_release), NULL);
  (void) g_signal_connect (G_OBJECT (drawingarea), "motion_notify_event",
                      G_CALLBACK (cb_for_mouse_move), NULL);
  gtk_widget_set_events(drawingarea, GDK_BUTTON_PRESS_MASK | 
              GDK_BUTTON_MOTION_MASK | GDK_BUTTON_RELEASE_MASK |
              GDK_POINTER_MOTION_MASK |GDK_EXPOSURE_MASK );

  (void) g_signal_connect(main_window, "window_state_event",
                          G_CALLBACK (on_state_event), 
                               NULL);
  (void) g_signal_connect(main_window, "map-event", //"visibility-notify-event",
                          G_CALLBACK (event_openfile), 
                               NULL);

  (void) g_signal_connect (G_OBJECT (main_window), "delete_event",
                      G_CALLBACK(cb_for_delete), (gpointer) "forced");

  return main_window;
}

void primecose (GtkWidget *main_window)
{
  GtkWidget *drawingarea;
  char *msgdefault = g_strdup_printf(" Welcome to %s", MR_PACKAGE);

  if(ifStatusbar)
  {
     statusbar   = lookup_widget(main_window, "statusbar");
     pixsmiley   = lookup_widget(main_window, "smiley");
     (void) gtk_statusbar_push(GTK_STATUSBAR(statusbar), 1, msgdefault);
  }
  drawingarea = lookup_widget(main_window, drawingareaname);
  initial_pix = create_initial_pix(initial_pixmap);
  if(!Style[STYLE_BG].colline)
  {
     GdkColor color  = Black;
     set_widget_color(drawingarea, &color);
  }
  else
  {
     GdkColor color  = White;
     set_widget_color(drawingarea, &color);
  }

//  gdk_window_clear (win);

  GtkAllocation allocation;
//  gtk_widget_get_allocation(main_window, &allocation);
  gtk_widget_get_allocation(drawingarea, &allocation);
  int w = (int) allocation.width;
  int h = (int) allocation.height;
  GtkWidget *paned1 = get_widget (main_window, "DAbox");
  gtk_paned_set_position(GTK_PANED(paned1), 3*h/2);
//  gtk_paned_set_position(GTK_PANED(paned1), 2*h/3);
  GtkWidget *paned2 = get_widget (main_window, "paned2");
  gtk_paned_set_position(GTK_PANED(paned2), w/2);

  if(ifStatusbar)
  {
     for (int i=0; i<NUM_SMILEY; i++)
           smil_buf[i]       = mr_load_animation(g_strdup_printf("smil%d.gif",i));
  }

  if(ifStatusbar)
          set_smiley(1);
}

void draw_initial_pixmap()
{
   if(initial_pix != NULL)
   {
      int x2, y2;
      gpointer outPix = getCurrentPix();
      gpointer plot_gc = getCurrentContext();
      GtkAllocation allocation;
      gtk_widget_get_allocation(drawingarea, &allocation);
      set_foreground( plot_gc, &color[1]);
      disegna_pixnew(outPix, plot_gc, initial_pix,
          (int)allocation.width/2, (int)allocation.height/2, &x2, &y2);
      cflush_();
   }
}

gboolean on_configure_event (GtkWidget *widget, GdkEventConfigure *event,
                                        gpointer user_data)
{
    int w,h;
    GtkWidget *mwin;
    gpointer pixmap;
    gpointer context;
    os_and_gc *rt;


//    if(ifMaximized)
//        gtk_window_maximize(GTK_WINDOW(gtk_widget_get_toplevel(widget)));
    GtkAllocation allocation;
    gtk_widget_get_allocation(widget, &allocation);
    w = (int)allocation.width;
    h = (int)allocation.height;
    if((w == wPrevious) && (h == hPrevious))
    {
        g_signal_stop_emission_by_name(G_OBJECT(widget), "configure_event");
        return TRUE;
    }
    if (get_object(widget, "context") != NULL)
        context = get_object(widget, "context");
    else
        context = NULL;

    if (get_object(widget, "offscreen") != NULL)
        pixmap = get_object(widget, "offscreen");
    else
        pixmap = NULL;

    destroy_os_and_gc(pixmap, context);
    rt = get_os_and_gc(widget);
    pixmap = rt->os;
    context = rt->gc;
    g_free(rt);
    g_object_set_data(G_OBJECT(widget), "context", context);
    g_object_set_data( G_OBJECT(widget), "offscreen", pixmap);
    mr_send_pixmap(widget);
    wPrevious = w;
    hPrevious = h;

    mwin = lookup_widget(widget, "mainwindow");
    gtk_widget_get_allocation(mwin, &allocation);
    w = (int)allocation.width;
    h = (int)allocation.height;
    update_dime(w, h);
//NEW
#ifdef IN_GTK3
     if (gtk_widget_get_visible(get_widget(finestre[0], "area_messaggi")))
     {
         int he = altezza_viewer();
         gtk_widget_get_allocation(get_widget(mwin, "area_grafica2"), &allocation);
         int wi = (int)allocation.width;
         do_configure(get_widget(finestre[0], "area_grafica2"), wi, he);
//       g_print("do_configure %d  %d\n", wi, he);
     }
#endif
//End NEW
    return FALSE;
}

/*
void set_clip(GtkWidget *win)
{
    GdkRectangle rect;

    if(plot_gc)
    {
         GtkAllocation allocation;
         gtk_widget_get_allocation(win, &allocation);
         rect.x = 0;
         rect.y = 0;
         rect.width = (int) allocation.width;
         rect.height = (int) allocation.height;
         gdk_gc_set_clip_origin(plot_gc, 0, 0);
         gdk_gc_set_clip_rectangle(plot_gc, &rect);
    }
}
*/

void mr_send_pixmap(GtkWidget *win)
{
    gpointer outWindow = gtk_widget_get_window(win);
    gpointer outPix =  get_object(win,"offscreen");
    gpointer context = get_object(win,"context");
    g_object_set_data(G_OBJECT(finestre[0]), "currentPixmap", outPix);
    g_object_set_data(G_OBJECT(finestre[0]), "currentWindow", outWindow);
    g_object_set_data(G_OBJECT(finestre[0]), "currentContext", context);
    set_clip(win, getCurrentContext());
}

void mr_restore_pixmap(void)
{
    GtkWidget *drawingarea;
   
    drawingarea = lookup_widget(finestre[0], drawingareaname);
    gpointer outWindow = gtk_widget_get_window(drawingarea);
    gpointer outPix = get_object(drawingarea, "offscreen");
    gpointer context = get_object(drawingarea, "context");
    g_object_set_data(G_OBJECT(finestre[0]), "currentPixmap", outPix);
    g_object_set_data(G_OBJECT(finestre[0]), "currentWindow", outWindow);
    g_object_set_data(G_OBJECT(finestre[0]), "currentContext", context);
    set_clip(drawingarea, getCurrentContext());
}

void mr_send_viewer_pixmap(GtkWidget *win)
{
      gpointer outWindow = gtk_widget_get_window(win);
      gpointer outPix = get_object(win,"offscreen");
      gpointer context = get_object(win, "context");
      g_object_set_data(G_OBJECT(finestre[0]), "currentPixmap", outPix);
      g_object_set_data(G_OBJECT(finestre[0]), "currentWindow", outWindow);
      g_object_set_data(G_OBJECT(finestre[0]), "currentContext", context);
      dialogo->viewerOpened = TRUE;
      set_clip(win, getCurrentContext());
}

#if 0
gboolean destroy (GtkWidget *widget, GdkEvent *event, gpointer data)
{
   dialogo->viewerOpened = FALSE;
   viewer_window = NULL;
   return FALSE;
}
#endif

char *ref_line(char *str)
{
    char *newstr;
    int lstr, i, k, notblank = 0;

    lstr = (int) strlen(str)-1;
    if(lstr)
    {
       newstr = g_new0(gchar, lstr+1);
       k = 1;
       for(i=0; i<lstr; i++)
       {
           if(str[i] == ' ')
           {
              if(notblank)
              {
                 k = 1;
                 notblank = 0;
              }
              newstr[i] = (k % 10) + '0';
              k++;
           }
           else
           {
              newstr[i] = (k % 10) + '0';
              k++;
              notblank = 1;
           }
       }
       return g_strchomp(newstr);
    }
    else
      return NULL;
}

gboolean
on_viewer_expose_event                 (GtkWidget       *widget,
                                        gpointer         obj,
                                        gpointer         user_data)
{
   gpointer pix, context;

    pix = get_object(widget, "offscreen");
    context = get_object(widget, "context");
#ifdef USE_DRAW
    draw_drawable(gtk_widget_get_window(widget),
                  context,
                  pix,
                  0, 0, 0, 0,
                  gtk_widget_get_allocated_width(widget),
                  gtk_widget_get_allocated_height(widget));
#else
    GdkEventExpose *event = ( GdkEventExpose * ) obj;
    if(event->count > 1)
       return TRUE;
    draw_drawable(gtk_widget_get_window(widget),
                  context,
                  pix,
                  event->area.x, event->area.y,
                  0, 0,
//                  event->area.x, event->area.y,
                  event->area.width, event->area.height);
#endif
  return FALSE;
}

gboolean chiudi_dlg(gpointer data )
{
     gtk_widget_destroy((GtkWidget*) data);
     return FALSE;
}

gboolean hide_dlg(gpointer data )
{
     gtk_widget_hide((GtkWidget*) data);
     return FALSE;
}

#if 0
void close_viewer  (GtkButton  *button, gpointer data)
{
  mr_restore_pixmap();
  dialogo->viewerOpened = FALSE;
  gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
}

void delete_viewer  (GtkButton  *button, gpointer data)
{
  mr_restore_pixmap();
  dialogo->viewerOpened = FALSE;
  viewer_window = NULL;
  gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
}
#endif

void reset_handler (GtkWidget *hwnd, GdkEvent *ev, gpointer data)
{
  data = NULL;
}

void add_text(GtkWidget *lista, char *stringa)
{
  GtkTextIter iter;
  GtkTextBuffer *tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(lista));

  gtk_text_buffer_get_end_iter (tb, &iter);
  gtk_text_buffer_insert (tb, &iter, stringa, (gint) strlen(stringa));

}

int load_file_into_window(char *filnam, GtkWidget *text, 
                          char *fore, char *back, int nlines)
{
    GtkTextBuffer *text_buffer;
    int ntags, ier;
    char *tags[4];

    text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text));
    ntags = 0;

    if(fore)
    {
       tags[ntags] = DuplicaStringa ("fore_color");
       gtk_text_buffer_create_tag (text_buffer, tags[ntags],
			      "foreground", fore, NULL);  
       ntags++;
    }
    if(back)
    {
       tags[ntags] = DuplicaStringa ("back_color");
       gtk_text_buffer_create_tag (text_buffer, tags[ntags],
			      "background", back, NULL);  
       ntags++;
    }
    clear_text(text);
    ier = load_file_into_buffer(filnam, text_buffer, nlines, tags, ntags);
    return ier;
}

int is_comment(char c)
{
    if(c == '!' || c == '>')
       return 1;
    return 0;
}

int load_file_into_buffer(char *filename, GtkTextBuffer *text, 
                          int nlines, char **tags, int ntags)
{
   FILE *infile;
   GtkTextIter iter;
   int i;
   GtkTextTagTable *tag_table;

   infile = fOpen(filename, "r");
  
   if (infile) 
   {
       char buffer[1024], *str;

       gtk_text_buffer_get_iter_at_offset (text, &iter, 0);
       if(nlines)
       {
          if((str = fgets(buffer, 1024, infile)) != NULL)
          {
             while(is_comment(str[0]))
               str = fgets(buffer, 1024, infile);
               
             gtk_text_buffer_insert_with_tags_by_name(text,
                                   &iter,
                                   ref_line(str), 
                                   (gint) strlen(ref_line(str)),
                                   "reference_line",
                                   NULL);
             gtk_text_buffer_insert(text,
                                   &iter,
                                   "\n", 
                                   1);
             tag_table = gtk_text_buffer_get_tag_table(text);
             for(i=0; i<ntags; i++)
                   gtk_text_tag_table_add(tag_table,
                      gtk_text_tag_new(tags[i]));
/*
           gtk_text_buffer_insert(text,
                                   &iter,
                                   g_strchomp(str), 
                                   strlen(g_strchomp(str)));
           gtk_text_buffer_insert(text,
                                   &iter,
                                   "\n", 
                                   1);
*/
          }
          (void) fclose (infile);
          infile = fOpen(filename, "r");
       }
       i = 0;
       while((str = fgets(buffer, 1024, infile)) != NULL)
       {
            gtk_text_buffer_insert(text,
                                   &iter,
                                   g_strchomp(str), 
                                   (gint) strlen(g_strchomp(str)));
            gtk_text_buffer_insert(text,
                                   &iter,
                                   "\n", 
                                   1);
            i++;
            if((nlines) && (i == nlines))
                break;
       }
       (void) fclose (infile);
       return 0;
    }
    return -1;
}

GtkWidget *scrolled_text_new (GtkWidget *box1)
{
  GtkWidget *scrollwin;
  GtkWidget *text;
  GtkTextBuffer *tb;

  scrollwin = gtk_scrolled_window_new( NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                  GTK_POLICY_AUTOMATIC, 
                                  GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrollwin);
  gtk_container_add (GTK_CONTAINER (box1), scrollwin);

  tb = gtk_text_buffer_new(NULL);
  gtk_text_buffer_create_tag (tb, "word_wrap",
			      "wrap_mode", GTK_WRAP_WORD, NULL);
  gtk_text_buffer_create_tag (tb, "font_p",
			      "font-desc", fontdescP, NULL);
  gtk_text_buffer_create_tag (tb, "font_n",
			      "font-desc", fontdescN, NULL);
  gtk_text_buffer_create_tag (tb, "font_u",
			      "font-desc", fontdescU, NULL);
  gtk_text_buffer_create_tag (tb, "blue_foreground",
			      "foreground", "blue", NULL);
  gtk_text_buffer_create_tag (tb, "gray_foreground",
//			      "foreground", "darkgray", NULL);
			      "foreground", "#606060", NULL);
  gtk_text_buffer_create_tag (tb, "yellow_foreground",
			      "foreground", "yellow", NULL);
  gtk_text_buffer_create_tag (tb, "wide_margins",
			      "left_margin", 10, "right_margin", 10,
			      NULL);
  gtk_text_buffer_create_tag (tb, "gray_bg",
			      "background", "lightgray", NULL);
  gtk_text_buffer_create_tag (tb, "superscript",
			      "rise", 15 * PANGO_SCALE,
			      "size", 12 * PANGO_SCALE,
			      "font-desc", fontdescP,
			      NULL);

  text = gtk_text_view_new_with_buffer(tb);
  gtk_container_add(GTK_CONTAINER(scrollwin), text);
  gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW(text), FALSE);

  return text;
}

GtkWidget *create_textwindow(DlgItem *tx, PangoFontDescription *pfd)
{
  GtkWidget *window;
  GtkWidget *box1;
  GtkWidget *button;
  GtkTextBuffer *text;
  GtkWidget *text_view;
  int       larg, alt;
  char *filename, *label;
  gboolean if_file = TRUE;
 
  window = gtk_dialog_new ();
  get_metrics(pfd, &larg, &alt);
  larg = 80 * larg;
  if(tx->nlines)
     alt = (tx->nlines+3) * (alt);
  else
     alt = 400;
  
  if(tx->format > 10)
  {
     tx->format -= 10;
     if_file = FALSE;
  }
  filename = DuplicaStringa(tx->title);
  gtk_window_set_title (GTK_WINDOW (window), toUTF8(filename));
  gtk_container_set_border_width (GTK_CONTAINER (window), 0);
  
  box1 = gtk_dialog_get_content_area(GTK_DIALOG(window));
  
  text_view = scrolled_text(box1); 
  widget_modify_font(text_view, pfd);
  g_object_set_data(G_OBJECT(window), "testo", text_view);
  text = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text_view));
  /* Load the file into the text window */
  
  if(if_file)
  {
     filename = DuplicaStringa(tx->text);
     g_object_set_data(G_OBJECT(window), "nome", filename);
     (void) load_file_into_buffer(filename, text, 0, NULL, 0);
  }

  gtk_widget_set_size_request (text_view, larg, MRmin(400, alt));
  gtk_widget_show (text_view);
  if(tx->format != 2)
     gtk_text_view_set_editable(GTK_TEXT_VIEW (text_view), FALSE);
  
  if(tx->nButtons >= 1)
  {
     label = DuplicaStringa(tx->label1);
     button = xpm_button(label);
     g_object_set_data(G_OBJECT(window), "button1", button);
     (void) g_signal_connect_after (G_OBJECT (button), "clicked",
                         tx->cb_func1,tx->cb_data1);
     gtk_dialog_add_action_widget (GTK_DIALOG (window), button, 1);
     gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);
     gtk_widget_show (button);
  }

  if(tx->nButtons >= 2)
  {
     label = DuplicaStringa(tx->label2);
     button = xpm_button(label);
     g_object_set_data(G_OBJECT(window), "button2", button);
     (void) g_signal_connect_after (G_OBJECT (button), "clicked",
                         tx->cb_func2,tx->cb_data2);
     gtk_dialog_add_action_widget (GTK_DIALOG (window), button, 2);
     gtk_widget_show (button);
  }

  if(tx->nButtons >= 3)
  {
     label = DuplicaStringa(tx->label3);
     button = xpm_button(label);
     g_object_set_data(G_OBJECT(window), "button3", button);
     (void) g_signal_connect_after (G_OBJECT (button), "clicked",
                         tx->cb_func3,tx->cb_data3);
     gtk_dialog_add_action_widget (GTK_DIALOG (window), button, 3);
     gtk_widget_show (button);
  }

/* bottoncino close connesso all'ultimo bottone definito */
  if(button)
     (void) g_signal_connect_swapped (G_OBJECT (window), "delete_event",
              G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   else
     (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
           G_CALLBACK(gtk_widget_hide), G_OBJECT(window)); 

  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return window;
}

GtkWidget* create_dialog (GtkWidget *mwin, DlgItem *it)
{
  GtkWidget *dialog;
  GtkWidget *vbox;
  GtkWidget *box1;
  GtkWidget *box2;
  GtkWidget *pixmap;
  GtkWidget *button1;
  GtkWidget *label;

  dialog = gtk_dialog_new ();
  if(mwin != NULL)
      g_object_set_data (G_OBJECT (dialog), "mainwindow", mwin);
  g_object_set_data (G_OBJECT (dialog), it->title, dialog);
  gtk_container_set_border_width (GTK_CONTAINER (dialog), 7);
  gtk_window_set_title (GTK_WINDOW (dialog), it->title);
  gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(dialog));

  box1 = vbox_new (FALSE, 4);

  box2 = hbox_new (FALSE, 4);

  if(it->format == 1)
  {
      gtk_container_add (GTK_CONTAINER (vbox), box1);
      gtk_box_pack_start (GTK_BOX (box1), box2, TRUE, TRUE, 0);
  }
  else
  {
      gtk_container_add (GTK_CONTAINER (vbox), box2);
      gtk_box_pack_end (GTK_BOX (box2), box1, TRUE, TRUE, 0);
  }
 
  if(it->image != NULL)
  {
     pixmap = create_image (it->image);
     gtk_box_pack_start (GTK_BOX (box2), pixmap, TRUE, FALSE, 0);
  }

  if(it->text != NULL)
  {
     label = gtk_label_new (NULL);
     gtk_label_set_text(GTK_LABEL(label), it->text);
     gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);

     if(it->format == 1)
        gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
     else
        gtk_box_pack_start (GTK_BOX (box1), label, TRUE, TRUE, 0);
     widget_modify_font(label, fontdescU);
  }

  if(it->nButtons >=1)
  {

     button1 = myimage_button(it->label1, it->image1);
     g_object_set_data(G_OBJECT (dialog), "button1",button1);
     gtk_dialog_add_action_widget (GTK_DIALOG (dialog), button1, 1);
     gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button1)),
         GTK_BUTTONBOX_SPREAD);

     (void) g_signal_connect_after (G_OBJECT(button1), "clicked", 
                      it->cb_func1,it->cb_data1);
     if(it->focus == 1)
        gtk_widget_grab_focus (button1);
  }
  if(it->nButtons >=2)
  {

     button1 = myimage_button(it->label2, it->image2);
     g_object_set_data(G_OBJECT (dialog), "button2",button1);
     gtk_dialog_add_action_widget (GTK_DIALOG (dialog), button1, 2);
     (void) g_signal_connect_after (G_OBJECT(button1), "clicked", 
                      it->cb_func2,it->cb_data2);
     if(it->focus == 2)
        gtk_widget_grab_focus (button1);
  }
  if(it->nButtons >=3)
  {

     button1 = myimage_button(it->label3, it->image3);
     g_object_set_data(G_OBJECT (dialog), "button3",button1);
     gtk_dialog_add_action_widget (GTK_DIALOG (dialog), button1, 3);
     (void) g_signal_connect_after (G_OBJECT(button1), "clicked", 
                      it->cb_func3,it->cb_data3);
     if(it->focus == 2)
        gtk_widget_grab_focus (button1);
  }
  if(button1)
     (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button1)); 
  else
     (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
           G_CALLBACK(gtk_widget_hide), G_OBJECT(dialog)); 

  (void) g_signal_connect (G_OBJECT (dialog), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return dialog;
}

/*
void fixed_toggled(GtkCellRendererToggle *cell, gchar *path_str, gpointer data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreeIter  iter;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  gboolean fixed;

  gtk_tree_model_get_iter (model, &iter, path);
  gtk_tree_model_get (model, &iter, 0, &fixed, -1);

  fixed ^= 1;
  gtk_list_store_set (GTK_LIST_STORE (model), &iter, 0, fixed, -1);
  gtk_tree_path_free (path);
}
*/

GtkWidget *create_cselection(GtkWidget *parent, GtkWidget *parentbox,
                            const char *title, const char *id)
{  
  GtkWidget *scrolledwindow1, *dirsel, *label;
  GtkListStore *store;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
//  ColorText *ct = g_new0(ColorText, 1);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
                                   GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrolledwindow1);
  if(parentbox)
  {
     if (GTK_IS_BOX(G_OBJECT(parentbox)))
         gtk_box_pack_start (GTK_BOX (parentbox), scrolledwindow1, TRUE, TRUE, 0);
     else if (GTK_IS_CONTAINER(G_OBJECT(parentbox)))
         gtk_container_add(GTK_CONTAINER(parentbox), scrolledwindow1);
  }
  store = gtk_list_store_new (1, G_TYPE_STRING);
  dirsel = gtk_tree_view_new_with_model(GTK_TREE_MODEL (store));
  g_object_set_data (G_OBJECT (parent), id, dirsel);
  gtk_widget_show (dirsel);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), dirsel);
     renderer = gtk_cell_renderer_text_new ();
     g_object_set (GTK_CELL_RENDERER (renderer),
                "font-desc", fontdescN, NULL);
     column = gtk_tree_view_column_new_with_attributes (title,
						     renderer,
						     "text",
						     0,
						     NULL);
     gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
     gtk_tree_view_column_set_clickable(column, FALSE);
     if(title)
     {
        label = gtk_label_new (title);
        gtk_widget_show (label);
        widget_modify_font(label, fontdescU);
        gtk_tree_view_column_set_widget(column, label);
        g_object_set_data(G_OBJECT(dirsel), "titolo", label);
     }
     else
        gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(dirsel), FALSE);
  return dirsel;
}

GtkWidget *createSelectionM(GtkWidget *parent, GtkWidget *parentbox,
                            const char *title[], const char *id, int ncol, const char *col)
{  
  GtkWidget *scrollwin, *dirsel, *label, *frame;
  GtkListStore *store;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
  GType *types = g_new0(GType, ncol);
  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  int i;

 for(i=0; i<ncol; i++)
     types[i] = G_TYPE_STRING;

  frame = gtk_frame_new(NULL);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
  if(parentbox)
  {
     if (GTK_IS_BOX(G_OBJECT(parentbox)))
         gtk_box_pack_start (GTK_BOX (parentbox), frame, TRUE, TRUE, 0);
     else if (GTK_IS_CONTAINER(G_OBJECT(parentbox)))
         gtk_container_add(GTK_CONTAINER(parentbox), frame);
  }
  gtk_widget_show (frame);

  scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add(GTK_CONTAINER(frame), scrollwin);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                   GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrollwin);
  dirsel = gtk_tree_view_new();
  g_object_set_data(G_OBJECT(dirsel), "formato", GINT_TO_POINTER(ncol));
  g_object_set_data(G_OBJECT(dirsel), "frame", frame);
  g_object_set_data(G_OBJECT(dirsel), "scrollwin", scrollwin);

  store = gtk_list_store_newv(ncol, types);
  renderer = gtk_cell_renderer_text_new ();
  g_object_set (GTK_CELL_RENDERER (renderer),
                "font-desc", fontlist, NULL);
  for(i=0; i<ncol; i++)
  {
        if(title && title[i])
           column = gtk_tree_view_column_new_with_attributes (title[i],
               renderer, "text", i, NULL);
        else
           column = gtk_tree_view_column_new_with_attributes ("Title",
               renderer, "text", i, NULL);
        gtk_tree_view_column_set_clickable(column, FALSE);
        gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
        if(title && title[i])
        {
           label = LABEL_BOLD_WITH_FONT(title[i], col, 0.99f, fontlist);
           gtk_widget_show (label);
           gtk_tree_view_column_set_widget(column, label);
        }
  }
  gtk_tree_view_set_model(GTK_TREE_VIEW(dirsel), GTK_TREE_MODEL (store));
  g_object_set_data(G_OBJECT (parent), id, dirsel);
  gtk_widget_show (dirsel);
  gtk_container_add (GTK_CONTAINER (scrollwin), dirsel);
  if(!title)
      gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(dirsel), FALSE);
  return dirsel;
}

GtkWidget *mostra_lista(const char *wtitle, const char *title, const char *vec[], int n_el,
                         int seltype, GCallback cb2)
{
  GtkWidget *window, *list, *vbox, *button;
  int lung;

  window = gtk_dialog_new();
  gtk_window_set_title (GTK_WINDOW(window), wtitle);
  gtk_window_set_position (GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
  lung = n_el * 30 + 100;
  if(lung > 350) 
     lung = 350;
  gtk_window_set_default_size(GTK_WINDOW(window), 100, lung);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(window));
  list = createSelection (window, vbox, title, title, 0, MyBLUE);
  gtk_widget_set_name (list, title);
  if(seltype == 0)
     set_selection_mode(list, GTK_SELECTION_SINGLE);
  else
     set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  populate_list(GTK_TREE_VIEW(list), vec, n_el, 1);
  gtk_widget_show (list);

  button = OK_button();
  gtk_widget_set_name(button, "ok");
  gtk_dialog_add_action_widget (GTK_DIALOG (window), button, 1);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);
  gtk_widget_show (button);
  (void) g_signal_connect (G_OBJECT(button), "clicked", cb2, DuplicaStringa(title));

  button =  CANCEL_button();
  gtk_widget_set_name(button, "cancel");
  gtk_dialog_add_action_widget (GTK_DIALOG (window), button, 2);
  gtk_widget_show (button);
  (void) g_signal_connect (G_OBJECT(button), "clicked", cb2, DuplicaStringa(title));
  
  (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  gtk_widget_show(window);
  finestra_modale_aperta2(window);
  return list;
}

static int action = 3;
static int vsele[MaxAtLSQ];

void end_list(GtkButton *button, gpointer data)
{
   GtkWidget *lista = get_widget(gtk_widget_get_toplevel(GTK_WIDGET(button)),
                             "scelte");

   get_selected_rownums(lista, vsele);

   action = GPOINTER_TO_INT(data);
   close_dlg(button, GINT_TO_POINTER(11));
   gtk_main_quit();
}

namespace GLextmr {
    void SelezionaAtomi(int whichModel, GList *atoms_to_sel);
    void set_children_status(gpointer item, gboolean active, GtkWidget *mw);
                  };
static void selected_peek(GtkTreeSelection  *sele, gpointer data)
{
using namespace GLextmr;
     GtkTreeView *tree_view;

     tree_view = gtk_tree_selection_get_tree_view(sele);
     GList *rowsel = NULL, *atoms_to_sel=NULL;
     rowsel = get_selections(GTK_WIDGET(tree_view));
     if(rowsel)
     {
        int num_sel = g_list_length(rowsel);
        for(int i=0; i<num_sel; i++)
        {
             GtkTreePath *path = (GtkTreePath *) g_list_nth_data (rowsel, i);
             gpointer riga =
                 get_selection_from_pathC(tree_view, path, 0);
             atoms_to_sel = g_list_append(atoms_to_sel, riga);
        }
        g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
        g_list_free (rowsel);
     }
     SelezionaAtomi(0, atoms_to_sel);
     g_list_free (atoms_to_sel);
}

GtkWidget *create_newpeeklist (int sel_mode, char *string, int natsOld)
{
  GtkWidget *label, *button;

  GtkWidget *window = gtk_dialog_new();
  gtk_container_set_border_width(GTK_CONTAINER(window), 6);

  int lar, alt;
  PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
  get_metrics(fontlist, &lar, &alt);
  GtkWidget *parentbox = gtk_dialog_get_content_area(GTK_DIALOG(window));
  if(string && (strlen(string) > 1))
  {
     label = label_boxed(string);
     set_alignment (gtk_bin_get_child(GTK_BIN(label)), 0.5, 0.5);
     gtk_widget_show(label);
     gtk_box_pack_start(GTK_BOX(parentbox), label, FALSE, FALSE, 0);
  }

  const char *titles[] = { "Number", "Label", "Intensity",
                           "Minimum distance", "From"};
  GType types[] = { G_TYPE_INT, G_TYPE_STRING, G_TYPE_INT,
                    G_TYPE_FLOAT,  G_TYPE_STRING};
  int  sizes[] = { -1, 0, 0, 0, 0};
  int precs[] = { 0, 0, 0, 3, 0};

  int ncol = (int)(sizeof(sizes)/sizeof(sizes[0]));
  GtkWidget *list =
  new_selection(window, parentbox, "scelte", ncol, titles, sizes, types, precs);
  widget_modify_font(list, fontlist);
  g_object_set_data(G_OBJECT(list), "alt", GINT_TO_POINTER(alt));
  for(int i=0; i<ncol; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), i);
      label = gtk_tree_view_column_get_widget(column);
      if(label)
         widget_modify_font(label, fontlist);
  }
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  if(sel_mode)
     set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  else
     set_selection_mode(list, GTK_SELECTION_SINGLE);

  int hnd = g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (selected_peek), NULL);
  g_object_set_data(G_OBJECT(selection), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));

  button = OK_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window), button, 1);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
          G_CALLBACK(end_list), GINT_TO_POINTER(1));

  button = myimage_button("   _All", "all.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (window), button, 2);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
          G_CALLBACK(end_list), GINT_TO_POINTER(2));

  button =  CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window), button, 3);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
          G_CALLBACK(end_list), GINT_TO_POINTER(3));

  (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
          G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return window;
}

void FillList1(GtkTreeView *list, int nc, int natsOld, atom_type *atm, 
               float mindistv[], int kminv[])
{
  GtkTreeIter iter;
  int alt = get_int(GTK_WIDGET(list), "alt");
  GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
  GtkTreeSelection *selection = gtk_tree_view_get_selection(list);
  int hnd = get_int(GTK_WIDGET(list), "hnd");
  if(hnd)
     g_signal_handler_block(G_OBJECT(selection), hnd);
  gtk_list_store_clear(GTK_LIST_STORE(list_store));
  gtk_widget_set_size_request(get_widget(GTK_WIDGET(list), "scrollwin"), -1, MRmin(2*nc*alt, 10*alt));
  for(int i=0; i<nc; i++)
  {
      int iat = natsOld + i;
//corr      int kat = kminv[i];
      int kat = kminv[i]-1;
//      char *label1 = g_strdup(atm[iat].lab);
//      char *label2 = g_strdup(atm[kat].lab);
      char *label1 = g_new0(char, 17);
      char *label2 = g_new0(char, 17);
      CopiaStringan(label1, 17, atm[iat].lab, 16);
      CopiaStringan(label2, 17, atm[kat].lab, 16);

      gtk_list_store_append (list_store, &iter);
      gtk_list_store_set (list_store, &iter,
              0, iat,
              1, g_strstrip(label1), 
              2, (int) atm[iat].inte,
              3, mindistv[i], 
              4, g_strstrip(label2), -1);
  }
  if(hnd)
     g_signal_handler_unblock(G_OBJECT(selection), hnd);
}

void open_newpeeklist(char *Inte, int NumCan, int *MultiSel, int sel[],
                  int *iExitC, int natsOld, char *Msg, 
                  atom_type *atm, float mindistv[], int kminv[])
{
   int i;
   GtkWidget *list, *dialog;

   action = 3;
   for(i=0; i<NumCan; i++)
       vsele[i] = sel[i];

   dialog = create_newpeeklist(*MultiSel, Msg, natsOld);
   gtk_window_set_title (GTK_WINDOW (dialog), Inte);
   list = lookup_widget(dialog, "scelte");
   FillList1(GTK_TREE_VIEW(list), NumCan, natsOld, atm, mindistv, kminv);

   gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(finestre[0]));
   gtk_widget_show_all(dialog);
   finestra_modale_aperta2(dialog);
   gtk_main();
   *iExitC = action;
   for(i=0; i<NumCan; i++)
       sel[i] = vsele[i];
}

extern "C" void c_newpeeklist_(char *Inte, int *NumCan, int *MultiSel, int sel[],
                  int *iExitC, int *natsOld, char *Msg, 
                  atom_type *atml, float mindistv[], int kminv[])
{
   fine_lavoro();
   int Nats = *natsOld + (*NumCan);
   atom_type *atm = g_new0(atom_type, Nats);
   memcpy(atm, atml, Nats*sizeof(atom_type));
   open_newpeeklist (Inte, *NumCan, MultiSel, sel, iExitC, 
                     *natsOld, Msg, atm, mindistv, kminv);
   g_free(atm);
}

void help_wind(gchar *tip_private, GtkWidget *widget)
{
   GtkWidget *hwin, *label;

   if(tip_private && (strstr(tip_private, "Private") == NULL) &&
        (strlen(tip_private) > 1))
   {
	  
      hwin = gtk_window_new(GTK_WINDOW_POPUP);
      gtk_window_set_position (GTK_WINDOW(hwin), GTK_WIN_POS_MOUSE);
      label = window_tip(tip_private, 30);
      gtk_container_add(GTK_CONTAINER(hwin), label);
      (void) g_signal_connect_swapped (G_OBJECT(hwin), "button-press-event",
                 G_CALLBACK(gtk_widget_destroy), G_OBJECT(hwin));
      (void) g_signal_connect_swapped (G_OBJECT(hwin), "leave-notify-event",
                 G_CALLBACK(gtk_widget_destroy), G_OBJECT(hwin));
      gtk_widget_set_events(hwin, GDK_BUTTON_PRESS_MASK | GDK_LEAVE_NOTIFY_MASK );
      gtk_widget_show_all(hwin);
   }
   else if(ifStatusbar)
      print_mess("Sorry. Help not available.");
}

GtkWidget *toolbar_button_with_label(const gchar  *xpm_filename, const gchar *label)
{
    GtkWidget *button;

    button = myimage_button (label, xpm_filename);

    gtk_button_set_relief (GTK_BUTTON(button), GTK_RELIEF_NONE);
    gtk_widget_set_can_focus(button, FALSE);
    gtk_widget_show(button);
    return button;
}

void salva_stato_tb(GtkWidget *widget, gboolean stato_sav[])
{
    GList     *children;
    GtkWidget *child, *hbox;
    int       numChildren,i;

    children = gtk_container_get_children(GTK_CONTAINER(get_widget(widget, "tb")));
//160710    children = gtk_container_get_children(GTK_CONTAINER(widget));
    numChildren = g_list_length(children);

    for(i=0; i<numChildren;i++)
    {
        child = GTK_WIDGET(g_list_nth_data(children, i));
        if(gtk_widget_get_sensitive(child))
           stato_sav[i] = TRUE;
        else
           stato_sav[i] = FALSE;
    }
    hbox = get_widget(widget, "hbox");
    if(gtk_widget_get_sensitive(hbox))
       stato_sav[50] = TRUE;
    else
       stato_sav[50] = FALSE;
    if(children)
       g_list_free(children);
}

void abilitatb(GtkWidget *widget, int state)
{
    GtkWidget *hbox;

    if(ifToolbar && show_toolbar)
    {

       hbox = get_widget(widget, "hbox");
       switch(state)
       {
       case -1:
          gtk_widget_set_sensitive(hbox, statoinitb[0][50]);
          break;
       case -2:
          gtk_widget_set_sensitive(hbox, statoinitb[win_stack][50]);
          break;
       default:
          gtk_widget_set_sensitive(hbox, state);
          break;
       }
/*
       GList     *children;
       children = gtk_container_get_children(GTK_CONTAINER(get_widget(widget, "tb")));
       int numChildren = (int) g_list_length(children);
       for(int i=0; i<numChildren;i++)
       {
           GtkWidget *child = GTK_WIDGET(g_list_nth_data(children, i));
           if(strstr(gtk_widget_get_name(child), "On Item"))
              gtk_widget_set_sensitive(child, TRUE);
           else
           
              switch(state)
              {
              case -1:
                 gtk_widget_set_sensitive(child, statoinitb[0][i]);
                 break;
              case -2:
                 gtk_widget_set_sensitive(child, statoinitb[win_stack][i]);
                 break;
              default:
                 if( (strstr(gtk_widget_get_name(child), "Move Labels")) && state)
                      gtk_widget_set_sensitive(child, dialogo->ifLabels);
                 else
                      gtk_widget_set_sensitive(child, state);
                 break;
              }
       }
*/
    }
}

void salva_stato_mb(GtkWidget *widget, gboolean stato_sav[])
{
    GList     *children, *nipoti;
    GtkWidget *child, *widgetf, *nipote;
    int       numChildren, numnipoti,i, j, k;

    children = gtk_container_get_children(GTK_CONTAINER(widget));
    numChildren = g_list_length(children);
    k = 0;
    for(i=0; i<numChildren - 1;i++)
    {
        child = GTK_WIDGET(g_list_nth_data(children, i));
        if(gtk_widget_get_sensitive(child))
           stato_sav[k++] = TRUE;
        else
           stato_sav[k++] = FALSE;
	       widgetf = gtk_menu_item_get_submenu(GTK_MENU_ITEM(child));
        nipoti = gtk_container_get_children(GTK_CONTAINER(widgetf));
        numnipoti = g_list_length(nipoti);
        if(numnipoti > 0)
        {
           for(j=0; j<numnipoti;j++)
           {
               nipote = GTK_WIDGET(g_list_nth_data(nipoti, j));
               if(gtk_widget_get_sensitive(nipote))
                  stato_sav[k++] = TRUE;
               else
                  stato_sav[k++] = FALSE;
           }
           g_list_free(nipoti);
        }
    }
    if(children)
       g_list_free(children);
}

void create_tree(GtkWidget *window, char *names[], int nRami, int nFoglie[],
                  int offset, GCallback cb1, GCallback cb2)
{
}

GtkWidget *menu_item(gchar *xpm_filename[], int n_icons, const gchar *labeltext)
{
    GtkWidget *box1;
    GtkWidget *label, *item;
    GtkWidget *pixmapwid;
    char num[8];
    int i;

    item = gtk_menu_item_new();

   /* Create box for xpm and label */
    box1 = hbox_new (FALSE, 0);
    g_object_set_data(G_OBJECT(item), "button", box1);

    /* Create images for the menuitem */
    for (i=0; i<n_icons; i++)
    {
         pixmapwid = create_image (xpm_filename[i]);
         gtk_widget_show(pixmapwid);
         gtk_box_pack_start (GTK_BOX (box1),
                                  pixmapwid, FALSE, FALSE, 0);
         ScriviStringa(num, sizeof(num), "icon%d", i);
         g_object_set_data (G_OBJECT(box1), num, pixmapwid);
    }

    g_object_set_data(G_OBJECT(box1), "quale", GINT_TO_POINTER(0));
    pixmapwid = get_widget(box1, "icon1");
    gtk_widget_hide(pixmapwid);

    /* Create a label for the menuitem */
    label = gtk_label_new_with_mnemonic(labeltext);
    g_object_set_data(G_OBJECT(item), "label", label);

    /* Pack the label into the box */
    gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 6);

    gtk_widget_show(label);
    gtk_widget_show(box1);

    gtk_container_add (GTK_CONTAINER (item), box1);

    return item;
}

void abilita_item(GtkWidget *child, int stato, int *indice)
{
  int k;

  k = *indice;
  switch(stato)
  {
  case -1:
       gtk_widget_set_sensitive(child, statoinimb[0][k]);
       break;
  case -2:
       gtk_widget_set_sensitive(child, statoinimb[win_stack][k]);
       break;
  case -3:
       gtk_widget_set_sensitive(child, statoinimb[5][k]);
       break;
  case 0:
       gtk_widget_set_sensitive(child, stato);
       break;
  default:
       stato = stato - 1;
       gtk_widget_set_sensitive(child, stato);
       break;
  }
  k++;
  *indice = k;
}

void abilitamb(GtkWidget *mwin, int stato)
{
    GList     *children;
    GtkWidget *child, *widget;
    int       numChildren;

    if(ifMenubar)
    {
       widget = lookup_widget(mwin, "menubar");
       children = gtk_container_get_children(GTK_CONTAINER(widget));
       numChildren = g_list_length(children);
       gtk_widget_set_sensitive(widget, stato);
       child = GTK_WIDGET(g_list_nth_data(children, numChildren-1));
       gtk_widget_set_sensitive(child, TRUE);
       if(numChildren)
          g_list_free(children);
    }
}

void Oldabilitamb(GtkWidget *mwin, int stato)
{
    GList     *children, *nipoti;
    GtkWidget *child, *widget, *widgetf, *nipote;
    int       numChildren, numnipoti, i, j, k;

    if(ifMenubar)
    {
       widget = lookup_widget(mwin, "menubar");
       children = gtk_container_get_children(GTK_CONTAINER(widget));
       numChildren = g_list_length(children);
       k = 0;

       for(i=0; i<numChildren - 1;i++)
       {
           child = GTK_WIDGET(g_list_nth_data(children, i));
           abilita_item(child, stato, &k);
           widgetf = gtk_menu_item_get_submenu(GTK_MENU_ITEM(child));
           nipoti = gtk_container_get_children(GTK_CONTAINER(widgetf));
           numnipoti = g_list_length(nipoti);
           if(numnipoti > 0)
           {
              for(j=0; j<numnipoti;j++)
              {
                  nipote = GTK_WIDGET(g_list_nth_data(nipoti, j));
                  abilita_item(nipote, stato, &k);
              }
           }
       }
       child = GTK_WIDGET(g_list_nth_data(children, numChildren-1));
       gtk_widget_set_sensitive(child, TRUE);
    }
}

void close_dlg  (GtkButton  *button, gpointer data)
{
    int num;
    gboolean ifmodale, ifdestroy, ifloop;

    ifdestroy = FALSE;
    ifloop = FALSE;
    num = GPOINTER_TO_INT(data);
    if(num >= 20)
    {
       num -= 20;
       ifloop = TRUE;
    }
    if(num >= 10)
    {
       num -= 10;
       ifdestroy = TRUE;
    }
    ifmodale = num % 2;
    num /= 2;
    if(ifmodale)
      finestra_modale_chiusa2();
    if(ifdestroy)
       gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
    else
       gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
    if(ifloop)
      gtk_main_quit();
}

void on_cb_show(GtkToggleButton *button, GtkWidget *to_show)
{
   gboolean st;

   st = gtk_toggle_button_get_active(button);
   if(st)
      gtk_widget_show(to_show);
   else
      gtk_widget_hide(to_show);
}

void on_cb_hide(GtkToggleButton *button, GtkWidget *to_hide)
{
   gboolean st;

   st = gtk_toggle_button_get_active(button);
   if(st)
      gtk_widget_hide(to_hide);
   else
      gtk_widget_show(to_hide);
}

void PrintScreen(GtkWidget *item, gpointer data)
{
using namespace gtkext;

//NEW 26042016
     std::string strExts;
     std::vector<std::string> vecExts;
     int filt = fill_formats(vecExts, strExts);
//END NEW 26042016

     GdkPixbuf *dest, *pixb;
     GError *error = NULL;
     FilselItem local_item;
     GtkAllocation allocation;
     gtk_widget_get_allocation(drawingarea, &allocation);

     std::string curdir = getPWD();
     char *temp_file = NULL;
     if(!TmpFile.empty())
        temp_file = g_strdup_printf("%s.png", TmpFile.c_str());
//26042016     local_item = saveas(finestre[0], "*.png", temp_file);
     if(filt != -1)
        default_filter_out = filt;
     local_item = saveas(finestre[0], strExts.c_str(), temp_file, false);
     dir_set_current(curdir.c_str());
     if(local_item.exitCode > 0)
     {
       std::string pngfile = local_item.cwd;
       std::string fn = local_item.fileinp;
//26042016       std::vector<std::string> exts;
//26042016       exts.push_back("png");
//26042016       int k = find_extension_in_list(fn, exts);
//26042016       if(k == -1)
//26042016          return;
       pngfile.append(fn);
       int tipo = local_item.nfilt;
       os_and_gc *rt = g_new0(os_and_gc, 1);
       rt->os = getCurrentPix();
       rt->gc = getCurrentWindow();
       pixb = (GdkPixbuf *)pixbuf_get_from_struct (rt);

       if(pixb != NULL)
       {
          if(local_item.ifAlpha)
          {
            if(Style[STYLE_BG].colline)
               dest = gdk_pixbuf_add_alpha(pixb, TRUE, 255, 255, 255);
            else
               dest = gdk_pixbuf_add_alpha(pixb, TRUE, 0, 0, 0);
          }
          else
               dest = gdk_pixbuf_copy(pixb);
          g_object_unref(G_OBJECT(pixb));
       }
       if(dest != NULL)
       {
         gdk_pixbuf_save (dest, pngfile.c_str(), vecExts[tipo].c_str(), &error, NULL);
//26042016         gdk_pixbuf_save (dest, pngfile.c_str(), "png", &error, NULL);
         if(error != NULL)
            MessageDialog(finestre[0], GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                   "Error: %s", error->message);
       }
         vecExts.clear();
         strExts.clear();
     }
}

void crea_png_(char *pngfile)
{
    if(!jscreen)
       return;
    os_and_gc *rt = g_new0(os_and_gc, 1);

    rt->os = getCurrentPix();
    rt->gc = getCurrentWindow();
    save_pixbuf_from_mem(rt, pngfile);
}

void appendPng(FILE *fp, const char *fn)
{
       if(g_file_test(fn, G_FILE_TEST_EXISTS))
       {
          fprintf(fp, "<p align=\"center\">");
          fprintf(fp,  "<font size=\"2\" style=\"font-family: courier new,courier,monospace;\"> \n");
          fprintf(fp,  "<u><b>Image File: %s</b></u></p>\n", fn);
          fprintf(fp,  "<img border=\"0\" src=\"%s", fn);
          fprintf(fp,  "\" >\n");
       }
}

void OpenHtml(const char *htmlFile, const char*ib)
{
   std::string file = htmlFile;
   std::string brow = ib;
   URLOpen(file, ib, finestre[0]);
}

void htmlOpen(char *htmlFile)
{
   if(!g_file_test(htmlFile, G_FILE_TEST_EXISTS))
   {
      cMsgWinErr("Error", htmlFile, ERR_WINDOW+10);
      return;
   }
   OpenHtml(htmlFile, Internet_Browser);
}

void createHtml()
{
      FILE *fp, *ifp;
      char *structname = g_new0(char, 80);
      char *htmlFile = g_new0(char, 500);
      char *dirn = g_new0(char, 500);
      char *filpng = g_new0(char, 500);
      char *filnam = g_new0(char, 500);
      char *line = g_new0(char, 500);

      CopiaStringa(htmlFile,  500, cSWareRC->WorkingDirectory);
      CopiaStringa(structname, 80, str_cut((char *)g_path_get_basename(filebin), "."));
      if(htmlFile[strlen(htmlFile)-1] != G_DIR_SEPARATOR)
         AppendiStringa(htmlFile, 500, G_DIR_SEPARATOR_S);
      CopiaStringa(dirn,  500, htmlFile);
      AppendiStringa(htmlFile, 500, structname);
      AppendiStringa(filnam, 500, structname);
      CopiaStringa(filpng,  500, htmlFile);
      AppendiStringa(htmlFile,  500, ".htm");
      AppendiStringa(filpng,  500, "_fPlot.png");
      AppendiStringa(filnam,  500, ".log");
      fp = fOpen(htmlFile, "w");

      if( !fp)
        return;

                                 /*   header     */
      fprintf(fp, "<html>\n");
      fprintf(fp, "<head>\n");
      fprintf(fp, "<meta http-equiv=\"Content-Language\" content=\"en-us\">\n");
      fprintf(fp, "<meta name=\"GENERATOR\" content=\"Sir2006\">\n");
      fprintf(fp, "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1252\">\n");
      fprintf(fp, "<title>%s</title>\n", structname);
      fprintf(fp, "</head>\n");
      fprintf(fp, "<body>\n");
      fprintf(fp, "<a name=\"home\"></a>\n");

                                 /*  body */
      fprintf(fp, "<p align=\"left\"><font size=\"5\" style=\"font-family: times new roman,times,serif;\"");
      fprintf(fp, "color=\"#FF0000\"><b>Summary for %s </b></font></p>", structname);
      fprintf(fp, " <hr color=\"#000080\" size=\"1\">");
      fprintf(fp, "<pre>\n");

      ifp = fOpen(filnam, "r");
      if(ifp)
      {
         while( fgets(line, 400, fp) != NULL)
            fprintf(fp, "%s", line);
         fclose(ifp);
      }
      appendPng(fp, filpng);
                                 /*   end */
      fprintf(fp, "</font>\n");
      fprintf(fp, "</pre>\n");
      fprintf(fp, "</body>\n");
      fprintf(fp, "</html>\n");
      fclose(fp);
      g_free(structname);
      g_free(dirn);
      g_free(filpng);
      g_free(filnam);
      g_free(line);
      htmlOpen(htmlFile);
      g_free(htmlFile);
}

/*****************************************************************/

void updclistavec (GtkWidget *gtklist, const char *list[], int n_el, int fClear)
{
     populate_list(GTK_TREE_VIEW(gtklist), list, n_el, fClear);
}

int find_element(const char *string, const char *vect[], int n_el)
{
   int i;

   for(i=0; i<n_el; i++)
   {
       if(g_ascii_strcasecmp(string, vect[i]) == 0)
          return i;
   }
   return -1;
}

void mr_make_absolute_path2(char *name)
{
    gchar *dirnam = g_path_get_dirname(name);
    gchar *basenam = g_path_get_basename(name);
    gchar *dirabs = g_new0(char, MaxLenFilename);

    if(g_path_is_absolute(dirnam))
       return;
    else if(dirnam[0] != '.')
      ScriviStringa(dirabs, MaxLenFilename, "%s%c%s", g_get_current_dir(), G_DIR_SEPARATOR, dirnam);
    else
    {
      if(strlen(dirnam) == 1)
         CopiaStringa(dirabs, MaxLenFilename, g_get_current_dir());
      else if(dirnam[1] == G_DIR_SEPARATOR)
      {
         strshift(dirnam, 2);
         ScriviStringa(dirabs, MaxLenFilename, "%s%c%s", g_get_current_dir(), G_DIR_SEPARATOR, dirnam);
      }
      else if(dirnam[2] == G_DIR_SEPARATOR)
      {
         strshift(dirnam, 3);
         ScriviStringa(dirabs, MaxLenFilename, "%s%c%s", g_path_get_dirname(g_get_current_dir()), G_DIR_SEPARATOR, dirnam);
      }
    }
    CopiaStringa(name, MaxLenFilename,
       g_build_filename(dirabs, basenam, NULL));
    g_free(dirnam);
    g_free(dirabs);
}

void call_expo(param_options_type *p)
{
using namespace main_app;
//    ScriviStringa(prog_dir, MaxLenFilename, "%s", get_prog_dir(args->arg[0]));
//    Application::SetProgName(prog_dir);
    if(args->argc > 1)
    {
       mr_make_absolute_path2(args->arg[1]);
       TmpFile.assign(str_cut(g_path_get_basename(args->arg[1]), "."));
#ifdef _WIN32
#ifdef RIGAKU
	   //Rigaku co. 2009/Sep./24
	   //To support Japanese.
       gchar *basenam = g_path_get_basename(args->arg[1]);
      ScriviStringa(args->arg[1], MaxLenFilename, "%s", basenam);

	   gsize fleng;
	   gchar *dir  = g_path_get_dirname(args->arg[1]);
	   gchar *_dir = g_locale_from_utf8((const gchar *)dir,-1,&fleng,&fleng,NULL);
	   if(_dir == NULL)
	   {
		   CopiaStringa(cSWareRC->WorkingDirectory, MaxLenFilename, dir);
		   g_free(_dir);
	   } else {
		   CopiaStringa(cSWareRC->WorkingDirectory, MaxLenFilename, _dir);
		   g_free(dir);
	   }
       g_free(basenam);
#else
       std::string s = fromUTF8(args->arg[1]);
       CopiaStringa(cSWareRC->WorkingDirectory, MaxLenFilename, 
            g_path_get_dirname(s.c_str()));
#endif
#else
       CopiaStringa(cSWareRC->WorkingDirectory, MaxLenFilename, 
            g_path_get_dirname(args->arg[1]));
#endif
       dir_set_current(cSWareRC->WorkingDirectory);
    }
    if(args->argc > 2)
       mr_make_absolute_path2(args->arg[2]);
    //if(prendi_parametro())
    //   return;
    expo2005_(p);
}

void init_some_val()
{
   
      dialogo->color_BLACK        = 1;
      dialogo->color_BRIGHTWHITE  = 2;
      dialogo->color_WHITE        = 3;
      dialogo->color_GRAY         = 4;
      dialogo->color_BLUE         = 5;
      dialogo->color_GREEN        = 6;
      dialogo->color_CYAN         = 7;
      dialogo->color_RED          = 8;
      dialogo->color_MAGENTA      = 9;
      dialogo->color_BROWN        = 10;
      dialogo->color_LIGHTBLUE    = 11;
      dialogo->color_LIGHTGREEN   = 12;
      dialogo->color_LIGHTCYAN    = 13;
      dialogo->color_LIGHTRED     = 14;
      dialogo->color_LIGHTMAGENTA = 15;
      dialogo->color_YELLOW       = 16;
      dialogo->color_OBS          = OBS + 1;
}

#if 0
#ifdef _WIN32
#ifdef MYDEBUG
int main(int argc, char **argv)
{
    int i;

#if !defined(_WIN32) && !defined(MACOSX)
     putenv(g_strdup("UBUNTU_MENUPROXY=0"));
#endif

    args->argc = argc;
    for(i=0; i<argc; i++)
    {
        memset(args->arg[i], 0, sizeof(nomefile));
        CopiaStringa(args->arg[i], MaxLenFilename, argv[i]);
    }
    init_some_val();
    call_expo();
    return 0;
}
#else
HANDLE hndOut;
#if defined (_MSC_VER) && (_MSC_VER < 1700)

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{

#else

#include <tchar.h>
#include <AtlBase.h>
int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
                     _In_opt_ HINSTANCE hPrevInstance,
                     _In_ LPTSTR    lpCmdLine,
                     _In_ int       nCmdShow)
{
  USES_CONVERSION;

  UNREFERENCED_PARAMETER(hInstance);
  UNREFERENCED_PARAMETER(hPrevInstance);
  UNREFERENCED_PARAMETER(nCmdShow);
  UNREFERENCED_PARAMETER(lpCmdLine);
#endif

    int i = 0;
    LPWSTR *szArglist;
    int nArgs;

    szArglist = CommandLineToArgvW(GetCommandLineW(), &nArgs);
    if( NULL != szArglist )
    {
        for( i=0; i<nArgs; i++) 
        {
#ifdef RIGAKU
			//Rigaku co. 2009/Sep./24
			//To support Japanese.
            int sizeMulti = WideCharToMultiByte(CP_OEMCP, 0, szArglist[i], -1, NULL, 0, NULL, NULL);
            WideCharToMultiByte(CP_OEMCP, 0, szArglist[i], -1, (char *)(args->arg[i]), sizeMulti, NULL, NULL);
#else
            ScriviStringa(args->arg[i], MaxLenFilename, "%ws", szArglist[i]);
#endif
        }
        LocalFree(szArglist);
    }
    args->argc = nArgs;  

//    AllocConsole();
//    hndOut = GetStdHandle(STD_OUTPUT_HANDLE);

    init_some_val();
    call_expo();

//    FreeConsole();
    return 0;
}
#endif
#else
int main(int argc, char **argv)
{
    int i;

#if !defined(_WIN32) && !defined(MACOSX)
     putenv(g_strdup("UBUNTU_MENUPROXY=0"));
#endif
    args->argc = argc;
    for(i=0; i<argc; i++)
    {
        memset(args->arg[i], 0, sizeof(nomefile));
        CopiaStringa(args->arg[i], MaxLenFilename, argv[i]);
    }
    init_some_val();
    call_expo();
    return 0;
}
#endif
#endif

void PrintVersion(std::ostream &os)
{
using namespace main_app;
using namespace std;
    char *path = g_strdup(Application::GetProgName());
    char *abs = g_build_filename(path, g_get_prgname(), NULL);
    os << MR_PACKAGE << " Version " << VERSION << "\n"
       << DateInfo(abs) << "\n" << ArchInfo() << "\n";
}

void PrintHelp(std::ostream &os)
{
    os << MR_PACKAGE << " " << VERSION << "\n\n";
    os << "usage: " << MR_PACKAGE <<
            " [options] file1 [file2 ...]\n" <<
          "     where options represents zero or more program options\n\n" <<
          "options\n" <<
          "-------\n" <<
          "     -help           Print this help on terminal.\n" <<
          "     -version        Print name and version of program.\n"  <<
          "     -nogui          Run the program without graphics.\n"  <<
          "     -auto           Run the program in automatic mode.\n" <<
          "     -index=val      Powder-pattern indexing.\n"  <<
          "     -wavel=val      Radiation wavelength.\n\n\n";
}

std::string getParamString(std::string param)
{
   std::string::size_type i1 =  param.find_first_of("=");
   std::string val = "";
   if(i1 != std::string::npos)
      val = param.substr(i1+1);
   return val;
}
int Main (int argc, char **argv)
{
using namespace main_app;
using namespace std;
    _OptStruct options[] = {
         {"version",  0, 0,  0},
         {"nogui",    1, 0,  1},
         {"auto",     1, 0,  1},
         {"help",     0, 0,  0},
         {"index",    1, 0,  2},
         {"wavel",    1, 0,  3},
         {NULL,       0, 0,  0} };
    param_options_type p = {0, 0, 0, -1.f};
    static const char ind_val[] = {"nmd"};

#if 0
#ifdef _WIN32
    SetThreadLocale(MAKELCID(MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US),SORT_DEFAULT));
#endif
#ifdef MACOSX
    gtk_disable_setlocale();
#endif
#endif
    args->argc = 1;
    CopiaStringa(args->arg[0], MaxLenFilename, argv[0]);
    gtk_init_check(&argc, &argv);
    ScriviStringa(prog_dir, MaxLenFilename, "%s", get_prog_dir(args->arg[0]));
    Application::SetProgName(prog_dir);

#ifdef _WIN32
      char *tmp = g_path_get_dirname(prog_dir);
      char *babel_dir = g_build_filename(tmp, "share", "openbabel", NULL);
      g_free(tmp);
      std::string env_str("BABEL_DATADIR=");
      env_str.append(babel_dir);
      _putenv(env_str.c_str());
#endif

    for(int i=1; i<argc; i++)
    {
         std::string param = argv[i];
         if(argv[i][0] == '-')                // gestione opzioni
         {
            if(param.find_first_not_of("-") == std::string::npos)
               continue;
            std::string option = param.substr(param.find_first_not_of("-"));
            int Result = IsValidOption(option, options);
            if(Result == -1)
               dlg_warning("Invalid option: %s", argv[i]);
            else if(Result < -1)
            {
               int k = MRabs(Result) / 100 - 1;
               int j = MRabs(Result) % 100;
               if(options[j].valore > 1)
               {
                  std::string val_opt = getParamString(option);
                  if(val_opt.empty())
                  {
                     dlg_warning("Invalid option: %s", argv[i]);
                     break;
                  }
                  int kv = options[j].valore - 2;
                  switch(kv)
                  {
                  default:
                       dlg_warning("Invalid option: %s", argv[i]);
                  case 0:           // indexing
                       {
                       std::string allowed = ind_val;
                       int *ind_vet = g_new0(int, allowed.length());
                       for(int kk=0; kk<(int)val_opt.length(); kk++)
                       {
                           char c = val_opt.at(kk);
                           size_t ind1 = allowed.find(c);
                           if(ind1 != std::string::npos)
                              ind_vet[(int)ind1] = 1;
                           else
                           {
                              dlg_warning("Invalid option: %s", argv[i]);
                              break;
                           }
                       }
                       options[j].valore = 0;
                       for(int kk=0; kk<(int)allowed.length(); kk++)
                       {
                           if(ind_vet[kk])    
                              options[j].valore += (int) pow(10., kk);
                       }
                       g_free(ind_vet);
                       p.v[k] = options[j].valore;
                       }
                       break;
                  case 1:           // wavelength
                       p.wavelen = (float) atof(val_opt.c_str());
                       if(p.wavelen <= 1e-10)
                       {
                           dlg_warning("Invalid option: %s", argv[i]);
                           break;
                       }
                       break;
                  }
               }
               else
                  p.v[k] = options[j].valore;
            }
            else
            {
               switch(Result/100-1)
               {
               case 0:
                    PrintVersion(cout);
                    return 0;
                    break;
               default:
               case 3:
                    PrintHelp(cout);
                    return 0;
                    break;
               }
            }
         }
         else
         {
            memset(args->arg[args->argc], 0, sizeof(nomefile));
            CopiaStringa(args->arg[args->argc], MaxLenFilename, argv[i]);
            args->argc++;
         }
    }
    init_some_val();
    call_expo(&p);
    return 0;
}

#ifndef LIBEXPO
#include "int_main.h"
#endif

void pdf_open(GtkWidget *item, gpointer data)
{
      //std::string pdfname = "http://www.ba.ic.cnr.it/softwareic/files/EXPO2014.pdf";
      std::string pdfname = "http://www.ba.ic.cnr.it/softwareic/expo/wp-content/uploads/sites/2/kalins-pdf/Expo2014.pdf";
      //std::string pdfname = g_strdup_printf(
      //     "%s%cexpo_help%cexpo_help.pdf",files_dir, DIR_SEPAR, DIR_SEPAR);
      OpenPdf(pdfname, finestre[0]);
}

void open_htm(const char *filenam, bool top)
{
      std::string urlname;
#if 0
      if(top)
         urlname = g_strdup_printf("%s%cexpo_help%c",files_dir, DIR_SEPAR, DIR_SEPAR);
      else
         urlname = g_strdup_printf("%s%cexpo_help%cfiles%c",files_dir, DIR_SEPAR, DIR_SEPAR, DIR_SEPAR);
      std::string temp(filenam);
      size_t i = temp.find("#");
      if(i == std::string::npos)
         urlname.append(filenam);
      else
         urlname.append(temp.substr(0,i));
#endif
      urlname = "http://www.ba.ic.cnr.it/softwareic/expo/";
      urlname.append(filenam);

      OpenHtml(urlname.c_str(), Internet_Browser);
}

extern "C" void set_action_on_pattern_(char *tb_string, int *stato)
{
     gpointer but = get_object(mainwin, tb_string);
     int st = *stato;
     obj_set_active(but, st);
}

extern "C" void wmenu_set_state_(char *menu_string, int *stato)
{
using namespace GLextmr;
     GtkWidget *menubar = lookup_widget(mainwin, "menubar");
     gpointer item = get_object(mainwin, menu_string);
     if(item == NULL)
        return;
     if(*stato == 2)
        obj_hide(item);
     else 
     {
        obj_show(item);
        set_children_status(item, (*stato == 1), finestre[0]);
        if (*stato == 1) 
            gtk_widget_set_sensitive(menubar, TRUE);

        obj_set_sensitive(item, *stato);

        if(strcmp(menu_string, "File") == 0)
        {
           gpointer item2 =  get_object(mainwin, "Save Project");
           if(item2)
              set_save_status(item2, *stato);
        }
     }
}

extern "C" void wmenu_set_button_(char *menu_string, int *stato)
{
using namespace GLextmr;
     gpointer item = get_object(mainwin, menu_string);
     if(item == NULL)
        return;
     int hnd = get_int(item, "hnd");
     g_signal_handler_block(G_OBJECT(item), hnd);
     obj_set_active(item, *stato);
     g_signal_handler_unblock(G_OBJECT(item), hnd);
}

extern "C" void toolbar_set_state_(char *tb_string, int *stato)
{
     GtkWidget *tbf = lookup_widget(finestre[0], toolbarname[Livcur]);
     GtkWidget *tb = get_widget(tbf, "tb");
     gpointer item = get_object(finestre[0], tb_string);
           
     if(item == NULL)
        return;
//corr
//mr     if (*stato == 1) 
//mr     {
//mr         GtkWidget *hbox = get_widget(tb, "hbox");
//mr         gtk_widget_set_sensitive(hbox,TRUE);
//mr     }
//corr
     if(*stato == 2)
        obj_hide(item);
     else 
     {
        obj_show(item);
        obj_set_sensitive(item, (*stato == 1));
        if (*stato == 1) 
        {
            GtkWidget *hbox = get_widget(tb, "hbox");
            gtk_widget_set_sensitive(hbox, TRUE);
        } 
     }
}

extern "C" void setcolor_asrgb_(int *r, int *g, int *b)
{
     CurrentColor.red   = (int)((double)(*r) * 65535. / 255.); 
     CurrentColor.green = (int)((double)(*g) * 65535. / 255.); 
     CurrentColor.blue  = (int)((double)(*b) * 65535. / 255.); 
     CurrentColor.pixel = 0;
//#ifdef USE_CMAP
//     gdk_colormap_alloc_color (cmap, &CurrentColor, TRUE, FALSE);
//#endif
}

char *filtraperc(const gchar *msg)
{
    std::string str = msg;

    std::string::size_type pos = str.find_first_of('%');
    while (pos != std::string::npos)
    {
          str.insert(pos+1, "%");
          pos = str.find_first_of('%',pos+2);
    }
      return DuplicaStringa(str.c_str());
}

int cMsgWinErr(const char *cmsg, int type, int tempo, int def_answer)
{
   char *messaggio, *msgtot;
   int answer;

   size_t sz = strlen(cmsg) + 1;
   msgtot          = g_new0(char, sz);
   CopiaStringa(msgtot, sz, cmsg);
   sz = strlen(msgtot) + 50;
       
   messaggio = g_new0(char, sz);
   formatta_msg(messaggio, sz, msgtot, MESG_SIZE);
   g_free(msgtot);
   answer = 0;

   if((type < 0)  || !jscreen)
   {
        if(gtk_init_check(NULL, NULL))
        {
           GtkWidget *dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  "%s", messaggio);
           gtk_dialog_run (GTK_DIALOG (dialog));
           gtk_widget_destroy (dialog);
        }
        answer = 1;
   }
   else
   switch(type)
   {
   case SEVERE_ERR_WINDOW:
   case ERR_WINDOW:
        answer = MessageDialog(NULL, tempo, def_answer, finestre[0], GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, filtraperc(messaggio));
        answer = 1;
        break;

   case WARN_WINDOW:
        answer = MessageDialog(NULL, tempo, def_answer, finestre[0], GTK_MESSAGE_WARNING, GTK_BUTTONS_OK, filtraperc(messaggio));
        answer = 1;
        break;

   default:
   case INFO_WINDOW:
        answer = MessageDialog(NULL, tempo, def_answer, finestre[0], GTK_MESSAGE_INFO, GTK_BUTTONS_OK, filtraperc(messaggio));
        answer = 1;
        break;

   case QUEST_WINDOW:
   case QUEST_WINDOW_R:
        answer = MessageDialog(NULL, tempo, def_answer, finestre[0], GTK_MESSAGE_QUESTION, GTK_BUTTONS_OK_CANCEL, filtraperc(messaggio));
        if(answer == GTK_RESPONSE_OK)
           answer = 1;
        else
           answer = 2;
        break;

   case QUEST_WINDOW_YES_NO:
   case QUEST_WINDOW_NO_YES:
        answer = MessageDialog(NULL, tempo, def_answer, finestre[0], GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, filtraperc(messaggio));
        if(answer == GTK_RESPONSE_YES)
           answer = 1;
        else
           answer = 2;
        break;

   }
   g_free(messaggio);
   return answer;
}

extern "C" void msgwinc2_ (char *msg, int *tipo, int *exitC, int *tempo)
{
    int ctempo = *tempo;
    int def_r = *exitC;

    *exitC = cMsgWinErr(msg, *tipo, ctempo, def_r);
}

extern "C" int findprog_(char *nome, char result[])
{
using namespace main_app;
    char *path = g_strdup(Application::GetProgName());
    char *abs = g_build_filename(path, nome, NULL);
    if(g_file_test(abs, G_FILE_TEST_EXISTS))
    {
       memcpy(result, path, strlen(path)+1);
       return 1;
    }
    g_free(path);
    path = g_find_program_in_path(nome);
    if(path != NULL)
    {
       memcpy(result, path, strlen(path)+1);
       g_free (path);
       return 1;
    }
    return 0;
}

extern "C" void leggiconfig_();
extern "C" int preliminari_ (int *num, char *arg1)
{
using namespace main_app;
    int argc = *num;
    char **argv = g_new0(char *, 1);
    argv[0] = g_strdup(arg1);

    args->argc = 1;
    CopiaStringa(args->arg[0], MaxLenFilename, argv[0]);
    gtk_init_check(&argc, &argv);
    ScriviStringa(prog_dir, MaxLenFilename, "%s", get_prog_dir(args->arg[0]));
    Application::SetProgName(prog_dir);

#ifdef _WIN32
      char *tmp = g_path_get_dirname(prog_dir);
      char *babel_dir = g_build_filename(tmp, "share", "openbabel", NULL);
      g_free(tmp);
      std::string env_str("BABEL_DATADIR=");
      env_str.append(babel_dir);
      _putenv(env_str.c_str());
#endif

    init_some_val();
    leggiconfig_();
    gchar *pixmapdir = g_strdup_printf("%s%cpixmaps", files_dir, DIR_SEPAR);
    add_pixmap_directory (pixmapdir);
    GtkIconTheme *icon_theme = gtk_icon_theme_get_default ();
    gtk_icon_theme_append_search_path (icon_theme, pixmapdir);
    return 0;
}


