#if 0
      module fourier_mod

      contains

      subroutine MakeMap(khl,fop,iphi2,wtt,numbMax,jpatt,x,ee,eep)
*  jpatt = 0   -> Fourier
*  jpatt = 1   -> Patterson
*  X(nx,ny,nz)
      USE ParametriMappa
      USE General
      USE Symmetry
      USE Phasemodule, only:nex
      implicit none
      integer, dimension(3,nrefl), intent(in) :: khl
      real, dimension(nrefl), intent(in)      :: fop,wtt
      integer, dimension(nrefl), intent(in)   :: iphi2
      integer, intent(in)                     :: jpatt
      integer, intent(in)                     :: numbMax
      real, dimension(:), intent(out), optional :: ee,eep
      real x(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      complex fh,fm,phasec
      integer lmod
      external lmod
      integer :: i,j,l,jn
      integer :: ih,ik,il
      integer :: nu, nv, nww
!corr      real :: ee,eep
      real, dimension(numbMax) :: e,ep
      integer, dimension(3) :: i1,i2,i3
      real :: f000, fourcoef, phase
c
      nu=np(1)
      nv=np(2)
      nww=np(3)
      f000 = 0.0

!corr      do 10 ih = 0, nu-1
!corr      do 10 ik = 0, nv-1
!corr      do 10 il = 0, nww-1
!corr        x(ih,ik,il) = 0.0
!corr  10  continue
      x(:,:,:) = 0.0
c
      if (jpatt == 0) then
          do i=1,numbMax
             fourcoef = fop(i)*wtt(i)
             phase=dtor*iphi2(i)
             ep(i)=fourcoef*sin(phase)
             e(i)=fourcoef*cos(phase)
          enddo
      else
          do i=1,numbMax
             ep(i)=0.0
             e(i) = fop(i)*wtt(i)
          enddo
      endif
!corr  100 continue
***   write(lo,*)' MakeMap: Number of reflection used',irefactiv,
***  *' su ',numbMax
c
c     generate one complete hemisphere of reflexions
c
      nex = 0
      do jn=1,numbMax
         i1(1) = khl(1,jn)
         i1(2) = khl(2,jn)
         i1(3) = khl(3,jn)
!corr         eep=ep(jn)
!corr         ee =e (jn)
         fh=cmplx(e(jn),ep(jn))

         do j=1,nsym
            do l=1,3
               i2(l) = khl(1,jn) * kmat(j,1,l) + khl(2,jn) * kmat(j,2,l)
     *         + khl(3,jn) * kmat(j,3,l)
            enddo
!test            do 540 i=1,3
!test  540       i2(i)=0
!test            do 560 i=1,3
!test               do 550 k=1,2
!test                  m=iabs(ismat(k,i,j))
!test                  if(m.ne.0) i2(m)=i2(m)+i1(i)*isign(1,ismat(k,i,j))
!test  550          continue
!test  560       continue

!corr            b1=1.0
!corr            js=1

*---- Javier ----*
!corr            fh=cmplx(ee,eep)
!!!!test
            phase =-twopi * (khl(1,jn) * tmat(j,1) +
     *       khl(2,jn) * tmat(j,2) + khl(3,jn) * tmat(j,3))
            fm = fh * phasec(phase)
!!!!test
!test            fm=fh*phasec(-twopi*(i1(1)*tsmat(1,j) +
!test     +                          i1(2)*tsmat(2,j) +
!test     +                          i1(3)*tsmat(3,j)) )

            if (i2(3) >= 0) then
                ih=  lmod(i2(1),nu)
                ik=  lmod(i2(2),nv)
                il=2*lmod(i2(3),nww)
                x(ih,ik,il)  =real(fm)
                x(ih,ik,il+1)= aimag(fm)
            endif

            if (-i2(3) >= 0) then
                ih=  lmod(-i2(1),nu)
                ik=  lmod(-i2(2),nv)
                il=2*lmod(-i2(3),nww)
                x(ih,ik,il)  =real(fm)
                x(ih,ik,il+1)= -aimag(fm)
            endif
         enddo
      enddo
!
      x(0,0,0)=f000
      call fft3hr(x,nu,nv,nww)
!
      if (present(ee)) then
          ee(:numbmax) = e(:)
          eep(:numbmax) = ep(:)
      endif
!
      end subroutine makemap

      end module fourier_mod
c-----------------------------------------------------------------------
      subroutine MakeMap_old(khl,fop,iphi2,wtt,numbMax,jpatt,x,e,ep)
      USE ParametriMappa
      USE General
      USE Symmetry
*
*  jpatt = 0   -> Fourier
*  jpatt = 1   -> Patterson
*  X(nx,ny,nz)
c
      dimension i1(3),i2(3),i3(3),kind(24),tab(15)
      dimension khl(3,nrefl),fop(nrefl),iphi2(nrefl),wtt(nrefl)
      dimension e(nrefl),ep(nrefl)
      common/invfou_sir/ ifmapt,f000,scale1,v_p,pv_p,nnobs,isirf
     +               ,Renve,stepE
      common /const/ nex,numset,npic,jall,nset,iset(20)
      common/conue/shi(4),ishi,shi1(4)
      common/dada/ncol,ndim1,ndim2,jmemo
c

      real x(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      complex fh,fm,phasec
      integer lmod
      external lmod
c
*     write(6,*) ' NumbMax in Makemap',numbMax
*     call CheckNumber(wtt,numbMax)
      nu=np(1)
      nv=np(2)
      nww=np(3)
      f000 = 0.0

      do 10 ih = 0, nu-1
      do 10 ik = 0, nv-1
      do 10 il = 0, nww-1
        x(ih,ik,il) = 0.0
  10  continue
c
      irefactiv=0
      do 100 i=1,numbMax
         ii=i
!!!
!        wtt(i) = 1.0
!!!
         fourcoef = fop(i)*wtt(i)
         if (fourcoef.gt.0.001) irefactiv=irefactiv+1
         phase=dtor*float(iphi2(i))
	 if (jpatt.gt.0) phase=0.0
         ep(i)=fourcoef*sin(phase)
         e(i)=fourcoef*cos(phase)
  100 continue
***   write(lo,*)' MakeMap: Number of reflection used',irefactiv,
***  *' su ',numbMax
c
c     generate one complete hemisphere of reflexions
c

      do 150 i=1,15
         tab(i)=sin(float(30*i)*dtor)
  150 continue

      nex = 0
      do 800 jn=1,numbMax
         i1(1) = khl(1,jn)
         i1(2) = khl(2,jn)
         i1(3) = khl(3,jn)
         eep=ep(jn)
         ee =e (jn)

         do 700 j=1,nsym
!old            do 540 i=1,3
!old  540       i2(i)=0
!old            do 560 i=1,3
!old               do 550 k=1,2
!old                  m=iabs(ismat(k,i,j))
!old                  if(m.ne.0) i2(m)=i2(m)+i1(i)*isign(1,ismat(k,i,j))
!old  550          continue
!old  560       continue
            i2(:) = matmul(i1,kmat(j,:,:))

            b1=1.0
            js=1

*---- Javier ----*
            fh=cmplx(ee,eep)
            fm=fh*phasec(-twopi*(i1(1)*tsmat(1,j) +
     +                          i1(2)*tsmat(2,j) +
     +                          i1(3)*tsmat(3,j)) )

        if (i2(3).ge.0) then
         ih=  lmod(i2(1),nu)
         ik=  lmod(i2(2),nv)
         il=2*lmod(i2(3),nww)
         x(ih,ik,il)  =real(fm)
         x(ih,ik,il+1)= aimag(fm)
        endif

*****   if (-i2(3).gt.0) then
        if (-i2(3).ge.0) then
         ih=  lmod(-i2(1),nu)
         ik=  lmod(-i2(2),nv)
         il=2*lmod(-i2(3),nww)
         x(ih,ik,il)  =real(fm)
         x(ih,ik,il+1)= -aimag(fm)
        endif

*---- Javier ----*

  700    continue
  800 continue
      x(0,0,0)=f000
      call fft3hr(x,nu,nv,nww)

      return
      end
#endif
c-----------------------------------------------------------------------
      subroutine InvMap(x,khl,mkang,iphi,fcv,numbMax,ier)
      USE ParametriMappa
      USE General
      USE PhaseModule
      real x(*)
      common /densog_sir/ den_p,n_p,perc,denmin,denmax
      common /CicliInv/ nit,nDelta,iDelta,numtot,mtotn,
     *                  mtot1,mtot2,mtot3,mtot4
c
      dimension khl(3,nrefl),mkang(nrefl),iphi(nrefl),fcv(nrefl)
c
***   a1=cos(cell(4)*pi/180.0)
***   a2=cos(cell(5)*pi/180.0)
***   a3=cos(cell(6)*pi/180.0)
***   arg=1.0-a1*a1
***  1       -a2*a2
***  2       -a3*a3
***  3       +a1*a2*a3*2.0
***   volume=cell(1)*cell(2)*cell(3)*sqrt(arg)
!!!!!!!!!!!!!!!!!!!!!!!!!!
! molecole con meno di 10 atomi
!     if (nit.le.2) perc = 0.15 
!     if (nit.gt.2.and.nit.le.4) perc = 0.075 
!     if (nit.gt.4.and.nit.le.6) perc = 0.025 
! molecole leggere con meno di 10 atomi
!
! molecole leggere con piu  di 10 atomi
!     if (nit.le.3) perc = 0.05 
!     if (nit.gt.3) perc = 0.025
!!!!!!!!!!!!!!!!!!!!!!!!!!
!
      perc = 0.025
c
!     if (sogmap.lt.0.0) then
!         if(iterok.eq.1) perc = 0.022
!         if(iterok.eq.2) perc = 0.025
!
!         if(iterok.eq.1) perc = 0.025
!         if(iterok.eq.2) perc = 0.035  !fournew01.f
!       else
!NEW
!         if(iterok.eq.1) perc = sogmap
!         if(iterok.eq.2) perc = sogmap + 0.01
!NEW
!     endif
      if (sogmap.gt.1.e-8) then
          perc = sogmap
      endif
c
*     write(6,*) ' ITEROK & PERC nella INVMAP',iterok,perc
      npts=np(1)*np(2)*np(3)
      npts1=npts*perc
      call denhist_sir(x,npts1)
      sogrho=0.0
      jflag=1
      call invfft_sir(khl,mkang,jflag,sogrho,iphi,fcv,numbMax,x,ier)
      return
      end
*-----------------------------------------------------*
c     subroutine invfft_sir(x,khl,mkang,jflag,sogrho1,iphi,
c    *                      fcv,numbMax,ier)
      subroutine invfft_sir(khl,mkang,jflag,sogrho1,iphi,
     *                      fcv,numbMax,x,ier)
      USE ParametriMappa
      USE General
      common /densog_sir/ den_p,n_p,perc,denmin,denmax
      common /appo/iVolta,pmax,nninv1,nninv2,kverbo,NumSteps,numsetmax
     *            ,numset0,imodmap
      common/estmap/avden,stden,dum(102)
      common /CicliInv/ nit,nDelta,iDelta,numtot,mtotn,
     *                  mtot1,mtot2,mtot3,mtot4
      dimension iphi(nrefl),fcv(nrefl),khl(3,nrefl),mkang(nrefl)
      real x(*)


*---- jflag=0 Non modifica la densita'  ----*
*---- jflag=1 Modifica la densita': troncare a " den_p "  ----*
*---- jflag=2 Modifica la densita': troncare la parte negativa--*


      if (sogrho1.gt.0.0) then
          sog=avden+sogrho1*stden
      else
          sog=0.0
      endif
      npunti=np(1)*np(2)*np(3)

      n_p=0
      n_s=0
      npu1=0
      call changemap (x,sog,jflag,npu1)
      If (nit.eq.nDelta) then                 !pgMAD110908
          write(lo,*)
          write(lo,*)'  ***************************************'
          write(lo,*)'  *          Inverse FFT Routine        *'
          write(lo,*)'  ***************************************'
      endif
      percT=float(n_p)/(float(npunti))
      perc=percT
      if (perc.gt.1.0) perc=1.0
      If (nit.eq.nDelta) then                  !pgMAD110908
*         write(lo,1000)nit,den_p/volume,n_p,percT*100.0,
*    +        '   Cut-off points .................... ',i8,/)
          write(lo,1000)nit,den_p/volume,percT*100.0
      endif
 1000 format(/,'   Number of performed cycles ........ ',i8,/,
     +        '   Minimum Density level ............. ',f8.3,/,
     +        '   Percentage of map points .......... ',f8.1)
*    +        '   Grid point .gt. Level ............. ',i8,2x,
*    +                                        1x,f6.1,'%',/,
*    +        '   Percentage of points .gt. Level.... ',f8.2,'%',/,
*    +        '   Cut-off density ................... ',f8.3,/,
*    +        '   Cut-off points .................... ',i8,/)


*     if (kverbo.eq.1) then
*         write(lo,1001) percT*100.0
*     endif
*1001 format('   Inverse FFT Routine  ',f6.1,'%')
      call newinv(khl,mkang,iphi,fcv,numbMax,np(1),np(2),np(3),x)
      return

      end
*------------------------------------------------------------------*
      subroutine changemap (x,sog,jflag,npu1)
      USE ParametriMappa
      USE General
      common /densog_sir/ den_p,n_p,perc,denmin,denmax
      real x(1:np(1),1:np(2),1:np(3))

      SOGmin=0.32*volume
      SOGmax=2.0*volume
      nx=np(1)
      ny=np(2)
      nz=np(3)
      n_p=0
      n_s=0

      do 150 i=1,nx
         do 100 j=1,ny
            do 50 k=1,nz
               xx=x(i,j,k)
               if (sog.gt.0.0.and.x(i,j,k).gt.sog) then
                    x(i,j,k)=sog
                    npu1=npu1+1
               endif

               if (jflag.eq.1) then
                  if (xx.lt.den_p.or.xx.le.0.0) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                  endif
               elseif (jflag.eq.2) then
                  if ( xx.le.0.0 ) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                  endif
*----------------
               else
                  n_p=n_p+1
               endif
  50        continue
 100     continue
 150  continue

      return
      end

c------------------------------------------------------------------
      subroutine denhist_sir(x,npts)
      USE ParametriMappa
c
c---- del common/histograms/ probably non servono tutti i campi contenuti
c
      USE General
      common /densog_sir/ den_p,n_p,perc,denmin,denmax
      common/estmap/avden,stden,dumm(102)
      common/histocommo/ vresl(50),vrmin(50),vrmax(50),vrave(50),
     +                   vrstd(50),hdata(200,50),nresl,nhist,
     +                   range(501),hisp(501),dip(501),nrange,
     +                   range1(501),hisp1(501),dip1(501)
      real hispP(501)
      real x(1:np(1),1:np(2),1:np(3))

c     call scrper(' Density Histogram ',0,0)


      nx=np(1)
      ny=np(2)
      nz=np(3)
      npunti=nx*ny*nz

      denmin=1.0e25
      denmax=-1.0e25
      call maxmin(nx,ny,nz,denmin,denmax,avden,stden,x)

      nrange=500
      rang=(denmax - denmin)/nrange
      do 10 i=1,nrange+1
         hispP(i)=0.0
         hisp(i)=0.0
         hisp1(i)=0.0
         range(i)=denmin + rang*(i-1)
 10   continue
      nrange=nrange+1

      do 150 ky=1,ny
         do 100 kz=1,nz
           do 50 kx=1,nx
               xx=x(kx,ky,kz)
               n=int((xx-denmin)/rang) + 1
               if (n.gt.nrange) n=nrange
               if (n.le.1) n=1
               hispP(n)=hispP(n)+1.0
               hisp(n)=hisp(n)+1.0

 50         continue
 100     continue

 150  continue

C     write(lo,*)
C     write(lo,*)'  ***************************************'
C     write(lo,*)'  *           HISTOGRAM MAP             *'
C     write(lo,*)'  ***************************************'
C     write(lo,*)
C     write(lo,*) '    Range      Points(Protein)  Points(solvent)'
C     nstep=25
C     num=hispP(1)
C     ico=1
C     do 200 i=1,nrange,nstep
C        ic=i
C        if (i.gt.1) then
C          num=0
C          do ii=ico,ic
C             num=num+ hispP(ii)
C          enddo
C        endif
C        write(lo,1000) range(i)/volume,num
C     ico=ic
C200  continue
C1000 format(f10.3,i12,5x,i12)
C     write(lo,*)

      jflag=1
      npts1=npts
      call findsog(den_p,npts1,jflag)

C     write(lo,2000) denmax/volume,denmin/volume,avden/volume,
C    +             stden/volume,den_p/volume
C2000 format('   Maximum density ............ ',f8.3,/,
C    +       '   Minimum density ............ ',f8.3,/,
C    +       '   Average density ............ ',f8.3,/,
C    +       '   Standar deviation .......... ',f8.3,/,
C    +       '   Level protein ...... ........',f8.3,/)

      return
      end

*----------------------------------------------*
      subroutine findsog(sogden,npts,jflag)
      USE General
      common /densog_sir/ den_p,n_p,perc,denmin,denmax
      common/histocommo/ vresl(50),vrmin(50),vrmax(50),vrave(50),
     +                   vrstd(50),hdata(200,50),nresl,nhist,
     +                   range(501),hisp(501),dip(501),nrange,
     +                   range1(501),hisp1(501),dip1(501)

      rang=(denmax - denmin)/nrange
      if (jflag.gt.0) then
         ires=0
         do 10 i=nrange+1,2,-1
            if (jflag.eq.1) ires=ires+hisp(i-1)
            if (jflag.eq.2) ires=ires+hisp1(i-1)
            if (ires.ge.npts) then
               sogden=denmin + (rang*(i-2) + rang/2)
               goto 20
            endif
 10      continue
 20      continue
c---------------
      else
         ires=0
         res=0.0
         do 30 i=nrange+1,2,-1
            res=range(i-1)
            if (jflag.eq.-1) ires=ires + hisp(i-1)
            if (jflag.eq.-2) ires=ires + hisp1(i-1)
            if (res.le.sogden) then
               npts=ires
               goto 40
            endif
 30      continue
 40      continue
      endif
      return
      end

*----------------------------------------------------------------------------*
      subroutine maxmin(nx,ny,nz,denmin,denmax,avden,stden,x)
      USE General
      real x(1:nx,1:ny,1:nz)

      do 30 ix = 1, nx
       do 20 iy = 1, ny
        do 10 iz = 1, nz
	   xx=x(ix,iy,iz)
           denmax=amax1(denmax,xx)
           denmin=amin1(denmin,xx)
           avden=avden + xx
           stden=stden + xx * xx
 10     continue
 20    continue
 30   continue

      avden=avden/float(nx*ny*nz)
      stden=stden/float(nx*ny*nz) - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine CheckNumber(wtt,numbMax)
      USE General
      dimension wtt(nrefl)
c
      numbM = numbMax
      j = numbM
      iflag = 0
      do while (iflag.eq.0.and.j.gt.0)
         if (wtt(j).gt.0.0001) then
             iflag = 1
             numbMax = j
         endif
         j = j - 1
      enddo
*     write(6,*) 'NUMERI in CheckNumber', numbM,numbMax
      return
      end
c-----------------------------------------------------------------------
      subroutine fft3hr(x,nx,ny,nz)

      real x(0:*)
      integer d(5),nx,ny,nz

      nxy=nx*ny
      nxyz=nxy*nz

      d(1)=nxyz
      d(2)=1
      d(3)=2*nxy
      d(4)=nxy
      d(5)=nx
      call cmplft(x(0),x(nxy),nx,d)

      d(1)=nxyz
      d(2)=nx
      d(3)=2*nxy
      d(4)=nx
      d(5)=1
      call cmplft(x(0),x(nxy),ny,d)

      d(1)=nxyz
      d(2)=2*nxy
      d(3)=nxyz
      d(4)=nxy
      d(5)=1
      call hermft(x(0),x(nxy),nz/2,d)

      return
      end
*----------------------------------------------------------*

      subroutine fft3rh(x,nu,nv,nww)

c 3-d Real to Hermitian FFT
c In:  real    x(u,v,w)
c Out: complex x(h,k,l)  (l=0...nl/2)
c    (complex elements are in odd l planes)
c x MUST BE LARGE ENOUGH TO HOLD ((w+2)*u*v) ELEMENTS
      integer nu,nv,nww,nuv,nuvw
      real x(0:*)
      integer d(5)
c
      nuv=nu*nv
      nuvw=nuv*nww
c Real transform l to w
c *** NOTE THAT THE w=nww/2 ELEMENTS ARE LOST ***
      d(1)=nuvw
      d(2)=2*nuv
      d(3)=nuvw
      d(4)=nuv
      d(5)=1
      call realft_sir(x(0),x(nuv),nww/2,d)
c Transform k to v
      d(1)=nuvw
      d(2)=nu
      d(3)=2*nuv
      d(4)=nu
      d(5)=1
      call cmplft(x(0),x(nuv),nv,d)
c Transform h to u
      d(1)=nuvw
      d(2)=1
      d(3)=2*nuv
      d(4)=nuv
      d(5)=nu
      call cmplft(x(0),x(nuv),nu,d)
      return
c
      end
*----------------------------------------------------------*
c
*---------------------------------------------------*
*----      NEW INVERSION FFT IN MEMORY          ----*
*---------------------------------------------------*
*---------------------------------------------------*
      subroutine newinv(khl,mkang,iphi2,fop2,numbMax,nu,nv,nww,x)
      USE General
      USE Symmetry
c
      common /newPatt/ ifPiero
      integer i1(3),i2(3),lmod
      dimension iphi2(nrefl),fop2(nrefl),khl(3,nrefl),
     *          mkang(nrefl)
!!!!!      real x(0:nu-1,0:nv-1,0:nww-1)
      real x(0:nu-1,0:nv-1,0:nww+1)
      real phaseof
      complex sf,phasec
      logical hemi

      external hemi,lmod,phasec,phaseof
c

*---- Scale ----*
      scfft=1.0/real(nu*nv*nww)
      scfft1=1.0/real(nu*nv*nww*nsym)

*---- Perform real hermitian FFT ----*
      call fft3rh(x,nu,nv,nww)

*---- Fill the reflection list ----*
      do 200 i=1,numbMax
         jjn=i
         i1(1) = khl(1,jjn)
         i1(2) = khl(2,jjn)
         i1(3) = khl(3,jjn)

*---- Average over symmetry equivalents for this reflection ----*
         sf=cmplx(0.0,0.0)
         do 100 j=1,nsym
!corr             do 10 k=1,3
!corr                i2(k)=0
!corr 10          continue
!corr             do 30 ii=1,3
!corr                do 20 k=1,2
!corr                   m=iabs(ismat(k,ii,j))
!corr                   if(m.ne.0) i2(m)=i2(m)+i1(ii)*isign(1,ismat(k,ii,j))
!corr 20             continue
!corr 30          continue
            i2(:) = matmul(i1,kmat(j,:,:))
            phim=twopi*(i1(1)*tsmat(1,j)
     *                 +i1(2)*tsmat(2,j)
     *                 +i1(3)*tsmat(3,j))
            if (hemi(i2(1),i2(2),i2(3))) then
               iu=lmod(i2(1),nu)
               iv=lmod(i2(2),nv)
               iw=2*lmod(i2(3),nww)
               sf=sf+cmplx(x(iu,iv,iw),-x(iu,iv,iw+1))*phasec(phim)
            else
               iu=lmod(-i2(1),nu)
               iv=lmod(-i2(2),nv)
               iw=2*lmod(-i2(3),nww)
               sf=sf+cmplx(x(iu,iv,iw),x(iu,iv,iw+1))*phasec(phim)
            endif
100      continue
         sf=sf*scfft1
         fop2(i)=abs(sf)   ! F.d.S calc.
         faze=phaseof(sf)*rtod
         if (mkang(i).ne.1) then
             faze1= favi(mkang(i),faze)
             faze=faze1
         endif
         faze=mod(faze+3600.,360.)
         iphi2(i)=faze   ! la fase calc.
200   continue

      return
      end
*----------------------------------------------------------*
* ====================== fftlib ========================================
C
      SUBROUTINE CMPLFT(X,Y,N,D)
C     ===============================
C
C
C     Complex finite discrete fourier transform
C     transforms one dimension of multi-dimensional data
C     modified by L. F. TEN EYCK from a one-dimensional version written
C     by G. T. SANDE, 1969.
C
C     This program calculates the transform
C               (X(T) + I*Y(T))*(COS(2*PI*T/N) - I*SIN(2*PI*T/N))
C
C     INDEXING -- the arrangement of the multi-dimensional data is
C     specified by the integer array D, the values of which are used as
C     control parameters in do loops.  when it is desired to cover all
C     elements of the data for which the subscript being transformed has
C     the value I0, the following is used.
C
C               I1 = (I0 - 1)*D(2) + 1
C               DO 100 I2 = I1, D(1), D(3)
C               I3 = I2 + D(4) - 1
C               DO 100 I = I2, I3, D(5)
C                  .
C                  .
C           100 CONTINUE
C
C     with this indexing it is possible to use a number of arrangements
C     of the data, including normal fortran complex numbers (d(5) = 2)
C     or separate storage of real and imaginary parts.
C
C
C---- PMAX is the largest prime factor that will be tolerated by this
C     program.
C
C---- TWOGRP is the largest power of two that is treated as a special
C     case.
C
C     .. Scalar Arguments ..
      INTEGER           N
C     ..
C     .. Array Arguments ..
      REAL              X(*),Y(*)
      INTEGER           D(5)
C     ..
C     .. Local Scalars ..
      INTEGER           PMAX,PSYM,TWOGRP
      LOGICAL           ERROR
C     ..
C     .. Local Arrays ..
      INTEGER           FACTOR(15),SYM(15),UNSYM(15)
C     ..
C     .. External Subroutines ..
      EXTERNAL          DIPRP,MDFTKD,SRFP
C     ..
      PMAX = 19
      TWOGRP = 8
C
      IF (N.GT.1) THEN
          CALL SRFP(N,PMAX,TWOGRP,FACTOR,SYM,PSYM,UNSYM,ERROR)
          IF (ERROR) THEN
C
              WRITE (6,FMT=9000) N
c             call ccperr(1,' stop in fftlib.for 1000')
          ELSE
C
              CALL MDFTKD(N,FACTOR,D,X,Y)
              CALL DIPRP(N,SYM,PSYM,UNSYM,D,X,Y)
          END IF
      END IF
C
C---- Format statements
C
 9000 FORMAT ('0INVALID NUMBER OF POINTS FOR CMPL FT.  N =',I10,//)
      END
C
C
      SUBROUTINE SRFP(PTS,PMAX,TWOGRP,FACTOR,SYM,PSYM,UNSYM,ERROR)
C     ==================================================================
C
C
C---- Symmetrized reordering factoring programme
C
C
C     .. Scalar Arguments ..
      INTEGER         PMAX,PSYM,PTS,TWOGRP
      LOGICAL         ERROR
C     ..
C     .. Array Arguments ..
      INTEGER         FACTOR(10),SYM(10),UNSYM(10)
C     ..
C     .. Local Scalars ..
      INTEGER         F,J,JJ,N,NEST,P,PTWO,Q,R
C     ..
C     .. Local Arrays ..
      INTEGER         PP(14),QQ(7)
C     ..
      NEST = 14
C
      N = PTS
      PSYM = 1
      F = 2
      P = 0
      Q = 0
   10 CONTINUE
      IF (N.LE.1) THEN
          GO TO 60
      ELSE
          DO 20 J = F,PMAX
              IF (N.EQ. (N/J)*J) GO TO 30
   20         CONTINUE
          GO TO 40
   30     IF (2*P+Q.GE.NEST) THEN
              GO TO 50
          ELSE
              F = J
              N = N/F
              IF (N.EQ. (N/F)*F) THEN
                  N = N/F
                  P = P + 1
                  PP(P) = F
                  PSYM = PSYM*F
              ELSE
                  Q = Q + 1
                  QQ(Q) = F
              END IF
              GO TO 10
          END IF
      END IF
C
   40 CONTINUE
      WRITE (6,FMT=9000) PMAX,PTS
      ERROR = .TRUE.
      GO TO 100
C
   50 CONTINUE
      WRITE (6,FMT=9010) NEST,PTS
      ERROR = .TRUE.
      GO TO 100
C
   60 CONTINUE
      R = 1
      IF (Q.EQ.0) R = 0
      IF (P.GE.1) THEN
          DO 70 J = 1,P
              JJ = P + 1 - J
              SYM(J) = PP(JJ)
              FACTOR(J) = PP(JJ)
              JJ = P + Q + J
              FACTOR(JJ) = PP(J)
              JJ = P + R + J
              SYM(JJ) = PP(J)
   70         CONTINUE
      END IF
      IF (Q.GE.1) THEN
          DO 80 J = 1,Q
              JJ = P + J
              UNSYM(J) = QQ(J)
              FACTOR(JJ) = QQ(J)
   80         CONTINUE
          SYM(P+1) = PTS/PSYM**2
      END IF
      JJ = 2*P + Q
      FACTOR(JJ+1) = 0
      PTWO = 1
      J = 0
   90 CONTINUE
      J = J + 1
      IF (FACTOR(J).NE.0) THEN
          IF (FACTOR(J).EQ.2) THEN
              PTWO = PTWO*2
              FACTOR(J) = 1
              IF (PTWO.LT.TWOGRP) THEN
                  IF (FACTOR(J+1).EQ.2) GO TO 90
              END IF
              FACTOR(J) = PTWO
              PTWO = 1
          END IF
          GO TO 90
      END IF
      IF (P.EQ.0) R = 0
      JJ = 2*P + R
      SYM(JJ+1) = 0
      IF (Q.LE.1) Q = 0
      UNSYM(Q+1) = 0
      ERROR = .FALSE.
C
  100 CONTINUE
C
C---- Format statements
C
 9000 FORMAT ('0LARGEST FACTOR EXCEEDS ',I3,'.  N = ',I6,'.')
 9010 FORMAT ('0FACTOR COUNT EXCEEDS ',I3,'.  N = ',I6,'.')
      END
C
C
      SUBROUTINE MDFTKD(N,FACTOR,DIM,X,Y)
C     ==========================================
C
C
C---- Multi-dimensional complex fourier transform kernel driver
C
C
C     .. Scalar Arguments ..
      INTEGER           N
C     ..
C     .. Array Arguments ..
      REAL              X(*),Y(*)
      INTEGER           DIM(5),FACTOR(10)
C     ..
C     .. Local Scalars ..
      INTEGER           F,M,P,R,S
C     ..
C     .. External Subroutines ..
      EXTERNAL          R2CFTK,R3CFTK,R4CFTK,R5CFTK,R8CFTK,RPCFTK
C     ..

      S = DIM(2)
      F = 0
      M = N
   10 CONTINUE
      F = F + 1
      P = FACTOR(F)
      IF (P.EQ.0) THEN
          RETURN
      ELSE
          M = M/P
          R = M*S
          IF (P.LE.8) THEN
              GO TO (10,20,30,40,50,80,70,60) P
              GO TO 80
C
   20         CONTINUE
              CALL R2CFTK(N,M,X(1),Y(1),X(R+1),Y(R+1),DIM)
              GO TO 10
C
   30         CONTINUE
              CALL R3CFTK(N,M,X(1),Y(1),X(R+1),Y(R+1),X(2*R+1),Y(2*R+1),
     +                    DIM)
              GO TO 10
C
   40         CONTINUE
              CALL R4CFTK(N,M,X(1),Y(1),X(R+1),Y(R+1),X(2*R+1),Y(2*R+1),
     +                    X(3*R+1),Y(3*R+1),DIM)
              GO TO 10
C
   50         CONTINUE
              CALL R5CFTK(N,M,X(1),Y(1),X(R+1),Y(R+1),X(2*R+1),Y(2*R+1),
     +                    X(3*R+1),Y(3*R+1),X(4*R+1),Y(4*R+1),DIM)
              GO TO 10
C
   60         CONTINUE
              CALL R8CFTK(N,M,X(1),Y(1),X(R+1),Y(R+1),X(2*R+1),Y(2*R+1),
     +                    X(3*R+1),Y(3*R+1),X(4*R+1),Y(4*R+1),X(5*R+1),
     +                    Y(5*R+1),X(6*R+1),Y(6*R+1),X(7*R+1),Y(7*R+1),
     +                    DIM)
              GO TO 10
          END IF
C
   70     CONTINUE
          CALL RPCFTK(N,M,P,R,X,Y,DIM)
          GO TO 10
      END IF
C
   80 CONTINUE
      WRITE (6,FMT=9000)
C
C---- Format statements
C
 9000 FORMAT ('0TRANSFER ERROR DETECTED IN MDFTKD',//)
      END
C
C
      SUBROUTINE R2CFTK(N,M,X0,Y0,X1,Y1,DIM)
C     ==============================================
C
C
C---- Radix 2 multi-dimensional complex fourier transform kernel
C
C     .. Scalar Arguments ..
      INTEGER           M,N
C     ..
C     .. Array Arguments ..
c     REAL              X0(10),X1(10),Y0(10),Y1(10)
      REAL              X0(*),X1(*),Y0(*),Y1(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              ANGLE,C,FJM1,FM2,IS,IU,RS,RU,S,TWOPI
      INTEGER           J,K,K0,K1,K2,KK,L,L1,M2,MM2,MOVER2,NS,NT,SEP,
     +                  SIZE
      LOGICAL           FOLD,ZERO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
C     .. Data statements ..
      DATA              TWOPI/6.283185/
C     ..
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M2 = M*2
      FM2 = REAL(M2)
      MOVER2 = M/2 + 1
      MM2 = SEP*M2
C
      FJM1 = -1.0
      DO 50 J = 1,MOVER2
          FOLD = J .GT. 1 .AND. 2*J .LT. M + 2
          K0 = (J-1)*SEP + 1
          FJM1 = FJM1 + 1.0
          ANGLE = TWOPI*FJM1/FM2
          ZERO = ANGLE .EQ. 0.0
          IF (.NOT.ZERO) THEN
              C = COS(ANGLE)
              S = SIN(ANGLE)
          END IF
   10     CONTINUE
C
          DO 40 KK = K0,NS,MM2
              DO 30 L = KK,NT,L1
                  K1 = L + SIZE
                  DO 20 K = L,K1,K2
                      RS = X0(K) + X1(K)
                      IS = Y0(K) + Y1(K)
                      RU = X0(K) - X1(K)
                      IU = Y0(K) - Y1(K)
                      X0(K) = RS
                      Y0(K) = IS
                      IF (ZERO) THEN
                          X1(K) = RU
                          Y1(K) = IU
                      ELSE
                          X1(K) = RU*C + IU*S
                          Y1(K) = IU*C - RU*S
                      END IF
   20                 CONTINUE
   30             CONTINUE
   40         CONTINUE
          IF (FOLD) THEN
              FOLD = .FALSE.
              K0 = (M+1-J)*SEP + 1
              C = -C
              GO TO 10
          END IF
   50     CONTINUE
C
      END
C
C
      SUBROUTINE R3CFTK(N,M,X0,Y0,X1,Y1,X2,Y2,DIM)
C     ======================================================
C
C
C---- Radix 3 multi-dimensional complex fourier transform kernel
C
C     .. Scalar Arguments ..
      INTEGER           M,N
C     ..
C     .. Array Arguments ..
c     REAL              X0(10),X1(10),X2(10),Y0(10),Y1(10),Y2(10)
      REAL              X0(*),X1(*),X2(*),Y0(*),Y1(*),Y2(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              A,ANGLE,B,C1,C2,FJM1,FM3,I0,I1,I2,IA,IB,IS,R0,
     +                  R1,R2,RA,RB,RS,S1,S2,T,TWOPI
      INTEGER           J,K,K0,K1,K2,KK,L,L1,M3,MM3,MOVER2,NS,NT,SEP,
     +                  SIZE
      LOGICAL           FOLD,ZERO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
C     .. Data statements ..
      DATA              TWOPI/6.283185/,A/-0.5/,B/0.86602540/
C     ..
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M3 = M*3
      FM3 = REAL(M3)
      MM3 = SEP*M3
      MOVER2 = M/2 + 1
C
      FJM1 = -1.0
      DO 50 J = 1,MOVER2
          FOLD = J .GT. 1 .AND. 2*J .LT. M + 2
          K0 = (J-1)*SEP + 1
          FJM1 = FJM1 + 1.0
          ANGLE = TWOPI*FJM1/FM3
          ZERO = ANGLE .EQ. 0.0
          IF (.NOT.ZERO) THEN
              C1 = COS(ANGLE)
              S1 = SIN(ANGLE)
              C2 = C1*C1 - S1*S1
              S2 = S1*C1 + C1*S1
          END IF
   10     CONTINUE
C
          DO 40 KK = K0,NS,MM3
              DO 30 L = KK,NT,L1
                  K1 = L + SIZE
                  DO 20 K = L,K1,K2
                      R0 = X0(K)
                      I0 = Y0(K)
                      RS = X1(K) + X2(K)
                      IS = Y1(K) + Y2(K)
                      X0(K) = R0 + RS
                      Y0(K) = I0 + IS
                      RA = RS*A + R0
                      IA = IS*A + I0
                      RB = (X1(K)-X2(K))*B
                      IB = (Y1(K)-Y2(K))*B
                      IF (ZERO) THEN
                          X1(K) = RA + IB
                          Y1(K) = IA - RB
                          X2(K) = RA - IB
                          Y2(K) = IA + RB
                      ELSE
                          R1 = RA + IB
                          I1 = IA - RB
                          R2 = RA - IB
                          I2 = IA + RB
                          X1(K) = R1*C1 + I1*S1
                          Y1(K) = I1*C1 - R1*S1
                          X2(K) = R2*C2 + I2*S2
                          Y2(K) = I2*C2 - R2*S2
                      END IF
   20                 CONTINUE
   30             CONTINUE
   40         CONTINUE
          IF (FOLD) THEN
              FOLD = .FALSE.
              K0 = (M+1-J)*SEP + 1
              T = C1*A + S1*B
              S1 = C1*B - S1*A
              C1 = T
              T = C2*A - S2*B
              S2 = -C2*B - S2*A
              C2 = T
              GO TO 10
          END IF
   50     CONTINUE
C
      END
C
C
      SUBROUTINE R4CFTK(N,M,X0,Y0,X1,Y1,X2,Y2,X3,Y3,DIM)
C     ==============================================================
C
C
C---- Radix 4 multi-dimensional complex fourier transform kernel
C
C     .. Scalar Arguments ..
      INTEGER           M,N
C     ..
C     .. Array Arguments ..
c     REAL              X0(10),X1(10),X2(10),X3(10),Y0(10),Y1(10),
c    +                  Y2(10),Y3(10)
      REAL              X0(*),X1(*),X2(*),X3(*),Y0(*),Y1(*),
     +                  Y2(*),Y3(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              ANGLE,C1,C2,C3,FJM1,FM4,I1,I2,I3,IS0,IS1,IU0,
     +                  IU1,R1,R2,R3,RS0,RS1,RU0,RU1,S1,S2,S3,T,TWOPI
      INTEGER           J,K,K0,K1,K2,KK,L,L1,M4,MM4,MOVER2,NS,NT,SEP,
     +                  SIZE
      LOGICAL           FOLD,ZERO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
C     .. Data statements ..
      DATA              TWOPI/6.283185/
C     ..
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M4 = M*4
      FM4 = REAL(M4)
      MM4 = SEP*M4
      MOVER2 = M/2 + 1
C
      FJM1 = -1.0
      DO 50 J = 1,MOVER2
          FOLD = J .GT. 1 .AND. 2*J .LT. M + 2
          K0 = (J-1)*SEP + 1
          FJM1 = FJM1 + 1.0
          ANGLE = TWOPI*FJM1/FM4
          ZERO = ANGLE .EQ. 0.0
          IF (.NOT.ZERO) THEN
              C1 = COS(ANGLE)
              S1 = SIN(ANGLE)
              C2 = C1*C1 - S1*S1
              S2 = S1*C1 + C1*S1
              C3 = C2*C1 - S2*S1
              S3 = S2*C1 + C2*S1
          END IF
   10     CONTINUE
C
          DO 40 KK = K0,NS,MM4
              DO 30 L = KK,NT,L1
                  K1 = L + SIZE
                  DO 20 K = L,K1,K2
                      RS0 = X0(K) + X2(K)
                      IS0 = Y0(K) + Y2(K)
                      RU0 = X0(K) - X2(K)
                      IU0 = Y0(K) - Y2(K)
                      RS1 = X1(K) + X3(K)
                      IS1 = Y1(K) + Y3(K)
                      RU1 = X1(K) - X3(K)
                      IU1 = Y1(K) - Y3(K)
                      X0(K) = RS0 + RS1
                      Y0(K) = IS0 + IS1
                      IF (ZERO) THEN
                          X2(K) = RU0 + IU1
                          Y2(K) = IU0 - RU1
                          X1(K) = RS0 - RS1
                          Y1(K) = IS0 - IS1
                          X3(K) = RU0 - IU1
                          Y3(K) = IU0 + RU1
                      ELSE
                          R1 = RU0 + IU1
                          I1 = IU0 - RU1
                          R2 = RS0 - RS1
                          I2 = IS0 - IS1
                          R3 = RU0 - IU1
                          I3 = IU0 + RU1
                          X2(K) = R1*C1 + I1*S1
                          Y2(K) = I1*C1 - R1*S1
                          X1(K) = R2*C2 + I2*S2
                          Y1(K) = I2*C2 - R2*S2
                          X3(K) = R3*C3 + I3*S3
                          Y3(K) = I3*C3 - R3*S3
                      END IF
   20                 CONTINUE
   30             CONTINUE
   40         CONTINUE
          IF (FOLD) THEN
              FOLD = .FALSE.
              K0 = (M+1-J)*SEP + 1
              T = C1
              C1 = S1
              S1 = T
              C2 = -C2
              T = C3
              C3 = -S3
              S3 = -T
              GO TO 10
          END IF
   50     CONTINUE
C
      END
C
C
      SUBROUTINE R5CFTK(N,M,X0,Y0,X1,Y1,X2,Y2,X3,Y3,X4,Y4,DIM)
C     =================================================================
C
C
C---- Radix 5 multi-dimensional complex fourier transform kernel
C
C     .. Scalar Arguments ..
      INTEGER           M,N
C     ..
C     .. Array Arguments ..
c     REAL              X0(10),X1(10),X2(10),X3(10),X4(10),Y0(10),
c    +                  Y1(10),Y2(10),Y3(10),Y4(10)
      REAL              X0(*),X1(*),X2(*),X3(*),X4(*),Y0(*),
     +                  Y1(*),Y2(*),Y3(*),Y4(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              A1,A2,ANGLE,B1,B2,C1,C2,C3,C4,FJM1,FM5,I0,I1,I2,
     +                  I3,I4,IA1,IA2,IB1,IB2,IS1,IS2,IU1,IU2,R0,R1,R2,
     +                  R3,R4,RA1,RA2,RB1,RB2,RS1,RS2,RU1,RU2,S1,S2,S3,
     +                  S4,T,TWOPI
      INTEGER           J,K,K0,K1,K2,KK,L,L1,M5,MM5,MOVER2,NS,NT,SEP,
     +                  SIZE
      LOGICAL           FOLD,ZERO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
C     .. Data statements ..
      DATA              TWOPI/6.283185/,A1/0.30901699/,B1/0.95105652/,
     +                  A2/-0.80901699/,B2/0.58778525/
C     ..
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M5 = M*5
      FM5 = REAL(M5)
      MM5 = SEP*M5
      MOVER2 = M/2 + 1
C
      FJM1 = -1.0
      DO 50 J = 1,MOVER2
          FOLD = J .GT. 1 .AND. 2*J .LT. M + 2
          K0 = (J-1)*SEP + 1
          FJM1 = FJM1 + 1.0
          ANGLE = TWOPI*FJM1/FM5
          ZERO = ANGLE .EQ. 0.0
          IF (.NOT.ZERO) THEN
              C1 = COS(ANGLE)
              S1 = SIN(ANGLE)
              C2 = C1*C1 - S1*S1
              S2 = S1*C1 + C1*S1
              C3 = C2*C1 - S2*S1
              S3 = S2*C1 + C2*S1
              C4 = C2*C2 - S2*S2
              S4 = S2*C2 + C2*S2
          END IF
   10     CONTINUE
C
          DO 40 KK = K0,NS,MM5
              DO 30 L = KK,NT,L1
                  K1 = L + SIZE
                  DO 20 K = L,K1,K2
                      R0 = X0(K)
                      I0 = Y0(K)
                      RS1 = X1(K) + X4(K)
                      IS1 = Y1(K) + Y4(K)
                      RU1 = X1(K) - X4(K)
                      IU1 = Y1(K) - Y4(K)
                      RS2 = X2(K) + X3(K)
                      IS2 = Y2(K) + Y3(K)
                      RU2 = X2(K) - X3(K)
                      IU2 = Y2(K) - Y3(K)
                      X0(K) = R0 + RS1 + RS2
                      Y0(K) = I0 + IS1 + IS2
                      RA1 = RS1*A1 + R0 + RS2*A2
                      IA1 = IS1*A1 + I0 + IS2*A2
                      RA2 = RS1*A2 + R0 + RS2*A1
                      IA2 = IS1*A2 + I0 + IS2*A1
                      RB1 = RU1*B1 + RU2*B2
                      IB1 = IU1*B1 + IU2*B2
                      RB2 = RU1*B2 - RU2*B1
                      IB2 = IU1*B2 - IU2*B1
                      IF (ZERO) THEN
                          X1(K) = RA1 + IB1
                          Y1(K) = IA1 - RB1
                          X2(K) = RA2 + IB2
                          Y2(K) = IA2 - RB2
                          X3(K) = RA2 - IB2
                          Y3(K) = IA2 + RB2
                          X4(K) = RA1 - IB1
                          Y4(K) = IA1 + RB1
                      ELSE
                          R1 = RA1 + IB1
                          I1 = IA1 - RB1
                          R2 = RA2 + IB2
                          I2 = IA2 - RB2
                          R3 = RA2 - IB2
                          I3 = IA2 + RB2
                          R4 = RA1 - IB1
                          I4 = IA1 + RB1
                          X1(K) = R1*C1 + I1*S1
                          Y1(K) = I1*C1 - R1*S1
                          X2(K) = R2*C2 + I2*S2
                          Y2(K) = I2*C2 - R2*S2
                          X3(K) = R3*C3 + I3*S3
                          Y3(K) = I3*C3 - R3*S3
                          X4(K) = R4*C4 + I4*S4
                          Y4(K) = I4*C4 - R4*S4
                      END IF
   20                 CONTINUE
   30             CONTINUE
   40         CONTINUE
          IF (FOLD) THEN
              FOLD = .FALSE.
              K0 = (M+1-J)*SEP + 1
              T = C1*A1 + S1*B1
              S1 = C1*B1 - S1*A1
              C1 = T
              T = C2*A2 + S2*B2
              S2 = C2*B2 - S2*A2
              C2 = T
              T = C3*A2 - S3*B2
              S3 = -C3*B2 - S3*A2
              C3 = T
              T = C4*A1 - S4*B1
              S4 = -C4*B1 - S4*A1
              C4 = T
              GO TO 10
          END IF
   50     CONTINUE
C
      END
C
C
      SUBROUTINE R8CFTK(N,M,X0,Y0,X1,Y1,X2,Y2,X3,Y3,X4,Y4,X5,Y5,X6,Y6,
     +                  X7,Y7,DIM)
C      ===============================================================
C
C
C---- Radix 8 multi-dimensional complex fourier transform kernel
C
C     .. Scalar Arguments ..
      INTEGER           M,N
C     ..
C     .. Array Arguments ..
c     REAL              X0(10),X1(10),X2(10),X3(10),X4(10),X5(10),
c    +                  X6(10),X7(10),Y0(10),Y1(10),Y2(10),Y3(10),
c    +                  Y4(10),Y5(10),Y6(10),Y7(10)
      REAL              X0(*),X1(*),X2(*),X3(*),X4(*),X5(*),
     +                  X6(*),X7(*),Y0(*),Y1(*),Y2(*),Y3(*),
     +                  Y4(*),Y5(*),Y6(*),Y7(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              ANGLE,C1,C2,C3,C4,C5,C6,C7,E,FJM1,FM8,I1,I2,I3,
     +                  I4,I5,I6,I7,IS0,IS1,IS2,IS3,ISS0,ISS1,ISU0,ISU1,
     +                  IU0,IU1,IU2,IU3,IUS0,IUS1,IUU0,IUU1,R1,R2,R3,R4,
     +                  R5,R6,R7,RS0,RS1,RS2,RS3,RSS0,RSS1,RSU0,RSU1,
     +                  RU0,RU1,RU2,RU3,RUS0,RUS1,RUU0,RUU1,S1,S2,S3,S4,
     +                  S5,S6,S7,T,TWOPI
      INTEGER           J,K,K0,K1,K2,KK,L,L1,M8,MM8,MOVER2,NS,NT,SEP,
     +                  SIZE
      LOGICAL           FOLD,ZERO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
C     .. Data statements ..
      DATA              TWOPI/6.283185/,E/0.70710678/
C     ..
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M8 = M*8
      FM8 = REAL(M8)
      MM8 = SEP*M8
      MOVER2 = M/2 + 1
C
      FJM1 = -1.0
      DO 50 J = 1,MOVER2
          FOLD = J .GT. 1 .AND. 2*J .LT. M + 2
          K0 = (J-1)*SEP + 1
          FJM1 = FJM1 + 1.0
          ANGLE = TWOPI*FJM1/FM8
          ZERO = ANGLE .EQ. 0.0
          IF (.NOT.ZERO) THEN
              C1 = COS(ANGLE)
              S1 = SIN(ANGLE)
              C2 = C1*C1 - S1*S1
              S2 = S1*C1 + C1*S1
              C3 = C2*C1 - S2*S1
              S3 = S2*C1 + C2*S1
              C4 = C2*C2 - S2*S2
              S4 = S2*C2 + C2*S2
              C5 = C4*C1 - S4*S1
              S5 = S4*C1 + C4*S1
              C6 = C4*C2 - S4*S2
              S6 = S4*C2 + C4*S2
              C7 = C4*C3 - S4*S3
              S7 = S4*C3 + C4*S3
          END IF
   10     CONTINUE
C
          DO 40 KK = K0,NS,MM8
              DO 30 L = KK,NT,L1
                  K1 = L + SIZE
                  DO 20 K = L,K1,K2
                      RS0 = X0(K) + X4(K)
                      IS0 = Y0(K) + Y4(K)
                      RU0 = X0(K) - X4(K)
                      IU0 = Y0(K) - Y4(K)
                      RS1 = X1(K) + X5(K)
                      IS1 = Y1(K) + Y5(K)
                      RU1 = X1(K) - X5(K)
                      IU1 = Y1(K) - Y5(K)
                      RS2 = X2(K) + X6(K)
                      IS2 = Y2(K) + Y6(K)
                      RU2 = X2(K) - X6(K)
                      IU2 = Y2(K) - Y6(K)
                      RS3 = X3(K) + X7(K)
                      IS3 = Y3(K) + Y7(K)
                      RU3 = X3(K) - X7(K)
                      IU3 = Y3(K) - Y7(K)
                      RSS0 = RS0 + RS2
                      ISS0 = IS0 + IS2
                      RSU0 = RS0 - RS2
                      ISU0 = IS0 - IS2
                      RSS1 = RS1 + RS3
                      ISS1 = IS1 + IS3
                      RSU1 = RS1 - RS3
                      ISU1 = IS1 - IS3
                      RUS0 = RU0 - IU2
                      IUS0 = IU0 + RU2
                      RUU0 = RU0 + IU2
                      IUU0 = IU0 - RU2
                      RUS1 = RU1 - IU3
                      IUS1 = IU1 + RU3
                      RUU1 = RU1 + IU3
                      IUU1 = IU1 - RU3
                      T = (RUS1+IUS1)*E
                      IUS1 = (IUS1-RUS1)*E
                      RUS1 = T
                      T = (RUU1+IUU1)*E
                      IUU1 = (IUU1-RUU1)*E
                      RUU1 = T
                      X0(K) = RSS0 + RSS1
                      Y0(K) = ISS0 + ISS1
                      IF (ZERO) THEN
                          X4(K) = RUU0 + RUU1
                          Y4(K) = IUU0 + IUU1
                          X2(K) = RSU0 + ISU1
                          Y2(K) = ISU0 - RSU1
                          X6(K) = RUS0 + IUS1
                          Y6(K) = IUS0 - RUS1
                          X1(K) = RSS0 - RSS1
                          Y1(K) = ISS0 - ISS1
                          X5(K) = RUU0 - RUU1
                          Y5(K) = IUU0 - IUU1
                          X3(K) = RSU0 - ISU1
                          Y3(K) = ISU0 + RSU1
                          X7(K) = RUS0 - IUS1
                          Y7(K) = IUS0 + RUS1
                      ELSE
                          R1 = RUU0 + RUU1
                          I1 = IUU0 + IUU1
                          R2 = RSU0 + ISU1
                          I2 = ISU0 - RSU1
                          R3 = RUS0 + IUS1
                          I3 = IUS0 - RUS1
                          R4 = RSS0 - RSS1
                          I4 = ISS0 - ISS1
                          R5 = RUU0 - RUU1
                          I5 = IUU0 - IUU1
                          R6 = RSU0 - ISU1
                          I6 = ISU0 + RSU1
                          R7 = RUS0 - IUS1
                          I7 = IUS0 + RUS1
                          X4(K) = R1*C1 + I1*S1
                          Y4(K) = I1*C1 - R1*S1
                          X2(K) = R2*C2 + I2*S2
                          Y2(K) = I2*C2 - R2*S2
                          X6(K) = R3*C3 + I3*S3
                          Y6(K) = I3*C3 - R3*S3
                          X1(K) = R4*C4 + I4*S4
                          Y1(K) = I4*C4 - R4*S4
                          X5(K) = R5*C5 + I5*S5
                          Y5(K) = I5*C5 - R5*S5
                          X3(K) = R6*C6 + I6*S6
                          Y3(K) = I6*C6 - R6*S6
                          X7(K) = R7*C7 + I7*S7
                          Y7(K) = I7*C7 - R7*S7
                      END IF
   20                 CONTINUE
   30             CONTINUE
   40         CONTINUE
          IF (FOLD) THEN
              FOLD = .FALSE.
              K0 = (M+1-J)*SEP + 1
              T = (C1+S1)*E
              S1 = (C1-S1)*E
              C1 = T
              T = S2
              S2 = C2
              C2 = T
              T = (-C3+S3)*E
              S3 = (C3+S3)*E
              C3 = T
              C4 = -C4
              T = - (C5+S5)*E
              S5 = (-C5+S5)*E
              C5 = T
              T = -S6
              S6 = -C6
              C6 = T
              T = (C7-S7)*E
              S7 = - (C7+S7)*E
              C7 = T
              GO TO 10
          END IF
   50     CONTINUE
C
      END
C
C
C
      SUBROUTINE DIPRP(PTS,SYM,PSYM,UNSYM,DIM,X,Y)
C     =================================================
C
C
C---- Double in place reordering programme
C
C
C     .. Scalar Arguments ..
      INTEGER          PSYM,PTS
C     ..
C     .. Array Arguments ..
c     REAL             X(10),Y(10)
      REAL             X(*),Y(*)
      INTEGER          DIM(5),SYM(10),UNSYM(10)
C     ..
C     .. Local Scalars ..
      REAL             T
      INTEGER          A,AL,B,BL,BS,C,CL,CS,D,DELTA,DK,DL,DS,E,EL,ES,F,
     +                 FL,FS,G,GL,GS,H,HL,HS,I,IL,IS,J,JJ,JL,JS,K,KK,KL,
     +                 KS,L,LK,LL,LS,M,ML,MODS,MS,MULT,N,NEST,NL,NS,NT,
     +                 P,P0,P1,P2,P3,P4,P5,PUNSYM,SEP,SIZE,TEST
      LOGICAL          ONEMOD
C     ..
C     .. Local Arrays ..
      INTEGER          MODULO(14),S(14),U(14)
C     ..
C     .. Equivalences ..
      EQUIVALENCE      (AL,U(1)), (BS,S(2)), (BL,U(2))
      EQUIVALENCE      (CS,S(3)), (CL,U(3)), (DS,S(4)), (DL,U(4))
      EQUIVALENCE      (ES,S(5)), (EL,U(5)), (FS,S(6)), (FL,U(6))
      EQUIVALENCE      (GS,S(7)), (GL,U(7)), (HS,S(8)), (HL,U(8))
      EQUIVALENCE      (IS,S(9)), (IL,U(9)), (JS,S(10)), (JL,U(10))
      EQUIVALENCE      (KS,S(11)), (KL,U(11)), (LS,S(12)), (LL,U(12))
      EQUIVALENCE      (MS,S(13)), (ML,U(13)), (NS,S(14)), (NL,U(14))
C     ..
      NEST = 14
C
      NT = DIM(1)
      SEP = DIM(2)
      P2 = DIM(3)
      SIZE = DIM(4) - 1
      P4 = DIM(5)
      IF (SYM(1).NE.0) THEN
          DO 10 J = 1,NEST
              U(J) = 1
              S(J) = 1
   10         CONTINUE
          N = PTS
          DO 20 J = 1,NEST
              IF (SYM(J).EQ.0) THEN
                  GO TO 30
              ELSE
                  JJ = NEST + 1 - J
                  U(JJ) = N
                  S(JJ) = N/SYM(J)
                  N = N/SYM(J)
              END IF
   20         CONTINUE
C
   30     JJ = 0
          DO 190 A = 1,AL
              DO 180 B = A,BL,BS
                  DO 170 C = B,CL,CS
                      DO 160 D = C,DL,DS
                          DO 150 E = D,EL,ES
                              DO 140 F = E,FL,FS
                                  DO 130 G = F,GL,GS
                                      DO 120 H = G,HL,HS
                                          DO 110 I = H,IL,IS
                                              DO 100 J = I,JL,JS
                                                 DO 90 K = J,KL,KS
                                                 DO 80 L = K,LL,LS
                                                 DO 70 M = L,ML,MS
                                                 DO 60 N = M,NL,NS
                                                 JJ = JJ + 1
                                                 IF (JJ.LT.N) THEN
                                                 DELTA = (N-JJ)*SEP
                                                 P1 = (JJ-1)*SEP + 1
                                                 DO 50 P0 = P1,NT,P2
                                                 P3 = P0 + SIZE
                                                 DO 40 P = P0,P3,P4
                                                 P5 = P + DELTA
                                                 T = X(P)
                                                 X(P) = X(P5)
                                                 X(P5) = T
                                                 T = Y(P)
                                                 Y(P) = Y(P5)
                                                 Y(P5) = T
   40                                            CONTINUE
   50                                            CONTINUE
                                                 END IF
   60                                            CONTINUE
   70                                            CONTINUE
   80                                            CONTINUE
   90                                            CONTINUE
  100                                            CONTINUE
  110                                         CONTINUE
  120                                     CONTINUE
  130                                 CONTINUE
  140                             CONTINUE
  150                         CONTINUE
  160                     CONTINUE
  170                 CONTINUE
  180             CONTINUE
  190         CONTINUE
      END IF
C
      IF (UNSYM(1).NE.0) THEN
          PUNSYM = PTS/PSYM**2
          MULT = PUNSYM/UNSYM(1)
          TEST = (UNSYM(1)*UNSYM(2)-1)*MULT*PSYM
          LK = MULT
          DK = MULT
          DO 200 K = 2,NEST
              IF (UNSYM(K).EQ.0) THEN
                  GO TO 210
              ELSE
                  LK = UNSYM(K-1)*LK
                  DK = DK/UNSYM(K)
                  U(K) = (LK-DK)*PSYM
                  MODS = K
              END IF
  200         CONTINUE
  210     ONEMOD = MODS .LT. 3
          IF (.NOT.ONEMOD) THEN
              DO 220 J = 3,MODS
                  JJ = MODS + 3 - J
                  MODULO(JJ) = U(J)
  220             CONTINUE
          END IF
          MODULO(2) = U(2)
          JL = (PUNSYM-3)*PSYM
          MS = PUNSYM*PSYM
C
          DO 290 J = PSYM,JL,PSYM
              K = J
  230         CONTINUE
C
              K = K*MULT
              IF (.NOT.ONEMOD) THEN
                  DO 240 I = 3,MODS
                      K = K - (K/MODULO(I))*MODULO(I)
  240                 CONTINUE
              END IF
              IF (K.GE.TEST) THEN
                  K = K - (K/MODULO(2))*MODULO(2) + MODULO(2)
              ELSE
                  K = K - (K/MODULO(2))*MODULO(2)
              END IF
              IF (K.LT.J) GO TO 230
C
              IF (K.NE.J) THEN
                  DELTA = (K-J)*SEP
                  DO 280 L = 1,PSYM
                      DO 270 M = L,PTS,MS
                          P1 = (M+J-1)*SEP + 1
                          DO 260 P0 = P1,NT,P2
                              P3 = P0 + SIZE
                              DO 250 JJ = P0,P3,P4
                                  KK = JJ + DELTA
                                  T = X(JJ)
                                  X(JJ) = X(KK)
                                  X(KK) = T
                                  T = Y(JJ)
                                  Y(JJ) = Y(KK)
                                  Y(KK) = T
  250                             CONTINUE
  260                         CONTINUE
  270                     CONTINUE
  280                 CONTINUE
              END IF
  290         CONTINUE
      END IF
C
      END
*-----------------
C
C
      SUBROUTINE RPCFTK(N,M,P,R,X,Y,DIM)
C     ==========================================
C
C
C---- Radix prime multi-dimensional complex fourier transform kernel
C
C     .. Scalar Arguments ..
      INTEGER           M,N,P,R
C     ..
C     .. Array Arguments ..
      REAL              X(R,P),Y(R,P)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              ANGLE,FJM1,FMP,FP,FU,IS,IU,RS,RU,T,TWOPI,XT,YT
      INTEGER           J,JJ,K,K0,K1,K2,KK,L,L1,MMP,MOVER2,MP,NS,NT,PM,
     +                  PP,SEP,SIZE,U,V
      LOGICAL           FOLD,ZERO
C     ..
C     .. Local Arrays ..
      REAL              A(18),AA(9,9),B(18),BB(9,9),C(18),IA(9),IB(9),
     +                  RA(9),RB(9),S(18)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
C     .. Data statements ..
      DATA              TWOPI/6.283185/
C     ..
C
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      MOVER2 = M/2 + 1
      MP = M*P
      FMP = REAL(MP)
      MMP = SEP*MP
      PP = P/2
      PM = P - 1
      FP = REAL(P)
      FU = 0.0
      DO 10 U = 1,PP
          FU = FU + 1.0
          ANGLE = TWOPI*FU/FP
          JJ = P - U
          A(U) = COS(ANGLE)
          B(U) = SIN(ANGLE)
          A(JJ) = A(U)
          B(JJ) = -B(U)
   10     CONTINUE
      DO 30 U = 1,PP
          DO 20 V = 1,PP
              JJ = U*V - U*V/P*P
              AA(V,U) = A(JJ)
              BB(V,U) = B(JJ)
   20         CONTINUE
   30     CONTINUE
C
      FJM1 = -1.0
      DO 140 J = 1,MOVER2
          FOLD = J .GT. 1 .AND. 2*J .LT. M + 2
          K0 = (J-1)*SEP + 1
          FJM1 = FJM1 + 1.0
          ANGLE = TWOPI*FJM1/FMP
          ZERO = ANGLE .EQ. 0.0
          IF (.NOT.ZERO) THEN
              C(1) = COS(ANGLE)
              S(1) = SIN(ANGLE)
              DO 40 U = 2,PM
                  C(U) = C(U-1)*C(1) - S(U-1)*S(1)
                  S(U) = S(U-1)*C(1) + C(U-1)*S(1)
   40             CONTINUE
          END IF
   50     CONTINUE
C
          DO 120 KK = K0,NS,MMP
              DO 110 L = KK,NT,L1
                  K1 = L + SIZE
                  DO 100 K = L,K1,K2
                      XT = X(K,1)
                      YT = Y(K,1)
                      RS = X(K,2) + X(K,P)
                      IS = Y(K,2) + Y(K,P)
                      RU = X(K,2) - X(K,P)
                      IU = Y(K,2) - Y(K,P)
                      DO 60 U = 1,PP
                          RA(U) = AA(U,1)*RS + XT
                          IA(U) = AA(U,1)*IS + YT
                          RB(U) = BB(U,1)*RU
                          IB(U) = BB(U,1)*IU
   60                     CONTINUE
                      XT = XT + RS
                      YT = YT + IS
                      DO 80 U = 2,PP
                          JJ = P - U
                          RS = X(K,U+1) + X(K,JJ+1)
                          IS = Y(K,U+1) + Y(K,JJ+1)
                          RU = X(K,U+1) - X(K,JJ+1)
                          IU = Y(K,U+1) - Y(K,JJ+1)
                          XT = XT + RS
                          YT = YT + IS
                          DO 70 V = 1,PP
                              RA(V) = AA(V,U)*RS + RA(V)
                              IA(V) = AA(V,U)*IS + IA(V)
                              RB(V) = BB(V,U)*RU + RB(V)
                              IB(V) = BB(V,U)*IU + IB(V)
   70                         CONTINUE
   80                     CONTINUE
                      X(K,1) = XT
                      Y(K,1) = YT
                      DO 90 U = 1,PP
                          JJ = P - U
                          IF (ZERO) THEN
                              X(K,U+1) = RA(U) + IB(U)
                              Y(K,U+1) = IA(U) - RB(U)
                              X(K,JJ+1) = RA(U) - IB(U)
                              Y(K,JJ+1) = IA(U) + RB(U)
                          ELSE
                              XT = RA(U) + IB(U)
                              YT = IA(U) - RB(U)
                              X(K,U+1) = C(U)*XT + S(U)*YT
                              Y(K,U+1) = C(U)*YT - S(U)*XT
                              XT = RA(U) - IB(U)
                              YT = IA(U) + RB(U)
                              X(K,JJ+1) = C(JJ)*XT + S(JJ)*YT
                              Y(K,JJ+1) = C(JJ)*YT - S(JJ)*XT
                          END IF
   90                     CONTINUE
  100                 CONTINUE
  110             CONTINUE
  120         CONTINUE
          IF (FOLD) THEN
              FOLD = .FALSE.
              K0 = (M+1-J)*SEP + 1
              DO 130 U = 1,PM
                  T = C(U)*A(U) + S(U)*B(U)
                  S(U) = -S(U)*A(U) + C(U)*B(U)
                  C(U) = T
  130             CONTINUE
              GO TO 50
          END IF
  140     CONTINUE
C
      END
C
C
C
C
      SUBROUTINE HERMFT(X,Y,N,DIM)
C     ==================================
C
C
C
C---- Hermitian symmetric fourier transform
C
C     Given the unique terms of a hermitian symmetric sequence of length
C     2N this subroutine calculates the 2N real numbers which are its
C     fourier transform.  The even numbered elements of the transform
C     (0, 2, 4, . . ., 2n-2) are returned in X and the odd numbered
C     elements (1, 3, 5, . . ., 2n-1) in Y.
C
C     A finite hermitian sequence of length 2n contains n + 1 unique
C     real numbers and n - 1 unique imaginary numbers.  For convenience
C     the real value for X(n) is stored at Y(0).
C
C
C     .. Scalar Arguments ..
      INTEGER           N
C     ..
C     .. Array Arguments ..
      REAL              X(*),Y(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              A,ANGLE,B,C,CO,D,E,F,SI,TWON,TWOPI
      INTEGER           D2,D3,D4,D5,I,I0,I1,I2,J,K,K1,NOVER2,NT
C     ..
C     .. External Subroutines ..
      EXTERNAL          CMPLFT
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
      TWOPI = 6.283185
      TWON = REAL(2*N)
C
      NT = DIM(1)
      D2 = DIM(2)
      D3 = DIM(3)
      D4 = DIM(4) - 1
      D5 = DIM(5)
C
      DO 20 I0 = 1,NT,D3
          I1 = I0 + D4
          DO 10 I = I0,I1,D5
              A = X(I)
              B = Y(I)
              X(I) = A + B
              Y(I) = A - B
   10         CONTINUE
   20     CONTINUE
C
      NOVER2 = N/2 + 1
      IF (NOVER2.GE.2) THEN
          DO 50 I0 = 2,NOVER2
              ANGLE = REAL(I0-1)*TWOPI/TWON
              CO = COS(ANGLE)
              SI = SIN(ANGLE)
              K = (N+2-2*I0)*D2
              K1 = (I0-1)*D2 + 1
              DO 40 I1 = K1,NT,D3
                  I2 = I1 + D4
                  DO 30 I = I1,I2,D5
                      J = I + K
                      A = X(I) + X(J)
                      B = X(I) - X(J)
                      C = Y(I) + Y(J)
                      D = Y(I) - Y(J)
                      E = B*CO + C*SI
                      F = B*SI - C*CO
                      X(I) = A + F
                      X(J) = A - F
                      Y(I) = E + D
                      Y(J) = E - D
   30                 CONTINUE
   40             CONTINUE
   50         CONTINUE
C
          CALL CMPLFT(X,Y,N,DIM)
      END IF
C
C
      END
C
C
C
      SUBROUTINE REALFT_SIR(EVEN,ODD,N,DIM)
C      ======================================
C
C
C
C     REAL FOURIER TRANSFORM
C
C     Given a real sequence of length 2n this subroutine calculates the
C     unique part of the fourier transform.  The fourier transform has
C     n + 1 unique real parts and n - 1 unique imaginary parts.  Since
C     the real part at x(n) is frequently of interest, this subroutine
C     stores it at x(n) rather than in y(0).  Therefore x and y must be
C     of length n + 1 instead of n.  Note that this storage arrangement
C     is different from that employed by the hermitian fourier transform
C     subroutine.
C
C     For convenience the data is presented in two parts, the first
C     containing the even numbered real terms and the second containing
C     the odd numbered terms (numbering starting at 0).  On return the
C     real part of the transform replaces the even terms and the
C     imaginary part of the transform replaces the odd terms.
C
C
C     .. Scalar Arguments ..
      INTEGER           N
C     ..
C     .. Array Arguments ..
      REAL              EVEN(*),ODD(*)
      INTEGER           DIM(5)
C     ..
C     .. Local Scalars ..
      REAL              A,ANGLE,B,C,CO,D,E,F,SI,TWON,TWOPI
      INTEGER           D2,D3,D4,D5,I,I0,I1,I2,J,K,L,NOVER2,NT
C     ..
C     .. External Subroutines ..
      EXTERNAL          CMPLFT
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC         COS,REAL,SIN
C     ..
      TWOPI = 6.283185
      TWON = REAL(2*N)
C
      CALL CMPLFT(EVEN,ODD,N,DIM)
C
      NT = DIM(1)
      D2 = DIM(2)
      D3 = DIM(3)
      D4 = DIM(4) - 1
      D5 = DIM(5)
      NOVER2 = N/2 + 1
C
      IF (NOVER2.GE.2) THEN
          DO 30 I = 2,NOVER2
              ANGLE = REAL(I-1)*TWOPI/TWON
              CO = COS(ANGLE)
              SI = SIN(ANGLE)
              I0 = (I-1)*D2 + 1
              J = (N+2-2*I)*D2
              DO 20 I1 = I0,NT,D3
                  I2 = I1 + D4
                  DO 10 K = I1,I2,D5
                      L = K + J
                      A = (EVEN(L)+EVEN(K))/2.0
                      C = (EVEN(L)-EVEN(K))/2.0
                      B = (ODD(L)+ODD(K))/2.0
                      D = (ODD(L)-ODD(K))/2.0
                      E = C*SI + B*CO
                      F = C*CO - B*SI
                      EVEN(K) = A + E
                      EVEN(L) = A - E
                      ODD(K) = F - D
                      ODD(L) = F + D
   10                 CONTINUE
   20             CONTINUE
   30         CONTINUE
      END IF
C
      IF (N.GE.1) THEN
          J = N*D2
          DO 50 I1 = 1,NT,D3
              I2 = I1 + D4
              DO 40 K = I1,I2,D5
                  L = K + J
                  EVEN(L) = EVEN(K) - ODD(K)
                  ODD(L) = 0.0
                  EVEN(K) = EVEN(K) + ODD(K)
                  ODD(K) = 0.0
   40             CONTINUE
   50         CONTINUE
      END IF
C
C
      END
C
C
*-----------------
      function favi(ityp1,phi)

      idv = 15*mod(iabs(ityp1)-1,12)
      ip1=idv
      ip2=idv + 180
      idif1=iabs(nint(phi)-ip1)
      idif1=min0(idif1,360-idif1)
      idif2=iabs(nint(phi)-ip2)
      idif2=min0(idif2,360-idif2)
      phi=float(ip1)
      if (idif2.lt.idif1) phi=float(ip2)
      if (phi.le.0.01) phi=phi+360.0
      favi=phi
      return
      end
c-----------------------------------------------------------------------
c--- vedi nperc e nnumb
c-----------------------------------------------------------------------
      integer function lmod(i,j)
c fixed integer mod (optimised for 0<=i<j)
      integer i,j,k
c
      if (i.lt.0) then
       lmod=mod(i+1,j)+j-1
      else if (i.ge.j) then
       lmod=mod(i,j)
      else
       lmod=i
      endif

      return
      end
c
c ----------------------------------------------------------------------
c
      complex function phasec(phi)
c PHASE - calculate a complex phase factor
      real phi
c
      phasec=cmplx(cos(phi),sin(phi))
      return
      end
c
*----------------------------------------------------------*
      logical function hemi(ih,ik,il)

      hemi=(il.gt.0 .or.
     +     (il.eq.0 .and. (ih.gt.0 .or.
     +     (ih.eq.0 .and. ik.gt.0) ) ) )

      return
      end
*--------------------------------------------------------*
      real function phaseof(f)

      complex f

      if (abs(f).gt.0.01) then
         phaseof=atan2(aimag(f),real(f))
      else
         phaseof=0.0
      endif

      return
      end
c--------------------------------------------------------------------------
      subroutine inversione(nrefl,hkl2,iphi,fcv,xmap)
      USE Riflessi, only : IndHkl         ,mkang
      USE ParametriMappa, only : np
      dimension xmap(0:np(1)-1,0:np(2)-1,0:np(3)-1)
!corr      dimension hkl2(3,nrefl),iphi(nrefl),fcv(nrefl)
      integer :: hkl2(3,nrefl)
      dimension iphi(nrefl),fcv(nrefl)
      dimension mkangc(nrefl)
c
c     write(6,*)'xmap',xmap(1:10,1,1)
c     call newinv(xmap,hkl2,mkang,iphi,fcv,nrefl,np(1),np(2),np(3))
      mkangc(1:nrefl)=mod(IndHKL(1:nrefl,5),32)
      call invfft_sir(hkl2,mkangc,0,0.0,iphi,
     *                      fcv,nrefl,xmap,ier)
c
      return
      end
c-----------------------------------------------------------------------------------
