module profile_function
   implicit none

   integer, parameter, public :: PEARSON7 = 1
   integer, parameter, public :: PVOIG    = 2
   integer, parameter, public :: TCHZ     = 3

   real, allocatable :: rapIcalc (:) ! rapIcalc (i,nph)    : rapporto di intensita'

   type :: profinfo_type
     integer                         :: iniz,ifin
     real, dimension(:), allocatable :: func
     real                            :: fconst
   end type profinfo_type

   type(profinfo_type), dimension(:), allocatable :: profi

contains

!corr   subroutine AllocaRietnew(iAction,nref)
!corr   USE progtype,only:ALLOCA
!corr!
!corr   implicit none
!corr   integer, intent(in)           :: iAction
!corr   integer, intent(in), optional :: nref
!corr   integer, dimension(10)        :: ierv
!corr!
!corr   ierv = 0
!corr!
!corr   if (iAction == ALLOCA) then
!corr      if (.not. allocated(rapIcalc))  allocate (rapIcalc  (1:nref)    , stat = ierv( 9))
!corr      if (sum(iabs(ierv)) /= 0) stop 'RIETNEW allocation error'
!corr   else
!corr      if (allocated(rapIcalc))deallocate (rapIcalc, stat=ierv(1))
!corr      if (ierv(1).ne.0) stop 'RIETNEW deallocation error'
!corr   endif
!corr!
!corr   end subroutine AllocaRietnew

!-----------------------------------------------------------------------------------------------------

   subroutine close_profile()
!
   if (allocated(profi)) deallocate(profi)
!   
   end subroutine close_profile

end module profile_function
