#include "mrconfig.h"
#include "callbacks.h"

static int ifLigand = 0;
#ifndef SIR_PGM
#include "forcomm2.h"
#include "forcomm1.h"
#include "aliasx.h"
GtkWidget *frame_preferential(GtkWidget *dlg);
enum pagine_sa {PAGE_SA, PAGE_EXTDOF, PAGE_INTDOF, PAGE_ANTIB, PAGE_PREF};
#else
extern _Dialogo *dialogo;
enum pagine_sa {PAGE_MAP, PAGE_SA, PAGE_EXTDOF, PAGE_INTDOF, PAGE_ANTIB};

typedef struct {
                 int   code;  // indica il tipo di restraint: 1=distanza,2=angolo,3=piano
                 int   nna;   // numero di atomi coinvolti nel restraint
                 int   *na;   // puntatori agli atomi coinvolti nel restraint
                 float val;   // valore corrente del restraint
                 float targ;  // valore target del restraint
                 float sigma; // deviazione standard
                 float wei;    // weight
                 int   sym;   // consider symmetry equivalent atoms
               } restraint_type;

     const char *labelvol[] = {"Along a", "Along b", "Along c"};

     static float defaultCell[3];
     static float Cella[3];
     extern "C" void getligandinfo_(int *ifLig, float defCell[], float cell[]);
     extern "C" void passanewvolume_(float cell[], float centre[], int *flag);
     extern "C" void resetvolumeinfo_();
     extern "C" void GetNewVolumeInfo(float cell[], float centre[]);
#endif


// new 14/01/14
extern "C" void passa_info_bumptab_(int *i, float *targ, int *code);
extern "C" void randomize_parameters_();

typedef struct {
                int baction;     //0 = bump disabled,
                                 //1 = default strategy,
                                 //2 = user strategy
                float weight;    //scale for bump in the CF
                float scaledist; //scale factor on distances
               } bump_settings;

static int nres;
restraint_type *abres;

typedef struct {
          int  npar;     // num. totale di parametri
          int  dofi;     // num. di DOF interni
          int  dofe;     // num. di DOF esterni
          int  nprot;    // num. di rotazioni affinate
          int  npb;      // numeri di parametri termici affinati
          int  npshift;  // numero di paramtri di shift affinati
          int  nreftot;  // num. totale riflessi
          int  nref;     // num. di riflessi usati
          int  nco;      // numero di conteggi usati
          float ttmin;    // 2theta min
          float ttmax;    // 2theta max
          float res;      // risoluzione
          int  cftype;   // tipo di funzione costo
          int doc;       // dynamical occupancy correction
          float rwp_leb;  // Rwp alla fine dell'affinamento del profilo
          int   nrun;        // Number of SA run
          int   nrunc;       // A quale run sono?
          char  cost_function_name[60];
          char  cost_function_name_short[20];
          int   seed;        // If different from zero, holds the seed for random number generator
          int   autoalgo;    // Selezione automatica del tipo di algoritmo
          int   algo;        // Algorithm type
          float sogcf;       // Valore soglia per la funzione costo
          float fmin;        // valore minimo della funzione costo
          int   rmin;        // run corrispondente al valore minimo
          char  popt [10];   // Opzioni di output:  S = stampa alla fine di ogni step di temperatura
                             //                     G = grafica
                             //                     H = stampa sintetica alla fine di ogni step
         } gopt_info_type;


typedef struct {
  float t_ini;       // Initial temperature
  float temp_fact;   // Temperature reduction factor
  float eps;         // Error tolerance for termination
  int   initconfig;  // Flag determining if the first configuration is random or read
  int   nt;          // Number of iterations before temperature reduction
  int   num_temps;   // Maximum number of temperatures in SA
  int   ns;          // After ns*npar stp is updated
  int   neps;        // Number of final function values used to decide upon termination
  int   autoti;      // calcolo automatico t_ini?
  int   autont;      // calcolo automatico nt?
  int   rand;        // randomizzazione iniziale
         } SimAnn_Conditions_type;

typedef struct {
  int   nump;        // size of population
  int   niter;       // number of iterations
  float tol;         // Stopping criterion
  int   nlocmax;     // numero di local search
  float beta;        // parametro di controllo
  int   autont;      // calcolo automatico di niter
         } bb_bc_condition;


typedef struct {
                int    rcod;           // codice di affinamento
                char   str_ators[80];  // atomi della torsione associata alla rotazione
                float  torsval;        // valore dell'angolo di torsione
                float  trbound[2];     // limiti sulla torsione
                } c_rotation_type;

typedef struct {
                 int *pos;         // num. d'ordine degli atomi del frammento
                 int  nat;         // num. di atomi nel frammento
                 int rcod[6];      // codici di affinamento
                 float tlow[3];    // limiti inferiori sulla traslazione
                 float thigh[3];   // limiti superiori sulla traslazione
                 float rbound[2];  // limiti sulla rotazione
                 int rat;          // rotation around rat (0 = center of mass)
               } c_fragment_type;

extern "C" {
           void  evaluate_res_    (float *res,int *numref, float *tthmaxr,int *ier);
           void  exitsannel_      ();
           void  sannelexewin_   (int *ier, double *resmin, double *resmax, 
                                  gopt_info_type *ginfo,
                                  SimAnn_Conditions_type *scgraph,
                                  bb_bc_condition *bbgraph, int *ifButton,
                                  bump_settings *bumpset);
           void  finishsannel_   (gopt_info_type *ginfo,
                                  SimAnn_Conditions_type *scgraph,
                                  bb_bc_condition *bbgraph, float *sa,
                                  bump_settings *bsc);
           void  passa_rcod_     (int *i, int *rcod, float *tlow, float *thigh,
                                  float *rbound, int *rat);
           int   get_srcod_      (int *i, int *j);
           void  get_rators_     (int *i, int vett[], int *cod, float *val,
                                  float b[]);
           void  put_rators_     (int *i, int *cod, float *val, float b[]);
           void  put_srcod_      (int *i, int cod[]);
           void  get_info_for_gtklist_(int *nrow,int *rcol,float *fcol,
                                       char *strcol, size_t dum);
           void  savesolution_   (int *n);
           void  showsolution_   (int *n);
           void  cancelsolution_ (int *n);
           void  ges_atom_parameters_win_(int *code,atom_type *atm,
                                   int shifta[],float *shiftatomval);
#ifndef SIR_PGM
           void  getvaluesforpattern_(r_param_type *gpo, int hklpo[], int *kopcorr);
           void  setvaluesforpattern_(r_param_type *gpo, int hklpo[], int *kopcorr);
#endif
        }

typedef struct {
    int katom;       // atomo 
    int kpar;        // parametro
               } _cbdata;

  enum  costs  {RWPC_COSTF=1, CHI2I, CHI2FACT, CHI2I_NEW,
                RWP_COSTF, CHI2GRU, CHI2_COSTF, CHI2I_SD};
  static const char *strCosts[] = {
           "R weighted profile","R intensities     ", "R structure factor",
           "Chisquared 1      ","Rwp 1             ","R groups          ",
           "Chisquared 3      ","Chisquared 4      "};

  static int *cfvect = NULL;
  static int szcfvect;

//static const char *parametri[] = {"x","y","z","B[iso]"};
gopt_info_type ginfo;
SimAnn_Conditions_type scgraph;
bb_bc_condition bbgraph;
static atom_type *atm;
c_rotation_type  *rotation;
c_fragment_type  *fragment;
int **shift_rcod;
int *shift_atom;
int **atm_rcod;

static int cftype;
static int nfrag;
static int numfrags;
static int numrot;
static int nats;
static float shiftatomval;
static GtkWidget *mainwin;
extern GtkWidget *finestre[6];
enum algotypes {SA_LOCAL = 1, BBBC};

static GtkWidget *sannel_dialog = NULL;
void stop_main_loop();
void apri_finestra_soluzioni(GtkWidget *dlg, int nrow, int nrcol[], 
                             float cfcol[], char *strcol);
int check_modi(char *string, float *val);
#ifndef SIR_PGM
//corr void sistema_tasti(int abilita);
static int hklpo[3];
static int kopcorr;
static r_param_type gpo;
#else //        aggiunte per sir 

extern gboolean can_drag;
int check_modi(char *string, float *val)
{
    char strval[20];
    char strinp[20];
    CopiaStringa(strinp, sizeof(strinp), string);
    g_strstrip(strinp);
    ScriviStringa(strval, sizeof(strval), "%-12.6f", *val);
    g_strstrip(strval);
    if(strcmp(strval, strinp) == 0)
       return 0;
    else
    {
       *val = (float) atof(strinp);
       return 1;
    }
}

void add_text(GtkWidget *textv, char *stringa)
{
  GtkTextIter iter;
  GtkTextBuffer *tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textv));

  gtk_text_buffer_get_end_iter (tb, &iter);
  gtk_text_buffer_insert (tb, &iter, stringa, (int) strlen(stringa));

}

#endif //   fine aggiunte

GtkWidget *create_my_combog(GList *labels, int def_b,
                           GCallback cb_func, gpointer data)
{
    GtkWidget *combo;
    int hnd;

    combo = create_combo_str(cb_func, data, false);
    fill_my_combog(combo, labels);
    hnd = get_int(combo, "hnd");
    if(hnd)
#ifndef GTK_COMBO_BOX
       g_signal_handler_block(G_OBJECT(GTK_COMBO(combo)->entry), hnd);
#else
       g_signal_handler_block(G_OBJECT(combo), hnd);
#endif
    combo_set_val(combo, def_b);
#ifndef GTK_COMBO_BOX
       g_signal_handler_unblock(G_OBJECT(GTK_COMBO(combo)->entry), hnd);
#else
       g_signal_handler_unblock(G_OBJECT(combo), hnd);
#endif

    return combo;
}

void set_spin_value(GtkWidget *spin, float val)
{
     int hnd = get_int(GTK_WIDGET(spin), "hnd");
     g_signal_handler_block(G_OBJECT(spin), hnd);
     spin_button_set_value(spin, val);
     g_signal_handler_unblock(G_OBJECT(spin), hnd);
}

void help_sannel(GtkButton *button, gpointer data)
{
#ifdef SIR_PGM
    open_htm("Solve.html#sannel");
#else
    open_htm("structure-solution-by-direct-space-methods/");
#endif
}

int prendi_srcod(int *i, int *j)
{
    int k=0;
    k = get_srcod_(i, j);
    return k;
}

extern "C" {

void passa_info_(atom_type *atml, int *atomsl, int *nfrags, int *nrot, int *natpr, float *sa)
{
     int i,j;
     nats = *natpr;

     atm = atml;
     shiftatomval = *sa;
     numfrags = *nfrags;
     numrot   = *nrot;
     fragment = g_new0(c_fragment_type, numfrags);
     for(i=0; i<numfrags; i++)
     {
         fragment[i].nat = atomsl[i];
         fragment[i].pos = g_new0(int, fragment[i].nat);
     }
     shift_rcod = g_new0(int *, nats);
     shift_atom = g_new0(int, nats);
     rotation = g_new0(c_rotation_type, nats);
     atm_rcod = g_new0(int *, nats);
     for(i=1; i<=nats; i++)
     {
         atm_rcod[i-1] = g_new0(int, 5);
         memcpy(atm_rcod[i-1], atm[i-1].rcod, 5*sizeof(int));
//NEW
         atm_rcod[i-1][4] = (atm[i-1].doc)?1:0;
         //g_print("%s %d\n", atm[i-1].lab, atm[i-1].doc);
//
         shift_rcod[i-1] = g_new0(int, 3);
         for(j=1; j<=3; j++)
             shift_rcod[i-1][j-1]= prendi_srcod(&i, &j);
         shift_atom[i-1] = shift_rcod[i-1][0] | shift_rcod[i-1][1] | shift_rcod[i-1][2];
     }
}

void passa_frag_(int *atomspos, int *rcodl, float *tlowl, float *thighl, 
                 float *rboundl, int *rat, int *i)
{
     memcpy(fragment[*i].pos, atomspos, fragment[*i].nat*sizeof(int));
     memcpy(fragment[*i].rcod, rcodl, 6*sizeof(int));
     memcpy(fragment[*i].tlow, tlowl, 3*sizeof(float));
     memcpy(fragment[*i].thigh, thighl, 3*sizeof(float));
     memcpy(fragment[*i].rbound, rboundl, 2*sizeof(float));
     fragment[*i].rat = *rat;
}

//NEW 26/04/16
void passa_cfvect_(int *szvec, int *vec)
{
    if(cfvect != NULL)
    {
       g_free(cfvect);
       cfvect = NULL;
    }
    szcfvect = *szvec;
    if(szcfvect)
    {
       cfvect = g_new0(int, szcfvect);
       for(int i=0; i<szcfvect; i++)
           cfvect[i] = vec[i];
    }
}

//NEW 14/01/14
void passa_abres_(int *nresl)
{
    if(abres != NULL)
    {
       for(int i=0; i<nres; i++)
           g_free(abres[i].na);
       g_free(abres);
       abres = NULL;
    }
    nres = *nresl;
    if(nres)
       abres = g_new0(restraint_type, nres);
}

void put_info_abres_(int *i, int *code, float* targ, int *nna, int na[])
{
   int j, numna = *nna;

   abres[*i].code = *code;
   abres[*i].targ = *targ;
   abres[*i].nna = numna;
   abres[*i].na = g_new0(int, numna);
   for(j=0; j<numna; j++)
       abres[*i].na[j] = na[j];
}
//END NEW

}

int csa_conta_parametri(gopt_info_type localinfo)
{
   int i, j, npar;
   GtkWidget *widget;

//  Conta gradi di libertà esterni
   localinfo.dofe = 0           ;
   for(i=0; i<numfrags; i++)
   {
       for(j=0; j<6; j++)
           localinfo.dofe += fragment[i].rcod[j];
   }

//  Conta i B
   localinfo.npb = 0;
   for(i=0; i<nats; i++)
       localinfo.npb += atm_rcod[i][3];

//  Conta le rotazioni   
   localinfo.nprot = 0;
   for(i=0; i<numrot; i++)
       localinfo.nprot +=  rotation[i].rcod;

//  Conta gli shifts   
   localinfo.npshift = 0;
   for(i=0; i<nats; i++)
   {
       for(j=0; j<3; j++)
           localinfo.npshift += shift_rcod[i][j];
   }

//  DOF interni   
   localinfo.dofi = localinfo.nprot;

//  Numero totale di parametri   
   npar = localinfo.dofi + localinfo.dofe + localinfo.npb + localinfo.npshift;
   if(sannel_dialog)
   {
      char *tmp = g_strdup_printf("%d", npar);
      widget = get_widget(sannel_dialog, "numRefPar");
      set_label_text(widget, tmp, MyRED, 0.99f, 0);
      g_free(tmp);
   }
   return npar;
}
void on_resol_changed (GtkWidget *button, GtkWidget *dlg)
{
   float resol = (float) spin_button_get_value (button);
   int ier = 0, num_refl;
   float tthmax;

   evaluate_res_(&resol, &num_refl, &tthmax, &ier);
   if(!ier)
   {
      GtkWidget *widget = get_widget(dlg, "nrefl");
      char *tmp = g_strdup_printf("N. of reflections: %d", num_refl);
      gtk_label_set_text(GTK_LABEL(widget), tmp);
      g_free(tmp);
      tmp = g_strdup_printf("2thmax: %.3f", tthmax);
      widget = get_widget(dlg, "thmax");
      gtk_label_set_text(GTK_LABEL(widget), tmp);
      g_free(tmp);
   }
}

void prendi_ators_etc(int i, int vett[], int *rrcod, float *val, float bounds[])
{
     int j = i;

     get_rators_(&j, vett, rrcod, val, bounds);
}

void passa_ators_etc(int i, int *rrcod, float *val, float bounds[])
{
     int j = i;

     put_rators_(&j, rrcod, val, bounds);
}

void passa_srcod(int i)
{
     int j = i+1;

     put_srcod_(&j, shift_rcod[i]);
}

void get_values(GtkWidget *dlg)
{
     GtkWidget *widget;

     ginfo.npar = csa_conta_parametri(ginfo);
// SA conditions

     ginfo.cftype = cfvect[cftype-1];
     widget = get_widget(sannel_dialog, "spinres");
     ginfo.res  = (float) spin_button_get_value(widget);
     widget = get_widget(dlg, "Nrun_spin");
     ginfo.nrun = spin_button_get_value_as_int(widget);
     widget = get_widget(dlg, "ran_seed_spin");
     ginfo.seed = spin_button_get_value_as_int(widget);
// 
     if(ginfo.algo == SA_LOCAL)
     { 
        widget = get_widget(dlg, "auto_temp_check");
        scgraph.autoti = 0;
        if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)))
            scgraph.autoti = -1;
        widget = get_widget(dlg, "start_temp_spin");
        if(!scgraph.autoti)
           scgraph.t_ini  = (float) spin_button_get_value(widget);
        widget = get_widget(dlg, "auto_moves_check");
        scgraph.autont = 0;
        if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)))
            scgraph.autont = -1;
        widget = get_widget(dlg, "Nmoves_spin");
        if(!scgraph.autont)
            scgraph.nt = spin_button_get_value_as_int(widget);
        widget = get_widget(dlg, "cool_rate_spin");
        scgraph.temp_fact = (float) spin_button_get_value(widget);
     }
     else
     {
        widget = get_widget(dlg, "auto_cycles_check");
        bbgraph.autont = 0;
        if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)))
            bbgraph.autont = -1;
        widget = get_widget(dlg, "Ncycles_spin");
        if(!bbgraph.autont)
            bbgraph.niter = spin_button_get_value_as_int(widget);
     }
//
//     widget = get_widget(sannel_dialog, "DOC");
//     ginfo.doc  = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget));
#if 0
#ifdef SIR_PGM
     widget = get_widget(sannel_dialog, "Rsoglia");
     ginfo.sogcf = (float) spin_button_get_value(widget);
#endif
#endif

#ifndef SIR_PGM
//
// Pattern
//
   char stringa[15];
   char *string;

   for(int i=1; i<=3; i++)
   {
     ScriviStringa(stringa,sizeof(stringa), "entryHKL%d", i);
     widget = get_widget(sannel_dialog, stringa);
     string = gtk_editable_get_chars(GTK_EDITABLE(widget),0, -1);
     if(atoi(string) != hklpo[i-1])
        hklpo[i-1] = atoi(string);
     g_free(string);
   }
   widget = get_widget (sannel_dialog, "entryG1");
   string = gtk_editable_get_chars(GTK_EDITABLE(widget),0, -1);
   if(atoi(string) != gpo.val)
      gpo.val = (float) atof(string);
   g_free(string);
   widget = get_widget (sannel_dialog, "checkG1");
   gpo.rcod = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget));
   if (gpo.rcod == 0 && MRabs(gpo.val - 1.000000) < 0.0001)
       kopcorr = 0;
   else
       kopcorr = 1;
   setvaluesforpattern_(&gpo, hklpo, &kopcorr);
#endif
}

#ifdef SIR_PGM
void UpdateVolumeInfo(int *flag)
{
    if(ifLigand)
    {
       float abc[3], xyz[3];
       GetNewVolumeInfo(abc, xyz);
       passanewvolume_(abc, xyz, flag);
    }
}
#endif

void get_abres(GtkWidget *list)
{
  GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
  GtkTreeIter iter;
  gboolean valid = gtk_tree_model_get_iter_first (model, &iter);

  int i = 0;
  while (valid)
  {
     gboolean val;
     gtk_tree_model_get (model, &iter, 3, &val, -1);
     abres[i].code = (val?4:-4);
     valid = gtk_tree_model_iter_next (model, &iter);
     i++;
  }
}

void get_rotation_values()
{
      int i, vett[4];
      int rrcod;
      float val, bounds[2];

      for(i=1; i<=numrot; i++)
      {
          prendi_ators_etc(i, vett, &rrcod, &val, bounds);
          rotation[i-1].torsval = val;
      }
}

void update_rotation_values(GtkWidget *dlg)
{
     get_rotation_values();
     for(int i=1; i<=numrot; i++)
     {
         if(rotation[i-1].rcod == 0)
            continue;
         std::stringstream nome;
         nome << "value" << i;
         GtkWidget *spin = get_widget(dlg, nome.str().c_str());
         spin_button_set_value(spin,  rotation[i-1].torsval);
     }
}

void ok_sannel  (GtkButton *button, gpointer user_data)
{

    GtkWidget *dlg;
    int i, rrcod;
    float val, bounds[2];
    bump_settings bumpset;

    dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));

    get_values(dlg);
//    gtk_widget_hide (dlg);

#ifdef SIR_PGM
    int flag = 1;
    UpdateVolumeInfo(&flag);
    finestra_modale_chiusa2();
    mostra_tb(mainwin, (gpointer) "run2");
#endif

    elaborazione_in_corso();
    fortran_al_lavoro();
//NEW 14/01/14
    GtkWidget *widget = get_widget(dlg, "bump_weight");
    bumpset.weight = (float) atof(gtk_entry_get_text(GTK_ENTRY(widget)));
    widget = get_widget(dlg, "bump_scale");
    bumpset.scaledist = (float) atof(gtk_entry_get_text(GTK_ENTRY(widget)));
    bumpset.baction = 0;
    for(int j=0; j<3; j++)
    {
        char *nm = g_strdup_printf("bact%d", j);
        widget = get_widget(dlg, nm);
        g_free(nm);
        if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)))
        {
           bumpset.baction = j;
           break;
        }
    }
    if(bumpset.baction > 0)   //== 2)
    {
       get_abres(get_widget(dlg, "listaabRestraints"));
       for(i=1; i<=nres;i++)
           passa_info_bumptab_(&i, &(abres[i-1].targ), &(abres[i-1].code));
    }

//END NEW
    for(i=1; i<=numrot; i++)
    {
        rrcod     = rotation[i-1].rcod;
        val       = rotation[i-1].torsval;
        bounds[0] = rotation[i-1].trbound[0];
        bounds[1] = rotation[i-1].trbound[1];
        passa_ators_etc(i, &rrcod, &val, bounds);
    }
    for(i=0; i<nats; i++)
    {
         memcpy(atm[i].rcod, atm_rcod[i], 5*sizeof(int));
         passa_srcod(i);
    }

    for(i=1; i<=numfrags; i++)
        passa_rcod_(&i, fragment[i-1].rcod, fragment[i-1].tlow, 
              fragment[i-1].thigh, fragment[i-1].rbound, &(fragment[i-1].rat));
    gtk_widget_hide (dlg);
    finishsannel_(&ginfo, &scgraph, &bbgraph, &shiftatomval, &bumpset);

    fine_lavoro();
    fine_elaborazione();

#ifdef SIR_PGM
    nascondi_tb(mainwin);
    finestra_modale_aperta2(dlg);
#else
    widget = get_widget(dlg, "checkG1");
    if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)))
    {
       int kopcorrl, hklpol[3];
       r_param_type gpol;
       getvaluesforpattern_(&gpol, hklpol, &kopcorrl);
       memcpy(&gpo, &gpol, sizeof(r_param_type));
       kopcorr = kopcorrl;
       for(i=0; i<3; i++)
           hklpo[i] = hklpol[i];
       widget = get_widget(dlg, "entryG1");
       gtk_entry_set_text(GTK_ENTRY(widget), 
          g_strdup_printf("%-12.6f", gpo.val));
    }
#endif
    update_rotation_values(dlg);
    gtk_widget_show(dlg);
}

void exit_sannel  (GtkButton *button, gpointer user_data)
{
   int i;
#ifdef SIR_PGM
   finestra_modale_chiusa2();
   can_drag = TRUE;   // mr 080214
#endif
   exitsannel_();
   for(i=0; i<numfrags; i++)
       g_free(fragment[i].pos);
   for(i=0; i<nats; i++)
       g_free(shift_rcod[i]);
   for(i=0; i<nats; i++)
       g_free(atm_rcod[i]);
   g_free(fragment);
   g_free(shift_rcod);
   g_free(shift_atom);
   g_free(atm_rcod);

   gtk_widget_hide(sannel_dialog);
#ifndef SIR_PGM
   stop_main_loop();
#endif
}

void show_solutions  (GtkButton *button, gpointer user_data)
{
using namespace gtkext;

    GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
    int nrow, *nrcol;
    float *cfcol;
    GtkWidget *widget = get_widget(dlg, "Nrun_spin");
    int nrun = spin_button_get_value_as_int(widget);

    char *strcol = g_new0(char, MaxLenFilename);
    memset(strcol, ' ', MaxLenFilename-1);

    nrcol = g_new0(int, nrun);
    cfcol = g_new0(float, nrun);

    get_info_for_gtklist_(&nrow,nrcol,cfcol,strcol, strlen(strcol));
    if(nrow == 0)
       dlg_errmsg(GTK_WINDOW(dlg), "No solutions available.");
    else
    {
       gtk_widget_hide (dlg);
#ifdef SIR_PGM
       finestra_modale_chiusa2();
#endif
       apri_finestra_soluzioni(dlg,nrow,nrcol,cfcol,strcol);
    }
}

void put_ref_codes()
{
    int rrcod;
    float val, bounds[2];
    for(int i=1; i<=numrot; i++)
    {
        rrcod     = rotation[i-1].rcod;
        val       = rotation[i-1].torsval;
        bounds[0] = rotation[i-1].trbound[0];
        bounds[1] = rotation[i-1].trbound[1];
        passa_ators_etc(i, &rrcod, &val, bounds);
    }
    for(int i=1; i<=numfrags; i++)
        passa_rcod_(&i, fragment[i-1].rcod, fragment[i-1].tlow,
             fragment[i-1].thigh, fragment[i-1].rbound, &(fragment[i-1].rat));
}

void on_randomize_clicked(GtkWidget *but, GtkWidget *dlg)
{
     put_ref_codes();
     randomize_parameters_();
     update_rotation_values(dlg);
}


GtkWidget *page_SAconditions(GtkWidget *sa_dlg, double resmin, double resmax)
{
  GtkWidget *vbox, *frame, *label, *table, *table1, *align;
  GtkWidget *cost_combo;
  GtkWidget *auto_moves_check;
  GtkWidget *auto_temp_check;
  GtkWidget *auto_cycles_check;
  GtkWidget *start_temp_spin;
  GtkWidget *hbox_res;
  GtkWidget *spinres;
  GtkWidget *nrefl;
  GtkWidget *thmax;
  GtkWidget *Nmoves_spin;
  GtkWidget *Ncycles_spin;
  GtkWidget *Nrun_spin;
  GtkWidget *ran_seed_spin;
  GtkWidget *cool_rate_spin;
  GtkWidget *sa_frame;
  GtkWidget *frame_cycles;
  GtkWidget *randomize_button;
#if 0
#ifdef SIR_PGM
  static const char *cftypes[] = {"R structure factor",
                                  "R intensities"};
#else
  static const char *cftypes[] = {"R weighted profile",
                            "R intensities"};
//corr                            "R Bragg structure factor",
//corr                            "R structure factor on single and double ref."};
#endif
#endif

  vbox = vbox_new (FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 8);

  frame = NEW_FRAME("General conditions");
  gtk_widget_show(frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 10);
  align = get_widget(frame, "align");
#ifdef IN_GTK3
  gtk_widget_set_vexpand(align, FALSE);
#else
  gtk_alignment_set(GTK_ALIGNMENT(align), 0.5, 0, 1, 0);
#endif
#ifdef SIR_PGM
  table1 = table_new (5, 4, FALSE);
#else
  table1 = table_new (4, 4, FALSE);
#endif
  gtk_widget_show (table1);
  table_set_col_spacings (table1, 20);
  table_set_row_spacings (table1, 10);
  gtk_container_add (GTK_CONTAINER (align), table1);

  label = LABEL_NEW ("Cost function: ", MyBLUE);
  gtk_widget_show (label);
  set_alignment(label, 0, 0.5);
  table_attach_exp (table1, label, 0, 1, 0, 1);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
  align = gtk_alignment_new (0.,0.5,0.,0.);
#endif
  gtk_widget_show (align);
  if(ifLigand)
  {
     cost_combo = LABEL_NEW("Variance", NULL);
     gtk_container_add(GTK_CONTAINER(align), cost_combo);
  }
  else
  {
     char **cftypes = g_new0(char *, szcfvect);
     for (int i=0; i<szcfvect; i++)
         cftypes[i] = g_strdup(strCosts[cfvect[i]-1]);
     cost_combo = create_combo (align, (const char **)cftypes, szcfvect, 1, &cftype,NULL, false);
     //cost_combo = create_combo (align, cftypes, sizeof(cftypes)/sizeof(cftypes[0]), 1, &cftype,NULL, false);
  }
  gtk_widget_show (cost_combo);
  table_attach_exp (table1, align, 1, 3, 0, 1);

  label = LABEL_NEW("Resolution: ", MyBLUE);
  gtk_widget_show (label);
  set_alignment(label, 0, 0.5);
  table_attach_exp (table1, label, 0, 1, 1, 2);

  hbox_res = hbox_new (FALSE, 0);
  gtk_widget_show (hbox_res);
  table_attach_exp (table1, hbox_res, 1, 4, 1, 2);
//#ifdef SIR_PGM
  if(resmin >resmax)
  {
      gtkext::dlg_errmsg(GTK_WINDOW(sa_dlg), "Warning: resmin > remax.");
      resmin = 0.00001;
      resmax = 4; 
  }
#ifdef SIR_PGM
  spinres = SPIN_NEW(resmin, resmax, resmin+0.00001, 0.01, 3);
#else
  spinres = SPIN_NEW(resmin, resmax, resmin+0.00001, 0.001, 3);
#endif
  gtk_widget_show (spinres);
  gtk_widget_set_size_request(spinres, 80, -1);
  gtk_box_pack_start (GTK_BOX (hbox_res), spinres, FALSE, FALSE, 0);

  nrefl = LABEL_NEW("N. of reflections: ", MyRED);
  gtk_widget_show (nrefl);
  set_alignment (nrefl, 0, 0.5);
  gtk_box_pack_start (GTK_BOX (hbox_res), nrefl, FALSE, FALSE, 8);

  thmax = LABEL_NEW ("2thmax: ", MyRED);
#ifndef SIR_PGM
  gtk_widget_show (thmax);
#endif
  set_alignment (thmax, 0, 0.5);
  gtk_box_pack_start (GTK_BOX (hbox_res), thmax, FALSE, FALSE, 8);

  label = LABEL_NEW ("Random seed: ", MyBLUE);
  gtk_widget_show (label);
  set_alignment(label, 0, 0.5);
  table_attach_exp (table1, label, 0, 1, 2, 3);

  ran_seed_spin = SPIN_NEW (0, 10000, 0, 1, 0);
  gtk_widget_show (ran_seed_spin);
  set_width_chars(GTK_ENTRY(ran_seed_spin), 5);
  table_attach_exp (table1, ran_seed_spin, 1, 2, 2, 3);

  label = LABEL_NEW ("Nr. of runs: ", MyBLUE);
  gtk_widget_show (label);
  set_alignment(label, 0, 0.5);
  table_attach_exp (table1, label, 0, 1, 3, 4);

  Nrun_spin = SPIN_NEW (1, 100, 9, 1, 0);
  gtk_widget_show (Nrun_spin);
  set_width_chars(GTK_ENTRY(Nrun_spin), 5);
  table_attach_exp (table1, Nrun_spin, 1, 2, 3, 4);

  sa_frame = NEW_FRAME ("Simulated annealing options");
  gtk_widget_show (sa_frame);
  gtk_box_pack_start (GTK_BOX (vbox), sa_frame, TRUE, TRUE, 10);
#ifdef IN_GTK3
  gtk_widget_set_vexpand(get_widget(sa_frame, "align"), FALSE);
#else
  gtk_alignment_set(GTK_ALIGNMENT(get_widget(sa_frame, "align")), 0.5, 0, 1, 0);
#endif

  table = table_new (3, 3, FALSE);
  gtk_container_add (GTK_CONTAINER (get_widget(sa_frame, "align")), table);
  table_set_col_spacings (table, 10);
  table_set_row_spacings (table, 10);

  label = LABEL_NEW ("Starting temperature: ", MyBLUE);
  set_alignment(label, 0, 0.5);
  table_attach_exp(table, label, 0, 1, 0, 1);

  auto_temp_check = gtk_check_button_new_with_mnemonic (("automatic"));
  table_attach_all(table, auto_temp_check, 2, 3, 0, 1);
  gtk_container_set_border_width (GTK_CONTAINER (auto_temp_check), 0);

  start_temp_spin = SPIN_NEW(0.001, 100000, 0.001, 0.001, 3);
  set_width_chars(GTK_ENTRY(start_temp_spin), 8);
  table_attach_exp(table, start_temp_spin, 1, 2, 0, 1);

  label = LABEL_NEW ("Number of moves: ", MyBLUE);
  set_alignment(label, 0, 0.5);
  table_attach_exp(table, label, 0, 1, 1, 2);

  auto_moves_check = gtk_check_button_new_with_mnemonic (("automatic"));
  table_attach_all(table, auto_moves_check, 2, 3, 1, 2);
  gtk_container_set_border_width (GTK_CONTAINER (auto_moves_check), 0);

  Nmoves_spin = SPIN_NEW(1, 10000, 1, 1, 0);
  set_width_chars(GTK_ENTRY(Nmoves_spin), 5);
  table_attach_exp(table, Nmoves_spin, 1, 2, 1, 2);

  label = LABEL_NEW ("Temperature reduction factor: ", MyBLUE);
  gtk_widget_show (label);
  set_alignment(label, 0, 0.5);
  table_attach_exp(table, label, 0, 1, 2, 3);

  cool_rate_spin = SPIN_NEW(0.001, 1., 0.90, 0.001, 3);
  gtk_widget_show (cool_rate_spin);
  set_width_chars(GTK_ENTRY(cool_rate_spin), 5);
  table_attach_exp(table, cool_rate_spin, 1, 2, 2, 3);

  frame_cycles = NEW_FRAME ("Global optimization conditions");
  gtk_widget_show (frame_cycles);
  gtk_box_pack_start (GTK_BOX (vbox), frame_cycles, TRUE, TRUE, 10);

#ifdef IN_GTK3
  gtk_widget_set_vexpand(get_widget(frame_cycles, "align"), FALSE);
#else
  gtk_alignment_set(GTK_ALIGNMENT(get_widget(frame_cycles, "align")), 0.5, 0, 1, 0);
#endif
  table = table_new (2, 3, FALSE);
  gtk_container_add (GTK_CONTAINER (get_widget(frame_cycles, "align")), table);
  table_set_col_spacings (table, 20);
  table_set_row_spacings (table, 10);

  label = LABEL_NEW ("Number of cycles: ", MyBLUE);
  set_alignment(label, 0, 0.5);
  table_attach_exp(table, label, 0, 1, 0, 1);

  auto_cycles_check = gtk_check_button_new_with_mnemonic (("automatic"));
  gtk_widget_show_all(auto_cycles_check);
  gtk_container_set_border_width (GTK_CONTAINER (auto_cycles_check), 0);
  table_attach_all(table, auto_cycles_check, 2, 3, 0, 1);

  Ncycles_spin = SPIN_NEW(1, 5000, 1, 1, 0);
  table_attach_exp(table, Ncycles_spin, 1, 2, 0, 1);
  set_width_chars(GTK_ENTRY(Ncycles_spin), 5);

  label = LABEL_BOLD("Stop when R% is less than: ", MyBLUE, 1);
  GtkWidget *spin_soglia = SPIN_NEW(1, 50, 25, 1, 0);
  set_width_chars(GTK_ENTRY(spin_soglia), 5);
#if 0
#ifdef SIR_PGM
  gtk_widget_show(label);
  gtk_widget_show(spin_soglia);
  spin_button_set_numeric (spin_soglia, TRUE);
  spin_button_set_update_policy( spin_soglia, GTK_UPDATE_IF_VALID);
  table = table_new(1, 2, FALSE);
  gtk_widget_show(table);
  gtk_box_pack_start (GTK_BOX (vbox), table, FALSE, FALSE, 10);
  table_attach_exp(table, label, 0, 1, 0, 1); //1, 2);
  table_attach_exp(table, spin_soglia, 1, 2, 0, 1); //1, 2);
#endif
#endif

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_START, 0, 0);
#else
  align = gtk_alignment_new(0, 0, 0, 0);
#endif
  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (vbox), align, FALSE, FALSE, 10);
  randomize_button = gtk_button_new_with_label ("Randomize parameters");
  gtk_container_add (GTK_CONTAINER(align), randomize_button);
  gtk_widget_show (randomize_button);
  HOOKUP_OBJECT (sa_dlg, vbox, "vbos_SAconditions");
  HOOKUP_OBJECT (sa_dlg, cost_combo, "cost_combo");
  HOOKUP_OBJECT (sa_dlg, auto_temp_check, "auto_temp_check");
  HOOKUP_OBJECT (sa_dlg, start_temp_spin, "start_temp_spin");
  HOOKUP_OBJECT (sa_dlg, hbox_res, "hbox_res");
  HOOKUP_OBJECT (sa_dlg, spinres, "spinres");
  HOOKUP_OBJECT (sa_dlg, label, "labelsoglia");
  HOOKUP_OBJECT (sa_dlg, spin_soglia, "Rsoglia");
  HOOKUP_OBJECT (sa_dlg, nrefl, "nrefl");
  HOOKUP_OBJECT (sa_dlg, thmax, "thmax");
  HOOKUP_OBJECT (sa_dlg, auto_moves_check, "auto_moves_check");
  HOOKUP_OBJECT (sa_dlg, Nmoves_spin, "Nmoves_spin");
  HOOKUP_OBJECT (sa_dlg, Nrun_spin, "Nrun_spin");
  HOOKUP_OBJECT (sa_dlg, ran_seed_spin, "ran_seed_spin");
  HOOKUP_OBJECT (sa_dlg, cool_rate_spin, "cool_rate_spin");
  HOOKUP_OBJECT (sa_dlg, sa_frame, "sa_frame");
  HOOKUP_OBJECT (sa_dlg, frame_cycles, "frame_cycles");
  HOOKUP_OBJECT (sa_dlg, auto_cycles_check, "auto_cycles_check");
  HOOKUP_OBJECT (sa_dlg, Ncycles_spin, "Ncycles_spin");

  g_signal_connect(G_OBJECT(auto_temp_check), "toggled", G_CALLBACK(on_cb_disattiva),
                   start_temp_spin);
  g_signal_connect(G_OBJECT(auto_moves_check), "toggled", G_CALLBACK(on_cb_disattiva),
                   Nmoves_spin);
  g_signal_connect(G_OBJECT(auto_cycles_check), "toggled", G_CALLBACK(on_cb_disattiva),
                   Ncycles_spin);
  g_signal_connect(G_OBJECT(spinres), "value-changed", G_CALLBACK(on_resol_changed), sa_dlg);
  g_signal_connect(G_OBJECT(randomize_button), "clicked", G_CALLBACK(on_randomize_clicked), sa_dlg);

  return vbox;
}

void sel_fragment(GtkWidget *combo, GtkWidget *dlg)
{
     get_comboselection(combo, &nfrag);
     GtkWidget *widget = get_widget(dlg, "label_frame");
     if(nfrag)
     {
        int n, indice, i, check;
        gtk_label_set_text(GTK_LABEL(widget), 
          g_strdup_printf("Parameters for fragment n. %d", nfrag));
        n = fragment[nfrag-1].nat;
        widget = get_widget(dlg, "l_atoms");
        clear_text(widget);
        for(i=0; i<n; i++)
        {
            char *lab = g_new0(char, 17);
            indice = fragment[nfrag-1].pos[i] - 1;
            CopiaStringa(lab, 17, atm[indice].lab);
            add_text(widget, g_strdup_printf("%s ", g_strstrip(lab)));
            g_free(lab);
        }
        for(i=0; i<3; i++)
        {
            check = fragment[nfrag-1].rcod[i];
            widget = get_widget(dlg, g_strdup_printf("check_trans%d", i));
            gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), check);
            widget = get_widget(dlg, g_strdup_printf("lower_tr%d", i));
            spin_button_set_value(widget, fragment[nfrag-1].tlow[i]);
            widget = get_widget(dlg, g_strdup_printf("upper_tr%d", i));
            spin_button_set_value(widget, fragment[nfrag-1].thigh[i]);
        }
        check = fragment[nfrag-1].rcod[3] + fragment[nfrag-1].rcod[4] + fragment[nfrag-1].rcod[5];
        widget = get_widget(dlg, "check_rot");
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), check);
        widget = get_widget(dlg, "lower_rot");
        spin_button_set_value(widget, fragment[nfrag-1].rbound[0]);
        widget = get_widget(dlg, "upper_rot");
        spin_button_set_value(widget, fragment[nfrag-1].rbound[1]);
        widget = get_widget(dlg, "check_rot");
        gtk_widget_set_sensitive(widget, (n > 1));
        widget = get_widget(dlg, "lower_rot");
        gtk_widget_set_sensitive(widget, (n > 1));
        widget = get_widget(dlg, "upper_rot");
        gtk_widget_set_sensitive(widget, (n > 1));
        check = fragment[nfrag-1].rat;
        if(check > 0)
        {
           widget = get_widget(dlg, "rat");
           gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
           widget = get_widget(dlg, "ratb");
           std::string s(atm[check-1].lab, 15);
           gtk_button_set_label(GTK_BUTTON(widget), s.c_str());
        }
        else
        {
           widget = get_widget(dlg, "rat0");
           gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
           widget = get_widget(dlg, "ratb");
           std::string s(atm[fragment[nfrag-1].pos[0]-1].lab, 15);
           gtk_button_set_label(GTK_BUTTON(widget), s.c_str());
        }
        widget = get_widget(dlg, "frame_centre");
        gtk_widget_set_sensitive(widget, (n > 1));
     }
}

static void tog_trans(GtkToggleButton *button, gpointer quale)
{
    int j;

    j = GPOINTER_TO_INT(quale);
    fragment[nfrag-1].rcod[j] = gtk_toggle_button_get_active(button);
    csa_conta_parametri(ginfo);
}

static void tog_rot(GtkToggleButton *button, GtkWidget *dlg)
{
    int j;

    for(j=3; j<6; j++)
        fragment[nfrag-1].rcod[j] = gtk_toggle_button_get_active(button);
    csa_conta_parametri(ginfo);
}

void on_limit_changed (GtkWidget *button, gpointer data)
{
    int quale = GPOINTER_TO_INT(data);
    int which = quale % 10;
    int j = quale / 10;

    switch(which)
    {
    case 1:
         fragment[nfrag-1].tlow[j] = (float) spin_button_get_value(button);
         if(fragment[nfrag-1].tlow[j] > fragment[nfrag-1].thigh[j])
         {
            fragment[nfrag-1].tlow[j] = fragment[nfrag-1].thigh[j];
            set_spin_value(button, fragment[nfrag-1].tlow[j]);
         }
         break;
    case 2:
         fragment[nfrag-1].thigh[j] = (float) spin_button_get_value(button);
         if(fragment[nfrag-1].tlow[j] > fragment[nfrag-1].thigh[j])
         {
            fragment[nfrag-1].thigh[j] = fragment[nfrag-1].tlow[j];
            set_spin_value(button, fragment[nfrag-1].thigh[j]);
         }
         break;
    case 3:
         fragment[nfrag-1].rbound[0] = (float) spin_button_get_value(button);
         if(fragment[nfrag-1].rbound[0] > fragment[nfrag-1].rbound[1])
         {
            fragment[nfrag-1].rbound[0] = fragment[nfrag-1].rbound[1];
            set_spin_value(button, fragment[nfrag-1].rbound[0]);
         }
         break;
    case 4:
         fragment[nfrag-1].rbound[1] = (float) spin_button_get_value(button);
         if(fragment[nfrag-1].rbound[0] > fragment[nfrag-1].rbound[1])
         {
            fragment[nfrag-1].rbound[1] = fragment[nfrag-1].rbound[0];
            set_spin_value(button, fragment[nfrag-1].rbound[1]);
         }
         break;
    }
}

static int scegli_atomo(GtkWidget *sa_dlg, atom_type *atm, int nats, int sel)
{
     GtkWidget *dlg = gtk_dialog_new();
     gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(sa_dlg));
     gtk_window_set_title(GTK_WINDOW(dlg), "Set centre of rotation");

     GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
     char riga[16];
     int lar, alt;

     PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
     get_metrics(fontlist, &lar, &alt);

     GtkWidget *list = createSelection(dlg, vbox, "Atoms", "listaAtomi", 0, MyBLUE);
     for(int i=0; i<nats; i++)
     {
         CopiaStringan(riga, sizeof(riga), atm[i].lab, 15);
         riga[15] = '\0';
         add_line_to_list(list, (gpointer) riga, 0);
     }
     widget_modify_font(list, fontlist);
     select_row(list, sel-1, false);
     gtk_widget_set_size_request(get_widget(list, "scrollwin"),
          -1, (int) MRmin(1.7f*(nats+1)*alt, 20*alt));


     GtkWidget *ok_button = OK_button();
     gtk_dialog_add_action_widget(GTK_DIALOG(dlg), ok_button, GTK_RESPONSE_OK);
      
     GtkWidget *cancel_button = CANCEL_button();
     gtk_dialog_add_action_widget(GTK_DIALOG(dlg), cancel_button, GTK_RESPONSE_CANCEL);
     gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(ok_button)),
          GTK_BUTTONBOX_SPREAD);

     gtk_widget_show_all(vbox);
     int result = gtk_dialog_run(GTK_DIALOG(dlg));
     if(result == GTK_RESPONSE_OK)
        result = row_selected(gtk_tree_view_get_selection(GTK_TREE_VIEW(list))) + 1;
     else
        result = 0;
     gtk_widget_destroy(dlg);
     return result;
}

void on_select_cr(GtkButton *but, GtkWidget *dlg)
{

     int v0 = fragment[nfrag-1].rat?
             fragment[nfrag-1].rat : fragment[nfrag-1].pos[0];
     int result = scegli_atomo(dlg, atm, nats, v0);
     if(result)
        fragment[nfrag-1].rat = result;
     else
        fragment[nfrag-1].rat = v0;
     std::string s(atm[fragment[nfrag-1].rat-1].lab, 15);
     gtk_button_set_label(GTK_BUTTON(but), s.c_str());
}

GtkWidget *page_extDOF(GtkWidget *sa_dlg)
{
  GtkWidget *vbox, *frame, *label, *hbox, *table, *align;
  GtkWidget *combo_frags;
  GtkWidget *l_atoms;
  GtkWidget *label_frame;
  GtkWidget *check_trans[3];
  GtkWidget *check_rot;
  GtkWidget *lower_tr[3];
  GtkWidget *upper_tr[3];
  GtkWidget *lower_rot;
  GtkWidget *upper_rot;
  int i, hnd;
  GList *glist = NULL;
  const char *labels[] = {"X Traslation", "Y Traslation", "Z Traslation"};

  vbox = vbox_new (FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 6);

  hbox = hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);

  frame = NEW_FRAME ("Select fragment");
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox), frame, FALSE, FALSE, 0);

  for(i=1; i<=numfrags; i++)
      glist = g_list_append(glist, g_strdup_printf("Fragment n. %d", i));

  align = get_widget(frame, "align");
#ifdef IN_GTK3
  gtk_widget_set_vexpand(align, FALSE);
  gtk_widget_set_hexpand(align, FALSE);
  g_object_set(G_OBJECT(align), "valign", GTK_ALIGN_CENTER, NULL);
#else
  gtk_alignment_set (GTK_ALIGNMENT(align), 0.5,0,0,0);
#endif

  combo_frags = create_my_combog(glist, 1, G_CALLBACK(sel_fragment), sa_dlg);
  gtk_widget_show (combo_frags);
  gtk_container_add (GTK_CONTAINER (align), combo_frags);
  g_list_free (glist);

  frame = NEW_FRAME ("Atoms");
  gtk_widget_show (frame);
  gtk_box_pack_end (GTK_BOX (hbox), frame, TRUE, TRUE, 3);
  align = get_widget(frame, "align");

  l_atoms = scrolled_text (align);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (l_atoms), FALSE);
  gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW (l_atoms), GTK_WRAP_WORD);
#ifndef IN_GTK3
  static GdkColor colorWhite = White;
  widget_modify_bg(l_atoms, GTK_STATE_NORMAL, &colorWhite);
#endif
  gtk_widget_show (l_atoms);

  frame = NEW_FRAME ("Parameters for fragment n. ");
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 10);
  label_frame = gtk_frame_get_label_widget(GTK_FRAME(frame));
  align = get_widget(frame, "align");
  
  GtkWidget *vbox2 = vbox_new(FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (align), vbox2);

  table = table_new (5, 4, FALSE);
  gtk_widget_show (table);
  //gtk_container_add (GTK_CONTAINER (align), table);
  gtk_box_pack_start (GTK_BOX (vbox2), table, TRUE, TRUE, 10);
  gtk_container_set_border_width (GTK_CONTAINER (table), 10);
  table_set_row_spacings (table, 10);
  table_set_col_spacings (table, 10);

  label = gtk_label_new (("Refine"));
  gtk_widget_show (label);
  table_attach (table, label, 1, 2, 0, 1);

  label = gtk_label_new (("Lower"));
  gtk_widget_show (label);
  table_attach (table, label, 2, 3, 0, 1);

  label = gtk_label_new (("Upper"));
  gtk_widget_show (label);
  table_attach (table, label, 3, 4, 0, 1);

  for(i=1; i<=3; i++)
  {
      label = gtk_label_new (labels[i-1]);
      gtk_widget_show (label);
      table_attach_exp (table, label, 0, 1, i, i+1);
      set_alignment(label, 0, 0.5);

      check_trans[i-1] = gtk_check_button_new();
      gtk_widget_show (check_trans[i-1]);
      table_attach (table, check_trans[i-1], 1, 2, i, i+1);

      lower_tr[i-1] = SPIN_NEW(0, 1, 0, 0.001, 3);
      gtk_widget_show (lower_tr[i-1]);
      table_attach (table, lower_tr[i-1], 2, 3, i, i+1);

      upper_tr[i-1] = SPIN_NEW(0, 1, 0, 0.001, 3);
      gtk_widget_show (upper_tr[i-1]);
      table_attach (table, upper_tr[i-1], 3, 4, i, i+1);
  }

  label = gtk_label_new (("Rotation"));
  gtk_widget_show (label);
  table_attach_exp (table, label, 0, 1, 4, 5);
  set_alignment(label, 0, 0.5);

  check_rot = gtk_check_button_new();
  gtk_widget_show (check_rot);
  table_attach (table, check_rot, 1, 2, 4, 5);

  lower_rot = SPIN_NEW(0, 1, 0, 0.001, 3);
  gtk_widget_show (lower_rot);
  table_attach (table, lower_rot, 2, 3, 4, 5);

  upper_rot = SPIN_NEW(0, 1, 0, 0.001, 3);
  gtk_widget_show (upper_rot);
  table_attach (table, upper_rot, 3, 4, 4, 5);

  frame = NEW_FRAME ("Centre of rotation");
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox2), frame, TRUE, TRUE, 10);
  align = get_widget(frame, "align");
  g_object_set_data (G_OBJECT (sa_dlg), "frame_centre", frame);
 
  hbox = hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  add_to_frame(frame, hbox);

  GtkWidget *ratb = gtk_button_new();
  gtk_widget_show(ratb);
  g_object_set_data (G_OBJECT (sa_dlg), "ratb", ratb);
  hnd = g_signal_connect (ratb, "clicked",
                    G_CALLBACK (on_select_cr), sa_dlg);
  gtk_widget_set_sensitive(ratb, FALSE);

  GSList *group = NULL;
  GtkWidget *radio = gtk_radio_button_new_with_label (group, "Centre of mass");
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
  gtk_widget_show(radio);
//  hnd = g_signal_connect (radio, "toggled",
//                    G_CALLBACK (on_select_cr), GINT_TO_POINTER(0));
//  g_object_set_data (G_OBJECT (radio), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data (G_OBJECT (sa_dlg), "rat0", radio);
  radio = gtk_radio_button_new_with_label (group, "Atom");
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 5);
  gtk_widget_show(radio);
//  hnd = g_signal_connect (radio, "toggled",
//                    G_CALLBACK (on_select_cr), GINT_TO_POINTER(1));
//  g_object_set_data (G_OBJECT (radio), "hnd", GINT_TO_POINTER(hnd));
  g_object_set_data (G_OBJECT (sa_dlg), "rat", radio);
  gtk_box_pack_start (GTK_BOX (hbox), ratb, FALSE, FALSE, 0);
  g_signal_connect (radio, "toggled",
                    G_CALLBACK (on_cb_attiva), ratb);

  HOOKUP_OBJECT (sa_dlg, combo_frags, "combo_frags");
  HOOKUP_OBJECT (sa_dlg, l_atoms, "l_atoms");
  HOOKUP_OBJECT (sa_dlg, label_frame, "label_frame");
  HOOKUP_OBJECT (sa_dlg, check_rot, "check_rot");
  HOOKUP_OBJECT (sa_dlg, lower_rot, "lower_rot");
  HOOKUP_OBJECT (sa_dlg, upper_rot, "upper_rot");
  for(i=0; i<3; i++)
  {
      HOOKUP_OBJECT (sa_dlg, check_trans[i], g_strdup_printf("check_trans%d", i));
      HOOKUP_OBJECT (sa_dlg, lower_tr[i], g_strdup_printf("lower_tr%d", i));
      HOOKUP_OBJECT (sa_dlg, upper_tr[i], g_strdup_printf("upper_tr%d", i));
      g_signal_connect(G_OBJECT(check_trans[i]), "toggled", G_CALLBACK(tog_trans), GINT_TO_POINTER(i));
      hnd = g_signal_connect(G_OBJECT(lower_tr[i]), "value-changed", 
            G_CALLBACK(on_limit_changed), GINT_TO_POINTER(10*i+1));
      g_object_set_data(G_OBJECT(lower_tr[i]), "hnd", GINT_TO_POINTER(hnd));
      hnd = g_signal_connect(G_OBJECT(upper_tr[i]), "value-changed", 
            G_CALLBACK(on_limit_changed), GINT_TO_POINTER(10*i+2));
      g_object_set_data(G_OBJECT(upper_tr[i]), "hnd", GINT_TO_POINTER(hnd));
  }

  g_signal_connect(G_OBJECT(check_rot), "toggled", G_CALLBACK(tog_rot), sa_dlg);
  hnd = g_signal_connect(G_OBJECT(lower_rot), "value-changed", G_CALLBACK(on_limit_changed), GINT_TO_POINTER(3));
  g_object_set_data(G_OBJECT(lower_rot), "hnd", GINT_TO_POINTER(hnd));
  hnd = g_signal_connect(G_OBJECT(upper_rot), "value-changed", G_CALLBACK(on_limit_changed), GINT_TO_POINTER(4));
  g_object_set_data(G_OBJECT(upper_rot), "hnd", GINT_TO_POINTER(hnd));
  return vbox;
}

void on_sa_changed(GtkWidget *spin, gpointer data)
{
   shiftatomval = (float) spin_button_get_value(spin);
}

// VECCHIA GESTIONE
#if 0
void fill_atoms_list(GtkWidget *window1)
{
  GtkWidget *entry;
  GtkWidget *checkbutton;
  char val[20];
  char string[15];
  int i,j,check1, check2;
  int numpar=4;

  for(i=0; i<numpar; i++)
  {
      for (j=0;j<nats;j++)
      {
          if(i < 3)
             ScriviStringa(val,sizeof(val), "%-12.6f",atm[j].xc[i]);
          else if(i == 3)
             ScriviStringa(val,sizeof(val), "%-12.6f",atm[j].biso);
          else
             ScriviStringa(val,sizeof(val), "%-12.6f",atm[j].och);
          ScriviStringa(string,sizeof(string), "entrystru%d%d",j,i);
          entry = get_widget(window1,string);
          gtk_entry_set_text(GTK_ENTRY(entry), val);
      }
  }
  for(j=0;j<nats;j++)
  {
//      check1 = shift_rcod[j][0] + shift_rcod[j][1] + shift_rcod[j][2];
      check1 = shift_atom[j];
      check2 = atm_rcod[j][3];
      for(i=0; i<numpar; i++)
      {
          if(i >= 3)
          {
             ScriviStringa(string,sizeof(string), "checkstru%d%d",j,i);
             checkbutton = get_widget(window1,string);
             gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), check2);
          }
          else
          {
             ScriviStringa(string,sizeof(string), "checkstru%d2",j);
             checkbutton = get_widget(window1,string);
             gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), check1);
          }
      }
  }
}

void on_refine_single(GtkToggleButton *button, gpointer data)
{
   _cbdata *cf = (_cbdata *) data;
   int katom = cf->katom;
   int kpar  = cf->kpar;
   gboolean torefine = gtk_toggle_button_get_active(button);
   if(kpar == 2)
     shift_atom[katom] = shift_rcod[katom][0] = shift_rcod[katom][1] = shift_rcod[katom][2] = torefine;
   else
     atm_rcod[katom][3] = torefine;
   (void) csa_conta_parametri(ginfo);
}

void global_label_toggle(GtkWidget *widget, gpointer data)
{
   GtkWidget *button, *dlg = gtk_widget_get_toplevel(GTK_WIDGET(widget));
   char stringa[15];
   int atompos;
   int i;

   atompos = GPOINTER_TO_INT(data);

   for(i = 0; i<4; i++)
   {
       if(i >= 3)
          ScriviStringa(stringa,sizeof(stringa), "checkstru%d%d", atompos,i);
       else
          ScriviStringa(stringa,sizeof(stringa), "checkstru%d2", atompos);
       button = get_widget(dlg, stringa);
       if(gtk_widget_get_sensitive(button))
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button),
               gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
   }
}

void global_par_toggle(GtkWidget *widget, gpointer data)
{
   GtkWidget *button, *dlg = gtk_widget_get_toplevel(GTK_WIDGET(widget));

   char stringa[15];
   int parpos;
   int i;

   parpos = GPOINTER_TO_INT(data);

   for(i = 0; i<nats; i++)
   {
       ScriviStringa(stringa,sizeof(stringa), "checkstru%d%d", i,parpos);
       button = get_widget(dlg, stringa);
       if(gtk_widget_get_sensitive(button))
           gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button),
                 gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
   }
}

GtkWidget *label_boxed2 (const gchar  *string)
{
    GtkWidget *frame, *label;

    frame = gtk_frame_new (NULL);
    gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_OUT);
    label = LABEL_NEW(string, NULL);
    set_alignment(label, 0.5, 0.5);
    gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_CENTER);
    set_margins (label, 3, 3, 4, 4);
    gtk_container_add (GTK_CONTAINER (frame), label);
    gtk_widget_show (label);
    gtk_widget_show (frame);
    return frame;
}

void atomic_parameters (GtkWidget *window1, GtkWidget *father)
{
  GtkWidget *scrolled_window;
  GtkWidget *hbox1;
  GtkWidget *table1;
  GtkWidget *entry;
  GtkWidget *buttonlabel;
  GtkWidget *buttonpar;
  GtkWidget *checkbutton;

  char string[15], label_at[16];
  int hnd,i,j,k=1,npar=4;

  hbox1 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (father), hbox1);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 5);

  scrolled_window = gtk_scrolled_window_new(NULL,NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (scrolled_window),
                                 GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_box_pack_start (GTK_BOX (hbox1), scrolled_window, TRUE, TRUE, 0);
  gtk_widget_show(scrolled_window);

  table1 = table_new (nats, 12, FALSE);
  gtk_widget_show (table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
  table_set_row_spacings (table1, 4);
  table_set_col_spacings (table1, 4);
  add_to_scrollwin (scrolled_window, table1);
//
//   Scrivi le labels degli atomi sulla prima colonna
//
  for (i=0;i<nats;i++)
  {
    CopiaStringan(label_at, sizeof(label_at), atm[i].lab, 15);
    label_at[15] = '\0';
    buttonlabel = TOGGLE_BUTTON_WITH_LABEL (label_at, MyBLUE);
    gtk_widget_show (buttonlabel);
    ScriviStringa(string,sizeof(string), "buttonlabel%d",i);
    g_object_set_data(G_OBJECT (window1),string, buttonlabel);
    table_attach_all (table1, buttonlabel, 0, 1, i+1, i+2);
    gtk_widget_set_size_request(buttonlabel, 50, 24);

    g_signal_connect (G_OBJECT(buttonlabel), "clicked", 
            G_CALLBACK(global_label_toggle), GINT_TO_POINTER(i));
  }
  
   buttonpar = label_boxed2 ("Atom");
   gtk_widget_show (buttonpar);
   table_attach_all (table1, buttonpar, 0, 1, 0, 1);
//
//--Scrivi il tipo di parametro (x,y,z,B,occ.) sulla prima riga
//
   k = 7;
   buttonpar = TOGGLE_BUTTON_WITH_LABEL ("x       y       z", MyBLUE);
   gtk_widget_show (buttonpar);
   table_attach(table1, buttonpar, 1, k, 0, 1, 1);
   g_object_set_data(G_OBJECT (window1),"buttonpar0", buttonpar);
   g_signal_connect (G_OBJECT(buttonpar), "clicked", 
              G_CALLBACK(global_par_toggle), GINT_TO_POINTER(2));

   for (i=3;i<npar;i++)
   {
       buttonpar = TOGGLE_BUTTON_WITH_LABEL (parametri[i], MyBLUE);
       gtk_widget_show (buttonpar);
       table_attach(table1, buttonpar, k, k+2, 0, 1, 1);
       ScriviStringa(string,sizeof(string), "buttonpar%d",i-2);
       g_object_set_data(G_OBJECT (window1),string, buttonpar);
       g_signal_connect (G_OBJECT(buttonpar), "clicked", 
              G_CALLBACK(global_par_toggle), GINT_TO_POINTER(i));
       k += 2;
   }
   k = 1;

  for (i=0;i<npar;i++)
  {
//
//--Inserisci un entry ed un checkbutton per ogni parametro sulle righe successive
//
    for (j=0;j<nats;j++)
    {
     _cbdata *cb_data = g_new0(_cbdata, 1);
//
//---Inserisci entry 
//
     entry = gtk_entry_new ();
     ScriviStringa(string,sizeof(string),"entrystru%d%d",j,i);
     g_object_set_data(G_OBJECT (window1),string, entry);
     gtk_widget_show (entry);
     if(i >= 2)
        table_attach (table1, entry, k, k+1, j+1, j+2);
     else
        table_attach (table1, entry, k, k+2, j+1, j+2);
     set_width_chars(GTK_ENTRY(entry), 10);
//
//---Inserisci checkbutton 
//
     if(i >= 2)
     {
        checkbutton = gtk_check_button_new();
        ScriviStringa(string,sizeof(string),"checkstru%d%d",j,i);
        g_object_set_data(G_OBJECT (window1),string, checkbutton);
        table_attach (table1, checkbutton, k+1, k+2, j+1, j+2);
        cb_data->katom = j;
        cb_data->kpar  = i;
        hnd = g_signal_connect(G_OBJECT(checkbutton),"toggled",G_CALLBACK(on_refine_single),(gpointer) cb_data);
        g_object_set_data(G_OBJECT (checkbutton),"hnd", GINT_TO_POINTER(hnd));
        gtk_widget_show (checkbutton);
     }
    }
    k = k + 2;
  }
}
#endif

//NEW 23 04 2014

static void occ_edited (GtkCellRendererText *cell,
             const gchar         *path_string,
             const gchar         *new_text,
             gpointer             data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
  GtkTreeIter iter;

  gtk_tree_model_get_iter (model, &iter, path);
  gint i;
  int column = 1;
  gchar *old_text;

  gtk_tree_model_get (model, &iter, column, &old_text, -1);
  g_free (old_text);

  i = gtk_tree_path_get_indices (path)[0];
  atm[i].och = (float) atof(new_text);
  gtk_list_store_set (GTK_LIST_STORE (model), &iter, column,
                 fToStr(atm[i].och, 5).c_str(), -1);
}

static void biso_edited (GtkCellRendererText *cell,
             const gchar         *path_string,
             const gchar         *new_text,
             gpointer             data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
  GtkTreeIter iter;

  gtk_tree_model_get_iter (model, &iter, path);
  gint i;
  int column = 2;
  gchar *old_text;

  gtk_tree_model_get (model, &iter, column, &old_text, -1);
  g_free (old_text);

  i = gtk_tree_path_get_indices (path)[0];
  atm[i].biso = (float) atof(new_text);
  gtk_list_store_set (GTK_LIST_STORE (model), &iter, column,
                 fToStr(atm[i].biso, 5).c_str(), -1);
}

gboolean check_rows(GtkTreeModel *model, int column)
{
    GtkTreeIter iter;
    gboolean fixed, result;

    result = TRUE;
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    
    while (valid)
    {
       gtk_tree_model_get (model, &iter, column, &fixed, -1);
       result = result & fixed;
       valid = gtk_tree_model_iter_next (model, &iter);
    }
    return result;
}

static void biso_activate_toggled (GtkCellRendererToggle *cell,
               gchar                 *path_str,
               gpointer               data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreeIter  iter;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  gboolean fixed;
  gint column = 3;

  gtk_tree_model_get_iter (model, &iter, path);
  gtk_tree_model_get (model, &iter, column, &fixed, -1);

  fixed ^= 1;

  int which = gtk_tree_path_get_indices (path)[0];
  gtk_list_store_set (GTK_LIST_STORE (model), &iter, column, fixed, -1);
  atm_rcod[which][3] = fixed?1:0;
  gtk_tree_path_free (path);
  (void) csa_conta_parametri(ginfo);
  gpointer w = g_object_get_data(G_OBJECT(data), "tog3");
  int hnd = get_int(data, "hndtog3");
  g_signal_handler_block(G_OBJECT(w), hnd);
  gboolean result = check_rows(model, column);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w), result);
  g_signal_handler_unblock(G_OBJECT(w), hnd);
}

static void xyz_activate_toggled (GtkCellRendererToggle *cell,
               gchar                 *path_str,
               gpointer               data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreeIter  iter;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  gboolean fixed;
  gint column = 4;

  gtk_tree_model_get_iter (model, &iter, path);
  gtk_tree_model_get (model, &iter, column, &fixed, -1);

  fixed ^= 1;

  int which = gtk_tree_path_get_indices (path)[0];
  gtk_list_store_set (GTK_LIST_STORE (model), &iter, column, fixed, -1);
  shift_atom[which] = shift_rcod[which][0] = shift_rcod[which][1] =
                  shift_rcod[which][2] = fixed?1:0;
  gtk_tree_path_free (path);
  (void) csa_conta_parametri(ginfo);
  gpointer w = g_object_get_data(G_OBJECT(data), "tog4");
  int hnd = get_int(data, "hndtog4");
  g_signal_handler_block(G_OBJECT(w), hnd);
  gboolean result = check_rows(model, column);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w), result);
  g_signal_handler_unblock(G_OBJECT(w), hnd);
}

static void doc_activate_toggled (GtkCellRendererToggle *cell,
               gchar                 *path_str,
               gpointer               data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreeIter  iter;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  gboolean fixed;
  gint column = 5;

  gtk_tree_model_get_iter (model, &iter, path);
  gtk_tree_model_get (model, &iter, column, &fixed, -1);

  fixed ^= 1;

  int which = gtk_tree_path_get_indices (path)[0];
  gtk_list_store_set (GTK_LIST_STORE (model), &iter, column, fixed, -1);
  atm_rcod[which][4] = fixed?1:0;
  atm[which].doc = atm_rcod[which][4];  // NEW
  gtk_tree_path_free (path);
  (void) csa_conta_parametri(ginfo);
  gpointer w = g_object_get_data(G_OBJECT(data), "tog5");
  int hnd = get_int(data, "hndtog5");
  g_signal_handler_block(G_OBJECT(w), hnd);
  gboolean result = check_rows(model, column);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w), result);
  g_signal_handler_unblock(G_OBJECT(w), hnd);
}


static GtkTreeModel *create_atomic_parameters_model (void)
{
  GtkListStore *model;

  model = gtk_list_store_new (6, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING,
                              G_TYPE_BOOLEAN, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN);

  return GTK_TREE_MODEL (model);
}

static void attiva_global_tog(GtkTreeViewColumn *col, gpointer toggle)
{
  gboolean val = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle));
  val ^= 1;
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle), val);
}

static void global_toggle_ap(GtkToggleButton *but, gpointer pcol)
{
  GtkWidget *list = get_widget(gtk_widget_get_toplevel(GTK_WIDGET(but)),
                       "lista_atomic_parameters");
  gint column = GPOINTER_TO_INT(pcol);

  GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
  GtkTreeIter iter;
  gboolean valid = gtk_tree_model_get_iter_first (model, &iter);

  while (valid)
  {
     gboolean val;
     val = gtk_toggle_button_get_active(but);
     gtk_list_store_set (GTK_LIST_STORE (model), &iter, column, val, -1);
     GtkTreePath *path = gtk_tree_model_get_path(model, &iter);
     int which = gtk_tree_path_get_indices (path)[0];
     if(column == 3)
        atm_rcod[which][3] = val?1:0;
     else if(column == 5)
        atm_rcod[which][4] = val?1:0;
     else
        shift_atom[which] = shift_rcod[which][0] = shift_rcod[which][1] =
                  shift_rcod[which][2] = val?1:0;
        gtk_tree_path_free (path);
     valid = gtk_tree_model_iter_next (model, &iter);
  }
  (void) csa_conta_parametri(ginfo);
}

void add_toggle_column(GtkTreeView *treeview, gint nc, const char *str, GCallback cb)
{
  GtkCellRenderer *renderer = gtk_cell_renderer_toggle_new ();
  GtkTreeModel *model = gtk_tree_view_get_model(treeview);
  g_signal_connect (renderer, "toggled", cb, model);

  gtk_tree_view_insert_column_with_attributes (treeview,
                                               -1, str, renderer,
                                               "active", nc,
                                               NULL);
  GtkTreeViewColumn *col = gtk_tree_view_get_column(treeview, nc);
  gtk_tree_view_column_set_clickable(col, TRUE);
  GtkWidget *tog = gtk_check_button_new_with_label(str);
  gtk_widget_show(tog);
  gtk_tree_view_column_set_widget(col, tog);
  int hnd = g_signal_connect(G_OBJECT(tog), "toggled",
        G_CALLBACK(global_toggle_ap), GINT_TO_POINTER(nc));
  g_object_set_data(G_OBJECT(tog), "hnd", GINT_TO_POINTER(hnd));
  g_signal_connect(G_OBJECT(col), "clicked", G_CALLBACK(attiva_global_tog),
         (gpointer) tog);
  char *tmp = g_strdup_printf("hndtog%d", nc);
  g_object_set_data(G_OBJECT(model), tmp, GINT_TO_POINTER(hnd));
  g_free(tmp);
  tmp = g_strdup_printf("tog%d", nc);
  g_object_set_data(G_OBJECT(model), tmp, (gpointer) tog);
  g_free(tmp);
}

static void add_columns_to_atomic_parameters_list (GtkTreeView *treeview,
             GtkTreeModel *model)
{
  GtkCellRenderer *renderer = gtk_cell_renderer_text_new ();
  g_object_set (renderer, "editable", FALSE, NULL);
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Atom", renderer,
                                               "text", 0,
                                               NULL);
  renderer = gtk_cell_renderer_text_new ();
  g_object_set (renderer, "editable", TRUE, NULL);
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Occ.", renderer,
                                               "text", 1,
                                               NULL);
  g_signal_connect (renderer, "edited",
                    G_CALLBACK (occ_edited), model);

  renderer = gtk_cell_renderer_text_new ();
  g_object_set (renderer, "editable", TRUE, NULL);
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "B[iso]", renderer,
                                               "text", 2,
                                               NULL);
  g_signal_connect (renderer, "edited",
                    G_CALLBACK (biso_edited), model);

  add_toggle_column(treeview, 3, "Refine B[iso]", G_CALLBACK(biso_activate_toggled));
  add_toggle_column(treeview, 4, "Shift on xyz", G_CALLBACK(xyz_activate_toggled));
  add_toggle_column(treeview, 5, "D.O.C.", G_CALLBACK(doc_activate_toggled));
#if 0
  renderer = gtk_cell_renderer_toggle_new ();
  g_signal_connect (renderer, "toggled",
                    G_CALLBACK (biso_activate_toggled), model);

  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Refine B[iso]", renderer,
                                               "active", 3,
                                               NULL);
  GtkTreeViewColumn *col = gtk_tree_view_get_column(GTK_TREE_VIEW(treeview), 3);
  gtk_tree_view_column_set_clickable(col, TRUE);
  GtkWidget *tog = gtk_check_button_new_with_label("Refine B[iso]");
  gtk_widget_show(tog);
  gtk_tree_view_column_set_widget(col, tog);
  int hnd = g_signal_connect(G_OBJECT(tog), "toggled",
        G_CALLBACK(global_toggle_ap), GINT_TO_POINTER(3));
  g_object_set_data(G_OBJECT(tog), "hnd", GINT_TO_POINTER(hnd));
  g_signal_connect(G_OBJECT(col), "clicked", G_CALLBACK(attiva_global_tog),
         (gpointer) tog);

  renderer = gtk_cell_renderer_toggle_new ();
  g_signal_connect (renderer, "toggled",
                    G_CALLBACK (xyz_activate_toggled), model);

  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Shift on xyz", renderer,
                                               "active", 4,
                                               NULL);
  col = gtk_tree_view_get_column(GTK_TREE_VIEW(treeview), 4);
  gtk_tree_view_column_set_clickable(col, TRUE);
  tog = gtk_check_button_new_with_label("Shift on xyz");
  gtk_widget_show(tog);
  gtk_tree_view_column_set_widget(col, tog);
  hnd = g_signal_connect(G_OBJECT(tog), "toggled",
        G_CALLBACK(global_toggle_ap), GINT_TO_POINTER(4));
  g_object_set_data(G_OBJECT(tog), "hnd", GINT_TO_POINTER(hnd));
  g_signal_connect(G_OBJECT(col), "clicked", G_CALLBACK(attiva_global_tog),
         (gpointer) tog);
#endif
}

GtkWidget *create_atomic_parameters_list(GtkWidget *vbox)
{
   GtkWidget *treeview, *sw;
   GtkTreeModel *model;

   sw = gtk_scrolled_window_new (NULL, NULL);
   gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (sw),
                                           GTK_SHADOW_ETCHED_IN);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw),
                                      GTK_POLICY_NEVER,
                                      GTK_POLICY_AUTOMATIC);
   gtk_container_add (GTK_CONTAINER (vbox), sw);

   model = create_atomic_parameters_model ();
   treeview = gtk_tree_view_new_with_model (model);
   //gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (treeview), FALSE);
   gtk_tree_selection_set_mode (gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview)),
                                   GTK_SELECTION_SINGLE);
   add_columns_to_atomic_parameters_list (GTK_TREE_VIEW (treeview), model);
   g_object_unref (model);
   gtk_container_add (GTK_CONTAINER (sw), treeview);

   gtk_widget_show_all(sw);
   return treeview;
}

void fill_atomic_parameters_list(GtkWidget *list)
{
  GtkListStore *model = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
  GtkTreeIter iter;

  for(int i=0; i<nats; i++)
  {
//mr12072016      std::string atom_lab = atm[i].lab;
      std::string atom_lab(atm[i].lab, 15);
      std::string b_iso =  fToStr(atm[i].biso, 5);
      std::string occ   =  fToStr(atm[i].och, 5);
      gboolean refine_biso = atm_rcod[i][3];
      gboolean refine_xyz  = shift_atom[i];
      gboolean refine_doc  = atm_rcod[i][4];
      gtk_list_store_append (model, &iter);
      gtk_list_store_set (model, &iter,
                          0, trim(atom_lab).c_str(),
                          1, trim(occ).c_str(),
                          2, trim(b_iso).c_str(),
                          3, refine_biso,
                          4, refine_xyz,
                          5, refine_doc,
                          -1);
    }
    for(int column=3; column<=5;column++)
    {
        char *tmp = g_strdup_printf("tog%d", column);
        gpointer w = g_object_get_data(G_OBJECT(model), tmp);
        g_free(tmp);
        tmp = g_strdup_printf("hndtog%d", column);
        int hnd = get_int(G_OBJECT(model), tmp);
        g_signal_handler_block(G_OBJECT(w), hnd);
        gboolean result = check_rows(GTK_TREE_MODEL(model), column);
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w), result);
        g_signal_handler_unblock(G_OBJECT(w), hnd);
    }
}
// END NEW

GtkWidget* create_atomic_par_dlg (void)
{
  GtkWidget *atomic_par_dlg;
  GtkWidget *vbox;
  GtkWidget *frame;
  GtkWidget *hbox8;
  GtkWidget *label23;
  GtkWidget *spin;
  GtkWidget *cancelbutton2;
  GtkWidget *okbutton2;

  atomic_par_dlg = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (atomic_par_dlg), ("Atomic parameters refinement"));
  gtk_widget_set_size_request(atomic_par_dlg, -1, 450);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG (atomic_par_dlg));

  frame = gtk_frame_new(NULL);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
  gtk_widget_show (frame);

//  atomic_parameters(atomic_par_dlg, frame);
  GtkWidget *ap_list = create_atomic_parameters_list(frame);

  hbox8 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox), hbox8, FALSE, FALSE, 10);
  gtk_container_set_border_width (GTK_CONTAINER (hbox8), 6);

  label23 = LABEL_NEW ("Maximum shift on position", MyBLUE);
  gtk_widget_show (label23);
  gtk_box_pack_start (GTK_BOX (hbox8), label23, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label23), GTK_JUSTIFY_LEFT);

  spin = SPIN_NEW(0.001, 2.00, shiftatomval, 0.01, 3);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox8), spin, TRUE, TRUE, 10);

//  GtkWidget *dialog_action_area2 = gtk_dialog_get_action_area(GTK_DIALOG (atomic_par_dlg));
//  gtk_widget_show (dialog_action_area2);
//  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area2), GTK_BUTTONBOX_END);

  cancelbutton2 = CANCEL_button();
  gtk_widget_show (cancelbutton2);
  gtk_dialog_add_action_widget (GTK_DIALOG (atomic_par_dlg), cancelbutton2, GTK_RESPONSE_CANCEL);
  gtk_widget_set_can_default (cancelbutton2, TRUE);

  okbutton2 = OK_button();
  gtk_widget_show (okbutton2);
  gtk_dialog_add_action_widget (GTK_DIALOG (atomic_par_dlg), okbutton2, GTK_RESPONSE_OK);
  gtk_widget_set_can_default (okbutton2, TRUE);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  HOOKUP_OBJECT(atomic_par_dlg, atomic_par_dlg, "atomic_par_dlg");
  HOOKUP_OBJECT(atomic_par_dlg, ap_list, "lista_atomic_parameters");

  g_signal_connect(G_OBJECT(spin), "value-changed", G_CALLBACK(on_sa_changed), NULL);

  return atomic_par_dlg;
}

void open_atomic_par(GtkButton *button, GtkWidget *sa_dlg)
{
   int result, code = 0;
   ges_atom_parameters_win_(&code,atm,shift_atom,&shiftatomval);
   GtkWidget *par_dlg = create_atomic_par_dlg();
   float shiftatomSav = shiftatomval;
   int **rcodSav = g_new0(int *, nats), i;

   for (i=0; i<nats; i++)
   {
       rcodSav[i] = g_new0(int, 5);
       memcpy(rcodSav[i], atm_rcod[i], 5*sizeof(int));
   }
//   fill_atoms_list(par_dlg);
   fill_atomic_parameters_list(get_widget(par_dlg, "lista_atomic_parameters"));
   gtk_window_set_transient_for(GTK_WINDOW(par_dlg), GTK_WINDOW(sa_dlg));
   gtk_widget_show_all(par_dlg);
   gtk_widget_set_sensitive(sa_dlg, FALSE);
   result = gtk_dialog_run(GTK_DIALOG(par_dlg));
   if(result != GTK_RESPONSE_OK)
   {
      code = 2;
      ges_atom_parameters_win_(&code,atm,shift_atom,&shiftatomval);
// rimette tutto a posto;
      shiftatomval = shiftatomSav;
      for (i=0; i<nats; i++)
          memcpy(atm_rcod[i], rcodSav[i], 5*sizeof(int));
      (void) csa_conta_parametri(ginfo);
   }
   else
   {
      code = 1;
      GtkWidget *list = get_widget(par_dlg, "lista_atomic_parameters");
      GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
      GtkTreeIter iter;
      gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
      while (valid)
      {
          GtkTreePath *path = gtk_tree_model_get_path(model, &iter);
          int i = gtk_tree_path_get_indices (path)[0];
          gchar *iso, *och;
          gtk_tree_model_get (model, &iter, 1, &och, 2, &iso, -1);
          check_modi(och, &(atm[i].och));
          check_modi(iso, &(atm[i].biso));
          valid = gtk_tree_model_iter_next (model, &iter);
      }
#if 0   // Vecchia gestione
      char stringa[15];
      char *string;

      for (i=0;i<nats;i++)
      {
          for (int j=0;j<4;j++)
          {
              ScriviStringa(stringa,sizeof(stringa), "entrystru%d%d", i,j);
              GtkWidget *entry = get_widget(par_dlg, stringa);
              string = gtk_editable_get_chars(GTK_EDITABLE(entry),0, -1);
              if(j < 3) 
                 check_modi(string, &(atm[i].xc[j]));
              else 
                 check_modi(string, &(atm[i].biso));
          }
      }
#endif
      ges_atom_parameters_win_(&code,atm,shift_atom,&shiftatomval);
   }
   for (i=0; i<nats; i++)
        g_free(rcodSav[i]);
   g_free(rcodSav);

   gtk_widget_destroy(par_dlg);
   gtk_widget_set_sensitive(sa_dlg, TRUE);
}

void globalrefine(GtkToggleButton *button, GtkWidget *dlg)
{
    GtkWidget *check;
    char nome[20];
    int i;
    gboolean active = gtk_toggle_button_get_active(button);
    for(i=1; i<=numrot; i++)
    {
        ScriviStringa(nome,sizeof(nome), "refine%d", i);
        check = get_widget(dlg, nome);
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), active);
    }
}

GtkWidget *page_intDOF(GtkWidget *sa_dlg)
{
  GtkWidget *vbox, *frame, *label, *button, *table;
  GtkWidget *scrolledwindow, *viewport, *hbox, *check;

  vbox = vbox_new (FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 6);

  hbox = hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 3);
  gtk_box_pack_end (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

  frame = gtk_frame_new (NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 3);

  scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow);
  gtk_container_add (GTK_CONTAINER (frame), scrolledwindow);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), 
       GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  viewport = gtk_viewport_new (NULL, NULL);
  gtk_widget_show (viewport);
#ifndef IN_GTK3
  static GdkColor colorWhite = White;
  widget_modify_bg(viewport, GTK_STATE_NORMAL, &colorWhite);
#endif
  gtk_container_add (GTK_CONTAINER (scrolledwindow), viewport);

  table = table_new (1, 5, FALSE);
  gtk_widget_show (table);
  gtk_container_add (GTK_CONTAINER (viewport), table);
  gtk_container_set_border_width (GTK_CONTAINER (table), 10);
  table_set_row_spacings (table, 4);
  table_set_col_spacings (table, 4);

  label = LABEL_NEW ("Internal DOFs", MyBLUE);
  gtk_widget_show (label);
  gtk_frame_set_label_widget (GTK_FRAME (frame), label);

  check = gtk_check_button_new_with_mnemonic ("Dynamical Occupancy Correction");
//  gtk_widget_show (check);
//  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 0);

  button = myimage_button (" _Atomic Parameters and Dynamical Occupancy Correction", "modibg.png");
//  button = gtk_button_new_with_mnemonic (("Atomic parameters"));
  gtk_widget_show (button);
//  gtk_box_pack_end (GTK_BOX (hbox), button, FALSE, FALSE, 0);
  gtk_box_pack_end (GTK_BOX (vbox), button, FALSE, FALSE, 0);

  HOOKUP_OBJECT (sa_dlg, frame, "int_DOF_frame");
  HOOKUP_OBJECT (sa_dlg, scrolledwindow, "scrolledwindow");
  HOOKUP_OBJECT (sa_dlg, table, "table_tors");
  HOOKUP_OBJECT (sa_dlg, check, "DOC");

  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(open_atomic_par), sa_dlg);

  return vbox;
}

void aggiorna_centro (vet3 xyz)
{
#ifdef SIR_PGM
   if(sannel_dialog != NULL)
   {
      for(int j=0; j<3;j++)
      {
          std::string nome = "tra";
          nome.append(labelvol[j]);
          GtkWidget *spin = get_widget(sannel_dialog, nome.c_str());
          int hnd = get_int(spin, "hnd");
          g_signal_handler_block(G_OBJECT(spin), hnd);
          spin_button_set_value (spin, xyz.v[j]);
          g_signal_handler_unblock(G_OBJECT(spin), hnd);
      }
   }
#endif
}

//NEW 14/01/14
static void ab_activate_toggled (GtkCellRendererToggle *cell,
               gchar                 *path_str,
               gpointer               data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreeIter  iter;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  gboolean fixed;

  gtk_tree_model_get_iter (model, &iter, path);
  gtk_tree_model_get (model, &iter, 3, &fixed, -1);

  fixed ^= 1;

  int which = gtk_tree_path_get_indices (path)[0];
  gtk_list_store_set (GTK_LIST_STORE (model), &iter, 3, fixed, -1);
  abres[which].code = fixed?4:-4;
  gtk_tree_path_free (path);
}

static void distance_edited (GtkCellRendererText *cell,
             const gchar         *path_string,
             const gchar         *new_text,
             gpointer             data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
  GtkTreeIter iter;

  gtk_tree_model_get_iter (model, &iter, path);
  gint i;
  int column = 2;
  gchar *old_text;

  gtk_tree_model_get (model, &iter, column, &old_text, -1);
  g_free (old_text);

  i = gtk_tree_path_get_indices (path)[0];
  abres[i].targ = (float) atof(new_text);
  gtk_list_store_set (GTK_LIST_STORE (model), &iter, column,
                 fToStr(abres[i].targ, 3).c_str(), -1);
}

static void add_columns (GtkTreeView  *treeview,
             GtkTreeModel *model)
{
  GtkCellRenderer *renderer = gtk_cell_renderer_text_new ();
  g_object_set (renderer, "editable", FALSE, NULL);
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Atom 1", renderer,
                                               "text", 0,
                                               NULL);
  renderer = gtk_cell_renderer_text_new ();
  g_object_set (renderer, "editable", FALSE, NULL);
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Atom 2", renderer,
                                               "text", 1,
                                               NULL);
  renderer = gtk_cell_renderer_text_new ();
  g_object_set (renderer, "editable", TRUE, NULL);
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Distance", renderer,
                                               "text", 2,
                                               NULL);
  g_signal_connect (renderer, "edited",
                    G_CALLBACK (distance_edited), model);

  renderer = gtk_cell_renderer_toggle_new ();
  g_signal_connect (renderer, "toggled",
                    G_CALLBACK (ab_activate_toggled), model);

  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
                                               -1, "Activate", renderer,
                                               "active", 3,
                                               NULL);

}

static GtkTreeModel *create_ab_restraints_model (void)
{
  GtkListStore *model;

  model = gtk_list_store_new (4, G_TYPE_STRING, G_TYPE_STRING,
                              G_TYPE_STRING, G_TYPE_BOOLEAN);

  return GTK_TREE_MODEL (model);
}

GtkWidget *create_ab_restraints_list(GtkWidget *vbox)
{
   GtkWidget *treeview, *sw;
   GtkTreeModel *abrestraints_model;

   sw = gtk_scrolled_window_new (NULL, NULL);
   gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (sw),
                                           GTK_SHADOW_ETCHED_IN);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw),
                                      GTK_POLICY_NEVER,
                                      GTK_POLICY_AUTOMATIC);
   gtk_container_add (GTK_CONTAINER (vbox), sw);
#ifdef IN_GTK3
  g_object_set(G_OBJECT(sw), "halign", GTK_ALIGN_START, NULL);
  gtk_widget_set_hexpand(sw, FALSE);
#endif

   abrestraints_model = create_ab_restraints_model ();
   treeview = gtk_tree_view_new_with_model (abrestraints_model);
   //gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (treeview), FALSE);
   gtk_tree_selection_set_mode (gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview)),
                                   GTK_SELECTION_SINGLE);
   add_columns (GTK_TREE_VIEW (treeview), abrestraints_model);
   g_object_unref (abrestraints_model);
   gtk_container_add (GTK_CONTAINER (sw), treeview);

   gtk_widget_show_all(sw);
   return treeview;
}

//NEW 14/01/14
void fill_model(GtkWidget *list, restraint_type *resv_local, bool only_cnos)
{
  gint i;
  GtkListStore *model = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
  GtkTreeIter iter;

  for (i = 0; i < nres; i++)
    {
      int a1 = resv_local[i].na[0] - 1;
      std::string str1 (get_nth_element(a1));
      int a2 = resv_local[i].na[1] - 1;
      std::string str2 (get_nth_element(a2));

      gboolean active = (resv_local[i].code >0)?1:0;
      if(only_cnos && Is_CNOS(a2) && (Is_CNOS(a1)))
         active = 1;
      gtk_list_store_append (model, &iter);
      gtk_list_store_set (model, &iter,
                          0, trim(str1).c_str(),
                          1, trim(str2).c_str(),
                          2, fToStr(resv_local[i].targ, 3).c_str(),
                          3, active,
                          -1);
    }
}
//END NEW

void on_select_bump(GtkToggleButton *but, gpointer data)
{
   GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(but));
   int which = GPOINTER_TO_INT(data);
   GtkWidget *list = get_widget(dlg, "frameabRestraints");
   gtk_widget_set_sensitive(list, which);
   list = get_widget(dlg, "listaabRestraints");
   clear_list(list);
   fill_model(list, abres, (which == 1));
}

GtkWidget *page_antibump(GtkWidget *sa_dlg)
{
  GtkWidget *vbox = vbox_new (FALSE, 0);
//Commentare la seguente per eliminare la parte di anti-bumo
  gtk_widget_show (vbox);

  gtk_container_set_border_width (GTK_CONTAINER (vbox), 6);
  GtkWidget *hb = hbox_new(TRUE, 0);
  gtk_widget_show(hb);
  gtk_box_pack_start (GTK_BOX (vbox), hb, FALSE, FALSE, 5);
  GSList *group = NULL;
  GtkWidget *radio = gtk_radio_button_new_with_label (group, "None");
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  gtk_box_pack_start (GTK_BOX (hb), radio, FALSE, FALSE, 0);
  gtk_widget_show(radio);
  g_signal_connect (radio, "toggled",
                    G_CALLBACK (on_select_bump), GINT_TO_POINTER(0));
  g_object_set_data (G_OBJECT (sa_dlg), "bact0", radio);
  radio = gtk_radio_button_new_with_label (group, "Only for C,N,O,S");
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  gtk_box_pack_start (GTK_BOX (hb), radio, FALSE, FALSE, 5);
  gtk_widget_show(radio);
  g_signal_connect (radio, "toggled",
                    G_CALLBACK (on_select_bump), GINT_TO_POINTER(1));
  g_object_set_data (G_OBJECT (sa_dlg), "bact1", radio);
  radio = gtk_radio_button_new_with_label (group, "Select from list");
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  gtk_box_pack_start (GTK_BOX (hb), radio, FALSE, FALSE, 5);
  g_signal_connect (radio, "toggled",
                    G_CALLBACK (on_select_bump), GINT_TO_POINTER(2));
  gtk_widget_show(radio);
  g_object_set_data (G_OBJECT (sa_dlg), "bact2", radio);
  
  GtkWidget *hbox = hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 5);

  GtkWidget *label = gtk_label_new("Weight");
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);

  GtkWidget *entry = gtk_entry_new ();
  g_object_set_data (G_OBJECT (sa_dlg), "bump_weight", entry);
  gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 5);
  gtk_widget_show (entry);
  set_width_chars(GTK_ENTRY(entry), 10);

  label = gtk_label_new("Scale factor on distances");
  gtk_widget_show(label);
  set_alignment (label, 0., 0.5);

  entry = gtk_entry_new ();
  g_object_set_data (G_OBJECT (sa_dlg), "bump_scale", entry);
  gtk_box_pack_end(GTK_BOX(hbox), entry, FALSE, FALSE, 5);
  gtk_widget_show (entry);
  set_width_chars(GTK_ENTRY(entry), 10);
  gtk_box_pack_end(GTK_BOX(hbox), label, FALSE, FALSE, 5);

  GtkWidget *frame = NEW_FRAME ("List of anti-bump restraints");
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
  gtk_widget_set_sensitive(frame, FALSE);
  g_object_set_data (G_OBJECT (sa_dlg), "frameabRestraints", frame);

  GtkWidget *align = get_widget(frame, "align");
#ifdef IN_GTK3
  gtk_widget_set_hexpand(align, FALSE);
#else
  gtk_alignment_set(GTK_ALIGNMENT(align), 0, 0, 0, 1);
#endif
  GtkWidget *list = create_ab_restraints_list(align);
  g_object_set_data (G_OBJECT (sa_dlg), "listaabRestraints", list);

  return vbox;
}
//END NEW 

#ifdef SIR_PGM
extern "C" void NewVolume(float v[]);
extern "C" void NewTrasl(float v[]);
void on_vol_changed (GtkWidget *, GtkWidget *dlg)
{
  float x[3];
  for(int j=0; j<3;j++)
  {
      std::string nome = "vol";
      nome.append(labelvol[j]);
      GtkWidget *spin = get_widget(dlg, nome.c_str());
      x[j] = (float) spin_button_get_value (spin);
  }
  NewVolume(x);
}

void on_tra_changed (GtkWidget *, GtkWidget *dlg)
{
  float x[3];
  for(int j=0; j<3;j++)
  {
      std::string nome = "tra";
      nome.append(labelvol[j]);
      GtkWidget *spin = get_widget(dlg, nome.c_str());
      x[j] = (float) spin_button_get_value (spin);
  }
  NewTrasl(x);
}

void apply_clicked(GtkWidget *, gpointer)
{
   int flag = 0;
   UpdateVolumeInfo(&flag);
}

void reset_clicked(GtkWidget *, gpointer)
{
    resetvolumeinfo_();
}

GtkWidget *page_map(GtkWidget *sa_dlg)
{
  GtkWidget *vbox, *frame, *align;

  vbox = vbox_new (FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 6);

  frame = NEW_FRAME("Volume");
  gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 10);
  align = get_widget(frame, "align");
  GtkWidget *table = table_new(2, 3, FALSE);
  gtk_container_add(GTK_CONTAINER(align), table);
  table_set_row_spacings(table, 10);
  table_set_col_spacings(table, 20);
  for(int j=0; j<3;j++)
  {
      GtkWidget *label = LABEL_NEW(labelvol[j], NULL);
      table_attach_exp(table, label, j, j + 1, 0, 1);
      GtkWidget *spin = SPIN_NEW(1, Cella[j], 0.1f, 0.1, 3);
      table_attach_exp(table, spin, j, j+1, 1, 2);
      std::string nome = "vol";
      nome.append(labelvol[j]);
      HOOKUP_OBJECT(sa_dlg, spin, nome.c_str());
      g_signal_connect(G_OBJECT(spin), "value-changed",
          G_CALLBACK(on_vol_changed), sa_dlg);
  }
  gtk_widget_show_all(frame);
  frame = NEW_FRAME("Translate");
  gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 30);
  align = get_widget(frame, "align");
  table = table_new(2, 3, FALSE);
  gtk_container_add(GTK_CONTAINER(align), table);
  table_set_row_spacings(table, 10);
  table_set_col_spacings(table, 20);
  for(int j=0; j<3;j++)
  {
      GtkWidget *label = LABEL_NEW(labelvol[j], NULL);
      table_attach_exp(table, label, j, j + 1, 0, 1);
      GtkWidget *spin = SPIN_NEW(-Cella[j]/2, Cella[j]/2, 0, 0.1, 3);
      table_attach_exp(table, spin, j, j+1, 1, 2);
      std::string nome = "tra";
      nome.append(labelvol[j]);
      HOOKUP_OBJECT(sa_dlg, spin, nome.c_str());
      int hnd = g_signal_connect(G_OBJECT(spin), "value-changed",
          G_CALLBACK(on_tra_changed), sa_dlg);
      g_object_set_data(G_OBJECT(spin), "hnd", GINT_TO_POINTER(hnd));
  }

  gtk_widget_show_all(frame);
  GtkWidget *hbox = hbutton_box_new();
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 30);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_SPREAD);
  GtkWidget *but = APPLY_button();
  gtk_container_add(GTK_CONTAINER(hbox), but);
  g_signal_connect(G_OBJECT(but), "clicked", G_CALLBACK(apply_clicked), NULL);
  but =  myimage_button(" _Reset", "reset.png");
  g_signal_connect(G_OBJECT(but), "clicked", G_CALLBACK(reset_clicked), NULL);
  gtk_container_add(GTK_CONTAINER(hbox), but);
  gtk_widget_show_all(hbox);

  return vbox;
}
#else
GtkWidget *page_patt(GtkWidget *sa_dlg)
{
  GtkWidget *vbox, *frame, *align;

  vbox = vbox_new (FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 6);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
  align = gtk_alignment_new (0.5,0.5,0.,0.);
#endif
  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (vbox), align, TRUE, TRUE, 0);

  frame = NEW_FRAME ("March-Dollase Preferred Orientation", true);
  gtk_widget_show (frame);
  gtk_container_add (GTK_CONTAINER (align), frame);
  align = frame_preferential(sa_dlg);
  add_to_frame(frame, align);

  return vbox;
}
#endif

GtkWidget* create_sa_dlg (double resmin, double resmax)
{
  GtkWidget *sa_dlg;
  GtkWidget *dialog_vbox1;
  GtkWidget *notebook1;
  GtkWidget *page1;
  GtkWidget *page2;
  GtkWidget *page3;
  GtkWidget *hbox9;
  GtkWidget *numRefPar;
  GtkWidget *label;
  GtkWidget *helpbutton1;
  GtkWidget *cancelbutton1;
  GtkWidget *okbutton1;
  GtkWidget *solbutton;

  sa_dlg = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (sa_dlg),("Global optimization dialog"));

  dialog_vbox1 = gtk_dialog_get_content_area(GTK_DIALOG (sa_dlg));
  gtk_widget_show (dialog_vbox1);

  notebook1 = NewNotebook(dialog_vbox1);
  gtk_widget_show (notebook1);
  //gtk_box_pack_start (GTK_BOX (dialog_vbox1), notebook1, TRUE, TRUE, 0);

#ifdef SIR_PGM
  GtkWidget *page4 = page_map(sa_dlg);
  gtk_container_add (GTK_CONTAINER (notebook1), page4);
  set_tab_label (GTK_NOTEBOOK (notebook1), PAGE_MAP, "DiffMap");
#endif

  page1 = page_SAconditions(sa_dlg, resmin, resmax);
  gtk_container_add (GTK_CONTAINER (notebook1), page1);
  set_tab_label (GTK_NOTEBOOK (notebook1), PAGE_SA, "SA conditions");

  page2 = page_extDOF(sa_dlg);
  gtk_container_add (GTK_CONTAINER (notebook1), page2);
  set_tab_label (GTK_NOTEBOOK (notebook1), PAGE_EXTDOF, "External DOF");

  page3 = page_intDOF(sa_dlg);
  gtk_container_add (GTK_CONTAINER (notebook1), page3);
  set_tab_label (GTK_NOTEBOOK (notebook1), PAGE_INTDOF, "Internal DOF");

//NEW 14/01/14
  GtkWidget *page5 = page_antibump(sa_dlg);
  gtk_container_add (GTK_CONTAINER (notebook1), page5);
  set_tab_label (GTK_NOTEBOOK (notebook1), PAGE_ANTIB, "Anti-bump");
//END NEW

#ifndef SIR_PGM
  GtkWidget *page4 = page_patt(sa_dlg);
  gtk_container_add (GTK_CONTAINER (notebook1), page4);
  set_tab_label (GTK_NOTEBOOK (notebook1), PAGE_PREF, "Pattern");
#endif

  hbox9 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox9);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), hbox9, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox9), 10);

  label = LABEL_NEW ("Number of refined parameters:", MyRED);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox9), label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);

  numRefPar = gtk_label_new ("");
  gtk_widget_show (numRefPar);
  gtk_box_pack_start (GTK_BOX (hbox9), numRefPar, FALSE, FALSE, 5);
  gtk_label_set_justify (GTK_LABEL (numRefPar), GTK_JUSTIFY_LEFT);

#ifdef IN_GTK3
  GtkWidget *align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
  GtkWidget *align = gtk_alignment_new(0, 0.5, 0, 0);
#endif
  gtk_widget_show (align);
  gtk_box_pack_end (GTK_BOX (hbox9), align, FALSE, FALSE, 0);
  solbutton = myimage_button(" Solutions", "solutions.png");
  gtk_widget_show (solbutton);
  gtk_container_add (GTK_CONTAINER (align), solbutton);

//  GtkWidget *dialog_action_area1 = gtk_dialog_get_action_area(GTK_DIALOG (sa_dlg));
//  gtk_widget_show (dialog_action_area1);
//  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  helpbutton1 = HELP_button();
  gtk_widget_show (helpbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (sa_dlg), helpbutton1, GTK_RESPONSE_HELP);
  gtk_widget_set_can_default (helpbutton1, TRUE);

  cancelbutton1 = QUIT_button();
  gtk_widget_show (cancelbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (sa_dlg), cancelbutton1, GTK_RESPONSE_CANCEL);
  gtk_widget_set_can_default (cancelbutton1, TRUE);
  

  okbutton1 = GO_button();
  gtk_widget_show (okbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (sa_dlg), okbutton1, GTK_RESPONSE_OK);
  gtk_widget_set_can_default (okbutton1, TRUE);  

  /* Callbacks */
  g_signal_connect (G_OBJECT(solbutton), "clicked",G_CALLBACK(show_solutions), NULL);
  g_signal_connect (G_OBJECT(helpbutton1), "clicked",G_CALLBACK(help_sannel), NULL);
  g_signal_connect (G_OBJECT(cancelbutton1), "clicked",G_CALLBACK(exit_sannel), NULL);
  g_signal_connect (G_OBJECT(okbutton1), "clicked",G_CALLBACK(ok_sannel), NULL);
  (void) g_signal_connect_swapped(G_OBJECT(sa_dlg), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(cancelbutton1));
  (void) g_signal_connect (G_OBJECT (sa_dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);


  /* Store pointers to all widgets, for use by lookup_widget(). */
  HOOKUP_OBJECT (sa_dlg, sa_dlg, "sa_dlg");
  HOOKUP_OBJECT (sa_dlg, dialog_vbox1, "dialog_vbox1");
  HOOKUP_OBJECT (sa_dlg, notebook1, "notebook1");
  HOOKUP_OBJECT (sa_dlg, hbox9, "hbox9");
  HOOKUP_OBJECT (sa_dlg, numRefPar, "numRefPar");
  HOOKUP_OBJECT (sa_dlg, helpbutton1, "helpbutton1");
  HOOKUP_OBJECT (sa_dlg, cancelbutton1, "cancelbutton1");
  HOOKUP_OBJECT (sa_dlg, okbutton1, "okbutton1");

  gtk_widget_grab_focus (okbutton1);
  return sa_dlg;
}

void refine_toggled(GtkToggleButton *button, gpointer data)
{
    int i = GPOINTER_TO_INT(data) - 1;
    rotation[i].rcod = gtk_toggle_button_get_active(button);
    (void) csa_conta_parametri(ginfo);
}

void torsval_changed(GtkWidget *spin, gpointer data)
{
   int i = GPOINTER_TO_INT(data) - 1;
   rotation[i].torsval = (float) spin_button_get_value(spin);
}

void lower_changed(GtkWidget *spin, gpointer data)
{
   int i = GPOINTER_TO_INT(data) - 1;
   rotation[i].trbound[0] = (float) spin_button_get_value(spin);
}

void upper_changed(GtkWidget *spin, gpointer data)
{
   int i = GPOINTER_TO_INT(data) - 1;
   rotation[i].trbound[1] = (float) spin_button_get_value(spin);
}

static int get_posi(int cfval)
{
   for(int i=0; i<szcfvect; i++)
       if(cfvect[i] == cfval)
          return (i+1);
   return 1;
}

void open_sannel_dlg(GtkWidget *win, int natsfort, double resmin, double resmax,
                     bump_settings *bumpset)
{
     GtkWidget *widget;
     int i, numChildren;
     GList *glist = NULL, *children;
     static const char *title[] = {"Torsion", "Refine", "Value", "Lower", "Upper"};

     if(sannel_dialog == NULL)
             sannel_dialog = create_sa_dlg(resmin, resmax);
     mainwin = win;

//     set initial values

// SA conditions page

     cftype = ginfo.cftype;
     widget = get_widget(sannel_dialog, "cost_combo");
     if(!ifLigand)
        combo_set_val(widget, get_posi(ginfo.cftype));
     widget = get_widget(sannel_dialog, "auto_temp_check");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), scgraph.autoti);
     widget = get_widget(sannel_dialog, "auto_moves_check");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), scgraph.autont);
     widget = get_widget(sannel_dialog, "start_temp_spin");
     spin_button_set_value(widget, scgraph.t_ini);
     widget = get_widget(sannel_dialog, "spinres");
     spin_button_set_range(widget, resmin, resmax);
     //corr if(ginfo.res > 0)
        spin_button_set_value(widget, ginfo.res);
     //corr else
     //corr    spin_button_set_value(widget, 2.0);
     widget = get_widget(sannel_dialog, "Nmoves_spin");
     spin_button_set_value(widget, scgraph.nt);
     widget = get_widget(sannel_dialog, "Nrun_spin");
     spin_button_set_value(widget, ginfo.nrun);
     widget = get_widget(sannel_dialog, "ran_seed_spin");
     spin_button_set_value(widget, ginfo.seed);
     widget = get_widget(sannel_dialog, "cool_rate_spin");
     spin_button_set_value(widget, scgraph.temp_fact);
     widget = get_widget(sannel_dialog, "auto_cycles_check");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), bbgraph.autont);
     widget = get_widget(sannel_dialog, "Ncycles_spin");
     spin_button_set_value(widget, bbgraph.niter);
     switch(ginfo.algo)
     {
     default:
     case SA_LOCAL:
          gtk_widget_show_all(get_widget(sannel_dialog, "sa_frame"));
          gtk_widget_hide(get_widget(sannel_dialog, "frame_cycles"));
          break;
     case BBBC:
          gtk_widget_show_all(get_widget(sannel_dialog, "frame_cycles"));
          gtk_widget_hide(get_widget(sannel_dialog, "sa_frame"));
          break;
     }
#if 0
#ifdef SIR_PGM
     widget = get_widget(sannel_dialog, "Rsoglia");
     obj_set_visible((gpointer)widget, (ginfo.sogcf > 1));
     spin_button_set_value(widget, ginfo.sogcf);
     widget = get_widget(sannel_dialog, "labelsoglia");
     obj_set_visible((gpointer)widget, (ginfo.sogcf > 1));
#endif
#endif

// External DOF page

     for(i=1; i<=numfrags; i++)
         glist = g_list_append(glist, g_strdup_printf("Fragment n. %d", i));
     widget = get_widget(sannel_dialog, "combo_frags");
     fill_my_combog(widget, glist);
     g_list_free(glist);
     combo_set_val(widget, 1);
     int v0 = fragment[nfrag-1].rat?
             fragment[nfrag-1].rat : fragment[nfrag-1].pos[0];
     std::string s(atm[v0-1].lab, 15);
     widget = get_widget(sannel_dialog, "ratb");
     gtk_button_set_label(GTK_BUTTON(widget), s.c_str());


// N. ref. par.

     widget = get_widget(sannel_dialog, "numRefPar");
     set_label_text(widget, 
          g_strdup_printf("%d", ginfo.npar), MyRED, 0.99f, 0);

// Internal DOF page

//     widget = get_widget(sannel_dialog, "DOC");
//     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), ginfo.doc);
     widget = get_widget(sannel_dialog, "table_tors");
     children = gtk_container_get_children(GTK_CONTAINER(widget));
     numChildren = g_list_length(children);
     for (i=0;i<numChildren;i++)
          gtk_container_remove(GTK_CONTAINER(widget),
                   (GtkWidget *) g_list_nth_data(children, i));
     table_resize (widget, numrot+1, 5);
  for(i=0; i<5; i++)
  {
      GtkWidget *entry;
      if(i == 1)
      {
         entry = TOGGLE_BUTTON_WITH_LABEL(title[i], MyBLUE);
         gtk_button_set_relief (GTK_BUTTON(entry), GTK_RELIEF_NONE);
         gtk_widget_set_can_focus(entry, FALSE);
         g_signal_connect(G_OBJECT(entry), "toggled", G_CALLBACK(globalrefine),
                            sannel_dialog);
      }
      else
      {
         entry = LABEL_NEW (title[i], MyBLUE);
         gtk_label_set_justify (GTK_LABEL (entry), GTK_JUSTIFY_CENTER);
         set_alignment (entry, 0.5, 0.5);
      }
      gtk_widget_show (entry);
      table_attach (widget, entry, i, i+1, 0, 1);
  }

     for(i=1; i<=numrot; i++)
     {
         GtkWidget *entry, *spin, *check;

         entry = gtk_entry_new();
         gtk_widget_show(entry);
         gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
         gtk_entry_set_text(GTK_ENTRY(entry), g_strstrip(rotation[i-1].str_ators));
         table_attach (widget, entry, 0, 1, i, i+1);
         check = gtk_check_button_new();
         gtk_widget_show(check);
         table_attach(widget, check, 1, 2, i, i+1);
         g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(refine_toggled), GINT_TO_POINTER(i));
         gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), rotation[i-1].rcod);
         HOOKUP_OBJECT (sannel_dialog, check, g_strdup_printf("refine%d", i));
         spin = SPIN_NEW(-180, 180, rotation[i-1].torsval, 0.01, 2);
#ifndef IN_GTK3
         static GdkColor colorBlck =  Black;
         widget_modify_text(spin, GTK_STATE_INSENSITIVE, &colorBlck);    // to remove
#endif
         HOOKUP_OBJECT (sannel_dialog, spin, g_strdup_printf("value%d", i));
         gtk_widget_set_sensitive(spin, FALSE);                              // to remove
         gtk_widget_show(spin);
         gtk_editable_set_editable(GTK_EDITABLE(spin), FALSE);
         table_attach (widget, spin, 2, 3, i, i+1);
         g_signal_connect(G_OBJECT(spin), "value-changed", G_CALLBACK(torsval_changed), GINT_TO_POINTER(i));
         spin = SPIN_NEW(-180, 180, rotation[i-1].trbound[0], 0.01, 2);
         gtk_widget_show(spin);
         table_attach (widget, spin, 3, 4, i, i+1);
         g_signal_connect(G_OBJECT(spin), "value-changed", G_CALLBACK(lower_changed), GINT_TO_POINTER(i));
         spin = SPIN_NEW(-180, 180, rotation[i-1].trbound[1], 0.01, 2);
         gtk_widget_show(spin);
         table_attach (widget, spin, 4, 5, i, i+1);
         g_signal_connect(G_OBJECT(spin), "value-changed", G_CALLBACK(upper_changed), GINT_TO_POINTER(i));
     }

//NEW 14/01/14
// Anti-bump restraints

     widget = get_widget(sannel_dialog, "bump_weight");
     gtk_entry_set_text(GTK_ENTRY(widget), fToStr(bumpset->weight, 3).c_str());
     widget = get_widget(sannel_dialog, "bump_scale");
     gtk_entry_set_text(GTK_ENTRY(widget), fToStr(bumpset->scaledist, 3).c_str());

     widget = get_widget(sannel_dialog, g_strdup_printf("bact%d", bumpset->baction));
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
     widget = get_widget(sannel_dialog, "listaabRestraints");
     clear_list(widget);
     fill_model(widget, abres, (bumpset->baction == 1));
//END NEW

#ifdef SIR_PGM
     widget = gtk_notebook_get_nth_page(GTK_NOTEBOOK(get_widget(
                  sannel_dialog, "notebook1")), PAGE_MAP);
     if(ifLigand)
     {
        gtk_widget_show(widget);
        for (int j=0; j<3; j++)
        {
            std::string nome = "vol";
            nome.append(labelvol[j]);
            widget = get_widget(sannel_dialog, nome.c_str());
            spin_button_set_value(widget, defaultCell[j]);
        }
     }
     else
        gtk_widget_hide(widget);
#else
// Page Pattern
     char stringa[15];
     for (int j=1;j<=3;j++)
     {
          ScriviStringa(stringa,sizeof(stringa), "entryHKL%d", j);
          widget = get_widget(sannel_dialog, stringa);
          ScriviStringa(stringa, sizeof(stringa), "%d", hklpo[j-1]);
          gtk_entry_set_text(GTK_ENTRY(widget), g_strstrip(stringa));
     }
     widget = get_widget(sannel_dialog, "entryG1");
     ScriviStringa(stringa, sizeof(stringa), "%-12.6f", gpo.val);
     gtk_entry_set_text(GTK_ENTRY(widget), stringa);

     widget = get_widget(sannel_dialog, "checkG1");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), gpo.rcod);
#endif

     widget = get_widget(sannel_dialog, "okbutton1");
     gtk_widget_grab_focus (widget);
#ifndef _WIN32
     gtk_window_set_transient_for(GTK_WINDOW(sannel_dialog), GTK_WINDOW(finestre[0]));
#endif
     gtk_widget_show(sannel_dialog);
#ifdef SIR_PGM
     finestra_modale_aperta2(sannel_dialog);
#endif
     gdk_window_raise(gtk_widget_get_window(sannel_dialog));
}

void c_globalopt (GtkWidget *item, gpointer data)
{
#ifdef SIR_PGM
   GtkWidget *tb, *mainwin;
#endif
   double resmin, resmax;
   bump_settings bumpset;
   int ier, ifButton = 0;

   if(item != NULL)
      ifButton = 1;
#ifdef SIR_PGM
   if(ifButton)
      dialogo->viewerOpened = 0;
   mainwin = finestre[0];
   abilitamb(mainwin, 0);
   tb = lookup_widget(mainwin, "toolbar_main");
   abilitatb(tb, 0);
#endif
   elaborazione_in_corso();

   sannelexewin_(&ier, &resmin, &resmax, &ginfo, &scgraph, &bbgraph, &ifButton,
                 &bumpset);

   fine_elaborazione();

#ifdef SIR_PGM
   abilitatb(tb, 2);
   abilitamb(mainwin, 2);
   getligandinfo_(&ifLigand, defaultCell, Cella);
#endif

   if(ier != -1)
   {
      int i, vett[4];
      int rrcod;
      float val, bounds[2];
      char *s1, *s2, *s3, *s4;

      s1 = g_new0(char, 17);
      s2 = g_new0(char, 17);
      s3 = g_new0(char, 17);
      s4 = g_new0(char, 17);
      nats = ier;
      for(i=1; i<=numrot; i++)
      {
          prendi_ators_etc(i, vett, &rrcod, &val, bounds);
          ScriviStringa(s1,17,"%s", atm[vett[0]-1].lab);
          ScriviStringa(s2,17,"%s", atm[vett[1]-1].lab);
          ScriviStringa(s3,17,"%s", atm[vett[2]-1].lab);
          ScriviStringa(s4,17,"%s", atm[vett[3]-1].lab);
          ScriviStringa(rotation[i-1].str_ators,80,"%s:%s:%s:%s", 
              g_strstrip(s1), g_strstrip(s2), g_strstrip(s3), g_strstrip(s4));
          rotation[i-1].rcod = rrcod;
          rotation[i-1].torsval = val;
          rotation[i-1].trbound[0] = bounds[0];
          rotation[i-1].trbound[1] = bounds[1];
      }
      g_free(s1);
      g_free(s2);
      g_free(s3);
      g_free(s4);
#ifndef SIR_PGM
      int kopcorrl, hklpol[3];
      r_param_type gpol;
      getvaluesforpattern_(&gpol, hklpol, &kopcorrl);
      memcpy(&gpo, &gpol, sizeof(r_param_type));
      kopcorr = kopcorrl;
      for(i=0; i<3; i++)
          hklpo[i] = hklpol[i];
#endif
      open_sannel_dlg(finestre[0], ier, resmin, resmax, &bumpset);
   }
}

/*********************************************************/
/*               V i e w   S o l u t i o n s             */
/*********************************************************/

static int ultima_scelta = 1;
int soluzione_scelta = -1;
int soluzione_salvata;

void save_solution(GtkButton *button, gpointer data)
{
using namespace gtkext;
   int *scelta = (int *) data;
   if(*scelta == -1)
   {
      dlg_errmsg(GTK_WINDOW(gtk_widget_get_toplevel(GTK_WIDGET(button))), 
        "No solutions selected.");
      return;
   }
   ultima_scelta = *scelta;
   savesolution_(scelta);
}

void cancel_solution(GtkButton *button, gpointer data)
{
   int *vecchiascelta = (int *) data;
   cancelsolution_(vecchiascelta);
}

void show_solution(int *scelta)
{
   showsolution_(scelta);
}

static void  on_select_solution (GtkTreeSelection *selec, gpointer data)
{
   int sel, pos;
   GtkTreeModel *model;
   GtkTreeIter iter;
   int *SelectedSolution = (int *) data;
//   GtkWidget *tv = GTK_WIDGET(gtk_tree_selection_get_tree_view(selec));
//   GtkWidget *toplev = gtk_widget_get_toplevel(tv);

   sel = gtk_tree_selection_get_selected (selec, &model, &iter);
   pos = -1;
   if(sel)
      pos = row_selected(selec);

   if(pos != -1)
   {
      *SelectedSolution = pos + 1 ;
      show_solution(SelectedSolution);       
//      if(gtk_widget_get_window(toplev));
//         gdk_window_raise(gtk_widget_get_window(toplev));
   }
   else
      *SelectedSolution = -1;
}

void riempi_listaSoluzioni(GtkWidget *lista, int nrow, int nrcol[],
                             float cfcol[], char *strcol)
{
  int i;
  char *rigacom[3] = {g_new0(char, MaxLenFilename),
                      g_new0(char, MaxLenFilename),
                      g_new0(char, MaxLenFilename)};

  clear_list(lista);
  for(i=0; i<nrow; i++)
  {
     ScriviStringa(rigacom[0], MaxLenFilename, "%6d", nrcol[i]);
     ScriviStringa(rigacom[1], MaxLenFilename, "%12.6f", cfcol[i]);
     ScriviStringa(rigacom[2], MaxLenFilename, "%s_best%d.cif", toUTF8(strcol), i+1);
     add_line_to_listM(lista, rigacom);
  }
}

void ripristina_sannel(GtkWidget *butt, gpointer data)
{
     GtkWidget *sa_dlg = (GtkWidget *)data;
     gtk_widget_destroy(gtk_widget_get_toplevel(butt));
#ifdef SIR_PGM
     finestra_modale_chiusa2();
#endif
     gtk_widget_show(sa_dlg);
#ifdef SIR_PGM
     finestra_modale_aperta2(sa_dlg);
#endif
     gdk_window_raise(gtk_widget_get_window(sa_dlg));
#ifndef _WIN32
     gtk_window_set_transient_for(GTK_WINDOW(sa_dlg), GTK_WINDOW(finestre[0]));
#endif
}

GtkWidget *crea_finestra_soluzioni(GtkWidget *sa_dlg, int nrow, int nrcol[], 
           float cfcol[], char *strcol, int *SelectedSolution, int *SavedSolution)
{
     GtkWidget *dlg;
     GtkWidget *list, *vbox, *button1, *button2;
     static const char *colonne[] = {" Run nr. ", "  Cost Function ", "  File  "};

     dlg = gtk_dialog_new ();
     gtk_window_set_title (GTK_WINDOW (dlg), "Solutions menu");
     gtk_container_set_border_width (GTK_CONTAINER (dlg), 10);
     gtk_widget_set_size_request(dlg, 400, 350);

     vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
     list = createSelectionM(dlg, vbox, colonne, "listaSoluzioni",
          sizeof(colonne)/sizeof(colonne[0]), MyBLUE);
     set_selection_mode(list, GTK_SELECTION_SINGLE);
     riempi_listaSoluzioni(list,nrow,nrcol,cfcol,strcol);

     button1 = myimage_button("   _Save ", "save.png");
     gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button1, GTK_RESPONSE_OK);
     
     button2 = CANCEL_button();
     gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button2, GTK_RESPONSE_CANCEL);

     g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (list))),
        "changed", G_CALLBACK(on_select_solution), (gpointer) SelectedSolution);

     g_signal_connect((gpointer) button1, "clicked", 
        G_CALLBACK(save_solution),  (gpointer) SelectedSolution);
     g_signal_connect((gpointer) button1, "clicked", 
                      G_CALLBACK(ripristina_sannel), (gpointer) sa_dlg);
     g_signal_connect((gpointer) button2, "clicked", 
        G_CALLBACK(cancel_solution),  (gpointer) SavedSolution);
     g_signal_connect((gpointer) button2, "clicked", 
                      G_CALLBACK(ripristina_sannel), (gpointer) sa_dlg);
     g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button2));
     g_signal_connect (G_OBJECT (dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);

     return dlg;
}

void apri_finestra_soluzioni(GtkWidget *sa_dlg, int nrow, int nrcol[], 
                             float cfcol[], char *strcol)
{
     soluzione_scelta = -1;
     soluzione_salvata = ultima_scelta;
     GtkWidget *dlg = crea_finestra_soluzioni(sa_dlg, nrow, nrcol, 
                      cfcol, strcol, &soluzione_scelta, &soluzione_salvata);
     GtkWidget *list = get_widget(dlg, "listaSoluzioni");
     select_row(list, ultima_scelta-1);
#ifndef _WIN32
     gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(finestre[0]));
#endif
     gtk_widget_show_all(dlg);
#ifdef SIR_PGM
     finestra_modale_aperta2(dlg);
#endif
     gdk_window_raise(gtk_widget_get_window(dlg));
}
