      subroutine WriteSymmInfo(kpr)
      USE General, only: spacegr
      USE Symmetry, only: isvet
      implicit none
      integer, intent(in) :: kpr
      call spacegr%prn(kpr,prlevel=1)
      if (isvet(1) /= 0) then
          write(kpr,'(/a,3a2,4x,5a2)')' Seminvariant condition : ',isvet
      endif
      end subroutine WriteSymmInfo
#if 0
      subroutine WriteSymmInfo(kpr)
      USE Symmetry
      USE Liste
!!!!!!test
!        USE General, only: spacegr
!        USE spginfom
!!!!!!test
!
      integer, intent(in) :: kpr
      common/spaceindexing /ispaceindexing,fspaceindex(660),
     *                   ntotmult1,ntotmult2,percind(660),errespac(660)
     *                   ,lauecell(660)
       character*20 lauecell
!
      character*16 space
      character buffer(24)*78
      character*2 tx(2,6,3), ll(2,3,2), lattice
      integer iscont(3), t(48,3)
!
!-- initializations
!
      iscont = 1
      t      = 0
!
      if (ispaceindexing<=0) write(kpr,19) texc(jsys)
      write(space,'(16a1)') nSpaceG
      call ucase(space(1:1))
      if (icent.eq.1) then
          if (ispaceindexing<=0) write(kpr,20) space
          ngo = nsym * 2
      else
          if (ispaceindexing<=0) write(kpr,21) space
          ngo = nsym
      endif
!
      do i=1, ngo
         do j=1,3
            if (abs(tmat(i,j)).gt.0.01) then
                t(i,j) = iabs (nint( tmat(i,j) * 24 ) )
            else
                t(i,j) = 0
            endif
         enddo
      enddo
!
!     if (ispaceindexing==0) write(kpr,27)
      if (ispaceindexing<=0) write(kpr,27)

      ne = ( ngo + 1 ) / 2
      buffer(ne) = ' '
      do n=1,ne
         id = 2 - ( n + n - 1 ) / ngo
         do l=1,2
            iscont(l) = l + ( n - 1 ) * 2
            i = iscont(l)
            do j=1,3
               nd = kmat(i,j,1) + kmat(i,j,2)*3 + kmat(i,j,3)*4 + 5
               tx(1,j,l) = teb(1,nd)
               tx(2,j,l) = teb(2,nd)
               do k=1,2
                  m = t(i,j)*2 + k
                  ll(k,j,l) = ntex(m)
               enddo
            enddo
         enddo
         write(buffer(n),13) (iscont(m),
     *                       (tx(1,j,m),tx(2,j,m),ll(1,j,m),ll(2,j,m),
     *                        j=1,3),m=1,id)
      enddo
      if (ispaceindexing<=0) write(kpr,32) (buffer(m),m=1,ne)
!
!-- seminvariants
!
      if (ispaceindexing<=0) write(kpr,15) isvet
!
!     kpolTrue = kpol
*     call NumeroGruppoSpaziale(space,nSpaceGroup)
      call sfl14
      if (ispaceindexing<=0) write(kpr,50)
      if (nSpaceGroup.gt.0) then
          if (ispaceindexing<=0) write(kpr,60) nSpaceGroup
c     else
c         write(kpr,70)
      endif
!
!-- lattice translations
!
      lattice = ' '
      lattice(2:2) = space(1:1)
      call ucase(lattice)
      if (lattice(2:2).eq.'P') then
          buffer(1) = lattice // '-lattice: (0,0,0)        '
      elseif (lattice(2:2).eq.'A') then
          buffer(1) = lattice // '-lattice: (0,0,0) '
     *                // '+ (0,1/2,1/2) '
      elseif (lattice(2:2).eq.'B') then
          buffer(1) = lattice // '-lattice: (0,0,0) '
     *                // '+ (1/2,0,1/2) '
      elseif (lattice(2:2).eq.'C') then
          buffer(1) = lattice // '-lattice: (0,0,0) '
     *                // '+ (1/2,1/2,0) '
      elseif (lattice(2:2).eq.'I') then
          buffer(1) = lattice // '-lattice: (0,0,0) '
     *                // '+ (1/2,1/2,1/2) '
      elseif (lattice(2:2).eq.'F') then
          buffer(1) = lattice // '-lattice: (0,0,0) '
     *                // '+ (0,1/2,1/2) '
     *                // '+ (1/2,0,1/2) '
     *                // '+ (1/2,1/2,0) '
      elseif (lattice(2:2).eq.'R') then
          if (ifRhombAx == 0) then
              buffer(1) = lattice // '-lattice: (0,0,0) '
     *                    // '+ (2/3,1/3,1/3) '
     *                    // '+ (1/3,2/3,2/3) '
          else
              buffer(1) = lattice // '-lattice: (0,0,0)        '
          endif
      endif
      if (ispaceindexing<=0) write(kpr,32) ' '
      if (ispaceindexing<=0) write(kpr,32) buffer(1)
!
!-- Allowed origin translations
!
      if (ispaceindexing <= 0) then
          call StampaOriginiRoxi(kpr)
      endif
!!!!!!!!!!!!!!!test
        !call prn_origins(spacegr,lo)
!!!!!!!!!!!!!!!test
!
      return
   13 format(2(' ',i3,') ',2(4a2,','),4a2,4x))
   15 format(//,' Seminvariant condition : ',3a2,4x,5a2)
   19 format (/,' Crystal family',29x,':  ',a)
   20 format (/,' Space group (centrosymmetric)',14x,':  ',a16,a)
   21 format (/,' Space group (noncentrosymmetric)',11x,':  ',a16,a)
   27 format(/,' Symmetry-operations'/)
   32 format(a78)
   50 format(' ')
   60 format(' Space Group Number =',i4)
   70 format(' Space Group Symbol not found in Sir Data Base')
      end
#endif
!-----------------------------------------------------------------------
      subroutine MakeSymmOperators(ncoper)
      USE General, only : lo
      USE Symmetry, only: nsym,kmat,tmat,icent,centrt,latt
!
      implicit none
      integer, intent(in) :: ncoper
      integer :: ifi, ifin(2), i, kt, kt1, l, n, nTot
      real    :: tr, centra(3)
!
      nTot = nsym
      if (icent == 1) then
!
!-- Centrosymmetry
!
          do i=1, nsym
             kmat(nTot+i,1:3,1:3) = -kmat(i,1:3,1:3)
             tmat(nTot+i,1:3)     = -tmat(i,1:3)
          enddo
          nTot = nTot + nsym
      endif
      if (ncoper > 1) then
!
!-- Centring
!
          n = nTot
          do kt=2, ncoper
             do l=1, 3
                kt1 = (kt-1) * 3 + l
                centra(l) = centrt(latt, kt1)
             enddo
             do i=1, nTot
                n = n + 1
                kmat(n,1:3,1:3) = kmat(i,1:3,1:3)
                do l=1, 3
                   tr = tmat(i,l) + centra(l)
                   if (abs(tr - 1.0) < 0.001) tr = 0.0
                   tmat(n,l) = tr
                enddo
             enddo
          enddo
      endif
!
      return
      end
!-----------------------------------------------------------------------
!corr      subroutine OriginiRoxi()
!corr      USE General
!corr!      USE Symmetry
!corr      USE sinterface
!corr!
!corr!--fornisce le origini permesse, per tutti i gruppi spaziali
!corr!
!corr!!!!!!!!!!!!!!!!!!test
!corr          call get_origini_spg(spacegr)
!corr          return
!corr!!!!!!!!!!!!!!!!!!test
!corr      return
!corr      end
