#include "callbacks.h"

gboolean ifToolbar = TRUE;
gboolean ifStatusbar = TRUE;

static mr_action_entry tb_entries[] = {
{0, 1, "Quit", "Exit", "Leave expo", "quit", G_CALLBACK(exit_confirm), NULL, -1, 1, 0}, 
{0, 1, "New Project", "New", "New Project", "filenew", G_CALLBACK(open_newproj_dlg), NULL, -1, 1, 0}, 
{0, 1, "Load", "Load", "Load input (.exp) file and start the run", "opensir", G_CALLBACK(open_file), NULL, 0, 1, 0}, 
{0, 1, "Old project", "Old Project", "Load Project (.bin) file", "openbin", G_CALLBACK(open_file), NULL, 1, 1, 0}, 
{0, 4},
{0, 3, "selectionmode", "selectionmode", "Selection mode", "selectoff", G_CALLBACK(on_set_mode), NULL, 0, 0, 1}, 
{0, 3, "zoommode", "zoommode", "Select area to zoom", "zoom_patt", G_CALLBACK(on_set_mode), NULL, 1, 0, 0}, 
{0, 1, "NoArea", "NoArea", "Show all pattern", "spettro1", G_CALLBACK(c_show_all_pattern), NULL, -1, 0, 0}, 
{0, 1, "Reset View", "Reset View", "Autoscale", "autoscale", G_CALLBACK(c_zoom_right), NULL, 5, 0, 0}, 
{0, 1, "Zoom_left", "Zoom_left", "zoom left", "zoom_left", G_CALLBACK(c_zoom_right), NULL, 1, 0, 0}, 
{0, 1, "Zoom_right", "Zoom_right", "zoom right", "zoom_right", G_CALLBACK(c_zoom_right), NULL, 2, 0, 0}, 
{0, 3, "peaksmode", "peaksmode", "Add peaks (left mouse click) / Del peaks (right mouse click)", "addpeak", G_CALLBACK(on_set_mode), NULL, 2, 0, 0}, 
{0, 3, "pointmode", "pointmode", "Add background point (left mouse click) / Del background point (right mouse click)", "addpoint", G_CALLBACK(on_set_mode), NULL, 3, 0, 0}, 
{0, 3, "legendTog", "legendTog", "Display Legend", "legendaon", G_CALLBACK(toggle_legend), NULL, -1, 0, 1}, 
{0, 1, "Output", "Output", "View output file", "output", G_CALLBACK(c_browserv2), NULL, 5, 1, 0}, 
{0, 4},
{0, -7, "Cycle", NULL, "Improve refinement", "cycle", G_CALLBACK(c_go_command), NULL, 1, 1, 0}, 
{0, 80, "expander", NULL, "expander", "void", NULL, NULL, 0, 0, 0}, 
{0, 1, "display structure", "display structure", "open viewer", "viewmol", G_CALLBACK(call_javs), NULL, 11, 0, 0}, 
{0, 1, "Skip", "Skip", "Skip to the next run", "nextgr", G_CALLBACK(skip_or_stop), NULL, 1, 0, 0}, 
{0, 1, "Stop", "Stop", "Stop the procedure", "stopr", G_CALLBACK(skip_or_stop), NULL, 2, 0, 0}, 
{0, 27, "continue", NULL, "Continue", "next_tb", G_CALLBACK(c_go_command), NULL, -1, 0, 0}
};

static const guint n_entries = G_N_ELEMENTS(tb_entries);

static gpointer toolbaritems = {(gpointer) tb_entries};

static const char *Nomi =   { "toolbar_main"};

#ifdef USE_ACTIONS
static const gchar *tbui_info =
"<ui>"
"  <toolbar name='toolbar_main'>"
"    <toolitem action='Exit'/>"
"    <toolitem action='New'/>"
"    <toolitem action='Load'/>"
"    <toolitem action='Old Project'/>"
"    <separator/>"
"    <toolitem action='selectionmode'/>"
"    <toolitem action='zoommode'/>"
"    <toolitem action='NoArea'/>"
"    <toolitem action='Reset View'/>"
"    <toolitem action='Zoom_left'/>"
"    <toolitem action='Zoom_right'/>"
"    <toolitem action='peaksmode'/>"
"    <toolitem action='pointmode'/>"
"    <toolitem action='legendTog'/>"
"    <toolitem action='Output'/>"
"    <separator/>"
"    <toolitem action='Cycle'/>"
"    <toolitem action='expander'/>"
"    <toolitem action='display structure'/>"
"    <toolitem action='Skip'/>"
"    <toolitem action='Stop'/>"
"    <toolitem action='continue'/>"
"  </toolbar>"
"</ui>";
#endif
