#include <utils.h>

extern GtkWidget *finestre[6];

extern "C" void openwave_(float *wavel, int *radtype)
{
   static const char *rads[] = {"X-ray", "Synchrotron", "Neutron"};
   int nrads = G_N_ELEMENTS(rads);
   GtkWidget *dlg = gtk_dialog_new();
   gtk_window_set_title(GTK_WINDOW(dlg), "Set wavelength radiation");
   gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(finestre[0]));
   gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER_ON_PARENT);

   GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
   GtkWidget *hbox =  table_new(2, 2, FALSE);
   gtk_container_set_border_width (GTK_CONTAINER (hbox), 20);
   gtk_container_add (GTK_CONTAINER (vbox), hbox);
   table_set_row_spacings(hbox, 10);
   table_set_col_spacings(hbox, 20);
   GtkWidget *label = gtk_label_new (" Wavelength: ");
   set_alignment (label, 0, 0.5);
   table_attach_exp(hbox, label, 0, 1, 0, 1);
   GtkWidget  *entry = gtk_entry_new();
   gtk_entry_set_width_chars(GTK_ENTRY(entry), 10);
   gtk_entry_set_text(GTK_ENTRY(entry), g_strdup_printf("%f", *wavel));
   table_attach_exp(hbox, entry, 1, 2, 0, 1);
   label = gtk_label_new (" Radiation: ");
   set_alignment (label, 0, 0.5);
   table_attach_exp(hbox, label, 0, 1, 1, 2);
   GtkWidget *combo = create_combo_str(false);
   fill_combo(combo, rads, nrads, 1);
   table_attach_exp(hbox, combo, 1, 2, 1, 2);

   GtkWidget *button = OK_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK);
   gtk_widget_grab_focus(button);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
             GTK_BUTTONBOX_SPREAD);
   gtk_widget_show_all(dlg);
   int response = gtk_dialog_run(GTK_DIALOG(dlg));
   if(response == GTK_RESPONSE_OK)
   {
      *wavel = (float) atof(gtk_entry_get_text(GTK_ENTRY(entry)));
       get_comboselection(combo, radtype);
   }
   else
      *wavel = 1.54056f;
   gtk_widget_destroy(dlg);
}


