//#define WIP
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

//#define USE_MYTAB 1

#include <cstring>
#include <string>
#include <cstdio>
#ifdef _WIN32
#include <io.h>
#endif
#include <sstream>
#include <fstream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <cctype>

#include <utils.h>
#ifdef MAC_INTEGRATION
#include <gtkosxapplication.h>
#endif
#define ENTRY_SIZE  65
#define HSPIN  22

#define USE_GTK_FILECHOOSER 1
#define DO_SETFILENAME      1
#ifndef GTK_FILE_CHOOSER
#undef USE_GTK_FILECHOOSER
#endif
#ifdef _WIN32
#if !GTK_CHECK_VERSION(2,20,0)
#undef DO_SETFILENAME
#endif
#endif


typedef struct 
               {
                 GtkWidget *dlg;
                 int response;
               } dlg_data;

extern "C" void mr_setenv_(char *string);
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)

#if GTK_MAJOR_VERSION < 3
int caratteri[] =     {
                        GDK_Greek_ALPHA,
                        GDK_Greek_BETA,
                        GDK_Greek_CHI,
                        GDK_Greek_DELTA,
                        GDK_Greek_EPSILON,
                        GDK_Greek_PHI,
                        GDK_Greek_GAMMA,
                        GDK_Greek_ETA,
                        GDK_Greek_IOTA,
                        GDK_Greek_IOTA,
                        GDK_Greek_KAPPA,
                        GDK_Greek_LAMDA,
                        GDK_Greek_MU,
                        GDK_Greek_NU,
                        GDK_Greek_OMICRON,
                        GDK_Greek_PI,
                        GDK_Greek_THETA,
                        GDK_Greek_RHO,
                        GDK_Greek_SIGMA,
                        GDK_Greek_TAU,
                        GDK_Greek_UPSILON,
                        GDK_Greek_IOTA,
                        GDK_Greek_OMEGA,
                        GDK_Greek_XI,
                        GDK_Greek_PSI,
                        GDK_Greek_ZETA };
static int alpha = GDK_Greek_alpha;
static int ALPHA = GDK_Greek_ALPHA;
#else
int caratteri[] =     {
                        GDK_KEY_Greek_ALPHA,
                        GDK_KEY_Greek_BETA,
                        GDK_KEY_Greek_CHI,
                        GDK_KEY_Greek_DELTA,
                        GDK_KEY_Greek_EPSILON,
                        GDK_KEY_Greek_PHI,
                        GDK_KEY_Greek_GAMMA,
                        GDK_KEY_Greek_ETA,
                        GDK_KEY_Greek_IOTA,
                        GDK_KEY_Greek_IOTA,
                        GDK_KEY_Greek_KAPPA,
                        GDK_KEY_Greek_LAMDA,
                        GDK_KEY_Greek_MU,
                        GDK_KEY_Greek_NU,
                        GDK_KEY_Greek_OMICRON,
                        GDK_KEY_Greek_PI,
                        GDK_KEY_Greek_THETA,
                        GDK_KEY_Greek_RHO,
                        GDK_KEY_Greek_SIGMA,
                        GDK_KEY_Greek_TAU,
                        GDK_KEY_Greek_UPSILON,
                        GDK_KEY_Greek_IOTA,
                        GDK_KEY_Greek_OMEGA,
                        GDK_KEY_Greek_XI,
                        GDK_KEY_Greek_PSI,
                        GDK_KEY_Greek_ZETA };
static int alpha = GDK_KEY_Greek_alpha;
static int ALPHA = GDK_KEY_Greek_ALPHA;
#endif

#ifdef NOCURS_FROM_PIXBUF
  const unsigned char 
  cross_bits[] = {
   0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00,
   0x00, 0x00, 0x3e, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01,
   0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00},
  cross_mask[] = {
   0x00, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x00,
   0x00, 0x00, 0x3e, 0xf8, 0x1f, 0x7c, 0x00, 0x00, 0x00, 0x01, 0x80, 0x01,
   0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x00},
  drag1_bits[] = {
   0xff, 0xff, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80,
   0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0x01, 0x80,
   0x01, 0x80, 0x01, 0x80, 0x01, 0x80, 0xff, 0xff},
  drag1_mask[] = {
   0xff, 0xff, 0xff, 0xff, 0x03, 0xc0, 0x03, 0xc0, 0x03, 0xc0, 0x03, 0xc0,
   0x03, 0xc0, 0x03, 0xc0, 0x03, 0xc0, 0x03, 0xc0, 0x03, 0xc0, 0x03, 0xc0,
   0x03, 0xc0, 0x03, 0xc0, 0xff, 0xff, 0xff, 0xff},
  drag2_bits[] = {
   0xb3, 0xcd, 0x01, 0x80, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x01, 0x80,
   0x00, 0x00, 0x01, 0x80, 0x01, 0x80, 0x00, 0x00, 0x01, 0x80, 0x01, 0x80,
   0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0xb3, 0xcd},
  drag2_mask[] = {
   0xb7, 0xed, 0xb7, 0xed, 0x03, 0xe0, 0x00, 0x00, 0x07, 0xc0, 0x03, 0xc0,
   0x00, 0x00, 0x03, 0xc0, 0x03, 0xc0, 0x00, 0x00, 0x03, 0xc0, 0x03, 0xc0,
   0x00, 0x00, 0x07, 0xe0, 0xb7, 0xed, 0xb7, 0xed},
 wait_bits[] = {
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0xe0, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0x0f, 0xe0, 0xff, 0xff, 0x0f, 0xe0, 0xff, 0xff, 0x4f, 0xe5, 0xff,
   0xff, 0x8f, 0xe2, 0xff, 0xff, 0x1f, 0xf1, 0xff, 0xff, 0x3f, 0xf8, 0xff,
   0xff, 0x7f, 0xfd, 0xff, 0xff, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xfe, 0xff,
   0xff, 0x7f, 0xfc, 0xff, 0xff, 0x3f, 0xf9, 0xff, 0xff, 0x1f, 0xf0, 0xff,
   0xff, 0x0f, 0xe1, 0xff, 0xff, 0x8f, 0xe2, 0xff, 0xff, 0x4f, 0xe5, 0xff,
   0xff, 0xaf, 0xea, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0xe0, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
   0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
 wait_mask[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0xfc, 0x7f, 0x00, 0x00, 0xfc, 0x7f, 0x00, 0x00, 0xfc, 0x7f, 0x00,
   0x00, 0xf8, 0x3f, 0x00, 0x00, 0xf8, 0x3f, 0x00, 0x00, 0xf8, 0x3f, 0x00,
   0x00, 0xf8, 0x3f, 0x00, 0x00, 0xf8, 0x3f, 0x00, 0x00, 0xf0, 0x1f, 0x00,
   0x00, 0xe0, 0x0f, 0x00, 0x00, 0xc0, 0x07, 0x00, 0x00, 0xc0, 0x07, 0x00,
   0x00, 0xe0, 0x0f, 0x00, 0x00, 0xf0, 0x1f, 0x00, 0x00, 0xf8, 0x3f, 0x00,
   0x00, 0xf8, 0x3f, 0x00, 0x00, 0xf8, 0x3f, 0x00, 0x00, 0xf8, 0x3f, 0x00,
   0x00, 0xf8, 0x3f, 0x00, 0x00, 0xfc, 0x7f, 0x00, 0x00, 0xfc, 0x7f, 0x00,
   0x00, 0xfc, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
  pick_mask[] = {
   0x00, 0x70, 0x00, 0xf8, 0x00, 0xf8, 0x00, 0xff, 0x00, 0x7e, 0x00, 0x1f,
   0x80, 0x1f, 0xc0, 0x17, 0xe0, 0x03, 0xf0, 0x01, 0xf8, 0x00, 0x7c, 0x00,
   0x3e, 0x00, 0x1e, 0x00, 0x0f, 0x00, 0x02, 0x00  },
  pick_bits[] = {
   0x00, 0x70, 0x00, 0xf8, 0x00, 0xf8, 0x00, 0xff, 0x00, 0x7e, 0x00, 0x1d,
   0x80, 0x18, 0x40, 0x14, 0x20, 0x02, 0x10, 0x01, 0x88, 0x00, 0x44, 0x00,
   0x22, 0x00, 0x12, 0x00, 0x0d, 0x00, 0x02, 0x00 },
  move_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0xc0, 0x01, 0x78, 0x0f, 0x08, 0x18, 0x08, 0x78,
   0x0e, 0x40, 0x09, 0x40, 0x09, 0x40, 0x01, 0x40, 0x01, 0x40, 0x01, 0x40,
   0x03, 0x40, 0xfe, 0x7f, 0x00, 0x00, 0x00, 0x00 },
  move_mask[] = {
   0x00, 0x00, 0x00, 0x00, 0xc0, 0x01, 0xf8, 0x0f, 0xf8, 0x1f, 0xf8, 0x7f,
   0xfe, 0x7f, 0xff, 0x7f, 0xff, 0x7f, 0xff, 0x7f, 0xff, 0x7f, 0xff, 0x7f,
   0xff, 0x7f, 0xfe, 0x7f, 0x00, 0x00, 0x00, 0x00 },
 hand_bits[] = {
   0xff, 0xff, 0xcf, 0xff, 0xcf, 0xff, 0xcf, 0xff, 0xcf, 0xff, 0xcf, 0xff,
   0x4f, 0xfe, 0x4f, 0xf2, 0x0d, 0xf0, 0x09, 0xc0, 0x09, 0xc0, 0x0b, 0xc0,
   0x03, 0xc0, 0x07, 0xc0, 0x07, 0xc0, 0x0f, 0xc0, 0x0f, 0xc0, 0x1f, 0xe0,
   0x1f, 0xe0, 0xff, 0xff},
 hand_mask[] = {
   0x30, 0x00, 0x78, 0x00, 0x78, 0x00, 0x78, 0x00, 0x78, 0x00, 0xf8, 0x01,
   0xf8, 0x0f, 0xfb, 0x1f, 0xff, 0x3f, 0xff, 0x7f, 0xff, 0x7f, 0xfe, 0x7f,
   0xfe, 0x7f, 0xfc, 0x7f, 0xfc, 0x7f, 0xf8, 0x7f, 0xf8, 0x7f, 0xf0, 0x3f,
   0xf0, 0x3f, 0xf0, 0x3f};
static unsigned short
  zoom_bits[] = {
   0x0000, 0x0000, 0x0000, 0x0020, 0x0020, 0x00f8, 0x0420, 0x0020, 0x0200,
   0x0400, 0x0e40, 0x1400, 0x3800, 0x7000, 0x6000, 0x0000 },

  zoom_mask[] = {
   0x00fc, 0x01fe, 0x03fe, 0x07ff, 0x07ff, 0x07ff, 0x07ff, 0x07ff, 0x07fe,
   0x0ffc, 0x1ff8, 0x3e00, 0x7c00, 0xf800, 0xf000, 0x6000 };
#else
   static const char *drag1_filename = "drag1.png",
                     *drag2_filename = "drag2.png",
                     *cross_filename = "selecton.png",
                     *wait_filename = "wait.png",
                     *pick_filename = "pick.png",
                     *hand_filename = "hand.png",
                     *move_filename = "curs.png",
                     *zoom_filename = "preview22.png" ;
#endif

#ifdef USE_MYSPIN

// GTK - The GIMP Toolkit
// Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
//
// GtkSpinButton widget for GTK+
// Copyright (C) 1998 Lars Hamann and Stefan Jeske
//
// MySpinButton widget for GTK+
// Modified by MR

#define MIN_SPIN_BUTTON_WIDTH 30
#define MAX_TIMER_CALLS       5
#define EPSILON               1e-10
#define MAX_DIGITS            20
#define MIN_ARROW_WIDTH       6

struct _MySpinButtonPrivate
{
  GtkAdjustment *adjustment;

  GdkWindow     *panel;

  guint32        timer;

  MySpinButtonUpdatePolicy update_policy;

  gdouble        climb_rate;
  gdouble        timer_step;

  guint          button        : 2;
  guint          click_child   : 2; // valid: GTK_ARROW_UP=0, GTK_ARROW_DOWN=1 or 2=NONE/BOTH 
  guint          digits        : 10;
  guint          in_child      : 2;
  guint          need_timer    : 1;
  guint          numeric       : 1;
  guint          snap_to_ticks : 1;
  guint          timer_calls   : 3;
  guint          wrap          : 1;
};

enum {
  PROP_0,
  PROP_ADJUSTMENT,
  PROP_CLIMB_RATE,
  PROP_DIGITS,
  PROP_SNAP_TO_TICKS,
  PROP_NUMERIC,
  PROP_WRAP,
  PROP_UPDATE_POLICY,
  PROP_VALUE
};

// Signals 
enum
{
  INPUT1,
  OUTPUT,
  VALUE_CHANGED,
  CHANGE_VALUE,
  WRAPPED,
  LAST_SIGNAL
};

static void my_spin_button_editable_init  (GtkEditableInterface *iface);
static void my_spin_button_finalize       (GObject            *object);
static void my_spin_button_set_property   (GObject         *object,
                                            guint            prop_id,
                                            const GValue    *value,
                                            GParamSpec      *pspec);
static void my_spin_button_get_property   (GObject         *object,
                                            guint            prop_id,
                                            GValue          *value,
                                            GParamSpec      *pspec);
static void my_spin_button_destroy        (GtkWidget          *widget);
static void my_spin_button_map            (GtkWidget          *widget);
static void my_spin_button_unmap          (GtkWidget          *widget);
static void my_spin_button_realize        (GtkWidget          *widget);
static void my_spin_button_unrealize      (GtkWidget          *widget);
static void my_spin_button_get_preferred_width  (GtkWidget          *widget,
                                                  gint               *minimum,
                                                  gint               *natural);

static void my_spin_button_size_allocate  (GtkWidget          *widget,
                                            GtkAllocation      *allocation);
static gint my_spin_button_draw           (GtkWidget          *widget,
                                            cairo_t            *cr);
static gint my_spin_button_button_press   (GtkWidget          *widget,
                                            GdkEventButton     *event);
static gint my_spin_button_button_release (GtkWidget          *widget,
                                            GdkEventButton     *event);
static gint my_spin_button_motion_notify  (GtkWidget          *widget,
                                            GdkEventMotion     *event);
static gint my_spin_button_enter_notify   (GtkWidget          *widget,
                                            GdkEventCrossing   *event);
static gint my_spin_button_leave_notify   (GtkWidget          *widget,
                                            GdkEventCrossing   *event);
static gint my_spin_button_focus_out      (GtkWidget          *widget,
                                            GdkEventFocus      *event);
static void my_spin_button_grab_notify    (GtkWidget          *widget,
                                            gboolean            was_grabbed);
static void my_spin_button_state_flags_changed  (GtkWidget     *widget,
                                                  GtkStateFlags  previous_state);
static void my_spin_button_style_updated  (GtkWidget          *widget);
static void my_spin_button_draw_arrow     (MySpinButton      *spin_button,
                                            GtkStyleContext    *context,
                                            cairo_t            *cr,
                                            GtkArrowType        arrow_type);
static gboolean my_spin_button_timer          (MySpinButton      *spin_button);
static gboolean my_spin_button_stop_spinning  (MySpinButton      *spin);
static void my_spin_button_value_changed  (GtkAdjustment      *adjustment,
                                            MySpinButton      *spin_button);
static gint my_spin_button_key_release    (GtkWidget          *widget,
                                            GdkEventKey        *event);
static gint my_spin_button_scroll         (GtkWidget          *widget,
                                            GdkEventScroll     *event);
static void my_spin_button_activate       (GtkEntry           *entry);
static void my_spin_button_get_text_area_size (GtkEntry *entry,
                                                gint     *x,
                                                gint     *y,
                                                gint     *width,
                                                gint     *height);
static void my_spin_button_snap           (MySpinButton      *spin_button,
                                            gdouble             val);
static void my_spin_button_insert_text    (GtkEditable        *editable,
                                            const gchar        *new_text,
                                            gint                new_text_length,
                                            gint               *position);
static void my_spin_button_real_spin      (MySpinButton      *spin_button,
                                            gdouble             step);
static void my_spin_button_real_change_value (MySpinButton   *spin,
                                               GtkScrollType    scroll);

static gint my_spin_button_default_input  (MySpinButton      *spin_button,
                                            gdouble            *new_val);
static gint my_spin_button_default_output (MySpinButton      *spin_button);

static gint spin_button_get_arrow_size     (MySpinButton      *spin_button);

static guint spinbutton_signals[LAST_SIGNAL] = {0};

#define NO_ARROW 2

G_DEFINE_TYPE_WITH_CODE (MySpinButton, my_spin_button, GTK_TYPE_ENTRY,
                         G_IMPLEMENT_INTERFACE (GTK_TYPE_EDITABLE,
                                                my_spin_button_editable_init))

#define add_spin_binding(binding_set, keyval, mask, scroll)            \
  gtk_binding_entry_add_signal (binding_set, keyval, mask,             \
                                "change_value", 1,                     \
                                GTK_TYPE_SCROLL_TYPE, scroll)

static gboolean
gtk_boolean_handled_accumulator (GSignalInvocationHint *ihint,
                                  GValue                *return_accu,
                                  const GValue          *handler_return,
                                  gpointer               dummy)
{
  gboolean continue_emission;
  gboolean signal_handled;

  signal_handled = g_value_get_boolean (handler_return);
  g_value_set_boolean (return_accu, signal_handled);
  continue_emission = !signal_handled;

  return continue_emission;
}

static void
gtk_marshal_BOOLEAN__VOID (GClosure     *closure,
                            GValue       *return_value G_GNUC_UNUSED,
                            guint         n_param_values,
                            const GValue *param_values,
                            gpointer      invocation_hint G_GNUC_UNUSED,
                            gpointer      marshal_data)
{
  typedef gboolean (*GMarshalFunc_BOOLEAN__VOID) (gpointer     data1,
                                                  gpointer     data2);
  register GMarshalFunc_BOOLEAN__VOID callback;
  register GCClosure *cc = (GCClosure*) closure;
  register gpointer data1, data2;
  gboolean v_return;

  g_return_if_fail (return_value != NULL);
  g_return_if_fail (n_param_values == 1);

  if (G_CCLOSURE_SWAP_DATA (closure))
    {
      data1 = closure->data;
      data2 = g_value_get_pointer (param_values + 0);
    }
  else
    {
      data1 = g_value_get_pointer (param_values + 0);
      data2 = closure->data;
    }
  callback = (GMarshalFunc_BOOLEAN__VOID) (marshal_data ? marshal_data : cc->callback);

  v_return = callback (data1,
                       data2);

  g_value_set_boolean (return_value, v_return);
}

static void
gtk_marshal_INT__POINTER (GClosure     *closure,
                           GValue       *return_value G_GNUC_UNUSED,
                           guint         n_param_values,
                           const GValue *param_values,
                           gpointer      invocation_hint G_GNUC_UNUSED,
                           gpointer      marshal_data)
{
  typedef gint (*GMarshalFunc_INT__POINTER) (gpointer     data1,
                                             gpointer     arg_1,
                                             gpointer     data2);
  register GMarshalFunc_INT__POINTER callback;
  register GCClosure *cc = (GCClosure*) closure;
  register gpointer data1, data2;
  gint v_return;

  g_return_if_fail (return_value != NULL);
  g_return_if_fail (n_param_values == 2);

  if (G_CCLOSURE_SWAP_DATA (closure))
    {
      data1 = closure->data;
      data2 = g_value_get_pointer (param_values + 0);
    }
  else
    {
      data1 = g_value_get_pointer (param_values + 0);
      data2 = closure->data;
    }
  callback = (GMarshalFunc_INT__POINTER) (marshal_data ? marshal_data : cc->callback);

  v_return = callback (data1,
                       g_value_get_pointer (param_values + 1),
                       data2);

  g_value_set_int (return_value, v_return);
}

static void my_spin_button_class_init (MySpinButtonClass *klass)
{
  GObjectClass     *gobject_class = G_OBJECT_CLASS (klass);
  GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS (klass);
  GtkEntryClass    *entry_class = GTK_ENTRY_CLASS (klass);
  GtkBindingSet    *binding_set;

  gobject_class->finalize = my_spin_button_finalize;
  gobject_class->set_property = my_spin_button_set_property;
  gobject_class->get_property = my_spin_button_get_property;

  widget_class->destroy = my_spin_button_destroy;
  widget_class->map = my_spin_button_map;
  widget_class->unmap = my_spin_button_unmap;
  widget_class->realize = my_spin_button_realize;
  widget_class->unrealize = my_spin_button_unrealize;
  widget_class->get_preferred_width = my_spin_button_get_preferred_width;
  widget_class->size_allocate = my_spin_button_size_allocate;
  widget_class->draw = my_spin_button_draw;
  widget_class->scroll_event = my_spin_button_scroll;
  widget_class->button_press_event = my_spin_button_button_press;
  widget_class->button_release_event = my_spin_button_button_release;
  widget_class->motion_notify_event = my_spin_button_motion_notify;
  widget_class->key_release_event = my_spin_button_key_release;
  widget_class->enter_notify_event = my_spin_button_enter_notify;
  widget_class->leave_notify_event = my_spin_button_leave_notify;
  widget_class->focus_out_event = my_spin_button_focus_out;
  widget_class->grab_notify = my_spin_button_grab_notify;
  widget_class->state_flags_changed = my_spin_button_state_flags_changed;
  widget_class->style_updated = my_spin_button_style_updated;

  entry_class->activate = my_spin_button_activate;
  entry_class->get_text_area_size = my_spin_button_get_text_area_size;

  klass->input = NULL;
  klass->output = NULL;
  klass->change_value = my_spin_button_real_change_value;

  g_object_class_install_property (gobject_class,
                                   PROP_ADJUSTMENT,
           g_param_spec_object ("adjustment",
                                ("Adjustment"),
                                ("The adjustment that holds the value of the spin button"),
                                GTK_TYPE_ADJUSTMENT,
                                (GParamFlags) G_PARAM_READWRITE));

  g_object_class_install_property (gobject_class,
                                   PROP_CLIMB_RATE,
                                   g_param_spec_double ("climb-rate",
                                                        ("Climb Rate"),
                                                        ("The acceleration rate when you hold down a button"),
                                                        0.0,
                                                        G_MAXDOUBLE,
                                                        0.0,
                                                       (GParamFlags)  G_PARAM_READWRITE));

  g_object_class_install_property (gobject_class,
                                   PROP_DIGITS,
                                   g_param_spec_uint ("digits",
                                                      ("Digits"),
                                                      ("The number of decimal places to display"),
                                                      0,
                                                      MAX_DIGITS,
                                                      0,
                                                     (GParamFlags)  G_PARAM_READWRITE));

  g_object_class_install_property (gobject_class,
                                   PROP_SNAP_TO_TICKS,
                                   g_param_spec_boolean ("snap-to-ticks",
                                                         ("Snap to Ticks"),
                                                         ("Whether erroneous values are automatically changed to a spin button's nearest step increment"),
                                                         FALSE,
                                                      (GParamFlags)    G_PARAM_READWRITE));

  g_object_class_install_property (gobject_class,
                                   PROP_NUMERIC,
                                   g_param_spec_boolean ("numeric",
                                                         ("Numeric"),
                                                         ("Whether non-numeric characters should be ignored"),
                                                         FALSE,
                                                       (GParamFlags)   G_PARAM_READWRITE));

  g_object_class_install_property (gobject_class,
                                   PROP_WRAP,
                                   g_param_spec_boolean ("wrap",
                                                         ("Wrap"),
                                                         ("Whether a spin button should wrap upon reaching its limits"),
                                                         FALSE,
                                                       (GParamFlags)   G_PARAM_READWRITE));

  g_object_class_install_property (gobject_class,
                                   PROP_UPDATE_POLICY,
                                   g_param_spec_enum ("update-policy",
                                                      ("Update Policy"),
                                                      ("Whether the spin button should update always, or only when the value is legal"),
                                                      GTK_TYPE_SPIN_BUTTON_UPDATE_POLICY,
                                                      GTK_UPDATE_ALWAYS,
                                                     (GParamFlags)  G_PARAM_READWRITE));

  g_object_class_install_property (gobject_class,
                                   PROP_VALUE,
                                   g_param_spec_double ("value",
                                                        ("Value"),
                                                        ("Reads the current value, or sets a new value"),
                                                        -G_MAXDOUBLE,
                                                        G_MAXDOUBLE,
                                                        0.0,
                                                     (GParamFlags)    G_PARAM_READWRITE));

  gtk_widget_class_install_style_property_parser (widget_class,
                                                  g_param_spec_enum ("shadow-type",
                                                                     "Shadow Type",
                                                                     ("Style of bevel around the spin button"),
                                                                     GTK_TYPE_SHADOW_TYPE,
                                                                     GTK_SHADOW_IN,
                                                                   (GParamFlags)   G_PARAM_READABLE),
                                                  gtk_rc_property_parse_enum);
  spinbutton_signals[INPUT1] =
    g_signal_new (("input"),
                  G_TYPE_FROM_CLASS (gobject_class),
                  G_SIGNAL_RUN_LAST,
                  G_STRUCT_OFFSET (MySpinButtonClass, input),
                  NULL, NULL,
                  gtk_marshal_INT__POINTER,
                  G_TYPE_INT, 1,
                  G_TYPE_POINTER);

  spinbutton_signals[OUTPUT] =
    g_signal_new (("output"),
                  G_TYPE_FROM_CLASS (gobject_class),
                  G_SIGNAL_RUN_LAST,
                  G_STRUCT_OFFSET (MySpinButtonClass, output),
                  gtk_boolean_handled_accumulator, NULL,
                  gtk_marshal_BOOLEAN__VOID,
                  G_TYPE_BOOLEAN, 0);

  spinbutton_signals[VALUE_CHANGED] =
    g_signal_new (("value-changed"),
                  G_TYPE_FROM_CLASS (gobject_class),
                  G_SIGNAL_RUN_LAST,
                  G_STRUCT_OFFSET (MySpinButtonClass, value_changed),
                  NULL, NULL,
                  g_cclosure_marshal_VOID__VOID,
                  G_TYPE_NONE, 0);

  spinbutton_signals[WRAPPED] =
    g_signal_new (("wrapped"),
                  G_TYPE_FROM_CLASS (gobject_class),
                  G_SIGNAL_RUN_LAST,
                  G_STRUCT_OFFSET (MySpinButtonClass, wrapped),
                  NULL, NULL,
                  g_cclosure_marshal_VOID__VOID,
                  G_TYPE_NONE, 0);

  spinbutton_signals[CHANGE_VALUE] =
    g_signal_new (("change-value"),
                  G_TYPE_FROM_CLASS (gobject_class),
                  (GSignalFlags) (G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION),
                  G_STRUCT_OFFSET (MySpinButtonClass, change_value),
                  NULL, NULL,
                  g_cclosure_marshal_VOID__ENUM,
                  G_TYPE_NONE, 1,
                  GTK_TYPE_SCROLL_TYPE);

  binding_set = gtk_binding_set_by_class (klass);

  add_spin_binding (binding_set, GDK_KEY_Up, (GdkModifierType)0, GTK_SCROLL_STEP_UP);
  add_spin_binding (binding_set, GDK_KEY_KP_Up,(GdkModifierType) 0, GTK_SCROLL_STEP_UP);
  add_spin_binding (binding_set, GDK_KEY_Down,(GdkModifierType) 0, GTK_SCROLL_STEP_DOWN);
  add_spin_binding (binding_set, GDK_KEY_KP_Down,(GdkModifierType) 0, GTK_SCROLL_STEP_DOWN);
  add_spin_binding (binding_set, GDK_KEY_Page_Up,(GdkModifierType) 0, GTK_SCROLL_PAGE_UP);
  add_spin_binding (binding_set, GDK_KEY_Page_Down,(GdkModifierType) 0, GTK_SCROLL_PAGE_DOWN);
  add_spin_binding (binding_set, GDK_KEY_Page_Up, GDK_CONTROL_MASK, GTK_SCROLL_END);
  add_spin_binding (binding_set, GDK_KEY_Page_Down, GDK_CONTROL_MASK, GTK_SCROLL_START);

  g_type_class_add_private (klass, sizeof (MySpinButtonPrivate));

//  gtk_widget_class_set_accessible_type (widget_class, MY_TYPE_SPIN_BUTTON_ACCESSIBLE);
}

static void
my_spin_button_editable_init (GtkEditableInterface *iface)
{
  iface->insert_text = my_spin_button_insert_text;
}

static void my_spin_button_set_property (GObject *object,
                              guint         prop_id,
                              const GValue *value,
                              GParamSpec   *pspec)
{
  MySpinButton *spin_button = MY_SPIN_BUTTON (object);
  MySpinButtonPrivate *priv = spin_button->priv;

  switch (prop_id)
    {
      GtkAdjustment *adjustment;

    case PROP_ADJUSTMENT:
      adjustment = GTK_ADJUSTMENT (g_value_get_object (value));
      if (!adjustment)
        adjustment = gtk_adjustment_new (0.0, 0.0, 0.0, 0.0, 0.0, 0.0);
      my_spin_button_set_adjustment (spin_button, adjustment);
      break;
    case PROP_CLIMB_RATE:
      my_spin_button_configure (spin_button,
                                 priv->adjustment,
                                 g_value_get_double (value),
                                 priv->digits);
      break;
    case PROP_DIGITS:
      my_spin_button_configure (spin_button,
                                 priv->adjustment,
                                 priv->climb_rate,
                                 g_value_get_uint (value));
      break;
    case PROP_SNAP_TO_TICKS:
      my_spin_button_set_snap_to_ticks (spin_button, g_value_get_boolean (value));
      break;
    case PROP_NUMERIC:
      my_spin_button_set_numeric (spin_button, g_value_get_boolean (value));
      break;
    case PROP_WRAP:
      my_spin_button_set_wrap (spin_button, g_value_get_boolean (value));
      break;
    case PROP_UPDATE_POLICY:
      my_spin_button_set_update_policy (spin_button, (MySpinButtonUpdatePolicy)g_value_get_enum (value));
      break;
    case PROP_VALUE:
      my_spin_button_set_value (spin_button, g_value_get_double (value));
      break;
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
      break;
    }
}

static void my_spin_button_get_property (GObject *object,
                              guint         prop_id,
                              GValue       *value,
                              GParamSpec   *pspec)
{
  MySpinButton *spin_button = MY_SPIN_BUTTON (object);
  MySpinButtonPrivate *priv = spin_button->priv;

  switch (prop_id)
    {
    case PROP_ADJUSTMENT:
      g_value_set_object (value, priv->adjustment);
      break;
    case PROP_CLIMB_RATE:
      g_value_set_double (value, priv->climb_rate);
      break;
    case PROP_DIGITS:
      g_value_set_uint (value, priv->digits);
      break;
    case PROP_SNAP_TO_TICKS:
      g_value_set_boolean (value, priv->snap_to_ticks);
      break;
    case PROP_NUMERIC:
      g_value_set_boolean (value, priv->numeric);
      break;
    case PROP_WRAP:
      g_value_set_boolean (value, priv->wrap);
      break;
    case PROP_UPDATE_POLICY:
      g_value_set_enum (value, priv->update_policy);
      break;
     case PROP_VALUE:
       g_value_set_double (value, gtk_adjustment_get_value (priv->adjustment));
      break;
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
      break;
    }
}

static void my_spin_button_init (MySpinButton *spin_button)
{
  MySpinButtonPrivate *priv;
  GtkStyleContext *context;

  spin_button->priv = G_TYPE_INSTANCE_GET_PRIVATE (spin_button,
                                                   MY_TYPE_SPIN_BUTTON,
                                                   MySpinButtonPrivate);
  priv = spin_button->priv;

  priv->adjustment = NULL;
  priv->panel = NULL;
  priv->timer = 0;
  priv->climb_rate = 0.0;
  priv->timer_step = 0.0;
  priv->update_policy = MY_UPDATE_ALWAYS;
  priv->in_child = NO_ARROW;
  priv->click_child = NO_ARROW;
  priv->button = 0;
  priv->need_timer = FALSE;
  priv->timer_calls = 0;
  priv->digits = 0;
  priv->numeric = FALSE;
  priv->wrap = FALSE;
  priv->snap_to_ticks = FALSE;

  my_spin_button_set_adjustment (spin_button,
                                  gtk_adjustment_new (0, 0, 0, 0, 0, 0));

  context = gtk_widget_get_style_context (GTK_WIDGET (spin_button));
  gtk_style_context_add_class (context, GTK_STYLE_CLASS_SPINBUTTON);
}

static void my_spin_button_finalize (GObject *object)
{
  my_spin_button_set_adjustment (MY_SPIN_BUTTON (object), NULL);

  G_OBJECT_CLASS (my_spin_button_parent_class)->finalize (object);
}

static void my_spin_button_destroy (GtkWidget *widget)
{
  my_spin_button_stop_spinning (MY_SPIN_BUTTON (widget));

  GTK_WIDGET_CLASS (my_spin_button_parent_class)->destroy (widget);
}

static void my_spin_button_map (GtkWidget *widget)
{
  MySpinButton *spin_button = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin_button->priv;

  if (gtk_widget_get_realized (widget) && !gtk_widget_get_mapped (widget))
    {
      GTK_WIDGET_CLASS (my_spin_button_parent_class)->map (widget);
      gdk_window_show (priv->panel);
    }
}

static void my_spin_button_unmap (GtkWidget *widget)
{
  MySpinButton *spin_button = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin_button->priv;

  if (gtk_widget_get_mapped (widget))
    {
      my_spin_button_stop_spinning (MY_SPIN_BUTTON (widget));

      gdk_window_hide (priv->panel);
      GTK_WIDGET_CLASS (my_spin_button_parent_class)->unmap (widget);
    }
}

static void my_spin_button_realize (GtkWidget *widget)
{
  MySpinButton *spin_button = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin_button->priv;
  GtkStyleContext *context;
  GtkStateFlags state;
  GtkAllocation allocation;
  GtkRequisition requisition;
  GdkWindowAttr attributes;
  gint attributes_mask;
  gboolean return_val;
  gint arrow_size;
  gint req_height;
  GtkBorder padding;

  arrow_size = spin_button_get_arrow_size (spin_button);

  gtk_widget_get_preferred_size (widget, &requisition, NULL);
  req_height = requisition.height - gtk_widget_get_margin_top (widget) - gtk_widget_get_margin_bottom (widget);
  gtk_widget_get_allocation (widget, &allocation);

  gtk_widget_set_events (widget, gtk_widget_get_events (widget) |
                         GDK_KEY_RELEASE_MASK);
  GTK_WIDGET_CLASS (my_spin_button_parent_class)->realize (widget);

  attributes.window_type = GDK_WINDOW_CHILD;
  attributes.wclass = GDK_INPUT_ONLY;
  attributes.visual = gtk_widget_get_visual (widget);
  attributes.event_mask = gtk_widget_get_events (widget);
  attributes.event_mask |= GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK
    | GDK_BUTTON_RELEASE_MASK | GDK_LEAVE_NOTIFY_MASK | GDK_ENTER_NOTIFY_MASK
    | GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK;

  attributes_mask = GDK_WA_X | GDK_WA_Y | GDK_WA_VISUAL;

  state = gtk_widget_get_state_flags (widget);
  context = gtk_widget_get_style_context (widget);
  gtk_style_context_get_padding (context, state, &padding);

  attributes.x = allocation.x + allocation.width - arrow_size - (padding.left + padding.right);
  attributes.y = allocation.y + (allocation.height - req_height) / 2;
  attributes.width = arrow_size + padding.left + padding.right;
  attributes.height = req_height;

  priv->panel = gdk_window_new (gtk_widget_get_window (widget),
                                &attributes, attributes_mask);
  gdk_window_set_user_data (priv->panel, widget);

  return_val = FALSE;
  g_signal_emit (spin_button, spinbutton_signals[OUTPUT], 0, &return_val);
  if (return_val == FALSE)
    my_spin_button_default_output (spin_button);

  gtk_widget_queue_resize (GTK_WIDGET (spin_button));
}

static void my_spin_button_unrealize (GtkWidget *widget)
{
  MySpinButton *spin = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin->priv;

  GTK_WIDGET_CLASS (my_spin_button_parent_class)->unrealize (widget);

  if (priv->panel)
    {
      gdk_window_set_user_data (priv->panel, NULL);
      gdk_window_destroy (priv->panel);
      priv->panel = NULL;
    }
}

static int compute_double_length (double val, int digits)
{
  int a;
  int extra;

  a = 1;
  if (fabs (val) > 1.0)
    a = (int) floor (log10 (fabs (val))) + 1;

  extra = 0;

  /* The dot: */
  if (digits > 0)
    extra++;

  /* The sign: */
  if (val < 0)
    extra++;

  return a + digits + extra;
}

static void my_spin_button_get_preferred_width (GtkWidget *widget,
                                     gint      *minimum,
                                     gint      *natural)
{
  MySpinButton *spin_button = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin_button->priv;
  GtkEntry *entry = GTK_ENTRY (widget);
  GtkStyleContext *style_context;
  GtkBorder padding;
  gint arrow_size;

  style_context = gtk_widget_get_style_context (widget);

  arrow_size = spin_button_get_arrow_size (spin_button);

  GTK_WIDGET_CLASS (my_spin_button_parent_class)->get_preferred_width (widget, minimum, natural);

  if (gtk_entry_get_width_chars (entry) < 0)
    {
      PangoContext *context;
      const PangoFontDescription *font_desc;
      PangoFontMetrics *metrics;
      gint width;
      gint w;
      gint string_len;
      gint max_string_len;
      gint digit_width;
      gboolean interior_focus;
      gint focus_width;

      gtk_widget_style_get (widget,
                            "interior-focus", &interior_focus,
                            "focus-line-width", &focus_width,
                            NULL);

      gtk_style_context_get(style_context, GTK_STATE_FLAG_NORMAL, "font",
       &font_desc, NULL);
//      font_desc = gtk_style_context_get_font (style_context, GTK_STATE_FLAG_NORMAL);

      context = gtk_widget_get_pango_context (widget);
      metrics = pango_context_get_metrics (context, font_desc,
                                           pango_context_get_language (context));

      digit_width = pango_font_metrics_get_approximate_digit_width (metrics);
      digit_width = PANGO_SCALE *
        ((digit_width + PANGO_SCALE - 1) / PANGO_SCALE);

      pango_font_metrics_unref (metrics);

      width = MIN_SPIN_BUTTON_WIDTH;
      max_string_len = MAX (10, compute_double_length (1e9 * gtk_adjustment_get_step_increment (priv->adjustment),
                                                       priv->digits));

      string_len = compute_double_length (gtk_adjustment_get_upper (priv->adjustment),
                                          priv->digits);
      w = PANGO_PIXELS (MIN (string_len, max_string_len) * digit_width);
      width = MAX (width, w);
      string_len = compute_double_length (gtk_adjustment_get_lower (priv->adjustment), priv->digits);
      w = PANGO_PIXELS (MIN (string_len, max_string_len) * digit_width);
      width = MAX (width, w);

//      gint xborder, yborder;
//      GtkBorder inner_border;
//      _gtk_entry_get_borders (entry, &xborder, &yborder);
//      _gtk_entry_effective_inner_border (entry, &inner_border);

//      width += xborder * 2 + inner_border.left + inner_border.right;

      *minimum = width;
      *natural = width;
    }

  gtk_style_context_get_padding (style_context,
                                 gtk_widget_get_state_flags (widget),
                                 &padding);

  *minimum += arrow_size + padding.left + padding.right;
  *natural += arrow_size + padding.left + padding.right;
}

static void my_spin_button_size_allocate (GtkWidget *widget,
                               GtkAllocation *allocation)
{
  MySpinButton *spin = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin->priv;
  GtkAllocation panel_allocation;
  GtkRequisition requisition;
  GtkStyleContext *context;
  GtkStateFlags state;
  GtkBorder padding;
  gint arrow_size;
  gint panel_width;
  gint req_height;

  arrow_size = spin_button_get_arrow_size (spin);
  context = gtk_widget_get_style_context (widget);
  state = gtk_widget_get_state_flags (widget);

  gtk_style_context_get_padding (context, state, &padding);
  panel_width = arrow_size + padding.left + padding.right;

  gtk_widget_get_preferred_size (widget, &requisition, NULL);
  req_height = requisition.height - gtk_widget_get_margin_top (widget) - gtk_widget_get_margin_bottom (widget);

  gtk_widget_set_allocation (widget, allocation);

  if (gtk_widget_get_direction (widget) == GTK_TEXT_DIR_RTL)
    panel_allocation.x = allocation->x;
  else
    panel_allocation.x = allocation->x + allocation->width - panel_width;

  panel_allocation.width = panel_width;
  panel_allocation.height = MIN (req_height, allocation->height);

  panel_allocation.y = allocation->y +
                       (allocation->height - req_height) / 2;

  GTK_WIDGET_CLASS (my_spin_button_parent_class)->size_allocate (widget, allocation);

  if (gtk_widget_get_realized (widget))
    {
      gdk_window_move_resize (priv->panel,
                              panel_allocation.x,
                              panel_allocation.y,
                              panel_allocation.width,
                              panel_allocation.height);
    }

  gtk_widget_queue_draw (GTK_WIDGET (spin));
}

static gint my_spin_button_draw (GtkWidget *widget, cairo_t *cr)
{
  MySpinButton *spin = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin->priv;
  GtkStyleContext *context;
  GtkStateFlags state = (GtkStateFlags) 0;
  gboolean is_rtl;

  is_rtl = (gtk_widget_get_direction (widget) == GTK_TEXT_DIR_RTL);
  context = gtk_widget_get_style_context (widget);

  cairo_save (cr);
  GTK_WIDGET_CLASS (my_spin_button_parent_class)->draw (widget, cr);
  cairo_restore (cr);

  state = gtk_widget_get_state_flags (widget);

  gtk_style_context_save (context);
  gtk_style_context_set_state (context, state);

  if (is_rtl)
    gtk_style_context_set_junction_sides (context, GTK_JUNCTION_RIGHT);
  else
    gtk_style_context_set_junction_sides (context, GTK_JUNCTION_LEFT);

  gtk_cairo_transform_to_window (cr, widget, priv->panel);

  my_spin_button_draw_arrow (spin, context, cr, GTK_ARROW_UP);
  my_spin_button_draw_arrow (spin, context, cr, GTK_ARROW_DOWN);

  gtk_style_context_restore (context);

  return FALSE;
}

static gboolean spin_button_at_limit (MySpinButton *spin_button,
                     GtkArrowType   arrow)
{
  MySpinButtonPrivate *priv = spin_button->priv;
  GtkArrowType effective_arrow;

  if (priv->wrap)
    return FALSE;

  if (gtk_adjustment_get_step_increment (priv->adjustment) > 0)
    effective_arrow = arrow;
  else
    effective_arrow = arrow == GTK_ARROW_UP ? GTK_ARROW_DOWN : GTK_ARROW_UP;

  if (effective_arrow == GTK_ARROW_UP &&
      (gtk_adjustment_get_upper (priv->adjustment) - gtk_adjustment_get_value (priv->adjustment) <= EPSILON))
    return TRUE;

  if (effective_arrow == GTK_ARROW_DOWN &&
      (gtk_adjustment_get_value (priv->adjustment) - gtk_adjustment_get_lower (priv->adjustment) <= EPSILON))
    return TRUE;

  return FALSE;
}

static void my_spin_button_draw_arrow (MySpinButton   *spin_button,
                            GtkStyleContext *context,
                            cairo_t         *cr,
                            GtkArrowType     arrow_type)
{
  MySpinButtonPrivate *priv;
  GtkJunctionSides junction;
  GtkStateFlags state;
  GtkWidget *widget;
  gdouble angle;
  gint panel_height;
  gdouble size, width, height, x, y;

  g_return_if_fail (arrow_type == GTK_ARROW_UP || arrow_type == GTK_ARROW_DOWN);

  gtk_style_context_save (context);
  gtk_style_context_add_class (context, GTK_STYLE_CLASS_BUTTON);

  priv = spin_button->priv;
  widget = GTK_WIDGET (spin_button);
  junction = gtk_style_context_get_junction_sides (context);

  panel_height = gdk_window_get_height (priv->panel);

  if (spin_button_at_limit (spin_button, arrow_type))
    state = GTK_STATE_FLAG_INSENSITIVE;
  else
    {
      if (priv->click_child == arrow_type)
        state = GTK_STATE_FLAG_ACTIVE;
      else
        {
          if (priv->in_child == arrow_type &&
              priv->click_child == NO_ARROW)
            state = GTK_STATE_FLAG_PRELIGHT;
          else
            state = gtk_widget_get_state_flags (widget);
        }
    }

  // first, draw the background and the frame
  if (arrow_type == GTK_ARROW_UP)
    {
      x = 0;
      y = 0;
      int j = (int) junction;
      j |= GTK_JUNCTION_BOTTOM;
      junction = (GtkJunctionSides) j;
    }
  else if (arrow_type == GTK_ARROW_DOWN)
    {
      x = 0;
      y = panel_height / 2.0;
      int j = (int) junction;
      j |= GTK_JUNCTION_TOP;
      junction = (GtkJunctionSides) j;
    }

  gtk_style_context_set_junction_sides (context, junction);
  gtk_style_context_set_state (context, state);

  height = panel_height / 2.0;
  width = gdk_window_get_width (priv->panel);
  gtk_render_background (context, cr,
                         x, y, width, height);
  gtk_render_frame (context, cr,
                    x, y, width, height);

  // make the actual rendered arrow smaller than text size 
  size = spin_button_get_arrow_size (spin_button);
  size = MIN (size, width);
  size *= 0.8;

  x = (width - size) / 2.0;

  if (arrow_type == GTK_ARROW_UP)
    {
      y = (height - size / 2.0) / 2.0;
      angle = 0;
    }
  else if (arrow_type == GTK_ARROW_DOWN)
    {
      y = height + ((height - size / 2.0) / 2.0) - size / 2.0;
      angle = G_PI;
    }

  gtk_render_arrow (context, cr,
                    angle, x, y, size);

  gtk_style_context_restore (context);
}

static gint my_spin_button_enter_notify (GtkWidget        *widget,
                              GdkEventCrossing *event)
{
  MySpinButton *spin = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin->priv;
  GtkRequisition requisition;
  gint req_height;

  if (event->window == priv->panel)
    {
      GdkDevice *device;
      gint x;
      gint y;

      device = gdk_event_get_device ((GdkEvent *) event);
      gdk_window_get_device_position (priv->panel, device, &x, &y, NULL);

      gtk_widget_get_preferred_size (widget, &requisition, NULL);
      req_height = requisition.height - gtk_widget_get_margin_top (widget) - gtk_widget_get_margin_bottom (widget);

      if (y <= req_height / 2)
        priv->in_child = GTK_ARROW_UP;
      else
        priv->in_child = GTK_ARROW_DOWN;

      gtk_widget_queue_draw (GTK_WIDGET (spin));
    }

  return GTK_WIDGET_CLASS (my_spin_button_parent_class)->enter_notify_event (widget, event);
}

static gint my_spin_button_leave_notify (GtkWidget        *widget,
                              GdkEventCrossing *event)
{
  MySpinButton *spin = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin->priv;

  if (priv->in_child != NO_ARROW)
    {
      priv->in_child = NO_ARROW;
      gtk_widget_queue_draw (GTK_WIDGET (spin));
    }

  return GTK_WIDGET_CLASS (my_spin_button_parent_class)->leave_notify_event (widget, event);
}

static gint
my_spin_button_focus_out (GtkWidget     *widget,
                           GdkEventFocus *event)
{
  if (gtk_editable_get_editable (GTK_EDITABLE (widget)))
    my_spin_button_update (MY_SPIN_BUTTON (widget));

  return GTK_WIDGET_CLASS (my_spin_button_parent_class)->focus_out_event (widget, event);
}

static void my_spin_button_grab_notify (GtkWidget *widget,
                             gboolean   was_grabbed)
{
  MySpinButton *spin = MY_SPIN_BUTTON (widget);

  if (!was_grabbed)
    {
      if (my_spin_button_stop_spinning (spin))
        gtk_widget_queue_draw (GTK_WIDGET (spin));
    }
}

static void my_spin_button_state_flags_changed (GtkWidget     *widget,
                                     GtkStateFlags  previous_state)
{
  MySpinButton *spin = MY_SPIN_BUTTON (widget);

  if (!gtk_widget_is_sensitive (widget))
    {
      if (my_spin_button_stop_spinning (spin))
        gtk_widget_queue_draw (GTK_WIDGET (spin));
    }
}

static void my_spin_button_style_updated (GtkWidget *widget)
{
#if GTK_MINOR_VERSION < 18
  MySpinButton *spin = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin->priv;

  if (gtk_widget_get_realized (widget))
    {
      GtkStyleContext *context;

      context = gtk_widget_get_style_context (widget);
      gtk_style_context_set_background (context, priv->panel);
    }
#endif
  GTK_WIDGET_CLASS (my_spin_button_parent_class)->style_updated (widget);
}


static gint my_spin_button_scroll (GtkWidget      *widget,
                        GdkEventScroll *event)
{
  MySpinButton *spin = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin->priv;

  if (event->direction == GDK_SCROLL_UP)
    {
      if (!gtk_widget_has_focus (widget))
        gtk_widget_grab_focus (widget);
      my_spin_button_real_spin (spin, gtk_adjustment_get_step_increment (priv->adjustment));
    }
  else if (event->direction == GDK_SCROLL_DOWN)
    {
      if (!gtk_widget_has_focus (widget))
        gtk_widget_grab_focus (widget);
      my_spin_button_real_spin (spin, -gtk_adjustment_get_step_increment (priv->adjustment));
    }
  else
    return FALSE;

  return TRUE;
}

static gboolean my_spin_button_stop_spinning (MySpinButton *spin)
{
  MySpinButtonPrivate *priv = spin->priv;
  gboolean did_spin = FALSE;

  if (priv->timer)
    {
      g_source_remove (priv->timer);
      priv->timer = 0;
      priv->need_timer = FALSE;

      did_spin = TRUE;
    }

  priv->button = 0;
  priv->timer_step = gtk_adjustment_get_step_increment (priv->adjustment);
  priv->timer_calls = 0;

  priv->click_child = NO_ARROW;

  return did_spin;
}

static void start_spinning (MySpinButton *spin,
                GtkArrowType   click_child,
                gdouble        step)
{
  MySpinButtonPrivate *priv;

  g_return_if_fail (click_child == GTK_ARROW_UP || click_child == GTK_ARROW_DOWN);

  priv = spin->priv;

  priv->click_child = click_child;

  if (!priv->timer)
    {
      //GtkSettings *settings = gtk_widget_get_settings (GTK_WIDGET (spin));
      guint        timeout = 500;

      //g_object_get (settings, "gtk-timeout-initial", &timeout, NULL);

      priv->timer_step = step;
      priv->need_timer = TRUE;
      priv->timer = gdk_threads_add_timeout (timeout,
                                   (GSourceFunc) my_spin_button_timer,
                                   (gpointer) spin);
    }
  my_spin_button_real_spin (spin, click_child == GTK_ARROW_UP ? step : -step);

  gtk_widget_queue_draw (GTK_WIDGET (spin));
}

static gint my_spin_button_button_press (GtkWidget      *widget,
                              GdkEventButton *event)
{
  MySpinButton *spin = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin->priv;

  if (!priv->button)
    {
      if (event->window == priv->panel)
        {
          GtkRequisition requisition;
          gint req_height;

          if (!gtk_widget_has_focus (widget))
            gtk_widget_grab_focus (widget);
          priv->button = event->button;

          if (gtk_editable_get_editable (GTK_EDITABLE (widget)))
            my_spin_button_update (spin);

          gtk_widget_get_preferred_size (widget, &requisition, NULL);
          req_height = requisition.height - gtk_widget_get_margin_top (widget) - gtk_widget_get_margin_bottom (widget);

          if (event->y <= req_height / 2)
            {
              if (event->button == 1)
                start_spinning (spin, GTK_ARROW_UP, gtk_adjustment_get_step_increment (priv->adjustment));
              else if (event->button == 2)
                start_spinning (spin, GTK_ARROW_UP, gtk_adjustment_get_page_increment (priv->adjustment));
              else
                priv->click_child = GTK_ARROW_UP;
            }
          else
            {
              if (event->button == 1)
                start_spinning (spin, GTK_ARROW_DOWN, gtk_adjustment_get_step_increment (priv->adjustment));
              else if (event->button == 2)
                start_spinning (spin, GTK_ARROW_DOWN, gtk_adjustment_get_page_increment (priv->adjustment));
              else
                priv->click_child = GTK_ARROW_DOWN;
            }
          return TRUE;
        }
      else
        return GTK_WIDGET_CLASS (my_spin_button_parent_class)->button_press_event (widget, event);
    }
  return FALSE;
}

static gint my_spin_button_button_release (GtkWidget      *widget,
                                GdkEventButton *event)
{
  MySpinButton *spin = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin->priv;
  gint arrow_size;

  arrow_size = spin_button_get_arrow_size (spin);

  if (event->button == priv->button)
    {
      int click_child = priv->click_child;

      my_spin_button_stop_spinning (spin);

      if (event->button == 3)
        {
          GtkRequisition requisition;
          gint req_height;
          GtkStyleContext *context;
          GtkStateFlags state;
          GtkBorder padding;

          gtk_widget_get_preferred_size (widget, &requisition, NULL);
          req_height = requisition.height - gtk_widget_get_margin_top (widget) - gtk_widget_get_margin_bottom (widget);

          context = gtk_widget_get_style_context (widget);
          state = gtk_widget_get_state_flags (widget);
          gtk_style_context_get_padding (context, state, &padding);

          if (event->y >= 0 && event->x >= 0 &&
              event->y <= req_height &&
              event->x <= arrow_size + padding.left + padding.right)
            {
              if (click_child == GTK_ARROW_UP &&
                  event->y <= req_height / 2)
                {
                  gdouble diff;

                  diff = gtk_adjustment_get_upper (priv->adjustment) - gtk_adjustment_get_value (priv->adjustment);
                  if (diff > EPSILON)
                    my_spin_button_real_spin (spin, diff);
                }
              else if (click_child == GTK_ARROW_DOWN &&
                       event->y > req_height / 2)
                {
                  gdouble diff;

                  diff = gtk_adjustment_get_value (priv->adjustment) - gtk_adjustment_get_lower (priv->adjustment);
                  if (diff > EPSILON)
                    my_spin_button_real_spin (spin, -diff);
                }
            }
        }
      gtk_widget_queue_draw (GTK_WIDGET (spin));

      return TRUE;
    }
  else
    return GTK_WIDGET_CLASS (my_spin_button_parent_class)->button_release_event (widget, event);
}

static gint my_spin_button_motion_notify (GtkWidget      *widget,
                               GdkEventMotion *event)
{
  MySpinButton *spin = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin->priv;

  if (priv->button)
    return FALSE;

  if (event->window == priv->panel)
    {
      GtkRequisition requisition;
      gint req_height;
      gint y = (gint) event->y;

      gdk_event_request_motions (event);

      gtk_widget_get_preferred_size (widget, &requisition, NULL);
      req_height = requisition.height - gtk_widget_get_margin_top (widget) - gtk_widget_get_margin_bottom (widget);

      if (y <= req_height / 2 &&
          priv->in_child == GTK_ARROW_DOWN)
        {
          priv->in_child = GTK_ARROW_UP;
          gtk_widget_queue_draw (GTK_WIDGET (spin));
        }
      else if (y > req_height / 2 &&
          priv->in_child == GTK_ARROW_UP)
        {
          priv->in_child = GTK_ARROW_DOWN;
          gtk_widget_queue_draw (GTK_WIDGET (spin));
        }

      return FALSE;
    }

  return GTK_WIDGET_CLASS (my_spin_button_parent_class)->motion_notify_event (widget, event);
}

static gint my_spin_button_timer (MySpinButton *spin_button)
{
  MySpinButtonPrivate *priv = spin_button->priv;
  gboolean retval = FALSE;

  if (priv->timer)
    {
      if (priv->click_child == GTK_ARROW_UP)
        my_spin_button_real_spin (spin_button, priv->timer_step);
      else
        my_spin_button_real_spin (spin_button, -priv->timer_step);

      if (priv->need_timer)
        {
          GtkSettings *settings = gtk_widget_get_settings (GTK_WIDGET (spin_button));
          guint        timeout;

          g_object_get (settings, "gtk-timeout-repeat", &timeout, NULL);

          priv->need_timer = FALSE;
          priv->timer = gdk_threads_add_timeout (timeout,
                                              (GSourceFunc) my_spin_button_timer,
                                              (gpointer) spin_button);
        }
      else
        {
          if (priv->climb_rate > 0.0 && priv->timer_step
              < gtk_adjustment_get_page_increment (priv->adjustment))
            {
              if (priv->timer_calls < MAX_TIMER_CALLS)
                priv->timer_calls++;
              else
                {
                  priv->timer_calls = 0;
                  priv->timer_step += priv->climb_rate;
                }
            }
          retval = TRUE;
        }
    }

  return retval;
}

static void my_spin_button_value_changed (GtkAdjustment *adjustment,
                               MySpinButton *spin_button)
{
  gboolean return_val;

  g_return_if_fail (GTK_IS_ADJUSTMENT (adjustment));

  return_val = FALSE;
  g_signal_emit (spin_button, spinbutton_signals[OUTPUT], 0, &return_val);
  if (return_val == FALSE)
    my_spin_button_default_output (spin_button);

  g_signal_emit (spin_button, spinbutton_signals[VALUE_CHANGED], 0);

  gtk_widget_queue_draw (GTK_WIDGET (spin_button));

  g_object_notify (G_OBJECT (spin_button), "value");
}

static void my_spin_button_real_change_value (MySpinButton *spin,
                                   GtkScrollType  scroll)
{
  MySpinButtonPrivate *priv = spin->priv;
  gdouble old_value;

  my_spin_button_update (spin);
  old_value = gtk_adjustment_get_value (priv->adjustment);

  switch (scroll)
    {
    case GTK_SCROLL_STEP_BACKWARD:
    case GTK_SCROLL_STEP_DOWN:
    case GTK_SCROLL_STEP_LEFT:
      my_spin_button_real_spin (spin, -priv->timer_step);

      if (priv->climb_rate > 0.0 && priv->timer_step
          < gtk_adjustment_get_page_increment (priv->adjustment))
        {
          if (priv->timer_calls < MAX_TIMER_CALLS)
            priv->timer_calls++;
          else
            {
              priv->timer_calls = 0;
              priv->timer_step += priv->climb_rate;
            }
        }
      break;

    case GTK_SCROLL_STEP_FORWARD:
    case GTK_SCROLL_STEP_UP:
    case GTK_SCROLL_STEP_RIGHT:
      my_spin_button_real_spin (spin, priv->timer_step);

      if (priv->climb_rate > 0.0 && priv->timer_step
          < gtk_adjustment_get_page_increment (priv->adjustment))
        {
          if (priv->timer_calls < MAX_TIMER_CALLS)
            priv->timer_calls++;
          else
            {
              priv->timer_calls = 0;
              priv->timer_step += priv->climb_rate;
            }
        }
      break;

    case GTK_SCROLL_PAGE_BACKWARD:
    case GTK_SCROLL_PAGE_DOWN:
    case GTK_SCROLL_PAGE_LEFT:
      my_spin_button_real_spin (spin, -gtk_adjustment_get_page_increment (priv->adjustment));
      break;

    case GTK_SCROLL_PAGE_FORWARD:
    case GTK_SCROLL_PAGE_UP:
    case GTK_SCROLL_PAGE_RIGHT:
      my_spin_button_real_spin (spin, gtk_adjustment_get_page_increment (priv->adjustment));
      break;

    case GTK_SCROLL_START:
      {
        gdouble diff = gtk_adjustment_get_value (priv->adjustment) - gtk_adjustment_get_lower (priv->adjustment);
        if (diff > EPSILON)
          my_spin_button_real_spin (spin, -diff);
        break;
      }

    case GTK_SCROLL_END:
      {
        gdouble diff = gtk_adjustment_get_upper (priv->adjustment) - gtk_adjustment_get_value (priv->adjustment);
        if (diff > EPSILON)
          my_spin_button_real_spin (spin, diff);
        break;
      }

    default:
      g_warning ("Invalid scroll type %d for MySpinButton::change-value", scroll);
      break;
    }

  my_spin_button_update (spin);

  if (gtk_adjustment_get_value (priv->adjustment) == old_value)
    gtk_widget_error_bell (GTK_WIDGET (spin));
}

static gint my_spin_button_key_release (GtkWidget   *widget,
                             GdkEventKey *event)
{
  MySpinButton *spin = MY_SPIN_BUTTON (widget);
  MySpinButtonPrivate *priv = spin->priv;

  priv->timer_step = gtk_adjustment_get_step_increment (priv->adjustment);
  priv->timer_calls = 0;

  return TRUE;
}

static void my_spin_button_snap (MySpinButton *spin_button,
                      gdouble        val)
{
  MySpinButtonPrivate *priv = spin_button->priv;
  gdouble inc;
  gdouble tmp;

  inc = gtk_adjustment_get_step_increment (priv->adjustment);
  if (inc == 0)
    return;

  tmp = (val - gtk_adjustment_get_lower (priv->adjustment)) / inc;
  if (tmp - floor (tmp) < ceil (tmp) - tmp)
    val = gtk_adjustment_get_lower (priv->adjustment) + floor (tmp) * inc;
  else
    val = gtk_adjustment_get_lower (priv->adjustment) + ceil (tmp) * inc;

  my_spin_button_set_value (spin_button, val);
}

static void my_spin_button_activate (GtkEntry *entry)
{
  if (gtk_editable_get_editable (GTK_EDITABLE (entry)))
    my_spin_button_update (MY_SPIN_BUTTON (entry));

  GTK_ENTRY_CLASS (my_spin_button_parent_class)->activate (entry);
}

static void my_spin_button_get_text_area_size (GtkEntry *entry,
                                    gint     *x,
                                    gint     *y,
                                    gint     *width,
                                    gint     *height)
{
  GtkStyleContext *context;
  GtkStateFlags state;
  GtkWidget *widget;
  GtkBorder padding;
  gint arrow_size;
  gint panel_width;

  GTK_ENTRY_CLASS (my_spin_button_parent_class)->get_text_area_size (entry, x, y, width, height);

  widget = GTK_WIDGET (entry);
  state = gtk_widget_get_state_flags (widget);
  context = gtk_widget_get_style_context (widget);
  gtk_style_context_get_padding (context, state, &padding);

  arrow_size = spin_button_get_arrow_size (MY_SPIN_BUTTON (entry));
  panel_width = arrow_size + padding.left + padding.right;

  if (width)
    *width -= panel_width;

  if (gtk_widget_get_direction (GTK_WIDGET (entry)) == GTK_TEXT_DIR_RTL && x)
    *x += panel_width;
}

static void my_spin_button_insert_text (GtkEditable *editable,
                             const gchar *new_text,
                             gint         new_text_length,
                             gint        *position)
{
  GtkEntry *entry = GTK_ENTRY (editable);
  MySpinButton *spin = MY_SPIN_BUTTON (editable);
  MySpinButtonPrivate *priv = spin->priv;
  GtkEditableInterface *parent_editable_iface;

  parent_editable_iface = (GtkEditableInterface*) g_type_interface_peek (my_spin_button_parent_class,
                                                 GTK_TYPE_EDITABLE);

  if (priv->numeric)
    {
      struct lconv *lc;
      gboolean sign;
      gint dotpos = -1;
      gint i;
//      guint32 pos_sign;
//      guint32 neg_sign;
      char pos_sign;
      char neg_sign;
      gint entry_length;
      const gchar *entry_text;

      entry_length = gtk_entry_get_text_length (entry);
      entry_text = gtk_entry_get_text (entry);

      lc = localeconv ();

      if (*(lc->negative_sign))
        neg_sign = *(lc->negative_sign);
      else
        neg_sign = '-';

      if (*(lc->positive_sign))
        pos_sign = *(lc->positive_sign);
      else
        pos_sign = '+';

#ifdef G_OS_WIN32
      if (pos_sign >= '0' && pos_sign <= '9')
        pos_sign = '+';
#endif

      for (sign=0, i=0; i<entry_length; i++)
        if ((entry_text[i] == neg_sign) ||
            (entry_text[i] == pos_sign))
          {
            sign = 1;
            break;
          }

      if (sign && !(*position))
        return;

      for (dotpos=-1, i=0; i<entry_length; i++)
        if (entry_text[i] == *(lc->decimal_point))
          {
            dotpos = i;
            break;
          }

      if (dotpos > -1 && *position > dotpos &&
          (gint)priv->digits - entry_length
            + dotpos - new_text_length + 1 < 0)
        return;

      for (i = 0; i < new_text_length; i++)
        {
          if (new_text[i] == neg_sign || new_text[i] == pos_sign)
            {
              if (sign || (*position) || i)
                return;
              sign = TRUE;
            }
          else if (new_text[i] == *(lc->decimal_point))
            {
              if (!priv->digits || dotpos > -1 ||
                  (new_text_length - 1 - i + entry_length
                    - *position > (gint)priv->digits))
                return;
              dotpos = *position + i;
            }
          else if (new_text[i] < 0x30 || new_text[i] > 0x39)
            return;
        }
    }

  parent_editable_iface->insert_text (editable, new_text,
                                      new_text_length, position);
}

static void my_spin_button_real_spin (MySpinButton *spin_button,
                           gdouble        increment)
{
  MySpinButtonPrivate *priv = spin_button->priv;
  GtkAdjustment *adjustment;
  gdouble new_value = 0.0;
  gboolean wrapped = FALSE;

  adjustment = priv->adjustment;

  new_value = gtk_adjustment_get_value (adjustment) + increment;

  if (increment > 0)
    {
      if (priv->wrap)
        {
          if (fabs (gtk_adjustment_get_value (adjustment) - gtk_adjustment_get_upper (adjustment)) < EPSILON)
            {
              new_value = gtk_adjustment_get_lower (adjustment);
              wrapped = TRUE;
            }
          else if (new_value > gtk_adjustment_get_upper (adjustment))
            new_value = gtk_adjustment_get_upper (adjustment);
        }
      else
        new_value = MIN (new_value, gtk_adjustment_get_upper (adjustment));
    }
  else if (increment < 0)
    {
      if (priv->wrap)
        {
          if (fabs (gtk_adjustment_get_value (adjustment) - gtk_adjustment_get_lower (adjustment)) < EPSILON)
            {
              new_value = gtk_adjustment_get_upper (adjustment);
              wrapped = TRUE;
            }
          else if (new_value < gtk_adjustment_get_lower (adjustment))
            new_value = gtk_adjustment_get_lower (adjustment);
        }
      else
        new_value = MAX (new_value, gtk_adjustment_get_lower (adjustment));
    }

  if (fabs (new_value - gtk_adjustment_get_value (adjustment)) > EPSILON)
    gtk_adjustment_set_value (adjustment, new_value);

  if (wrapped)
    g_signal_emit (spin_button, spinbutton_signals[WRAPPED], 0);

  gtk_widget_queue_draw (GTK_WIDGET (spin_button));
}

static gint my_spin_button_default_input (MySpinButton *spin_button,
                               gdouble       *new_val)
{
  gchar *err = NULL;

  *new_val = g_strtod (gtk_entry_get_text (GTK_ENTRY (spin_button)), &err);
  if (*err)
    return GTK_INPUT_ERROR;
  else
    return FALSE;
}

static gint my_spin_button_default_output (MySpinButton *spin_button)
{
  MySpinButtonPrivate *priv = spin_button->priv;

  gchar *buf = g_strdup_printf ("%0.*f", priv->digits, gtk_adjustment_get_value (priv->adjustment));

  if (strcmp (buf, gtk_entry_get_text (GTK_ENTRY (spin_button))))
    gtk_entry_set_text (GTK_ENTRY (spin_button), buf);
  g_free (buf);
  return FALSE;
}


// ***                  Public interface                   ***

void my_spin_button_configure (MySpinButton *spin_button,
                           GtkAdjustment *adjustment,
                           gdouble        climb_rate,
                           guint          digits)
{
  MySpinButtonPrivate *priv;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  if (adjustment)
    my_spin_button_set_adjustment (spin_button, adjustment);
  else
    adjustment = priv->adjustment;

  g_object_freeze_notify (G_OBJECT (spin_button));
  if (priv->digits != digits)
    {
      priv->digits = digits;
      g_object_notify (G_OBJECT (spin_button), "digits");
    }

  if (priv->climb_rate != climb_rate)
    {
      priv->climb_rate = climb_rate;
      g_object_notify (G_OBJECT (spin_button), "climb-rate");
    }
  g_object_thaw_notify (G_OBJECT (spin_button));

#if GTK_MINOR_VERSION < 18
  gtk_adjustment_value_changed (adjustment);
#endif
}

GtkWidget *my_spin_button_new (GtkAdjustment *adjustment,
                     gdouble        climb_rate,
                     guint          digits)
{
  MySpinButton *spin;

  if (adjustment)
    g_return_val_if_fail (GTK_IS_ADJUSTMENT (adjustment), NULL);

  spin = (MySpinButton *) g_object_new (MY_TYPE_SPIN_BUTTON, NULL);

  my_spin_button_configure (spin, adjustment, climb_rate, digits);

  return GTK_WIDGET (spin);
}

GtkWidget *my_spin_button_new_with_range (gdouble min,
                                gdouble max,
                                gdouble step)
{
  GtkAdjustment *adjustment;
  MySpinButton *spin;
  gint digits;
  if(step == 0.0)
  {
     step = 1;
     g_print("Something wrong with LC_NUMERIC \n");
  }

  g_return_val_if_fail (min <= max, NULL);
  g_return_val_if_fail (step != 0.0, NULL);

  spin = (MySpinButton *) g_object_new (MY_TYPE_SPIN_BUTTON, NULL);

  adjustment = gtk_adjustment_new (min, min, max, step, 10 * step, 0);

  if (fabs (step) >= 1.0 || step == 0.0)
    digits = 0;
  else {
    digits = abs ((gint) floor (log10 (fabs (step))));
    if (digits > MAX_DIGITS)
      digits = MAX_DIGITS;
  }

  my_spin_button_configure (spin, adjustment, step, digits);

  my_spin_button_set_numeric (spin, TRUE);

  return GTK_WIDGET (spin);
}

static void adjustment_changed_cb (GtkAdjustment *adjustment, gpointer data)
{
  MySpinButton *spin_button = MY_SPIN_BUTTON (data);
  MySpinButtonPrivate *priv = spin_button->priv;

  priv->timer_step = gtk_adjustment_get_step_increment (priv->adjustment);
  gtk_widget_queue_resize (GTK_WIDGET (spin_button));
}

void my_spin_button_set_adjustment (MySpinButton *spin_button,
                                GtkAdjustment *adjustment)
{
  MySpinButtonPrivate *priv;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  if (priv->adjustment != adjustment)
    {
      if (priv->adjustment)
        {
          g_signal_handlers_disconnect_by_func (priv->adjustment,
                                                (GClosure *)my_spin_button_value_changed,
                                                spin_button);
          g_signal_handlers_disconnect_by_func (priv->adjustment,
                                                (GClosure *)adjustment_changed_cb,
                                                spin_button);
          g_object_unref (priv->adjustment);
        }
      priv->adjustment = adjustment;
      if (adjustment)
        {
          g_object_ref_sink (adjustment);
          g_signal_connect (adjustment, "value-changed",
                            G_CALLBACK (my_spin_button_value_changed),
                            spin_button);
          g_signal_connect (adjustment, "changed",
                            G_CALLBACK (adjustment_changed_cb),
                            spin_button);
          priv->timer_step = gtk_adjustment_get_step_increment (priv->adjustment);
        }

      gtk_widget_queue_resize (GTK_WIDGET (spin_button));
    }

  g_object_notify (G_OBJECT (spin_button), "adjustment");
}

GtkAdjustment * my_spin_button_get_adjustment (MySpinButton *spin_button)
{
  g_return_val_if_fail (MY_IS_SPIN_BUTTON (spin_button), NULL);

  return spin_button->priv->adjustment;
}

void my_spin_button_set_digits (MySpinButton *spin_button,
                            guint          digits)
{
  MySpinButtonPrivate *priv;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  if (priv->digits != digits)
    {
      priv->digits = digits;
      my_spin_button_value_changed (priv->adjustment, spin_button);
      g_object_notify (G_OBJECT (spin_button), "digits");

      gtk_widget_queue_resize (GTK_WIDGET (spin_button));
    }
}

guint my_spin_button_get_digits (MySpinButton *spin_button)
{
  g_return_val_if_fail (MY_IS_SPIN_BUTTON (spin_button), 0);

  return spin_button->priv->digits;
}

void my_spin_button_set_increments (MySpinButton *spin_button,
                                gdouble        step,
                                gdouble        page)
{
  MySpinButtonPrivate *priv;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  gtk_adjustment_configure (priv->adjustment,
                            gtk_adjustment_get_value (priv->adjustment),
                            gtk_adjustment_get_lower (priv->adjustment),
                            gtk_adjustment_get_upper (priv->adjustment),
                            step,
                            page,
                            gtk_adjustment_get_page_size (priv->adjustment));
}

void my_spin_button_get_increments (MySpinButton *spin_button,
                                gdouble       *step,
                                gdouble       *page)
{
  MySpinButtonPrivate *priv;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  if (step)
    *step = gtk_adjustment_get_step_increment (priv->adjustment);
  if (page)
    *page = gtk_adjustment_get_page_increment (priv->adjustment);
}

void my_spin_button_set_range (MySpinButton *spin_button,
                           gdouble        min,
                           gdouble        max)
{
  GtkAdjustment *adjustment;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  adjustment = spin_button->priv->adjustment;

  gtk_adjustment_configure (adjustment,
                            CLAMP (gtk_adjustment_get_value (adjustment), min, max),
                            min,
                            max,
                            gtk_adjustment_get_step_increment (adjustment),
                            gtk_adjustment_get_page_increment (adjustment),
                            gtk_adjustment_get_page_size (adjustment));
}

void my_spin_button_get_range (MySpinButton *spin_button,
                           gdouble       *min,
                           gdouble       *max)
{
  MySpinButtonPrivate *priv;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  if (min)
    *min = gtk_adjustment_get_lower (priv->adjustment);
  if (max)
    *max = gtk_adjustment_get_upper (priv->adjustment);
}

gdouble my_spin_button_get_value (MySpinButton *spin_button)
{
  g_return_val_if_fail (MY_IS_SPIN_BUTTON (spin_button), 0.0);

  return gtk_adjustment_get_value (spin_button->priv->adjustment);
}

gint my_spin_button_get_value_as_int (MySpinButton *spin_button)
{
  MySpinButtonPrivate *priv;
  gdouble val;

  g_return_val_if_fail (MY_IS_SPIN_BUTTON (spin_button), 0);

  priv = spin_button->priv;

  val = gtk_adjustment_get_value (priv->adjustment);
  if (val - floor (val) < ceil (val) - val)
    return (gint)floor (val);
  else
    return (gint)ceil (val);
}

void my_spin_button_set_value (MySpinButton *spin_button,
                           gdouble        value)
{
  MySpinButtonPrivate *priv;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  if (fabs (value - gtk_adjustment_get_value (priv->adjustment)) > EPSILON)
    gtk_adjustment_set_value (priv->adjustment, value);
  else
    {
      gint return_val = FALSE;
      g_signal_emit (spin_button, spinbutton_signals[OUTPUT], 0, &return_val);
      if (return_val == FALSE)
        my_spin_button_default_output (spin_button);
    }
}

void my_spin_button_set_update_policy (MySpinButton             *spin_button,
                                   MySpinButtonUpdatePolicy  policy)
{
  MySpinButtonPrivate *priv;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  if (priv->update_policy != policy)
    {
      priv->update_policy = policy;
      g_object_notify (G_OBJECT (spin_button), "update-policy");
    }
}

MySpinButtonUpdatePolicy my_spin_button_get_update_policy
                (MySpinButton *spin_button)
{
  g_return_val_if_fail (MY_IS_SPIN_BUTTON (spin_button), MY_UPDATE_ALWAYS);

  return spin_button->priv->update_policy;
}

void my_spin_button_set_numeric (MySpinButton *spin_button,
                             gboolean       numeric)
{
  MySpinButtonPrivate *priv;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  numeric = numeric != FALSE;

  if (priv->numeric != numeric)
    {
       priv->numeric = numeric;
       g_object_notify (G_OBJECT (spin_button), "numeric");
    }
}

gboolean my_spin_button_get_numeric (MySpinButton *spin_button)
{
  g_return_val_if_fail (MY_IS_SPIN_BUTTON (spin_button), FALSE);

  return spin_button->priv->numeric;
}

void my_spin_button_set_wrap (MySpinButton  *spin_button,
                          gboolean        wrap)
{
  MySpinButtonPrivate *priv;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  wrap = wrap != FALSE;

  if (priv->wrap != wrap)
    {
       priv->wrap = wrap;

       g_object_notify (G_OBJECT (spin_button), "wrap");
    }
}

gboolean my_spin_button_get_wrap (MySpinButton *spin_button)
{
  g_return_val_if_fail (MY_IS_SPIN_BUTTON (spin_button), FALSE);

  return spin_button->priv->wrap;
}

static gint spin_button_get_arrow_size (MySpinButton *spin_button)
{
  const PangoFontDescription *font_desc;
  GtkStyleContext *context;
  gint size;
  gint arrow_size;

  context = gtk_widget_get_style_context (GTK_WIDGET (spin_button));
//  font_desc = gtk_style_context_get_font (context, GTK_STATE_FLAG_NORMAL);
  gtk_style_context_get(context, GTK_STATE_FLAG_NORMAL, "font",
       &font_desc, NULL);

  size = pango_font_description_get_size (font_desc);
  arrow_size = MAX (PANGO_PIXELS (size), MIN_ARROW_WIDTH);

  return arrow_size - arrow_size % 2; 
}

void my_spin_button_set_snap_to_ticks (MySpinButton *spin_button,
                                   gboolean       snap_to_ticks)
{
  MySpinButtonPrivate *priv;
  guint new_val;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  new_val = (snap_to_ticks != 0);

  if (new_val != priv->snap_to_ticks)
    {
      priv->snap_to_ticks = new_val;
      if (new_val && gtk_editable_get_editable (GTK_EDITABLE (spin_button)))
        my_spin_button_update (spin_button);

      g_object_notify (G_OBJECT (spin_button), "snap-to-ticks");
    }
}

gboolean my_spin_button_get_snap_to_ticks (MySpinButton *spin_button)
{
  g_return_val_if_fail (MY_IS_SPIN_BUTTON (spin_button), FALSE);

  return spin_button->priv->snap_to_ticks;
}

void my_spin_button_spin (MySpinButton *spin_button,
                      MySpinType    direction,
                      gdouble        increment)
{
  MySpinButtonPrivate *priv;
  GtkAdjustment *adjustment;
  gdouble diff;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  adjustment = priv->adjustment;

  if (increment != 0 && increment != gtk_adjustment_get_step_increment (adjustment) &&
      (direction == MY_SPIN_STEP_FORWARD ||
       direction == MY_SPIN_STEP_BACKWARD))
    {
      if (direction == MY_SPIN_STEP_BACKWARD && increment > 0)
        increment = -increment;
      direction = MY_SPIN_USER_DEFINED;
    }

  switch (direction)
    {
    case MY_SPIN_STEP_FORWARD:

      my_spin_button_real_spin (spin_button, gtk_adjustment_get_step_increment (adjustment));
      break;

    case MY_SPIN_STEP_BACKWARD:

      my_spin_button_real_spin (spin_button, -gtk_adjustment_get_step_increment (adjustment));
      break;

    case MY_SPIN_PAGE_FORWARD:

      my_spin_button_real_spin (spin_button, gtk_adjustment_get_page_increment (adjustment));
      break;

    case MY_SPIN_PAGE_BACKWARD:

      my_spin_button_real_spin (spin_button, -gtk_adjustment_get_page_increment (adjustment));
      break;

    case MY_SPIN_HOME:

      diff = gtk_adjustment_get_value (adjustment) - gtk_adjustment_get_lower (adjustment);
      if (diff > EPSILON)
        my_spin_button_real_spin (spin_button, -diff);
      break;

    case MY_SPIN_END:

      diff = gtk_adjustment_get_upper (adjustment) - gtk_adjustment_get_value (adjustment);
      if (diff > EPSILON)
        my_spin_button_real_spin (spin_button, diff);
      break;

    case MY_SPIN_USER_DEFINED:

      if (increment != 0)
        my_spin_button_real_spin (spin_button, increment);
      break;

    default:
      break;
    }
}

void my_spin_button_update (MySpinButton *spin_button)
{
  MySpinButtonPrivate *priv;
  gdouble val;
  gint error = 0;
  gint return_val;

  g_return_if_fail (MY_IS_SPIN_BUTTON (spin_button));

  priv = spin_button->priv;

  return_val = FALSE;
  g_signal_emit (spin_button, spinbutton_signals[INPUT1], 0, &val, &return_val);
  if (return_val == FALSE)
    {
      return_val = my_spin_button_default_input (spin_button, &val);
      error = (return_val == GTK_INPUT_ERROR);
    }
  else if (return_val == GTK_INPUT_ERROR)
    error = 1;

  gtk_widget_queue_draw (GTK_WIDGET (spin_button));

  if (priv->update_policy == MY_UPDATE_ALWAYS)
    {
      if (val < gtk_adjustment_get_lower (priv->adjustment))
        val = gtk_adjustment_get_lower (priv->adjustment);
      else if (val > gtk_adjustment_get_upper (priv->adjustment))
        val = gtk_adjustment_get_upper (priv->adjustment);
    }
  else if ((priv->update_policy == MY_UPDATE_IF_VALID) &&
           (error ||
            val < gtk_adjustment_get_lower (priv->adjustment) ||
            val > gtk_adjustment_get_upper (priv->adjustment)))
    {
      my_spin_button_value_changed (priv->adjustment, spin_button);
      return;
    }

  if (priv->snap_to_ticks)
    my_spin_button_snap (spin_button, val);
  else
    my_spin_button_set_value (spin_button, val);
}

GdkWindow *_my_spin_button_get_panel (MySpinButton *spin_button)
{
  return spin_button->priv->panel;
}
#endif

int MRblend(int fg, int bg, double fgfactor, double flim)
{
    if(flim == 0)
       return (int) ((double)fg * fgfactor);


    if(flim == 1)
       return (int) ((double)fg + (double)(bg - fg) * fgfactor);

    if(fgfactor <= flim)
       return (int) ((double)fg * MRmin((0.2 + 0.8*fgfactor / flim), 1.));
                                                                                 
    return (int) ((double)bg + (double)(fg - bg) * (1-fgfactor)/(1-flim));
}

void set_mandatory(GtkWidget *label)
{
    const char *labelstring = gtk_label_get_text(GTK_LABEL(label));
    std::string new_string = labelstring;
    new_string.append (" (<span foreground=\"red\"> * </span>)");
    gtk_label_set_markup(GTK_LABEL(label), new_string.c_str());
}

char *special_car(int chr)
{
    gunichar car;
    char *str1= g_new0(char, 7);

    car = gdk_keyval_to_unicode(chr);
    g_unichar_to_utf8(car, str1);
    return str1;
}

char *special_car_greek(int chr)
{
    gunichar car;
    char *str1= g_new0(char, 7);
    int newchr;

    if(chr >= 'a')
       newchr = caratteri[chr-'a'] + alpha-ALPHA;
    else
       newchr = caratteri[chr-'A'];
    car = gdk_keyval_to_unicode(newchr);
    g_unichar_to_utf8(car, str1);
    return str1;
}

bool parse_text(const char *str_in)
{
   //gchar *text;
   //PangoAttrList *attrs;

   //gboolean result = pango_parse_markup (str_in, -1, 0, &attrs, &text, NULL, NULL);
   gboolean result = pango_parse_markup (str_in, -1, 0, NULL, NULL, NULL, NULL);
   return (result != 0);
}

GtkWidget*
lookup_widget                          (GtkWidget       *widget,
                                        const gchar     *widget_name)
{
  GtkWidget *parent, *found_widget;

  for (;;)
    {
      if (GTK_IS_MENU (widget))
        parent = gtk_menu_get_attach_widget (GTK_MENU (widget));
      else
        parent = gtk_widget_get_parent(widget);
      if (!parent)
        parent = static_cast<GtkWidget*>(g_object_get_data (G_OBJECT (widget), "GladeParentKey"));
      if (parent == NULL)
        break;
      widget = parent;
    }

  found_widget = (GtkWidget*) g_object_get_data (G_OBJECT (widget),
                                                   widget_name);
  if (!found_widget)
    g_print ("Widget not found: %s\n", widget_name);
  return found_widget;
}

GObject *lookup_object (GtkWidget *widget, const gchar *widget_name)
{
  GtkWidget *parent;
  GObject  *found_object;

  for (;;)
  {
      if (GTK_IS_MENU (widget))
        parent = gtk_menu_get_attach_widget (GTK_MENU (widget));
      else
        parent = gtk_widget_get_parent(widget);
      if (!parent)
        parent = static_cast<GtkWidget*>(g_object_get_data (G_OBJECT (widget), "GladeParentKey"));
      if (parent == NULL)
        break;
      widget = parent;
  }

  found_object = (GObject *) g_object_get_data (G_OBJECT (widget), widget_name);
  if (!found_object)
    g_print ("object not found: %s\n", widget_name);
  return found_object;
}

GtkWidget *get_widget(GtkWidget *father, const char *name)
{
   if(!father)
      return NULL;
#ifdef WIP
   if(g_object_get_data(G_OBJECT(father), name) == NULL)
       g_print ("object not found: %s\n", name);
#endif
   if (GTK_IS_WIDGET(g_object_get_data(G_OBJECT(father), name)))
       return GTK_WIDGET(g_object_get_data(G_OBJECT(father), name));
   else
      return NULL;
}

gpointer get_object(GtkWidget *father, const char *name)
{
   if(!father)
      return NULL;
//#ifdef WIP
//   if(g_object_get_data(G_OBJECT(father), name) == NULL)
//       g_print ("object not found: %s\n", name);
//#endif
   return (g_object_get_data(G_OBJECT(father), name));
}

int get_int(gpointer father, const char *name)
{
   if(!father)
      return 0;
   if (g_object_get_data(G_OBJECT(father), name))
       return GPOINTER_TO_INT( g_object_get_data(G_OBJECT(father), name));
   else
      return 0;
}

char *get_string(GtkWidget *father, const char *name)
{
   if(!father)
      return NULL;
   if (g_object_get_data(G_OBJECT(father), name))
       return (char *)(g_object_get_data(G_OBJECT(father), name));
   else
      return NULL;
}

char *getpwd (void)
{
  char *tmpstr, *cwd;
  int lstr;

  tmpstr = g_get_current_dir();
  size_t sz = strlen(tmpstr) + 2;
  cwd = g_new0(char, sz); 
  CopiaStringa(cwd, sz, tmpstr);
  lstr = (int) strlen(cwd);

  if(lstr > 0)
      if(*(cwd+lstr-1) == G_DIR_SEPARATOR)
         *(cwd+lstr-1) = '\0';
  return cwd;
}

static GList *pixmaps_directories = NULL;

// Use this function to set the directory containing installed pixmaps. 
void add_pixmap_directory  (const gchar *directory)
{
  pixmaps_directories = g_list_prepend (pixmaps_directories,
                                        g_strdup (directory));
}

// This is an internally used function to find pixmap files.
gchar *find_pixmap_file (const gchar *filename)
{
  GList *elem;

  /* We step through each of the pixmaps directory to find it. */
  elem = pixmaps_directories;
  elem = g_list_append(elem, g_strdup("."));
  std::string nomefile = filename;
  bool noext = false;
  if(nomefile.find_last_of(".") == std::string::npos)
     noext = true;
  if(noext)
     nomefile.append(".png");
  while (elem)
  {
      gchar *pathname = g_strdup_printf ("%s%s%s", (gchar*)elem->data,
                                         G_DIR_SEPARATOR_S, nomefile.c_str());
      if (g_file_test (pathname, G_FILE_TEST_EXISTS))
        return pathname;

      g_free (pathname);
      elem = elem->next;
  }
  if(noext )
  {
     nomefile.assign(filename);
     nomefile.append(".xpm");
     elem = pixmaps_directories;
     while (elem)
     { 
         gchar *pathname = g_strdup_printf ("%s%s%s", (gchar*)elem->data,
                                         G_DIR_SEPARATOR_S, nomefile.c_str());
         if (g_file_test (pathname, G_FILE_TEST_EXISTS))
           return pathname;
    
         g_free (pathname);
         elem = elem->next;
     } 
  }
  g_warning (_("Couldn't find pixmap file: %s\n"), nomefile.c_str());
  return NULL;
}

#ifdef GDK_PIXMAP
GtkWidget *create_pixmap (GtkWidget *, const gchar *filename)
{
  gchar *pathname = NULL;
  GtkWidget *pixmap;

  if (!filename || !filename[0])
      return gtk_image_new ();

  pathname = find_pixmap_file (filename);

  if (!pathname)
    {
//      g_warning (_("Couldn't find pixmap file: %s"), filename);
      return gtk_image_new ();
    }

  pixmap = gtk_image_new_from_file (pathname);
  g_free (pathname);
  return pixmap;
}

GdkPixmap* mr_load_pixmap_withmask  (GtkWidget *widget, const gchar *filename, GdkBitmap **mask)
{
  GdkPixmap *gdkpixmap;
  GdkColormap *colormap = gtk_widget_get_colormap (widget);
  GdkPixbuf *pixb = create_pixbuf(filename);
  GdkBitmap *mask1;
  gdk_pixbuf_render_pixmap_and_mask_for_colormap (pixb, colormap,
                                           &gdkpixmap, &mask1, 1);
  *mask = mask1;

  return gdkpixmap;
}
#endif

GdkPixbufAnimation *mr_load_animation  (const gchar *filename)
{
  gchar *found_filename = NULL;
  GdkPixbufAnimation *gdkpixbuf;
  GError *error = NULL;

  found_filename = find_pixmap_file(filename);

  if (!found_filename)
      return (GdkPixbufAnimation *)dummy_pixbuf();

  gdkpixbuf = gdk_pixbuf_animation_new_from_file (found_filename, &error);
  g_free(found_filename);
  if (gdkpixbuf == NULL)
  {
      g_warning ("Error loading file: %s", error->message);
      return (GdkPixbufAnimation *)dummy_pixbuf();
  }
  return gdkpixbuf;
}


/* This is an internally used function to create pixbufs. */

GdkPixbuf *dummy_pixbuf()
{
static const char *missing_xpm[] = {
"24 24 11 1",
" 	c None",
".	c #C7C7C7",
"+	c #000000",
"@	c #585858",
"#	c #3E3E3E",
"$	c #CFCFCF",
"%	c #4B4B4B",
"&	c #706F6F",
"*	c #65625A",
"=	c #DF421E",
"-	c #676359",
"                        ",
"  .++++++++++++.        ",
"  +.          .@#       ",
"  +           ...+      ",
"  +           .  .+     ",
"  +           .   .+    ",
"  +           .   $.%   ",
"  +           .++++++.  ",
"  +                &*+  ",
"  +                ..+  ",
"  +      ==  ==     .+  ",
"  +       ====      .+  ",
"  +        ==       .+  ",
"  +       ====      .+  ",
"  +      ==  ==     .+  ",
"  +                 .+  ",
"  +                 .+  ",
"  +                 .+  ",
"  +                 .+  ",
"  +                 .+  ",
"  +                 .+  ",
"  +.................-+  ",
"  .++++++++++++++++++.  ",
"                        "};


    return gdk_pixbuf_new_from_xpm_data ((const char **)missing_xpm);
}

GdkPixbuf *create_pixbuf  (const gchar *filename)
{
  gchar *pathname = NULL;
  GdkPixbuf *pixbuf;
  GError *error = NULL;

  if (!filename || !filename[0])
      return dummy_pixbuf();

  pathname = find_pixmap_file (filename);

  if (!pathname)
      return dummy_pixbuf();

  pixbuf = gdk_pixbuf_new_from_file (pathname, &error);
  if (!pixbuf)
    {
      fprintf (stderr, "Failed to load pixbuf file: %s: %s\n",
               pathname, error->message);
      g_error_free (error);
      return dummy_pixbuf();
    }
  g_free (pathname);
  return pixbuf;
}

#if 0
void set_icon_list (GtkWidget *window, const gchar *filename)
{
  GdkPixbuf *ico = NULL;
#ifdef MAC_INTEGRATION
  std::string filnam = filename;
  filnam.append("-32");
  ico = create_pixbuf (filename);
  if(ico)
  {
     GtkOSXApplication *OsxApp = (GtkOSXApplication  *)
              g_object_new(GTK_TYPE_OSX_APPLICATION, NULL);
     gtk_osxapplication_set_dock_icon_pixbuf(OsxApp, ico);
     g_object_unref(ico);
  }
#else
  static const char *sizes[] = {"-16", "-32", "-48", "-64", "-128"};
  GList *icon_list=NULL;
  for(guint i=0; i<G_N_ELEMENTS(sizes); i++)
  {
      std::string filnam = filename;
      filnam.append(sizes[i]);
      ico = create_pixbuf (filnam.c_str());
      if (ico)
          icon_list = g_list_append(icon_list, ico);
  }
  gtk_window_set_icon_list (GTK_WINDOW (window), icon_list);
  gtk_window_set_default_icon_list (icon_list);
  g_list_free (icon_list);
#endif
}
#endif

void set_icon (GtkWidget *window, const gchar *filename)
{
  GdkPixbuf *ico = NULL;
  ico = create_pixbuf (filename);
  if (ico)
  {
#ifdef MAC_INTEGRATION
#ifdef GTKOSX_TYPE_APPLICATION
  GtkosxApplication *OsxApp = (GtkosxApplication  *)g_object_new(GTKOSX_TYPE_APPLICATION, NULL);
  gtkosx_application_set_dock_icon_pixbuf(OsxApp, ico);
#else
  GtkOSXApplication *OsxApp = (GtkOSXApplication  *)g_object_new(GTK_TYPE_OSX_APPLICATION, NULL);
  gtk_osxapplication_set_dock_icon_pixbuf(OsxApp, ico);
#endif
#else
      gtk_window_set_icon (GTK_WINDOW (window), ico);
      GList *list = g_list_prepend (NULL, ico);
      gtk_window_set_default_icon_list (list);
      g_list_free (list);
#endif
      g_object_unref (G_OBJECT(ico));
  }
}

GtkWidget *xpm_button(const gchar  *xpm_filename)
{
    GtkWidget *button;
    GtkWidget *pixmapwid;

    button = gtk_button_new ();
    pixmapwid = create_image (xpm_filename);
    if(pixmapwid)
    {
        gtk_widget_show(pixmapwid);
        gtk_container_add (GTK_CONTAINER (button), pixmapwid);
    }
    gtk_widget_show(button);
    return button;
}

GtkWidget *toolbar_button(const gchar  *xpm_filename, const gchar *label)
{
    GtkWidget *button;

    if(label != NULL)
       button = myimage_button(label, xpm_filename);
    else
       button = xpm_button (xpm_filename);

    gtk_button_set_relief (GTK_BUTTON(button), GTK_RELIEF_NONE);
    gtk_widget_set_can_focus(button, FALSE);
    gtk_widget_show(button);
    return button;
}

#ifdef USE_TOOLBAR
GtkToolItem *toolpalette_button(const gchar *xpm_filename, const gchar *label)
{
    GtkToolItem *button;
    GtkWidget *pixmapwid;

    pixmapwid = create_image (xpm_filename);
    button = gtk_tool_button_new (pixmapwid, label);
    return button;
}
#endif

static GtkWidget *create_dummy_image                    ()
{
  GtkWidget *pixmap;

#if GTK_MAJOR_VERSION < 3
  pixmap = gtk_image_new_from_stock(GTK_STOCK_MISSING_IMAGE, GTK_ICON_SIZE_BUTTON);
#else
  pixmap = gtk_image_new_from_icon_name("gtk-missing", GTK_ICON_SIZE_BUTTON);
#endif
  return pixmap;
}

static GtkWidget *create_dummy_menuicon                 ()
{
  GtkWidget *pixmap;

#if GTK_MAJOR_VERSION < 3
  pixmap = gtk_image_new_from_stock(GTK_STOCK_MISSING_IMAGE, GTK_ICON_SIZE_MENU);
#else
  pixmap = gtk_image_new_from_icon_name("gtk-missing", GTK_ICON_SIZE_MENU);
#endif
  return pixmap;
}

GtkWidget *create_menuicon(const gchar *filename, int w, int h)
{
   GdkPixbuf *pix1 = create_pixbuf(filename);
   if(pix1 != NULL)
   {
      GdkPixbuf *pix2 = gdk_pixbuf_scale_simple(pix1, w, h, GDK_INTERP_BILINEAR);
      g_object_unref(pix1);
      if(pix2 != NULL)
         return gtk_image_new_from_pixbuf(pix2);
   }
   return create_dummy_menuicon();
}

GtkWidget* create_image (const gchar *filename)
{
  gchar *found_filename = NULL;

  if (!filename || !filename[0])
      return create_dummy_image ();

  found_filename = find_pixmap_file (filename);
  if (!found_filename)
  {
//      g_warning ("Couldn't find pixmap file: %s", filename);
      return create_dummy_image ();
  }
  GtkWidget *img = gtk_image_new_from_file (found_filename);
  g_free(found_filename);
  return img;
}

void register_stock_icon (const char *stock_id)
{
#ifdef GTK_STOCK_OK
      if(str_white(stock_id))
         return;
      GtkIconFactory *factory;
      char *id = DuplicaStringa(stock_id);
      static GtkStockItem item = 
      {
          id,
          NULL,                   //"",
          (GdkModifierType) 0, 0, NULL 
      };
      
      gtk_stock_add (&item, 1);
      
      factory = gtk_icon_factory_new ();
      gtk_icon_factory_add_default (factory);
      GdkPixbuf *pixbuf = create_pixbuf(stock_id);

      /* Register icon to accompany stock item */
      if (pixbuf)
      {
          GtkIconSet *icon_set = gtk_icon_set_new_from_pixbuf (pixbuf);
          gtk_icon_factory_add (factory, stock_id, icon_set);
          gtk_icon_set_unref (icon_set);
          g_object_unref (pixbuf);
      }
      g_object_unref (factory);
//#else
//      GdkPixbuf *pixbuf = create_pixbuf(stock_id);
//      gtk_icon_theme_add_builtin_icon (stock_id, 24, pixbuf);
//      g_object_unref (pixbuf);
#endif
}

PangoFontDescription *DefaultFont()
{
#ifdef _WIN32
    NONCLIENTMETRICS ncm;
    ncm.cbSize = sizeof(ncm);
    OSVERSIONINFO osvi;
    ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
    osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&osvi);
#if WINVER > 0x0502
    if ( (osvi.dwMajorVersion < 5) ||
       ( (osvi.dwMajorVersion == 5) && (osvi.dwMinorVersion <= 1) ))
          ncm.cbSize = sizeof(ncm) - sizeof(int);
#endif
    SystemParametersInfo(SPI_GETNONCLIENTMETRICS, ncm.cbSize, &ncm, 0);
    std::string fontname = ncm.lfMessageFont.lfFaceName;
    int h = ncm.lfMessageFont.lfHeight;
    HDC hdc;
    GdkWindow *window = gdk_screen_get_root_window(gdk_screen_get_default());
    HWND hWnd = static_cast<HWND> GDK_WINDOW_HWND(window);
    if (NULL != (hdc = GetDC(hWnd))) 
    { 
        int size = MulDiv(-h, 72, GetDeviceCaps(hdc, LOGPIXELSY));
        fontname.append(g_strdup_printf(" %d", size));
    }          
    else
        fontname.append(" 8");
    return pango_font_description_from_string(fontname.c_str());
#endif

#if GTK_MAJOR_VERSION < 3
    GtkStyle *defstyle;
    defstyle = gtk_style_new();
    return (pango_font_description_copy(defstyle->font_desc));
#else
    GSettings *sett = g_settings_new ("org.gnome.desktop.interface");
    PangoFontDescription *pfd;
    if(sett != NULL)
    {
       char *tmp = g_settings_get_string(sett, "font-name");
       pfd = pango_font_description_from_string(tmp);
       g_free(tmp);
       return pfd;
    }
    GtkStyleContext *defstyle;
    defstyle = gtk_style_context_new();
    GtkWidgetPath *path = gtk_widget_path_new ();
    gtk_widget_path_append_type (path, GTK_TYPE_WINDOW);
    gtk_style_context_set_path (defstyle, path);
//    return (pango_font_description_copy(gtk_style_context_get_font(
//          defstyle, GTK_STATE_FLAG_NORMAL)));
    gtk_style_context_get( defstyle, GTK_STATE_FLAG_NORMAL, "font", &pfd, NULL);
    return pfd;
#endif
}

PangoFontDescription *DefaultFontMono()
{
#ifndef _WIN32
#if GTK_MAJOR_VERSION >= 3
    GSettings *sett = g_settings_new ("org.gnome.desktop.interface");
    if(sett != NULL)
       return pango_font_description_from_string(g_settings_get_string(sett, "monospace-font-name"));
#endif
#endif
  PangoFontDescription *font_desc = DefaultFont();
  pango_font_description_set_family(font_desc, MONOSPACE_FONT);
  return font_desc;
}

PangoFontDescription *new_font_desc(float factor, PangoFontDescription *fdesc)
{
    int newsize;
    PangoFontDescription *newfdesc;
    newfdesc = pango_font_description_copy(fdesc);
    if(factor >= 2)
       pango_font_description_set_weight(newfdesc,PANGO_WEIGHT_ULTRABOLD);
    else if(factor >= 1)
#ifdef PANGO_WEIGHT_SEMIBOLD
       pango_font_description_set_weight(newfdesc,PANGO_WEIGHT_SEMIBOLD);
#else
       pango_font_description_set_weight(newfdesc,PANGO_WEIGHT_BOLD);
#endif
    else
       factor = 1.;
    newsize = (int)(factor*pango_font_description_get_size(fdesc));
    pango_font_description_set_size(newfdesc,newsize);
    return newfdesc;
}

#if (GTK_MAJOR_VERSION >= 3) && (defined USE_MYTAB)

typedef struct {
                 int page;
                 GtkNotebook *nb;
               } nb_data;

static void sel_page(GtkWidget *b, GdkEvent *, gpointer data)
{
    nb_data *nbd = (nb_data *) data;
    gtk_notebook_set_current_page (GTK_NOTEBOOK (nbd->nb), nbd->page);
}

static gboolean key_press_event (GtkWidget *,
                                 GdkEventKey *event, gpointer data)
{
    nb_data *nbd = (nb_data *) data;
    int key = event->keyval;
    int stato = event->state;
    int ifCtrl = 0;
    if ( (stato & GDK_CONTROL_MASK) == GDK_CONTROL_MASK )
          ifCtrl =  1;
    int ipage = gtk_notebook_get_current_page(GTK_NOTEBOOK(nbd->nb));
    int npages = gtk_notebook_get_n_pages(GTK_NOTEBOOK(nbd->nb));

    int pag = ipage;
    switch(key)
    {
    default:
         return FALSE;
    case KeyLeft:
    case KeyKpLeft:
         pag = ((ipage-1) < 0)?npages-1:ipage-1;
         break;
    case KeyRight:
    case KeyKpRight:
         pag = ((ipage+1) >=npages)?0:ipage+1;
         break;
    case KeyPageDown:
    case KeyKpPageDown:
         if(ifCtrl) 
            pag = ((ipage+1) >=npages)?0:ipage+1;
         else
            return FALSE;
         break;
    case KeyPageUp:
    case KeyKpPageUp:
         if(ifCtrl) 
            pag = ((ipage-1) < 0)?npages-1:ipage-1;
         else
            return FALSE;
         break;
    case KeyHome:
    case KeyKpHome:
         pag = 0;
         break;
    case KeyEnd:
    case KeyKpEnd:
         pag = npages-1;
         break;
    }
    gtk_notebook_set_current_page(GTK_NOTEBOOK(nbd->nb), pag);
    return TRUE;
}

static void notebook_page_callback (GtkNotebook *notebook, gpointer page,
                                 guint page_num, GtkWidget *box)
{
    GList *children = gtk_container_get_children(GTK_CONTAINER(box));
    for(guint i=0; i< g_list_length(children); i++)
    {
        GtkWidget *child = GTK_WIDGET(g_list_nth_data(children, i));
        if(i == page_num)
        {
           widget_set_selected (child);
           gtk_widget_grab_focus(child);
        }
        else
           widget_set_unselected (child);
    }
    g_list_free(children);
}

static void set_label_style(GtkWidget *widget)
{
    GtkStyleContext *context = gtk_widget_get_style_context (widget);
    GtkCssProvider *provider = gtk_css_provider_new ();
    char *css_string = g_strdup(
    "GtkEventBox > GtkLabel {\n"
    "padding: 5px 5px 5px 5px;\n"
    "}\n");

    gtk_css_provider_load_from_data (GTK_CSS_PROVIDER (provider),
                                 css_string, -1, NULL);
    gtk_style_context_add_provider (context,
                                GTK_STYLE_PROVIDER (provider),
                                GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
    g_object_unref (provider);
    g_free(css_string);

}

static void set_ebox_style(GtkWidget *widget, bool first)
{
    GtkStyleContext *context = gtk_widget_get_style_context (widget);
    GtkCssProvider *provider = gtk_css_provider_new ();
    std::string css_string( " GtkEventBox:selected {\n");
    css_string.append("background-color: rgb(255, 255, 255);\n");
    css_string.append("background-image: none;\n");
    css_string.append("border-bottom-color: rgb(0, 128, 250);\n");
    css_string.append("border-bottom-width: 3px;\n");
    css_string.append("}\n");
    css_string.append("GtkEventBox {\n");
    css_string.append("background-image: linear-gradient(180deg, rgba(160, 160, 160, 0), rgba(160,160,160, 0.7));\n");
    css_string.append("border-color: rgb(150, 150, 150);\n");
    css_string.append("border-style: solid;\n");
    css_string.append("border-width: 1px 1px 0 0;\n");
    if(first)
       css_string.append("border-left:1px solid rgb(150, 150, 150);\n");
//    "border-bottom-left-radius: 5px;\n"
//    "border-bottom-right-radius: 5px;\n"
    css_string.append("border-top-left-radius: 2px;\n");
    css_string.append("border-top-right-radius: 3px;\n");
    css_string.append("}\n");

    gtk_css_provider_load_from_data (GTK_CSS_PROVIDER (provider),
                                 css_string.c_str(), -1, NULL);
    gtk_style_context_add_provider (context,
                                GTK_STYLE_PROVIDER (provider),
                                GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
    g_object_unref (provider);
}

void set_tab_label(GtkNotebook *notebook, int npag, const char *label,
                   _StyleType *style)
{
  gtk_notebook_set_show_tabs (GTK_NOTEBOOK (notebook), FALSE);
  //gtk_notebook_set_show_border (GTK_NOTEBOOK (notebook), FALSE);
  int hnd = get_int (GTK_WIDGET(notebook), "hnd");
  g_object_set_data (G_OBJECT (notebook), "hnd", GINT_TO_POINTER(hnd));

  GtkWidget *hbox = get_widget(GTK_WIDGET(notebook), "hbox");
  GtkWidget *ebox = gtk_event_box_new ();
  widget_set_unselected (ebox);
  gtk_box_pack_start (GTK_BOX (hbox), ebox, FALSE, FALSE, 0);
  GtkWidget *lab= gtk_label_new(label);
  set_alignment (lab, 0.0, 0.5);
  gtk_container_add (GTK_CONTAINER (ebox), lab);
  gtk_widget_set_events(ebox, GDK_BUTTON_PRESS_MASK | GDK_KEY_PRESS_MASK | GDK_EXPOSURE_MASK);
  gtk_widget_set_can_focus(ebox, TRUE);
  bool first = (hnd == 0);
  if(first)
     widget_set_selected (ebox);
  if(!hnd)
     hnd = g_signal_connect (notebook, "switch-page",
                    G_CALLBACK (notebook_page_callback),
                    hbox);
  g_object_set_data(G_OBJECT(notebook), "hnd", GINT_TO_POINTER(hnd));
  set_ebox_style(ebox, first);
  set_label_style(lab);

  gtk_widget_show_all (ebox);

  nb_data *data = g_new0(nb_data, 1);
  data->page = npag;
  data->nb = notebook;
  g_signal_connect(G_OBJECT(ebox), "button_press_event", G_CALLBACK(sel_page), (gpointer) data);
  g_signal_connect (G_OBJECT (ebox), "key_press_event",
                      G_CALLBACK (key_press_event),  (gpointer) data);
}

GtkWidget *get_tab_label(GtkNotebook *notebook, GtkWidget *child)
{
  
  GtkWidget *hbox = get_widget(GTK_WIDGET(notebook), "hbox");
  guint num = gtk_notebook_page_num (notebook, child);
  GList *children = gtk_container_get_children(GTK_CONTAINER(hbox));
  GtkWidget *tab_label = GTK_WIDGET(g_list_nth_data(children, num));
  return tab_label;
}

GtkWidget *NewNotebook(GtkWidget *father)
{
  GtkWidget *hbox =  hbox_new(FALSE, 0);
  gtk_box_pack_start (GTK_BOX (father), hbox, FALSE, FALSE, 0);
  gtk_widget_show(hbox);

  GtkWidget *notebook;
  notebook = gtk_notebook_new ();

  gtk_box_pack_start (GTK_BOX (father), notebook, TRUE, TRUE, 0);
  g_object_set_data(G_OBJECT(notebook), "hbox", hbox);
  return notebook;
}

#else

void set_tab_label(GtkNotebook *notebook, int npag, const char *label, 
                   _StyleType *style)
{
  GtkWidget *lab1;
  if(style->Bold)
     lab1 = LABEL_BOLD (label, style->color, style->size);
  else
     lab1 = LABEL_NEW (label, style->color);
  gtk_widget_show (lab1);
  gtk_notebook_set_tab_label (notebook,
         gtk_notebook_get_nth_page (notebook, npag), lab1);
}

GtkWidget *get_tab_label(GtkNotebook *notebook, GtkWidget *child)
{
  return gtk_notebook_get_tab_label(notebook,
           child);
}

GtkWidget *NewNotebook(GtkWidget *father)
{
  GtkWidget *notebook;
  notebook = gtk_notebook_new ();

  gtk_box_pack_start (GTK_BOX (father), notebook, TRUE, TRUE, 0);
  return notebook;
}

#endif

GtkWidget *LABEL_BOLD_WITH_FONT(const char *string, const gchar *color, float factor,
                                PangoFontDescription *fdesc)
{
    GtkWidget *label;
    PangoFontDescription *newfdesc;
                                                                                                          
    label = gtk_label_new(NULL);
    if(!string)
       return label;
                                                                                                          
    newfdesc = new_font_desc(factor, fdesc);
    if(color)
       setta_colore(label, color);
    gtk_label_set_markup_with_mnemonic(GTK_LABEL(label), string);
    widget_modify_font(label, newfdesc);
    pango_font_description_free(newfdesc);
                                                                                                          
    return label;
}
                                                                                    
void set_entry_text(GtkWidget *widget, const char *testo)
{
        int hnd = get_int(widget, "hnd");
        g_signal_handler_block (G_OBJECT (widget), hnd);
        gtk_entry_set_text(GTK_ENTRY(widget), testo);
        g_signal_handler_unblock (G_OBJECT (widget), hnd);
}

void set_label_text(GtkWidget *label, const char *string, const char *color, float factor, int ifmne)
{
    if(!string)
       return;
    PangoFontDescription *newfdesc = get_font((double)factor);

    if(color)
       set_label_color(label, color);
       //setta_colore(label, color);
    if(ifmne)
       gtk_label_set_markup_with_mnemonic(GTK_LABEL(label), toUTF8(string));
    else
       gtk_label_set_markup(GTK_LABEL(label), toUTF8(string));
    widget_modify_font(label, newfdesc);
    pango_font_description_free(newfdesc);
}                                                                                                         
void set_label_text(GtkWidget *label, const char *string, const char *color, float factor)
{
     set_label_text(label, string, color, factor, 1);
}

void set_label_text(GtkWidget *label, const char *string, const char *color)
{
     set_label_text(label, string, color, 0.99f, 0);
}

GtkWidget *LABEL_BOLD(const char *string, const gchar *color, float factor, int ifmne)
{
    GtkWidget *label;
    PangoFontDescription *newfdesc;

    label = gtk_label_new(NULL);
    if(!string)
       return label;

    newfdesc  = get_font((double) factor);

    if(color)
       setta_colore(label, color);
    widget_modify_font(label, newfdesc);
    if(ifmne)
       gtk_label_set_markup_with_mnemonic(GTK_LABEL(label), string);
    else
       gtk_label_set_markup(GTK_LABEL(label), string);
    pango_font_description_free(newfdesc);

    return label;
}

GtkWidget *LABEL_BOLD(const char *string, const gchar *color, float factor)
{
    return LABEL_BOLD(string, color, factor, 1);
}

GtkWidget *LABEL_NEW(const char *string, const gchar *color, int ifmne)
{
    GtkWidget *label;

    label = gtk_label_new(NULL);
    if(!string)
       return label;

    if(color)
       setta_colore(label, color);
    if(ifmne)
       gtk_label_set_markup_with_mnemonic(GTK_LABEL(label), string);
    else
       gtk_label_set_markup(GTK_LABEL(label), string);

    return label;
}
GtkWidget *LABEL_NEW(const char *string, const gchar *color)
{
     return LABEL_NEW(string, color, 1);
}
 
GtkWidget *label_boxed (const gchar  *string)
{
    GtkWidget *frame, *label;

    frame = gtk_frame_new (NULL);
    gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
    label = LABEL_NEW(toUTF8(string), NULL);
    set_alignment (label, 0.5, 0.5);
    gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_CENTER);
#ifdef IN_GTK3
    set_margins(label, 2, 2, 4, 4);
#else
    gtk_misc_set_padding (GTK_MISC (label), 4, 2);
#endif
    gtk_container_add (GTK_CONTAINER (frame), label);
    set_label_color(label, "#008050");
    g_object_set_data(G_OBJECT(frame), "label", label);
    gtk_widget_show (label);
    gtk_widget_show (frame);
    return frame;
}

GtkWidget *add_accelerator(int key, int mods)
{
    const gchar *accel_str;
#ifndef NOACC_LABEL
    accel_str = gtk_accelerator_get_label(
             (guint) key, (GdkModifierType)mods);
#else
    accel_str = gtk_accelerator_name(
             (guint) key, (GdkModifierType)mods);
#endif
    GtkWidget *accel_label = gtk_label_new(accel_str);
    set_alignment(accel_label, 1, 0.5f);
    return accel_label;
}

#ifdef IN_GTK3
void do_nothing(GtkMenuItem *item, gint ts, gpointer data)
{
    GtkAllocation alloc;
    gtk_widget_get_allocation(gtk_bin_get_child(GTK_BIN(item)), &alloc);
//    const char *nome = gtk_label_get_text(GTK_LABEL(get_widget(GTK_WIDGET(item), "label")));

//       g_print("%s ts %d alloc.x %d\n", nome, ts, alloc.x);
    if((ts > 0) && (alloc.x > ts))
    {
//       g_print("%s ts %d alloc.x %d\n", nome, ts, alloc.x);
       alloc.x -= ts;
    }
    gtk_widget_size_allocate(gtk_bin_get_child(GTK_BIN(item)), &alloc);
}

void set_origin(GtkWidget *w, GdkRectangle *alloc1, gpointer)
{
    gint ts = 17;
    GtkAllocation alloc;
     
    gtk_widget_get_allocation(gtk_bin_get_child(GTK_BIN(w)), &alloc);
    if((ts > 0) && (alloc.x > ts))
        gtk_menu_item_toggle_size_allocate(GTK_MENU_ITEM(w), 17);
}

#endif

GtkWidget *xpm_menu_item(const gchar *xpm_filename, const gchar *labeltext,
                         gboolean ifmne)
{
    GtkWidget *box1;
    GtkWidget *label, *item;
    GtkWidget *pixmapwid;

    item = gtk_menu_item_new();
    box1 = hbox_new (FALSE, 0);
    g_object_set_data(G_OBJECT(item), "button", box1);
    gtk_container_set_border_width(GTK_CONTAINER(box1), 0);
    gtk_container_set_border_width(GTK_CONTAINER(item), 0);

//    if(ifmne)
//       label = gtk_label_new_with_mnemonic(labeltext);
//    else
//       label = gtk_label_new(labeltext);
    label = gtk_accel_label_new(labeltext);
    g_object_set_data(G_OBJECT(item), "label", label);
    gtk_accel_label_set_accel_widget(GTK_ACCEL_LABEL(label), item);
    if(ifmne)
      gtk_label_set_markup_with_mnemonic(GTK_LABEL(label), labeltext);

    if(strstr(xpm_filename, ".gif"))
       pixmapwid = create_image(xpm_filename);
    else
    {     
        register_stock_icon (xpm_filename);
#ifdef GTK_STOCK_OK
        pixmapwid = gtk_image_new_from_stock (xpm_filename, GTK_ICON_SIZE_BUTTON);
#else
        pixmapwid = gtk_image_new_from_icon_name (xpm_filename, GTK_ICON_SIZE_BUTTON);
#endif
    }
    if(pixmapwid)
    {
#ifdef IN_GTK3
          g_signal_connect(G_OBJECT(item), "toggle-size-allocate", 
             G_CALLBACK(do_nothing), NULL);
          g_signal_connect(G_OBJECT(item), "size-allocate", 
             G_CALLBACK(set_origin), NULL);
#endif
          g_object_set_data(G_OBJECT(item), "pixmap", pixmapwid);
          gtk_box_pack_start (GTK_BOX (box1), pixmapwid, FALSE, FALSE, 0);
          gtk_widget_show(pixmapwid);
    }
    gtk_box_pack_start (GTK_BOX (box1), label, TRUE, TRUE, 2);
#ifdef IN_GTK3
#if GTK_MINOR_VERSION < 16
    g_object_set (label, "xalign", 0.0, NULL);
#else
    gtk_label_set_xalign (GTK_LABEL (label), 0.0);
#endif
#endif
    gtk_widget_show(label);
    gtk_widget_show(box1);
    gtk_container_add (GTK_CONTAINER (item), box1);
    return item;
}

/*
GtkWidget *mr_menu_item(mr_action_entry entry)
{
    GtkWidget *box1;
    GtkWidget *label, *item;
    GtkWidget *pixmapwid;
    const gchar *xpm_filename = entry.icon; 
    const gchar *labeltext = entry.string;

    switch(entry.type)
    {
    default:
    case 1:
         item = gtk_menu_item_new();
         break;
    case 3:
         item = gtk_check_menu_item_new();
         break;
    }

// Create box for xpm and label
    box1 = hbox_new (FALSE, 0);
    g_object_set_data(G_OBJECT(item), "button", box1);

// Create a label for the menuitem 
    label = gtk_label_new_with_mnemonic(labeltext);
    g_object_set_data(G_OBJECT(item), "label", label);

// Add accelerator for the menuitem 
    if(entry.accel_key > 0)
    {
       GtkWidget *accel_label = add_accelerator(entry.accel_key, entry.accel_mods);
       gtk_box_pack_end (GTK_BOX (box1), accel_label, TRUE, TRUE, 2);
   }
   if(xpm_filename != NULL)
   {
      if(strstr(xpm_filename, ".gif"))
          pixmapwid = create_image(xpm_filename);
      else
      {     
           register_stock_icon (xpm_filename);
           pixmapwid = gtk_image_new_from_stock (xpm_filename, GTK_ICON_SIZE_BUTTON);
      }
      if(pixmapwid)
      {
         g_object_set_data(G_OBJECT(item), "pixmap", pixmapwid);
         gtk_box_pack_start (GTK_BOX (box1), pixmapwid, FALSE, FALSE, 0);
      }
   }

// Pack the label into the box
    gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 6);

    gtk_widget_show_all(box1);
    gtk_container_add (GTK_CONTAINER (item), box1);

    return item;
}

GtkWidget *xpm_checkmenu_item(const gchar *xpm_filename, const gchar *labeltext)
{
    GtkWidget *box1;
    GtkWidget *label, *item;
    GtkWidget *pixmapwid;

    item = gtk_check_menu_item_new();
    box1 = hbox_new (FALSE, 0);
    g_object_set_data(G_OBJECT(item), "button", box1);

    label = gtk_label_new_with_mnemonic(labeltext);
    g_object_set_data(G_OBJECT(item), "label", label);

    if(xpm_filename != NULL)
    {
        if(strstr(xpm_filename, ".gif"))
           pixmapwid = create_image(xpm_filename);
        else
        {     
            register_stock_icon (xpm_filename);
            pixmapwid = gtk_image_new_from_stock (xpm_filename, GTK_ICON_SIZE_BUTTON);
        }
        if(pixmapwid)
        {
              g_object_set_data(G_OBJECT(item), "pixmap", pixmapwid);
              gtk_box_pack_start (GTK_BOX (box1), pixmapwid, FALSE, FALSE, 0);
              gtk_widget_show(pixmapwid);
        }
    }

    gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 6);

    gtk_widget_show(label);
    gtk_widget_show(box1);

    gtk_container_add (GTK_CONTAINER (item), box1);

    return item;
}
*/

int LungNum(double val, int ncifre_dec)
{
  int parte_intera;
  int extra;

  parte_intera = 1;
  if (fabs (val) > 1.0)
    parte_intera = (gint) floor (log10 (fabs (val))) + 1;
  extra = 0;
// Punto decimale
  if (ncifre_dec > 0)
    extra++;
// Segno
  if (val < 0)
    extra++;
  return parte_intera + ncifre_dec + extra;
}

GtkWidget *SPIN_WITH_LABEL(const gchar *string, const char *colore, double vmin, 
         double vmax, double val, double step, int ncifre, int ori)
{
    GtkWidget *label=NULL, *spin, *box;

    if(ori)
       box = vbox_new(FALSE, 0);
    else
       box = hbox_new(FALSE, 0);
    if(string)
    {
       label = LABEL_NEW(string, colore);
       set_alignment (label, 0.0, 0.5);
       gtk_box_pack_start(GTK_BOX(box), label,FALSE, FALSE, 2);
    }
    spin = spin_button_new_with_range(vmin, vmax, step);
    spin_button_set_value(spin, val);
    spin_button_set_digits(spin, ncifre);
    int l = MRmax(LungNum(vmax, ncifre), LungNum(vmin, ncifre));
    gtk_entry_set_width_chars(GTK_ENTRY(spin), l);
#if defined(IN_GTK3) && (GTK_MINOR_VERSION >= 12)
    gtk_entry_set_max_width_chars(GTK_ENTRY(spin), l);
#endif
    gtk_box_pack_start(GTK_BOX(box), spin, FALSE, FALSE, 2);
    if(label)
    {
       gtk_label_set_mnemonic_widget(GTK_LABEL(label), spin);
       g_object_set_data(G_OBJECT(box), "label", label);
    }
    g_object_set_data(G_OBJECT(box), "spin", spin);

    return box;
}

GtkWidget *BrowseButton()
{
   return myimage_button("_Browse", "browse22.png");
}

gboolean isHbox(GtkWidget *box)
{
    if(!GTK_IS_BOX(box))
       return FALSE;
#if GTK_MAJOR_VERSION < 3
    return (GTK_IS_HBOX(box));
#else
    if(GTK_IS_ORIENTABLE(box))
       return (gtk_orientable_get_orientation(GTK_ORIENTABLE(box)) == GTK_ORIENTATION_HORIZONTAL);
    else
       return FALSE;
#endif
}

gboolean isVbox(GtkWidget *box)
{
    if(!GTK_IS_BOX(box))
       return FALSE;
#if GTK_MAJOR_VERSION < 3
    return (GTK_IS_VBOX(box));
#else
    if(GTK_IS_ORIENTABLE(box))
       return (gtk_orientable_get_orientation(GTK_ORIENTABLE(box)) == GTK_ORIENTATION_VERTICAL);
    else
       return FALSE;
#endif
}

GtkWidget *entry_for_filesel(GtkWidget *parentbox, const char *labelstring, const char *entryname, 
                             int ifPreview, int ifBrowse, int ifModify)
{
  GtkWidget *hbox, *label, *button, *Entry, *button2;

  hbox = hbox_new (FALSE, 4);
  if(parentbox)
  {
     if(isHbox(parentbox))
        gtk_box_pack_start (GTK_BOX (parentbox), hbox, TRUE, TRUE, 0);
     else if(isVbox(parentbox))
        gtk_box_pack_start (GTK_BOX (parentbox), hbox, FALSE, FALSE, 0);
     else
        gtk_container_add (GTK_CONTAINER (parentbox), hbox);
  }

  label = LABEL_NEW (labelstring, MyBLUE);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
  set_alignment(label, 0, 0.5);

  Entry = gtk_entry_new ();
  gtk_widget_set_name (Entry, entryname);
#ifdef IN_GTK3
  gtk_widget_set_halign(Entry, GTK_ALIGN_FILL);
#endif
  gtk_box_pack_start (GTK_BOX (hbox), Entry, TRUE, TRUE, 0);
  g_object_set_data(G_OBJECT(Entry), "label", label);

  if(ifModify)
  {
     button2 = myimage_button("_Modify", "model_settings.png");
     gtk_box_pack_end (GTK_BOX (hbox), button2, FALSE, FALSE, 2);
     g_object_set_data(G_OBJECT(Entry), "modify", button2);
     g_object_set_data(G_OBJECT(button2), "entry", Entry);
  }


  if(ifPreview)
  {
     button2 = myimage_button("_View", "preview22.png");
     gtk_box_pack_end (GTK_BOX (hbox), button2, FALSE, FALSE, 2);
     g_object_set_data(G_OBJECT(Entry), "preview", button2);
  }

  if(ifBrowse)
  {
    button = BrowseButton ();
    gtk_box_pack_end (GTK_BOX (hbox), button, FALSE, FALSE, 2);
    g_object_set_data(G_OBJECT(Entry), "browse", button);
    g_object_set_data(G_OBJECT(button), "entry", Entry);
  }

  gtk_widget_show_all(hbox);
  g_object_set_data(G_OBJECT(Entry), "box", hbox);

  return Entry;
}

int get_hFont(PangoFontDescription *font_desc)
{
  if (font_desc)
  {
      PangoContext *context;
      PangoFontMetrics *metrics;

      context = gdk_pango_context_get ();
      pango_context_set_font_description (context, font_desc);
#ifdef MUST_SET_CM
      gdk_pango_context_set_colormap(context, gdk_colormap_get_system());
#endif
      metrics = pango_context_get_metrics (context,
                    font_desc, pango_context_get_language (context));
      
      return ((pango_font_metrics_get_ascent (metrics) +
              pango_font_metrics_get_descent (metrics))/PANGO_SCALE);
  }
  return 10;
}

#ifdef GTK_PRINT_OPERATION
#define HEADER_HEIGHT (10*72/25.4)
#define HEADER_GAP (3*72/25.4)
static GtkPrintSettings *print_settings = NULL;

typedef struct 
{
  gchar *filename;
  gdouble font_size;

  gint lines_per_page;  
  gchar **lines;
  gint num_lines;
  gint num_pages;
} PrintData;

static void
begin_print (GtkPrintOperation *operation, 
             GtkPrintContext   *context,
             gpointer           user_data)
{
  PrintData *data = (PrintData *)user_data;
  char *contents;
  int i;
  double height;

  height = gtk_print_context_get_height (context) - HEADER_HEIGHT - HEADER_GAP;
  
  data->lines_per_page = (int) floor (height / data->font_size);
  
  g_file_get_contents (data->filename, &contents, NULL, NULL);

  data->lines = g_strsplit (contents, "\n", 0);
  g_free (contents);

  i = 0;
  while (data->lines[i] != NULL)
    i++;
  
  data->num_lines = i;
  data->num_pages = (data->num_lines - 1) / data->lines_per_page + 1;
  gtk_print_operation_set_n_pages (operation, data->num_pages);
}

static void
draw_page (GtkPrintOperation *,
           GtkPrintContext   *context,
           gint               page_nr,
           gpointer           user_data)
{
  PrintData *data = (PrintData *)user_data;
  cairo_t *cr;
  PangoLayout *layout;
  gint text_width, text_height;
  gdouble width;
  gint line, i;
  PangoFontDescription *desc;
  gchar *page_str;

  cr = gtk_print_context_get_cairo_context (context);
  width = gtk_print_context_get_width (context);

  cairo_rectangle (cr, 0, 0, width, HEADER_HEIGHT);
  
  cairo_set_source_rgb (cr, 0.8, 0.8, 0.8);
  cairo_fill_preserve (cr);
  
  cairo_set_source_rgb (cr, 0, 0, 0);
  cairo_set_line_width (cr, 1);
  cairo_stroke (cr);

  layout = gtk_print_context_create_pango_layout (context);

  desc = pango_font_description_from_string ("sans 14");
  pango_layout_set_font_description (layout, desc);
  pango_font_description_free (desc);
  pango_layout_set_text (layout, data->filename, -1);
  pango_layout_get_pixel_size (layout, &text_width, &text_height);

  if (text_width > width)
    {
      pango_layout_set_width (layout, (int) width);
      pango_layout_set_ellipsize (layout, PANGO_ELLIPSIZE_START);
      pango_layout_get_pixel_size (layout, &text_width, &text_height);
    }

  cairo_move_to (cr, (width - text_width) / 2,  (HEADER_HEIGHT - text_height) / 2);
  pango_cairo_show_layout (cr, layout);

  page_str = g_strdup_printf ("%d/%d", page_nr + 1, data->num_pages);
  pango_layout_set_text (layout, page_str, -1);
  g_free (page_str);

  pango_layout_set_width (layout, -1);
  pango_layout_get_pixel_size (layout, &text_width, &text_height);
  cairo_move_to (cr, width - text_width - 4, (HEADER_HEIGHT - text_height) / 2);
  pango_cairo_show_layout (cr, layout);
  
  g_object_unref (layout);
  
  layout = gtk_print_context_create_pango_layout (context);
  
  desc = get_fontN (MONOSPACE_FONT);
  pango_font_description_set_size (desc, (gint)(data->font_size*PANGO_SCALE));
  pango_layout_set_font_description (layout, desc);
  pango_font_description_free (desc);
  
  cairo_move_to (cr, 0, HEADER_HEIGHT + HEADER_GAP);
  line = page_nr * data->lines_per_page;
  for (i = 0; i < data->lines_per_page && line < data->num_lines; i++) 
    {
      pango_layout_set_text (layout, data->lines[line], -1);
      pango_cairo_show_layout (cr, layout);
      cairo_rel_move_to (cr, 0, data->font_size);
      line++;
    }

  g_object_unref (layout);
}

static void
end_print (GtkPrintOperation *, 
           GtkPrintContext   *,
           gpointer           user_data)
{
  PrintData *data = (PrintData *)user_data;

  g_free (data->filename);
  g_strfreev (data->lines);
  g_free (data);
}


void do_printing (GtkWidget *do_widget, const gchar *filnam)
{
  GtkPrintOperation *op;
  PrintData *data;
  GError *error = NULL;

  op = gtk_print_operation_new ();
  data = g_new0 (PrintData, 1);
  data->filename = DuplicaStringa(filnam);
  data->font_size = 12.0;
  if (print_settings != NULL)
    gtk_print_operation_set_print_settings (op, print_settings);

  g_signal_connect (G_OBJECT (op), "begin-print", 
           G_CALLBACK (begin_print), data);
  g_signal_connect (G_OBJECT (op), "draw-page", 
           G_CALLBACK (draw_page), data);
  g_signal_connect (G_OBJECT (op), "end-print", 
           G_CALLBACK (end_print), data);

  GtkPrintOperationResult res = gtk_print_operation_run (op,
             GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG, GTK_WINDOW (do_widget),
             &error);

  if (res == GTK_PRINT_OPERATION_RESULT_ERROR)
  {
      GtkWidget *dialog;
      
      dialog = gtk_message_dialog_new (GTK_WINDOW (do_widget),
           GTK_DIALOG_DESTROY_WITH_PARENT,
           GTK_MESSAGE_ERROR,
           GTK_BUTTONS_CLOSE,
           "%s", error->message);
      g_signal_connect (dialog, "response",
           G_CALLBACK (gtk_widget_destroy), NULL);
      gtk_widget_show (dialog);      
      g_error_free (error);
  }
  else if (res == GTK_PRINT_OPERATION_RESULT_APPLY)
  {
      if (print_settings != NULL)
        g_object_unref (print_settings);
      print_settings = (GtkPrintSettings *)
        g_object_ref(gtk_print_operation_get_print_settings(op));
  }
  g_object_unref (op);
}

void PrintFile(GtkWidget *dlg,  const char *file)
{
    do_printing(dlg, file);
}
#else
#ifdef _WIN32
#include <commdlg.h> 

PRINTDLG pdPrint; 
 
int WINAPI TPrintFile (HWND hWnd, GtkWidget *dlg, const char *file) 
{ 
    SIZE sLine; 
    int yLineExt; 
    int xCharExt; 
    int yExt; 
    int yPageExt; 
    int nMaxChars;
    UINT uLine; 
    UINT uNumLines; 
    UINT uLineLen; 
    DOCINFO diPrint; 
    HFONT hFont; 
    HFONT hFontPrt = NULL; 
    int nPageCnt = 1; 
    GtkWidget *text_view = get_widget(dlg, "testo");
    GtkTextBuffer *text_buffer;
    FILE *infile;
    char buffer[1024], *str;
 
/* call common print dialog to get initialized printer DC */ 
    memset(&pdPrint, 0, sizeof(PRINTDLG));
    pdPrint.lStructSize = sizeof(PRINTDLG);
    pdPrint.hwndOwner = hWnd;
    pdPrint.hDevMode = (HANDLE) NULL; 
    pdPrint.hDevNames = (HANDLE) NULL; 
    pdPrint.Flags = PD_RETURNDC; 
    pdPrint.hDC = (HDC) NULL; 
    pdPrint.nFromPage = 1; 
    pdPrint.nToPage = 1; 
    pdPrint.nMinPage = 0; 
    pdPrint.nMaxPage = 0; 
    pdPrint.nCopies = 1; 
    pdPrint.hInstance = NULL; //(HANDLE) NULL; 
    pdPrint.lCustData = 0L; 
    pdPrint.lpfnPrintHook = NULL; //(LPPRINTHOOKPROC) NULL; 
    pdPrint.lpfnSetupHook = NULL; //(LPSETUPHOOKPROC) NULL; 
    pdPrint.lpPrintTemplateName = NULL; //(LPSTR) NULL; 
    pdPrint.lpSetupTemplateName = NULL; //(LPSTR)  NULL; 
    pdPrint.hPrintTemplate = NULL; //(HANDLE) NULL; 
    pdPrint.hSetupTemplate = NULL; //(HANDLE) NULL;  
 
    /* call common print dialog */ 
    if (!PrintDlg (&pdPrint)) 
         return -1; 
 
    text_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view));
    hFont = (HFONT) GetStockObject(SYSTEM_FONT); 
    {
        HDC     hdcScreen; 
        LOGFONT lf; 
 
        if (NULL != (hdcScreen = GetDC(hWnd))) 
        { 
            if(GetObject(hFont, sizeof(LOGFONT), &lf))
            {
               PangoFontDescription *fontdesc  = DefaultFont();

                lf.lfWidth = 0; 
                lf.lfHeight = get_hFont(fontdesc); 
                lf.lfWeight = FW_NORMAL;
                lf.lfHeight = lf.lfHeight 
                            * GetDeviceCaps(pdPrint.hDC, LOGPIXELSX) 
                            / GetDeviceCaps(hdcScreen, LOGPIXELSX); 
//                CopiaStringa(lf.lfFaceName, 256, "Monospace"); 
                CopiaStringa(lf.lfFaceName, 256, MONOSPACE_FONT); 
                if (NULL != (hFontPrt = CreateFontIndirect(&lf)))
                    hFont = hFontPrt; 
            } 
            ReleaseDC(hWnd, hdcScreen); 
        } 
    } 
    hFont = (HFONT) SelectObject(pdPrint.hDC, hFont); 
    int MaxWidth = GetDeviceCaps(pdPrint.hDC, PHYSICALWIDTH) - 2 * GetDeviceCaps(pdPrint.hDC, PHYSICALOFFSETX);
    /* initialize printer for job */ 
    diPrint.cbSize = sizeof (DOCINFO); 
    diPrint.lpszDocName = file; 
    diPrint.lpszOutput = NULL; 
    if (StartDoc (pdPrint.hDC, &diPrint) == SP_ERROR ||  StartPage (pdPrint.hDC) < 0) 
    { 
/* on error, clean up and go away */ 
        SelectObject(pdPrint.hDC, hFont); 
        if (hFontPrt)
            DeleteObject(hFontPrt); 
        DeleteDC (pdPrint.hDC); 
        return -1; 
    } 
 
 
    /* retrieve dimensions for printing and init loop variables */ 
    uNumLines = gtk_text_buffer_get_line_count  (text_buffer);

    GetTextExtentPoint32 (pdPrint.hDC, "CC", 2, &sLine); 
    yLineExt = sLine.cy; 
    xCharExt = sLine.cx/2; 
    nMaxChars = MaxWidth / xCharExt;
    yPageExt = GetDeviceCaps (pdPrint.hDC, VERTRES) - 4*yLineExt; 
    yExt = 0; 
    uLine = 0; 
    if (pdPrint.Flags & PD_PAGENUMS)  
        uLine = (pdPrint.nFromPage - 1) * (yPageExt / yLineExt); 
    
 
    /* print text line by line from top to bottom */ 

    infile = fOpen(file, "r");
    if(!infile)
       return -1;
  
    while((str = fgets(buffer, 1024, infile)) != NULL)
//    while (uLine < uNumLines) 
   { 
/* if at end of page, start a new page */ 
       if ((yExt + yLineExt) > yPageExt) 
       { 
          if (!EndPage (pdPrint.hDC) || StartPage (pdPrint.hDC) < 0) 
          { 
              SelectObject(pdPrint.hDC, hFont); 
              if (hFontPrt)
                  DeleteObject(hFontPrt); 
              DeleteDC (pdPrint.hDC); 
              return -1; 
          } 
          yExt = 0; 
       } 
 
/* determine buffer offset for current line and line length */ 
       char *str1 = filtra(str, "\n");
       uLineLen = (unsigned int) strlen(str1); 
       while(uLineLen > (unsigned int) nMaxChars)
       {
          TextOut (pdPrint.hDC, 200, yExt+2*yLineExt, str1, nMaxChars); 
          yExt += 2*yLineExt; 
          uLine++; 
          str1 += nMaxChars;
          uLineLen -= nMaxChars;
       }
 
/* print current the line and unlock the text handle */ 
       TextOut (pdPrint.hDC, 200, yExt+2*yLineExt, str1, uLineLen); 
 
/* increment page position */ 
       yExt += 2*yLineExt; 
       uLine++; 
   } 
 
    /* end the last page and document */ 
    EndPage (pdPrint.hDC); 
    EndDoc (pdPrint.hDC); 
 
    SelectObject(pdPrint.hDC, hFont); 
    if (hFontPrt) { 
        DeleteObject(hFontPrt); 
    } 
    /* clean up and exit */ 
    DeleteDC(pdPrint.hDC); 
    return TRUE; 
} 
 
void PrintFile(GtkWidget *dlg,  const char *file)
{
    HWND        hWnd = (HWND) GDK_WINDOW_HWND(dlg->window);
    std::string fn;
    if(g_path_is_absolute (file))
       fn.assign(file);
    else
       fn = g_build_filename(g_get_current_dir(), file, NULL);
    TPrintFile(hWnd, dlg, fn.c_str());
}
#else
void PrintFile(GtkWidget *dlg,  const char *file)
{
}
#endif
#endif

int apply_markup(GtkTextBuffer *buffer, const char *message, 
                 GtkTextIter *log_iter, char csize)
{
   GtkTextIter iter1, iter2;
   gchar *text;
   PangoAttrList *attrs;
   PangoAttrIterator *iterator;
   gint start, end;
   PangoAttribute *attr;
   char *fg_color = g_new0(char, 20), *string;
   GtkTextTag *tag1[10];
   int ntag = 0, i, i1, i2, size;
   const gchar *strlang;
   gboolean result;
   bool col_set = false, size_set = false, font_set = false;

  switch(csize)
   {
   case 'S':
         size = 8;
         break;
   case 'M':
   default:
         size = 12;
         break;
   case 'L':
         size = 14;
         break;
   }
  result = pango_parse_markup (message, -1, 0, &attrs, &text, NULL, NULL);
  if(!result)
     return result;

  iterator = pango_attr_list_get_iterator(attrs);

  do 
  {
      ntag = 0;
      size_set= false;
      col_set  = false;
      font_set = false;
      pango_attr_iterator_range(iterator, &start, &end);

      size_t szstring = 2*strlen(text) + 1;
      string = g_new0(char, szstring);
      ScriviStringa(string, szstring, "%.*s", MIN((gint)strlen(text), end - start),
              &text[start]);
      if ((attr = pango_attr_iterator_get(iterator, PANGO_ATTR_FOREGROUND)) != NULL) 
      {
          const PangoAttrColor *color_attr = (const PangoAttrColor *)attr;
          ScriviStringa (fg_color, 20, "#%04x%04x%04x", color_attr->color.red,
                   color_attr->color.green, color_attr->color.blue);
          tag1[ntag++] = gtk_text_buffer_create_tag (buffer, NULL, "foreground", fg_color, NULL);
          col_set = true;
      }
      if ((attr = pango_attr_iterator_get(iterator, PANGO_ATTR_UNDERLINE)) != NULL)
      {
          tag1[ntag++] = gtk_text_buffer_create_tag (buffer, NULL,
                      "underline", PANGO_UNDERLINE_SINGLE, NULL);
      }
      if((attr = pango_attr_iterator_get(iterator, PANGO_ATTR_WEIGHT)) != NULL)
      {
          PangoAttrInt *bal = (PangoAttrInt *)attr;
          tag1[ntag++] = gtk_text_buffer_create_tag (buffer, NULL,
                      "weight", bal->value, NULL);
      }
      if((attr = pango_attr_iterator_get(iterator, PANGO_ATTR_SIZE)) != NULL)
      {
          PangoAttrInt *bal = (PangoAttrInt *)attr;
          tag1[ntag++] = gtk_text_buffer_create_tag (buffer, NULL,
                      "size", bal->value, NULL);
          size_set = true;
      }
      if((attr = pango_attr_iterator_get(iterator, PANGO_ATTR_SCALE)) != NULL)
      {
          PangoAttrFloat *bal = (PangoAttrFloat *)attr;
          tag1[ntag++] = gtk_text_buffer_create_tag (buffer, NULL,
                      "scale", bal->value, NULL);
          size_set = true;
      }
      if((attr = pango_attr_iterator_get(iterator, PANGO_ATTR_RISE)) != NULL)
      {
          PangoAttrInt *bal = (PangoAttrInt *)attr;
          tag1[ntag++] = gtk_text_buffer_create_tag (buffer, NULL,
                      "rise", bal->value, NULL);
      }
      if((attr = pango_attr_iterator_get(iterator, PANGO_ATTR_FAMILY)) != NULL)
      {
          PangoAttrString *family = (PangoAttrString *)attr;
          tag1[ntag++] = gtk_text_buffer_create_tag (buffer, NULL,
                      "family", family->value, NULL);
          font_set = true;
      }
      if((attr = pango_attr_iterator_get(iterator, PANGO_ATTR_LANGUAGE)) != NULL)
      {
          PangoAttrLanguage *language = (PangoAttrLanguage *)attr;
          strlang = pango_language_to_string(language->value);
          if(strstr(strlang, "greek"))
          {
             std::string str2;
             for(i=0; i<(int)strlen(string); i++)
                 str2.append(special_car_greek(string[i]));
             CopiaStringa(string, szstring, str2.c_str());
          }
          else if(strstr(strlang, "a"))
          {
             std::string str2;
             for(i=0; i<(int)strlen(string); i++)
                 str2.append(special_car(Aring)); 
             CopiaStringa(string, szstring, str2.c_str());
          }
      }
      if(!col_set)
           tag1[ntag++] = gtk_text_buffer_create_tag (buffer, NULL, "foreground", "black", NULL);  
      if(!size_set)
           tag1[ntag++] = gtk_text_buffer_create_tag (buffer, NULL,
			      "size", size*PANGO_SCALE, NULL);  
      if(!font_set)
           tag1[ntag++] = gtk_text_buffer_create_tag (buffer, NULL,
			      "family", MONOSPACE_FONT, NULL);  
      i1 = gtk_text_iter_get_offset(log_iter);
      gtk_text_buffer_insert (buffer, log_iter, string, -1);
      i2 = gtk_text_iter_get_offset(log_iter);
      gtk_text_buffer_get_iter_at_offset(buffer, &iter1, i1);
      gtk_text_buffer_get_iter_at_offset(buffer, &iter2, i2);
      for (i=0; i<ntag; i++)
          gtk_text_buffer_apply_tag(buffer, tag1[i], &iter1, &iter2);
      g_free(string);
  }
  while (pango_attr_iterator_next(iterator));

  gtk_text_buffer_insert(buffer, log_iter, "\n", 1);
  GtkTextIter endIter;
  gtk_text_buffer_get_end_iter(buffer, &endIter);
  gtk_text_buffer_delete(buffer, log_iter, &endIter);
  
  pango_attr_iterator_destroy (iterator);
  return result;
}

int load_file_into_buffer( const char *filename, GtkTextBuffer *text, 
                           int flags)
{
   FILE *infile = NULL;
   GtkTextIter iter;

   if(filename && strlen(filename))
      infile = fOpen(filename, "r");
  
   if (infile) 
   {
       char buffer[1024], *str, *str1;

       GtkTextIter i1, i2;

       gtk_text_buffer_get_bounds(text, &i1, &i2);
       gtk_text_buffer_delete(text, &i1, &i2);

       GtkTextTagTable *tag_table = gtk_text_buffer_get_tag_table (text);
       int ntag = 0;
       GtkTextTag *tag[2];
       if((flags & gtkext::IFPROP) == 0)
       {
          tag[ntag] = gtk_text_tag_table_lookup (tag_table, "Family");
          if(tag[ntag] == NULL)
             tag[ntag]= gtk_text_buffer_create_tag (text, "Family",
                      "family", MONOSPACE_FONT, NULL);
          ntag++;
       }
       if(flags & gtkext::IFWRAP)
       {
          tag[ntag] = gtk_text_tag_table_lookup (tag_table, "Wrap");
          if(tag[ntag] == NULL)
             tag[ntag]= gtk_text_buffer_create_tag (text, "Wrap",
                      "wrap_mode", GTK_WRAP_WORD, NULL);
          ntag++;
       }
       gtk_text_buffer_get_iter_at_offset (text, &iter, 0);
       while((str1 = fgets(buffer, 1024, infile)) != NULL)
       {
            str = (DuplicaStringa(toUTF8(str1)));
            if(!ntag)
                gtk_text_buffer_insert(text,
                                   &iter,
                                   g_strchomp(str), 
                                   (gint) strlen(g_strchomp(str)));
            else if(ntag == 1)
                gtk_text_buffer_insert_with_tags(text,
                                   &iter,
                                   g_strchomp(str), 
                                   (gint) strlen(g_strchomp(str)),
                                   tag[0], NULL);
            else
                gtk_text_buffer_insert_with_tags(text,
                                   &iter,
                                   g_strchomp(str), 
                                   (gint) strlen(g_strchomp(str)),
                                   tag[0], tag[1], NULL);
            gtk_text_buffer_insert(text,
                                   &iter,
                                   "\n", 
                                   1);
            g_free(str);
       }
       (void) fclose (infile);

       GtkTextIter iter1, iter2;
       if(flags & gtkext::IFMARKUP)
       {
          gtk_text_buffer_get_bounds (text, &iter1, &iter2);
          char *testo = gtk_text_buffer_get_text(text, &iter1, &iter2, FALSE);
          (void) apply_markup(text, testo, &iter1, 'S');
       }
       return 0;
    }
    return -1;
}

GtkWidget *image_button( const char *imagename)
{
    GtkWidget *image, *button;
    button = gtk_button_new();

#ifdef GTK_STOCK_OK
    if(!strchr(imagename, '.'))
       image = gtk_image_new_from_stock(imagename, GTK_ICON_SIZE_LARGE_TOOLBAR);
    else
#endif
       image = create_image(imagename);
    gtk_container_add(GTK_CONTAINER(button), image);
    gtk_button_set_relief(GTK_BUTTON(button), GTK_RELIEF_NONE);
    return button;
}

GtkWidget *myimage_button(const gchar *label, const gchar  *filename)
{
    GtkWidget *button, *pixmapwid;
#ifdef NOIMAGEBUTTON
    GtkWidget *hbox, *labelw;
    GtkWidget *align;

    button = gtk_button_new ();
    GtkWidget *align = gtk_alignment_new (0.5, 0.5, 0, 0);
    gtk_container_add (GTK_CONTAINER (button), align);

    hbox = hbox_new(FALSE, 0);
    gtk_container_add (GTK_CONTAINER (align), hbox);
    gtk_container_set_border_width (GTK_CONTAINER (hbox), 1);

    pixmapwid = create_image (filename);
    if(pixmapwid)
        gtk_box_pack_start(GTK_BOX (hbox), pixmapwid, FALSE, FALSE, 0);
    if(label)
    {
       labelw = gtk_label_new_with_mnemonic (label);
       gtk_box_pack_start (GTK_BOX (hbox), labelw, FALSE, FALSE, 4);
    }

    gtk_widget_show_all(button);
#else
    if(label)
       button = gtk_button_new_with_mnemonic(label);
    else
       button = gtk_button_new();
    pixmapwid = create_image (filename);
    if(pixmapwid)
       gtk_button_set_image (GTK_BUTTON(button), pixmapwid);
    gtk_widget_show(button);
#endif
    return button;
}

static void change_frame(GtkToggleButton *button, gpointer data)
{
    GtkWidget *frame = (GtkWidget *) data;
    if(gtk_toggle_button_get_active(button))
       gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
    else
       gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_OUT);
}

GtkWidget *myimage_togbutton(const gchar  *filename)
{
    GtkWidget *button;
    GtkWidget *pixmapwid, *align;

    button = gtk_toggle_button_new ();
    align = gtk_frame_new(NULL);
    gtk_frame_set_shadow_type(GTK_FRAME(align), GTK_SHADOW_OUT);
    gtk_container_add (GTK_CONTAINER (button), align);
    gtk_container_set_border_width(GTK_CONTAINER (button), 0);

    pixmapwid = create_image (filename);
    if(pixmapwid)
        gtk_container_add (GTK_CONTAINER (align), pixmapwid);
    gtk_container_set_border_width(GTK_CONTAINER (align), 0);
    gtk_widget_show_all(button);
    g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(change_frame),
                     (gpointer) align);
    return button;
}

/************************************************************/
/*************** L i s t s  functions  **********************/
/************************************************************/

#ifdef VERY_LOW_VERSION
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <glib.h>
typedef enum
{
  GTK_RBNODE_BLACK = 1 << 0,
  GTK_RBNODE_RED = 1 << 1,
  GTK_RBNODE_IS_PARENT = 1 << 2,
  GTK_RBNODE_IS_SELECTED = 1 << 3,
  GTK_RBNODE_IS_PRELIT = 1 << 4,
  GTK_RBNODE_IS_SEMI_COLLAPSED = 1 << 5,
  GTK_RBNODE_IS_SEMI_EXPANDED = 1 << 6,
  GTK_RBNODE_INVALID = 1 << 7,
  GTK_RBNODE_COLUMN_INVALID = 1 << 8,
  GTK_RBNODE_DESCENDANTS_INVALID = 1 << 9,
  GTK_RBNODE_NON_COLORS = GTK_RBNODE_IS_PARENT |
                          GTK_RBNODE_IS_SELECTED |
                          GTK_RBNODE_IS_PRELIT |
                          GTK_RBNODE_IS_SEMI_COLLAPSED |
                          GTK_RBNODE_IS_SEMI_EXPANDED |
                          GTK_RBNODE_INVALID |
                          GTK_RBNODE_COLUMN_INVALID |
                          GTK_RBNODE_DESCENDANTS_INVALID
} GtkRBNodeColor;

typedef struct _GtkRBTree GtkRBTree;
typedef struct _GtkRBNode GtkRBNode;
typedef struct _GtkRBTreeView GtkRBTreeView;

typedef void (*GtkRBTreeTraverseFunc) (GtkRBTree  *tree,
                                       GtkRBNode  *node,
                                       gpointer  data);

struct _GtkRBTree
{
  GtkRBNode *root;
  GtkRBNode *nil;
  GtkRBTree *parent_tree;
  GtkRBNode *parent_node;
};

struct _GtkRBNode
{
  guint flags : 14;

  /* We keep track of whether the aggregate count of children plus 1
   * for the node itself comes to an even number.  The parity flag is
   * the total count of children mod 2, where the total count of
   * children gets computed in the same way that the total offset gets
   * computed. i.e. not the same as the "count" field below which
   * doesn't include children. We could replace parity with a
   * full-size int field here, and then take % 2 to get the parity flag,
   * but that would use extra memory.
   */

  guint parity : 1;
  
  GtkRBNode *left;
  GtkRBNode *right;
  GtkRBNode *parent;

  /* count is the number of nodes beneath us, plus 1 for ourselves.
   * i.e. node->left->count + node->right->count + 1
   */
  gint count;
  
  /* this is the total of sizes of
   * node->left, node->right, our own height, and the height
   * of all trees in ->children, iff children exists because
   * the thing is expanded.
   */
  gint offset;

  /* Child trees */
  GtkRBTree *children;
};


#define GTK_RBNODE_GET_COLOR(node) (node?(((node->flags&GTK_RBNODE_RED)==GTK_RBNODE_RED)?GTK_RBNODE_RED:GTK_RBNODE_BLACK):GTK_RBNODE_BLACK)
#define GTK_RBNODE_SET_COLOR(node,color)  if((node->flags&color)!=color)node->flags=node->flags^(GTK_RBNODE_RED|GTK_RBNODE_BLACK)
#define GTK_RBNODE_GET_HEIGHT(node)  (node->offset-(node->left->offset+node->right->offset+(node->children?node->children->root->offset:0)))
#define GTK_RBNODE_SET_FLAG(node, flag)    G_STMT_START{ (node->flags|=flag); }G_STMT_END
#define GTK_RBNODE_UNSET_FLAG(node, flag)  G_STMT_START{ (node->flags&=~(flag)); }G_STMT_END
#define GTK_RBNODE_FLAG_SET(node, flag)  (node?(((node->flags&flag)==flag)?TRUE:FALSE):FALSE)


void       _gtk_rbtree_push_allocator   (GAllocator             *allocator);
void       _gtk_rbtree_pop_allocator    (void);
GtkRBTree *_gtk_rbtree_new              (void);
void       _gtk_rbtree_free             (GtkRBTree              *tree);
void       _gtk_rbtree_remove           (GtkRBTree              *tree);
void       _gtk_rbtree_destroy          (GtkRBTree              *tree);
GtkRBNode *_gtk_rbtree_insert_before    (GtkRBTree              *tree,
                                         GtkRBNode              *node,
                                         gint                    height,
                                         gboolean                valid);
GtkRBNode *_gtk_rbtree_insert_after     (GtkRBTree              *tree,
                                         GtkRBNode              *node,
                                         gint                    height,
                                         gboolean                valid);
void       _gtk_rbtree_remove_node      (GtkRBTree              *tree,
                                         GtkRBNode              *node);
void       _gtk_rbtree_reorder          (GtkRBTree              *tree,
                                         gint                   *new_order,
                                         gint                    length);
GtkRBNode *_gtk_rbtree_find_count       (GtkRBTree              *tree,
                                         gint                    count);
void       _gtk_rbtree_node_set_height  (GtkRBTree              *tree,
                                         GtkRBNode              *node,
                                         gint                    height);
void       _gtk_rbtree_node_mark_invalid(GtkRBTree              *tree,
                                         GtkRBNode              *node);
void       _gtk_rbtree_node_mark_valid  (GtkRBTree              *tree,
                                         GtkRBNode              *node);
void       _gtk_rbtree_column_invalid   (GtkRBTree              *tree);
void       _gtk_rbtree_mark_invalid     (GtkRBTree              *tree);
void       _gtk_rbtree_set_fixed_height (GtkRBTree              *tree,
                                         gint                    height);
gint       _gtk_rbtree_node_find_offset (GtkRBTree              *tree,
                                         GtkRBNode              *node);
gint       _gtk_rbtree_node_find_parity (GtkRBTree              *tree,
                                         GtkRBNode              *node);
gint       _gtk_rbtree_find_offset      (GtkRBTree              *tree,
                                         gint                    offset,
                                         GtkRBTree             **new_tree,
                                         GtkRBNode             **new_node);
void       _gtk_rbtree_traverse         (GtkRBTree              *tree,
                                         GtkRBNode              *node,
                                         GTraverseType           order,
                                         GtkRBTreeTraverseFunc   func,
                                         gpointer                data);
GtkRBNode *_gtk_rbtree_next             (GtkRBTree              *tree,
                                         GtkRBNode              *node);
GtkRBNode *_gtk_rbtree_prev             (GtkRBTree              *tree,
                                         GtkRBNode              *node);
void       _gtk_rbtree_next_full        (GtkRBTree              *tree,
                                         GtkRBNode              *node,
                                         GtkRBTree             **new_tree,
                                         GtkRBNode             **new_node);
void       _gtk_rbtree_prev_full        (GtkRBTree              *tree,
                                         GtkRBNode              *node,
                                         GtkRBTree             **new_tree,
                                         GtkRBNode             **new_node);

gint       _gtk_rbtree_get_depth        (GtkRBTree              *tree);

  
#define TREE_VIEW_DRAG_WIDTH 6

typedef enum
{
  GTK_TREE_VIEW_IS_LIST = 1 << 0,
  GTK_TREE_VIEW_SHOW_EXPANDERS = 1 << 1,
  GTK_TREE_VIEW_IN_COLUMN_RESIZE = 1 << 2,
  GTK_TREE_VIEW_ARROW_PRELIT = 1 << 3,
  GTK_TREE_VIEW_HEADERS_VISIBLE = 1 << 4,
  GTK_TREE_VIEW_DRAW_KEYFOCUS = 1 << 5,
  GTK_TREE_VIEW_MODEL_SETUP = 1 << 6,
  GTK_TREE_VIEW_IN_COLUMN_DRAG = 1 << 7
} GtkTreeViewFlags;

typedef enum
{
  GTK_TREE_SELECT_MODE_TOGGLE = 1 << 0,
  GTK_TREE_SELECT_MODE_EXTEND = 1 << 1
}
GtkTreeSelectMode;

enum
{
  DRAG_COLUMN_WINDOW_STATE_UNSET = 0,
  DRAG_COLUMN_WINDOW_STATE_ORIGINAL = 1,
  DRAG_COLUMN_WINDOW_STATE_ARROW = 2,
  DRAG_COLUMN_WINDOW_STATE_ARROW_LEFT = 3,
  DRAG_COLUMN_WINDOW_STATE_ARROW_RIGHT = 4
};
  
#define GTK_TREE_VIEW_SET_FLAG(tree_view, flag)   G_STMT_START{ (tree_view->priv->flags|=flag); }G_STMT_END
#define GTK_TREE_VIEW_UNSET_FLAG(tree_view, flag) G_STMT_START{ (tree_view->priv->flags&=~(flag)); }G_STMT_END
#define GTK_TREE_VIEW_FLAG_SET(tree_view, flag)   ((tree_view->priv->flags&flag)==flag)
#define TREE_VIEW_HEADER_HEIGHT(tree_view)        (GTK_TREE_VIEW_FLAG_SET (tree_view, GTK_TREE_VIEW_HEADERS_VISIBLE)?tree_view->priv->header_height:0)
#define TREE_VIEW_COLUMN_REQUESTED_WIDTH(column)  (CLAMP (column->requested_width, (column->min_width!=-1)?column->min_width:column->requested_width, (column->max_width!=-1)?column->max_width:column->requested_width))
#define TREE_VIEW_DRAW_EXPANDERS(tree_view)       (!GTK_TREE_VIEW_FLAG_SET (tree_view, GTK_TREE_VIEW_IS_LIST)&&GTK_TREE_VIEW_FLAG_SET (tree_view, GTK_TREE_VIEW_SHOW_EXPANDERS))

 /* This lovely little value is used to determine how far away from the title bar
  * you can move the mouse and still have a column drag work.
  */
#define TREE_VIEW_COLUMN_DRAG_DEAD_MULTIPLIER(tree_view) (10*TREE_VIEW_HEADER_HEIGHT(tree_view))

typedef void (*GtkTreeViewSearchDialogPositionFunc) (GtkTreeView *tree_view,
                                         GtkWidget   *search_dialog);

typedef struct _GtkTreeViewColumnReorder GtkTreeViewColumnReorder;
struct _GtkTreeViewColumnReorder
{
  gint left_align;
  gint right_align;
  GtkTreeViewColumn *left_column;
  GtkTreeViewColumn *right_column;
};

struct _GtkTreeViewPrivate
{
  GtkTreeModel *model;

  guint flags;
  /* tree information */
  GtkRBTree *tree;

  GtkRBNode *button_pressed_node;
  GtkRBTree *button_pressed_tree;

  GList *children;
  gint width;
  gint height;
  gint expander_size;

  GtkAdjustment *hadjustment;
  GtkAdjustment *vadjustment;

  GdkWindow *bin_window;
  GdkWindow *header_window;
  GdkWindow *drag_window;
  GdkWindow *drag_highlight_window;
  GtkTreeViewColumn *drag_column;

  GtkTreeRowReference *last_button_press;
  GtkTreeRowReference *last_button_press_2;

  /* bin_window offset */
  GtkTreeRowReference *top_row;
  gint top_row_dy;
  /* dy == y pos of top_row + top_row_dy */
  /* we cache it for simplicity of the code */
  gint dy;
  gint drag_column_x;

  GtkTreeViewColumn *expander_column;
  GtkTreeViewColumn *edited_column;
  guint presize_handler_timer;
  guint validate_rows_timer;
  guint scroll_sync_timer;

  /* Focus code */
  GtkTreeViewColumn *focus_column;

  /* Selection stuff */
  GtkTreeRowReference *anchor;
  GtkTreeRowReference *cursor;

  /* Column Resizing */
  gint drag_pos;
  gint x_drag;

  /* Prelight information */
  GtkRBNode *prelight_node;
  GtkRBTree *prelight_tree;

  /* The node that's currently being collapsed or expanded */
  GtkRBNode *expanded_collapsed_node;
  GtkRBTree *expanded_collapsed_tree;
  guint expand_collapse_timeout;

  /* Selection information */
  GtkTreeSelection *selection;

  /* Header information */
  gint n_columns;
  GList *columns;
  gint header_height;

  GtkTreeViewColumnDropFunc column_drop_func;
  gpointer column_drop_func_data;
  GtkDestroyNotify column_drop_func_data_destroy;
  GList *column_drag_info;
  GtkTreeViewColumnReorder *cur_reorder;

  /* ATK Hack */
  GtkTreeDestroyCountFunc destroy_count_func;
  gpointer destroy_count_data;
  GtkDestroyNotify destroy_count_destroy;

  /* Scroll timeout (e.g. during dnd) */
  guint scroll_timeout;

  /* Row drag-and-drop */
  GtkTreeRowReference *drag_dest_row;
  GtkTreeViewDropPosition drag_dest_pos;
  guint open_dest_timeout;

  gint pressed_button;
  gint press_start_x;
  gint press_start_y;

  /* Scroll-to functionality when unrealized */
  GtkTreeRowReference *scroll_to_path;
  GtkTreeViewColumn *scroll_to_column;
  gfloat scroll_to_row_align;
  gfloat scroll_to_col_align;
  guint scroll_to_use_align : 1;

  guint fixed_height_check : 1;

  guint reorderable : 1;
  guint header_has_focus : 1;
  guint drag_column_window_state : 3;
  /* hint to display rows in alternating colors */
  guint has_rules : 1;
  guint mark_rows_col_dirty : 1;

  guint ctrl_pressed : 1;
  guint shift_pressed : 1;
  
  /* interactive search */
  guint enable_search : 1;
  guint disable_popdown : 1;
  gint search_column;
  GtkTreeViewSearchDialogPositionFunc search_dialog_position_func;
  GtkTreeViewSearchEqualFunc search_equal_func;
  gpointer search_user_data;
  GtkDestroyNotify search_destroy;
};

/* cool ABI compat hack */
#define GTK_CELL_RENDERER_INFO_KEY "gtk-cell-renderer-info"

typedef struct _GtkCellRendererInfo GtkCellRendererInfo;
struct _GtkCellRendererInfo
{
  GdkColor cell_background;

  /* text renderer */
  gulong focus_out_id;

  /* toggle renderer */
  guint inconsistent :1;
};

#ifdef __GNUC__

#define TREE_VIEW_INTERNAL_ASSERT(expr, ret)     G_STMT_START{          \
     if (!(expr))                                                       \
       {                                                                \
         g_log (G_LOG_DOMAIN,                                           \
                G_LOG_LEVEL_CRITICAL,                                   \
                "file %s: line %d (%s): assertion `%s' failed.\n"       \
                "There is a disparity between the internal view of the GtkTreeView,\n"    \
                "and the GtkTreeModel.  This generally means that the model has changed\n"\
                "without letting the view know.  Any display from now on is likely to\n"  \
                "be incorrect.\n",                                                        \
                __FILE__,                                               \
                __LINE__,                                               \
                __PRETTY_FUNCTION__,                                    \
                #expr);                                                 \
         return ret;                                                    \
       };                               }G_STMT_END

#define TREE_VIEW_INTERNAL_ASSERT_VOID(expr)     G_STMT_START{          \
     if (!(expr))                                                       \
       {                                                                \
         g_log (G_LOG_DOMAIN,                                           \
                G_LOG_LEVEL_CRITICAL,                                   \
                "file %s: line %d (%s): assertion `%s' failed.\n"       \
                "There is a disparity between the internal view of the GtkTreeView,\n"    \
                "and the GtkTreeModel.  This generally means that the model has changed\n"\
                "without letting the view know.  Any display from now on is likely to\n"  \
                "be incorrect.\n",                                                        \
                __FILE__,                                               \
                __LINE__,                                               \
                __PRETTY_FUNCTION__,                                    \
                #expr);                                                 \
         return;                                                        \
       };                               }G_STMT_END

#else

#define TREE_VIEW_INTERNAL_ASSERT(expr, ret)     G_STMT_START{          \
     if (!(expr))                                                       \
       {                                                                \
         g_log (G_LOG_DOMAIN,                                           \
                G_LOG_LEVEL_CRITICAL,                                   \
                "file %s: line %d: assertion `%s' failed.\n"       \
                "There is a disparity between the internal view of the GtkTreeView,\n"    \
                "and the GtkTreeModel.  This generally means that the model has changed\n"\
                "without letting the view know.  Any display from now on is likely to\n"  \
                "be incorrect.\n",                                                        \
                __FILE__,                                               \
                __LINE__,                                               \
                #expr);                                                 \
         return ret;                                                    \
       };                               }G_STMT_END

#define TREE_VIEW_INTERNAL_ASSERT_VOID(expr)     G_STMT_START{          \
     if (!(expr))                                                       \
       {                                                                \
         g_log (G_LOG_DOMAIN,                                           \
                G_LOG_LEVEL_CRITICAL,                                   \
                "file %s: line %d: assertion '%s' failed.\n"            \
                "There is a disparity between the internal view of the GtkTreeView,\n"    \
                "and the GtkTreeModel.  This generally means that the model has changed\n"\
                "without letting the view know.  Any display from now on is likely to\n"  \
                "be incorrect.\n",                                                        \
                __FILE__,                                               \
                __LINE__,                                               \
                #expr);                                                 \
         return;                                                        \
       };                               }G_STMT_END
#endif


/* functions that shouldn't be exported */
void         _gtk_tree_selection_internal_select_node (GtkTreeSelection  *selection,
                GtkRBNode         *node,
                GtkRBTree         *tree,
                GtkTreePath       *path,
                                                       GtkTreeSelectMode  mode,
                gboolean           override_browse_mode);
gboolean     _gtk_tree_view_find_node                 (GtkTreeView       *tree_view,
                GtkTreePath       *path,
                GtkRBTree        **tree,
                GtkRBNode        **node);
GtkTreePath *_gtk_tree_view_find_path                 (GtkTreeView       *tree_view,
                GtkRBTree         *tree,
                GtkRBNode         *node);
void         _gtk_tree_view_child_move_resize         (GtkTreeView       *tree_view,
                GtkWidget         *widget,
                gint               x,
                gint               y,
                gint               width,
                gint               height);
void         _gtk_tree_view_queue_draw_node           (GtkTreeView       *tree_view,
                GtkRBTree         *tree,
                GtkRBNode         *node,
                GdkRectangle      *clip_rect);

void _gtk_tree_view_column_realize_button   (GtkTreeViewColumn *column);
void _gtk_tree_view_column_unrealize_button (GtkTreeViewColumn *column);
void _gtk_tree_view_column_set_tree_view    (GtkTreeViewColumn *column,
                GtkTreeView       *tree_view);
void _gtk_tree_view_column_unset_model      (GtkTreeViewColumn *column,
                GtkTreeModel      *old_model);
void _gtk_tree_view_column_unset_tree_view  (GtkTreeViewColumn *column);
void _gtk_tree_view_column_set_width        (GtkTreeViewColumn *column,
                gint               width);
void _gtk_tree_view_column_start_drag       (GtkTreeView       *tree_view,
                GtkTreeViewColumn *column);
gboolean _gtk_tree_view_column_cell_event   (GtkTreeViewColumn  *tree_column,
                GtkCellEditable   **editable_widget,
                GdkEvent           *event,
                gchar              *path_string,
                GdkRectangle       *background_area,
                GdkRectangle       *cell_area,
                guint               flags);
void _gtk_tree_view_column_start_editing (GtkTreeViewColumn *tree_column,
                GtkCellEditable   *editable_widget);
void _gtk_tree_view_column_stop_editing  (GtkTreeViewColumn *tree_column);
void _gtk_tree_view_install_mark_rows_col_dirty (GtkTreeView *tree_view);
void             _gtk_tree_view_column_autosize          (GtkTreeView       *tree_view,
                GtkTreeViewColumn *column);

gboolean         _gtk_tree_view_column_has_editable_cell (GtkTreeViewColumn *column);
GtkCellRenderer *_gtk_tree_view_column_get_edited_cell   (GtkTreeViewColumn *column);
gint             _gtk_tree_view_column_count_special_cells (GtkTreeViewColumn *column);
GtkCellRenderer *_gtk_tree_view_column_get_cell_at_pos   (GtkTreeViewColumn *column,
                gint               x);

GtkTreeSelection* _gtk_tree_selection_new                (void);
GtkTreeSelection* _gtk_tree_selection_new_with_tree_view (GtkTreeView      *tree_view);
void              _gtk_tree_selection_set_tree_view      (GtkTreeSelection *selection,
                                                          GtkTreeView      *tree_view);

void                _gtk_tree_view_column_cell_render      (GtkTreeViewColumn *tree_column,
                GdkWindow         *window,
                GdkRectangle      *background_area,
                GdkRectangle      *cell_area,
                GdkRectangle      *expose_area,
                guint              flags);
gboolean       _gtk_tree_view_column_cell_focus       (GtkTreeViewColumn *tree_column,
                gint               direction,
                gboolean           left,
                gboolean           right);
void            _gtk_tree_view_column_cell_draw_focus  (GtkTreeViewColumn *tree_column,
                      GdkWindow         *window,
                      GdkRectangle      *background_area,
                      GdkRectangle      *cell_area,
                      GdkRectangle      *expose_area,
                      guint              flags);
void _gtk_tree_view_column_cell_set_dirty(GtkTreeViewColumn *tree_column,
                   gboolean           install_handler);
void              _gtk_tree_view_column_get_neighbor_sizes (GtkTreeViewColumn *column,
                   GtkCellRenderer   *cell,
                   gint              *left,
                   gint              *right);


#ifdef __cplusplus
}
#endif /* __cplusplus */

static void        _gtk_rbnode_validate_allocator (GAllocator *allocator);
static GtkRBNode * _gtk_rbnode_new                (GtkRBTree  *tree,
                   gint        height);
static void        _gtk_rbnode_free               (GtkRBNode  *node);
static void        _gtk_rbnode_rotate_left        (GtkRBTree  *tree,
                   GtkRBNode  *node);
static void        _gtk_rbnode_rotate_right       (GtkRBTree  *tree,
                   GtkRBNode  *node);
static void        _gtk_rbtree_insert_fixup       (GtkRBTree  *tree,
                   GtkRBNode  *node);
static void        _gtk_rbtree_remove_node_fixup  (GtkRBTree  *tree,
                   GtkRBNode  *node);
static gint        _count_nodes                   (GtkRBTree  *tree,
                   GtkRBNode  *node);
static inline void _fixup_validation              (GtkRBTree  *tree,
                   GtkRBNode  *node);
static inline void _fixup_parity                  (GtkRBTree  *tree,
                   GtkRBNode  *node);



/* node allocation
 */
struct _GAllocator /* from gmem.c */
{
  gchar      *name;
  guint16     n_preallocs;
  guint       is_unused : 1;
  guint       type : 4;
  GAllocator *last;
  GMemChunk  *mem_chunk;
  GtkRBNode  *free_nodes; /* implementation specific */
};


G_LOCK_DEFINE_STATIC (current_allocator);
static GAllocator *current_allocator = NULL;


/* HOLDS: current_allocator_lock */
static void
_gtk_rbnode_validate_allocator (GAllocator *allocator)
{
  g_return_if_fail (allocator != NULL);
  g_return_if_fail (allocator->is_unused == TRUE);

  if (allocator->type != G_ALLOCATOR_NODE)
    {
      allocator->type = G_ALLOCATOR_NODE;
      if (allocator->mem_chunk)
      {
      g_mem_chunk_destroy (allocator->mem_chunk);
      allocator->mem_chunk = NULL;
      }
    }

  if (!allocator->mem_chunk)
    {
      allocator->mem_chunk = g_mem_chunk_new (allocator->name,
      sizeof (GtkRBNode),
      sizeof (GtkRBNode) * allocator->n_preallocs,
      G_ALLOC_ONLY);
      allocator->free_nodes = NULL;
    }

  allocator->is_unused = FALSE;
}

static GtkRBNode *
_gtk_rbnode_new (GtkRBTree *tree, gint height)
{
  GtkRBNode *node;

  G_LOCK (current_allocator);
  if (!current_allocator)
    {
      GAllocator *allocator = g_allocator_new ("GTK+ default GtkRBNode allocator", 128);
      _gtk_rbnode_validate_allocator (allocator);
      allocator->last = NULL;
      current_allocator = allocator;
    }
  if (!current_allocator->free_nodes)
    node = g_chunk_new (GtkRBNode, current_allocator->mem_chunk);
  else
    {
      node = current_allocator->free_nodes;
      current_allocator->free_nodes = node->left;
    }
  G_UNLOCK (current_allocator);

  node->left = tree->nil;
  node->right = tree->nil;
  node->parent = tree->nil;
  node->flags = GTK_RBNODE_RED;
  node->parity = 1;
  node->count = 1;
  node->children = NULL;
  node->offset = height;
  return node;
}

static void
_gtk_rbnode_free (GtkRBNode *node)
{
  G_LOCK (current_allocator);
  node->left = current_allocator->free_nodes;
  current_allocator->free_nodes = node;
  if (gtk_debug_flags & GTK_DEBUG_TREE)
    {
      /* unfortunately node->left has to continue to point to
       * a node...
       */
      node->right = (GtkRBNode *) 0xdeadbeef;
      node->parent = (GtkRBNode *) 0xdeadbeef;
      node->offset = 56789;
      node->count = 56789;
      node->flags = 0;
    }
  G_UNLOCK (current_allocator);
}

static void
_gtk_rbnode_rotate_left (GtkRBTree *tree, GtkRBNode *node)
{
  gint node_height, right_height;
  GtkRBNode *right = node->right;

  g_return_if_fail (node != tree->nil);

  node_height = node->offset -
    (node->left?node->left->offset:0) -
    (node->right?node->right->offset:0) -
    (node->children?node->children->root->offset:0);
  right_height = right->offset -
    (right->left?right->left->offset:0) -
    (right->right?right->right->offset:0) -
    (right->children?right->children->root->offset:0);
  node->right = right->left;
  if (right->left != tree->nil)
    right->left->parent = node;

  if (right != tree->nil)
    right->parent = node->parent;
  if (node->parent != tree->nil)
    {
      if (node == node->parent->left)
          node->parent->left = right;
      else
          node->parent->right = right;
    } else {
      tree->root = right;
    }

  right->left = node;
  if (node != tree->nil)
    node->parent = right;

  node->count = 1 + (node->left?node->left->count:0) +
    (node->right?node->right->count:0);
  right->count = 1 + (right->left?right->left->count:0) +
    (right->right?right->right->count:0);

  node->offset = node_height +
    (node->left?node->left->offset:0) +
    (node->right?node->right->offset:0) +
    (node->children?node->children->root->offset:0);
  right->offset = right_height +
    (right->left?right->left->offset:0) +
    (right->right?right->right->offset:0) +
    (right->children?right->children->root->offset:0);

  _fixup_validation (tree, node);
  _fixup_validation (tree, right);
  _fixup_parity (tree, node);
  _fixup_parity (tree, right);
}

static void
_gtk_rbnode_rotate_right (GtkRBTree *tree, GtkRBNode *node)
{
  gint node_height, left_height;
  GtkRBNode *left = node->left;

  g_return_if_fail (node != tree->nil);

  node_height = node->offset -
    (node->left?node->left->offset:0) -
    (node->right?node->right->offset:0) -
    (node->children?node->children->root->offset:0);
  left_height = left->offset -
    (left->left?left->left->offset:0) -
    (left->right?left->right->offset:0) -
    (left->children?left->children->root->offset:0);
  
  node->left = left->right;
  if (left->right != tree->nil)
    left->right->parent = node;

  if (left != tree->nil)
    left->parent = node->parent;
  if (node->parent != tree->nil)
    {
      if (node == node->parent->right)
          node->parent->right = left;
      else
          node->parent->left = left;
    }
  else
    {
      tree->root = left;
    }

  /* link node and left */
  left->right = node;
  if (node != tree->nil)
    node->parent = left;

  node->count = 1 + (node->left?node->left->count:0) +
    (node->right?node->right->count:0);
  left->count = 1 + (left->left?left->left->count:0) +
    (left->right?left->right->count:0);

  node->offset = node_height +
    (node->left?node->left->offset:0) +
    (node->right?node->right->offset:0) +
    (node->children?node->children->root->offset:0);
  left->offset = left_height +
    (left->left?left->left->offset:0) +
    (left->right?left->right->offset:0) +
    (left->children?left->children->root->offset:0);

  _fixup_validation (tree, node);
  _fixup_validation (tree, left);
  _fixup_parity (tree, node);
  _fixup_parity (tree, left);
}

static void
_gtk_rbtree_insert_fixup (GtkRBTree *tree, GtkRBNode *node)
{

  /* check Red-Black properties */
  while (node != tree->root && GTK_RBNODE_GET_COLOR (node->parent) == GTK_RBNODE_RED)
    {
      /* we have a violation */
      if (node->parent == node->parent->parent->left)
      {
          GtkRBNode *y = node->parent->parent->right;
          if (GTK_RBNODE_GET_COLOR (y) == GTK_RBNODE_RED)
          {
              /* uncle is GTK_RBNODE_RED */
              GTK_RBNODE_SET_COLOR (node->parent, GTK_RBNODE_BLACK);
              GTK_RBNODE_SET_COLOR (y, GTK_RBNODE_BLACK);
              GTK_RBNODE_SET_COLOR (node->parent->parent, GTK_RBNODE_RED);
              node = node->parent->parent;
          }
          else
          {
          /* uncle is GTK_RBNODE_BLACK */
             if (node == node->parent->right)
             {
             /* make node a left child */
                node = node->parent;
               _gtk_rbnode_rotate_left (tree, node);
             }

             /* recolor and rotate */
             GTK_RBNODE_SET_COLOR (node->parent, GTK_RBNODE_BLACK);
             GTK_RBNODE_SET_COLOR (node->parent->parent, GTK_RBNODE_RED);
             _gtk_rbnode_rotate_right(tree, node->parent->parent);
          }
      }
      else
      {
      /* mirror image of above code */
      GtkRBNode *y = node->parent->parent->left;
      if (GTK_RBNODE_GET_COLOR (y) == GTK_RBNODE_RED)
      {
      /* uncle is GTK_RBNODE_RED */
      GTK_RBNODE_SET_COLOR (node->parent, GTK_RBNODE_BLACK);
      GTK_RBNODE_SET_COLOR (y, GTK_RBNODE_BLACK);
      GTK_RBNODE_SET_COLOR (node->parent->parent, GTK_RBNODE_RED);
      node = node->parent->parent;
      }
      else
      {
      /* uncle is GTK_RBNODE_BLACK */
      if (node == node->parent->left)
      {
      node = node->parent;
      _gtk_rbnode_rotate_right (tree, node);
      }
      GTK_RBNODE_SET_COLOR (node->parent, GTK_RBNODE_BLACK);
      GTK_RBNODE_SET_COLOR (node->parent->parent, GTK_RBNODE_RED);
      _gtk_rbnode_rotate_left (tree, node->parent->parent);
      }
      }
    }
  GTK_RBNODE_SET_COLOR (tree->root, GTK_RBNODE_BLACK);
}

static void
_gtk_rbtree_remove_node_fixup (GtkRBTree *tree, GtkRBNode *node)
{
  while (node != tree->root && GTK_RBNODE_GET_COLOR (node) == GTK_RBNODE_BLACK)
    {
      if (node == node->parent->left)
      {
      GtkRBNode *w = node->parent->right;
      if (GTK_RBNODE_GET_COLOR (w) == GTK_RBNODE_RED)
      {
      GTK_RBNODE_SET_COLOR (w, GTK_RBNODE_BLACK);
      GTK_RBNODE_SET_COLOR (node->parent, GTK_RBNODE_RED);
      _gtk_rbnode_rotate_left (tree, node->parent);
      w = node->parent->right;
      }
      if (GTK_RBNODE_GET_COLOR (w->left) == GTK_RBNODE_BLACK && GTK_RBNODE_GET_COLOR (w->right) == GTK_RBNODE_BLACK)
      {
      GTK_RBNODE_SET_COLOR (w, GTK_RBNODE_RED);
      node = node->parent;
      }
      else
      {
      if (GTK_RBNODE_GET_COLOR (w->right) == GTK_RBNODE_BLACK)
      {
      GTK_RBNODE_SET_COLOR (w->left, GTK_RBNODE_BLACK);
      GTK_RBNODE_SET_COLOR (w, GTK_RBNODE_RED);
      _gtk_rbnode_rotate_right (tree, w);
      w = node->parent->right;
      }
      GTK_RBNODE_SET_COLOR (w, GTK_RBNODE_GET_COLOR (node->parent));
      GTK_RBNODE_SET_COLOR (node->parent, GTK_RBNODE_BLACK);
      GTK_RBNODE_SET_COLOR (w->right, GTK_RBNODE_BLACK);
      _gtk_rbnode_rotate_left (tree, node->parent);
      node = tree->root;
      }
      }
      else
      {
      GtkRBNode *w = node->parent->left;
      if (GTK_RBNODE_GET_COLOR (w) == GTK_RBNODE_RED)
      {
      GTK_RBNODE_SET_COLOR (w, GTK_RBNODE_BLACK);
      GTK_RBNODE_SET_COLOR (node->parent, GTK_RBNODE_RED);
      _gtk_rbnode_rotate_right (tree, node->parent);
      w = node->parent->left;
      }
      if (GTK_RBNODE_GET_COLOR (w->right) == GTK_RBNODE_BLACK && GTK_RBNODE_GET_COLOR (w->left) == GTK_RBNODE_BLACK)
      {
      GTK_RBNODE_SET_COLOR (w, GTK_RBNODE_RED);
      node = node->parent;
      }
      else
      {
      if (GTK_RBNODE_GET_COLOR (w->left) == GTK_RBNODE_BLACK)
      {
      GTK_RBNODE_SET_COLOR (w->right, GTK_RBNODE_BLACK);
      GTK_RBNODE_SET_COLOR (w, GTK_RBNODE_RED);
      _gtk_rbnode_rotate_left (tree, w);
      w = node->parent->left;
      }
      GTK_RBNODE_SET_COLOR (w, GTK_RBNODE_GET_COLOR (node->parent));
      GTK_RBNODE_SET_COLOR (node->parent, GTK_RBNODE_BLACK);
      GTK_RBNODE_SET_COLOR (w->left, GTK_RBNODE_BLACK);
      _gtk_rbnode_rotate_right (tree, node->parent);
      node = tree->root;
      }
      }
    }
  GTK_RBNODE_SET_COLOR (node, GTK_RBNODE_BLACK);
}

/* Public functions */
void
_gtk_rbnode_push_allocator (GAllocator *allocator)
{
  G_LOCK (current_allocator);
  _gtk_rbnode_validate_allocator ( allocator );
  allocator->last = current_allocator;
  current_allocator = allocator;
  G_UNLOCK (current_allocator);
}

void
_gtk_rbnode_pop_allocator (void)
{
  G_LOCK (current_allocator);
  if (current_allocator)
    {
      GAllocator *allocator;

      allocator = current_allocator;
      current_allocator = allocator->last;
      allocator->last = NULL;
      allocator->is_unused = TRUE;
    }
  G_UNLOCK (current_allocator);
}

GtkRBTree *
_gtk_rbtree_new (void)
{
  GtkRBTree *retval;

  retval = (GtkRBTree *) g_new (GtkRBTree, 1);
  retval->parent_tree = NULL;
  retval->parent_node = NULL;

  retval->nil = g_new0 (GtkRBNode, 1);
  retval->nil->left = NULL;
  retval->nil->right = NULL;
  retval->nil->parent = NULL;
  retval->nil->flags = GTK_RBNODE_BLACK;
  retval->nil->count = 0;
  retval->nil->offset = 0;
  retval->nil->parity = 0;

  retval->root = retval->nil;
  return retval;
}

static void
_gtk_rbtree_free_helper (GtkRBTree  *tree,
      GtkRBNode  *node,
      gpointer    data)
{
  if (node->children)
    _gtk_rbtree_free (node->children);

  _gtk_rbnode_free (node);
}

void
_gtk_rbtree_free (GtkRBTree *tree)
{
  _gtk_rbtree_traverse (tree,
      tree->root,
      G_POST_ORDER,
      _gtk_rbtree_free_helper,
      NULL);

  if (tree->parent_node &&
      tree->parent_node->children == tree)
    tree->parent_node->children = NULL;
  _gtk_rbnode_free (tree->nil);
  g_free (tree);
}

void
_gtk_rbtree_remove (GtkRBTree *tree)
{
  GtkRBTree *tmp_tree;
  GtkRBNode *tmp_node;

  gint height = tree->root->offset;

#ifdef G_ENABLE_DEBUG  
  if (gtk_debug_flags & GTK_DEBUG_TREE)
    _gtk_rbtree_test (G_STRLOC, tree);
#endif
  
  tmp_tree = tree->parent_tree;
  tmp_node = tree->parent_node;

  /* ugly hack to make _fixup_validation work in the first iteration of the
   * loop below */
  GTK_RBNODE_UNSET_FLAG (tree->root, GTK_RBNODE_DESCENDANTS_INVALID);
  
  while (tmp_tree && tmp_node && tmp_node != tmp_tree->nil)
    {
      _fixup_validation (tmp_tree, tmp_node);
      tmp_node->offset -= height;

      /* If the removed tree was odd, flip all parents */
      if (tree->root->parity)
        tmp_node->parity = !tmp_node->parity;
      
      tmp_node = tmp_node->parent;
      if (tmp_node == tmp_tree->nil)
      {
      tmp_node = tmp_tree->parent_node;
      tmp_tree = tmp_tree->parent_tree;
      }
    }

  tmp_tree = tree->parent_tree;
  tmp_node = tree->parent_node;
  _gtk_rbtree_free (tree);

#ifdef G_ENABLE_DEBUG  
  if (gtk_debug_flags & GTK_DEBUG_TREE)
    _gtk_rbtree_test (G_STRLOC, tmp_tree);
#endif
}


GtkRBNode *
_gtk_rbtree_insert_after (GtkRBTree *tree,
      GtkRBNode *current,
      gint       height,
      gboolean   valid)
{
  GtkRBNode *node;
  gboolean right = TRUE;
  GtkRBNode *tmp_node;
  GtkRBTree *tmp_tree;  

  if (current != NULL && current->right != tree->nil)
    {
      current = current->right;
      while (current->left != tree->nil)
      current = current->left;
      right = FALSE;
    }
  /* setup new node */
  node = _gtk_rbnode_new (tree, height);
  node->parent = (current?current:tree->nil);

  /* insert node in tree */
  if (current)
    {
      if (right)
      current->right = node;
      else
      current->left = node;
      tmp_node = node->parent;
      tmp_tree = tree;
    }
  else
    {
      tree->root = node;
      tmp_node = tree->parent_node;
      tmp_tree = tree->parent_tree;
    }

  while (tmp_tree && tmp_node && tmp_node != tmp_tree->nil)
    {
      /* We only want to propagate the count if we are in the tree we
       * started in. */
      if (tmp_tree == tree)
      tmp_node->count++;

      tmp_node->parity += 1;
      tmp_node->offset += height;
      tmp_node = tmp_node->parent;
      if (tmp_node == tmp_tree->nil)
      {
      tmp_node = tmp_tree->parent_node;
      tmp_tree = tmp_tree->parent_tree;
      }
    }

  if (valid)
    _gtk_rbtree_node_mark_valid (tree, node);
  else
    _gtk_rbtree_node_mark_invalid (tree, node);

  _gtk_rbtree_insert_fixup (tree, node);

  return node;
}

GtkRBNode *
_gtk_rbtree_insert_before (GtkRBTree *tree,
      GtkRBNode *current,
      gint       height,
      gboolean   valid)
{
  GtkRBNode *node;
  gboolean left = TRUE;
  GtkRBNode *tmp_node;
  GtkRBTree *tmp_tree;

  if (current != NULL && current->left != tree->nil)
    {
      current = current->left;
      while (current->right != tree->nil)
      current = current->right;
      left = FALSE;
    }

  /* setup new node */
  node = _gtk_rbnode_new (tree, height);
  node->parent = (current?current:tree->nil);

  /* insert node in tree */
  if (current)
    {
      if (left)
      current->left = node;
      else
      current->right = node;
      tmp_node = node->parent;
      tmp_tree = tree;
    }
  else
    {
      tree->root = node;
      tmp_node = tree->parent_node;
      tmp_tree = tree->parent_tree;
    }

  while (tmp_tree && tmp_node && tmp_node != tmp_tree->nil)
    {
      /* We only want to propagate the count if we are in the tree we
       * started in. */
      if (tmp_tree == tree)
      tmp_node->count++;

      tmp_node->parity += 1;
      tmp_node->offset += height;
      tmp_node = tmp_node->parent;
      if (tmp_node == tmp_tree->nil)
      {
      tmp_node = tmp_tree->parent_node;
      tmp_tree = tmp_tree->parent_tree;
      }
    }

  if (valid)
    _gtk_rbtree_node_mark_valid (tree, node);
  else
    _gtk_rbtree_node_mark_invalid (tree, node);

  _gtk_rbtree_insert_fixup (tree, node);

  return node;
}

GtkRBNode *
_gtk_rbtree_find_count (GtkRBTree *tree,
      gint       count)
{
  GtkRBNode *node;

  node = tree->root;
  while (node != tree->nil && (node->left->count + 1 != count))
    {
      if (node->left->count >= count)
      node = node->left;
      else
      {
      count -= (node->left->count + 1);
      node = node->right;
      }
    }
  if (node == tree->nil)
    return NULL;
  return node;
}

void
_gtk_rbtree_node_set_height (GtkRBTree *tree,
      GtkRBNode *node,
      gint       height)
{
  gint diff = height - GTK_RBNODE_GET_HEIGHT (node);
  GtkRBNode *tmp_node = node;
  GtkRBTree *tmp_tree = tree;

  if (diff == 0)
    return;

  while (tmp_tree && tmp_node && tmp_node != tmp_tree->nil)
    {
      tmp_node->offset += diff;
      tmp_node = tmp_node->parent;
      if (tmp_node == tmp_tree->nil)
      {
      tmp_node = tmp_tree->parent_node;
      tmp_tree = tmp_tree->parent_tree;
      }
    }
#ifdef G_ENABLE_DEBUG  
  if (gtk_debug_flags & GTK_DEBUG_TREE)
    _gtk_rbtree_test (G_STRLOC, tree);
#endif
}

void
_gtk_rbtree_node_mark_invalid (GtkRBTree *tree,
      GtkRBNode *node)
{
  if (GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_INVALID))
    return;

  GTK_RBNODE_SET_FLAG (node, GTK_RBNODE_INVALID);
  do
    {
      if (GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_DESCENDANTS_INVALID))
      return;
      GTK_RBNODE_SET_FLAG (node, GTK_RBNODE_DESCENDANTS_INVALID);
      node = node->parent;
      if (node == tree->nil)
      {
      node = tree->parent_node;
      tree = tree->parent_tree;
      }
    }
  while (node);
}

void
_gtk_rbtree_node_mark_valid (GtkRBTree *tree,
      GtkRBNode *node)
{
  if ((!GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_INVALID)) &&
      (!GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_COLUMN_INVALID)))
    return;

  GTK_RBNODE_UNSET_FLAG (node, GTK_RBNODE_INVALID);
  GTK_RBNODE_UNSET_FLAG (node, GTK_RBNODE_COLUMN_INVALID);

  do
    {
      if ((GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_INVALID)) ||
      (GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_COLUMN_INVALID)) ||
      (node->children && GTK_RBNODE_FLAG_SET (node->children->root, GTK_RBNODE_DESCENDANTS_INVALID)) ||
      (node->left != tree->nil && GTK_RBNODE_FLAG_SET (node->left, GTK_RBNODE_DESCENDANTS_INVALID)) ||
      (node->right != tree->nil && GTK_RBNODE_FLAG_SET (node->right, GTK_RBNODE_DESCENDANTS_INVALID)))
      return;

      GTK_RBNODE_UNSET_FLAG (node, GTK_RBNODE_DESCENDANTS_INVALID);
      node = node->parent;
      if (node == tree->nil)
      {
      node = tree->parent_node;
      tree = tree->parent_tree;
      }
    }
  while (node);
}

/* Assume tree is the root node as it doesn't set DESCENDANTS_INVALID above.
 */
void
_gtk_rbtree_column_invalid (GtkRBTree *tree)
{
  GtkRBNode *node;

  if (tree == NULL)
    return;
  node = tree->root;
  g_assert (node);

  while (node->left != tree->nil)
    node = node->left;

  do
    {
      if (! (GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_INVALID)))
      GTK_RBNODE_SET_FLAG (node, GTK_RBNODE_COLUMN_INVALID);
      GTK_RBNODE_SET_FLAG (node, GTK_RBNODE_DESCENDANTS_INVALID);

      if (node->children)
      _gtk_rbtree_column_invalid (node->children);
    }
  while ((node = _gtk_rbtree_next (tree, node)) != NULL);
}

void
_gtk_rbtree_mark_invalid (GtkRBTree *tree)
{
  GtkRBNode *node;

  if (tree == NULL)
    return;
  node = tree->root;
  g_assert (node);

  while (node->left != tree->nil)
    node = node->left;

  do
    {
      GTK_RBNODE_SET_FLAG (node, GTK_RBNODE_INVALID);
      GTK_RBNODE_SET_FLAG (node, GTK_RBNODE_DESCENDANTS_INVALID);

      if (node->children)
      _gtk_rbtree_mark_invalid (node->children);
    }
  while ((node = _gtk_rbtree_next (tree, node)) != NULL);
}

void
_gtk_rbtree_set_fixed_height (GtkRBTree *tree,
      gint       height)
{
  GtkRBNode *node;

  if (tree == NULL)
    return;

  node = tree->root;
  g_assert (node);

  while (node->left != tree->nil)
    node = node->left;

  do
    {
      if (GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_INVALID))
      _gtk_rbtree_node_set_height (tree, node, height);

      if (node->children)
      _gtk_rbtree_set_fixed_height (node->children, height);
    }
  while ((node = _gtk_rbtree_next (tree, node)) != NULL);
}

typedef struct _GtkRBReorder
{
  GtkRBTree *children;
  gint height;
  gint flags;
  gint order;
  gint invert_order;
  gint parity;
} GtkRBReorder;

static int
gtk_rbtree_reorder_sort_func (gconstpointer a,
      gconstpointer b)
{
  return ((GtkRBReorder *) a)->order - ((GtkRBReorder *) b)->order;
}

static int
gtk_rbtree_reorder_invert_func (gconstpointer a,
      gconstpointer b)
{
  return ((GtkRBReorder *) a)->invert_order - ((GtkRBReorder *) b)->invert_order;
}

static void
gtk_rbtree_reorder_fixup (GtkRBTree *tree,
      GtkRBNode *node)
{
  if (node == tree->nil)
    return;

  node->parity = 1;

  if (node->left != tree->nil)
    {
      gtk_rbtree_reorder_fixup (tree, node->left);
      node->offset += node->left->offset;
      node->parity += node->left->parity;
    }
  if (node->right != tree->nil)
    {
      gtk_rbtree_reorder_fixup (tree, node->right);
      node->offset += node->right->offset;
      node->parity += node->right->parity;
    }
      
  if (node->children)
    {
      node->offset += node->children->root->offset;
      node->parity += node->children->root->parity;
    }
  
  if (GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_INVALID) ||
      (node->right != tree->nil && GTK_RBNODE_FLAG_SET (node->right, GTK_RBNODE_DESCENDANTS_INVALID)) ||
      (node->left != tree->nil && GTK_RBNODE_FLAG_SET (node->left, GTK_RBNODE_DESCENDANTS_INVALID)) ||
      (node->children && GTK_RBNODE_FLAG_SET (node->children->root, GTK_RBNODE_DESCENDANTS_INVALID)))
    GTK_RBNODE_SET_FLAG (node, GTK_RBNODE_DESCENDANTS_INVALID);
  else
    GTK_RBNODE_UNSET_FLAG (node, GTK_RBNODE_DESCENDANTS_INVALID);
}

/* It basically pulls everything out of the tree, rearranges it, and puts it
 * back together.  Our strategy is to keep the old RBTree intact, and just
 * rearrange the contents.  When that is done, we go through and update the
 * heights.  There is probably a more elegant way to write this function.  If
 * anyone wants to spend the time writing it, patches will be accepted.
 */
void
_gtk_rbtree_reorder (GtkRBTree *tree,
      gint      *new_order,
      gint       length)
{
  GtkRBReorder reorder = {0, };
  GArray *array;
  GtkRBNode *node;
  gint i;
  
  g_return_if_fail (tree != NULL);
  g_return_if_fail (length > 0);
  g_return_if_fail (tree->root->count == length);
  
  /* Sort the trees values in the new tree. */
  array = g_array_sized_new (FALSE, FALSE, sizeof (GtkRBReorder), length);
  for (i = 0; i < length; i++)
    {
      reorder.order = new_order[i];
      reorder.invert_order = i;
      g_array_append_val (array, reorder);
    }

  g_array_sort(array, gtk_rbtree_reorder_sort_func);

  /* rewind node*/
  node = tree->root;
  while (node && node->left != tree->nil)
    node = node->left;

  for (i = 0; i < length; i++)
    {
      g_assert (node != tree->nil);
      g_array_index (array, GtkRBReorder, i).children = node->children;
      g_array_index (array, GtkRBReorder, i).flags = GTK_RBNODE_NON_COLORS & node->flags;
      g_array_index (array, GtkRBReorder, i).height = GTK_RBNODE_GET_HEIGHT (node);

      node = _gtk_rbtree_next (tree, node);
    }

  g_array_sort (array, gtk_rbtree_reorder_invert_func);
 
  /* rewind node*/
  node = tree->root;
  while (node && node->left != tree->nil)
    node = node->left;

  /* Go through the tree and change the values to the new ones. */
  for (i = 0; i < length; i++)
    {
      reorder = g_array_index (array, GtkRBReorder, i);
      node->children = reorder.children;
      if (node->children)
      node->children->parent_node = node;
      node->flags = GTK_RBNODE_GET_COLOR (node) | reorder.flags;
      /* We temporarily set the height to this. */
      node->offset = reorder.height;
      node = _gtk_rbtree_next (tree, node);
    }
  gtk_rbtree_reorder_fixup (tree, tree->root);

  g_array_free (array, TRUE);
}


gint
_gtk_rbtree_node_find_offset (GtkRBTree *tree,
      GtkRBNode *node)
{
  GtkRBNode *last;
  gint retval;

  g_assert (node);
  g_assert (node->left);
  
  retval = node->left->offset;

  while (tree && node && node != tree->nil)
    {
      last = node;
      node = node->parent;

      /* Add left branch, plus children, iff we came from the right */
      if (node->right == last)
      retval += node->offset - node->right->offset;
      
      if (node == tree->nil)
           {
      node = tree->parent_node;
      tree = tree->parent_tree;

          /* Add the parent node, plus the left branch. */
      if (node)
      retval += node->left->offset + GTK_RBNODE_GET_HEIGHT (node);
      }
    }
  return retval;
}

gint
_gtk_rbtree_node_find_parity (GtkRBTree *tree,
                              GtkRBNode *node)
{
  GtkRBNode *last;
  gint retval;  
  
  g_assert (node);
  g_assert (node->left);
  
  retval = node->left->parity;

  while (tree && node && node != tree->nil)
    {
      last = node;
      node = node->parent;

      /* Add left branch, plus children, iff we came from the right */
      if (node->right == last)
      retval += node->parity - node->right->parity;
      
      if (node == tree->nil)
      {
      node = tree->parent_node;
      tree = tree->parent_tree;

          /* Add the parent node, plus the left branch. */
      if (node)
      retval += node->left->parity + 1; /* 1 == GTK_RBNODE_GET_PARITY() */
      }
    }
  
  return retval % 2;
}

gint
_gtk_rbtree_real_find_offset (GtkRBTree  *tree,
      gint        height,
      GtkRBTree **new_tree,
      GtkRBNode **new_node)
{
  GtkRBNode *tmp_node;

  g_assert (tree);

  if (height < 0)
    {
      *new_tree = NULL;
      *new_node = NULL;

      return 0;
    }
  
    
  tmp_node = tree->root;
  while (tmp_node != tree->nil &&
      (tmp_node->left->offset > height ||
      (tmp_node->offset - tmp_node->right->offset) < height))
    {
      if (tmp_node->left->offset > height)
      tmp_node = tmp_node->left;
      else
      {
      height -= (tmp_node->offset - tmp_node->right->offset);
      tmp_node = tmp_node->right;
      }
    }
  if (tmp_node == tree->nil)
    {
      *new_tree = NULL;
      *new_node = NULL;
      return 0;
    }
  if (tmp_node->children)
    {
      if ((tmp_node->offset -
      tmp_node->right->offset -
      tmp_node->children->root->offset) > height)
      {
      *new_tree = tree;
      *new_node = tmp_node;
      return (height - tmp_node->left->offset);
      }
      return _gtk_rbtree_real_find_offset (tmp_node->children,
      height - tmp_node->left->offset -
      (tmp_node->offset -
      tmp_node->left->offset -
      tmp_node->right->offset -
      tmp_node->children->root->offset),
      new_tree,
      new_node);
    }
  *new_tree = tree;
  *new_node = tmp_node;
  return (height - tmp_node->left->offset);
}

gint
_gtk_rbtree_find_offset (GtkRBTree  *tree,
      gint        height,
      GtkRBTree **new_tree,
      GtkRBNode **new_node)
{
  g_assert (tree);

  if ((height < 0) ||
      (height >= tree->root->offset))
    {
      *new_tree = NULL;
      *new_node = NULL;

      return 0;
    }
  return _gtk_rbtree_real_find_offset (tree, height, new_tree, new_node);
}

void
_gtk_rbtree_remove_node (GtkRBTree *tree,
      GtkRBNode *node)
{
  GtkRBNode *x, *y;
  GtkRBTree *tmp_tree;
  GtkRBNode *tmp_node;
  gint node_height;
  gint y_height;
  
  g_return_if_fail (tree != NULL);
  g_return_if_fail (node != NULL);

  
  /* make sure we're deleting a node that's actually in the tree */
  for (x = node; x->parent != tree->nil; x = x->parent)
    ;
  g_return_if_fail (x == tree->root);

  if (node->left == tree->nil || node->right == tree->nil)
    {
      y = node;
    }
  else
    {
      y = node->right;

      while (y->left != tree->nil)
      y = y->left;
    }

  /* adjust count only beneath tree */
  for (x = y; x != tree->nil; x = x->parent)
    {
      x->count--;
    }

  /* offsets and parity adjust all the way up through parent trees */
  y_height = GTK_RBNODE_GET_HEIGHT (y);
  node_height = GTK_RBNODE_GET_HEIGHT (node) + (node->children?node->children->root->offset:0);

  tmp_tree = tree;
  tmp_node = y;
  while (tmp_tree && tmp_node && tmp_node != tmp_tree->nil)
    {
      tmp_node->offset -= (y_height + (y->children?y->children->root->offset:0));
      _fixup_validation (tmp_tree, tmp_node);
      _fixup_parity (tmp_tree, tmp_node);
      tmp_node = tmp_node->parent;
      if (tmp_node == tmp_tree->nil)
      {
      tmp_node = tmp_tree->parent_node;
      tmp_tree = tmp_tree->parent_tree;
      }
    }

  /* x is y's only child, or nil */
  if (y->left != tree->nil)
    x = y->left;
  else
    x = y->right;

  /* remove y from the parent chain */
  x->parent = y->parent;
  if (y->parent != tree->nil)
    {
      if (y == y->parent->left)
      y->parent->left = x;
      else
      y->parent->right = x;
    }
  else
    {
      tree->root = x;
    }

  /* We need to clean up the validity of the tree.
   */

  tmp_tree = tree;
  tmp_node = x;
  do
    {
      /* We skip the first time, iff x is nil */
      if (tmp_node != tmp_tree->nil)
      {
      _fixup_validation (tmp_tree, tmp_node);
      _fixup_parity (tmp_tree, tmp_node);
      }
      tmp_node = tmp_node->parent;
      if (tmp_node == tmp_tree->nil)
      {
      tmp_node = tmp_tree->parent_node;
      tmp_tree = tmp_tree->parent_tree;
      }
    }
  while (tmp_tree != NULL);

  if (y != node)
    {
      gint diff;

      /* Copy the node over */
      if (GTK_RBNODE_GET_COLOR (node) == GTK_RBNODE_BLACK)
      node->flags = ((y->flags & (GTK_RBNODE_NON_COLORS)) | GTK_RBNODE_BLACK);
      else
      node->flags = ((y->flags & (GTK_RBNODE_NON_COLORS)) | GTK_RBNODE_RED);
      node->children = y->children;
      if (y->children)
      {
      node->children = y->children;
      node->children->parent_node = node;
      }
      else
      {
      node->children = NULL;
      }
      _fixup_validation (tree, node);
      _fixup_parity (tree, node);
      /* We want to see how different our height is from the previous node.
       * To do this, we compare our current height with our supposed height.
       */
      diff = y_height - GTK_RBNODE_GET_HEIGHT (node);
      tmp_tree = tree;
      tmp_node = node;

      while (tmp_tree && tmp_node && tmp_node != tmp_tree->nil)
      {
      tmp_node->offset += diff;
      _fixup_validation (tmp_tree, tmp_node);
      _fixup_parity (tmp_tree, tmp_node);
      tmp_node = tmp_node->parent;
      if (tmp_node == tmp_tree->nil)
      {
      tmp_node = tmp_tree->parent_node;
      tmp_tree = tmp_tree->parent_tree;
      }
      }
    }

  if (GTK_RBNODE_GET_COLOR (y) == GTK_RBNODE_BLACK)
    _gtk_rbtree_remove_node_fixup (tree, x);
  _gtk_rbnode_free (y);

}

GtkRBNode *
_gtk_rbtree_next (GtkRBTree *tree,
      GtkRBNode *node)
{
  g_return_val_if_fail (tree != NULL, NULL);
  g_return_val_if_fail (node != NULL, NULL);

  /* Case 1: the node's below us. */
  if (node->right != tree->nil)
    {
      node = node->right;
      while (node->left != tree->nil)
      node = node->left;
      return node;
    }

  /* Case 2: it's an ancestor */
  while (node->parent != tree->nil)
    {
      if (node->parent->right == node)
      node = node->parent;
      else
      return (node->parent);
    }

  /* Case 3: There is no next node */
  return NULL;
}

GtkRBNode *
_gtk_rbtree_prev (GtkRBTree *tree,
      GtkRBNode *node)
{
  g_return_val_if_fail (tree != NULL, NULL);
  g_return_val_if_fail (node != NULL, NULL);

  /* Case 1: the node's below us. */
  if (node->left != tree->nil)
    {
      node = node->left;
      while (node->right != tree->nil)
      node = node->right;
      return node;
    }

  /* Case 2: it's an ancestor */
  while (node->parent != tree->nil)
    {
      if (node->parent->left == node)
      node = node->parent;
      else
      return (node->parent);
    }

  /* Case 3: There is no next node */
  return NULL;
}

void
_gtk_rbtree_next_full (GtkRBTree  *tree,
      GtkRBNode  *node,
      GtkRBTree **new_tree,
      GtkRBNode **new_node)
{
  g_return_if_fail (tree != NULL);
  g_return_if_fail (node != NULL);
  g_return_if_fail (new_tree != NULL);
  g_return_if_fail (new_node != NULL);

  if (node->children)
    {
      *new_tree = node->children;
      *new_node = (*new_tree)->root;
      while ((*new_node)->left != (*new_tree)->nil)
      *new_node = (*new_node)->left;
      return;
    }

  *new_tree = tree;
  *new_node = _gtk_rbtree_next (tree, node);

  while ((*new_node == NULL) &&
      (*new_tree != NULL))
    {
      *new_node = (*new_tree)->parent_node;
      *new_tree = (*new_tree)->parent_tree;
      if (*new_tree)
      *new_node = _gtk_rbtree_next (*new_tree, *new_node);
    }
}

void
_gtk_rbtree_prev_full (GtkRBTree  *tree,
      GtkRBNode  *node,
      GtkRBTree **new_tree,
      GtkRBNode **new_node)
{
  g_return_if_fail (tree != NULL);
  g_return_if_fail (node != NULL);
  g_return_if_fail (new_tree != NULL);
  g_return_if_fail (new_node != NULL);

  *new_tree = tree;
  *new_node = _gtk_rbtree_prev (tree, node);

  if (*new_node == NULL)
    {
      *new_node = (*new_tree)->parent_node;
      *new_tree = (*new_tree)->parent_tree;
    }
  else
    {
      while ((*new_node)->children)
      {
      *new_tree = (*new_node)->children;
      *new_node = (*new_tree)->root;
      while ((*new_node)->right != (*new_tree)->nil)
      *new_node = (*new_node)->right;
      }
    }
}

gint
_gtk_rbtree_get_depth (GtkRBTree *tree)
{
  GtkRBTree *tmp_tree;
  gint depth = 0;

  tmp_tree = tree->parent_tree;
  while (tmp_tree)
    {
      ++depth;
      tmp_tree = tmp_tree->parent_tree;
    }

  return depth;
}

static void
_gtk_rbtree_traverse_pre_order (GtkRBTree             *tree,
           GtkRBNode             *node,
      GtkRBTreeTraverseFunc  func,
      gpointer               data)
{
  if (node == tree->nil)
    return;

  (* func) (tree, node, data);
  _gtk_rbtree_traverse_pre_order (tree, node->left, func, data);
  _gtk_rbtree_traverse_pre_order (tree, node->right, func, data);
}

static void
_gtk_rbtree_traverse_post_order (GtkRBTree             *tree,
      GtkRBNode             *node,
      GtkRBTreeTraverseFunc  func,
      gpointer               data)
{
  if (node == tree->nil)
    return;

  _gtk_rbtree_traverse_post_order (tree, node->left, func, data);
  _gtk_rbtree_traverse_post_order (tree, node->right, func, data);
  (* func) (tree, node, data);
}

void
_gtk_rbtree_traverse (GtkRBTree             *tree,
      GtkRBNode             *node,
      GTraverseType          order,
      GtkRBTreeTraverseFunc  func,
      gpointer               data)
{
  g_return_if_fail (tree != NULL);
  g_return_if_fail (node != NULL);
  g_return_if_fail (func != NULL);
  g_return_if_fail (order <= G_LEVEL_ORDER);

  switch (order)
    {
    case G_PRE_ORDER:
      _gtk_rbtree_traverse_pre_order (tree, node, func, data);
      break;
    case G_POST_ORDER:
      _gtk_rbtree_traverse_post_order (tree, node, func, data);
      break;
    case G_IN_ORDER:
    case G_LEVEL_ORDER:
    default:
      g_warning ("unsupported traversal order.");
      break;
    }
}

static gint
_count_nodes (GtkRBTree *tree,
      GtkRBNode *node)
{
  gint res;
  if (node == tree->nil)
    return 0;

  g_assert (node->left);
  g_assert (node->right);
  
  res = (_count_nodes (tree, node->left) +
      _count_nodes (tree, node->right) + 1);

  if (res != node->count)
    g_print ("Tree failed\n");
  return res;
}

static inline
void _fixup_validation (GtkRBTree *tree,
      GtkRBNode *node)
{
  if (GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_INVALID) ||
      GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_COLUMN_INVALID) ||
      (node->left != tree->nil && GTK_RBNODE_FLAG_SET (node->left, GTK_RBNODE_DESCENDANTS_INVALID)) ||
      (node->right != tree->nil && GTK_RBNODE_FLAG_SET (node->right, GTK_RBNODE_DESCENDANTS_INVALID)) ||
      (node->children != NULL && GTK_RBNODE_FLAG_SET (node->children->root, GTK_RBNODE_DESCENDANTS_INVALID)))
    {
      GTK_RBNODE_SET_FLAG (node, GTK_RBNODE_DESCENDANTS_INVALID);
    }
  else
    {
      GTK_RBNODE_UNSET_FLAG (node, GTK_RBNODE_DESCENDANTS_INVALID);
    }
}

static inline
void _fixup_parity (GtkRBTree *tree,
      GtkRBNode *node)
{
  node->parity = 1 +
    ((node->children != NULL && node->children->root != node->children->nil) ? node->children->root->parity : 0) + 
    ((node->left != tree->nil) ? node->left->parity : 0) + 
    ((node->right != tree->nil) ? node->right->parity : 0);
}


GList *
gtk_tree_selection_get_selected_rows (GtkTreeSelection   *selection,
                                      GtkTreeModel      **model)
{

  GList *list = NULL;
  GtkRBTree *tree = NULL;
  GtkRBNode *node = NULL;
  GtkTreePath *path;

  g_return_val_if_fail (GTK_IS_TREE_SELECTION (selection), NULL);
  g_return_val_if_fail (selection->tree_view != NULL, NULL);
  g_return_val_if_fail (selection->tree_view->priv->model != NULL, NULL);

  if (selection->tree_view->priv->tree == NULL ||
      selection->tree_view->priv->tree->root == NULL)
    return NULL;

  if (model)
    *model = selection->tree_view->priv->model;

  if (selection->type == GTK_SELECTION_NONE)
    return NULL;
  else if (selection->type != GTK_SELECTION_MULTIPLE)
  {
      GtkTreeIter iter;

      if (gtk_tree_selection_get_selected (selection, NULL, &iter))
      {
      GtkTreePath *path;

      path = gtk_tree_model_get_path (selection->tree_view->priv->model, &iter);
      list = g_list_append (list, path);

      return list;
      }

  return NULL;
  }

  tree = selection->tree_view->priv->tree;
  node = selection->tree_view->priv->tree->root;

  while (node->left != tree->nil)
    node = node->left;
  path = gtk_tree_path_new_first ();

  do
    {
      if (GTK_RBNODE_FLAG_SET (node, GTK_RBNODE_IS_SELECTED))
      list = g_list_append (list, gtk_tree_path_copy (path));

      if (node->children)
        {
      tree = node->children;
      node = tree->root;

      while (node->left != tree->nil)
      node = node->left;

      gtk_tree_path_append_index (path, 0);
      }
      else
        {
      gboolean done = FALSE;

      do
      {
      node = _gtk_rbtree_next (tree, node);
      if (node != NULL)
      {
      done = TRUE;
      gtk_tree_path_next (path);
      }
      else
      {
      node = tree->parent_node;
      tree = tree->parent_tree;

      if (!tree)
      {
      gtk_tree_path_free (path);
      return list;
      }

      gtk_tree_path_up (path);
      }
      }
      while (!done);
      }
    }
  while (TRUE);

  gtk_tree_path_free (path);

  return list;
}

#endif

void clear_list(GtkWidget *list)
{
    GtkListStore *list_store;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    gtk_list_store_clear(GTK_LIST_STORE(list_store));
}

void add_line_to_list(GtkWidget *list, gpointer line, gint ncol)
{
    GtkListStore *list_store;
    GtkTreeIter iter;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    gtk_list_store_append (list_store, &iter);
    gtk_list_store_set (list_store, &iter, ncol, line,-1);
}

void add_gen_line_to_list(GtkWidget *list, int n, ...)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    int i;
    va_list l1;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    gtk_list_store_append (list_store, &iter);
    va_start(l1, n);
    for(i=0; i<n; i++)
    {
        gpointer cell = va_arg(l1, gpointer);
        gtk_list_store_set (list_store, &iter, i, cell,-1);
    }
    va_end(l1);
}

gpointer get_selection_from_path(GtkTreeView *tree_view, GtkTreePath *path)
{
     gpointer data;
     GtkTreeModel *model = gtk_tree_view_get_model (tree_view);
     GtkTreeIter iter;
     int formato = get_int(GTK_WIDGET(tree_view), "formato");

     gtk_tree_model_get_iter (model, &iter, path);
     if(formato <= 3)
        gtk_tree_model_get (model, &iter, 0, &data, -1);
     else if(formato < 10)
        gtk_tree_model_get (model, &iter, 1, &data, -1);
     else
        gtk_tree_model_get (model, &iter, 2, &data, -1);

     return data;
}

gpointer get_selection_from_pathC(GtkTreeView *tree_view, GtkTreePath *path, int col)
{
     gpointer data;
     GtkTreeModel *model = gtk_tree_view_get_model (tree_view);
     GtkTreeIter iter;
                                                                                                            
     gtk_tree_model_get_iter (model, &iter, path);
     gtk_tree_model_get (model, &iter, col, &data, -1);
                                                                                                            
     return data;
}

void unselect_all(GtkTreeView *list, bool block_hnd)
{
    GtkTreeSelection *select;

    select = GTK_TREE_SELECTION(gtk_tree_view_get_selection(list));
   int hnd = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(select), "hnd"));

   if(block_hnd && hnd)
      g_signal_handler_block(G_OBJECT(select), hnd);
    gtk_tree_selection_unselect_all(select);
   if(block_hnd && hnd)
      g_signal_handler_unblock(G_OBJECT(select), hnd);
}

GtkSelectionMode get_selection_mode(GtkWidget *list)
{
    GtkTreeSelection *sele;

    sele = GTK_TREE_SELECTION(gtk_tree_view_get_selection(GTK_TREE_VIEW(list)));
    return (gtk_tree_selection_get_mode(sele));
}

void set_selection_mode(GtkWidget *list, GtkSelectionMode mode)
{
    GtkTreeSelection *sele;

    sele = GTK_TREE_SELECTION(gtk_tree_view_get_selection(GTK_TREE_VIEW(list)));
    gtk_tree_selection_set_mode(sele, mode);
}

GList *get_selections(GtkWidget *list)
{
   GtkTreeSelection *sele;
   GtkTreeModel *model;
   GList *rowsel;

   sele = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
   model = gtk_tree_view_get_model(GTK_TREE_VIEW(list)); 
   rowsel = gtk_tree_selection_get_selected_rows (sele,  &model);
   return rowsel;
}

gchar *get_selected_row(GtkWidget *list)
{
   GtkTreePath *path;
   GList *rowsel=NULL;
   gchar *riga = NULL; //g_new0(char, 200);

   rowsel = get_selections(list);
   if(rowsel)
   {
      path = (GtkTreePath *) g_list_nth_data (rowsel, 0);
      riga = (char *) get_selection_from_path(GTK_TREE_VIEW(list), path);
      g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL); 
      g_list_free (rowsel); 
   }
   return riga;
}

gchar *get_selected_row_col(GtkWidget *list, int col)
{
   GtkTreePath *path;
   GList *rowsel=NULL;
   gchar *riga = NULL; //g_new0(char, 200);

   rowsel = get_selections(list);
   if(rowsel)
   {
      path = (GtkTreePath *) g_list_nth_data (rowsel, 0);
      riga = (char *) get_selection_from_pathC(GTK_TREE_VIEW(list), path, col);
      g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL); 
      g_list_free (rowsel); 
   }
   return riga;
}

void populate_listg(GtkTreeView *list, GList *values)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    char *entry;
    int i, numval;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
    gtk_list_store_clear(GTK_LIST_STORE(list_store));
    numval = g_list_length(values);
    for(i=0; i<numval; i++)
    {
        entry = (char *)g_list_nth_data (values, i);
        if(entry && strlen(entry))
        {
           gtk_list_store_append (list_store, &iter);
           gtk_list_store_set (list_store, &iter, 0, entry,-1);
        }
    }
}

void populate_selection(GtkTreeView *list, GList *values_1, GList *values_2)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    char *entry1, *entry2;
    int i, numval;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
    gtk_list_store_clear(GTK_LIST_STORE(list_store));
    numval = g_list_length(values_1);
    for(i=0; i<numval; i++)
    {
        entry1 = (char *)g_list_nth_data (values_1, i);
        entry2 = (char *)g_list_nth_data (values_2, i);
        if(entry1 && strlen(entry1))
        {
           gtk_list_store_append (list_store, &iter);
           gtk_list_store_set (list_store, &iter, 0, entry1, 1, entry2, -1);
        }
    }
}

gchar *get_text(GtkTextView *tw)
{
    GtkTextIter start, end;
    gtk_text_buffer_get_bounds(gtk_text_view_get_buffer (GTK_TEXT_VIEW (tw)), &start, &end);
    return gtk_text_buffer_get_text(gtk_text_view_get_buffer (GTK_TEXT_VIEW (tw)), &start, &end, FALSE);
}

void clear_text(GtkWidget *tw)
{
  GtkTextIter iter, iter2;
  GtkTextBuffer *tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(tw));

  gtk_text_buffer_get_iter_at_offset (tb, &iter, 0);
  gtk_text_buffer_get_bounds (tb, &iter, &iter2);
  gtk_text_buffer_delete (tb, &iter, &iter2);
}

void put_text(GtkWidget *w, const char *text, const char *tagname)
{
    if(GTK_IS_TEXT_VIEW(w))
    {
       GtkTextBuffer *buf = gtk_text_view_get_buffer (GTK_TEXT_VIEW (w));
       gtk_text_buffer_set_text(buf, toUTF8(text), -1);
       if(tagname != NULL)
       {
          GtkTextIter iter1, iter2;
          gtk_text_buffer_get_bounds(buf, &iter1, &iter2);
          gtk_text_buffer_apply_tag_by_name (buf, tagname, &iter1, &iter2);
       }
    }
    else
    {
#ifndef NOMKESC
       char *markup = g_markup_printf_escaped ("<tt><small>%s</small></tt>", text);
#else
       char *markup = g_strdup_printf("<tt><small>%s</small></tt>", text);
#endif

       gtk_label_set_markup(GTK_LABEL(w), markup);
       g_free(markup);
    }
}

int get_selected_row_num(GtkWidget *list)
{
   GtkTreePath *path;
   GList *rowsel=NULL;
   int riga;

   rowsel = get_selections(list);
   riga = -1;
   if(rowsel)
   {
      path = (GtkTreePath *) g_list_nth_data (rowsel, 0);
      riga = atoi(gtk_tree_path_to_string(path));
      g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
      g_list_free (rowsel);
   }
   return riga;
}

int row_selected (GtkTreeSelection *sele)
{
   GtkTreeModel *model;
   GtkTreeIter iter;
   GtkTreePath *path;

   if(gtk_tree_selection_get_mode(sele) == GTK_SELECTION_SINGLE)
   {
      if(gtk_tree_selection_get_selected(sele, &model, &iter))
      {
          path = gtk_tree_model_get_path (model, &iter);
          return atoi(gtk_tree_path_to_string(path));
      }
   }
   else
   {
      GList *rowsel = NULL;

      rowsel = gtk_tree_selection_get_selected_rows (sele,  &model);
                                                                                                         
      if(rowsel)
      {
          path = (GtkTreePath *) g_list_nth_data (rowsel, 0);
          int retval = atoi(gtk_tree_path_to_string(path));
          g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
          g_list_free (rowsel);
          return retval;
      }
   }
   return -1;
}

GList *copy_selection_to_list(GtkWidget *selec)
{
   GtkTreePath *path;
   GList *rowsel, *list;
   char *riga;
   int i, num_sel;

   list = NULL;
   rowsel = get_selections(selec);
   if(rowsel)
   {
      num_sel = g_list_length(rowsel);
      for(i=0; i<num_sel; i++)
      {
          riga = g_new0(char, MaxLenFilename);
          path = (GtkTreePath *) g_list_nth_data (rowsel, i);
          ScriviStringa(riga, MaxLenFilename, "%s", (char *)get_selection_from_path(GTK_TREE_VIEW(selec), path));
          list = g_list_append(list, riga);
      }
      g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL); 
      g_list_free (rowsel); 
   }
   return list;
}

void populate_list(GtkTreeView *list, gchar *values[], int numval, int ifClear)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    int i;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
    if(ifClear)
       gtk_list_store_clear(GTK_LIST_STORE(list_store));
    for(i=0; i<numval; i++)
    {
        if(values[i] && strlen(values[i]))
        {
           gtk_list_store_append (list_store, &iter);
           gtk_list_store_set (list_store, &iter, 0, values[i],-1);
        }
    }
}

void populate_list(GtkTreeView *list, const gchar *values[], int numval, int ifClear)
{
    int i;
    char **newval = g_new0(char *, numval);

    for(i=0; i<numval; i++)
        newval[i] = g_strdup_printf("%s", values[i]);
    populate_list(list, newval, numval, ifClear);
    for(i=0; i<numval; i++)
        g_free(newval[i]);
    g_free(newval);
}

int n_children (GtkWidget *list)
{
  GtkTreeModel *model;
  GtkTreeIter iter;
  gboolean valid;
  gint row_count = 0;
                                                                                                                       
  model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
  valid = gtk_tree_model_get_iter_first (model, &iter);
                                                                                                                       
  while (valid)
  {
      row_count++;
      valid = gtk_tree_model_iter_next (model, &iter);
  }
  return row_count;
}

int n_colonne (GtkWidget *list)
{
  GList *cols = NULL;
  int ncols = 0;
                                                                                                                       
  cols = gtk_tree_view_get_columns(GTK_TREE_VIEW(list));
  ncols = g_list_length(cols);
  g_list_free(cols);
  return ncols;
}

void set_listfont(GtkWidget *treeview,PangoFontDescription *fd, int col)
{
  GtkTreeViewColumn *tvc = gtk_tree_view_get_column (GTK_TREE_VIEW(treeview), col);
  GtkCellRenderer *cr;
  GList *crlist;
  int i;

#ifdef NOCELL_LAYOUT_GET_CELLS
  crlist = gtk_tree_view_column_get_cell_renderers(tvc);
#else
  crlist = gtk_cell_layout_get_cells(GTK_CELL_LAYOUT(tvc));
#endif

  for(i=0; i<(int) g_list_length(crlist); i++)
  {
      cr = (GtkCellRenderer *) g_list_nth_data(crlist, i);
      g_object_set (cr, "font-desc", fd, NULL);
  }
  g_list_free(crlist);
}

void remove_nth_line(GtkWidget *widget, int n)
{
  GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(widget));
//  GtkTreeStore *treestore = GTK_TREE_STORE(model);
  GtkListStore *liststore = GTK_LIST_STORE(model);
  GtkTreePath *path;
  GtkTreeIter iter;
  char num[5];

  ScriviStringa(num, sizeof(num), "%d", n-1);
  path = gtk_tree_path_new_from_string(num);
  if(gtk_tree_model_get_iter (model, &iter, path))
//     gtk_tree_store_remove(treestore, &iter);
     gtk_list_store_remove(liststore, &iter);
}

void select_row (GtkWidget *list, int row, bool block_hnd)
{
   GtkTreePath *path;
   GtkTreeSelection *sele = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
   gchar *strpath;
   int hnd = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(sele), "hnd"));

   strpath = g_new0(char, 5);
   ScriviStringa(strpath, 5, "%d", row);
   path = gtk_tree_path_new_from_string(strpath);
   g_free(strpath);
   sele = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
   if(block_hnd && hnd)
      g_signal_handler_block(G_OBJECT(sele), hnd);
   gtk_tree_selection_select_path(sele, path);
   if(block_hnd && hnd)
      g_signal_handler_unblock(G_OBJECT(sele), hnd);
}

void unselect_row (GtkWidget *list, int row)
{
   GtkTreePath *path;
   GtkTreeSelection *sele;
   gchar *strpath;

   strpath = g_new0(char, 5);
   ScriviStringa(strpath, 5, "%d", row);
   path = gtk_tree_path_new_from_string(strpath);
   g_free(strpath);
   sele = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
   gtk_tree_selection_unselect_path(sele, path);
}

char *get_selected_row_path(GtkWidget *list)
{
   GtkTreePath *path;
   GList *rowsel=NULL;
   char *riga = g_new0(char, 30);

   rowsel = get_selections(list);
   if(rowsel)
   {
      path = static_cast<GtkTreePath *> (g_list_nth_data (rowsel, 0));
      ScriviStringa(riga, 30, "%s", gtk_tree_path_to_string(path));
      g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL); 
      g_list_free (rowsel); 
   }
   return riga;
}

void get_selected_rownums(GtkWidget *selec, int selvet[])
{
   GtkTreePath *path;
   GList *rowsel;
   int i, num_sel, row_num;

   int nvet = n_children(selec);          // 090406

   for (i=0; i<nvet; i++)
        selvet[i] = 0;
   rowsel = get_selections(selec);
   if(rowsel == NULL)
      return;
   num_sel = g_list_length(rowsel);
   for(i=0; i<num_sel; i++)
   {
      path =  static_cast<GtkTreePath *> (g_list_nth_data (rowsel, i));
      row_num = atoi(gtk_tree_path_to_string(path));
      selvet[row_num] = 1;
   }
   g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL); 
   g_list_free (rowsel); 
}

void remove_selection(GtkWidget *list)
{
     int i, num_sel;
     GList *rowsel;
     GtkTreeIter iter;
     GtkTreeModel *model;
     GtkTreePath *path;

     rowsel = get_selections(list);
     if(rowsel == NULL)
        return;
     num_sel = g_list_length(rowsel);
     model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));

     for (i=num_sel-1; i>=0; i--)
     {
          path = static_cast<GtkTreePath *> (g_list_nth_data (rowsel, i));
          gtk_tree_model_get_iter (model, &iter, path);
          gtk_list_store_remove (GTK_LIST_STORE(model), &iter);
     }
     g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
     g_list_free (rowsel);
}

gpointer get_nth_row(GtkWidget *list, int nrow, int ncol)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    GtkTreePath *path;
    char strpath[6];
    gpointer line;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    ScriviStringa(strpath, sizeof(path), "%d", nrow);
    path = gtk_tree_path_new_from_string(strpath);
    if(gtk_tree_model_get_iter (GTK_TREE_MODEL(list_store), &iter, path))
        gtk_tree_model_get (GTK_TREE_MODEL(list_store), &iter, ncol, &line, -1);
    return line;
}

void clear_store(GtkWidget *list)
{
    GtkTreeStore *tree_store;

    tree_store = GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    gtk_tree_store_clear(GTK_TREE_STORE(tree_store));
}

void populate_model (GtkTreeView *list, GList *chains, GList **residues, int ifClear)
{
  GtkTreeIter iter;
  int i, j;

  GtkTreeStore *model = GTK_TREE_STORE(gtk_tree_view_get_model(list));
  if(ifClear)
    gtk_tree_store_clear(GTK_TREE_STORE(model));

  i = 0;
  /* add chains to the tree store */
  while (g_list_nth_data(chains, i))
  {
      gtk_tree_store_append (model, &iter, NULL);
      gtk_tree_store_set (model, &iter, 0, g_list_nth_data(chains, i), -1);
      /* add children (residues) */
      j = 0;
      while (g_list_nth_data(residues[i], j))
      {
           GtkTreeIter child_iter;
           gtk_tree_store_append (model, &child_iter, &iter);
           gtk_tree_store_set (model, &child_iter, 0, g_list_nth_data(residues[i], j), -1);
           j++;
      }
      i++;
  }
}

static void collapse_other(GtkTreeView *treeview, GtkTreeIter *, GtkTreePath *arg2,
                     gpointer )
{
      int hnd = get_int(GTK_WIDGET(treeview), "hnd");
          
      gtk_tree_view_collapse_all(treeview);
      g_signal_handler_block(treeview, hnd);
      gtk_tree_view_expand_row (treeview, arg2, 0);
      g_signal_handler_unblock(treeview, hnd);
}

void create_tree_store (GtkWidget *father, GtkWidget *parent, const char *name, GCallback cb, GtkWidget *cb_data)
{
      GtkWidget *treeview;
      GtkTreeStore *store;
      GtkTreeModel *model;
      int hnd;

      GtkWidget *frame = gtk_frame_new(NULL);
      gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
      if(parent)
      {
         if (GTK_IS_BOX(G_OBJECT(parent)))
             gtk_box_pack_start (GTK_BOX (parent), frame, TRUE, TRUE, 0);
         else if (GTK_IS_CONTAINER(G_OBJECT(parent)))
             gtk_container_add(GTK_CONTAINER(parent), frame);
      }
      GtkWidget *scrollwin = gtk_scrolled_window_new (NULL, NULL);
      gtk_container_add(GTK_CONTAINER(frame), scrollwin);

      gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
      GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);
  
      /* create model */
      store = gtk_tree_store_new (1, G_TYPE_STRING);
      model = GTK_TREE_MODEL(store);

      /* create tree view */
      treeview = gtk_tree_view_new_with_model (model);
      g_object_unref (model);
      //gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (treeview), FALSE);
      gtk_tree_selection_set_mode (gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview)),
      GTK_SELECTION_SINGLE);
      if(cb != NULL)
          g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview))),
        "changed", cb, cb_data);
      g_object_set_data(G_OBJECT(father), name, treeview);

      GtkCellRenderer *renderer = gtk_cell_renderer_text_new ();
      GtkTreeViewColumn *column = gtk_tree_view_column_new_with_attributes (name,
            renderer, "markup", 0, NULL);
        gtk_tree_view_column_set_clickable(column, FALSE);
        gtk_tree_view_append_column (GTK_TREE_VIEW(treeview), column);
        if(name)
        {
           GtkWidget *label = LABEL_NEW(name, MyBLUE);
           gtk_widget_show (label);
           gtk_tree_view_column_set_widget(column, label);
        }

      gtk_container_add (GTK_CONTAINER (scrollwin), treeview);

      g_signal_connect (treeview, "realize",
               G_CALLBACK (gtk_tree_view_collapse_all), NULL);
      hnd = g_signal_connect (treeview, "row-expanded",
               G_CALLBACK (collapse_other), NULL);
      g_object_set_data(G_OBJECT(treeview), "hnd", GINT_TO_POINTER(hnd));
      gtk_widget_show_all(frame);
}

static GdkPixbufAnimation *prev_buf;
void resetSmiley(GtkWidget *wind)
{
   GtkWidget *pixsmiley = get_widget(wind, "smiley");
   if(pixsmiley == NULL)
      return;
   if(GDK_IS_PIXBUF_ANIMATION(prev_buf))
   {
      if(gdk_pixbuf_animation_is_static_image(prev_buf))
         gtk_image_set_from_pixbuf(GTK_IMAGE(pixsmiley),
               gdk_pixbuf_animation_get_static_image(prev_buf));
      else
         gtk_image_set_from_animation(GTK_IMAGE(pixsmiley), prev_buf);
   }
   else
         gtk_image_set_from_pixbuf(GTK_IMAGE(pixsmiley), (GdkPixbuf *)prev_buf);
}

void setSmiley(GtkWidget *wind, const char *filenam)
{
   GtkWidget *pixsmiley = get_widget(wind, "smiley");

   if(pixsmiley == NULL)
      return;
   GdkPixbufAnimation *smil_buf = mr_load_animation(filenam);

   GtkImageType type = gtk_image_get_storage_type(GTK_IMAGE(pixsmiley));
   if(type == GTK_IMAGE_PIXBUF)
      prev_buf = (GdkPixbufAnimation *) gtk_image_get_pixbuf(GTK_IMAGE(pixsmiley));
   else
      prev_buf = gtk_image_get_animation(GTK_IMAGE(pixsmiley));
   if(gdk_pixbuf_animation_is_static_image(smil_buf))
      gtk_image_set_from_pixbuf(GTK_IMAGE(pixsmiley),
               gdk_pixbuf_animation_get_static_image(smil_buf));
   else
      gtk_image_set_from_animation(GTK_IMAGE(pixsmiley), smil_buf);
   g_object_unref(smil_buf);
}

static gboolean put_response(gpointer data )
{
     dlg_data *cb_data = (dlg_data *) data;
     GtkWidget *dlg = cb_data->dlg;
     int response = cb_data->response;
     if(GTK_IS_DIALOG(dlg))
        gtk_dialog_response(GTK_DIALOG(dlg), response);
     return FALSE;
}

 int MessageDialog(const char *title, int timeout, int def_resp,
                    GtkWidget *parent, GtkMessageType type,
                    GtkButtonsType buttons, const gchar *message, ...)
{
  GtkWidget *okbutton, *cancelbutton, *yesbutton, *nobutton, *closebutton;
  GtkWidget *label, *image, *hbox, *action_area = NULL;
  GtkWidget *dialog = gtk_dialog_new();
  gchar* msg = NULL;
  va_list args;
  int response, default_response = -1;

  gtk_window_set_resizable (GTK_WINDOW (dialog), FALSE);
  if(title)
     gtk_window_set_title (GTK_WINDOW (dialog), title);
  okbutton = myimage_button("_OK", "ok.png");
  cancelbutton = myimage_button("_Cancel", "cancel.png");
  closebutton = myimage_button("_Close", "close.png");
  yesbutton = myimage_button("_Yes", "apply.png");
  nobutton = myimage_button("_No", "cancel.png");
  switch(type)
  {
  case GTK_MESSAGE_INFO:
  default:
       image = create_image("infodialog.png");
       if(!title)
          gtk_window_set_title (GTK_WINDOW (dialog), "Info");
       break;
  case GTK_MESSAGE_WARNING:
       image = create_image("warningdialog.png");
       if(!title)
          gtk_window_set_title (GTK_WINDOW (dialog), "Warning");
       break;

  case GTK_MESSAGE_ERROR:
       image = create_image("errordialog.png");
       if(!title)
          gtk_window_set_title (GTK_WINDOW (dialog), "Error");
       break;

  case GTK_MESSAGE_QUESTION:
       image = create_image("questiondialog.png");
       if(!title)
          gtk_window_set_title (GTK_WINDOW (dialog), "Question");
       break;

  }
  switch (buttons)
  {
    case GTK_BUTTONS_NONE:
      default_response = GTK_RESPONSE_DELETE_EVENT;
      break;

    case GTK_BUTTONS_OK:
      gtk_dialog_add_action_widget (GTK_DIALOG(dialog),
                             okbutton,
                             GTK_RESPONSE_OK);
      default_response = GTK_RESPONSE_OK;
      action_area = gtk_widget_get_parent(okbutton);
      break;

    case GTK_BUTTONS_CLOSE:
      gtk_dialog_add_action_widget (GTK_DIALOG(dialog),
                             closebutton,
                             GTK_RESPONSE_CLOSE);
      default_response = GTK_RESPONSE_CLOSE;
      action_area = gtk_widget_get_parent(closebutton);
      break;

    case GTK_BUTTONS_CANCEL:
      gtk_dialog_add_action_widget (GTK_DIALOG(dialog),
                             cancelbutton,
                             GTK_RESPONSE_CANCEL);
      default_response = GTK_RESPONSE_CANCEL;
      action_area = gtk_widget_get_parent(cancelbutton);
      break;

    case GTK_BUTTONS_YES_NO:
      gtk_dialog_add_action_widget (GTK_DIALOG(dialog),
                             yesbutton,
                             GTK_RESPONSE_YES);
      gtk_dialog_add_action_widget (GTK_DIALOG(dialog),
                             nobutton,
                             GTK_RESPONSE_NO);
      default_response = GTK_RESPONSE_NO;
      gtk_widget_grab_focus(nobutton);
      if(def_resp == 1)
      {
         default_response = GTK_RESPONSE_YES;
         gtk_widget_grab_focus(yesbutton);
      }
      action_area = gtk_widget_get_parent(nobutton);
      break;

    case GTK_BUTTONS_OK_CANCEL:
      gtk_dialog_add_action_widget (GTK_DIALOG(dialog),
                             okbutton,
                             GTK_RESPONSE_OK);
      gtk_dialog_add_action_widget (GTK_DIALOG(dialog),
                             cancelbutton,
                             GTK_RESPONSE_CANCEL);
      default_response = GTK_RESPONSE_CANCEL;
      gtk_widget_grab_focus(cancelbutton);
      if(def_resp == 1)
      {
         default_response = GTK_RESPONSE_OK;
         gtk_widget_grab_focus(okbutton);
      }
      action_area = gtk_widget_get_parent(okbutton);
      break;
  }

  label = gtk_label_new ("");
  center_image (image);
  if (message)
  {
      va_start (args, message);
      msg = g_strdup_vprintf (message, args);
      va_end (args);
      gtk_label_set_text (GTK_LABEL (label), toUTF8(msg));
      g_free (msg);
   }

  
  gtk_label_set_line_wrap  (GTK_LABEL (label), TRUE);
  gtk_label_set_selectable (GTK_LABEL (label), TRUE);
  set_alignment   (label, 0.0, 0.5);
  
  hbox = hbox_new (FALSE, 12);
  gtk_container_set_border_width(GTK_CONTAINER(hbox), 8);

  gtk_box_pack_start (GTK_BOX (hbox), image,
                      FALSE, FALSE, 0);

  gtk_box_pack_start (GTK_BOX (hbox), label,
                      FALSE, FALSE, 0);

  gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG (dialog))),
                      hbox,
                      FALSE, FALSE, 0);

  if(action_area != NULL)
     gtk_button_box_set_layout(GTK_BUTTON_BOX(action_area), GTK_BUTTONBOX_SPREAD);
  gtk_widget_show_all (hbox);
  gboolean modale = FALSE;
  if(parent != NULL)
  {
     gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(parent));
     modale = gtk_window_get_modal(GTK_WINDOW(parent));
     if (modale)
         gtk_window_set_modal(GTK_WINDOW(parent), FALSE);
     if(GTK_IS_DIALOG(parent))
        gtk_widget_set_sensitive(parent, FALSE);
     else
        setSmiley(parent, "smil5.gif");
  }
  if(timeout > 0)
  {
     dlg_data *cb_data = g_new0(dlg_data, 1);
     cb_data->dlg = dialog;
     cb_data->response = default_response;
     (void) g_timeout_add(timeout, put_response, (gpointer) cb_data);
  }
//  if(timeout == 0)
//  {
     response = gtk_dialog_run(GTK_DIALOG(dialog));
     gtk_widget_destroy(dialog);
     if(parent != NULL)
     {
        gtk_window_set_modal(GTK_WINDOW(parent), modale);
        if(GTK_IS_DIALOG(parent))
           gtk_widget_set_sensitive(parent, TRUE);
        else
           resetSmiley(parent);
     }
//  }
//  else
//  {
//     g_signal_connect_swapped(G_OBJECT(okbutton), "clicked", G_CALLBACK(gtk_widget_hide), dialog);
//     g_signal_connect_swapped(G_OBJECT(cancelbutton), "clicked", G_CALLBACK(gtk_widget_hide), dialog);
//     g_signal_connect_swapped(G_OBJECT(closebutton), "clicked", G_CALLBACK(gtk_widget_hide), dialog);
//     response = 1;
//     gtk_widget_show_all(dialog);
//     (void) g_timeout_add(timeout, destroy_dlg, dialog);
//  }
  return response;
}

/*******************************************************************************/

#define PIX_TEXT_TYPE pix_text_get_type ()

static void pix_text_free (PixText *pixtext)
{
  g_free (pixtext->text);
  if (pixtext->icon)
    g_object_unref (pixtext->icon);
  
  g_free (pixtext);
}

static PixText* pix_text_copy (PixText *src)
{
  PixText *dst;

  dst = g_new (PixText, 1);
  dst->text = g_strdup (src->text);

  dst->icon = src->icon;
  if (dst->icon)
    g_object_ref (dst->icon);

  return dst;
}


static GType pix_text_get_type (void)
{
  static GType our_type = 0;
  
  if (our_type == 0)
    our_type = g_boxed_type_register_static ("PixText",
                                             (GBoxedCopyFunc) pix_text_copy,
                                             (GBoxedFreeFunc) pix_text_free);

  return our_type;
}

static void fill_cell(GtkTreeViewColumn *,
                      GtkCellRenderer   *cell,
                      GtkTreeModel      *model,
                      GtkTreeIter       *iter,
                      gpointer           data)
{
  PixText *info;
  int qual = GPOINTER_TO_INT(data);
  
  gtk_tree_model_get (model, iter,
                      0, &info,
                      -1);
  if(qual)
     g_object_set (GTK_CELL_RENDERER (cell),
                "text", info->text,
                NULL);
  else
     g_object_set (GTK_CELL_RENDERER (cell),
                "pixbuf", info->icon,
                NULL);
  
  pix_text_free (info);
}

static void pix_num_free (PixNum *pixnum)
{
  if (pixnum->icon)
    g_object_unref (pixnum->icon);
  g_free (pixnum);
}

static PixNum* pix_num_copy (PixNum *src)
{
  PixNum *dst;

  dst = g_new (PixNum, 1);
  dst->num = src->num;

  dst->icon = src->icon;
  if (dst->icon)
    g_object_ref (dst->icon);

  return dst;
}


GType pix_num_get_type (void)
{
  static GType our_type = 0;
  
  if (our_type == 0)
    our_type = g_boxed_type_register_static ("PixNum",
                                             (GBoxedCopyFunc) pix_num_copy,
                                             (GBoxedFreeFunc) pix_num_free);
  return our_type;
}

static void fill_cell2(GtkTreeViewColumn *,
                      GtkCellRenderer   *cell,
                      GtkTreeModel      *model,
                      GtkTreeIter       *iter,
                      gpointer           data)
{
  PixNum *info;
  int qual = GPOINTER_TO_INT(data);
  
  gtk_tree_model_get (model, iter,
                      0, &info,
                      -1);
  if(qual)
     g_object_set (GTK_CELL_RENDERER (cell),
                "text", g_strdup_printf("%d", info->num),
                NULL);
  else
     g_object_set (GTK_CELL_RENDERER (cell),
                "pixbuf", info->icon,
                NULL);
  
  pix_num_free (info);
}

void fixed_rend_toggled(GtkCellRendererToggle *cell, gchar *path_str, gpointer data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreeIter  iter;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  gboolean fixed;

  gtk_tree_model_get_iter (model, &iter, path);
  gtk_tree_model_get (model, &iter, 0, &fixed, -1);

  fixed ^= 1;
  gtk_list_store_set (GTK_LIST_STORE (model), &iter, 0, fixed, -1);

  gtk_tree_path_free (path);
}

GtkWidget *createSelection(GtkWidget *parent, GtkWidget *parentbox,
           const char *title,  const char *id, int formato,  const char *col)
{  
  GtkWidget *scrollwin, *dirsel, *label=NULL;
  GtkWidget *frame;
  GtkListStore *store;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;

  frame = gtk_frame_new(NULL);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
  if(parentbox)
  {
     if (GTK_IS_BOX(G_OBJECT(parentbox)))
         gtk_box_pack_start (GTK_BOX (parentbox), frame, TRUE, TRUE, 0);
     else if (GTK_IS_CONTAINER(G_OBJECT(parentbox)))
         gtk_container_add(GTK_CONTAINER(parentbox), frame);
  }
  gtk_widget_show (frame);
  scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add(GTK_CONTAINER(frame), scrollwin);

  if(formato >= 10)
  {
     gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                   GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
     formato -= 10;
  }
  else
     gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                   GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrollwin);

  dirsel = gtk_tree_view_new();
  g_object_set_data(G_OBJECT(dirsel), "frame", frame);
  g_object_set_data(G_OBJECT(dirsel), "scrollwin", scrollwin);
  g_object_set_data(G_OBJECT(dirsel), "formato", GINT_TO_POINTER(formato));

  switch(formato)
  {
  default:
  case 0:
        store = gtk_list_store_new (1, G_TYPE_STRING);
        renderer = gtk_cell_renderer_text_new ();
        column = gtk_tree_view_column_new_with_attributes (title,
            renderer, "markup", 0, NULL);
        gtk_tree_view_column_set_clickable(column, FALSE);
        gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
        if(title)
        {
           label = LABEL_NEW(title, col);
           gtk_widget_show (label);
           gtk_tree_view_column_set_widget(column, label);
        }
        break;
  case 1:
        store = gtk_list_store_new (1, PIX_TEXT_TYPE); 
        column = gtk_tree_view_column_new ();
        renderer = gtk_cell_renderer_pixbuf_new ();
        gtk_tree_view_column_pack_start (column, renderer, FALSE);
        gtk_tree_view_column_set_cell_data_func (column, renderer,
            fill_cell, GINT_TO_POINTER(0), NULL);
        renderer = gtk_cell_renderer_text_new ();
        gtk_tree_view_column_pack_start (column, renderer,TRUE);
        gtk_tree_view_column_set_cell_data_func (column, renderer,
            fill_cell, GINT_TO_POINTER(1), NULL);
        gtk_tree_view_column_set_clickable(column, FALSE);
        if(title)
        {
           label = LABEL_NEW(title, col);
           gtk_widget_show (label);
           gtk_tree_view_column_set_widget(column, label);
        }
        gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
        break;
  case 2:
        store = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_BOOLEAN);
        renderer = gtk_cell_renderer_text_new ();
        column = gtk_tree_view_column_new_with_attributes (title,
            renderer, "markup", 0, NULL);
        gtk_tree_view_column_set_clickable(column, FALSE);
        if(title)
        {
           label = LABEL_BOLD(title, col, 1.1f);
           gtk_widget_show (label);
           gtk_tree_view_column_set_widget(column, label);
        }
        gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
                                   GTK_TREE_VIEW_COLUMN_FIXED);
        gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(column), 80);
        gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
        renderer = gtk_cell_renderer_toggle_new ();
        column = gtk_tree_view_column_new_with_attributes ("Defined",
            renderer, "active", 1, NULL);
        g_object_set_data(G_OBJECT(dirsel), "togglerenderer", renderer);
        gtk_tree_view_column_set_clickable(column, FALSE);
        gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
                                   GTK_TREE_VIEW_COLUMN_FIXED);
        gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(column), 30);
        gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
        if(title)
        {
           label = LABEL_BOLD("Def", col, 1.1f);
           gtk_widget_show (label);
           gtk_tree_view_column_set_widget(column, label);
        }
        break;
  case 3:
        store = gtk_list_store_new (1, PIX_TEXT_TYPE);
        column = gtk_tree_view_column_new ();
        renderer = gtk_cell_renderer_pixbuf_new ();
        gtk_tree_view_column_pack_start (column, renderer, FALSE);
        gtk_tree_view_column_set_cell_data_func (column, renderer,
            fill_cell, GINT_TO_POINTER(0), NULL);
        renderer = gtk_cell_renderer_text_new ();
        gtk_tree_view_column_pack_start (column, renderer,TRUE);
        gtk_tree_view_column_set_cell_data_func (column, renderer,
            fill_cell, GINT_TO_POINTER(1), NULL);
        gtk_tree_view_column_set_clickable(column, FALSE);
        if(title)
        {
           label = LABEL_NEW(title, col);
           gtk_widget_show (label);
           gtk_tree_view_column_set_widget(column, label);
        }
        gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column);
        break;

  case 4:
        store = gtk_list_store_new (2, G_TYPE_BOOLEAN, G_TYPE_STRING);
        renderer = gtk_cell_renderer_toggle_new ();
        column = gtk_tree_view_column_new_with_attributes ("Selected",
            renderer, "active", 0, NULL);
        g_object_set_data(G_OBJECT(dirsel), "togglerenderer", renderer);
        g_signal_connect (renderer, "toggled", G_CALLBACK (fixed_rend_toggled),
          GTK_TREE_MODEL(store));
        gtk_tree_view_column_set_clickable(column, FALSE);
        gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
                                   GTK_TREE_VIEW_COLUMN_AUTOSIZE);
        gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
        if(title)
        {
           label = LABEL_BOLD("Selected", col, 1.1f);
           gtk_widget_show (label);
           gtk_tree_view_column_set_widget(column, label);
        }
        renderer = gtk_cell_renderer_text_new ();
        column = gtk_tree_view_column_new_with_attributes (title,
            renderer, "markup", 1, NULL);
        gtk_tree_view_column_set_clickable(column, FALSE);
        if(title)
        {
           label = LABEL_BOLD(title, col, 1.1f);
           gtk_widget_show (label);
           gtk_tree_view_column_set_widget(column, label);
        }
        gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
                                   GTK_TREE_VIEW_COLUMN_FIXED);
        gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(column), 80);
        gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column);
        break;
  }
  gtk_tree_view_set_model(GTK_TREE_VIEW(dirsel), GTK_TREE_MODEL (store));
  g_object_set_data(G_OBJECT (parent), id, dirsel);
  gtk_widget_show (dirsel);
  gtk_container_add (GTK_CONTAINER (scrollwin), dirsel);
  if(label)
      g_object_set_data(G_OBJECT(dirsel), "titolo", label);
  else
      gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(dirsel), FALSE);

  return dirsel;
}

std::string fToStr(float num, int precision)
{
using namespace std;

    std::stringstream os;
    if(MRabs(num) < 1e-8)
       os << " ";
    else if(precision > 0)
    {
       os << setiosflags( ios::fixed );
       os << setiosflags( ios::left );
       os << setprecision(precision);
       os << setw(precision+10);
       os << num;
    }
    else
      os << iround(num);
    return os.str();
}

std::string fToStr2(float num, int precision)
{
using namespace std;

    std::stringstream os;
    if(MRabs(num) < 1e-8)
       num = 0;
    if(precision > 0)
    {
       os << setiosflags( ios::fixed );
       os << setiosflags( ios::right );
       os << setprecision(precision);
       os << setw(precision+5);
       os << num;
    }
    else if(precision < 0)
    {
       precision = MRabs(precision);
       if(num < 0)
       {
          for(int i=0; i<(precision+5)/2; i++)
              os << " ";
          os << "-";
       }
       else
       {
       os << setiosflags( ios::fixed );
       os << setiosflags( ios::right );
       os << setprecision(precision);
       os << setw(precision+5);
       os << num;
       }
    }
    else
    {
       os << setiosflags( ios::fixed );
       os << setiosflags( ios::right );
       os << setw(8);
       os << iround(num);
    }
    return os.str();
}

void incolonna_float (GtkTreeViewColumn *col, GtkCellRenderer *renderer,
                      GtkTreeModel *model, GtkTreeIter *iter, gpointer data)
{
     gfloat  val;
     int colonna = GPOINTER_TO_INT(data);

     gtk_tree_model_get(model, iter, colonna, &val, -1);
     int prec = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(col), "precision"));
     std::string buf = fToStr2(val, prec);
     g_object_set(renderer, "text", buf.c_str(), NULL);
}

//NEW
void edit_canceled(GtkCellRenderer *cell, gpointer data)
{
  int insospeso = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(data), "insospeso"));
  if(!insospeso)
     return;
  GtkTreePath *path = (GtkTreePath *) g_object_get_data(G_OBJECT(data), "path");
  GtkCellEditable *ed = (GtkCellEditable *) g_object_get_data(G_OBJECT(data), "celleditable");
  if (GTK_IS_ENTRY (ed))
  {
          const char *new_text = gtk_entry_get_text(GTK_ENTRY (ed));
          g_signal_emit_by_name  (G_OBJECT(cell), "edited",
            gtk_tree_path_to_string(path), new_text, data, NULL);
  }
  return;
}

void edit_startfunc(GtkCellRenderer *cell, GtkCellEditable *editable,
               gchar *path_string, gpointer data)
{
  GtkTreePath *path = gtk_tree_path_new_from_string (path_string);

  g_object_set_data(G_OBJECT(data), "insospeso", GINT_TO_POINTER(1));
  g_object_set_data(G_OBJECT(data), "path", (gpointer) path);
  g_object_set_data(G_OBJECT(data), "celleditable", (gpointer) editable);
}
//END NEW

GtkWidget *new_selection(GtkWidget *parent, GtkWidget *parentbox, const char *id, 
           int ncol, const char *titles[], int sizes[], GType *types, int *pr,
           bool *editable, GCallback edit_func)
{
  GtkWidget *scrollwin, *frame, *dirsel;
  GtkListStore *store;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
  int i;

  if(editable == NULL)
  {
     editable = g_new0(bool, ncol);
     for(int i=0; i<ncol; i++)
         editable[i] = false;
  }
  if(pr == NULL)
  {
     pr = g_new0(int, ncol);
     for(int i=0; i<ncol; i++)
         pr[i] = 0;
  }
  if(types == NULL)
  {
     types = g_new0(GType, ncol);
     for(int i=0; i<ncol; i++)
         types[i] = G_TYPE_STRING;
  }

  frame = gtk_frame_new(NULL);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
  if(parentbox)
  {
#if GTK_MAJOR_VERSION < 3
     GtkWidget *align = gtk_alignment_new (0.5f, 0, 0.1f, 1);
     gtk_widget_show (align);
     gtk_container_add(GTK_CONTAINER (align), frame);
     gtk_container_add(GTK_CONTAINER(parentbox), align);
#else
     gtk_widget_set_halign(frame, GTK_ALIGN_CENTER);
     gtk_widget_set_vexpand(frame, TRUE);
     gtk_container_add(GTK_CONTAINER(parentbox), frame);
#endif
  }
  gtk_widget_show (frame);
  scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add(GTK_CONTAINER(frame), scrollwin);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                   GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrollwin);

  dirsel = gtk_tree_view_new();
  g_object_set_data(G_OBJECT(dirsel), "formato", GINT_TO_POINTER(ncol));
  g_object_set_data(G_OBJECT(dirsel), "frame", frame);
  g_object_set_data(G_OBJECT(dirsel), "scrollwin", scrollwin);

  store = gtk_list_store_newv(ncol, types);
  g_object_set_data(G_OBJECT(store), "father", parent);
  for(i=0; i<ncol; i++)
  {
      if(types[i] == PIX_NUM_TYPE)
      {
         column = gtk_tree_view_column_new ();
         renderer = gtk_cell_renderer_text_new ();
         gtk_tree_view_column_pack_start (column, renderer,TRUE);
         gtk_tree_view_column_set_cell_data_func (column, renderer,
               fill_cell2, GINT_TO_POINTER(1), NULL);
         renderer = gtk_cell_renderer_pixbuf_new ();
         gtk_tree_view_column_pack_start (column, renderer, FALSE);
         gtk_tree_view_column_set_cell_data_func (column, renderer,
               fill_cell2, GINT_TO_POINTER(0), NULL);
         gtk_tree_view_column_set_title(column, titles[i]);
      }
      else
      {
#ifdef GTK_CELL_RENDERER_COMBO
        if((types[i] == G_TYPE_STRING) && (pr[i] != 0))
        {
           renderer = gtk_cell_renderer_combo_new ();
           g_object_set (renderer,
                "has-entry", FALSE,
                NULL);
        }
        else
#endif
           renderer = gtk_cell_renderer_text_new ();
        column = gtk_tree_view_column_new_with_attributes (titles[i],
            renderer, "text", i, NULL);
      }
      g_object_set_data(G_OBJECT(column), "renderer", (gpointer) renderer);
      GtkWidget *label = LABEL_NEW(titles[i], MyBLUE);
      if(editable[i])
      {
           g_object_set (G_OBJECT(renderer), "editable", TRUE, NULL);
           if(edit_func != NULL)
              g_signal_connect (G_OBJECT(renderer), "edited",
                    edit_func, store);
//NEW
              g_signal_connect (G_OBJECT(renderer), "editing-started",
                    G_CALLBACK(edit_startfunc), store);
              g_signal_connect (G_OBJECT(renderer), "editing-canceled",
                    G_CALLBACK(edit_canceled), store);
//END NEW
      }

      if(types[i] == G_TYPE_FLOAT) //190914&& (pr[i] != 0))
      {
            g_object_set_data(G_OBJECT(column), "precision", GINT_TO_POINTER(pr[i]));
            gtk_tree_view_column_set_cell_data_func(column, renderer, incolonna_float, GINT_TO_POINTER(i), NULL);
      }
      g_object_set_data (G_OBJECT (renderer), "column", GINT_TO_POINTER (i));
      g_object_set_data (G_OBJECT (renderer), "gtype", GINT_TO_POINTER (types[i]));
      gtk_tree_view_column_set_alignment  (column, 0.5f);
      gtk_widget_show (label);
      gtk_tree_view_column_set_widget(column, label);
      if(sizes[i] > 0)
      {
           gtk_tree_view_column_set_sizing (column,GTK_TREE_VIEW_COLUMN_FIXED);
           gtk_tree_view_column_set_fixed_width(column, sizes[i]);
      }
      else
          gtk_tree_view_column_set_sizing (column,GTK_TREE_VIEW_COLUMN_AUTOSIZE);
      gtk_tree_view_column_set_visible(column, (sizes[i] >= 0));
      gtk_tree_view_column_set_clickable(column, FALSE);
      gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column);
  }
  gtk_tree_view_set_model(GTK_TREE_VIEW(dirsel), GTK_TREE_MODEL (store));
  gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(dirsel), TRUE);
  g_object_set_data(G_OBJECT (parent), id, dirsel);
  gtk_container_add (GTK_CONTAINER (scrollwin), dirsel);
  return dirsel;
}

gboolean find_elem_in_list(GtkWidget *list, const char *str, int column)
{
    GtkTreeIter iter;
    gpointer data;
    char *line;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));

    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    while (valid)
    {
       gtk_tree_model_get (model, &iter, column, &data, -1);
       line = (char *) data;
       if(g_ascii_strcasecmp(line, str) == 0)
          return TRUE;
       valid = gtk_tree_model_iter_next (model, &iter);
    }
    return FALSE;
}

GtkTreeViewColumn *get_column(GtkWidget *treeview, int ncol)
{
   GList *columns;
   GtkTreeViewColumn *column;

   columns = gtk_tree_view_get_columns(GTK_TREE_VIEW(treeview));
   column = (GtkTreeViewColumn *) g_list_nth_data(columns, ncol);
   g_free(columns);
   return column;
}

GtkWidget *scrolled_text (GtkWidget *box1, bool ifScroll)
{
  GtkWidget *text;
  GtkTextBuffer *text_buffer;

  text = gtk_text_view_new ();
  text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text));
  gtk_text_buffer_create_tag (text_buffer, "reference_line",
                              "foreground", "red", NULL);
  gtk_text_buffer_create_tag (text_buffer, "big",
                              "size", 9 * PANGO_SCALE,
                              "weight", PANGO_WEIGHT_BOLD,
                              "family", MONOSPACE_FONT, NULL);
  gtk_text_buffer_create_tag (text_buffer, MONOSPACE_FONT,
                              "family", MONOSPACE_FONT, NULL);

  gtk_text_view_set_editable(GTK_TEXT_VIEW(text), TRUE);

  if(ifScroll)
  {
      GtkWidget *scrollwin = gtk_scrolled_window_new( NULL, NULL);
      gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                  GTK_POLICY_AUTOMATIC,
                                  GTK_POLICY_AUTOMATIC);
      gtk_widget_show (scrollwin);
      gtk_container_add (GTK_CONTAINER (box1), scrollwin);
#ifdef IN_GTK3
      gtk_widget_set_hexpand(scrollwin, TRUE);
      gtk_widget_set_vexpand(scrollwin, TRUE);
#endif

      gtk_container_add(GTK_CONTAINER(scrollwin), text);
      g_object_set_data(G_OBJECT(text), "scrollwin", scrollwin);
  }
  else
      gtk_container_add(GTK_CONTAINER(box1), text);


  return text;
}

GtkWidget *scrolled_labeltext (GtkWidget *box1, bool ifScroll)
{
  GtkWidget *text;

  text = gtk_label_new ("");
  set_alignment (text, 0., 0.);
  gtk_label_set_justify (GTK_LABEL (text), GTK_JUSTIFY_FILL);

  if(ifScroll)
  {
      GtkWidget *scrollwin = gtk_scrolled_window_new( NULL, NULL);
      gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                  GTK_POLICY_AUTOMATIC,
                                  GTK_POLICY_AUTOMATIC);
      gtk_widget_show (scrollwin);
      gtk_container_add (GTK_CONTAINER (box1), scrollwin);
#ifdef IN_GTK3
      gtk_widget_set_hexpand(scrollwin, TRUE);
      gtk_widget_set_vexpand(scrollwin, TRUE);
#endif
      GtkWidget *view = gtk_viewport_new(NULL, NULL);
      gtk_widget_show (view);
      gtk_container_add(GTK_CONTAINER(scrollwin), view);
      gtk_container_add(GTK_CONTAINER(view), text);
      g_object_set_data(G_OBJECT(text), "scrollwin", scrollwin);
  }
  else
      gtk_container_add(GTK_CONTAINER(box1), text);


  return text;
}

#ifdef GTK_COMBO_BOX
int n_items_combo (GtkWidget *combo)
{
  GtkTreeModel *model;
  GtkTreeIter iter;
  gboolean valid;
  gint row_count = 0;

  model = gtk_combo_box_get_model(GTK_COMBO_BOX(combo));
  valid = gtk_tree_model_get_iter_first (model, &iter);

  while (valid)
  {
      row_count++;
      valid = gtk_tree_model_iter_next (model, &iter);
  }
  return row_count;
}
#endif

GtkWidget *combo_box_new()
{
#ifndef GTK_COMBO_BOX
    return gtk_combo_new();
#elif defined(GTK_COMBO_BOX_TEXT)
    return gtk_combo_box_text_new();
#else
    return gtk_combo_box_new_text ();
#endif
}

GtkWidget *combo_new()
{
#ifndef GTK_COMBO_BOX
    return gtk_combo_new();
#elif defined(GTK_COMBO_BOX_TEXT)
    return gtk_combo_box_text_new_with_entry ();
#else
    return gtk_combo_box_entry_new_text ();
#endif
}

#ifdef GTK_COMBO_BOX
void combo_remove_text(GtkWidget *combo)
{
#ifndef GTK_COMBO_BOX_TEXT
        gtk_combo_box_remove_text (GTK_COMBO_BOX (combo), 0);
#else
        gtk_combo_box_text_remove(GTK_COMBO_BOX_TEXT (combo), 0);
#endif
}

void combo_insert_text(GtkWidget *combo, int i, const char *str)
{
#ifndef GTK_COMBO_BOX_TEXT
        gtk_combo_box_insert_text (GTK_COMBO_BOX (combo), i, str);
#else
        gtk_combo_box_text_insert_text(GTK_COMBO_BOX_TEXT (combo),  i, str);
#endif
}
#endif

void set_popdown_strings (GtkWidget *combo, GList *strings)
{
    int i, nlabels = g_list_length(strings);
#ifndef GTK_COMBO_BOX
    gtk_combo_set_popdown_strings(GTK_COMBO(combo), strings);
#else
    int nitems = n_items_combo(combo);
    for(i=0; i<nitems; i++)
        combo_remove_text (combo);
    for(i=0; i<nlabels; i++)
    {
        char *str = (char *)g_list_nth_data(strings, i);
        combo_insert_text (combo, i, str);
        g_object_set_data(G_OBJECT(combo),
          g_strdup_printf("%d",i), DuplicaStringa(str));
    }
    combo_set_val(combo, 1);
#endif
    for(i=0; i<nlabels; i++)
    {
        char *str = (char *)g_list_nth_data(strings, i);
        g_object_set_data(G_OBJECT(combo), DuplicaStringa(str),
          GINT_TO_POINTER(i));
    }
}

void fill_my_combog(GtkWidget *combo, GList *items)
{
    int hnd = get_int(combo, "hnd");
#ifndef GTK_COMBO_BOX
    if(hnd)
       g_signal_handler_block(G_OBJECT(GTK_COMBO(combo)->entry), hnd);
     set_popdown_strings (combo, items);
    if(hnd)
       g_signal_handler_unblock(G_OBJECT(GTK_COMBO(combo)->entry), hnd);
#else
    if(hnd)
       g_signal_handler_block(G_OBJECT(combo), hnd);
     set_popdown_strings (combo, items);
    if(hnd)
       g_signal_handler_unblock(G_OBJECT(combo), hnd);
#endif
}

GtkWidget *create_combo_str(GCallback cb, gpointer data, bool with_entry)
{
    GtkWidget *combo;
    if(with_entry)
       combo = combo_new();
    else
       combo = combo_box_new();
    int hnd = 0;

#ifndef GTK_COMBO_BOX
    g_object_set_data (G_OBJECT(combo), "entry", GTK_COMBO(combo)->entry);
    g_object_set_data (G_OBJECT(GTK_COMBO(combo)->list), "entry", GTK_COMBO(combo)->entry);
    gtk_combo_disable_activate (GTK_COMBO(combo));
    if(cb)
       hnd =  g_signal_connect(G_OBJECT(get_widget(combo, "entry")), "changed",  cb, data);
#else
    if(with_entry)
       g_object_set_data (G_OBJECT(combo), "entry", gtk_bin_get_child(GTK_BIN(combo)));
    else
       g_object_set_data (G_OBJECT(combo), "entry", combo);
    if(cb)
       hnd =  g_signal_connect(G_OBJECT(combo), "changed",  cb, data);
#endif
    if(hnd)
       g_object_set_data (G_OBJECT(combo), "hnd", GINT_TO_POINTER(hnd));
    return combo;
}

GtkWidget *create_combo_str(bool with_entry)
{
    return create_combo_str(NULL, NULL, with_entry);
}

void fill_combo(GtkWidget *combo, const char *labels[],
                              int nlabels, int def_b)
{
    int i;

#ifndef GTK_COMBO_BOX
  if(nlabels)
  {
      GList *combo_items = NULL;
      for(i=0; i<nlabels;i++)
      {
          char *labstr = g_strdup(labels[i]);
          combo_items = g_list_append (combo_items,labstr);
          g_object_set_data(G_OBJECT(combo),
//            g_strdup_printf("%d",i), DuplicaStringa(labels[i]+1));
            g_strdup_printf("%d",i), labstr);
          g_object_set_data(G_OBJECT(GTK_COMBO(combo)->entry),
//            g_strdup_printf("%d",i), DuplicaStringa(labels[i]+1));
            g_strdup_printf("%d",i), labstr);
          g_object_set_data(G_OBJECT(GTK_COMBO(combo)->list),
            g_strdup_printf("%d",i), DuplicaStringa(labels[i]+1));
      }
      gtk_combo_set_popdown_strings (GTK_COMBO (combo), combo_items);
      g_list_free (combo_items);
      gtk_combo_disable_activate (GTK_COMBO(combo));
  }
  char *nome =  g_strdup_printf("%d", def_b-1);
  char *label = get_string(combo, nome);
  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo)->entry), label);
#else 

    for(i=0; i<nlabels; i++)
        combo_remove_text (combo);
    for(i=0; i<nlabels; i++)
    {
        combo_insert_text (combo, i, labels[i]);
        char *tmpnam = g_strdup_printf("%d",i);
        g_object_set_data(G_OBJECT(combo), tmpnam,
          g_strdup_printf("%s", labels[i]+1));
        g_free(tmpnam);
    }
    gtk_combo_box_set_active (GTK_COMBO_BOX (combo), def_b-1);

#endif
}
#ifndef GTK_COMBO_BOX
void get_comboselection (GtkWidget *widget, int *val)
{
    GtkWidget *combo = gtk_widget_get_parent(widget);
    GtkWidget *list = GTK_COMBO(combo)->list;
    GtkWidget *child;
    GList *children = gtk_container_get_children(GTK_CONTAINER(list));
    char stringa[50], stringasel[50];
    CopiaStringa(stringasel,  50, gtk_editable_get_chars (GTK_EDITABLE(widget), 0, -1));
    for(int i=0; i<(int) g_list_length(children); i++)
    {
        child = GTK_WIDGET(g_list_nth_data(children, i));
        CopiaStringa(stringa,  50, gtk_label_get_text (GTK_LABEL(GTK_BIN(child)->child)));
        if(strcmp(stringa, stringasel) == 0)
        {
           *val = i+1;
           return;
        }
    }
    *val = 0;
}
#else
void get_comboselection(GtkWidget *combo, int *val)
{ 
     int selection = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
     *val = selection+1;
}
#endif

GtkWidget *create_combo(GtkWidget *parentbox, const char *items[],
                          int n_items, int default_selected, int *val,
                          GCallback cb, bool with_entry)
{
  GtkWidget *combo;
  int hnd;

  combo = create_combo_str(NULL, NULL, with_entry);
#ifdef IN_GTK3
  GtkWidget *align = combo;
  gtk_widget_set_halign(combo, GTK_ALIGN_START);
  gtk_widget_set_valign(combo, GTK_ALIGN_START);
  gtk_widget_set_hexpand(combo, FALSE);
  gtk_widget_set_vexpand(combo, FALSE);
#else
  GtkWidget *align = gtk_alignment_new(0.,0.5,0.,0.);
  gtk_container_add (GTK_CONTAINER (align), combo);
  gtk_widget_show(align);
#endif
  g_object_set_data(G_OBJECT(combo), "parent", align);
  if(parentbox)
  {
     if(GTK_IS_BOX(parentbox))
        gtk_box_pack_start (GTK_BOX (parentbox), align, FALSE, FALSE, 0);
     else if(!IsTable(parentbox))
        gtk_container_add (GTK_CONTAINER (parentbox), align);
  }
  if(n_items)
     fill_combo(combo, items, n_items, default_selected);
  if(val)
  {
#ifndef GTK_COMBO_BOX
     hnd = g_signal_connect(G_OBJECT(GTK_COMBO(combo)->entry), "changed",
               G_CALLBACK(get_comboselection), val);
//     hnd = g_signal_connect(G_OBJECT(GTK_COMBO(combo)->list), "select-child",
//               G_CALLBACK(get_comboselection), val);
#else
     hnd =  g_signal_connect(G_OBJECT(combo), "changed",
                G_CALLBACK(get_comboselection), val);
#endif
  }
  else if (cb)
  {
#ifndef GTK_COMBO_BOX
      hnd = g_signal_connect(G_OBJECT(GTK_COMBO(combo)->entry), "changed",
		G_CALLBACK(cb), NULL);
//      hnd = g_signal_connect(G_OBJECT(GTK_COMBO(combo)->list), "select-child", cb, NULL);
#else
      hnd = g_signal_connect(G_OBJECT(combo), "changed", cb, NULL);
#endif
  g_object_set_data(G_OBJECT(combo), "hnd", GINT_TO_POINTER(hnd));
  }
  return combo;
}

GtkWidget *create_combog(GList *items, int default_selected)
{
  GtkWidget *combo = create_combo_str(NULL, NULL);
  set_popdown_strings(combo, items);
  combo_set_val(combo, default_selected);
  return combo;
}

void combo_set_val (GtkWidget *combo, int val)
{
#ifndef GTK_COMBO_BOX
//    gtk_list_select_item (GTK_LIST(GTK_COMBO(combo)->list), val-1);
    char *nome =  g_strdup_printf("%d", val-1);
    char *label = get_string(combo, nome);
    gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo)->entry), label);
#else
    gtk_combo_box_set_active (GTK_COMBO_BOX (combo), -1);
    gtk_combo_box_set_active (GTK_COMBO_BOX (combo), val-1);
#endif
}

int combo_get_val(GtkWidget *combo)
{
#ifndef GTK_COMBO_BOX
    int i;
    GtkWidget *entry = get_widget(combo, "entry");
    GtkWidget *list = GTK_COMBO(combo)->list;
    GtkWidget *child;
    GList *children = gtk_container_get_children(GTK_CONTAINER(list));
    char stringa[50], stringasel[50];
    CopiaStringa(stringasel,  50, gtk_editable_get_chars (GTK_EDITABLE(entry), 0, -1));
    for(i=0; i<(int) g_list_length(children); i++)
    {
        child = GTK_WIDGET(g_list_nth_data(children, i));
        CopiaStringa(stringa,  50, gtk_label_get_text (GTK_LABEL(GTK_BIN(child)->child)));
        if(strcmp(stringa, stringasel) == 0)
           return (i+1);
    }
    return 0; 
#else
     int selection = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));
     return (selection+1);
#endif
}

gchar *combo_get_text(GtkWidget *combo)
{
#ifndef GTK_COMBO_BOX
    return gtk_editable_get_chars (GTK_EDITABLE(combo), 0, -1);
#elif defined(GTK_COMBO_BOX_TEXT)
    if(GTK_IS_COMBO_BOX_TEXT(combo))
       return gtk_combo_box_text_get_active_text(GTK_COMBO_BOX_TEXT(combo));
#else
    if(GTK_IS_COMBO_BOX(combo))
    return gtk_combo_box_get_active_text(GTK_COMBO_BOX(combo));
#endif
return gtk_editable_get_chars (GTK_EDITABLE(combo), 0, -1);
}

void OpenPdf(std::string pdfnam, GtkWidget *dlg)
{
#ifdef _WIN32
      ShellExecute(NULL, "open", pdfnam.c_str(), NULL, NULL, SW_SHOWNORMAL);
#else
      std::string cmd(GetPDFViewer());
      std::vector<std::string> args;
      std::string msg;
      args.push_back(toUTF8(pdfnam.c_str()));
      int i = run_command(cmd, args, msg);
      if((i == -1) && !str_white(msg.c_str()))
            gtkext::dlg_errmsg(GTK_WINDOW(dlg), msg);
#endif
}

void URLOpen(std::string Url, std::string Internet_Browser, GtkWidget *dlg)
{
      std::string urlstring;

#ifndef MACOSX
      if( !strstr(Url.c_str(), "http")  && !strstr(Url.c_str(), "file:") )
          urlstring = "file://" + Url;
      else
          urlstring = Url;
#else
      urlstring = Url;
#endif

#ifdef _WIN32
      ShellExecute(NULL, "open", urlstring.c_str(), NULL, NULL, SW_SHOWNORMAL);
#else
      int i;

      if(str_white(Internet_Browser.c_str()) || Internet_Browser.find("unknown") !=std::string::npos)
      {
          gtkext::dlg_errmsg(GTK_WINDOW(dlg), "Internet Browser not defined!\nCHECK SETTINGS!\n");
          return;
      }
      std::string cmd(toUTF8(Internet_Browser.c_str()));
      std::vector<std::string> args;
      std::string msg;
      args.push_back(toUTF8(urlstring.c_str()));
//      args.push_back(urlstring.c_str());
      i = run_command(cmd, args, msg);
      if((i == -1) && !str_white(msg.c_str()))
            gtkext::dlg_errmsg(GTK_WINDOW(dlg), msg);
#endif
 }

void get_metrics(PangoFontDescription *font_desc,
                 int *char_width, int *char_height)
{
  if (font_desc)
  {
      PangoContext *context;
      PangoFontMetrics *metrics;

      context = gdk_pango_context_get();
      pango_context_set_font_description (context, font_desc);
#ifdef MUST_SET_CM
      gdk_pango_context_set_colormap(context, gdk_colormap_get_system());
#endif
      metrics = pango_context_get_metrics (context,
                    font_desc, pango_context_get_language (context));
      
      *char_height = (pango_font_metrics_get_ascent (metrics) +
           pango_font_metrics_get_descent (metrics))/PANGO_SCALE;
      *char_width  = 
          pango_font_metrics_get_approximate_char_width(metrics)/PANGO_SCALE;
      *char_width  += 
          pango_font_metrics_get_approximate_digit_width(metrics)/PANGO_SCALE;
      *char_width  /= 2; 
      double rap = (double)(*char_height) / (double) (*char_width);
      if (rap >= 2.58)
         *char_height = (int) ((*char_width) * 2.57);
      pango_font_metrics_unref (metrics);
      g_object_unref(context);
   }
}

#ifndef NOCURS_FROM_PIXBUF

GdkCursor *create_my_cursor(cursors tipo)
{
   GdkCursor *cursor;
   my_cursor MyCursor;

   switch ((int) tipo)
   {
   default:
   case CROSS_CURSOR:
        MyCursor.x_hot = 8;
        MyCursor.y_hot = 8;
        MyCursor.filename = (char *)cross_filename;
        break;
   case WAIT_CURSOR:
        MyCursor.x_hot = 0;
        MyCursor.y_hot = 0;
        MyCursor.filename = (char *)wait_filename;
        break;
   case HAND_CURSOR:
        MyCursor.x_hot = 0;
        MyCursor.y_hot = 0;
        MyCursor.filename = (char *)hand_filename;
        break;
   case MOVE_CURSOR:
        MyCursor.x_hot = 6;
        MyCursor.y_hot = 6;
        MyCursor.filename = (char *)move_filename;
        break;
   case PICK_CURSOR:
        MyCursor.x_hot = 2;
        MyCursor.y_hot = 13;
        MyCursor.filename = (char *)pick_filename;
        break;
   case DRAG1_CURSOR:
        MyCursor.x_hot = 0;
        MyCursor.y_hot = 15;
        MyCursor.filename = (char *)drag1_filename;
        break;
   case DRAG2_CURSOR:
        MyCursor.x_hot = 0;
        MyCursor.y_hot = 15;
        MyCursor.filename = (char *)drag2_filename;
        break;
   case ZOOM_CURSOR:
        MyCursor.x_hot = 7;
        MyCursor.y_hot = 7;
        MyCursor.filename = (char *)zoom_filename;
        break;
   }

   GdkPixbuf *pixbuf = create_pixbuf  (MyCursor.filename);
   cursor = gdk_cursor_new_from_pixbuf (gdk_display_get_default (),
            pixbuf, 
            MyCursor.x_hot, MyCursor.y_hot);
   g_object_unref(pixbuf);

   return cursor;
}

#else

GdkCursor *create_my_cursor(cursors tipo)
{
   GdkCursor *cursor;
   GdkPixmap *source, *mask;
   my_cursor MyCursor;

   GdkColor fg = { 0, 0, 0, 0 };             // Black.
   GdkColor bg = { 0, 65535, 65535, 65535 }; // White. 

   switch ((int) tipo)
   {
   case CROSS_CURSOR:
        MyCursor.width = 16;
        MyCursor.height = 16;
        MyCursor.x_hot = 8;
        MyCursor.y_hot = 8;
        MyCursor.bits_bmp = (char *)cross_bits;
        MyCursor.bits_msk = (char *)cross_mask;
        break;
   case WAIT_CURSOR:
        MyCursor.width = 32;
        MyCursor.height = 32;
        MyCursor.x_hot = 0;
        MyCursor.y_hot = 0;
        MyCursor.bits_bmp = (char *)wait_bits;
        MyCursor.bits_msk = (char *)wait_mask;
        break;
   case HAND_CURSOR:
        MyCursor.width = 16;
        MyCursor.height = 16;
        MyCursor.x_hot = 0;
        MyCursor.y_hot = 0;
        MyCursor.bits_bmp = (char *)hand_bits;
        MyCursor.bits_msk = (char *)hand_mask;
        break;
   case MOVE_CURSOR:
        MyCursor.width = 16;
        MyCursor.height = 16;
        MyCursor.x_hot = 6;
        MyCursor.y_hot = 6;
        MyCursor.bits_bmp = (char *)move_bits;
        MyCursor.bits_msk = (char *)move_mask;
        break;
   case PICK_CURSOR:
        MyCursor.width = 16;
        MyCursor.height = 16;
        MyCursor.x_hot = 2;
        MyCursor.y_hot = 13;
        MyCursor.bits_bmp = (char *)pick_bits;
        MyCursor.bits_msk = (char *)pick_mask;
        break;
   case DRAG1_CURSOR:
        MyCursor.width = 16;
        MyCursor.height = 16;
        MyCursor.x_hot = 0;
        MyCursor.y_hot = 15;
        MyCursor.bits_bmp = (char *)drag1_bits;
        MyCursor.bits_msk = (char *)drag1_mask;
        break;
   case DRAG2_CURSOR:
        MyCursor.width = 16;
        MyCursor.height = 16;
        MyCursor.x_hot = 0;
        MyCursor.y_hot = 15;
        MyCursor.bits_bmp = (char *)drag2_bits;
        MyCursor.bits_msk = (char *)drag2_mask;
   case ZOOM_CURSOR:
        MyCursor.width = 16;
        MyCursor.height = 16;
        MyCursor.x_hot = 7;
        MyCursor.y_hot = 7;
        MyCursor.bits_bmp = (char *)zoom_bits;
        MyCursor.bits_msk = (char *)zoom_mask;
        break;
   }

   source = gdk_bitmap_create_from_data (NULL, MyCursor.bits_bmp,
            MyCursor.width, MyCursor.height);
   mask   = gdk_bitmap_create_from_data (NULL, MyCursor.bits_msk,
            MyCursor.width, MyCursor.height);
   cursor = gdk_cursor_new_from_pixmap (source, mask, &fg, &bg, 
            MyCursor.x_hot, MyCursor.y_hot);
   g_object_unref (source);
   g_object_unref (mask);

   return cursor;
}

#endif

typedef struct {
                GtkWidget *label;
                nomefile browser;
               } user_d;

static gboolean hypertext_cb(GtkWidget *wid, GdkEvent *, user_d *data)
{
      GtkWidget *label = data->label;
      std::string ib = (char *)data->browser;
      std::string tit = gtk_label_get_text(GTK_LABEL(label));
      URLOpen(tit, ib, gtk_widget_get_toplevel(wid));

      return TRUE;    
}


GtkWidget *hypertext_new(const char *string, const char *browser)
{
     GtkWidget *label;
     GtkWidget *ebox = gtk_event_box_new();
     user_d *data = g_new0(user_d, 1);

#ifndef NOMKESC
     char *markup = g_markup_printf_escaped ("<u><span foreground=\"blue\">%s</span></u>", 
                 string);
#else
     char *markup = g_strdup_printf("<u><span foreground=\"blue\">%s</span></u>", 
                 string);
#endif
     label = gtk_label_new(NULL);
     gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
     gtk_label_set_markup(GTK_LABEL(label), markup);
     gtk_container_add(GTK_CONTAINER(ebox), label);
     CopiaStringa(data->browser, MaxLenFilename, browser);
     data->label = label;
      (void) g_signal_connect (G_OBJECT (ebox), "button_press_event",
                      G_CALLBACK (hypertext_cb), data);
      gtk_widget_set_events(ebox, GDK_BUTTON_PRESS_MASK );

     return ebox;
}

GtkWidget *ScrolledText (GtkWidget *parent)
{
  GtkWidget *scrollwin;
  GtkWidget *text;

  scrollwin = gtk_scrolled_window_new( NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                  GTK_POLICY_AUTOMATIC, 
                                  GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrollwin);
#ifdef IN_GTK3
  gtk_widget_set_hexpand(scrollwin, TRUE);
  gtk_widget_set_vexpand(scrollwin, TRUE);
  gtk_container_add(GTK_CONTAINER(parent), scrollwin);
#else
  GtkWidget *a = gtk_alignment_new(0, 0, 1, 1);
  gtk_widget_show(a);
  gtk_container_add(GTK_CONTAINER(parent), a);
  gtk_container_add(GTK_CONTAINER(a), scrollwin);
#endif
  text = gtk_text_view_new();
  g_object_set_data(G_OBJECT(text), "box", scrollwin);
  gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW(text), TRUE);
  gtk_container_add(GTK_CONTAINER(scrollwin), text);
 
  return text;
}

void ClearText(GtkWidget *textview)
{
  GtkTextIter iter, iter2;
  GtkTextBuffer *tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview));

  gtk_text_buffer_get_iter_at_offset (tb, &iter, 0);
  gtk_text_buffer_get_bounds (tb, &iter, &iter2);
  gtk_text_buffer_delete (tb, &iter, &iter2);
}

gchar *GetTextW(GtkWidget *textview)
{
  GtkTextIter iter, iter2;
  GtkTextBuffer *tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview));

  gtk_text_buffer_get_bounds (tb, &iter, &iter2);
  return gtk_text_iter_get_text(&iter, &iter2);
}

gboolean true_cb (GtkWidget *, GdkEventAny *, gpointer )
{
    return TRUE;
}

GtkWidget *SPIN_WITH_LABEL2(const gchar *string, const char *colore, double vmin, 
         double vmax, double val, double step, int ncifre, gboolean use_default)
{
    GtkWidget *label=NULL, *spin, *box;

    box = hbox_new(FALSE, 0);
    if(string)
    {
       label = LABEL_NEW(string, colore);
       set_alignment (label, 0.0, 0.5);
       gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
       gtk_box_pack_start(GTK_BOX(box), label,FALSE, FALSE, 2);
    }
    spin = spin_button_new_with_range(vmin, vmax, step);
    spin_button_set_value(spin, val);
    spin_button_set_digits(spin, ncifre);
    int l = MRmax(LungNum(vmax, ncifre), LungNum(vmin, ncifre));
    gtk_entry_set_width_chars(GTK_ENTRY(spin), l);
#if defined(IN_GTK3) && (GTK_MINOR_VERSION >= 12)
    gtk_entry_set_max_width_chars(GTK_ENTRY(spin), l);
#endif
    gtk_box_pack_start(GTK_BOX(box), spin, FALSE, TRUE, 2);
    if(use_default)
    {
       GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("Use default", colore);
       gtk_box_pack_start(GTK_BOX(box), check, FALSE, TRUE, 8);
       g_object_set_data(G_OBJECT(box), "check", check);
       g_signal_connect(G_OBJECT(check) , "toggled", G_CALLBACK(on_cb_disattiva), (gpointer) spin);
    }
    if(label)
    {
       gtk_label_set_mnemonic_widget(GTK_LABEL(label), spin);
       g_object_set_data(G_OBJECT(box), "label", label);
    }
    g_object_set_data(G_OBJECT(box), "spin", spin);

    return box;
}

GtkWidget *SPIN_NEW(double vmin, double vmax, double val, double step, int ncifre)
{
    GtkWidget *spin;

    spin = spin_button_new_with_range(vmin, vmax, step);
    spin_button_set_value(spin, val);
    spin_button_set_digits(spin, ncifre);
    int l = MRmax(LungNum(vmax, ncifre), LungNum(vmin, ncifre));
    gtk_entry_set_width_chars(GTK_ENTRY(spin), l);
#if defined(IN_GTK3) && (GTK_MINOR_VERSION >= 12)
    gtk_entry_set_max_width_chars(GTK_ENTRY(spin), l);
#endif
    return spin;
}

GtkWidget *RADIO_BUTTON_WITH_LABEL(GSList *gr, const char *string, const char *color, int ifmne)
{
    GtkWidget *button;

    if(ifmne)
       button = gtk_radio_button_new_with_mnemonic(gr, string);
    else
       button = gtk_radio_button_new_with_label(gr, string);
    if(color)
       setta_colore(gtk_bin_get_child(GTK_BIN(button)), color);

    return button;
}

GtkWidget *RADIO_BUTTON_WITH_LABEL(GSList *gr, const char *string, const char *color)
{
    return RADIO_BUTTON_WITH_LABEL(gr, string, color, 1);
}

GtkWidget *RADIO_BUTTON_WITH_LABELW(GtkRadioButton *radio, const char *string, const char *color)
{
    GtkWidget *button;

    button = gtk_radio_button_new_with_label_from_widget(radio, string);
    if(color)
       setta_colore(gtk_bin_get_child(GTK_BIN(button)), color);
    return button;
}

GtkWidget *FRAME_BOLD (const gchar  *string, const char *colore, float fact, int ifmne)
{
    GtkWidget *frame, *label;
    
    frame = gtk_frame_new(NULL);
    gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_IN);
    if(string)
    {
       size_t sz = strlen(string)+2;
       gchar *string1 = g_new0(char, sz);
       CopiaStringa(string1, sz, " ");
       AppendiStringa(string1, sz, string);
       label = LABEL_BOLD(string1, colore, fact, ifmne);
       gtk_frame_set_label_widget(GTK_FRAME(frame), label);
       gtk_widget_show(label);
       set_alignment(label, 0., 0.);
//       gtk_misc_set_padding(GTK_MISC(label), 6, 0);
       g_free(string1);
    }
    return frame;
}

GtkWidget *FRAME_BOLD (const gchar  *string, const char *colore, float fact)
{
    return FRAME_BOLD (string, colore, fact, 1);
}

GtkWidget *FRAME_NEW (const gchar  *string, const char *colore)
{
    GtkWidget *frame;
    
    frame = FRAME_BOLD(string, colore, 0.99f);
    return frame;
}

GtkWidget *NEW_FRAME (const gchar  *string, _StyleType *style)
{
    GtkWidget *frame, *label;
    
    frame = gtk_frame_new(NULL);
    gtk_frame_set_shadow_type(GTK_FRAME(frame), style->shadow_type);
    if(string)
    {
       std::string str2 = string;
       if(style->Bold)
          label = LABEL_BOLD(str2.c_str(), style->color, style->size, 1);
       else
          label = LABEL_NEW(str2.c_str(), style->color, 1);
       gtk_frame_set_label_widget(GTK_FRAME(frame), label);
       gtk_widget_show(label);
       set_alignment(label, 0., 0.);
       g_object_set_data(G_OBJECT(frame), "label", label);
    }
#ifdef IN_GTK3
    GtkWidget *a = new_alignment(GTK_ALIGN_FILL, GTK_ALIGN_FILL, 1, 1);
    set_margins(a, style->top_p, style->bottom_p,style->left_p,
                style->right_p);
    gtk_widget_show(a);
#else
    GtkWidget *a = gtk_alignment_new(0.5, 0.5, 1, 1);
    gtk_alignment_set_padding(GTK_ALIGNMENT(a), style->top_p, style->bottom_p,
                  style->left_p, style->right_p);
    gtk_widget_show(a);
#endif
    g_object_set_data(G_OBJECT(frame), "align", a);
    gtk_container_add(GTK_CONTAINER(frame), a);
    return frame;
}

GtkWidget *NEW_FRAME (const gchar  *string, bool show_frame)
{
    if(show_frame)
    {
       _StyleType style = {true, 1, NULL, GTK_SHADOW_ETCHED_IN, 6, 6, 20, 6};
       return NEW_FRAME(string, &style);
    }
    else
    {
       _StyleType style = {false, 1, NULL, GTK_SHADOW_NONE, 6, 6, 15, 6};
       return NEW_FRAME(string, &style);
    }
}

GtkWidget *CHECK_BUTTON_WITH_LABEL(const char *string, const char *color)
{
    return CHECK_BUTTON_WITH_LABEL(string, color, 1);
}

GtkWidget *CHECK_BUTTON_WITH_LABEL(const char *string, const char *color, int ifmne)
{
    GtkWidget *button;

    if(ifmne)
       button = gtk_check_button_new_with_mnemonic(string);
    else
       button = gtk_check_button_new_with_label(string);
    if(color)
       setta_colore(gtk_bin_get_child(GTK_BIN(button)), color);
    set_alignment(gtk_bin_get_child(GTK_BIN(button)), 0, 0.5);
    return button;
}

GtkWidget *BUTTON_BOLD(const char *string, const char *color, float factor, int type)
{
    // type = 1 --> check_button
    // type = 2 --> radio_button

    GtkWidget *button;
    PangoFontDescription *newfdesc  = get_font((double) factor);

    switch(type)
    {
    default:
    case 1:
         button = gtk_check_button_new_with_label(string);
         break;
    case 2:
         button = gtk_radio_button_new_with_label(NULL, string);
         break;
    }
    widget_modify_font(gtk_bin_get_child(GTK_BIN(button)), newfdesc);
    if(color)
       setta_colore(gtk_bin_get_child(GTK_BIN(button)), color);
     pango_font_description_free (newfdesc);
     return button;
}

GtkWidget *CHECK_BUTTON_BOLD(const char *string, const char *color, float factor)
{
     return BUTTON_BOLD(string, color, factor, 1);
}

GtkWidget *RADIO_BUTTON_BOLD(const char *string, const char *color, float factor)
{
     return BUTTON_BOLD(string, color, factor, 2);
}

GtkWidget *TOGGLE_BUTTON_WITH_LABEL(const char *string)
{
    return TOGGLE_BUTTON_WITH_LABEL(string, NULL);
}

GtkWidget *TOGGLE_BUTTON_WITH_LABEL(const char *string, const char *color)
{
    GtkWidget *button;

    button = gtk_toggle_button_new_with_mnemonic(string);
    if(color)
       setta_colore(gtk_bin_get_child(GTK_BIN(button)), color);
    return button;
}

void on_cb_attiva(GtkToggleButton *button, GtkWidget *to_active)
{
   gtk_widget_set_sensitive(to_active, gtk_toggle_button_get_active(button));
}

void on_cb_disattiva(GtkToggleButton *button, GtkWidget *to_active)
{
   gtk_widget_set_sensitive(to_active, !gtk_toggle_button_get_active(button));
}

void button_set_label (GtkButton *button, const gchar *label)
{
   gtk_label_set_text(GTK_LABEL(gtk_bin_get_child(GTK_BIN(button))), label);
}

GtkWidget *show_image (const gchar *filename, const gchar *title, GtkWidget *parent)
{
  GtkWidget *vbox;
  GtkWidget *image;
  GtkWidget *window;
  GdkColor colorWhite = {0, 65535, 65535, 65535};
  
  if (!g_file_test (toUTF8(filename), G_FILE_TEST_EXISTS))
     return NULL;
  window = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window), toUTF8(title));

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(window));
  widget_modify_bg(window, GTK_STATE_NORMAL, &colorWhite);

  image = gtk_image_new_from_file (toUTF8(filename));
  gtk_container_add (GTK_CONTAINER (vbox), image);
  gtk_window_set_transient_for(GTK_WINDOW(window), GTK_WINDOW(parent));

  gtk_widget_show_all(window);
  return window;
}

void set_widget_font (GtkWidget *widget, const char *font)
{
  PangoFontDescription *font_desc;

  font_desc = pango_font_description_from_string (font);
  
  widget_modify_font (widget, font_desc);
  pango_font_description_free (font_desc);
  
}

void set_widget_fontN (GtkWidget *widget, double fact)
{
  PangoFontDescription *newfdesc  = DefaultFontMono();
  int dime = (int) (fact * (double) pango_font_description_get_size(newfdesc));

  pango_font_description_set_size (newfdesc, dime);
  widget_modify_font (widget, newfdesc);
  pango_font_description_free (newfdesc);
}

PangoFontDescription *get_fontN (const char *desc, double fact)
{
  PangoFontDescription *font_desc, *newfdesc;

  if(strcmp(desc, MONOSPACE_FONT) == 0)
  {
     newfdesc  = DefaultFontMono();
     font_desc  = DefaultFontMono();
  }
  else
  {
     newfdesc  = DefaultFont();
     font_desc = pango_font_description_from_string (desc);
  }
  int dime = (int) (fact * (double) pango_font_description_get_size(newfdesc));

  pango_font_description_set_size (font_desc, dime);
  pango_font_description_free(newfdesc);
  return font_desc;
}

PangoFontDescription *get_font (double fact, int dime)
{
  PangoFontDescription *newfdesc  = DefaultFont();
  if(fact >= 2)
     pango_font_description_set_weight(newfdesc,PANGO_WEIGHT_ULTRABOLD);
  else if(fact > 1)
       pango_font_description_set_weight(newfdesc,PANGO_WEIGHT_HEAVY);
  else if(fact == 1)
#ifdef PANGO_WEIGHT_SEMIBOLD
     pango_font_description_set_weight(newfdesc,PANGO_WEIGHT_SEMIBOLD);
#else
     pango_font_description_set_weight(newfdesc,PANGO_WEIGHT_BOLD);
#endif
  else if(fact > 0.98)
     fact = 1.;
  int newsize = (int) (fact * (double) MY_FONT_SIZE * PANGO_SCALE);
  if(dime)
     newsize = (int) (fact * (double) dime * PANGO_SCALE);
#ifndef USE_MY_FONT_SIZE
  if(!dime)
     return newfdesc;
#endif
  pango_font_description_set_size (newfdesc, newsize);
  return newfdesc;
}

PangoFontDescription *get_fontP (int sz)
{
  PangoFontDescription *newfdesc  = DefaultFont();
  int newsize = (int) (sz * PANGO_SCALE);
  pango_font_description_set_size (newfdesc, newsize);

  return newfdesc;
}

GtkWidget* mr_toggle_button_new_with_color ()
{
  GtkWidget *toggle_button;
  GtkWidget *pix;
  GtkWidget *align;

  toggle_button = gtk_toggle_button_new ();
  align = gtk_aspect_frame_new (NULL, 0.5, 0.5, 1, FALSE);
  gtk_frame_set_shadow_type(GTK_FRAME(align), GTK_SHADOW_ETCHED_OUT);
  pix = gtk_drawing_area_new();
  gtk_container_add (GTK_CONTAINER (toggle_button), align);
  gtk_container_add (GTK_CONTAINER (align), pix);
  gtk_container_set_border_width (GTK_CONTAINER (align), 0);
  gtk_widget_show_all(toggle_button);
  g_object_set_data(G_OBJECT(toggle_button), "pix", pix);
  return toggle_button;
}

#ifdef NOIMAGEBUTTON
GtkWidget* mr_toggle_button_new_with_pixmap (GtkWidget *pixa, gboolean ini)
{
  GtkWidget *toggle_button;

  toggle_button = gtk_toggle_button_new ();
  gtk_container_add (GTK_CONTAINER (toggle_button), pixa);
  gtk_widget_show(pixa);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_button), ini);
  return toggle_button;
}
#else
GtkWidget* mr_toggle_button_new_with_pixmap (GtkWidget *pixa, gboolean ini)
{
  GtkWidget *toggle_button;

  toggle_button = gtk_toggle_button_new ();
  gtk_button_set_image (GTK_BUTTON(toggle_button), pixa);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_button), ini);
  return toggle_button;
}
#endif

void widget_modify_font(GtkWidget *widget, PangoFontDescription *font_desc)
{
#if GTK_MAJOR_VERSION < 3
    gtk_widget_modify_font(widget, font_desc);
#else
#if GTK_MINOR_VERSION < 16
    gtk_widget_override_font(widget, font_desc);
#else
    std::stringstream nome;
    nome << "text" << pango_font_description_get_family(font_desc)
         << PANGO_PIXELS(pango_font_description_get_size (font_desc));
    std::string nomestr = filtrastr(nome.str(), ' ');
    gtk_widget_set_name(widget, nomestr.c_str());
    PangoWeight wei = pango_font_description_get_weight(font_desc);

    GtkStyleContext *context = gtk_widget_get_style_context (widget);
    GtkCssProvider *provider = gtk_css_provider_new ();
    char *css_string = g_strdup_printf("#%s {\nfont-family: \"%s\";\n"
                  "font-size: %dpx;\n"
                  "font-weight: %d;\n}\n", nomestr.c_str(),
                  pango_font_description_get_family(font_desc),
                  PANGO_PIXELS(pango_font_description_get_size (font_desc)),
                  wei);
    gtk_css_provider_load_from_data (GTK_CSS_PROVIDER (provider),
                                 css_string, -1, NULL);
    gtk_style_context_add_provider (context,
                                GTK_STYLE_PROVIDER (provider),
                                GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
    g_object_unref (provider);
    g_free(css_string);
#endif
#endif
}

void set_error_color(GtkWidget *widget, bool err)
{
#if GTK_MAJOR_VERSION < 3
  GdkColor red = { 0, 65535, 0, 0 }; 
  if(err)
     for(int i=GTK_STATE_NORMAL; i<=GTK_STATE_INSENSITIVE; i++)
      gtk_widget_modify_text(widget, (GtkStateType) i, &red);
  else
     for(int i=GTK_STATE_NORMAL; i<=GTK_STATE_INSENSITIVE; i++)
      gtk_widget_modify_text(widget, (GtkStateType) i, NULL);
#else
  if(err)
     gtk_widget_set_name(widget, "textred");
  else
     gtk_widget_set_name(widget, "textgen");
#if 0
  const GdkRGBA color = {1.0, 0, 0, 1.0};
  if(err)
     for(int i=GTK_STATE_FLAG_NORMAL; i<=GTK_STATE_FLAG_FOCUSED; i++)
      gtk_widget_override_color(widget, (GtkStateFlags) i, &color);
  else
     for(int i=GTK_STATE_FLAG_NORMAL; i<=GTK_STATE_FLAG_FOCUSED; i++)
      gtk_widget_override_color(widget, (GtkStateFlags) i, NULL);
#endif
#endif
}

#ifdef IN_GTK3
void set_bgcolor(GtkWidget *widget, const char *colore)
{
  std::stringstream nome;
  nome << "color";
  gtk_widget_set_name(widget, nome.str().c_str());
  GtkStyleContext *context = gtk_widget_get_style_context (widget);
  GtkCssProvider *provider = gtk_css_provider_new ();
  char *css_string = g_strdup_printf("#%s {\nbackground-color: %s;\n}\n",
                  nome.str().c_str(), colore);
  gtk_css_provider_load_from_data (GTK_CSS_PROVIDER (provider),
                                 css_string, -1, NULL);
  gtk_style_context_add_provider (context,
                                GTK_STYLE_PROVIDER (provider),
                                GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
  g_object_unref (provider);
  g_free(css_string);
}
#endif

void set_widget_color(GtkWidget *widget, GdkColor colore)
{
#if GTK_MAJOR_VERSION < 3
  for(int i=GTK_STATE_NORMAL; i<=GTK_STATE_INSENSITIVE; i++)
      gtk_widget_modify_bg(widget, (GtkStateType) i, &colore);
#else
  float *col = ToColor3f(&colore);
  const GdkRGBA color = {col[0], col[1], col[2], 1.0};
  g_free(col);
  char *strcol = gdk_rgba_to_string(&color);
  set_bgcolor(widget, strcol);
  g_free(strcol);
//  for(int i=GTK_STATE_FLAG_NORMAL; i<=GTK_STATE_FLAG_FOCUSED; i++)
//      gtk_widget_override_background_color(widget, (GtkStateFlags) i, &color);
#endif
}                  

void set_widget_color (GtkWidget *widget, GdkColor *colore)
{
     set_widget_color(widget, *colore);
}

#ifdef IN_GTK3
void set_color(GtkWidget *widget, const char *colore)
{
  std::stringstream nome;
  nome << "color";
  gtk_widget_set_name(widget, nome.str().c_str());
  GtkStyleContext *context = gtk_widget_get_style_context (widget);
  GtkCssProvider *provider = gtk_css_provider_new ();
  //std::string css_string = g_strdup_printf("#%s {\ncolor: %s;\n}\n",
  char *css_string = g_strdup_printf("#%s {\ncolor: %s;\n}\n",
                  nome.str().c_str(), colore);
  gtk_css_provider_load_from_data (GTK_CSS_PROVIDER (provider),
                                 css_string, -1, NULL);
  gtk_style_context_add_provider (context,
                                GTK_STYLE_PROVIDER (provider),
                                GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
  g_object_unref (provider);
  g_free(css_string);
}
#endif

void widget_modify_fg(GtkWidget *widget, int i, const float *colore)
{
#if GTK_MAJOR_VERSION < 3
    GdkColor *gdkCol = ToGdkColor(colore);
    gtk_widget_modify_fg(widget, (GtkStateType) i, gdkCol);
#else
  const GdkRGBA color = {colore[0], colore[1], colore[2], 1.0};
  char *strcol = gdk_rgba_to_string(&color);
  //gtk_widget_override_color(widget, (GtkStateFlags) i, &color);
  //gtk_widget_override_color(widget, GTK_STATE_FLAG_INSENSITIVE, NULL);
  set_color(widget, strcol);
#endif
}

#ifndef IN_GTK3
void widget_modify_text(GtkWidget *widget, int i, GdkColor *colore)
{
    gtk_widget_modify_text(widget, (GtkStateType) i, colore);
}
#endif

void widget_modify_bg(GtkWidget *widget, int i, GdkColor *colore)
{
#if GTK_MAJOR_VERSION < 3
    gtk_widget_modify_bg(widget, (GtkStateType) i, colore);
#else
  float *col = ToColor3f(colore);
  const GdkRGBA color = {col[0], col[1], col[2], 1.0};
  char *strcol = gdk_rgba_to_string(&color);
  set_bgcolor(widget, strcol);
  //gtk_widget_override_background_color(widget, (GtkStateFlags) i, &color);
#endif
}

void widget_modify_base(GtkWidget *widget, int i, GdkColor *colore)
{
#if GTK_MAJOR_VERSION < 3
    gtk_widget_modify_base(widget, (GtkStateType) i, colore);
#else
  float *col = ToColor3f(colore);
  const GdkRGBA color = {col[0], col[1], col[2], 1.0};
  char *strcol = gdk_rgba_to_string(&color);
  set_bgcolor(widget, strcol);
  //gtk_widget_override_background_color(widget, (GtkStateFlags) i, &color);
#endif
}

void set_label_color (GtkWidget *widget, const char *col)
{
#if GTK_MAJOR_VERSION < 3
  GdkColor colore;
  if(gdk_color_parse(col, &colore))
  {
  for(int i=GTK_STATE_NORMAL; i<GTK_STATE_INSENSITIVE; i++)
      gtk_widget_modify_fg(widget, (GtkStateType) i, &colore);
  }
#else
  set_color(widget, col);
//  GdkRGBA colore;
//  if(gdk_rgba_parse(&colore, col))
//  {
//  for(int i=GTK_STATE_FLAG_NORMAL; i<GTK_STATE_FLAG_FOCUSED; i++)
//      gtk_widget_override_color(widget, (GtkStateFlags) i, &colore);
//  }
#endif
}

void set_bg_color (GtkWidget *widget, GdkColor colore)
{
#if GTK_MAJOR_VERSION < 3
    gtk_widget_modify_base(widget, GTK_STATE_NORMAL, &colore);
#else
  float *col = ToColor3f(&colore);
  const GdkRGBA color = {col[0], col[1], col[2], 1.0};
  char *strcol = gdk_rgba_to_string(&color);
  set_bgcolor(widget, strcol);
  //gtk_widget_override_background_color(widget, GTK_STATE_FLAG_NORMAL, &color);
#endif
}

void set_text_color (GtkWidget *widget, const char *col)
{
#if GTK_MAJOR_VERSION < 3
  GdkColor colore;
  if(gdk_color_parse(col, &colore))
    gtk_widget_modify_text(widget, GTK_STATE_NORMAL, &colore);
#else
  set_color(widget, col);
  //float *col = ToColor3f(&colore);
  //const GdkRGBA color = {col[0], col[1], col[2], 1.0};
  //gtk_widget_override_color(widget, GTK_STATE_FLAG_NORMAL, &color);
#endif
}

GList *fill_list(const char *stringa, const char *delimiter)
{
    GList *lista = NULL;
    char *str = g_strdup(stringa);
#ifdef HAVE_STRTOK_R
    int j;
    char *str1, *token, *saveptr1;

    for (j = 1, str1 = str; ; j++, str1 = NULL)
    {
         token = strtok_r(str1, delimiter, &saveptr1);
         if (token == NULL)
             break;
         lista = g_list_append(lista, DuplicaStringa(token));
    }
#else
#if __STDC_WANT_SECURE_LIB__
    int j;
    char *str1, *token, *saveptr1;

    for (j = 1, str1 = str; ; j++, str1 = NULL)
    {
         token = strtok_s(str1, delimiter, &saveptr1);
         if (token == NULL)
             break;
         lista = g_list_append(lista, DuplicaStringa(token));
    }
#else
    char *pstr = strtok(str, delimiter);
    while (pstr != NULL)
    {
          lista = g_list_append(lista, DuplicaStringa(pstr));
          pstr = strtok((char *)NULL, delimiter );
    }
#endif
#endif
    if(str)
       g_free(str);
    return lista;
}

int num_fields(const char *stringa, const char *delimiter)
{
   int n = 0;
   GList *lista = fill_list(stringa, delimiter);
   if(lista)
   {
      n = g_list_length(lista);
      for(int i=0; i<n; i++)
      {
          char *pstr = (char *)g_list_nth_data(lista, i);
          g_free(pstr);
      }
      g_list_free(lista);
   }
   return n;
}

void get_int_tokens (const char *str, const char *c, int num_tokens, int my_tokens[])
{
    int i;
    GList *lista = fill_list(str, c);

    for (i=0; i<num_tokens; i++)
        my_tokens[i] = 0;
    
    if(lista)
    {
       for(i=0; i<MRmin(num_tokens, (int)g_list_length(lista)); i++)
       {
           char *pstr = (char *)g_list_nth_data(lista, i);
           my_tokens[i] = atoi(pstr);
           g_free(pstr);
       }
       g_list_free(lista);
    }
}

void get_float_tokens (const char *str, const char *c, int num_tokens, float my_tokens[])
{
    int i;
    GList *lista = fill_list(str, c);

    for (i=0; i<num_tokens; i++)
        my_tokens[i] = 0;

    if(lista)
    {
       for(i=0; i<MRmin(num_tokens, (int)g_list_length(lista)); i++)
       {
           char *pstr = (char *)g_list_nth_data(lista, i);
           my_tokens[i] = (float) atof(pstr);
           g_free(pstr);
       }
       g_list_free(lista);
    }
}

int get_str_tokens (const char *str, const char *c, int num_tokens, char *my_tokens[])
{
    int i, n=0;
    GList *lista = fill_list(str, c);

    for (i=0; i<num_tokens; i++)
        my_tokens[i] = 0;

    if(lista)
    {
       n = MRmin(num_tokens, (int)g_list_length(lista));
       for(i=0; i<MRmin(num_tokens, (int)g_list_length(lista)); i++)
       {
           char *pstr = (char *)g_list_nth_data(lista, i);
           my_tokens[i] = DuplicaStringa(pstr);
           g_free(pstr);
       }
       g_list_free(lista);
    }
    return n;
}

void *get_nth_field (const char *str, const char *c, int n_field, char type)
{
    int num_field = n_field-1;
    char *pstr = NULL;
    GList *lista = fill_list(str, c);
    if(lista)
    {
       int n = g_list_length(lista);
       if(n > num_field)
          pstr = (char *)g_list_nth_data(lista, num_field);
       g_list_free(lista);
       if(!pstr)
          return NULL;
       switch(type)
       {
       case 's':
             {
             gchar *nstr = DuplicaStringa(pstr);
             g_free(pstr);
             return nstr;
             }
             break;
       case 'i':
             {
             int *ival = g_new0(int, 1);
             *ival = atoi(pstr);
             g_free(pstr);
             return ival;
             }
             break;
       case 'd':
             {
             double *dval = g_new0(double, 1);
             *dval = atof(pstr);
             g_free(pstr);
             return dval;
             }
             break;
       case 'f':
             {
             float *fval = g_new0(float, 1);
             *fval = (float) atof(pstr);
             g_free(pstr);
             return fval;
             }
             break;
       default:
             return (gpointer) pstr;
       }
    }
    return NULL;
}

int open_project(const char *fn, std::ifstream &f)
{
    f.open(fn, std::ios::binary | std::ios::in);

    if( !f || !f.is_open() )
      return -1;
    return 0;
}

size_t read_project(std::ifstream &f, char *str, size_t dime)
{
//#if __STDC_WANT_SECURE_LIB__
//    size_t nsz = f.rdbuf()->_Sgetn_s(str, dime, dime);
//#else
    size_t nsz = (size_t) f.rdbuf()->sgetn(str, dime);
//#endif
    return nsz;
}

size_t read_project(const char *fn, char *str, size_t dime)
{
    std::ifstream f;
    f.open(fn, std::ios::binary | std::ios::in);

    if( !f || !f.is_open() )
      return 0;

//#if __STDC_WANT_SECURE_LIB__
//    size_t nsz = f.rdbuf()->_Sgetn_s(str, dime, dime);
//#else
    size_t nsz = (size_t) f.rdbuf()->sgetn(str, dime);
//#endif
    return nsz;
}

int run_command(const std::string &exe, const std::vector<std::string> &args,
                std::string &msg, int ifSync, char **buffer, char **errbuff)
{
    if( exe.empty() )
    {
      msg = "no executable provided";
      return -1;
    }

    std::string cmd;
    GError *gerr = NULL;
    cmd = "'" + exe + "'";
    for( unsigned i=0; i<args.size(); ++i )
      cmd +=  " '" + args[i] + "'";
    if(ifSync)
       g_spawn_command_line_sync(cmd.c_str(), buffer, errbuff, NULL, &gerr);
    else
       g_spawn_command_line_async(cmd.c_str(), &gerr);
    if( gerr!=NULL )
    {
      msg = "Failed to execute the following command : "+ cmd +
        "\nCHECK SETTINGS!\nError message from glib : \n" + gerr->message;
      g_error_free(gerr);
      return -1;
    }
    return 0;
}

void block_handler(GtkWidget *combo)
{
#ifndef GTK_COMBO_BOX
    int hnd = get_int(get_widget(combo, "entry"), "hnd");
    if(hnd)
       g_signal_handler_block (G_OBJECT (get_widget(combo, "entry")), hnd);
#else
    int hnd = get_int(combo, "hnd");
    if(hnd)
       g_signal_handler_block (G_OBJECT (combo), hnd);
#endif
}

void unblock_handler(GtkWidget *combo)
{
#ifndef GTK_COMBO_BOX
    int hnd = get_int(get_widget(combo, "entry"), "hnd");
    if(hnd)
       g_signal_handler_unblock (G_OBJECT (get_widget(combo, "entry")), hnd);
#else
    int hnd = get_int(combo, "hnd");
    if(hnd)
       g_signal_handler_unblock (G_OBJECT (combo), hnd);
#endif
}

gboolean on_entry_focus_in_event  (GtkWidget  *widget, GdkEventFocus *,
                                    gpointer )
{
  gtk_editable_set_position(GTK_EDITABLE(widget), 0);
  return FALSE;
}

void mremove(const char *filter)
{
    GDir *dir;
    const gchar *name;
    GPatternSpec *pattern = g_pattern_spec_new(filter);

    dir = g_dir_open (g_get_current_dir(), 0, NULL);
    if (!dir)
      return;
    name = g_dir_read_name (dir);
    while (name != NULL)
    {
        gchar *path;
        gboolean is_dir;

        path = g_build_filename (g_get_current_dir(), name, NULL);
        is_dir = g_file_test (path, G_FILE_TEST_IS_DIR);
        if(!is_dir)
        {
           if(g_pattern_match_string (pattern, g_utf8_casefold(name, -1)))
              remove(name);
        }
        g_free (path);
        name = g_dir_read_name (dir);
   }
   g_dir_close(dir);
}

const char *get_ext(std::string &filename)
{
   int p = (int) filename.find_last_of( "." );
   if (p >= 0)
       return DuplicaStringa(filename.substr(p+1).c_str());
   else
       return "";
}

void fill_list_exts(const char *estens, std::vector<std::string> &exts)
{
using namespace std;
    string f1 = estens;
    size_t found = f1.find_first_of(",");
    while (found!=string::npos)
    {
       exts.push_back(f1.substr(0, found));
       f1.erase(0,found+1);
       found = f1.find_first_of(",");
    }
    exts.push_back(f1);
}

int fill_formats( std::vector<std::string> &vecExts, std::string &strExts)
{
     GSList *formats = gdk_pixbuf_get_formats ();
     int k=0;
     int filt = -1;
     for(guint i=0; i<g_slist_length(formats); i++)
     {
       GdkPixbufFormat *format = (GdkPixbufFormat *)g_slist_nth_data(formats, i);
       if (gdk_pixbuf_format_is_writable (format))
       {
         gchar **exts = gdk_pixbuf_format_get_extensions(format);
         int j=0;
         if(k)
            strExts.append("@");
         k++;
         strExts.append(gdk_pixbuf_format_get_description(format));
         strExts.append("(");
         while(exts[j] != NULL)
         {
            if(strstr(exts[j], "png"))
               filt = k-1;
            if(j)
               strExts.append(",");
            strExts.append("*.");
            strExts.append(exts[j++]);
         }
         strExts.append(")");
         vecExts.push_back(gdk_pixbuf_format_get_name(format));
         g_strfreev(exts);
       }
     }
     g_slist_free (formats);
     return filt;
}

int fill_formats(std::vector<std::string> &types,
                 std::vector<std::string> &exts, std::string &extensions)
{
   GSList *formats = gdk_pixbuf_get_formats ();
   int k = 0;
   for(int i=0; i<(int) g_slist_length(formats); i++)
   {
       GdkPixbufFormat *f = (GdkPixbufFormat *) g_slist_nth_data(formats, i);
       if (gdk_pixbuf_format_is_writable (f))
       {
           char *fname = gdk_pixbuf_format_get_name(f), *a;
           if(strstr(fname, "tiff"))
              a = g_strdup("tif");
           else if(strstr(fname, "jpeg"))
              a = g_strdup("jpg");
           else
              a = g_strdup(fname);
           if(strstr(fname, "png"))
           {
              types.insert(types.begin(), fname);
              std::string b = "*.";
              b.append(a);
              if(k > 0)
                 b.append(",");
              extensions.insert(0, b);
              exts.insert(exts.begin(), a);
           }
           else
           {
              types.push_back(fname);
              if(k > 0)
                 extensions.append(",*.");
              else
                 extensions.append("*.");
              extensions.append(a);
              exts.push_back(a);
           }
           k++;
       }
    }
    g_slist_free (formats);
    return k;
}

char *get_exts_from_filter(const char *filtro)
{
using namespace std;
    gchar **filts =  g_strsplit(filtro, "@", 20);
    string f1;
    for(int j=0; filts[j]!=NULL; j++)
    {
        std::string tmp(filts[j]);
        size_t n1 = tmp.find_first_of("*");
        size_t n2 = tmp.find_last_of(")");
        if(n2 == std::string::npos)
           n2 = tmp.size();
        gchar *truefilt;
        if(n1 != std::string::npos)
           truefilt = DuplicaStringa(tmp.substr(n1, (n2-n1)).c_str());
        else
           truefilt = DuplicaStringa(tmp.substr(0, n2).c_str());

        gchar **mfilt =  g_strsplit(truefilt, ",", 20);
        for(int i=0; mfilt[i]!=NULL; i++)
        {
            size_t sz = strlen(mfilt[i])+1;
            gchar *filt = g_new0(char, sz);

            if(strcmp(mfilt[i], "*.*"))
               CopiaStringa(filt, sz, mfilt[i]);
            else
               CopiaStringa(filt, sz, "*");
            f1.append(filt);
            f1.append(",");
            g_free(filt);
        }
        g_free(truefilt);
        g_strfreev(mfilt);
    }
    g_strfreev(filts);
    size_t found = f1.find_last_of(",");
    if (found!=string::npos)
       f1.erase(found,1);
    found = f1.find_first_of(".*");
    while (found!=string::npos)
    {
       f1.erase(found,1);
       found = f1.find_first_of(".*",found);
    }
    return g_strdup(f1.c_str());
}

char *get_exts_from_filterErr(const char *filtro)
{
using namespace std;
    string f1 = filtro;
    size_t found = f1.find_first_of(".*");
    while (found!=string::npos)
    {
       f1.erase(found,1);
       found = f1.find_first_of(".*",found);
    }
    return g_strdup(f1.c_str());
}

int find_extension_in_list(std::string &fn, std::vector<std::string> exts)
{
    std::string ext1 = get_ext(fn);
    if(str_white(ext1.c_str()))
       return -1;
    int kit = 0;
    int ke = -1;
    while(kit < 2)
    {
       ke = -1;
       for(int i=0; i<(int)exts.size(); i++)
       {
          if(g_ascii_strcasecmp(exts[i].c_str(), ext1.c_str()) == 0)
          {
            ke = i;
            break;
          }
       }
       if(ke != -1)
          kit = 2;
       else
          kit++;
    }
    return ke;
}

GtkWidget *create_combo(GtkWidget *parentbox, GList *items,
                        int default_selected, int *val)
{
  GtkWidget *combo;
  int hnd;

  combo = create_combo_str(NULL, NULL);
#ifdef IN_GTK3
  GtkWidget *align = combo;
  gtk_widget_set_halign(combo, GTK_ALIGN_START);
  gtk_widget_set_valign(combo, GTK_ALIGN_CENTER);
  gtk_widget_set_hexpand(combo, FALSE);
  gtk_widget_set_vexpand(combo, FALSE);
#else
  GtkWidget *align = gtk_alignment_new(0.,0.5,0.,0.);
  gtk_container_add (GTK_CONTAINER (align), combo);
  gtk_widget_show(align);
#endif

  g_object_set_data(G_OBJECT(combo), "parent", align);
  if(parentbox)
  {
     if(GTK_IS_BOX(parentbox))
        gtk_box_pack_start (GTK_BOX (parentbox), align, FALSE, FALSE, 0);
     else if(!IsTable(parentbox))
        gtk_container_add (GTK_CONTAINER (parentbox), align);
  }
  set_popdown_strings(combo, items);
  combo_set_val(combo, default_selected);
  if(val)
  {
#ifndef GTK_COMBO_BOX
     hnd = g_signal_connect(G_OBJECT(GTK_COMBO(combo)->entry), "changed",
               G_CALLBACK(get_comboselection), val);
//     hnd = g_signal_connect(G_OBJECT(GTK_COMBO(combo)->list), "select-child",
//               G_CALLBACK(get_comboselection), val);
#else
     hnd =  g_signal_connect(G_OBJECT(combo), "changed",  G_CALLBACK(get_comboselection),
                 val);
#endif
     g_object_set_data(G_OBJECT(combo), "hnd", GINT_TO_POINTER(hnd));
  }
  return combo;
}

void set_right_justified(GtkWidget *item)
{
    if(!item)
       return;
#if GTK_MAJOR_VERSION < 3
    gtk_menu_item_set_right_justified((GtkMenuItem *)item, TRUE);
#else
    gtk_widget_set_hexpand(item, TRUE);
    gtk_widget_set_hexpand_set(item, TRUE);
    gtk_widget_set_halign(item, GTK_ALIGN_END);
#endif
}

void widget_size_request(GtkWidget *w, GtkRequisition *req)
{
#if GTK_MAJOR_VERSION < 3
    gtk_widget_size_request(w, req);
#else
    GtkRequisition mini;
    gtk_widget_get_preferred_size(w, &mini, req);
#endif
}

static gboolean can_activate_cb(GtkWidget* widget, guint , gpointer )
{
  return gtk_widget_is_sensitive(widget);
}
 
void SetMainMenu(GtkWidget *menubar, bool set_ready)
{
#ifdef MAC_INTEGRATION
#ifdef GTKOSX_TYPE_APPLICATION
  GtkosxApplication *OsxApp = (GtkosxApplication  *)g_object_new(GTKOSX_TYPE_APPLICATION, NULL);
  gtk_widget_hide(menubar);
  gtkosx_application_set_menu_bar (OsxApp, GTK_MENU_SHELL (menubar));
  if(set_ready)
     gtkosx_application_ready (OsxApp);
  gtkosx_application_sync_menubar (OsxApp);
#else
  GtkOSXApplication *OsxApp = (GtkOSXApplication  *)g_object_new(GTK_TYPE_OSX_APPLICATION, NULL);
  gtk_widget_hide(menubar);
  gtk_osxapplication_set_menu_bar (OsxApp, GTK_MENU_SHELL (menubar));
  if(set_ready)
     gtk_osxapplication_ready (OsxApp);
  gtk_osxapplication_sync_menubar (OsxApp);
#endif
#endif
}

void sync_menubar()
{
#ifdef MAC_INTEGRATION
#ifdef GTKOSX_TYPE_APPLICATION
  GtkosxApplication *OsxApp = (GtkosxApplication  *)g_object_new(GTKOSX_TYPE_APPLICATION, NULL);
  gtkosx_application_sync_menubar (OsxApp);
#else
  GtkOSXApplication *OsxApp = (GtkOSXApplication  *)g_object_new(GTK_TYPE_OSX_APPLICATION, NULL);
  gtk_osxapplication_sync_menubar (OsxApp);
#endif
#endif
}

GtkWidget* CreateMenubar( GtkWidget  *window, mr_action_entry menu_items[],
                          guint n_menu_items, int w, int h, bool ifmne)
{
  GtkWidget *menubar, *menuitem, *item, *menu[5], *father;
  mr_action_entry entry;
  int old_liv, hnd;
  gchar *altra_string;
  GSList *bg_group = NULL;
  gboolean radio, check;
  GtkAccelGroup *accel_group = gtk_accel_group_new ();
  gtk_window_add_accel_group (GTK_WINDOW (window), accel_group);

#ifdef MAC_INTEGRATION
  gboolean top_active;
#endif

#ifndef GTK_TOOLTIP
  GtkTooltips *tooltips = gtk_tooltips_new ();
  g_object_set_data(G_OBJECT(window), "tt", tooltips);
#endif

  menubar = gtk_menu_bar_new( );

  g_signal_connect(menubar, "can-activate-accel", 
                   G_CALLBACK(can_activate_cb), NULL);

  menu[0] = menubar;
  old_liv = 1;

  father = NULL;
  for(guint i=0; i<n_menu_items; i++)
  {
      radio = FALSE;
      check = FALSE;
      entry = menu_items[i];
      menuitem = menu[entry.level];
      bool to_show = true;
      if(entry.type < 0)
      {
         entry.type  = -entry.type;
         to_show = false;
      }
      if(entry.type == 2)
         radio = TRUE;
      else if(entry.type == 3)
         check = TRUE;
#ifdef MAC_INTEGRATION
      if(entry.level == 0)
         top_active = entry.abi;
#endif

      if(entry.level > old_liv)             // submenu 
      {
           menuitem = gtk_menu_new();
           father = menuitem;
           menu[entry.level] = menuitem;
           gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), menuitem);
           gtk_widget_show(menuitem);
#ifdef IN_GTK3
           gtk_menu_set_reserve_toggle_size(GTK_MENU(menuitem), TRUE);
#endif
           bg_group = NULL;
      }
      if(entry.type == 4)          // separatore 
      {
           item = gtk_separator_menu_item_new();
           gtk_menu_shell_append(GTK_MENU_SHELL(menu[entry.level]),item );
           if(to_show)
              gtk_widget_show(item);
      }
      else
      {
          if(radio)
          {
             item = gtk_radio_menu_item_new_with_mnemonic(bg_group, entry.string);
             bg_group = gtk_radio_menu_item_get_group(GTK_RADIO_MENU_ITEM(item));
          }
          else if(check)
             item = gtk_check_menu_item_new_with_mnemonic(entry.string);
          else if((entry.level == 0) || (entry.icon == NULL))
          {
             if(g_strrstr(entry.string, "recent"))
                item = gtk_menu_item_new_with_label("       ");
             else
             {
                if(ifmne)
                   item = gtk_menu_item_new_with_mnemonic(entry.string);
                else
                   item = gtk_menu_item_new_with_label(entry.string);
             }
          }
          else
          {
#ifdef GTK_IMAGE_MENU_ITEM
             if(ifmne)
                item = gtk_image_menu_item_new_with_mnemonic(entry.string);
             else
                item = gtk_image_menu_item_new_with_label(entry.string);
             if(entry.icon != NULL)
             {
                GtkWidget *image = create_menuicon(entry.icon, w, h);
                gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), image);
             }
#else
             if((entry.icon != NULL))// && (entry.accel == NULL))
                item = xpm_menu_item(entry.icon, entry.string, ifmne);
             else
             {
                if(ifmne)
                   item = gtk_menu_item_new_with_mnemonic(entry.string);
                else
                   item = gtk_menu_item_new_with_label(entry.string);
             }
#endif
          }
         if(entry.accel != NULL)
         {
            guint accel_key;
            GdkModifierType  accel_mods;
            gtk_accelerator_parse(entry.accel, &accel_key, &accel_mods);
             gtk_widget_add_accelerator(item, "activate", accel_group,
                accel_key, accel_mods, GTK_ACCEL_VISIBLE);
          }
          if(to_show)
             gtk_widget_show(item);

          gtk_menu_shell_append(GTK_MENU_SHELL(menu[entry.level]),item );
          altra_string = DuplicaStringa(entry.name);
          if(strstr(altra_string, "Help") != NULL)
              set_right_justified(item);
          gtk_widget_set_name(item, altra_string);
          g_object_set_data(G_OBJECT(window), altra_string, item);
          if(father != NULL)
             g_object_set_data(G_OBJECT(father), altra_string, item);
          g_object_set_data(G_OBJECT(menubar), altra_string, item);
          if((strlen(altra_string) > 1) && (strstr(altra_string, "recent")))
               gtk_widget_show(item);

         if(entry.cb)
         {
            if(entry.num == -2)
               hnd = g_signal_connect( G_OBJECT(item), "activate",
                        G_CALLBACK(entry.cb), window);
            else if(entry.num == -1)
               hnd = g_signal_connect( G_OBJECT(item), "activate",
                        G_CALLBACK(entry.cb), altra_string);
            else
               hnd = g_signal_connect( G_OBJECT(item), "activate",
                        G_CALLBACK(entry.cb), GINT_TO_POINTER(entry.num));
            g_object_set_data(G_OBJECT(item), "hnd", GINT_TO_POINTER(hnd));
         }
         if(altra_string)
            g_free(altra_string);
#ifdef MAC_INTEGRATION
         if(top_active)
            gtk_widget_set_sensitive (item, entry.abi);
         else
            gtk_widget_set_sensitive (item, top_active && entry.abi);
#else
         obj_set_sensitive ((gpointer) item, entry.abi);
#endif
         set_tip (item, entry.tip);
      }
      old_liv = entry.level;
  }
  g_object_set_data(G_OBJECT(menubar), "mainwin", window);
  return menubar;
}

#define HORIZONTAL 0
GtkWidget *create_range(GtkWidget *father, GtkWidget *parent, const char *label,
            int orientation, const char*name)
{
      if(name == NULL)
         name = g_strdup(label);
      GtkWidget *button;
      GtkWidget *label_button = gtk_label_new(label);
      gtk_widget_show(label_button);
      if(isVbox(parent))
         gtk_box_pack_start(GTK_BOX(parent), label_button, FALSE, FALSE, 2);
      else
      {
         set_alignment(label_button, 0., 0.);
         gtk_box_pack_start(GTK_BOX(parent), label_button, FALSE, FALSE, 0);
      }
      std::string str = "box_";
      str.append(name);
      g_object_set_data (G_OBJECT (father), str.c_str(),parent);
      if(orientation == HORIZONTAL)
          button = hscale_new_with_range(0.01, 20, 0.01);
      else
          button = vscale_new_with_range(0.01, 20, 0.01);
      gtk_scale_set_digits(GTK_SCALE(button), 2);
      gtk_scale_set_draw_value(GTK_SCALE(button), TRUE);
      gtk_scale_set_value_pos(GTK_SCALE(button), GTK_POS_BOTTOM);
      if(orientation == HORIZONTAL)
         gtk_widget_set_size_request(button, 120, -1);
      else
         gtk_widget_set_size_request(button, -1, 120);
      if(isVbox(parent))
         gtk_box_pack_start(GTK_BOX(parent), button, FALSE, FALSE, 2);
      else
         gtk_box_pack_start(GTK_BOX(parent), button, TRUE, TRUE, 4);
      g_object_set_data (G_OBJECT (button), "label", label_button);
      return button;
}

#ifdef USE_TOOLBAR
GtkWidget *CreateToolbar(GtkWidget *father, int orientation,
                           mr_action_entry tb_entries[], guint n_tb_entries)
{
      GtkWidget *bar, *button1, *box;
      GtkToolItem *button;
      int hnd;
      mr_action_entry entry;

      bar = gtk_toolbar_new();
      if(orientation == HORIZONTAL)
#ifdef GTK_ORIENTABLE
         gtk_orientable_set_orientation(GTK_ORIENTABLE(bar), GTK_ORIENTATION_HORIZONTAL);
#else
         gtk_toolbar_set_orientation(GTK_TOOLBAR(bar), GTK_ORIENTATION_HORIZONTAL);
#endif
      else
#ifdef GTK_ORIENTABLE
         gtk_orientable_set_orientation(GTK_ORIENTABLE(bar), GTK_ORIENTATION_VERTICAL);
#else
         gtk_toolbar_set_orientation(GTK_TOOLBAR(bar), GTK_ORIENTATION_VERTICAL);
#endif
      gtk_toolbar_set_style(GTK_TOOLBAR(bar), GTK_TOOLBAR_ICONS);
      for(guint i=0; i<n_tb_entries; i++)
      {
          button = NULL;
          button1 = NULL;
          bool to_show = true;
          bool can_focus = false;
          entry = tb_entries[i];
          if(entry.type < 0)
          {
             to_show = false;
             entry.type = -entry.type;
          }
          if(entry.type > 100)
          {
               entry.type -= 100;
               GtkWidget *iconw = create_image(entry.icon);
               char *tmp = g_strdup_printf("icon%s", entry.name);
               g_object_set_data (G_OBJECT(father), tmp, iconw);
               g_free(tmp);
          }
          else if((entry.type > 20) && (entry.type <= 30))
          {
               can_focus = TRUE;
               entry.type -= 20;
          }

          gpointer data;
          if(entry.cb)
          {
             if(entry.num == -2)
                data = (gpointer) father;
             else if(entry.num == -1)
                data = (gpointer) entry.name;
             else
                data = GINT_TO_POINTER(entry.num);
          }
          switch(entry.type)
          {
          default:
          case 1:
#ifndef GTK_STOCK_OK
               button = gtk_tool_button_new(create_image (entry.icon), NULL);
#else
               register_stock_icon(entry.icon);
               button = gtk_tool_button_new(NULL, NULL);
               gtk_tool_button_set_icon_name(GTK_TOOL_BUTTON(button),
                  entry.icon);
#endif
               if(entry.cb)
                  g_signal_connect ((gpointer) button, "clicked",
                    entry.cb , data);
               gtk_widget_set_can_focus(GTK_WIDGET(button), can_focus);
               break;

          case 3:
               button = gtk_toggle_tool_button_new();
#ifndef GTK_STOCK_OK
               gtk_tool_button_set_icon_widget(GTK_TOOL_BUTTON(button),
                     create_image(entry.icon));
#else
               register_stock_icon(entry.icon);
               gtk_tool_button_set_icon_name(GTK_TOOL_BUTTON(button),
                     entry.icon);
#endif
               gtk_toggle_tool_button_set_active(GTK_TOGGLE_TOOL_BUTTON(button),
                     entry.stato);
               gtk_widget_set_can_focus(GTK_WIDGET(button), can_focus);
               hnd = g_signal_connect ((gpointer) button, "toggled",
                    entry.cb , data);
               g_object_set_data(G_OBJECT(button), "hnd",
                  GINT_TO_POINTER(hnd));
               break;

          case 4:
               button = gtk_separator_tool_item_new();
               break;
          case 5:
               {
               float v[6];
               char *tmpst = g_strdup(entry.icon);
               get_float_tokens(tmpst,  ",", 5,  v);
               g_free(tmpst);
               button = gtk_tool_item_new();
               button1 = spin_button_new_with_range(v[2], v[3], v[4]);
               spin_button_set_value(button1, v[1]);
               if(v[0] > 0) 
                  set_width_chars(GTK_ENTRY(button1),6);
               spin_button_set_numeric (button1, TRUE);
               if(entry.cb)
               {
                  hnd = g_signal_connect ((gpointer) button1, "value-changed",
                    entry.cb , data);
                  g_object_set_data (G_OBJECT (button1), "hnd",
                          GINT_TO_POINTER(hnd));
               }
               gtk_container_add(GTK_CONTAINER(button), button1);
               }
               break;
          case 6:
               button = gtk_tool_item_new();
               box = vbox_new(FALSE, 0);
               gtk_container_add(GTK_CONTAINER(button), box);
               button1 = create_range(father, box, entry.string, orientation);
               gtk_widget_set_sensitive(get_widget(button1, "label"), FALSE);
               gtk_widget_set_sensitive(button1, FALSE);
               hnd = g_signal_connect ((gpointer) button1, "value-changed",
                    entry.cb , data);
               g_object_set_data (G_OBJECT (button1), "hnd", GINT_TO_POINTER(hnd));
               break;

          case 7:
          case 8:
               button = gtk_tool_item_new();
               button1 = myimage_button(entry.string, entry.icon);
               gtk_button_set_relief (GTK_BUTTON(button1), GTK_RELIEF_NONE);
               gtk_widget_set_can_focus(button1, can_focus);
               gtk_container_add(GTK_CONTAINER(button), button1);
               if(entry.cb)
                  g_signal_connect ((gpointer) button1, "clicked",
                    entry.cb , data);
               break;
            
          case 12:
               button = gtk_tool_item_new();
               button1 = LABEL_BOLD(entry.string, MyBLUE, 1.1f);
               gtk_container_add(GTK_CONTAINER(button), button1);
               break;
          case 13:
               button = gtk_tool_item_new();
               button1 = gtk_entry_new();
               gtk_container_add(GTK_CONTAINER(button), button1);
               break;
          case 47:
               {
               char *icons[3];
               char *tmpst = g_strdup(entry.icon);
               get_str_tokens(tmpst,  ",", 2,  icons);
               g_free(tmpst);
               button = gtk_tool_item_new();
               button1 = gtk_event_box_new();
               GtkWidget *tbpix1 = create_image(icons[0]);
               GtkWidget *tbpix2 = create_image(icons[1]);
               g_object_ref(G_OBJECT(tbpix1));
               g_object_ref(G_OBJECT(tbpix2));
               for(int kk=0; kk<2; kk++)
                   if(icons[kk] != NULL)
                      g_free(icons[kk]);
               if(to_show) 
                    gtk_widget_show(tbpix1);
               if(to_show) 
                    gtk_widget_show(tbpix2);
               g_object_set_data(G_OBJECT(button1), "icon1", tbpix1);
               g_object_set_data(G_OBJECT(button1), "icon2", tbpix2);
               gtk_container_set_border_width(GTK_CONTAINER(button1), 0);
               gtk_container_add(GTK_CONTAINER(button1), tbpix1);
//               gtk_box_pack_end(GTK_BOX(tb), button1, FALSE, FALSE,2);
               if(entry.cb)
               {
                  (void) g_signal_connect (G_OBJECT (button1), 
                  "button_release_event", entry.cb, GINT_TO_POINTER(0));
                  (void) g_signal_connect (G_OBJECT (button1), 
                  "button_press_event", entry.cb, GINT_TO_POINTER(1));
                   gtk_widget_set_events(button1, GDK_BUTTON_RELEASE_MASK | 
                        GDK_BUTTON_PRESS_MASK);
               }
               gtk_container_add(GTK_CONTAINER(button), button1);
               }
               break;

          case 50:
               button = gtk_tool_item_new();
               button1 = create_image(entry.icon);
               gtk_container_add(GTK_CONTAINER(button), button1);
               break;

          case 52:
               button = gtk_tool_item_new();
               button1 = label_boxed(" ");
               gtk_container_add(GTK_CONTAINER(button), button1);
               break;

          case 80:
               button = gtk_tool_item_new();
               gtk_tool_item_set_expand(button, TRUE);
               break;
         }
         if(!str_white(entry.name))
         {
            if((entry.type >= 5) && (entry.type <= 8) )
            {
               g_object_set_data (G_OBJECT (father), entry.name,button1);
               g_object_set_data (G_OBJECT (bar), entry.name, button1);
               gtk_widget_set_name(button1, entry.name);
            }
            else if(entry.type < 9) //5)
            {
               g_object_set_data (G_OBJECT (father), entry.name,button);
               g_object_set_data (G_OBJECT (bar), entry.name, button);
               gtk_widget_set_name(GTK_WIDGET(button), entry.name);
            }
            else if(entry.type == 52)
            {
               g_object_set_data (G_OBJECT (father), entry.name,
                    gtk_bin_get_child(GTK_BIN(button1)));
               g_object_set_data (G_OBJECT (bar), entry.name,
                    gtk_bin_get_child(GTK_BIN(button1)));
            }
            else if(entry.type != 80)
            {
               g_object_set_data (G_OBJECT (father), entry.name,button1);
               g_object_set_data (G_OBJECT (bar), entry.name, button1);
               gtk_widget_set_name(button1, entry.name);
            }

         }
         if(!str_white(entry.tip))
         {
#ifdef GTK_TOOLTIP
         gtk_tool_item_set_tooltip_text (GTK_TOOL_ITEM (button), entry.tip);
#else
         set_tip(GTK_WIDGET(button), entry.tip);
#endif
         }
         if(to_show)
            gtk_widget_show_all(GTK_WIDGET(button));
         if((entry.type != 4) && (entry.type != 80))
            obj_set_sensitive(get_object(bar, entry.name), entry.abi);
         gtk_toolbar_insert(GTK_TOOLBAR(bar), button, -1);
      }
      gtk_toolbar_set_show_arrow(GTK_TOOLBAR(bar), TRUE);
      gtk_widget_show(bar);
      return bar;
}
#else

GtkWidget *CreateToolbar(GtkWidget *father, int orientation,
                           mr_action_entry tb_entries[], int n_tb_entries)
{
      GtkWidget *bar, *box, *button, *align;
      int i, hnd;
      mr_action_entry entry;

      bar = gtk_frame_new(NULL);
      gtk_frame_set_shadow_type(GTK_FRAME(bar), GTK_SHADOW_ETCHED_IN);
      if(orientation == HORIZONTAL)
      {
         box = hbox_new(FALSE, 2);
         gtk_container_add(GTK_CONTAINER(bar), box);
      }
      else
      {
         GtkWidget *sc = gtk_scrolled_window_new(NULL, NULL);
         gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sc),
                         GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
         gtk_widget_show (sc);
         box = vbox_new(FALSE, 2);
         add_to_scrollwin(sc, box);
         gtk_container_add(GTK_CONTAINER(bar), sc);
      }
      gtk_widget_show (box);
      for(i=0; i<n_tb_entries; i++)
      {
          button = NULL;
          button1 = NULL;
          bool to_show = true;
          bool can_focus = false;
          entry = tb_entries[i];
          if(entry.type < 0)
          {
             to_show = false;
             entry.type = -entry.type;
          }
          if(entry.type > 100)
          {
               entry.type -= 100;
               GtkWidget *iconw = create_image(entry.icon);
               g_object_set_data (G_OBJECT(father),
                  g_strdup_printf("icon%s", entry.name), iconw);
          }
          else if((entry.type > 20) && (entry.type <= 30))
          {
               canFocus = TRUE;
               entry.type -= 20;
          }

          gpointer data;
          if(entry.cb)
          {
             if(entry.num == -2)
                data = (gpointer) father;
             else if(entry.num == -1)
                data = (gpointer) entry.name;
             else
                data = GINT_TO_POINTER(entry.num);
          }
          switch(entry.type)
          {
          case 1:
               button = gtk_alignment_new(0.5f, 0.5f, 0, 0);
               button1 = toolbar_button(entry.icon);
               gtk_container_add(GTK_CONTAINER(button), button1);
               if(entry.cb)
               {
                  hnd = g_signal_connect ((gpointer) button1, "toggled",
                    entry.cb , data);
                  g_object_set_data(G_OBJECT(button1), "hnd",
                     GINT_TO_POINTER(hnd));
               }
               break;

          case 3:
               {
               button = gtk_alignment_new(0.5f, 0.5f, 0, 0);
               GtkWidget *tbpix1 = create_image(entry.icon);
               button1 = mr_toggle_button_new_with_pixmap(tbpix1, entry.stato)
               gtk_button_set_relief(GTK_BUTTON(button1), GTK_RELIEF_NONE);
               gtk_widget_set_can_focus (button1, can_focus);
               gtk_container_add(GTK_CONTAINER(button), button1);
               if(entry.cb)
               {
                  hnd = g_signal_connect ((gpointer) button1, "toggled",
                    entry.cb , data);
                  g_object_set_data(G_OBJECT(button1), "hnd",
                     GINT_TO_POINTER(hnd));
               }
               }
               break;

          case 4:
               button = vseparator_new();
               break;

          case 5:
               {
               float v[6];
               char *tmpst = g_strdup(entry.icon);
               get_float_tokens(tmpst,  ",", 5,  v);
               button = spin_button_new_with_range(v[2], v[3], v[4]);
               spin_button_set_value(button, v[1]);
               if(v[0] > 0)
                  set_width_chars(GTK_ENTRY(button),6);
               spin_button_set_numeric (button, TRUE);
               if(entry.cb)
               {
                  hnd = g_signal_connect ((gpointer) button, "value-changed",
                    entry.cb , data);
                  g_object_set_data (G_OBJECT (button), "hnd",
                          GINT_TO_POINTER(hnd));
               }
               }

         case 6:
               button = vbox_new(FALSE, 0);
               button1 = create_range(father, buttonx, entry.string, orientation);
               gtk_widget_set_sensitive(get_widget(button1, "label"), FALSE);
               gtk_widget_set_sensitive(button1, FALSE);
               if(entry.cb)
               {
               hnd = g_signal_connect ((gpointer) button1, "value-changed",
                    entry.cb , data);
               g_object_set_data (G_OBJECT (button1), "hnd", GINT_TO_POINTER(hnd));
               }
               break;

          case 7:
          case 8:
               button = gtk_alignment_new(0.5f, 0.5f, 0, 0);
               button1 = myimage_button(entry.string, entry.icon);
               gtk_button_set_relief (GTK_BUTTON(button1), GTK_RELIEF_NONE);
               gtk_widget_set_can_focus (button1, can_focus);
               gtk_container_add(GTK_CONTAINER(button), button1);
               if(entry.cb)
               {
               hnd = g_signal_connect ((gpointer) button1, "clicked",
                    entry.cb , data);
               g_object_set_data (G_OBJECT (button1), "hnd", GINT_TO_POINTER(hnd));
               }
               break;
          case 12:
               button = gtk_alignment_new(0.5f, 0.5f, 0, 0);
               button1 = LABEL_BOLD(entry.string, MyBLUE, 1.1f);
               gtk_container_add(GTK_CONTAINER(button), button1);
               break;
          case 13:
               button = gtk_alignment_new(0.5f, 0.5f, 0, 0);
               button1 = gtk_entry_new();
               gtk_container_add(GTK_CONTAINER(button), button1);
               break;
          case 47:
               {
               char *icons[3];
               char *tmpst = g_strdup(entry.icon);
               get_str_tokens(tmpst,  ",", 2,  icons);
               button = gtk_alignment_new(0.5f, 0.5f, 0, 0);
               button1 = gtk_event_box_new();
               GtkWidget *tbpix1 = create_image(icons[0]);
               GtkWidget *tbpix2 = create_image(icons[1]);
               g_object_ref(G_OBJECT(tbpix1));
               g_object_ref(G_OBJECT(tbpix2));
               for(int kk=0; kk<2; kk++)
                   if(icons[kk] != NULL)
                      g_free(icons[kk]);
               if(to_show)
                    gtk_widget_show(tbpix1);
               if(to_show)
                    gtk_widget_show(tbpix2);
               g_object_set_data(G_OBJECT(button1), "icon1", tbpix1);
               g_object_set_data(G_OBJECT(button1), "icon2", tbpix2);
               gtk_container_set_border_width(GTK_CONTAINER(button1), 0);
               gtk_container_add(GTK_CONTAINER(button1), tbpix1);
               if(entry.cb)
               {
                  (void) g_signal_connect (G_OBJECT (button1),
                  "button_release_event", entry.cb, GINT_TO_POINTER(0));
                  (void) g_signal_connect (G_OBJECT (button1),
                  "button_press_event", entry.cb, GINT_TO_POINTER(1));
                   gtk_widget_set_events(button1, GDK_BUTTON_RELEASE_MASK |
                        GDK_BUTTON_PRESS_MASK);
               }
               gtk_container_add(GTK_CONTAINER(button), button1);
               }
               break;
          case 50:
               button = gtk_alignment_new(0.5f, 0.5f, 0, 0);
               button1 = create_image(entry.icon);
               gtk_container_add(GTK_CONTAINER(button), button1);
               break;

          case 52:
               button = gtk_alignment_new(0.5f, 0.5f, 0, 0);
               button1 = label_boxed(" ");
               gtk_container_add(GTK_CONTAINER(button), button1);
               break;
          }
         if(!str_white(entry.name))
         {
            if((entry.type == 4) || (entry.type == 5))
            {
               g_object_set_data (G_OBJECT (father), entry.name,button);
               g_object_set_data (G_OBJECT (bar), entry.name, button);
            }
            else if(entry.type == 52)
            {
               g_object_set_data (G_OBJECT (father), entry.name,
                    gtk_bin_get_child(GTK_BIN(button1)));
               g_object_set_data (G_OBJECT (bar), entry.name,
                    gtk_bin_get_child(GTK_BIN(button1)));
            }
            else
            {
               g_object_set_data (G_OBJECT (father), entry.name,button1);
               g_object_set_data (G_OBJECT (bar), entry.name, button1);
               gtk_widget_set_name(button1, entry.name);
            }
         }
         if(!str_white(entry.tip))
         {
#ifdef GTK_TOOLTIP
         gtk_tool_item_set_tooltip_text (GTK_TOOL_ITEM (button), entry.tip);
#else
         set_tip(GTK_WIDGET(button), entry.tip);
#endif
         }
         if(to_show)
            gtk_widget_show_all(GTK_WIDGET(button));
         if(entry.type != 4)
            obj_set_sensitive(get_object(bar, entry.name), entry.abi);
         gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE, 2);
      }
      gtk_widget_show(bar);
      return bar;
}
#endif

#ifdef USE_ACTIONS

GtkWidget *CreateMenubar(GtkWidget  *window, const char *info,
                         GtkUIManager *merge,  GtkActionGroup *action_group)
{
  AddUIManager(window, info, merge);
  GtkWidget *menubar = gtk_ui_manager_get_widget (merge, "/MenuBar");
  gtk_widget_show (menubar);
  g_object_set_data(G_OBJECT(window), "menubar", menubar);
  GtkWidget *help_item = gtk_ui_manager_get_widget (merge, "/MenuBar/Help");
  if(help_item)
     set_right_justified (help_item);

  g_object_set_data(G_OBJECT(menubar), "mainwin", window);
  return menubar;
}

GtkWidget *CreateToolbar(GtkWidget  *window, const char *info,
  GtkUIManager *merge,  GtkActionGroup *action_group, const char *nome, int ori)
{
  AddUIManager(window, info, merge);
  std::string nome1 = "/";
  nome1.append(nome);
  GtkWidget *toolbar = gtk_ui_manager_get_widget (merge, nome1.c_str());
  g_object_set_data(G_OBJECT(window), "toolbar", toolbar);
  gtk_toolbar_set_style(GTK_TOOLBAR(toolbar), GTK_TOOLBAR_ICONS);
  if(ori== HORIZONTAL)
#ifdef GTK_ORIENTABLE
     gtk_orientable_set_orientation(GTK_ORIENTABLE(toolbar), GTK_ORIENTATION_HORIZONTAL);
#else
     gtk_toolbar_set_orientation(GTK_TOOLBAR(toolbar), GTK_ORIENTATION_HORIZONTAL);
#endif
   else
#ifdef GTK_ORIENTABLE
     gtk_orientable_set_orientation(GTK_ORIENTABLE(toolbar), GTK_ORIENTATION_VERTICAL);
#else
     gtk_toolbar_set_orientation(GTK_TOOLBAR(toolbar), GTK_ORIENTATION_VERTICAL);
#endif
  return toolbar;
}

void AddUIManager(GtkWidget  *window, const char *info, GtkUIManager *merge)
{
  GError *error = NULL;
  if (!gtk_ui_manager_add_ui_from_string (merge, info, -1, &error))
  {
      g_message ("building menu/toolbar failed: %s", error->message);
      g_error_free (error);
  }
}

typedef struct
{
  GtkAction action;
} GenericItemAction;

typedef struct
{
  GtkActionClass parent_class;
} GenericItemActionClass;

G_DEFINE_TYPE(GenericItemAction, generic_item_action, GTK_TYPE_ACTION)
static void generic_item_action_class_init (GenericItemActionClass *myclass);
static void generic_item_action_init (GenericItemAction *action);

#define TYPE_GENERIC_ITEM_ACTION  (generic_item_action_get_type ())

static void generic_item_action_class_init (GenericItemActionClass *myclass)
{
  GTK_ACTION_CLASS (myclass)->toolbar_item_type =  GTK_TYPE_TOOL_ITEM;
}

static void generic_item_action_init (GenericItemAction *action)
{
}

GtkAction *generic_item_action_new (const gchar *name, const gchar *label,
      const gchar *tooltip, const gchar *stock_id)
{
   g_return_val_if_fail (name != NULL, NULL);

   return (GtkAction *)g_object_new (TYPE_GENERIC_ITEM_ACTION,
         "name", name,
         "label", label,
         "tooltip", tooltip,
//         "stock-id", stock_id,
         NULL);
}

GtkActionGroup *CreateActionGroup(GtkWidget  *window, guint n_entries,
      mr_action_entry menu_entries[], const gchar *fathername)
{
  mr_action_entry entry;
  int old_liv, val;
  GSList *bg_group = NULL;
  GtkAction *act;

  old_liv = 0;
  GtkActionGroup *action_group;
  if(get_object(window, "action_group") == NULL)
  {
     action_group = gtk_action_group_new ("AppWindowActions");
     g_object_set_data_full (G_OBJECT (window), "action_group",
           action_group, g_object_unref);
  }
  else
     action_group = (GtkActionGroup *) get_object(window, "action_group");

  for(guint i=0; i<n_entries; i++)
  {
      int tipo =  menu_entries[i].type;
      if(tipo >100)
         tipo -= 100;
      if(!str_white(menu_entries[i].icon) && (tipo != 5) && (tipo != 6)
         && (tipo != 47))
         register_stock_icon(menu_entries[i].icon);
  }

  std::string path_to_action("/");
  path_to_action.append(fathername);
  path_to_action.append("/");
  for(guint i=0; i<n_entries; i++)
  {
       bool to_show = true;
       entry = menu_entries[i];
       if(str_white(entry.name))
          continue;
       if(gtk_action_group_get_action(action_group, entry.name) != NULL)
       {
#ifdef WIP
          g_print("Warning: duplicated action %s\n", entry.name);
#endif
          continue;
       }

       if(entry.type < 0)
       {
           to_show = false;
           entry.type = -entry.type;
       }
       if(entry.type > 100)
       {
           entry.type -= 100;
           GtkWidget *iconw = create_image(entry.icon);
           g_object_set_data (G_OBJECT(window), 
                   g_strdup_printf("icon%s", entry.name), iconw);
       }
       int dlev = old_liv - entry.level;
       if(dlev < 0)
       {
          bg_group = NULL;
          val = 0;
       }
       else
       {
           for(int j=0; j<=dlev; j++)
           {
               size_t found = path_to_action.find_last_of("/");
               if (found!=std::string::npos)
                  path_to_action.erase(found);
           }
       }
       path_to_action.append("/");
       path_to_action.append(entry.name);
//       g_print("%s\n", path_to_action.c_str());
       gpointer data;
       if(entry.cb)
       {
          if(entry.num == -2)
             data = (gpointer) window;
          else if(entry.num == -1)
             data = (gpointer) entry.name;
          else
             data = GINT_TO_POINTER(entry.num);
       }
       switch(entry.type)
       {
       case 1:
       case 80:
            act = gtk_action_new(entry.name, entry.string, entry.tip,
                                 entry.icon);
            g_object_set_data (G_OBJECT (window), entry.name,act);
            break;

       case 2:
            act = (GtkAction *)gtk_radio_action_new(entry.name, entry.string,
                        entry.tip, entry.icon, val);
            val++;
            gtk_radio_action_set_group(GTK_RADIO_ACTION(act), bg_group);
            bg_group = gtk_radio_action_get_group(GTK_RADIO_ACTION(act));
            break;

       case 3:
            act = (GtkAction *)gtk_toggle_action_new(entry.name, entry.string,
                        entry.tip, entry.icon);
            gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(act), entry.stato);
            break;

       case 4:
            break;

       default:
       case 5:
       case 6:
       case 12:
       case 13:
       case 47:
       case 50:
       case 52:
       case 7:
       case 8:
            act = generic_item_action_new(entry.name, entry.string, entry.tip,
                                 NULL);
            break;
       }
       g_object_set_data (G_OBJECT (window), entry.name,act);
       g_object_set_data (G_OBJECT (act), "mainwindow", window);
       if(entry.accel != NULL)
          gtk_action_group_add_action_with_accel(action_group, act, entry.accel);
       else
          gtk_action_group_add_action(action_group, act);
       g_object_set_data(G_OBJECT(act), "path", g_strdup(path_to_action.c_str()));

       if((entry.type < 4) && (entry.cb))
       {
            int hnd = g_signal_connect( G_OBJECT(act), "activate",
                        G_CALLBACK(entry.cb), data);
            g_object_set_data(G_OBJECT(act), "hnd", GINT_TO_POINTER(hnd));
       }
       gtk_action_set_sensitive(act, entry.abi);
       gtk_action_set_visible(act, to_show);
       g_object_unref(act);
       old_liv = entry.level;
  }
  return action_group;
}
#endif

void obj_activate(gpointer w)
{
   if(w == NULL)
      return;
#ifdef USE_ACTIONS
   if(GTK_IS_ACTION(w))
   {
      gtk_action_set_sensitive(GTK_ACTION(w), TRUE);
      gtk_action_activate(GTK_ACTION(w));
      return;
   }
#endif
   if(GTK_IS_MENU_ITEM(w))
      gtk_menu_item_activate(GTK_MENU_ITEM(w));
}

gboolean obj_get_active(gpointer w)
{
   if(w == NULL)
      return FALSE;
#ifdef USE_ACTIONS
   if(GTK_IS_ACTION(w))
      return gtk_toggle_action_get_active(GTK_TOGGLE_ACTION(w));
#endif
   if(GTK_IS_MENU_ITEM(w))
      return gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(w));
#ifdef USE_TOOLBAR
   if(GTK_IS_TOGGLE_TOOL_BUTTON(w))
      return gtk_toggle_tool_button_get_active(GTK_TOGGLE_TOOL_BUTTON(w));
#endif
   if(GTK_IS_TOGGLE_BUTTON(w))
      return gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(w));
   return FALSE;
}

void obj_set_label(gpointer w, const gchar *str)
{
   if(w == NULL)
      return;
#ifdef USE_ACTIONS
   if(GTK_IS_ACTION(w))
   {
      gtk_action_set_label(GTK_ACTION(w),  str);
      return;
   }
#endif
   if(GTK_IS_MENU_ITEM(w))
   {
      if(gtk_menu_item_get_label(GTK_MENU_ITEM(w)) != NULL)
         gtk_menu_item_set_label(GTK_MENU_ITEM(w), str);
      else
         gtk_label_set_text(GTK_LABEL(get_widget(GTK_WIDGET(w), "label")), str);
   }
}

#ifdef USE_ACTIONS
void set_tooltips_on_menu(GtkWidget *top, guint n_entries,
                          mr_action_entry menu_entries[])
{
  GtkActionGroup *ag = (GtkActionGroup *) get_object(top, "action_group");
  for(guint i=0; i<n_entries; i++)
  {
       mr_action_entry entry = menu_entries[i];
       if(str_white(entry.name))
          continue;
       GtkAction *act = gtk_action_group_get_action(ag, entry.name);
       if(act != NULL)
       {
          GtkWidget *item = get_widget_from_action(act, top);
          if(GTK_IS_WIDGET(item))
             set_tip (item, entry.tip);
       }
  }
}

GtkWidget *get_widget_from_action(GtkAction *act, GtkWidget *top)
{
   if(top == NULL)
      top = GTK_WIDGET(g_object_get_data(G_OBJECT(act), "mainwindow"));

   gchar *nome = (gchar *)g_object_get_data(G_OBJECT(act), "path");
   GtkUIManager *merge = (GtkUIManager *) get_object(top, "ui-manager");
   GtkWidget *widget =  gtk_ui_manager_get_widget(merge, nome);
   if((widget != NULL) && (GTK_IS_MENU_ITEM(widget) ||GTK_IS_TOOL_ITEM(widget)))
      return widget;
   else
      g_print("Warning. Item not found: %s\n", nome);
   return NULL;
}

GtkAction *get_action_from_widget(GtkWidget *w, GtkWidget *top)
{
   const gchar *nome = gtk_widget_get_name(w);
   GtkActionGroup *ag = (GtkActionGroup *) get_object(top, "action_group");
   return gtk_action_group_get_action(ag, nome);
}

#endif

const gchar *obj_get_label(gpointer w)
{
   if(w == NULL)
      return " ";
#ifdef USE_ACTIONS
   if(GTK_IS_ACTION(w))
   {
      return gtk_action_get_label(GTK_ACTION(w));
   }
#endif
   if(GTK_IS_MENU_ITEM(w))
   {
      if(gtk_menu_item_get_label(GTK_MENU_ITEM(w)) != NULL)
         return gtk_menu_item_get_label(GTK_MENU_ITEM(w));
      else
         return gtk_label_get_text(GTK_LABEL(get_widget(GTK_WIDGET(w), "label")));
   }
//   if(GTK_IS_MENU_ITEM(w))
//      return gtk_label_get_text(GTK_LABEL(gtk_bin_get_child(GTK_BIN(w))));
   return " ";
}

gboolean  obj_get_visible(gpointer w)
{
   if(w == NULL)
      return FALSE;
#ifdef USE_ACTIONS
   if(GTK_IS_ACTION(w))
      return gtk_action_get_visible(GTK_ACTION(w));
#endif
   if(GTK_IS_WIDGET(w))
      return gtk_widget_get_visible(GTK_WIDGET(w));
   return FALSE;
}

void obj_set_visible(gpointer w, gboolean vis)
{
   if(w == NULL)
      return;
#ifdef USE_ACTIONS
   if(GTK_IS_ACTION(w))
   {
      gtk_action_set_visible(GTK_ACTION(w), vis);
      return;
   }
#endif
   if(GTK_IS_WIDGET(w))
   {
      if(vis)
         gtk_widget_show(GTK_WIDGET(w));
      else
         gtk_widget_hide(GTK_WIDGET(w));
   }
}

void obj_show(gpointer w)
{
     obj_set_visible(w, TRUE);
}

void obj_hide(gpointer w)
{
     obj_set_visible(w, FALSE);
}

void obj_set_active(gpointer w, gboolean act, bool ifBlock)
{
   if(w == NULL)
      return;
#ifdef USE_ACTIONS
   if(GTK_IS_ACTION(w))
   {
      int hnd = get_int(w, "hnd");
      if(ifBlock && hnd)
         g_signal_handler_block(G_OBJECT(w), hnd);
      else if(ifBlock)
         gtk_action_block_activate(GTK_ACTION(w));
      gtk_toggle_action_set_active(GTK_TOGGLE_ACTION(w), act);
      if(ifBlock && hnd)
         g_signal_handler_unblock(G_OBJECT(w), hnd);
      else if(ifBlock)
         gtk_action_unblock_activate(GTK_ACTION(w));
      return;
   }
#endif
   int hnd = get_int(w, "hnd");
   if(ifBlock)
      g_signal_handler_block(G_OBJECT(w), hnd);

   if(GTK_IS_MENU_ITEM(w))
      gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(w), act);
#ifdef USE_TOOLBAR
   if(GTK_IS_TOGGLE_TOOL_BUTTON(w))
      gtk_toggle_tool_button_set_active(GTK_TOGGLE_TOOL_BUTTON(w), act);
#endif
   if(GTK_IS_TOGGLE_BUTTON(w))
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w), act);
   if(ifBlock)
      g_signal_handler_unblock(G_OBJECT(w), hnd);
}

void obj_set_sensitive(gpointer w, gboolean sens)
{
   if(w == NULL)
      return;
#ifdef USE_ACTIONS
   if(GTK_IS_WIDGET(w))
      gtk_widget_set_sensitive(GTK_WIDGET(w), sens);
   else if(GTK_IS_ACTION(w))
      gtk_action_set_sensitive(GTK_ACTION(w), sens);
#else
   if(GTK_IS_WIDGET(w))
      gtk_widget_set_sensitive(GTK_WIDGET(w), sens);
#endif
}

gboolean obj_get_sensitive(gpointer w)
{
   gboolean sens = FALSE;
   if(w == NULL)
      return sens;
#ifdef USE_ACTIONS
   if(GTK_IS_WIDGET(w))
      sens = gtk_widget_get_sensitive(GTK_WIDGET(w));
   else if(GTK_IS_ACTION(w))
      sens = gtk_action_get_sensitive(GTK_ACTION(w));
#else
   if(GTK_IS_WIDGET(w))
      sens = gtk_widget_get_sensitive(GTK_WIDGET(w));
#endif
   return sens;
}

gboolean  RefreshWelcomeMessage(gpointer data)
{
  Re_data *re_data = (Re_data *) data;
  GtkWidget *statusbar = re_data->statusbar;
  const char *msg = re_data->msg;
  AddWelcomeMessage(statusbar, msg);
  return TRUE;
}

void AddWelcomeMessage(GtkWidget *statusbar, const char *msgdefault)
{
     struct tm newtime;
     gchar *Msg;

     OraCorrente(&newtime);

     if((newtime.tm_hour >= 14) && (newtime.tm_hour < 18))
        Msg = g_strdup_printf("Good afternoon, %s. %s",g_get_user_name(),
          msgdefault);
     else if((newtime.tm_hour >= 18) && (newtime.tm_hour <= 23))
        Msg = g_strdup_printf("Good evening, %s. %s",g_get_user_name(),
          msgdefault);
     else if(newtime.tm_hour >= 3)
        Msg = g_strdup_printf("Good morning, %s. %s",g_get_user_name(),
          msgdefault);
     else
        Msg = g_strdup_printf("Good night, %s. %s",g_get_user_name(),
          msgdefault);
     (void) gtk_statusbar_push(GTK_STATUSBAR(statusbar), 1, Msg);
     g_free(Msg);
}

#if GTK_MAJOR_VERSION >= 3
GdkPixbuf *pix_from_file_and_text(const char *file, char *text,
                                  PangoFontDescription *fontdesc,
                                  int x, int y, GdkColor *col, GtkWidget *wid)
{
    int w, h;
    gchar *pathname = find_pixmap_file (file);   
    cairo_surface_t *image = cairo_image_surface_create_from_png (pathname);
    drawable_get_size(image, &w, &h);
    if(x < 0)
       x = w + x;
    if(y < 0)
       y = h + y;
    if(image == NULL)
       return NULL;
    cairo_t *cr = cairo_create(image);
    if(text != NULL)
       draw_string(NULL, fontdesc, (gpointer) cr, x, y, text, col, NULL);
    GdkPixbuf *pix = gdk_pixbuf_get_from_surface(image, 0, 0, w, h);
    return pix;
}
#else
GdkPixbuf *pix_from_file_and_text(const char *file, char *text,
                                  PangoFontDescription *fontdesc,
                                  int x, int y, GdkColor *col, GtkWidget *wid)
{
    GdkPixmap *gdk_pixmap;
    GdkBitmap *mask;
    int w, h;
    gdk_pixmap = mr_load_pixmap_withmask (wid, file, &mask);
    if(gdk_pixmap == NULL)
       return NULL;
#ifdef HAVE_DRAWABLE
  gdk_drawable_get_size(GDK_DRAWABLE(gdk_pixmap), &w, &h);
#else
  gdk_pixmap_get_size(gdk_pixmap, &w, &h);
#endif
    if(x < 0)
       x = w + x;
    if(y < 0)
       y = h + y;
    if(text != NULL)
       draw_string(gdk_pixmap, fontdesc, gdk_gc_new(GDK_DRAWABLE(gdk_pixmap)),
          x, y, text, col, NULL);
    GdkPixbuf *dest = gdk_pixbuf_get_from_drawable (NULL, gdk_pixmap,
                      gdk_colormap_get_system(), 
                      0,0, 0, 0, -1, -1);       
    g_object_unref(gdk_pixmap);
    g_object_unref(G_OBJECT(mask));
    return dest;
}
#endif

#ifdef CAIRO_VERSION

#ifdef CAIRO_HAS_IMAGE_SURFACE
guchar toGdk_color_channel(guchar src, guchar alpha)
{
	return alpha ? ((src << 8) - src) / alpha : 0;
}

GdkPixbuf * fromCairoToPixbuf (cairo_surface_t *surface)
{
   GdkPixbuf *pixbuf;
   int width, height;
   int srcstride, dststride;
   guchar *srcpixels, *dstpixels;
   guchar *srcpixel, *dstpixel;
   int n_channels;

   width = cairo_image_surface_get_width (surface);
   height = cairo_image_surface_get_height (surface);
   srcstride = cairo_image_surface_get_stride (surface);
   srcpixels = cairo_image_surface_get_data (surface);
   pixbuf = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, width, height);
   dststride = gdk_pixbuf_get_rowstride (pixbuf);
   dstpixels = gdk_pixbuf_get_pixels (pixbuf);
   n_channels = gdk_pixbuf_get_n_channels (pixbuf);

   for (int y = 0; y < height; y++)
   {
      for (int x = 0; x < width; x++)
      {
         srcpixel = srcpixels + y * srcstride + x * 4;
         dstpixel = dstpixels + y * dststride + x * n_channels;
         dstpixel[0] = toGdk_color_channel(srcpixel[2], srcpixel[3]);
         dstpixel[1] = toGdk_color_channel(srcpixel[1], srcpixel[3]);
         dstpixel[2] = toGdk_color_channel(srcpixel[0], srcpixel[3]);
         dstpixel[3] = srcpixel[3];
      }
   }
   return pixbuf;
}

GdkPixbuf *create_rect(float colore[])
{
     cairo_surface_t *surface = cairo_image_surface_create(CAIRO_FORMAT_ARGB32,
                                 16, 16);
     cairo_t *cr = cairo_create(surface);

     cairo_set_source_rgb (cr, colore[0], colore[1], colore[2]);
     cairo_rectangle(cr, 2, 2, 12, 12);
     cairo_fill(cr);
     if(surface == NULL)
        return NULL;
     GdkPixbuf *pixb;
#if GTK_MAIOR_VERSION > 2
     pixb = gdk_pixbuf_get_from_surface (surface, 0, 0, 16, 16);
#else
     pixb = fromCairoToPixbuf (surface);
#endif
     cairo_surface_destroy(surface);
     cairo_destroy(cr);
     return pixb;
}

#else

GdkPixbuf *create_rect(float colore[])
{
    GdkPixmap *pix =  gdk_pixmap_new(NULL, 16, 16, 24);

    cairo_t *cr = gdk_cairo_create(pix);
    cairo_set_source_rgb (cr, 0, 0, 0);
    cairo_rectangle(cr, 0, 0, 16, 16);
    cairo_fill(cr);
    cairo_set_source_rgb (cr, colore[0], colore[1], colore[2]);
    cairo_rectangle(cr, 2, 2, 12, 12);
    cairo_fill(cr);
    GdkPixbuf *pixb = gdk_pixbuf_get_from_drawable (NULL, pix,
         gdk_colormap_get_system(), 0, 0, 0, 0, 16, 16);
    g_object_unref(pix);
    GdkPixbuf *dest = gdk_pixbuf_add_alpha(pixb, TRUE, 0, 0, 0);
    g_object_unref(pixb);
    cairo_destroy(cr);
    return dest;
}
#endif

void rounded_rectangle(cairo_t *cr, double x, double y, double width,
                      double height, double radius, GdkColor colore)
{
    double rad = M_PI / 180.0;
#ifdef HAVE_SUBPATH
    cairo_new_sub_path (cr);
#else
    cairo_move_to (cr, x , y );
#endif
    cairo_arc (cr, x + width - radius, y + radius, radius, -90 * rad, 0 * rad);
    cairo_arc (cr, x + width - radius, y + height - radius, radius, 0 * rad, 90 * rad);
    cairo_arc (cr, x + radius, y + height - radius, radius, 90 * rad, 180 * rad);
    cairo_arc (cr, x + radius, y + radius, radius, 180 * rad, 270 * rad);
    cairo_close_path (cr);
    float *color = ToColor3f(&colore);
    cairo_pattern_t *pat = cairo_pattern_create_linear (x, y, x, y+height);
    cairo_pattern_add_color_stop_rgba (pat, 0, 1, 1, 1, 1);
    cairo_pattern_add_color_stop_rgba (pat, 0.6, color[0], color[1], color[2], 1);
    Darker(color);
    cairo_set_source (cr, pat);
    cairo_fill_preserve (cr);
    cairo_set_source_rgb (cr, color[0], color[1], color[2]);
    cairo_set_line_width (cr, 1.5);
    cairo_stroke (cr);
}

void DrawButton(GtkWidget *widget, gpointer context=NULL)
{
    if(gtk_widget_get_window(widget) == NULL)
       return;
    if( !gtk_widget_get_realized(widget) )
       return;
    guint16 red = (guint16) get_int(widget, "red");
    guint16 green = (guint16) get_int(widget, "green");
    guint16 blue = (guint16) get_int(widget, "blue");
    GdkColor colore = {0, red, green, blue};

    cairo_t *cr;
    bool created_cairot = true;
    GtkAllocation allocation;
    gtk_widget_get_allocation(widget, &allocation);
#if GTK_MAJOR_VERSION >= 3
    if(context != NULL)
    {
       cr = (cairo_t *) context;
       created_cairot = false;
    }
    else
    {
       cairo_surface_t *surface = gdk_window_create_similar_surface
            (gtk_widget_get_window (widget),
            CAIRO_CONTENT_COLOR,
            allocation.width,
            allocation.height);
       cr = cairo_create(surface);
    }
#else
       cr = gdk_cairo_create (gtk_widget_get_window(widget));
#endif
    double x = 0,
           y = 0,
           width  = allocation.width - 4,
           height = allocation.height - 4,
           radius = 4.0;

    rounded_rectangle(cr, x, y, width, height, radius, colore);
    GdkColor bg = { 0, 0, 0, 0 };             // Black.
    const char *label = (const char *) get_object(widget, "label");
    if(label)
       draw_string(NULL, DefaultFont(), (gpointer) cr, 4, 4,
               label, &bg, NULL, PANGO_ALIGN_CENTER);
    if(created_cairot)
       cairo_destroy(cr);
}
#else
GdkPixbuf *create_rect(float colore[])
{
    GdkPixmap *pix =  gdk_pixmap_new(NULL, 16, 16, 24);
    GdkGC *gc  =  gdk_gc_new(pix);
    GdkColor *c1 = ToGdkColor(colore);
    GdkColor bg = { 0, 0, 0, 0 };             // Black.
    gdk_gc_set_rgb_fg_color(gc, &bg);
    gdk_draw_rectangle (pix, gc, TRUE, 0, 0, 16, 16);
    gdk_gc_set_rgb_fg_color(gc, c1);
    gdk_draw_rectangle (pix, gc, TRUE, 2, 2, 12, 12);
    GdkPixbuf *pixb = gdk_pixbuf_get_from_drawable (NULL, pix,
         gdk_colormap_get_system(), 0, 0, 0, 0, 16, 16);
    g_object_unref(pix);
    GdkPixbuf *dest = gdk_pixbuf_add_alpha(pixb, TRUE, 0, 0, 0);
    g_object_unref(pixb);
    return dest;
}

#endif

void mycolor_button_get_color(GtkWidget *button, float *colore)
{
     colore[0] = (float) get_int(button, "red") / 65535.f;
     colore[1] = (float) get_int(button, "green") / 65535.f;
     colore[2] = (float) get_int(button, "blue") / 65535.f;
     colore[3] = (float) get_int(button, "alpha") / 65535.f;
}

void mycolor_button_set_color(GtkWidget *button, const float *colore)
{
     g_object_set_data(G_OBJECT(button), "red",
          GINT_TO_POINTER((int)(65535.*colore[0])));
     g_object_set_data(G_OBJECT(button), "green",
          GINT_TO_POINTER((int)(65535.*colore[1])));
     g_object_set_data(G_OBJECT(button), "blue",
          GINT_TO_POINTER((int)(65535.*colore[2])));
     g_object_set_data(G_OBJECT(button), "alpha",
          GINT_TO_POINTER((int)(65535.*colore[3])));
#ifdef CAIRO_VERSION
     DrawButton(button);
     widget_modify_fg(button, GTK_STATE_NORMAL, colore);
#else
     GdkColor *gdkCol = ToGdkColor(colore);
     set_widget_color(button, gdkCol);
#endif
}

GtkWidget *color_dialog(const char *title, GtkWidget *parent)
{
#ifdef GTK_COLOR_CHOOSER
    return gtk_color_chooser_dialog_new(title, GTK_WINDOW(parent));
#else
    return gtk_color_selection_dialog_new(title);
#endif
}

GtkWidget *color_widget(GtkWidget *dialog)
{
#ifdef GTK_COLOR_CHOOSER
     return dialog;
#else
     return gtk_color_selection_dialog_get_color_selection(
                      (GtkColorSelectionDialog *) dialog);
#endif
}

void set_current_color(GtkWidget *csw, float color[])
{
#ifdef GTK_COLOR_CHOOSER
     GdkRGBA rgbaCol = {color[0], color[1], color[2], color[3]};
     gtk_color_chooser_set_rgba(GTK_COLOR_CHOOSER(csw), &rgbaCol);
#else
     GdkColor gdkcolor;
     gdkcolor.pixel = 0;
     gdkcolor.red   = (guint16)(color[0] * 65535);
     gdkcolor.green = (guint16)(color[1] * 65535);
     gdkcolor.blue  = (guint16)(color[2] * 65535);
     gtk_color_selection_set_current_color(GTK_COLOR_SELECTION(csw),
                       &gdkcolor);
#endif
}

void get_current_color(GtkWidget *csw, float color[])
{
#ifdef GTK_COLOR_CHOOSER
     GdkRGBA rgbaCol;
     gtk_color_chooser_get_rgba(GTK_COLOR_CHOOSER(csw), &rgbaCol);
     color[0] = (float) rgbaCol.red;
     color[1] = (float) rgbaCol.green;
     color[2] = (float) rgbaCol.blue;
     color[3] = (float) rgbaCol.alpha;
#else
     GdkColor gdkcolor;
     gtk_color_selection_get_current_color(GTK_COLOR_SELECTION(csw),
                       &gdkcolor);
     float *col1 = ToColor3f(&gdkcolor);
     for(int i=0; i<3; i++)
         color[i] = col1[i];
     color[3] = 1;
#endif
}

void open_csd(GtkWidget *button, gpointer data)
{
     const char *title = (const char *) data;
     GtkWidget *dlg = color_dialog(title, gtk_widget_get_toplevel(button));

     GtkWidget *csw = color_widget(dlg);
     float color[4];
     color[0] = (float) get_int(button, "red") / 65535.f;
     color[1] = (float) get_int(button, "green") / 65535.f;
     color[2] = (float) get_int(button, "blue") / 65535.f;
     color[3] = (float) get_int(button, "alpha") / 65535.f;
     set_current_color(csw, color);
     int result = gtk_dialog_run(GTK_DIALOG(dlg));
     if (result == GTK_RESPONSE_OK)
     {
         float colore[4];
         get_current_color(csw, colore);
         mycolor_button_set_color(button, colore);
     }
     gtk_widget_destroy(dlg);
}

void open_csd1(GtkWidget *button, GdkEvent *, gpointer data)
{
     open_csd(button, data);
}

#ifdef CAIRO_VERSION
static gboolean button_expose_event (GtkWidget *widget, gpointer context,
                             gpointer )
{
   DrawButton(widget, context);
   return TRUE;
}
#endif

GtkWidget *mycolor_button(const float *colore, const char *title,
     GCallback cb, gpointer data, const char *label)
{
    GtkWidget *button = gtk_event_box_new ();
    if(label == NULL)
       gtk_widget_set_size_request(button, 22, 22);
    else
       gtk_widget_set_size_request(button, 36, 30);
    g_object_set_data(G_OBJECT(button), "pix", button);
    gtk_widget_set_events(button, GDK_BUTTON_PRESS_MASK | GDK_EXPOSURE_MASK);
    if(cb != NULL)
       g_signal_connect (G_OBJECT (button), "button_press_event",
                      cb, data);
    else
       g_signal_connect (G_OBJECT (button), "button_press_event",
                      G_CALLBACK (open_csd1), (gpointer) title);
#ifdef CAIRO_VERSION
    if(label != NULL)
       g_object_set_data(G_OBJECT (button), "label", g_strdup(label));
    g_signal_connect (G_OBJECT (button), DRAW_EVENT,
                    G_CALLBACK (button_expose_event),  NULL);
#endif
    mycolor_button_set_color(button, colore);
    return button;
}

GtkWidget *color_button(const float color[], const char *title)
{
#ifdef GTK_COLOR_CHOOSER
     GdkRGBA rgbaCol = {(double)color[0], (double)color[1],
                        (double)color[2], (double)color[3]};
    GtkWidget *button = gtk_color_button_new_with_rgba(&rgbaCol);
    gtk_color_button_set_title(GTK_COLOR_BUTTON(button), title);
    return button;
#elif defined (GTK_COLOR_BUTTON)
    GdkColor *colore = ToGdkColor(color);
    GtkWidget *button = gtk_color_button_new_with_color(colore);
    gtk_color_button_set_title(GTK_COLOR_BUTTON(button), title);
    return button;
#else
    return mycolor_button(color, title);
#endif
}

void color_button_get_color(GtkWidget *button, float color[])
{
#ifdef GTK_COLOR_CHOOSER
     GdkRGBA col1;
     gtk_color_chooser_get_rgba(GTK_COLOR_CHOOSER(button), &col1);
     color[0] = (float) col1.red;
     color[1] = (float) col1.green;
     color[2] = (float) col1.blue;
     color[3] = (float) col1.alpha;
#else
     GdkColor gdkcolor;
#ifdef GTK_COLOR_BUTTON
     gtk_color_button_get_color(GTK_COLOR_BUTTON(button), &gdkcolor);
#else
     gdkcolor.red = (guint16) get_int(button, "red");
     gdkcolor.green = (guint16) get_int(button, "green");
     gdkcolor.blue = (guint16) get_int(button, "blue");
#endif
     float *c = ToColor3f(&gdkcolor);
     for(int i=0; i<3; i++)
        color[i] = c[i];
     color[3] = 1;
#endif
}

void color_button_set_color(GtkWidget *button, const float color[])
{
#ifdef GTK_COLOR_CHOOSER
     GdkRGBA rgbaCol = {(double)color[0], (double)color[1],
                        (double)color[2], (double)color[3]};
     gtk_color_chooser_set_rgba(GTK_COLOR_CHOOSER(button),&rgbaCol);
#elif defined (GTK_COLOR_BUTTON)
     GdkColor *colore = ToGdkColor(color);
     gtk_color_button_set_color(GTK_COLOR_BUTTON(button),colore);
#else
     mycolor_button_set_color(button, color);
#endif
}

const char *font_button_get_font_name(GtkWidget *button)
{
#ifdef GTK_FONT_BUTTON
     return gtk_font_button_get_font_name(GTK_FONT_BUTTON(button));
#else
     return myfont_button_get_font_name(button);
#endif
}

#ifndef GTK_FONT_BUTTON
void open_fsd(GtkWidget *button, gpointer data)
{
     const char *fontname = (const char *) data;
     GtkWidget *dlg = gtk_font_selection_dialog_new ("Select font");
     gtk_font_selection_dialog_set_font_name ((GtkFontSelectionDialog *)dlg,
                                             fontname);
     int result = gtk_dialog_run(GTK_DIALOG(dlg));
     if (result == GTK_RESPONSE_OK)
     {
         const char *name = gtk_font_selection_dialog_get_font_name(GTK_FONT_SELECTION_DIALOG(dlg));
         if(name)
            g_object_set_data(G_OBJECT(button), "fontname", g_strdup(name));
     }
     gtk_widget_destroy(dlg);
}

const char *myfont_button_get_font_name(GtkWidget *button)
{
    return get_string(button, "fontname");
}

void myfont_button_set_font_name(GtkWidget *button, const char *fontname)
{
    g_object_set_data(G_OBJECT(button), "fontname", g_strdup(fontname));
    int hnd = get_int(button, "hnd");
    if(hnd)
       g_signal_handler_disconnect(G_OBJECT(button), hnd);
    hnd = g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(open_fsd), (gpointer) fontname);
    g_object_set_data(G_OBJECT(button), "hnd", GINT_TO_POINTER(hnd));
}

GtkWidget *myfont_button(const char *fontname)
{
    GtkWidget *button = image_button("font.png");
    g_object_set_data(G_OBJECT(button), "fontname", g_strdup(fontname));
    int hnd = g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(open_fsd), (gpointer) fontname);
    g_object_set_data(G_OBJECT(button), "hnd", GINT_TO_POINTER(hnd));
    return button;
}
#endif

void font_button_set_font_name(GtkWidget *button, const char *fontname)
{
#ifdef GTK_FONT_BUTTON
     gtk_font_button_set_font_name(GTK_FONT_BUTTON(button), fontname);
#else
     myfont_button_set_font_name(button, fontname);
#endif
}

GtkWidget *font_button(const char *fontname)
{
#ifdef GTK_FONT_BUTTON
    GtkWidget *button = gtk_font_button_new_with_font(fontname);
    return button;
#else
    return myfont_button(fontname);
#endif
}

int MY_MAJOR_VERSION(std::string version)
{
using namespace std;
    size_t i = version.find_first_of('.');
    if(i != string::npos)
    {
       stringstream is;
       is.str(version.substr(0, i));
       int mjv;
       is >> mjv;
       return mjv;
    }
    return 0;
}

int MY_MINOR_VERSION(std::string version)
{
using namespace std;
    size_t i = version.find_first_of('.');
    if(i != string::npos)
    {
       size_t k = version.find_last_of('.');
       if(k != string::npos)
       {
          stringstream is;
          is.str(version.substr(i+1, k-i-1));
          int mjv;
          is >> mjv;
          return mjv;
       }
    }
    return 0;
}

int MY_MICRO_VERSION(std::string version)
{
using namespace std;
    size_t i = version.find_last_of('.');
    if(i != string::npos)
    {
       stringstream is;
       is.str(version.substr(i+1));
       int mcv;
       is >> mcv;
       return mcv;
    }
    return 0;
}

void dlg_warning(const gchar *fmt, ...)
{
    gchar *msg;
    va_list lst;
    va_start(lst, fmt);
    msg = g_strdup_vprintf(fmt, lst);
    va_end(lst);
    gtk_init(NULL, NULL);

    GtkWidget *dialog = gtk_message_dialog_new (NULL,
         GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING,
         GTK_BUTTONS_CLOSE, "%s", msg);
    gtk_dialog_run (GTK_DIALOG (dialog));
    gtk_widget_destroy (dialog);

    g_free(msg);
}

int MY_NUM_VERSION(std::string version)
{
using namespace std;
    int i1 = MY_MAJOR_VERSION(version);
    int i2 = MY_MINOR_VERSION(version);
    int i3 = MY_MICRO_VERSION(version);
    stringstream os;
    os << setw(2) << right << setfill('0');
    os << i1 << i2 <<i3;
    int nv;
    os >> nv;
    return nv;
}

void remove_children(GtkWidget *parent)
{
    GList *children = gtk_container_get_children(GTK_CONTAINER(parent));
     int n_children = g_list_length(children);
     for(int i=0; i<n_children; i++)
         gtk_container_remove(GTK_CONTAINER(parent), (GtkWidget *)g_list_nth_data(children, i));
}

bool dlgest_yesno(GtkWindow *parent, const gchar *fmt, ...)
{
    gchar *msg;
    gint response;
    va_list lst;
    va_start(lst, fmt);
    msg = g_strdup_vprintf(fmt, lst);
    va_end(lst);
    gtk_init(NULL, NULL);
    response = MessageDialog(GTK_WIDGET(parent), GTK_MESSAGE_QUESTION,
        GTK_BUTTONS_YES_NO, msg);
    g_free(msg);
    return response == GTK_RESPONSE_YES;
}

static GtkWidget *win_main;

void set_win_main(GtkWidget *win)
{
    win_main = win;
}

void set_tip(GtkWidget *widget, const char *tip)
{
#ifndef GTK_TOOLTIP
    GtkTooltips *tt = (GtkTooltips *)lookup_object(win_main, "tt");
    gtk_tooltips_set_tip (tt, widget, tip, tip);
#else
    gtk_widget_set_tooltip_text(widget, tip);
#endif
}

void set_smil_tip(GtkWidget *widget, const char *tip)
{
#ifndef GTK_TOOLTIP
    GtkTooltips *tt = (GtkTooltips *)lookup_object(win_main, "smilett");
    gtk_tooltips_set_tip (tt, widget, tip, tip);
#else
    gtk_widget_set_tooltip_text(widget, tip);
#endif
}

void enable_tip(GtkWidget *widget, gboolean status)
{
#ifndef GTK_TOOLTIP
    GtkTooltips *tt = (GtkTooltips *)lookup_object(win_main, "smilett");
    if(status)
       gtk_tooltips_enable (tt);
    else
       gtk_tooltips_disable (tt);
#else
    gtk_widget_set_has_tooltip(widget, status);
#endif
}

GtkWidget *new_combo()
{
   GtkWidget *combo;
   combo = combo_box_new();
#ifndef GTK_COMBO_BOX
   g_object_set_data (G_OBJECT(combo), "entry", GTK_COMBO(combo)->entry);
#elif defined(GTK_COMBO_BOX_TEXT)
   g_object_set_data (G_OBJECT(combo), "entry", combo);
#else
   g_object_set_data (G_OBJECT(combo), "entry", combo);
#endif 
   return combo;
}

float *ToColor3f(const GdkColor *gdkcolor)
{
    float *color = g_new0(float, 3);
    color[0] = (float)gdkcolor->red   / 65535.f;
    color[1] = (float)gdkcolor->green / 65535.f;
    color[2] = (float)gdkcolor->blue  / 65535.f;
    return color;
}
 
float *ToColor4f(const GdkColor *gdkcolor)
{
    float *color = g_new0(float, 4);
    color[0] = (float)gdkcolor->red   / 65535.f;
    color[1] = (float)gdkcolor->green / 65535.f;
    color[2] = (float)gdkcolor->blue  / 65535.f;
    color[3] = 1;
    return color;
}
 
GdkColor *ToGdkColor(const float color[])
{
    GdkColor *gdkcolor = g_new0(GdkColor, 1);
    gdkcolor->pixel = 0;
    gdkcolor->red   = (guint16)(color[0] * 65535);
    gdkcolor->green = (guint16)(color[1] * 65535);
    gdkcolor->blue  = (guint16)(color[2] * 65535);
    return gdkcolor;
}

#if GTK_MAJOR_VERSION >= 3
void RGBAToGdk(GdkRGBA color_rgba, GdkColor *gdkcolor)
{
  double color[] = {color_rgba.red, color_rgba.green, color_rgba.blue};
  gdkcolor->pixel = 0;
  gdkcolor->red   = (guint16)(color[0] * 65535);
  gdkcolor->green = (guint16)(color[1] * 65535);
  gdkcolor->blue  = (guint16)(color[2] * 65535);
}
#endif

void ShowWaitCursor(GtkWidget *window)
{
      GdkCursor *wait_cursor = gdk_cursor_new_for_display(
               gdk_display_get_default(), GDK_WATCH);
      gdk_window_set_cursor(gtk_widget_get_window(window),wait_cursor);
      while(gtk_events_pending())
            (void) gtk_main_iteration();
}

void HideWaitCursor(GtkWidget *window)
{
      gdk_window_set_cursor(gtk_widget_get_window(window),NULL);
}

#ifndef _WIN32
gboolean licence_txt(const char *filnam, const char *str)
{
using namespace std;
char *c = new char [512];
    cout << str << "\nPress return to continue ";
    cin.read(c, 1);
    std::ifstream ff;
    ff.open(filnam, std::ios::in);
    if( !ff.is_open() || !ff )
    {
        cout << "Licence file not found.\n ";
        return false;
    }
//    while( !ff.eof() )
//    {
//       ff.getline(c, 512);
//       cout << c << "\n";
//    }
    ff.close();
    std::string cmd = "more ";
    cmd.append(filnam);
    int ier = system(cmd.c_str());
    if(ier == -1)
       return false;
    cout << "\nDo you accept the terms of this licence agreement? (Y/n) ";
    cin.read(c, 1);
    bool result = false;
    if((c[0] != 'N') && (c[0] != 'n'))
        result = true;

    delete [] c;
    return result;
}

void ok_licence(GtkWidget , gpointer)
{
  gtk_main_quit();
}

gboolean licence_dialog(std::string pkgdir)
{
  std::string nome;
  nome = g_path_get_dirname(pkgdir.c_str());
  nome.append(G_DIR_SEPARATOR_S);
  nome.append("files");
  nome.append(G_DIR_SEPARATOR_S);
  nome.append("licence.txt");

  const char *str ="Please read the following License Agreement. \nYou must "
                   "accept the terms of this agreement before continuing.";
                   
  if(!gtk_init_check(NULL, NULL))
  {
     g_print("GUI cannot be inizialized\n");
     return licence_txt(nome.c_str(), str);
  }
  //GtkWidget *dlg = gtk_dialog_new();
  GtkWidget *dlg = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (dlg), "License Agreement");
  gtk_container_set_border_width (GTK_CONTAINER (dlg), 8);

  //GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
  GtkWidget *vbox = vbox_new(FALSE, 0);
  gtk_container_add (GTK_CONTAINER (dlg), vbox);

  GtkWidget *label = LABEL_NEW(str, MyBLUE);
  gtk_label_set_line_wrap (GTK_LABEL(label), TRUE);
  gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 20);

  GtkWidget *frame = gtk_frame_new(NULL);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 20);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);

  GtkWidget *scrollwin = gtk_scrolled_window_new( NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                  GTK_POLICY_AUTOMATIC,
                                  GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrollwin); 
  gtk_container_add(GTK_CONTAINER (frame), scrollwin);

  GtkWidget *text = gtk_text_view_new ();
  g_object_set_data(G_OBJECT(dlg), "testo", text);

  GtkTextBuffer *text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text));
  gtk_text_view_set_right_margin  (GTK_TEXT_VIEW(text), 4);
  gtk_text_view_set_left_margin  (GTK_TEXT_VIEW(text), 4); 
  g_object_set_data(G_OBJECT(dlg), "buffer", text_buffer);
  gtk_text_view_set_editable(GTK_TEXT_VIEW(text), FALSE);
  gtk_container_add(GTK_CONTAINER(scrollwin), text);
  gtk_widget_set_size_request(dlg, 450, 600);

  int flags = gtkext::IFPROP+gtkext::IFREADONLY+gtkext::IFWRAP;
  load_file_into_buffer(nome.c_str(), text_buffer, flags);
  GtkTextIter iter1, iter2;
  gtk_text_buffer_get_bounds (text_buffer, &iter1, &iter2);
  char *testo = gtk_text_buffer_get_text(text_buffer, &iter1, &iter2, FALSE);
  gtk_text_buffer_delete(text_buffer, &iter1, &iter2);
  gtk_text_buffer_get_start_iter(text_buffer, &iter1);
  GtkTextTag *tag = gtk_text_buffer_create_tag (text_buffer, NULL, "wrap_mode", GTK_WRAP_WORD, NULL);
  gtk_text_buffer_insert_with_tags(text_buffer, &iter1, testo, -1, tag, NULL);

  GSList *group = NULL;
  GtkWidget *radio1 = RADIO_BUTTON_WITH_LABEL (group, "I accept the agreement",
                 NULL);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio1));
  gtk_box_pack_start (GTK_BOX (vbox), radio1, FALSE, FALSE, 8);
  GtkWidget *radio2 = RADIO_BUTTON_WITH_LABEL (group, "I do not accept the agreement",
                 NULL);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio2));
  gtk_box_pack_start (GTK_BOX (vbox), radio2, FALSE, FALSE, 4);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio2), TRUE);

  GtkWidget *align;
#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_START, 0, 0);
#else
  align = gtk_alignment_new(0.5f, 0.f, 0.f, 0.f);
#endif

  gtk_box_pack_start (GTK_BOX (vbox), align, FALSE, FALSE, 4);
  GtkWidget *b = gtk_button_new_with_label("OK");
  gtk_container_add(GTK_CONTAINER(align), b);
  g_signal_connect(G_OBJECT(b), "clicked", G_CALLBACK(ok_licence), NULL);
  (void) g_signal_connect_swapped (G_OBJECT (dlg), "delete-event",
                      G_CALLBACK(gtk_button_clicked), G_OBJECT(b));
  (void) g_signal_connect (G_OBJECT (dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  gtk_widget_show_all(dlg);
  //gtk_dialog_add_button(GTK_DIALOG(dlg), "OK", GTK_RESPONSE_OK);
  //gtk_dialog_run(GTK_DIALOG(dlg));
  gtk_main();
  int result = 0;
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radio1)))
     result = 1;
  gtk_widget_destroy(dlg);
  while(gtk_events_pending())
     (void) gtk_main_iteration();

  return result;
}

gboolean AcceptLicence(std::string LicFile, std::string pkgdir)
{
    gboolean accept = 0;
    char *riga = g_new0(char, 15);
    std::string version(PACKAGE_VERSION);
    int i1 = MY_MAJOR_VERSION(version);
    int i2 = MY_MINOR_VERSION(version);
    int i3 = MY_MICRO_VERSION(version);
    int iLic = i1*100+i2*10+i3;

    if (g_file_test (LicFile.c_str(), G_FILE_TEST_EXISTS))
    {
        FILE *fp = fOpen(LicFile.c_str(), "r");
        if (fp != NULL)
        {
            if((fgets(riga,10,fp) != NULL) && (strlen(riga) > 1))
            {
               std::string vers(riga);
               i1 = MY_MAJOR_VERSION(vers);
               i2 = MY_MINOR_VERSION(vers);
               i3 = MY_MICRO_VERSION(vers);
               int iLicR = i1*100+i2*10+i3;
               if(iLicR >= iLic)
                    accept = 1;
            }
            fclose(fp);
        }
     }
     if(!accept)
     {
        if(licence_dialog(pkgdir))
        {
           FILE *fp = fOpen(LicFile.c_str(), "w");
           if (fp != NULL)
           {
               fprintf(fp, "%s\n", PACKAGE_VERSION);
               fclose(fp);
               accept = 1;
           }
        }
     }
     g_free(riga);
     return accept;
}
#endif

void MRcombo_set_val(GtkWidget *combo, int val, bool ifBlock)
{
     if(val < 0)
        return;
     int hnd = get_int(combo, "hnd");
#ifndef GTK_COMBO_BOX
     if(ifBlock && hnd)
        g_signal_handler_block(G_OBJECT(GTK_COMBO(combo)->list), hnd);
     gtk_list_unselect_all (GTK_LIST(GTK_COMBO(combo)->list));
     gtk_list_select_item (GTK_LIST(GTK_COMBO(combo)->list), val);
     if(ifBlock && hnd)
        g_signal_handler_unblock(G_OBJECT(GTK_COMBO(combo)->list), hnd);
#else
     if(ifBlock && hnd)
        g_signal_handler_block(G_OBJECT(combo), hnd);
     gtk_combo_box_set_active(GTK_COMBO_BOX(combo), -1);
     gtk_combo_box_set_active(GTK_COMBO_BOX(combo), val);
     if(ifBlock && hnd)
        g_signal_handler_unblock(G_OBJECT(combo), hnd);
#endif
}

#ifndef GTK_COMBO_BOX
void MRcombo_cb (GtkList *list, GtkWidget *widget, void (*cb_data)(int p1))
{
     int selection = gtk_list_child_position(GTK_LIST(list), widget);
     cb_data(selection);
}
#else
void MRcombo_cb (GtkWidget *widget, void (*cb_data)(GtkWidget *w, int p1))
{
     int selection = gtk_combo_box_get_active(GTK_COMBO_BOX(widget));
     cb_data(widget, selection);
}
#endif

GtkWidget *MRcombo_new(const char *strings[], 
   void (*selection_cb) (GtkWidget *w,int val), 
                       int def_selected, int nlabels)
{
    GtkWidget *combo = combo_box_new();
    int hnd;
#ifndef GTK_COMBO_BOX
    if(nlabels)
    {
        GList *combo_items = NULL;
        for(int i=0; i<nlabels;i++)
            combo_items = g_list_append (combo_items, g_strdup(labels[i]));
        gtk_combo_set_popdown_strings (GTK_COMBO (combo), combo_items);
        g_list_free (combo_items);
        gtk_combo_disable_activate (GTK_COMBO(combo));
        if(def_selected >= 0)
           gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo)->entry), strings[def_selected]);
        hnd = g_signal_connect(G_OBJECT(GTK_COMBO(combo)->list), "select-child",
               G_CALLBACK(MRcombo_cb), (gpointer) (selection_cb));
    }
#else
    if(nlabels)
    {
    for(int i=0; i<nlabels; i++)
        combo_remove_text (combo);
    for(int i=0; i<nlabels; i++)
        combo_insert_text (combo, i, strings[i]);
    if(def_selected >= 0)
       gtk_combo_box_set_active (GTK_COMBO_BOX (combo), def_selected);
    }
    hnd = g_signal_connect(G_OBJECT(combo), "changed", 
                G_CALLBACK(MRcombo_cb), (gpointer) (selection_cb));
#endif
    g_object_set_data(G_OBJECT(combo), "hnd", GINT_TO_POINTER(hnd));
    return combo;
}

int UpdateDialog(GtkWidget *parent, int *checkstatus, const gchar *message, ...)
{
  GtkWidget *okbutton, *button;
  GtkWidget *label, *image, *hbox, *vbox, *label1=NULL;
  GtkWidget *dialog = gtk_dialog_new();
  gchar* msg = NULL;
  va_list args;
  int response;
  GdkCursor *hand_cursor = create_my_cursor(HAND_CURSOR);

  gtk_window_set_resizable (GTK_WINDOW (dialog), FALSE);
  gtk_window_set_title (GTK_WINDOW (dialog), "Info");
  okbutton = myimage_button("_OK", "ok.png");
  image = create_image("infodialog.png");
  gtk_dialog_add_action_widget (GTK_DIALOG(dialog),
                             okbutton,
                             GTK_RESPONSE_OK);
  label = gtk_label_new ("");
  center_image (image);
  if (message)
  {
      va_start (args, message);
      msg = g_strdup_vprintf (message, args);
      va_end (args);
      gtk_label_set_text (GTK_LABEL (label), msg);
      if(strstr(msg, "download"))
         label1 = hypertext_new("http://wwwba.ic.cnr.it/", GetBrowser());
      g_free (msg);
   }

   gtk_label_set_line_wrap  (GTK_LABEL (label), TRUE);
   gtk_label_set_selectable (GTK_LABEL (label), FALSE);
   set_alignment   (label, 0.0, 0.5);
  
   button = gtk_check_button_new_with_label("Automatically check for updates\n"
                 "at program start");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), *checkstatus);
   hbox = hbox_new (FALSE, 12);
   gtk_container_set_border_width(GTK_CONTAINER(hbox), 8);

   vbox = vbox_new (FALSE, 0);

   gtk_box_pack_start (GTK_BOX (hbox), image,
                      FALSE, FALSE, 0);

   gtk_box_pack_start (GTK_BOX (hbox), vbox,
                      FALSE, FALSE, 0);
   gtk_box_pack_start (GTK_BOX (vbox), label,
                      FALSE, FALSE, 0);
   if(label1 != NULL)
      gtk_box_pack_start (GTK_BOX (vbox), label1,
                      FALSE, FALSE, 4);
   gtk_box_pack_start (GTK_BOX (vbox), button,
                      FALSE, FALSE, 8);

   gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG (dialog))),
                      hbox,
                      FALSE, FALSE, 0);

   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(okbutton)),
             GTK_BUTTONBOX_SPREAD);
   gtk_widget_show_all (hbox);
   if(parent != NULL)
      gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(parent));
   gtk_widget_show_all (dialog);
   if(label1 != NULL)
    gdk_window_set_cursor (gtk_widget_get_window(label1), hand_cursor);

   response = gtk_dialog_run(GTK_DIALOG(dialog));
   *checkstatus = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button));
   gtk_widget_destroy(dialog);

   return response;
}

void UpdateCheck(GtkWidget *father, int result, int *flag, const char *v)
{
   if(v == NULL)
   {
      if(result > 0)
         UpdateDialog(father, flag,
            "It's time to update. Please download the latest version of the program from http://wwwba.ic.cnr.it/");
      else if(result == 0)
         UpdateDialog(father, flag, "The program is up-to-date.");
      else              // No internet connection
         UpdateDialog(father, flag, "Sorry. No internet connection.");
   }
   else
   {
      if(result > 0)
         UpdateDialog(father, flag,
            "It's time to update to %s version. Please download it from", v);
// http://wwwba.ic.cnr.it/", v);
      else if(result == 0)
         UpdateDialog(father, flag, g_strdup_printf(
           "The program is up-to-date to the latest version '%s'.", v));
      else              // No internet connection
         UpdateDialog(father, flag, "Sorry. No internet connection.");
   }
}

GtkWidget *OpenContactWindow(GtkWidget *mw)
{
  GtkWidget *label;
  GtkWidget *dialog = gtk_dialog_new();

  gtk_window_set_resizable (GTK_WINDOW (dialog), FALSE);
  gtk_window_set_title (GTK_WINDOW (dialog), "Info");
  label = gtk_label_new ("    Contacting IC server, please wait...    ");
  gtk_label_set_line_wrap  (GTK_LABEL (label), TRUE);
  gtk_label_set_selectable (GTK_LABEL (label), FALSE);
  set_alignment   (label, 0.5, 0.5);
  gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG (dialog))),
                      label,
                      FALSE, FALSE, 0);
  
  gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(mw));
  gtk_widget_show_all(dialog);
  gdk_window_raise(gtk_widget_get_window(dialog));
  while(gtk_events_pending())
        (void) gtk_main_iteration();
  return dialog;
}

void CloseContactWindow(GtkWidget *w)
{
  gtk_widget_destroy(w);
}

namespace gtkext {

static const char *sizes[] = {"Small", "Medium", "Large", "X-Large"};
int NSIZES = sizeof(sizes)/sizeof(sizes[0]);
int default_filter_inp = 0;
int default_filter_out = 0;

#define EDIT 1
#define GO 2
#define VIEW 3

typedef struct {
                 std::string filename;
                 std::string mtime;
                 std::string mtime_n;
               } FileInfo;

// Creates and shows 'Yes or No' dialog, returns TRUE if 'Yes' selected

gboolean dlg_yesno(GtkWindow *parent, const gchar *fmt, ...)
{
    gchar *msg;
    gint response;
    va_list lst;
    va_start(lst, fmt);
    msg = g_strdup_vprintf(fmt, lst);
    va_end(lst);
    response = MessageDialog(GTK_WIDGET(parent), GTK_MESSAGE_QUESTION,
        GTK_BUTTONS_YES_NO, msg);
    g_free(msg);
    return response == GTK_RESPONSE_YES;
}

// Creates and shows Error message dialog
void dlg_errmsg(GtkWindow *parent, const gchar *fmt, ...)
{
    gchar *msg;
    va_list lst;
    va_start(lst, fmt);
    msg = g_strdup_vprintf(fmt, lst);
    va_end(lst);
    MessageDialog(GTK_WIDGET(parent), GTK_MESSAGE_ERROR,
        GTK_BUTTONS_CLOSE, msg);
    g_free(msg);
}

void dlg_errmsg(const gchar *fmt, ...)
{
    gchar *msg;
    va_list lst;
    va_start(lst, fmt);
    msg = g_strdup_vprintf(fmt, lst);
    va_end(lst);
    gtk_init(NULL, NULL);
    GtkWidget *dialog = gtk_message_dialog_new (NULL,
         GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR,
         GTK_BUTTONS_CLOSE, "%s", msg);
    gtk_dialog_run (GTK_DIALOG (dialog));
    gtk_widget_destroy (dialog);

    g_free(msg);
}

std::string dlg_select_file(GtkWidget *mw, const std::string &fn, e_select_type flags, const char *pattern, bool showT, bool *ifT, bool ifAll, int *tipo)
{
   std::string result;
   FilselItem it;   

   it.fileinp    = g_new0(gchar, MaxLenFilename);
   it.fileout    = g_new0(gchar, MaxLenFilename);
   it.cwd        = g_new0(gchar, MaxLenFilename);
   if( pattern!=NULL )
       it.filter     = g_strdup_printf("%s", pattern);
   else
       it.filter     = g_strdup("*.*");
   it.ifDirOnly  = FALSE;
   it.ifMultiple = FALSE;
   it.ifPreview  = FALSE;
   it.ifSave     = FALSE;
   it.exitCode   = 0;
   it.fd         = NULL;
   it.label      = g_new0(gchar, 50);
   it.ifEditable = FALSE;
   it.ifExe      = FALSE;
   it.nofilter   = FALSE;
   it.ifOutput   = FALSE;
   it.window     = mw;
   it.ifAlpha    = FALSE;
   it.AllFiles   = ifAll?TRUE:FALSE;

   if( !fn.empty() )
   {
       if(flags == eSELECT_DIR)
          CopiaStringa(it.cwd, MaxLenFilename, fn.c_str());
       else
       {
       CopiaStringa(it.fileinp, MaxLenFilename, g_path_get_basename(fn.c_str()));
       CopiaStringa(it.cwd, MaxLenFilename, g_path_get_dirname(fn.c_str()));
       }
   }
   else
       CopiaStringa(it.cwd, MaxLenFilename, g_get_current_dir());
   dir_set_current(it.cwd);

   switch(flags)
   {
   case eSELECT_ALIEN:
      it.title = g_strdup_printf("Select executable file");
      break;
   case eSELECT_TO_READ:
      it.title = g_strdup_printf("Select file to read from");
      break;
   case eSELECT_TO_WRITE:
      it.title = g_strdup_printf("Select file to write to");
      it.ifSave     = TRUE;
      break;
   default:
      it.title = g_strdup_printf("Select directory");
      it.nofilter   = TRUE;
      it.ifDirOnly  = TRUE;
      showT = false;
   }
   file_open(&it, showT);
   if(it.exitCode > 0)
   {
      if(!it.ifDirOnly)
      {
         char *nome = g_build_filename(it.cwd, it.fileinp, NULL);
         result = nome;
         g_free(nome);
         if(ifT != NULL)
            *ifT = (it.ifAlpha != 0);
      }
      else
         result = it.cwd;
   }
   if(tipo != NULL)
      *tipo = it.nfilt;
   return result;
}

int text_width(PangoFontDescription *fontdesc, const char *text)
{
    int width, height;
    PangoLayout *layout;
    PangoContext *context;

    context = gdk_pango_context_get();
    layout = pango_layout_new (context);
    if(parse_text(text))
       pango_layout_set_markup(layout, text, (int) strlen(text));
    else
       pango_layout_set_text(layout, text, (int) strlen(text));
    pango_layout_set_font_description (layout, fontdesc);
    pango_layout_get_pixel_size (layout, &width, &height);
    g_object_unref (layout);
    g_object_unref (context);

    return width;
}

bool is_monospace(const char *fontnam)
{
    PangoFontDescription *pf = pango_font_description_from_string(fontnam);
    bool result = (text_width(pf, "l") == text_width(pf, "m"));
    pango_font_description_free(pf);
    return result;
}

void search_text(GtkEditable *widget, gpointer data)
{
    GtkWidget *checkb, *statusb;
    char *text, *text1;
    std::string buffer, buffer2;
    gboolean match_case;
    int istart;
    GtkTextBuffer *tb;
    GtkTextIter iter, iterf, iter0;
    GtkTextMark *mark;
    GtkWidget *text_view = get_widget(GTK_WIDGET(widget), "testo");
    int idir = GPOINTER_TO_INT(data);
    int kstart;
     
    checkb = lookup_widget(GTK_WIDGET(widget), "case");
    statusb = lookup_widget(GTK_WIDGET(widget), "statusbar");
    match_case = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkb));
  
    tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view));
    mark = gtk_text_buffer_get_mark(tb,"current_pos");
    gtk_text_buffer_get_iter_at_offset(tb, &iter0, 0);
    gtk_text_buffer_get_iter_at_mark(tb, &iter, mark);
    gtk_text_buffer_get_end_iter(tb, &iterf);
    istart = gtk_text_iter_get_offset (&iter);    
    if(idir == 1)
       buffer = gtk_text_buffer_get_text(tb, &iter, &iterf, FALSE);  
    else if(istart)
    {
       buffer = gtk_text_buffer_get_text(tb, &iter0, &iter, FALSE);  
       istart = 0;
    }
    else
       buffer = gtk_text_buffer_get_text(tb, &iter0, &iterf, FALSE);  

    text = gtk_editable_get_chars (GTK_EDITABLE(widget), 0, -1);
    if((strlen(text) > 0) && (strlen(buffer.c_str()) > 0))
    {
        text1   = g_strdup(text);
        if(!match_case)
        {
           buffer2 = g_ascii_strdown(buffer.c_str(), -1);
           g_ascii_strdown(text1, -1);
        }
        else
           buffer2 = buffer;
        if(idir == 1)
           kstart = (int) buffer2.find(text1, 0);
        else
           kstart = (int) buffer2.rfind(text1, strlen(buffer2.c_str()));

        if(kstart >= 0)
        {
           gtk_text_buffer_get_iter_at_offset(tb, &iter, istart+kstart);
           gtk_text_buffer_get_iter_at_offset(tb, &iterf, istart+kstart+(int) strlen(text));

           if(idir == 1)
              gtk_text_buffer_move_mark_by_name(tb, "current_pos", &iterf);
           else
              gtk_text_buffer_move_mark_by_name(tb, "current_pos", &iter);
           gtk_text_buffer_move_mark_by_name(tb, "insert", &iter);
           gtk_text_buffer_move_mark_by_name(tb, "selection_bound", &iterf);
           gtk_statusbar_pop(GTK_STATUSBAR(statusb), 1);
           (void) gtk_statusbar_push(GTK_STATUSBAR(statusb), 1," ");
        }
        else
        {
           gtk_text_buffer_get_iter_at_offset(tb, &iter, 0);
           gtk_text_buffer_move_mark_by_name(tb, "current_pos", &iter);
           gtk_text_buffer_place_cursor(tb, &iter);
           gtk_statusbar_pop(GTK_STATUSBAR(statusb), 1);
           if(istart || (idir ==2))
              (void) gtk_statusbar_push(GTK_STATUSBAR(statusb), 1,
                 "Passed the end of file");
           else
              (void) gtk_statusbar_push(GTK_STATUSBAR(statusb), 1,
                 "String not found");
        }
        gtk_text_view_scroll_mark_onscreen(GTK_TEXT_VIEW(text_view),
                          gtk_text_buffer_get_mark(tb,"current_pos"));
    }
    g_free(text);
}

void set_response(GtkWidget *button, gpointer data)
{
   int response = GPOINTER_TO_INT(data);
    if(response)
    {
       GtkWidget *entry = get_widget(gtk_widget_get_toplevel(button), "entry");
       search_text(GTK_EDITABLE(entry), data);
    }
    else
       gtk_dialog_response(GTK_DIALOG(gtk_widget_get_toplevel(button)), response);
}

GtkWidget *create_find_window()
{
  GtkWidget *window, *mbox, *box, *hbox, *wid, *entry;

  window = gtk_dialog_new();
  gtk_window_set_title(GTK_WINDOW(window), "Find");
  gtk_window_set_default_size(GTK_WINDOW(window), 250, 120);

  mbox = gtk_dialog_get_content_area(GTK_DIALOG(window));
  gtk_container_set_border_width(GTK_CONTAINER(window), 0);
  wid = gtk_statusbar_new();
  gtk_box_pack_end(GTK_BOX(mbox), wid, FALSE, FALSE, 4);
  g_object_set_data(G_OBJECT(window), "statusbar", wid);

  wid = gtk_frame_new(NULL);
  gtk_box_pack_start(GTK_BOX(mbox), wid, FALSE, FALSE, 4);
  box = vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(wid), box);
  gtk_container_set_border_width(GTK_CONTAINER(box), 8);

  hbox = hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(box), hbox, FALSE, FALSE, 4);
  wid = gtk_label_new("Find what");
  gtk_box_pack_start(GTK_BOX(hbox), wid, FALSE, FALSE, 4);
  entry = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 4);
  g_object_set_data(G_OBJECT(window), "entry", entry);
  (void) g_signal_connect(G_OBJECT(entry), "activate", 
                   G_CALLBACK(search_text), GINT_TO_POINTER(1));

  wid = gtk_check_button_new_with_label("Match case");
  gtk_box_pack_start(GTK_BOX(box), wid, FALSE, FALSE, 4);
  g_object_set_data(G_OBJECT(window), "case", wid);

  hbox = hbox_new(FALSE, 0);
  gtk_box_pack_end(GTK_BOX(box), hbox, FALSE, FALSE, 4);
  wid = myimage_button("  _Next", "next.png");
  gtk_box_pack_start(GTK_BOX(hbox), wid, FALSE, FALSE, 4);
  (void) g_signal_connect(G_OBJECT(wid), "clicked", 
      G_CALLBACK(set_response) , GINT_TO_POINTER(1));

  wid = myimage_button("  _Previous", "previous.png");
  gtk_box_pack_start(GTK_BOX(hbox), wid, FALSE, FALSE, 4);
  (void) g_signal_connect(G_OBJECT(wid), "clicked", 
      G_CALLBACK(set_response) , GINT_TO_POINTER(2));

  wid = myimage_button("  _Cancel", "cancel.png");
  gtk_box_pack_end(GTK_BOX(hbox), wid, FALSE, FALSE, 4);
  (void) g_signal_connect(G_OBJECT(wid), "clicked", 
      G_CALLBACK(set_response), GINT_TO_POINTER(0));
  return window;
}

void find_str  (GtkWidget  *dlg)
{
  GtkWidget *entry, *find_window, *text_view;
  GtkTextBuffer *tb;
  GtkTextIter iter;
  int irisp;

  text_view = get_widget(dlg, "testo");
  find_window = create_find_window();
  tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view));
  gtk_text_buffer_get_start_iter(tb, &iter);
  gtk_text_buffer_create_mark(tb, "current_pos", &iter, FALSE);
  gtk_widget_show_all(find_window);
  gdk_window_raise(gtk_widget_get_window(find_window));
  entry = get_widget(find_window, "entry");
  gtk_widget_grab_focus(entry);
  g_object_set_data(G_OBJECT(entry), "testo", text_view);
  while((irisp = gtk_dialog_run(GTK_DIALOG(find_window))) > 0)
        search_text(GTK_EDITABLE(entry), GINT_TO_POINTER(irisp));
  gtk_widget_destroy(find_window);
}  

void on_click (GtkWidget *button, gpointer data)
{
    gint response = GPOINTER_TO_INT(data);
    gtk_dialog_response(GTK_DIALOG(gtk_widget_get_toplevel(button)), response);
}

void on_size(GtkWidget *wid, GtkWidget *dlg)
{
   GtkTextBuffer *tb = (GtkTextBuffer *) get_object(dlg, "buffer");
   GtkTextIter start, end;
   GtkTextTag *tagf;
   int isize = 0;

#ifndef GTK_COMBO_BOX
      int i;
      const gchar *ent = gtk_entry_get_text(GTK_ENTRY(wid));
      for(i=0; i<(int)(NSIZES); i++)
          if(strcmp(sizes[i], ent) == 0)
             isize = i;
#else
     isize = gtk_combo_box_get_active(GTK_COMBO_BOX(wid));       
     if(isize == -1)
        isize = 1;
#endif

   isize = (8 + 2*isize) * PANGO_SCALE;
   if(tb)
   {
      tagf = gtk_text_buffer_create_tag(tb, NULL, "size", isize, NULL);
      gtk_text_buffer_get_bounds(tb, &start, &end);
      gtk_text_buffer_apply_tag(tb, tagf, &start, &end);
   }
}

GtkWidget *char_size_button(GtkWidget *father)
{
    GtkWidget *align, *hbox, *label, *combo;

    hbox = hbox_new(FALSE, 0);
#ifdef IN_GTK3
    align = gtk_frame_new(NULL);
    gtk_frame_set_shadow_type (GTK_FRAME (align), GTK_SHADOW_NONE);
    gtk_widget_set_vexpand(hbox, FALSE);
    gtk_widget_set_hexpand(hbox, FALSE);
    g_object_set(G_OBJECT(hbox), "valign", GTK_ALIGN_CENTER, NULL);
#else
    align = gtk_alignment_new(0.1f, 0.5f, 0, 0);
#endif
    gtk_container_add(GTK_CONTAINER(align), hbox);
    gtk_container_set_border_width(GTK_CONTAINER(hbox), 2);
    label = create_image("font.png");
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
    //align2 = gtk_alignment_new(0.1f, 0.5f, 0, 0);
    //gtk_box_pack_start(GTK_BOX(hbox), align2, FALSE, FALSE, 2);
    combo = create_combo_str(G_CALLBACK(on_size), father);
    fill_combo(combo, sizes, NSIZES, 1);
    gtk_widget_set_size_request(combo, 75, 22);
    gtk_box_pack_start(GTK_BOX(hbox), combo, FALSE, FALSE, 2);
    //gtk_container_add(GTK_CONTAINER(align2), combo);
    gtk_editable_set_editable(GTK_EDITABLE(get_widget(combo, "entry")), FALSE);

    gtk_widget_show_all(hbox);
    return align;
}

GtkWidget *text_editor (char *filename, int flags, const char *title) 
{
  GtkWidget *scrollwin, *text, *dialog, *frame, *hbox, *button_car;
  GtkWidget *button_new, *button_save, *button_open, *button_quit, 
            *button_saveas, *button_print, *button_find;
  GtkTextBuffer *text_buffer;
  GdkPixbuf *icon_pixbuf;

  dialog = gtk_dialog_new();
#ifndef GTK_TOOLTIP
  GtkTooltips *tt = gtk_tooltips_new();
  g_object_set_data(G_OBJECT(dialog), "tt", tt);
#endif

  gtk_widget_set_size_request(dialog, 600, 350);
  if(title)
     gtk_window_set_title(GTK_WINDOW(dialog), toUTF8(title));
  else
     gtk_window_set_title(GTK_WINDOW(dialog), "Editor");

  icon_pixbuf = create_pixbuf ("editor.png");
  if (icon_pixbuf)
  {
      gtk_window_set_icon (GTK_WINDOW (dialog), icon_pixbuf);
      g_object_unref (icon_pixbuf);
  }

  frame = gtk_frame_new(NULL);
  gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dialog))), frame, FALSE, FALSE, 0);
  hbox = hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER (frame), hbox);

  button_quit = image_button("quit32.png");
  gtk_box_pack_start (GTK_BOX (hbox), button_quit, FALSE, FALSE, 0);
  set_tip(button_quit, "Quit");
  g_signal_connect((gpointer) button_quit, "clicked", G_CALLBACK(on_click), GINT_TO_POINTER(EXIT));

  if(flags & IFOPEN)
  {
  button_new = image_button("filenew32.png");
  gtk_box_pack_start (GTK_BOX (hbox), button_new, FALSE, FALSE, 0);
  set_tip(button_new, "New File");
  g_signal_connect((gpointer) button_new, "clicked", G_CALLBACK(on_click), GINT_TO_POINTER(NEW));

  button_open = image_button("fileopen32.png");
  gtk_box_pack_start (GTK_BOX (hbox), button_open, FALSE, FALSE, 0);
  set_tip(button_open, "Open File");
  g_signal_connect((gpointer) button_open, "clicked", G_CALLBACK(on_click), GINT_TO_POINTER(OPEN));
  }

  if(flags & IFSAVE)
  {
  button_save = image_button("filesave32.png");
  gtk_box_pack_start (GTK_BOX (hbox), button_save, FALSE, FALSE, 0);
  set_tip(button_save, "Save File");
  g_signal_connect((gpointer) button_save, "clicked", G_CALLBACK(on_click), GINT_TO_POINTER(SAVE));
  }

  if(flags & IFSAVEAS)
  {
  button_saveas = image_button("filesaveas32.png");
  gtk_box_pack_start (GTK_BOX (hbox), button_saveas, FALSE, FALSE, 0);
  set_tip(button_saveas, "Save File");
  g_signal_connect((gpointer) button_saveas, "clicked", G_CALLBACK(on_click), GINT_TO_POINTER(SAVEAS));
  }

  button_print = image_button("fileprint32.png");
  gtk_box_pack_start (GTK_BOX (hbox), button_print, FALSE, FALSE, 0);
  set_tip(button_print, "Print File");
  g_signal_connect((gpointer) button_print, "clicked", G_CALLBACK(on_click), GINT_TO_POINTER(PRINT));

  button_find = image_button("filefind32.png");
  gtk_box_pack_start (GTK_BOX (hbox), button_find, FALSE, FALSE, 0);
  set_tip(button_find, "Find in file");
  g_signal_connect((gpointer) button_find, "clicked", G_CALLBACK(on_click), GINT_TO_POINTER(FIND));

  button_car = char_size_button(dialog);
  gtk_box_pack_start (GTK_BOX (hbox), button_car, FALSE, FALSE, 0);
  set_tip(button_car, "Modify character size");

  frame = gtk_frame_new(NULL);
  gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dialog))), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);

  scrollwin = gtk_scrolled_window_new( NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                  GTK_POLICY_AUTOMATIC, 
                                  GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrollwin);
  gtk_container_add(GTK_CONTAINER (frame), scrollwin);

  text = gtk_text_view_new ();
  g_object_set_data(G_OBJECT(dialog), "testo", text);

  text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text));
  gtk_text_view_set_right_margin  (GTK_TEXT_VIEW(text), 4);
  gtk_text_view_set_left_margin  (GTK_TEXT_VIEW(text), 4);
  g_object_set_data(G_OBJECT(dialog), "buffer", text_buffer);

  if(flags & IFREADONLY)
     gtk_text_view_set_editable(GTK_TEXT_VIEW(text), FALSE);
  else
     gtk_text_view_set_editable(GTK_TEXT_VIEW(text), TRUE);
  gtk_container_add(GTK_CONTAINER(scrollwin), text);

   if(filename)
      (void) load_file_into_buffer(filename, text_buffer, flags);
   gtk_text_buffer_set_modified (text_buffer, FALSE);

  return dialog;
}

  void text_window(GtkWindow *winmain, const char *filnam, const char *filter, int flags, const char *title)
  {
      text_window(winmain, filnam, filter, flags, title, -1, -1);
  }

  void text_window(GtkWindow *winmain, const char *filnam, const char *filter, int flags, 
           const char *title, int wid, int hei)
  {
      gint response;
      gboolean do_loop = TRUE;
      GtkWidget *window;
      GtkTextIter i1, i2;

      gchar *filename = g_new0(char, MaxLenFilename);
      if(filnam)
         CopiaStringa(filename, MaxLenFilename, filnam);

      window = text_editor(filename, flags, title);
      if((wid > 0) && (hei > 0))
         gtk_widget_set_size_request(window, wid, hei);
      if(winmain != NULL)
         gtk_window_set_transient_for(GTK_WINDOW(window), winmain);
      gtk_widget_show_all(window);
      GtkTextBuffer *tb = (GtkTextBuffer *) get_object(window, "buffer");
      while (do_loop)
      {
          std::string fn = "";
          response = gtk_dialog_run(GTK_DIALOG(window));
          gtk_widget_hide(window);
          switch(response)
          {
          case NEW:
               gtk_text_buffer_get_bounds(tb, &i1, &i2);
               gtk_text_buffer_delete(tb, &i1, &i2);
               gtk_window_set_title(GTK_WINDOW(window), "New file");
               memset(filename, 0, MaxLenFilename);
               break;
         case OPEN:
               gtk_widget_show(window);
               fn = dlg_select_file(window, fn, eSELECT_TO_READ, filter);
               if(!fn.empty())
               {
                  ScriviStringa(filename, MaxLenFilename, "%s", fn.c_str());
                  gtk_window_set_title(GTK_WINDOW(window), toUTF8(filename));
                  (void) load_file_into_buffer(filename, tb, flags);
               }
               break;
         case GTK_RESPONSE_NONE:
         case GTK_RESPONSE_DELETE_EVENT:
         case EXIT:
              do_loop = FALSE;
              if(!gtk_text_buffer_get_modified (tb))
                  break;
              else
              {
                  gtk_window_set_modal(GTK_WINDOW(window), FALSE);
                  gboolean result = dlg_yesno(GTK_WINDOW(window),
                        "Save changes to file '%s' before closing?", filename);
                  gtk_window_set_modal(GTK_WINDOW(window), TRUE);
                  if(result)
                     response = SAVE;
                  else
                     break;
              }
         case SAVE:
         case SAVEAS:
               gtk_text_buffer_get_bounds(tb, &i1, &i2);
               if(filename && (response == SAVE))
                  fn = filename;
               if(fn.empty())
               {
                  gtk_widget_show(window);
                  fn = dlg_select_file(window, fn, eSELECT_TO_WRITE, filter);
                  CopiaStringa(filename, MaxLenFilename, fn.c_str());
               }
               if(!fn.empty())
               {
                  gchar *buffer = g_strdup(fromUTF8(gtk_text_iter_get_text (&i1, &i2)).c_str());
                  if(g_file_test(fn.c_str(), G_FILE_TEST_EXISTS) && !mr_access(filename, 'w'))
                     gtkext::dlg_errmsg(GTK_WINDOW(window), "The file '%s' is READ_ONLY!", filename);
                  else
                  { 
                     FILE *fp = fOpen(filename, "w");
                     if(fp)
                     {
                        (void) fputs(buffer, fp);
                        (void) fclose(fp);
                     }
                     g_free(buffer);
                     gtk_text_buffer_set_modified (tb, FALSE);
                  }
               }
               gtk_widget_show(window);
               break;
          case PRINT:
               if(strlen(filename))
                  PrintFile(window, filename);
               break;
          case FIND:
               gtk_widget_show_all(window);
               find_str(window);
          default:
               break;
          }
      }
      gtk_widget_destroy(window);
      g_free(filename);
  }

char*  get_filt(char *filnam)
{
     char *tmp;
     char *result;

     tmp = strrchr(filnam, '.');
     if(tmp == NULL)
     {
        result = g_new0(char, 4);
        CopiaStringa(result, 4, "*.*");
     }
     else
     {
        size_t sz = strlen(tmp) + 2;
        result = g_new0(char, sz);
        ScriviStringa(result, sz, "*%s", tmp);
     }
     return result;
}

GdkPixbuf *get_pixbuf(GtkWidget *dlg, char quale)
{
    GdkPixbuf *pixbuf;
    switch(quale)
    {
    default:
    case 'C':
          pixbuf = (GdkPixbuf *) get_object(dlg, "grpbuf");
          break;
    case 'O':
          pixbuf = (GdkPixbuf *) get_object(dlg, "openbuf");
          break;
    case 'D':
          pixbuf = (GdkPixbuf *) get_object(dlg, "grpdefbuf");
          break;
    case 'A':
          pixbuf = (GdkPixbuf *) get_object(dlg, "opendefbuf");
          break;
    case 'F':
          pixbuf = (GdkPixbuf *) get_object(dlg, "floppybuf");
          break;
    case 'R':
          pixbuf = (GdkPixbuf *) get_object(dlg, "remotebuf");
          break;
    case 'X':
          pixbuf = (GdkPixbuf *) get_object(dlg, "fixedbuf");
          break;
    case 'B':
          pixbuf = (GdkPixbuf *) get_object(dlg, "cdbuf");
          break;
    }
    return pixbuf;
}

static GtkWidget *filesel_w = NULL;
FilselItem it;

#ifdef _WIN32
static int ind_drv[26];
static unsigned int type_drv[26];
void add_drv_to_list (GtkWidget *listad, int NumItems)
{

  char string[3];
  GdkPixbuf *bmp;
  int i;
  int num[7], tipo[4], ind_riga;
//  int SupportedTypes = 3;             
  int SupportedTypes = 4;              // next release
  GtkListStore *list_store;
  GtkTreeIter iter;
  PixText direntry;
  GtkWidget *dlg = gtk_widget_get_toplevel(listad);

  list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(listad)));

  for(i=0; i<7;i++)
      num[i] = 0;
  for(i=0; i<NumItems;i++)
      num[type_drv[i]]++;
  tipo[0] = num[DRIVE_FIXED] + num[DRIVE_UNKNOWN] +
            num[DRIVE_NO_ROOT_DIR] + num[DRIVE_RAMDISK];
  tipo[1] = num[DRIVE_REMOVABLE];
  tipo[2] = num[DRIVE_REMOTE];
  tipo[3] = num[DRIVE_CDROM];

  for(i=0; i<NumItems; i++)
  {
      switch(type_drv[i])
      {
       case DRIVE_UNKNOWN:
       case DRIVE_NO_ROOT_DIR:
       case DRIVE_RAMDISK:
       case DRIVE_FIXED:
            ind_riga = 0;
            bmp = get_pixbuf(dlg, 'X');;
            break;
       case DRIVE_REMOVABLE:
            bmp = get_pixbuf(dlg, 'F');;
            ind_riga = 1;
            break;
       case DRIVE_REMOTE:
            bmp = get_pixbuf(dlg, 'R');;
            ind_riga = 2;
            break;
       case DRIVE_CDROM:
            bmp = get_pixbuf(dlg, 'B');;
            ind_riga = 3;
            break;
      }
      if(ind_riga < SupportedTypes)
      {
         ScriviStringa(string, sizeof(string), "%c:", ind_drv[i]+'A'-1);
         direntry.text = string;
         direntry.icon = bmp;
         gtk_list_store_append (list_store, &iter);
         gtk_list_store_set (list_store, &iter,
                          0, &direntry,-1);
      }
   }
}

void aggiungi_drv(GtkWidget *listadir)
{
     int   ndrive, i, curdrive;
     char  *string;
     unsigned long available_drives;

     ndrive = 0;
     if((available_drives = GetLogicalDrives()) != 0)
     {
         for (i=0;i<27;i++)
         {
             if(b_test(available_drives, i))
             {
                if(i == _getdrive())
                   curdrive = ndrive;
                string = g_strdup_printf("%c:", i + 'A');
                type_drv[ndrive] = GetDriveType(string);
                ind_drv[ndrive] = i+1;
                ndrive++;
             }
          }
     }
     add_drv_to_list (listadir, ndrive);
}
#endif

bool alphagreater ( std::string elem1, std::string elem2 )
{
   gchar *temp1, *temp2;
   temp1 = g_utf8_casefold(elem1.c_str (), -1);
   temp2 = g_utf8_casefold(elem2.c_str (), -1);
   int result = strcmp(temp1, temp2);
   g_free(temp1);
   g_free(temp2);
   return (result < 0);
}

void clistfiles(const char *filter, std::vector<std::string> &Files)
{
    GDir *dir;
    const gchar *name;
    size_t sz = strlen(filter)+1;
    gchar *filt = g_new0(char, sz);

    if(strcmp(filter, "*.*"))
       CopiaStringa(filt, sz, filter);
    else
       CopiaStringa(filt, sz, "*");

    GPatternSpec *pattern = g_pattern_spec_new(filt);
    g_free(filt);
    gchar *curdir = g_get_current_dir();
    dir = g_dir_open (curdir, 0, NULL);
    g_free(curdir);
    if (!dir)
      return;

    name = g_dir_read_name (dir);
    while (name != NULL)
    {
        gchar *path;
        gboolean is_dir;
      
        if (name[0] != '.')
     	{
            char *cd = g_get_current_dir();
	    path = g_build_filename (cd, name, NULL);
            g_free(cd);
	    is_dir = g_file_test (path, G_FILE_TEST_IS_DIR);
            if(is_dir && strstr(filter, "*.dir"))
                  Files.push_back (name);
            else if(!is_dir  && !strstr(filter, "*.dir")) 
            {
               gchar *tmps = g_utf8_casefold(name, -1);
               if(g_pattern_match_string (pattern, tmps))
                  Files.push_back (name);
               g_free(tmps);
            }
            g_free (path);
        }
        name = g_dir_read_name (dir);      
    }
    g_pattern_spec_free(pattern);
    g_dir_close(dir);        
    sort( Files.begin( ), Files.end( ), alphagreater );
}

bool alphagreater2 ( FileInfo elem1, FileInfo elem2 )
{
   gchar *temp1, *temp2;
   temp1 = g_utf8_casefold(elem1.filename.c_str (), -1);
   temp2 = g_utf8_casefold(elem2.filename.c_str (), -1);
   int result = strcmp(temp1, temp2);
   g_free(temp1);
   g_free(temp2);
   return (result < 0);
}

bool alphasmaller2 ( FileInfo elem1, FileInfo elem2 )
{
   gchar *temp1, *temp2;
   temp1 = g_utf8_casefold(elem1.filename.c_str (), -1);
   temp2 = g_utf8_casefold(elem2.filename.c_str (), -1);
   int result = strcmp(temp1, temp2);
   g_free(temp1);
   g_free(temp2);
   return (result > 0);
}

bool alphagreater3 ( FileInfo elem1, FileInfo elem2 )
{
   int temp1, temp2;
   temp1 = atoi(elem1.mtime_n.c_str ());
   temp2 = atoi(elem2.mtime_n.c_str ());
   return (temp1 < temp2);
}

bool alphasmaller3 ( FileInfo elem1, FileInfo elem2 )
{
   int temp1, temp2;
   temp1 = atoi(elem1.mtime_n.c_str ());
   temp2 = atoi(elem2.mtime_n.c_str ());
   return (temp1 > temp2);
}

void clistfilesNew(const char *filter, std::vector<FileInfo> &Files)
{
    GDir *dir;
    const gchar *name;
    FileInfo file;
    int i;
    GList *listapatt = NULL;

    gchar **mfilt =  g_strsplit(filter, ",", 20);
    for(i=0; mfilt[i]!=NULL; i++)
    {
        size_t sz = strlen(mfilt[i])+1;
        gchar *filt = g_new0(char, sz);

        if(strcmp(mfilt[i], "*.*"))
           CopiaStringa(filt, sz, mfilt[i]);
        else
           CopiaStringa(filt, sz, "*");

        GPatternSpec *pattern = g_pattern_spec_new(filt);
        listapatt = g_list_append(listapatt, pattern);
        g_free(filt);
    }
    g_strfreev(mfilt);

    dir = g_dir_open (g_get_current_dir(), 0, NULL);
    if (!dir)
      return;

    name = g_dir_read_name (dir);
    while (name != NULL)
    {
        gchar *path;
        gboolean is_dir;
#  ifdef _WIN32
        struct _stat buf;
#else
        struct stat buf;
#endif
        struct tm TMbuf;
      
        if (name[0] != '.')
     	{
	        path = g_build_filename (g_get_current_dir(), name, NULL);
	        is_dir = g_file_test (path, G_FILE_TEST_IS_DIR);
            file.filename = name;
            file.mtime = " ";
            file.mtime_n = " ";
            if(is_dir && strstr(filter, "*.dir"))
                  Files.push_back (file);
            else if(!is_dir  && !strstr(filter, "*.dir")) 
            {
               for(i=0; i<(int)g_list_length(listapatt); i++)
               {
                  GPatternSpec *patt = (GPatternSpec *)g_list_nth_data(listapatt, i);
                  if(g_pattern_match_string (patt, g_utf8_casefold(name, -1)))
                  {
#ifdef _WIN32
                      _stat(name, &buf);
#else
                     stat(name, &buf);
#endif
                     OraFormatotm(&buf.st_mtime,&TMbuf);
                     file.filename = name;
                     file.mtime_n = g_strdup_printf("%d", (int) buf.st_mtime);
                     file.mtime = g_strdup_printf( "%2.2d/%2.2d/%4.4d", TMbuf.tm_mday, TMbuf.tm_mon+1, TMbuf.tm_year+1900);
                     Files.push_back (file);
                  }
               }
            }
            g_free (path);
        }
        name = g_dir_read_name (dir);      
    }
    g_dir_close(dir);        
    sort( Files.begin( ), Files.end( ), alphagreater2 );
    g_list_free(listapatt);
}

void modify_out_file(char *rigap, GtkWidget *out_file)
{
  if(strlen(rigap) > 1)
  {
     if(it.ifOutput)
     {
        std::string outf = str_cut(rigap, ".");
        outf.append(".out");
        gtk_entry_set_text( (GtkEntry *) out_file, outf.c_str());
     }
  }
  else
     gtk_entry_set_text( (GtkEntry *) out_file, " ");
}
 
void on_alpha(GtkToggleButton *button, gpointer )
{
  it.ifAlpha = gtk_toggle_button_get_active(button);
}

void modify_outf (GtkEditable *widget, gpointer )
{
     GtkWidget *out_file;
     gchar *rigap = g_new0(char, MaxLenFilename);

     out_file = get_widget(gtk_widget_get_toplevel(GTK_WIDGET(widget)), "out_txt");
     ScriviStringa(rigap, MaxLenFilename, "%s",
         gtk_editable_get_chars(widget, 0, -1));

     modify_out_file(rigap, out_file);
}

void FillList(GtkWidget *list)
{
     riempi_listNew(list);
}

void change_dir(gchar *newdir, GtkWidget *list1, gpointer data)
{
     dir_set_current(newdir);
     FillList(list1);
     if(data != NULL)
     {
        GtkWidget *fillist = get_widget(list1, "lf");
        FillList(fillist);
     }
}

void selected_dir(GtkToggleButton *button, gchar *newdir)
{
     if(!gtk_toggle_button_get_active(button))
         return;
     GtkWidget *father = gtk_widget_get_toplevel(GTK_WIDGET(button));
     GtkWidget *list1 = get_widget(father, "dirsel");
     change_dir(newdir, list1, GINT_TO_POINTER(1));
}

void add_line_to_listNew(GtkWidget *list, FileInfo *line)
{
    GtkListStore *list_store;
    GtkTreeIter iter;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    gtk_list_store_append (list_store, &iter);
    gtk_list_store_set (list_store, &iter, 0, line->filename.c_str(), 1, line->mtime.c_str(), 
                  2, line->mtime_n.c_str(), -1);
}

GtkTreeModel *create_completion_model (void)
{
  GtkListStore *store;
  
  store = gtk_list_store_new (1, G_TYPE_STRING);

  return GTK_TREE_MODEL (store);
}

void fill_completion_model (GtkTreeModel *model, std::vector<FileInfo> &Files )
{
  GtkListStore *store;
  GtkTreeIter iter;
  
  store = GTK_LIST_STORE(model);
  gtk_list_store_clear(store);

  /* Append filenames */
  for(unsigned int i=0; i < Files.size(); i++)
  {
      std::string nome1 = strstrip(Files[i].filename);
      std::string nome = filtrastr(nome1, '\n');
      gtk_list_store_append (store, &iter);
      gtk_list_store_set (store, &iter, 0, nome1.c_str(), -1);
  }
}

void modify_filter (GtkEditable *widget, gpointer )
{
     std::string filnam = gtk_editable_get_chars(widget, 0, -1);
     FileInfo filentry;
     std::vector<FileInfo> Files;
     GtkWidget *listad = get_widget(gtk_widget_get_toplevel(GTK_WIDGET(widget)), "filsel");

     filnam.append("*");
     clistfilesNew((char *) filnam.c_str(), Files);
     clear_list(listad);
     for(unsigned int i=0; i < Files.size(); i++)
     {
         std::string nome1 = strstrip(Files[i].filename);
         std::string nome = filtrastr(nome1, '\n');
         filentry.filename = nome;
         filentry.mtime    = Files[i].mtime.c_str();
         filentry.mtime_n  = Files[i].mtime_n;
         add_line_to_listNew(listad, &filentry);
     }
}

void riempi_listNew (GtkWidget *listad)
{
    static GdkPixbuf *upperbuf, *fixedbuf, *cdbuf, *floppybuf, *remotebuf,
               *cartlbuf, *cartbuf, *homebuf, *grpbuf, *grpdefbuf, *openbuf,
               *opendefbuf;
    int ifDir;
    char *rigap;
    char riga[MaxLenFilename];
    GtkWidget *cwd_txt, *button;
    int lung_str;
    PixText  *direntry = g_new0(PixText , 1);
    FileInfo filentry;
    GtkAdjustment *adj;
    std::vector<FileInfo> Files;
    GtkWidget *dlg = gtk_widget_get_toplevel(listad);

    if(!upperbuf)
    {
        upperbuf   = create_pixbuf("upper.png");
        fixedbuf   = create_pixbuf("fixed.png");
        floppybuf  = create_pixbuf("floppy.png");
        remotebuf  = create_pixbuf("remote.png");
        cdbuf      = create_pixbuf("cd.png");
        cartbuf    = create_pixbuf("cart.png");
        cartlbuf   = create_pixbuf("cartl.png");
        homebuf    = create_pixbuf("home.png");
        grpbuf     = create_pixbuf("closed.png");
        grpdefbuf  = create_pixbuf("closed_def.png");
        openbuf    = create_pixbuf("open.png");
        opendefbuf = create_pixbuf("open_def.png");
    }
    g_object_set_data(G_OBJECT(dlg), "grpbuf", (gpointer) grpbuf);
    g_object_set_data(G_OBJECT(dlg), "openbuf", (gpointer) openbuf);
    g_object_set_data(G_OBJECT(dlg), "grpdefbuf", (gpointer) grpdefbuf);
    g_object_set_data(G_OBJECT(dlg), "opendefbuf", (gpointer) opendefbuf);
    g_object_set_data(G_OBJECT(dlg), "fixedbuf", (gpointer) fixedbuf);
    g_object_set_data(G_OBJECT(dlg), "cdbuf", (gpointer) cdbuf);
    g_object_set_data(G_OBJECT(dlg), "remotebuf", (gpointer) remotebuf);
    g_object_set_data(G_OBJECT(dlg), "floppybuf", (gpointer) floppybuf);

    clear_list(listad);
    rigap = riga;

    CopiaStringa(rigap, MaxLenFilename, getpwd());
    lung_str = (int) strlen(rigap);
    riga[lung_str] = G_DIR_SEPARATOR;
    riga[lung_str+1] = '\0';

    std::string exten;
    exten.assign("*");
    exten.append(get_string(listad, "filtro"));
//    CopiaStringan(ext, 8, get_string(listad, "filtro"), 6);
//    ext[6] = '\0';
    if((int) exten.find("*.dir") == -1)
       ifDir = 0;
    else
       ifDir = 1;

    if(ifDir)                                   /* directories */
    {
      int i, hnd;
      cwd_txt = get_widget(listad, "filnam");
      if(GTK_IS_ENTRY(cwd_txt))
          gtk_entry_set_text((GtkEntry *) cwd_txt, rigap);
      else
          gtk_label_set_text (GTK_LABEL(gtk_bin_get_child(GTK_BIN(cwd_txt))),rigap);
       clistfilesNew("*.dir", Files);
      GtkWidget *cwd_box = get_widget(listad, "cwd_box");
      bool found = false;
      if(GTK_IS_WIDGET(cwd_box))
      {
         GList *children = gtk_container_get_children(GTK_CONTAINER(cwd_box));
         if (children != NULL)
         {
             int n_children = g_list_length(children);
             for(i=0; i<n_children; i++)
             {
                 GtkWidget *child = (GtkWidget *)g_list_nth_data(children, i);
                 if(strcmp(gtk_widget_get_name(child), rigap) == 0)
                 {
                    found = true;
                    int hnd = get_int(child, "hnd");
                    g_signal_handler_block (G_OBJECT (child), hnd);
                    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(child), TRUE);
                    g_signal_handler_unblock (G_OBJECT (child), hnd);
                 } 
                 else
                    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(child), FALSE);
             }
             if(!found)
                 for(i=0; i<n_children; i++)
                     gtk_container_remove(GTK_CONTAINER(cwd_box), (GtkWidget *)g_list_nth_data(children, i));
         }
         if(!found)
         {
         gchar **dirs = g_strsplit(rigap, G_DIR_SEPARATOR_S, 128);
         i = 0;
         if(dirs[i] != NULL)
         {
              if(str_white(dirs[i]))
              {
                 button = gtk_toggle_button_new_with_label(G_DIR_SEPARATOR_S);
                 gtk_box_pack_start(GTK_BOX(cwd_box), button, FALSE, FALSE, 2);
                 gtk_widget_set_name(button, G_DIR_SEPARATOR_S);
                 hnd = g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(selected_dir),
                      DuplicaStringa(G_DIR_SEPARATOR_S));
                 g_object_set_data(G_OBJECT(button), "hnd", GINT_TO_POINTER(hnd));
                 gtk_widget_show(button);
              }
              else if(strstr(dirs[i], ":"))
              {
                 gchar *pathname = g_new0(char, 512);
                 AppendiStringa(pathname, 512, dirs[i]);
                 AppendiStringa(pathname, 512, G_DIR_SEPARATOR_S);
                 button = gtk_toggle_button_new_with_label(pathname);
                 gtk_box_pack_start(GTK_BOX(cwd_box), button, FALSE, FALSE, 2);
                 gtk_widget_set_name(button, pathname);
                 hnd = g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(selected_dir),
                      DuplicaStringa(pathname));
                 g_object_set_data(G_OBJECT(button), "hnd", GINT_TO_POINTER(hnd));
                 g_free(pathname);
                 gtk_widget_show(button);
                 i++;
             }
         }
         while(dirs[i] != NULL)
         {
              if (!str_white(dirs[i]))
              {
                  button = gtk_toggle_button_new_with_label(dirs[i]);
                  gtk_box_pack_start(GTK_BOX(cwd_box), button, FALSE, FALSE, 2);
                  gchar *pathname = g_new0(char, 512);
                  int j;
                  for(j=0; j<=i; j++)
                  {
                      if (!str_white(dirs[j]))
                      {
                          AppendiStringa(pathname, 512, dirs[j]);
                          AppendiStringa(pathname, 512, G_DIR_SEPARATOR_S);
                      }
                      else
                          AppendiStringa(pathname, 512, G_DIR_SEPARATOR_S);
                  }
                  hnd = g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(selected_dir),
                      DuplicaStringa(pathname));
                  g_object_set_data(G_OBJECT(button), "hnd", GINT_TO_POINTER(hnd));
                  gtk_widget_set_name(button, pathname);
                  g_free(pathname);
                  gtk_widget_show(button);
              }
              i++;
         }
         g_strfreev(dirs);
      }
      }
    }
    else                                       /* files */
    {
//       std::string ext2 = "*";
//       ext2.append(ext);
//       clistfilesNew(ext2.c_str(), Files);
       clistfilesNew(exten.c_str(), Files);
#ifdef GTK_ENTRY_COMPLETION
       if( get_object(gtk_widget_get_toplevel(listad), "completion") != NULL )
       {
           GtkEntryCompletion *completion = (GtkEntryCompletion *)
                 get_object(gtk_widget_get_toplevel(listad), "completion");
           GtkTreeModel *completion_model = gtk_entry_completion_get_model (completion);
           fill_completion_model (completion_model, Files);
       }
#endif
    }

    if(ifDir)                                   // directories 
    {
         direntry->text = DuplicaStringa("Home");
         direntry->icon = homebuf;
         add_line_to_list(listad, (gpointer) direntry);
         const char *r = g_path_skip_root(g_get_current_dir());
         if(strlen(r) > 0)
         {
            direntry->text = DuplicaStringa("..");
            direntry->icon = upperbuf;
            add_line_to_list(listad, (gpointer) direntry);
         }
    }
    for(unsigned int i=0; i < Files.size(); i++)
    {
       CopiaStringa(riga, MaxLenFilename, Files[i].filename.c_str());
       rigap = g_strchomp(riga);
       CopiaStringa(riga, sizeof(riga), filtra(rigap,"\n"));
       if(ifDir)
       {
           if(mr_access(rigap, 'r') == 0)
              direntry->icon = cartlbuf;
           else
              direntry->icon = cartbuf;
           direntry->text = rigap;
           add_line_to_list(listad, (gpointer) direntry);
       }
       else if((int) exten.find(".gru") != -1)
       {
           direntry->text = rigap;
           direntry->icon = grpbuf;
           add_line_to_list(listad, (gpointer) direntry);
       }
       else
       {

           if((int) exten.find(".prj") != -1)
           {
              std::string rigatmp = riga;
              CopiaStringa(riga, sizeof(riga), rigatmp.substr(0, rigatmp.find("_sir.")).c_str());
           }

           filentry.filename = rigap;
           filentry.mtime    = Files[i].mtime.c_str();
           filentry.mtime_n  = Files[i].mtime_n;
           add_line_to_listNew(listad, &filentry);
       }
    }

#ifdef _WIN32
    if(ifDir)                                   // directories 
       aggiungi_drv(listad);
#endif
    adj = gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(
                    get_widget(listad, "scrollwin")));
    gtk_adjustment_set_value (adj,0.);
    gtk_scrolled_window_set_vadjustment(GTK_SCROLLED_WINDOW(
                    get_widget(listad, "scrollwin")), adj);
}

void dir_selected(GtkTreeView *tree_view, GtkTreePath *path,
                   GtkTreeViewColumn *, gpointer user_data)
{
     PixText *info;
     gchar *newdir = g_new0(char, MaxLenFilename);

     info = (PixText *) get_selection_from_path(tree_view, path);
     ScriviStringa(newdir, MaxLenFilename, "%s", info->text);
     if(strcmp(newdir, "Home") == 0)
        CopiaStringa(newdir, MaxLenFilename, g_get_home_dir());
     change_dir(newdir, (GtkWidget *)tree_view, user_data);
}

void fil_selected(GtkTreeSelection  *sele, gpointer )
{
     GtkTreeView *tree_view;
     int row;
     gchar *filenam = g_new0(char, MaxLenFilename);
     gchar *fullfilename;
     GtkWidget *label;

     tree_view = gtk_tree_selection_get_tree_view(sele);
     if(get_selection_mode(GTK_WIDGET(tree_view)) == GTK_SELECTION_MULTIPLE)
        return; 
     row = row_selected(sele);
     if(row != -1)
     {
        CopiaStringa(filenam, MaxLenFilename, get_selected_row(GTK_WIDGET(tree_view)));
     fullfilename = g_new0(char, MaxLenFilename);
     label = get_widget(GTK_WIDGET(tree_view), "filnam");
     CopiaStringa(fullfilename, MaxLenFilename, filenam);
     if(GTK_IS_ENTRY(label))
          gtk_entry_set_text((GtkEntry *) label, fullfilename);
     else
          gtk_label_set_text (GTK_LABEL(gtk_bin_get_child(GTK_BIN(label))),
                     fullfilename);
     }
}

void fil_selected_m(GtkTreeView *tree_view, GtkTreePath *path,
                  GtkTreeViewColumn *, gpointer )
{

     gchar *filenam = g_new0(char, MaxLenFilename);
     gchar *fullfilename;
     GtkWidget *label;

     if(get_selection_mode(GTK_WIDGET(tree_view)) != GTK_SELECTION_MULTIPLE)
        return; 
     filenam = (char *)get_selection_from_path(tree_view, path);

     fullfilename = g_new0(char, MaxLenFilename);
     label = get_widget(GTK_WIDGET(tree_view), "filnam");
     CopiaStringa(fullfilename, MaxLenFilename, filenam);
     if(GTK_IS_ENTRY(label))
          gtk_entry_set_text((GtkEntry *) label, fullfilename);
     else
          gtk_label_set_text (GTK_LABEL(gtk_bin_get_child(GTK_BIN(label))),
                     fullfilename);
}

void change_default(GtkWidget *list)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    PixText *info;
    gpointer data;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GtkTreeSelection *selec = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
    GtkWidget *dlg = gtk_widget_get_toplevel(list);
                                                                                
    list_store = GTK_LIST_STORE(model);
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    while (valid)
    {
       gtk_tree_model_get (model, &iter, 0, &data, -1);
       info = (PixText *) data;
       if(gtk_tree_selection_iter_is_selected(selec, &iter))
          info->icon = get_pixbuf(dlg, 'D');
       else
          info->icon = get_pixbuf(dlg, 'C');
       gtk_list_store_set (list_store, &iter, 0, (gpointer) info,-1);
       valid = gtk_tree_model_iter_next (model, &iter);
    }
}
                                                                                
void check_default(GtkWidget *list, const char *filename)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    PixText *info;
    gpointer data;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GtkTreeSelection *selec = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
    GtkWidget *dlg = gtk_widget_get_toplevel(list);

    list_store = GTK_LIST_STORE(model);
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    while (valid)
    {
       gtk_tree_model_get (model, &iter, 0, &data, -1);
       info = (PixText *) data;
       char *nome = NULL;
       nome = g_build_filename(g_get_current_dir(), info->text, NULL);
       if(strcmp(nome, filename) == 0)
       {
           gtk_tree_selection_select_iter(selec, &iter);
           info->icon = get_pixbuf(dlg, 'D');
       }
       else
       {
           gtk_tree_selection_unselect_iter(selec, &iter);
           info->icon = get_pixbuf(dlg, 'C');
       }
       gtk_list_store_set (list_store, &iter, 0, (gpointer) info,-1);
       valid = gtk_tree_model_iter_next (model, &iter);
    }
}

void ok_edit  (GtkButton  *button, gpointer )
{
  GtkWidget *editw, *textw;
  char *buffer,*inpFile;
  FILE *fp;
  GtkTextIter start, end;
  GtkTextBuffer *text_buffer;

  editw = gtk_widget_get_toplevel(GTK_WIDGET(button));
  textw = get_widget(editw, "testo");
  inpFile = get_string(editw, "nome");
  text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (textw));
  gtk_text_buffer_get_bounds (text_buffer, &start, &end);
  buffer = g_strdup(fromUTF8(gtk_text_iter_get_text (&start, &end)).c_str());
  fp = fOpen(inpFile, "w");
  (void) fputs(buffer, fp);
  (void) fclose(fp);
  g_free(buffer);
 
  gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
/* riabilitiamo la file selection */
  gtk_widget_set_sensitive(filesel_w, TRUE);
}

void cancel_edit  (GtkButton  *button, gpointer data)
{

  gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
  if(GPOINTER_TO_INT(data))
  {
      gtk_widget_set_sensitive(filesel_w, TRUE);
  }

}

void modify_filsel (GtkWidget *widget, gpointer )
{
      GtkWidget *listaf, *combo;

      listaf = get_widget(gtk_widget_get_toplevel(widget), "filsel");
      combo = get_widget(gtk_widget_get_toplevel(widget), "combo_fil");
      std::string ent = combo_get_text(get_widget(combo, "entry"));
      if(strstr(ent.c_str(), "All"))
         g_object_set_data(G_OBJECT(listaf), "filtro", DuplicaStringa(".*"));
      else
      {
         int iposi = (int) ent.find(".");
         if (iposi != -1)
             g_object_set_data(G_OBJECT(listaf), "filtro", DuplicaStringa(ent.substr(iposi).c_str()));
         else
             g_object_set_data(G_OBJECT(listaf), "filtro", DuplicaStringa(".*"));
      }
      FillList(listaf);
}

void on_cancel_filesel (GtkButton  *, gpointer )
{
     it.exitCode = 0;
}

void on_ok_filesel (GtkWidget  *window, gpointer usr)
{
     gchar *inpFile = g_new0(char, MaxLenFilename);
     gchar *outFile = g_new0(char, MaxLenFilename);
     gchar *cwd     = g_new0(char, MaxLenFilename);
     gchar *exten   = g_new0(char, 5);
     GtkWidget *myEntry;
   
     int flags;
     const gchar *fn;
     GtkWidget *entry;

     it.exitCode = 1;
     flags = GPOINTER_TO_INT(usr);
     entry = get_widget(GTK_WIDGET(window), "inp_txt");
     fn = gtk_entry_get_text(GTK_ENTRY(entry)) ;
     if(str_white(fn))
     {
        it.exitCode = 0;
        return;
     }
     if( (flags == eSELECT_DIR) ||  (flags == eSELECT_TO_READ) || (flags == eSELECT_ALIEN) ) {
          if(!g_file_test(fn, G_FILE_TEST_EXISTS))
          {
             gtk_window_set_modal(GTK_WINDOW(window), FALSE);
             gtkext::dlg_errmsg(GTK_WINDOW(window), "The selection '%s' does not exist", fn);
             gtk_window_set_modal(GTK_WINDOW(window), TRUE);
             it.exitCode = 0;
             return;
          }
          if(flags != eSELECT_ALIEN){
          if(mr_access(fn, 'm') == 0){
             gtk_window_set_modal(GTK_WINDOW(window), FALSE);
             gtkext::dlg_errmsg(GTK_WINDOW(window), "The selection '%s' is write-protected", fn);
             gtk_window_set_modal(GTK_WINDOW(window), TRUE);
             it.exitCode = 0;
             return;
          }
          }
     }
     
     if( flags == eSELECT_DIR ) {
       if( !g_file_test(fn, G_FILE_TEST_IS_DIR) ) {
        gtk_window_set_modal(GTK_WINDOW(window), FALSE);
        gtkext::dlg_errmsg(GTK_WINDOW(window), "The selection '%s' does not exist or is not a directory", fn);
        gtk_window_set_modal(GTK_WINDOW(window), TRUE);
        it.exitCode = 0;
       }
     }
     else if ( (flags != eSELECT_NP ) && (flags !=eSELECT_ALIEN) ){
       gboolean exists = g_file_test(fn, G_FILE_TEST_EXISTS);
       if( flags == eSELECT_TO_READ ) {
         if( !exists ) {
           gtk_window_set_modal(GTK_WINDOW(window), FALSE);
           gtkext::dlg_errmsg(GTK_WINDOW(window), "The file '%s' does not exist", fn);
           gtk_window_set_modal(GTK_WINDOW(window), TRUE);
           it.exitCode = 0;
         }
       }
       else {
         if( exists ) {
           gtk_window_set_modal(GTK_WINDOW(window), FALSE);
           if( !gtkext::dlg_yesno(GTK_WINDOW(window), "The file '%s' already exists. Do you want to overwrite it?", fn) )
              it.exitCode = 0;
           gtk_window_set_modal(GTK_WINDOW(window), TRUE);
         }
       }
     }
//     gtk_widget_show(GTK_WIDGET(window));

     if(!it.exitCode)
         return;

     gtk_widget_hide(GTK_WIDGET(window));
     myEntry = get_widget(window, "cwd_txt");
     ScriviStringa(cwd, MaxLenFilename, "%s",  
         gtk_editable_get_chars((GtkEditable *) myEntry, 0, -1));
     dir_set_current(cwd);
     if( (mr_access(cwd, 'm') == 0) && (flags != eSELECT_ALIEN) ){
        gtk_window_set_modal(GTK_WINDOW(window), FALSE);
        gtkext::dlg_errmsg(GTK_WINDOW(window), "The directory '%s' is write-protected", cwd);
        gtk_window_set_modal(GTK_WINDOW(window), TRUE);
        it.exitCode = 0;
        return;
     }
     ScriviStringa(it.cwd, MaxLenFilename, "%s", cwd);;
     if(it.ifDirOnly)
           return;

     if(it.ifMultiple)
     {
        myEntry = get_widget(window, "filsel");
        it.selection = copy_selection_to_list(myEntry);
        return;
     }
/*
     myEntry = get_widget(window, "inp_txt");
     (void) ScriviStringa(inpFile, "%s", g_strstrip( 
         gtk_editable_get_chars((GtkEditable *) myEntry, 0, -1)));
     if(!strlen(inpFile))
     {
        it.exitCode = 0;
        return;
     }
*/
     ScriviStringa(inpFile, MaxLenFilename, "%s", g_strstrip((char *)fn));
     if(it.ifOutput)
     {
        myEntry = get_widget(window, "out_txt");
        ScriviStringa(outFile, MaxLenFilename, "%s", g_strstrip( 
             gtk_editable_get_chars((GtkEditable *) myEntry, 0, -1)));
     }

     exten = get_string(filesel_w, "tipo");
     if(it.ifSave)
     {
        if(!strstr(inpFile, "."))         // manca l'estensione
        {
           if(strstr(exten, "prj"))
              AppendiStringa(inpFile, MaxLenFilename, "_sir");
           AppendiStringa(inpFile, MaxLenFilename, ".");
           AppendiStringa(inpFile, MaxLenFilename, exten);
        }
     }
     else if(!strstr(inpFile, ".") && strstr(exten, "prj"))
     {
           AppendiStringa(inpFile, MaxLenFilename, "_sir");
           AppendiStringa(inpFile, MaxLenFilename, ".");
           AppendiStringa(inpFile, MaxLenFilename, exten);
     }
     myEntry = get_widget(window, "inp_txt");
     gtk_entry_set_text(GTK_ENTRY(myEntry), inpFile);
     CopiaStringa(it.fileinp, MaxLenFilename, inpFile);
     if (flags != eSELECT_TO_WRITE )
         CopiaStringa(it.fileout, MaxLenFilename, outFile);
     it.exitCode = 1;
}

void on_view_filesel (GtkWidget *button, gpointer user_data)
{
  gchar *inpFile = g_new0(char, sizeof(char)*MaxLenFilename);
  GtkWidget *myEntry, *top_w;
  int ep;

  top_w = gtk_widget_get_toplevel(button);
  ep = GPOINTER_TO_INT(user_data);   
//  gtk_widget_hide(top_w);

  if(ep != -1)
  {
     myEntry = get_widget(top_w, "inp_txt");

     ScriviStringa(inpFile, MaxLenFilename, "%s",
        gtk_editable_get_chars((GtkEditable *) myEntry, 0, -1));
      if(str_white(inpFile))
         return;
      gtk_widget_hide(top_w);
      char *tmp = get_filt(inpFile);
      if(ep == 1)
         text_window(GTK_WINDOW(top_w), inpFile, tmp, IFPROP + IFSAVE + IFREADONLY, inpFile);
      else
         text_window(GTK_WINDOW(top_w), inpFile, tmp, IFPROP + IFSAVE, inpFile);
      g_free(tmp);
  }
  else
  {
     gtk_widget_hide(top_w);
     ScriviStringa(inpFile, MaxLenFilename, " ");
     text_window(GTK_WINDOW(top_w), NULL, "*.*", 1, NULL);
  }
  gtk_widget_show(top_w);

  
}

#ifndef USE_GTK_FILECHOOSER
void sort_col(GtkWidget *column, gpointer data)
{
    FileInfo file;
    std::vector<FileInfo> Files;
    int ncol = GPOINTER_TO_INT(data);
    int ordin = get_int(column, "set_order");
    GtkWidget *treeview = get_widget(column, "father");
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
    GtkListStore *list_store = GTK_LIST_STORE(model);
    GtkTreeIter iter;
    char *f1, *f2, *f3;

    if(ordin > 0)
       ordin = -1;
    else
       ordin = 1;
    g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(ordin));
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    Files.clear();
    while (valid)
    {
       f1 = g_new0(char, MaxLenFilename);
       f2 = g_new0(char, 30);
       f3 = g_new0(char, 30);
       gtk_tree_model_get (model, &iter, 0, &f1, 1, &f2, 
                  2, &f3, -1);
       valid = gtk_tree_model_iter_next (model, &iter);
       file.filename = f1;
       file.mtime = f2;
       file.mtime_n = f3;
       Files.push_back (file);
       g_free(f1);
       g_free(f2);
       g_free(f3);
    }
    if(ncol == 0)
    {
       if(ordin == -1)
          sort( Files.begin( ), Files.end( ), alphasmaller2 );
       else
          sort( Files.begin( ), Files.end( ), alphagreater2 );
    }
    else
    {
       if(ordin == -1)
          sort( Files.begin( ), Files.end( ), alphasmaller3 );
       else
          sort( Files.begin( ), Files.end( ), alphagreater3 );
    }
    valid = gtk_tree_model_get_iter_first (model, &iter);
    int i = 0;
    while (valid)
    {
       file = Files[i];
       gtk_list_store_set (list_store, &iter, 0, (gpointer) file.filename.c_str(), 
                  1, (gpointer) file.mtime.c_str(), 
                  2, (gpointer) file.mtime_n.c_str(), -1);
       i++;
       valid = gtk_tree_model_iter_next (model, &iter);
    }
}

GtkWidget *create_fileselectionNew(void)
{
  GtkWidget *filesel;
  GtkWidget *vbox1;
  GtkWidget *label;
  GtkWidget *cwd_txt;
  GtkWidget *hbox1;
  GtkWidget *dirsel;
  GtkWidget *filsel;
  GtkWidget *hbox2, *hbox3;
  GtkWidget *combo_fil;
  GtkWidget *inp_txt, *out_txt;
  GtkWidget *ok_filesel;
  GtkWidget *go_filesel;
  GtkWidget *cancel_filesel;
  GtkWidget *edit_filesel;
  GtkWidget *frame, *align;
  GtkWidget *preview_button;
  GtkTreeSelection *selection;
  char *labstr;
  const char *titoli[] = {"Files", "Modified", " "};
  int i, dimens[] = {250, 80, -1};

  filesel = gtk_dialog_new ();
  gtk_window_set_position(GTK_WINDOW(filesel), GTK_WIN_POS_MOUSE);
  gtk_window_set_default_size(GTK_WINDOW(filesel), 650,400);
  gtk_container_set_border_width (GTK_CONTAINER (filesel), 4);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(filesel));
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 8);

/* Working directory */
  labstr = g_strdup_printf("Current _Directory");
  label = LABEL_NEW (labstr, LABELCOLOR);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox1), label, FALSE, FALSE, 2);
  set_alignment (label, 0.0f, 0.5f);

  cwd_txt = gtk_entry_new();
  g_object_set_data (G_OBJECT (filesel), "cwd_txt", cwd_txt);
  gtk_editable_set_editable(GTK_EDITABLE(cwd_txt), FALSE);
//  gtk_widget_show (cwd_txt);
  gtk_box_pack_start (GTK_BOX (vbox1), cwd_txt, FALSE, FALSE, 2);
//  gtk_label_set_mnemonic_widget(GTK_LABEL(label), cwd_txt);

  hbox1 = hbox_new(FALSE, 0);
  gtk_widget_show (hbox1);
  g_object_set_data (G_OBJECT (filesel), "cwd_box", hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, FALSE, 2);

  hbox1 = hpaned_new();
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 4);
  g_object_set_data (G_OBJECT (filesel), "paned", hbox1);
//  gtk_paned_set_position (GTK_PANED (hbox1), 300);

/*       directories  & files list */

  frame = gtk_frame_new(NULL);
  g_object_set_data(G_OBJECT(filesel), "left", frame);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
  gtk_paned_pack1((GtkPaned *)hbox1, frame, TRUE, FALSE);
  gtk_widget_show(frame);
  dirsel = createSelection(filesel, frame, "Directories", "dirsel", 11, LABELCOLOR);
  g_object_set_data (G_OBJECT (dirsel), "filnam", cwd_txt);
  g_object_set_data (G_OBJECT (dirsel), "cwd_box", get_widget(filesel, "cwd_box"));
  g_object_set_data(G_OBJECT(dirsel), "filtro", DuplicaStringa(".dir"));
  GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(dirsel), 0);
  gtk_tree_view_column_set_sizing (column,GTK_TREE_VIEW_COLUMN_FIXED);
  gtk_tree_view_column_set_fixed_width(column, 180);

  frame = gtk_frame_new(NULL);
  g_object_set_data(G_OBJECT(filesel), "right", frame);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
  gtk_paned_pack2((GtkPaned *)hbox1, frame, TRUE, FALSE);
  gtk_widget_show(frame);
  filsel = new_selection(filesel, frame, "filsel", 3, titoli,  dimens);
  g_object_set_data(G_OBJECT(filsel), "filtro",  DuplicaStringa(".*"));
  g_object_set_data (G_OBJECT(dirsel), "lf", filsel);
  for(i=0; i<2; i++)
  {
      column = gtk_tree_view_get_column(GTK_TREE_VIEW(filsel), i);
      gtk_tree_view_column_set_clickable(column, TRUE);
      g_signal_connect(G_OBJECT(column), "clicked", G_CALLBACK(sort_col), 
                 GINT_TO_POINTER(i));
      g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(1-i));
      g_object_set_data(G_OBJECT(column), "father", filsel);
  }
  gtk_widget_show_all(filsel);

  hbox2 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, FALSE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(hbox2), 0);

  align = gtk_alignment_new(0, 0.5, 1, 0);
  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (hbox2), align, FALSE, FALSE, 0);

  hbox3 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_container_add(GTK_CONTAINER(align), hbox3);

/* combo file filter */

  label = LABEL_NEW ("File _filter", LABELCOLOR);
  gtk_widget_show (label);
  g_object_set_data(G_OBJECT (filesel), "label_fil", label);
  gtk_box_pack_start(GTK_BOX (hbox3), label, FALSE, FALSE, 0);
  set_alignment (label, 0.0f, 0.5f);
  combo_fil = create_combo_str (G_CALLBACK(modify_filsel), NULL);
  gtk_label_set_mnemonic_widget(GTK_LABEL(label), combo_fil);
  gtk_widget_set_size_request(combo_fil, 90, 26);
  gtk_editable_set_editable(GTK_EDITABLE(get_widget(combo_fil, "entry")), TRUE);

  gtk_container_set_border_width(GTK_CONTAINER(combo_fil), 4);
  gtk_box_pack_start(GTK_BOX(hbox3), combo_fil, FALSE, FALSE, 0);
  gtk_widget_show(combo_fil);

  g_object_set_data(G_OBJECT (filesel), "combo_fil", combo_fil);
//  gtk_widget_set_size_request(combo_fil, 90, 30);

  preview_button = myimage_button("Preview", "preview.png");
  gtk_widget_show(preview_button);
  gtk_box_pack_end (GTK_BOX (hbox2), preview_button, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (preview_button), 4);
  set_tip (preview_button, "Click to preview");
  g_object_set_data(G_OBJECT (filesel), "preview", preview_button);
  
  GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("Transparent", MyBLUE);
  gtk_box_pack_start(GTK_BOX(vbox1), check, FALSE, TRUE, 8);
  g_object_set_data(G_OBJECT(filesel), "alphacheck", check);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_alpha), NULL);
  gtk_widget_show(check);

  labstr = g_strdup_printf("_Input Filename");
  label = LABEL_NEW (labstr, LABELCOLOR);
  g_object_set_data(G_OBJECT (filesel), "labelw", label);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox1), label, FALSE, FALSE, 8);
  set_alignment (label, 0.0f, 0.5f);

  inp_txt = gtk_entry_new();
  gtk_editable_set_editable((GtkEditable *) inp_txt, FALSE);
  g_object_set_data(G_OBJECT (filesel), "inp_txt", inp_txt);
  g_object_set_data (G_OBJECT (filsel), "filnam", inp_txt);
  gtk_widget_show (inp_txt);
  gtk_box_pack_start (GTK_BOX (vbox1), inp_txt, FALSE, FALSE, 2);
  gtk_label_set_mnemonic_widget(GTK_LABEL(label), inp_txt);

  labstr = g_strdup_printf("_Output Filename");
  label = LABEL_NEW (labstr, LABELCOLOR);
  g_object_set_data(G_OBJECT (filesel), "labelo", label);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox1), label, FALSE, FALSE, 8);
  set_alignment (label, 0.0f, 0.5f);

  out_txt = gtk_entry_new();
  g_object_set_data (G_OBJECT (filesel), "out_txt", out_txt);
  gtk_widget_show (out_txt);
  gtk_box_pack_start (GTK_BOX (vbox1), out_txt, FALSE, FALSE, 2);
  gtk_label_set_mnemonic_widget(GTK_LABEL(label), out_txt);

//  hbox1 = gtk_dialog_get_action_area(GTK_DIALOG(filesel));
//  g_object_set_data (G_OBJECT (filesel), "bottoni", hbox1);
  
  ok_filesel = myimage_button("   _OK", "ok.png");
  g_object_set_data (G_OBJECT (filesel), "ok_filesel", ok_filesel);
  gtk_dialog_add_action_widget(GTK_DIALOG(filesel), ok_filesel, GTK_RESPONSE_OK); 
  gtk_widget_show (ok_filesel);
  hbox1 = gtk_widget_get_parent(ok_filesel);
  g_object_set_data (G_OBJECT (filesel), "bottoni", hbox1);

  go_filesel = myimage_button("", "go.png");
  g_object_set_data (G_OBJECT (filesel), "go_filesel", go_filesel);
  gtk_dialog_add_action_widget(GTK_DIALOG(filesel), go_filesel, GO); 

  cancel_filesel = myimage_button("  _Cancel", "cancel.png");
  g_object_set_data (G_OBJECT (filesel), "cancel_filesel", cancel_filesel);
  gtk_dialog_add_action_widget(GTK_DIALOG(filesel), cancel_filesel, GTK_RESPONSE_CANCEL); 
  gtk_widget_show (cancel_filesel);

  edit_filesel = myimage_button("  _Edit", "edit.png");
  g_object_set_data(G_OBJECT (filesel), "edit_filesel", edit_filesel);
  gtk_dialog_add_action_widget(GTK_DIALOG(filesel), edit_filesel, EDIT); 
  gtk_widget_show (edit_filesel);

  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(dirsel));
  (void) g_signal_connect (G_OBJECT (dirsel), "row_activated",
                      G_CALLBACK (dir_selected),
                      (gpointer) "non_null");
  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(filsel));
  (void) g_signal_connect (G_OBJECT (filsel), "row_activated",
                      G_CALLBACK (fil_selected_m), NULL);
  (void) g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (fil_selected), NULL);
  (void) g_signal_connect (G_OBJECT (preview_button), "clicked",
			G_CALLBACK (on_view_filesel),
			GINT_TO_POINTER(1));

  (void) g_signal_connect (G_OBJECT (inp_txt), "changed",
                      G_CALLBACK (modify_outf),
                      NULL);
  (void) g_signal_connect (G_OBJECT (inp_txt), "activate",
                      G_CALLBACK (modify_filter),
                      NULL);
#ifdef GTK_ENTRY_COMPLETION
  GtkEntryCompletion *completion = gtk_entry_completion_new ();
  gtk_entry_set_completion (GTK_ENTRY (inp_txt), completion);
  g_object_set_data (G_OBJECT (filesel), "completion", completion);
  g_object_unref (completion);
  GtkTreeModel *completion_model = create_completion_model ();
  gtk_entry_completion_set_model (completion, completion_model);
  g_object_unref (completion_model);
  gtk_entry_completion_set_text_column (completion, 0);
#endif
  riempi_listNew(dirsel);
  return filesel;
}

void file_open_mr (FilselItem *local_it, bool showT)
{

    GtkWidget *combo_fil, *listaf, *edit, *listad, *myEntry, 
              *go, *ok, *box, *labelw, *labelo, *hbox1;
    const char *ext[2];
    gboolean editable;
    int response;
    e_select_type flags;

    it = *local_it;
    if(it.ifSave)
    {
       editable = TRUE;
       flags = eSELECT_TO_WRITE;
    }
    else
    {
       editable = FALSE;
       flags = eSELECT_TO_READ;
    }
    if(it.ifDirOnly)
       flags = eSELECT_DIR;
    if(strstr(it.label, "Structure name"))
       flags = eSELECT_NP;
    if(strstr(it.title, "Select executable"))
       flags = eSELECT_ALIEN;
    ext[0] = it.filter;
    
    if (filesel_w == NULL)
    {
        filesel_w = create_fileselectionNew ();
#ifndef GTK_TOOLTIP
        GtkTooltips *fsToolTips = gtk_tooltips_new();
        g_object_set_data(G_OBJECT(filesel_w), "tt", fsToolTips);
#endif

        hbox1 = get_widget(filesel_w, "paned");
        gtk_paned_set_position (GTK_PANED (hbox1), 300);

//        filesel_w = create_fileselection ();
    }
    else if (gtk_widget_get_visible(filesel_w))
    {
        gdk_window_raise (gtk_widget_get_window(filesel_w));
        return;
    }

    gtk_window_set_title (GTK_WINDOW (filesel_w), it.title);
    g_object_set_data(G_OBJECT(filesel_w), "tipo", (char*)(ext[0]+2));
    myEntry = get_widget(filesel_w, "preview" );
    if(it.ifPreview)
       gtk_widget_show(myEntry);
    else
       gtk_widget_hide(myEntry);
    myEntry = get_widget(filesel_w, "alphacheck" );
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(myEntry), FALSE);
    it.ifAlpha = FALSE;
    if(it.ifSave && strstr(it.filter, "png") && showT)
       gtk_widget_show(myEntry);
    else
       gtk_widget_hide(myEntry);
    combo_fil = get_widget(filesel_w, "combo_fil");
    listaf    = get_widget(filesel_w, "filsel");
    listad    = get_widget(filesel_w, "dirsel");
    edit      = get_widget(filesel_w, "edit_filesel");
    go        = get_widget(filesel_w, "go_filesel");
    ok        = get_widget(filesel_w, "ok_filesel");
    box       = get_widget(filesel_w, "bottoni");
    labelw    = get_widget(filesel_w, "labelw");
    labelo    = get_widget(filesel_w, "labelo");
    ext[1]    = "All files";

    block_handler(combo_fil);
    fill_combo(combo_fil, ext, 2, 1);
    unblock_handler(combo_fil);

    g_object_set_data(G_OBJECT(listaf), "filtro", (char*) (ext[0]+1));
    FillList(listad);
    FillList(listaf);

    myEntry = get_widget(filesel_w, "inp_txt" );
    gtk_editable_set_editable(GTK_EDITABLE(myEntry), editable);
    gtk_editable_set_editable(GTK_EDITABLE(myEntry), TRUE);    // sperimentale
//    if(it.ifSave && it.fileinp)
    if(it.fileinp)
       gtk_entry_set_text( (GtkEntry *) myEntry, it.fileinp);
    else
       gtk_entry_set_text( (GtkEntry *) myEntry, "");
    if(it.ifEditable)
       gtk_widget_show(edit);
    else
       gtk_widget_hide(edit);
    if(it.ifExe)
    {
         gtk_widget_hide(ok);
         gtk_box_reorder_child(GTK_BOX(box), go, 0);
         gtk_box_reorder_child(GTK_BOX(box), edit, 1);
         gtk_widget_show(go);
    }
    else
    {
         gtk_widget_hide(go);
         gtk_box_reorder_child(GTK_BOX(box), ok, 0);
         gtk_widget_show(ok);
    }

    myEntry = get_widget(filesel_w, "out_txt" );
    if(it.ifOutput)
    {
        gtk_widget_show(labelo);
        gtk_widget_show(myEntry);
    }
    else
    {
        gtk_widget_hide(labelo);
        gtk_widget_hide(myEntry);
    }
    
    if(it.ifDirOnly)
    {
        gtk_widget_hide(get_widget(filesel_w, "right"));
        gtk_widget_hide(get_widget(filesel_w, "label_fil"));
        gtk_widget_hide(get_widget(filesel_w, "inp_txt"));
        gtk_widget_hide(combo_fil);
        gtk_widget_hide(labelw);
    }
    else
    {
        gtk_widget_show(get_widget(filesel_w, "right"));
        gtk_widget_show(get_widget(filesel_w, "label_fil"));
        gtk_widget_show(get_widget(filesel_w, "inp_txt"));
        gtk_widget_show(combo_fil);
        gtk_widget_show(labelw);
    }
    if(it.nofilter)
    {
        gtk_widget_hide(get_widget(filesel_w, "label_fil"));
        gtk_widget_hide(combo_fil);
    }
    else
    {
        gtk_widget_show(get_widget(filesel_w, "label_fil"));
        gtk_widget_show(combo_fil);
    }
    set_label_text(labelw, it.label, LABELCOLOR, 0.9f);
    gtk_widget_show (filesel_w);

    if(it.ifMultiple)
       set_selection_mode(listaf, GTK_SELECTION_MULTIPLE);
    else
       set_selection_mode(listaf, GTK_SELECTION_SINGLE);

    gtk_window_set_modal(GTK_WINDOW(filesel_w), TRUE);
    if(it.window != NULL)
    {
       gtk_window_set_transient_for(GTK_WINDOW(filesel_w), GTK_WINDOW(it.window)); 
       setSmiley(it.window, "smil5.gif");
    }

    while(it.exitCode == 0)
    {
       response = gtk_dialog_run(GTK_DIALOG(filesel_w));
       switch(response)
       {
       case GTK_RESPONSE_OK:
       case GO:
            on_ok_filesel(filesel_w, reinterpret_cast<void*>(flags));
            *local_it = it;
//            gtk_widget_hide(filesel_w);  
            break;
       case GTK_RESPONSE_CANCEL:
       case GTK_RESPONSE_DELETE_EVENT:
            it.exitCode = -1;
            *local_it = it;
            gtk_widget_hide(filesel_w);    
            break;
       case EDIT:
            on_view_filesel(filesel_w, NULL);
       }
    }
    if(it.window != NULL)
       resetSmiley(it.window);
}
#endif

std::string GetTmpFile()
{
    gchar *confdir=NULL;
    std::string TmpFile = "";

    const gchar *dir = g_get_home_dir();
    if( dir==NULL )
      dir = g_get_current_dir();

    confdir = g_build_path(G_DIR_SEPARATOR_S, dir, "." PACKAGE, NULL);
    if( !g_file_test(confdir, G_FILE_TEST_IS_DIR) )
      dir_create(confdir);
    TmpFile = g_build_filename(confdir, "tmp.tmp", NULL);
    g_free(confdir);
    return TmpFile;
}

GtkWidget* create_about_dialog (GtkWidget *mwin, AboutItem *about_it)
{
  GtkWidget *dialog;
  GtkWidget *vbox;
  GtkWidget *box1;
  GtkWidget *box2;
  GtkWidget *pixmap;
  GtkWidget *button1;
  GtkWidget *label;
  GtkWidget *frame;

  dialog = gtk_dialog_new ();
  if(mwin != NULL)
  {
      g_object_set_data (G_OBJECT (dialog), "mainwindow", mwin);
      gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(mwin)); 
  }
  g_object_set_data (G_OBJECT (dialog), about_it->title, dialog);
  gtk_container_set_border_width (GTK_CONTAINER (dialog), 8);
  gtk_window_set_title (GTK_WINDOW (dialog), about_it->title);
  gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
  gtk_window_set_resizable (GTK_WINDOW (dialog), FALSE);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
  gtk_box_set_spacing (GTK_BOX (vbox), 8);

//  GtkWidget *align1 = gtk_alignment_new(0.5, 0.5, 0., 0.);
  box1 = hbox_new (FALSE, 4);
  box2 = vbox_new (FALSE, 4);
  gtk_box_set_spacing (GTK_BOX (box1), 8);
//  gtk_box_pack_end (GTK_BOX (box1), align1, TRUE, TRUE, 0);
//  gtk_container_add(GTK_CONTAINER(align1), box2);
  gtk_box_pack_end (GTK_BOX (box1), box2, TRUE, TRUE, 0);

  gtk_container_add (GTK_CONTAINER (vbox), box1);
 
  if(about_it->image != NULL)
  {
     frame = gtk_frame_new(NULL);
     gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_NONE);
     pixmap = create_image (about_it->image);
#ifdef IN_GTK3
     center_image(pixmap);
     gtk_container_add(GTK_CONTAINER(frame), pixmap);
#else
     GtkWidget *align = gtk_alignment_new(0.5, 0.5, 0., 0.);
     gtk_container_add(GTK_CONTAINER(frame), align);
     gtk_container_add(GTK_CONTAINER(align), pixmap);
     gtk_container_set_border_width (GTK_CONTAINER (align), 8);
#endif
     gtk_box_pack_start (GTK_BOX (box1), frame, TRUE, FALSE, 0);
  }

  if(about_it->text1 != NULL)
  {
     label = gtk_label_new(NULL);
     gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
     gtk_label_set_markup(GTK_LABEL(label), about_it->text1);
     gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
  }

  if(about_it->htext1 != NULL)
  {
     label = hypertext_new(about_it->htext1, about_it->browser);
     gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
     g_object_set_data(G_OBJECT(dialog), "htext1", label);
  }

  if(about_it->text2 != NULL)
  {
     label = gtk_label_new(NULL);
     gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
     gtk_label_set_markup(GTK_LABEL(label), about_it->text2);
     gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
  }

  if(about_it->htext2 != NULL)
  {
     label = hypertext_new(about_it->htext2, about_it->browser);
     gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
     g_object_set_data(G_OBJECT(dialog), "htext2", label);
  }

  if(about_it->text3 != NULL)
  {
     label = gtk_label_new(NULL);
     gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
     gtk_label_set_markup(GTK_LABEL(label), about_it->text3);
     gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
  }

  if(about_it->htext3 != NULL)
  {
     label = hypertext_new(about_it->htext3, about_it->browser);
     gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
     g_object_set_data(G_OBJECT(dialog), "htext3", label);
  }

  if(about_it->text4 != NULL)
  {
     label = gtk_label_new(NULL);
     gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
     gtk_label_set_markup(GTK_LABEL(label), about_it->text4);
     gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
  }

  if(about_it->htext4 != NULL)
  {
     label = hypertext_new(about_it->htext4, about_it->browser);
     gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
     g_object_set_data(G_OBJECT(dialog), "htext4", label);
  }

  if(about_it->text5 != NULL)
  {
     label = gtk_label_new(NULL);
     gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
     gtk_label_set_markup(GTK_LABEL(label), about_it->text5);
     gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
  }

  if(about_it->htext5 != NULL)
  {
     label = hypertext_new(about_it->htext5, about_it->browser);
     gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
     g_object_set_data(G_OBJECT(dialog), "htext5", label);
  }

  button1 = OK_button();
  gtk_widget_set_can_default (button1, TRUE);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog), button1,
                                   GTK_RESPONSE_OK);
  
  gtk_widget_grab_default (button1);

  {
     (void) g_signal_connect_swapped (G_OBJECT(button1), "clicked", 
                   G_CALLBACK(gtk_widget_hide) ,dialog);
     (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button1)); 
     (void) g_signal_connect (G_OBJECT (dialog), "delete_event",
                      G_CALLBACK(true_cb), NULL);
  }

  return dialog;
}

void mr_CopyDir(const char *srcdir, const char *dstdir, bool ifOverride)
{
    GDir *dir;
    const gchar *name;
    dir = g_dir_open (srcdir, 0, NULL);
    if (!dir)
      return;

    name = g_dir_read_name (dir);
    while (name != NULL)
    {
        gchar *srcpath, *dstpath;
        gboolean is_dir;
      
        if (name[0] != '.')
     	{
            srcpath = g_build_filename (srcdir, name, NULL);
            dstpath = g_build_filename (dstdir, name, NULL);
            is_dir = g_file_test (srcpath, G_FILE_TEST_IS_DIR);
            if(is_dir)
            {
               dir_create(dstpath);
               mr_CopyDir(srcpath, dstpath, ifOverride);
            }
            else if(!g_file_test(dstpath, G_FILE_TEST_EXISTS) || ifOverride)
               mr_CopyFile(srcpath, dstpath);
            g_free (srcpath);
            g_free (dstpath);
        }
        name = g_dir_read_name (dir);      
    }
    g_dir_close(dir);        
}

#ifdef USE_GTK_FILECHOOSER

void modifica_outfile(GtkFileChooser *chooser, GtkWidget *out_file)
{
    gchar *inpfile = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(chooser));
    if(!inpfile)
       return;
    gchar *filname = g_path_get_basename(inpfile);
    gchar *tmp = str_cut(filname, ".");
    std::string outf = tmp;
    outf.append(".out");
    gtk_entry_set_text( (GtkEntry *) out_file, outf.c_str());
    g_free(tmp);
    g_free(inpfile);
    g_free(filname);
}

const gchar *pref_estensione(FilselItem *it)
{
    int nfilt = it->nfilt;
    gchar *est = NULL;
    if(nfilt == -1)
       nfilt = 0;
    gchar **filts =  g_strsplit(it->filter, "@", 20);
    for(int j=0; filts[j]!=NULL; j++)
    {
        if(j != nfilt)
           continue;
        std::string tmp(filts[j]);
        size_t n1 = tmp.find_first_of("*");
        size_t n2 = tmp.find_last_of(")");
        if(n2 == std::string::npos)
           n2 = tmp.size();
        gchar *truefilt;
        if(n1 != std::string::npos)
           truefilt = DuplicaStringa(tmp.substr(n1, (n2-n1)).c_str());
        else
           truefilt = DuplicaStringa(tmp.substr(0, n2).c_str());

        gchar **mfilt =  g_strsplit(truefilt, ",", 20);
        if(strcmp(mfilt[0], "*.*"))
        {
           std::string f1 = mfilt[0];
           size_t found = f1.find_first_of(".*");
           while (found!=std::string::npos)
           {
              f1.erase(found,1);
              found = f1.find_first_of(".*",found);
           }
           est = g_strdup(f1.c_str());
        }
        g_strfreev(mfilt);
    }
    g_strfreev(filts);
    return est;
}
;
void prova(GtkComboBox *combo, FilselItem *local_it)
{
  GtkWidget *chooser = gtk_widget_get_toplevel(GTK_WIDGET(combo));
  //g_print("sel %d\n", gtk_combo_box_get_active(combo));
  
  int nf = gtk_combo_box_get_active(combo);
  if(nf < 0)
     return;
  std::string oldname = get_string(chooser, "filename");
  if(oldname.empty())
     return;
  size_t pos = oldname.find_last_of('.');
  std::string newname = oldname.substr(0, pos);
  local_it->nfilt = nf;
  const char *ext2 = pref_estensione(local_it);
  if(!str_white(ext2))
  {
     newname.append(".");
     newname.append(pref_estensione(local_it));
  }
  //g_print("%s\n", newname.c_str());
  gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER(chooser),  toUTF8(newname.c_str()));
  gtk_file_chooser_select_filename(GTK_FILE_CHOOSER(chooser),  toUTF8(newname.c_str()));
}

void find_combo(GtkWidget *vbox, FilselItem *local_it)
{
  GList *children = gtk_container_get_children(GTK_CONTAINER(vbox));
  GtkWidget *child = NULL;
  for(int i=0; i<(int) g_list_length(children); i++)
  {
        child = GTK_WIDGET(g_list_nth_data(children, i));
        if(GTK_IS_COMBO_BOX(child))
        {
           g_signal_connect(G_OBJECT(child), "changed", G_CALLBACK(prova), local_it);
           break;
        }
        else if(GTK_IS_CONTAINER(child))
           find_combo(child, local_it);
  }
}

GtkWidget *create_fileselection(GtkFileChooserAction action, GtkWindow *parent,
                                int ifPreview)
{
  GtkWidget *filesel = gtk_file_chooser_dialog_new ("File", parent, action, 
                       NULL, NULL, NULL);
  g_object_set_data(G_OBJECT (filesel), "chooser", filesel);

  //GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(filesel));
  //if(action == GTK_FILE_CHOOSER_ACTION_SAVE)
  //   find_combo(vbox);
  
  GtkWidget *vbox1 = hbox_new(FALSE, 4);
  gtk_widget_show (vbox1);
  gtk_file_chooser_set_extra_widget(GTK_FILE_CHOOSER(filesel), vbox1);

  GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("Transparent", MyBLUE);
  gtk_box_pack_start(GTK_BOX(vbox1), check, FALSE, TRUE, 8);
  g_object_set_data(G_OBJECT(filesel), "alphacheck", check);
  gtk_widget_show(check);

  GtkWidget *label = LABEL_NEW ("_Output Filename", MyBLUE);
  g_object_set_data(G_OBJECT (filesel), "labelo", label);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox1), label, FALSE, FALSE, 8);
  set_alignment (label, 0.0f, 0.5f);

  GtkWidget *out_txt = gtk_entry_new();
  g_object_set_data (G_OBJECT (filesel), "out_txt", out_txt);
  gtk_widget_show (out_txt);
  gtk_box_pack_start (GTK_BOX (vbox1), out_txt, FALSE, FALSE, 2);
  gtk_label_set_mnemonic_widget(GTK_LABEL(label), out_txt);

//  GtkWidget *hbox1 = gtk_dialog_get_action_area(GTK_DIALOG(filesel));
//  g_object_set_data (G_OBJECT (filesel), "bottoni", hbox1);
//  gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox1), GTK_BUTTONBOX_SPREAD);
  
  GtkWidget *ok_filesel = myimage_button("   _OK", "ok.png");
  g_object_set_data (G_OBJECT (filesel), "ok_filesel", ok_filesel);
  gtk_dialog_add_action_widget(GTK_DIALOG(filesel), ok_filesel, GTK_RESPONSE_OK); 
  gtk_widget_show (ok_filesel);
  gtk_widget_set_can_default (ok_filesel, TRUE);
  GtkWidget *hbox1 = gtk_widget_get_parent(ok_filesel);
  g_object_set_data (G_OBJECT (filesel), "bottoni", hbox1);
  if(GTK_IS_BUTTON_BOX(hbox1))
     gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox1), GTK_BUTTONBOX_SPREAD);
  gtk_widget_show (hbox1);

  GtkWidget *go_filesel = myimage_button("", "go.png");
  g_object_set_data (G_OBJECT (filesel), "go_filesel", go_filesel);
  gtk_dialog_add_action_widget(GTK_DIALOG(filesel), go_filesel, GO); 
  gtk_widget_set_can_default (go_filesel, TRUE);

  GtkWidget *cancel_filesel = myimage_button("  _Cancel", "cancel.png");
  g_object_set_data (G_OBJECT (filesel), "cancel_filesel", cancel_filesel);
  gtk_dialog_add_action_widget(GTK_DIALOG(filesel), cancel_filesel, GTK_RESPONSE_CANCEL); 
  gtk_widget_show (cancel_filesel);
  gtk_widget_set_can_default (cancel_filesel, TRUE);

  GtkWidget *edit_filesel = myimage_button("  _Edit", "edit.png");
  g_object_set_data(G_OBJECT (filesel), "edit_filesel", edit_filesel);
  gtk_dialog_add_action_widget(GTK_DIALOG(filesel), edit_filesel, EDIT); 
  gtk_widget_show (edit_filesel);
  gtk_widget_set_can_default (edit_filesel, TRUE);

  if(ifPreview)
  {
     GtkWidget *preview_button = myimage_button("Preview", "preview.png");
     gtk_widget_show(preview_button);
     gtk_dialog_add_action_widget(GTK_DIALOG(filesel), preview_button, VIEW); 
     set_tip (preview_button, "Click to preview");
     g_object_set_data(G_OBJECT (filesel), "preview", preview_button);
     gtk_widget_set_can_default (preview_button, TRUE);
  }
  return filesel;
}

GList *copy_slist_to_list(GtkWidget *chooser)
{
   GSList *rowsel;
   GList *list;
   int i, num_sel;

   list = NULL;
   rowsel = gtk_file_chooser_get_filenames(GTK_FILE_CHOOSER(chooser));
   if(rowsel)
   {
      num_sel = g_slist_length(rowsel);
      for(i=0; i<num_sel; i++)
          list = g_list_append(list, g_slist_nth_data(rowsel, i));
      g_slist_foreach (rowsel, (GFunc)g_free, NULL);
      g_slist_free (rowsel);
   }
   return list;
}

void mr_make_absolute_path(char *name, char *dirname)
{
    gchar *dirnam = g_path_get_dirname(name);
    gchar *basenam = g_path_get_basename(name);
    gchar *dirabs = g_new0(char, MaxLenFilename);

    gchar *tmp = g_get_current_dir();
    if(!g_path_is_absolute(dirnam))
    {
       if((dirname != NULL)  && (g_path_is_absolute(dirname)))
         CopiaStringa(dirabs, MaxLenFilename, dirname);
       else if(dirname != NULL)
       {
         if(strlen(dirname) == 1)
            CopiaStringa(dirabs, MaxLenFilename, tmp);
         else if(dirname[1] == G_DIR_SEPARATOR)
         {
            strshift(dirname, 2);
            ScriviStringa(dirabs, MaxLenFilename, "%s%c%s", tmp, G_DIR_SEPARATOR, dirname);
         }
         else if(dirname[2] == G_DIR_SEPARATOR)
         {
            strshift(dirname, 3);
            char *tmp1 = g_path_get_dirname(tmp);
            ScriviStringa(dirabs, MaxLenFilename, "%s%c%s", tmp1, G_DIR_SEPARATOR, dirname);
            g_free(tmp1);
         }
       }
       else
            CopiaStringa(dirabs, MaxLenFilename, tmp);
       std::string s = fromUTF8(dirabs);
       gchar *tmp1 = g_build_filename(s.c_str(), basenam, NULL);
       CopiaStringa(name, MaxLenFilename, tmp1);
       g_free(tmp1);
    }
    g_free(tmp);
    g_free(dirnam);
    g_free(basenam);
    g_free(dirabs);
}

void set_filter(GtkWidget *chooser, const char *filtro, gboolean ifAll, int default_filter)
{
    gchar **filts =  g_strsplit(filtro, "@", 20);
    for(int j=0; filts[j]!=NULL; j++)
    {
        GtkFileFilter *filter = gtk_file_filter_new ();
        std::string filtrostr = filts[j];
        size_t nf = filtrostr.find_first_of("!");
        if(nf != std::string::npos)
           gtk_file_filter_set_name(filter, filtrostr.substr(0, nf).c_str());
        else
           gtk_file_filter_set_name(filter, filts[j]);
        std::string tmp(filts[j]);
        size_t n1 = tmp.find_first_of("*");
        size_t n2 = tmp.find_last_of(")");
        if(n2 == std::string::npos)
           n2 = tmp.size();
        gchar *truefilt;
        if(n1 != std::string::npos)
           truefilt = DuplicaStringa(tmp.substr(n1, (n2-n1)).c_str());
        else
           truefilt = DuplicaStringa(tmp.substr(0, n2).c_str());
 
        gchar **mfilt =  g_strsplit(truefilt, ",", 20);
        for(int i=0; mfilt[i]!=NULL; i++)
        {
            size_t sz = strlen(mfilt[i])+1;
            gchar *filt = g_new0(char, sz);

            if(strcmp(mfilt[i], "*.*"))
               CopiaStringa(filt, sz, mfilt[i]);
            else
               CopiaStringa(filt, sz, "*");
            gtk_file_filter_add_pattern(filter, filt);
            g_free(filt);
        }
        g_strfreev(mfilt);
        g_free(truefilt);
        gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(chooser), filter);
        if(j==default_filter)
           gtk_file_chooser_set_filter  (GTK_FILE_CHOOSER(chooser), filter);
    }
    g_strfreev(filts);
    if(ifAll)
    {
       GtkFileFilter *filter = gtk_file_filter_new ();
       gtk_file_filter_set_name(filter, "All files");
       gtk_file_filter_add_pattern(filter, "*.*");
       gtk_file_chooser_add_filter (GTK_FILE_CHOOSER(chooser), filter);
    }
}

char *prima_estensione(const char *extensions)
{
using namespace std;
    string exte = extensions;
    size_t i = exte.find_first_of(',');
    if(i != string::npos)
    {
       char *pe = DuplicaStringa(exte.substr(0, i).c_str());
       return pe;
    }
    return DuplicaStringa(extensions);
}

void file_open_gtk (FilselItem *local_it, bool showT)
{

    GtkWidget *chooser, *myEntry, *edit, *go, *ok, *box, *labelo;
    int response;
    GtkFileChooserAction action;
    gchar *exten = NULL;
    int *default_filter;

    if(local_it->ifSave)
    {
       action = GTK_FILE_CHOOSER_ACTION_SAVE;
       default_filter = &default_filter_out;
    }
    else
    {
       action = GTK_FILE_CHOOSER_ACTION_OPEN;
       default_filter = &default_filter_inp;
    }
    if(local_it->ifDirOnly)
       action = GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER;
    
    chooser = create_fileselection(action, GTK_WINDOW(local_it->window),
                                   local_it->ifPreview);
  if(action == GTK_FILE_CHOOSER_ACTION_SAVE)
     find_combo(gtk_dialog_get_content_area(GTK_DIALOG(chooser)), local_it);
    if(local_it->ifOutput)
       g_signal_connect(G_OBJECT(chooser), "selection-changed",
                    G_CALLBACK(modifica_outfile), get_widget(chooser, "out_txt"));
    
#ifndef GTK_TOOLTIP
    GtkTooltips *fsToolTips = gtk_tooltips_new();
    g_object_set_data(G_OBJECT(chooser), "tt", fsToolTips);
#endif

    gtk_window_set_title (GTK_WINDOW (chooser), local_it->title);
    char *estensioni = get_exts_from_filter(local_it->filter);
    g_object_set_data(G_OBJECT(chooser), "tipo", estensioni);
    myEntry = get_widget(chooser, "alphacheck" );
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(myEntry), FALSE);
    local_it->ifAlpha = FALSE;
    if(local_it->ifSave && strstr(local_it->filter, "png") && showT)
       gtk_widget_show(myEntry);
    else
       gtk_widget_hide(myEntry);
    edit      = get_widget(chooser, "edit_filesel");
    go        = get_widget(chooser, "go_filesel");
    ok        = get_widget(chooser, "ok_filesel");
    box       = get_widget(chooser, "bottoni");
    labelo    = get_widget(chooser, "labelo");

    g_object_set_data(G_OBJECT(chooser), "filename", g_strdup (""));
    if(local_it->fileinp)
    {
       if(!str_white(local_it->fileinp))
       {
           char *abso = g_new0(char, MaxLenFilename);
           CopiaStringa(abso, MaxLenFilename, local_it->fileinp);
           mr_make_absolute_path(abso, local_it->cwd);
#ifdef DO_SETFILENAME
           gtk_file_chooser_set_filename (GTK_FILE_CHOOSER(chooser),  toUTF8(abso));
           if(action == GTK_FILE_CHOOSER_ACTION_SAVE) 
           {
              gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER(chooser), toUTF8(local_it->fileinp));
              g_object_set_data(G_OBJECT(chooser), "filename", g_strdup (toUTF8(local_it->fileinp)));
           }
           gtk_file_chooser_select_filename(GTK_FILE_CHOOSER(chooser),  toUTF8(abso));
#endif
           gchar *tmp = g_path_get_dirname(toUTF8(abso));
           gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER(chooser),  tmp);
           g_free(tmp);
           g_free(abso);
       }
       else 
       {
           char *abso = g_new0(char, MaxLenFilename);
           CopiaStringa(abso, MaxLenFilename, "*");
           if(!str_white(local_it->cwd))
               mr_make_absolute_path(abso, local_it->cwd);
           else
               mr_make_absolute_path(abso, g_get_current_dir());
           gtk_file_chooser_set_current_folder_uri(GTK_FILE_CHOOSER(chooser), toUTF8(g_path_get_dirname(abso)));
           gtk_file_chooser_set_filename (GTK_FILE_CHOOSER(chooser),  toUTF8(abso));
       }
    }
    else
       gtk_file_chooser_set_filename (GTK_FILE_CHOOSER(chooser),  "");

    if(local_it->ifEditable)
       gtk_widget_show(edit);
    else
       gtk_widget_hide(edit);

    myEntry = get_widget(chooser, "out_txt" );
    if(local_it->ifOutput)
    {
        gtk_widget_show(labelo);
        gtk_widget_show(myEntry);
    }
    else
    {
        gtk_widget_hide(labelo);
        gtk_widget_hide(myEntry);
    }

    set_filter(chooser, local_it->filter, local_it->AllFiles, *default_filter);
    gtk_widget_show (chooser);
    if(local_it->ifExe)
    {
         gtk_widget_hide(ok);
         if(GTK_IS_BOX(box))
         {
            gtk_box_reorder_child(GTK_BOX(box), go, 0);
            gtk_box_reorder_child(GTK_BOX(box), edit, 1);
         }
         gtk_widget_show(go);
         gtk_widget_grab_focus (go);
    }
    else
    {
         gtk_widget_hide(go);
         if(GTK_IS_BOX(box))
            gtk_box_reorder_child(GTK_BOX(box), ok, 0);
         gtk_widget_show(ok);
         gtk_widget_grab_focus (ok);
    }

    gtk_file_chooser_set_select_multiple(GTK_FILE_CHOOSER(chooser), local_it->ifMultiple);

    gtk_window_set_modal(GTK_WINDOW(chooser), TRUE);
    if(local_it->window != NULL)
    {
       gtk_window_set_transient_for(GTK_WINDOW(chooser), GTK_WINDOW(local_it->window)); 
       setSmiley(local_it->window, "smil5.gif");
    }
    gchar *fn = NULL;
    while(local_it->exitCode == 0)
    {
       response = gtk_dialog_run(GTK_DIALOG(chooser));
       gchar *nome = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER(chooser));
       local_it->nfilt = -1;
       GSList *filters = gtk_file_chooser_list_filters(GTK_FILE_CHOOSER(chooser));
       GtkFileFilter *cur_filt = gtk_file_chooser_get_filter(GTK_FILE_CHOOSER(chooser));
       GSList *pos = g_slist_find(filters, (gpointer) cur_filt);
       if(pos != NULL)
       {
          local_it->nfilt = g_slist_position(filters, pos);
          *default_filter = local_it->nfilt;
       }
       if(filters != NULL)
          g_slist_free(filters);
       if((response != GTK_RESPONSE_CANCEL) &&
          (response != GTK_RESPONSE_DELETE_EVENT))
       {
          if(!nome)
             continue;
          if(str_white(nome))
          {
             g_free(nome);
             continue;
          }
          std::string filnam = nome; 
          g_free(nome);
          exten = get_string(chooser, "tipo");
//          if((action != GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER) &&
          if((action == GTK_FILE_CHOOSER_ACTION_SAVE) &&
              !str_white(exten))
          {
             std::string base = g_path_get_basename(filnam.c_str());
             std::vector<std::string> exts;
             fill_list_exts(exten, exts);
             int k = find_extension_in_list(base, exts);
             if(k == -1)    // manca l'estensione
             {
                if(strcmp(exten, "*"))          // non e' *
                {
                   if(strstr(exten, "prj"))
                      filnam.append( "_sir");
                   const char *ext2 = pref_estensione(local_it);
                   if(!str_white(ext2))
                   {
                      filnam.append(".");
                      filnam.append(ext2);
                   }
                }
             }
          }
          fn = g_strdup(filnam.c_str());
       }
       switch(response)
       {
       case GTK_RESPONSE_OK:
       case GO:
       {
            local_it->exitCode = 1;
            if((action == GTK_FILE_CHOOSER_ACTION_OPEN)  ||
                (action == GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER))
            {
                if(!g_file_test(fn, G_FILE_TEST_EXISTS))
                {
                     gtk_window_set_modal(GTK_WINDOW(chooser), FALSE);
                     gtkext::dlg_errmsg(GTK_WINDOW(chooser), 
                          "The selection '%s' does not exist", fn);
                     gtk_window_set_modal(GTK_WINDOW(chooser), TRUE);
                     local_it->exitCode = 0;
                     break;
                }
                if(action == GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER)
                {
                   if(mr_access(fn, 'm') == 0)
                   {
                      gtk_window_set_modal(GTK_WINDOW(chooser), FALSE);
                      gtkext::dlg_errmsg(GTK_WINDOW(chooser),
                          "The selection '%s' is write-protected", fn);
                      gtk_window_set_modal(GTK_WINDOW(chooser), TRUE);
                      local_it->exitCode = 0;
                      break;
                   }
                }
                if(action == GTK_FILE_CHOOSER_ACTION_OPEN) 
                {
                   if(!g_file_test(fn, G_FILE_TEST_IS_REGULAR))
                   {
                     gtk_window_set_modal(GTK_WINDOW(chooser), FALSE);
                     gtkext::dlg_errmsg(GTK_WINDOW(chooser),
                          "Please select an existing filename");
                     gtk_window_set_modal(GTK_WINDOW(chooser), TRUE);
                     local_it->exitCode = 0;
                     break;
                   }
                }
            }
            else
            {
                gboolean exists = FALSE;
                if(fn)
                   exists = g_file_test(fn, G_FILE_TEST_EXISTS);
                if( exists ) 
                {
                   if(mr_access(fn, 'm') == 0)
                   {
                      gtk_window_set_modal(GTK_WINDOW(chooser), FALSE);
                      gtkext::dlg_errmsg(GTK_WINDOW(chooser),
                          "The selection '%s' is write-protected", fn);
                      gtk_window_set_modal(GTK_WINDOW(chooser), TRUE);
                      local_it->exitCode = 0;
                      break;
                   }
                   else
                   {
                      gtk_window_set_modal(GTK_WINDOW(chooser), FALSE);
                      if( !gtkext::dlg_yesno(GTK_WINDOW(chooser), 
                          "The file '%s' already exists. Do you want to overwrite it?", fn) )
                         local_it->exitCode = 0;
                      gtk_window_set_modal(GTK_WINDOW(chooser), TRUE);
                   }
                }
            }
            if(local_it->exitCode)
               gtk_widget_hide(chooser);
            break;
       }
       case GTK_RESPONSE_CANCEL:
       case GTK_RESPONSE_DELETE_EVENT:
            local_it->exitCode = -1;
            gtk_widget_hide(chooser);    
            break;
       case EDIT:
            if(!str_white(fn))
            {
               if(mr_access(fn, 'm') == 0)
               {
                  gtk_window_set_modal(GTK_WINDOW(chooser), FALSE);
                  gtkext::dlg_errmsg(GTK_WINDOW(chooser),
                          "The selection '%s' is write-protected", fn);
                  gtk_window_set_modal(GTK_WINDOW(chooser), TRUE);
                  local_it->exitCode = 0;
               }
               else
               {
                   //gtk_widget_hide(chooser);    
                   char *tmp = get_filt(fn);
                   text_window(GTK_WINDOW(chooser), fn, tmp, IFPROP + IFSAVE, fn);
                   g_free(tmp);
               }
            }
#if 0
#ifdef _WIN32
            gtk_widget_show(chooser);    
#else
#if (GTK_MAJOR_VERSION == 2) && (GTK_MINOR_VERSION == 20)
            gtk_file_chooser_set_filename (GTK_FILE_CHOOSER(chooser),  g_path_get_basename(fn));
            gtk_widget_show(chooser);    
#else
            gtk_widget_show(chooser);    
            gtk_file_chooser_set_filename (GTK_FILE_CHOOSER(chooser),  fn);
#endif
#endif
#endif
            break;
       case VIEW:
            if(!str_white(fn))
            {
                gtk_widget_hide(chooser);    
                char *tmp = get_filt(fn);
                text_window(GTK_WINDOW(chooser), fn, tmp, IFPROP + IFSAVE + IFREADONLY, fn);
                g_free(tmp);
            }
            break;
       }
    }
    if(local_it->exitCode > 0)
    {
       char *tmp = g_path_get_basename(fn);
       CopiaStringa(local_it->fileinp, MaxLenFilename,tmp);
       g_free(tmp);
       if(local_it->ifDirOnly)
          CopiaStringa(local_it->cwd, MaxLenFilename, fn);
       else if(local_it->ifMultiple)
          local_it->selection = copy_slist_to_list(chooser);
       else
       {
/*10 Agosto 2012
          if(gtk_file_chooser_get_current_folder(GTK_FILE_CHOOSER(chooser)) != NULL)
             ScriviStringa(local_it->cwd, MaxLenFilename, "%s%c",
               gtk_file_chooser_get_current_folder(GTK_FILE_CHOOSER(chooser)),
               G_DIR_SEPARATOR);
          else
*/
             tmp =  g_path_get_dirname(fn);
             ScriviStringa(local_it->cwd, MaxLenFilename, "%s%c",
                tmp, G_DIR_SEPARATOR);
             g_free(tmp);
       }
       if(local_it->ifOutput)
       {
             GtkWidget *myEntry = get_widget(chooser, "out_txt");
             tmp = gtk_editable_get_chars((GtkEditable *) myEntry, 0, -1);
             ScriviStringa(local_it->fileout, MaxLenFilename, "%s", g_strstrip(
                tmp));
             g_free(tmp);
       }

       if(showT)
       {
          GtkToggleButton *button = GTK_TOGGLE_BUTTON(get_widget(chooser, "alphacheck"));
          local_it->ifAlpha = gtk_toggle_button_get_active(button);
       }
    }
    if(local_it->window != NULL)
       resetSmiley(local_it->window);
    if(exten != NULL)
       g_free(exten);
    gtk_widget_destroy(chooser);
    if(fn != NULL)
    {
       g_free(fn);
       fn = NULL;
    }
}
#endif

FilselItem saveas  (GtkWidget *mw, const char *filter, const char *filenam, bool ifAll)
{
  PangoFontDescription *fontdesc  = get_font();

  FilselItem local_it;

  local_it.title  = g_strdup_printf("Save As");
  local_it.label  = g_strdup_printf("Enter _filename");
  local_it.filter = DuplicaStringa(filter);
  local_it.nofilter = FALSE;
  local_it.ifEditable = FALSE;
  local_it.ifOutput = FALSE;
  local_it.ifAlpha  = FALSE;
  local_it.ifExe = FALSE;
  local_it.ifSave = TRUE;
  local_it.ifMultiple = FALSE;
  local_it.ifPreview  = FALSE;
  local_it.ifDirOnly  = FALSE;
  local_it.fileinp  = g_new0(char, MaxLenFilename);
  local_it.cwd      = g_new0(char, MaxLenFilename);
  local_it.fileout  = NULL;
  local_it.exitCode = 0;
  local_it.fd       = fontdesc;
  local_it.AllFiles = ifAll?TRUE:FALSE;
  local_it.window   = mw;
  if(filenam)
     CopiaStringa(local_it.fileinp, MaxLenFilename, filenam);
  file_open (&local_it);
  return(local_it);
}

void file_open(FilselItem *local_it, bool showT)
{
#ifdef USE_GTK_FILECHOOSER
       file_open_gtk(local_it, showT);
#else
       file_open_mr(local_it, showT);
#endif
}

} //end namespace gtkext

enum
{
  TOGGLED,
  LAST_CH_SIGNAL
};

#if GLIB_MINOR_VERSION >= 24
static void      mr_chain_button_constructed      (GObject         *object);
#else
static GObject  *mr_chain_button_constructor      (GType, guint, GObjectConstructParam*);
#endif

static void      mr_chain_button_clicked_callback (GtkWidget       *widget,
                                                     MrChainButton *button);
static void      mr_chain_button_update_image     (MrChainButton *button);


G_DEFINE_TYPE (MrChainButton, mr_chain_button, GTK_TYPE_BUTTON)

#define parent_class mr_chain_button_parent_class

static guint mr_chain_button_signals[LAST_CH_SIGNAL] = { 0 };

static const gchar *const pixmaps[] = { "vchain", "vchain_broken"};

static void mr_chain_button_class_init (MrChainButtonClass *klass)
{
  GObjectClass *object_class = G_OBJECT_CLASS (klass);

#if GLIB_MINOR_VERSION >= 24
  object_class->constructed  = mr_chain_button_constructed;
#else
  object_class->constructor  = mr_chain_button_constructor;
#endif
  mr_chain_button_signals[TOGGLED] =
    g_signal_new ("toggled",
                  G_TYPE_FROM_CLASS (klass),
                  G_SIGNAL_RUN_FIRST,
                  G_STRUCT_OFFSET (MrChainButtonClass, toggled),
                  NULL, NULL,
                  g_cclosure_marshal_VOID__VOID,
                  G_TYPE_NONE, 0);

  klass->toggled = NULL;
}

#if GLIB_MINOR_VERSION >= 24
static void mr_chain_button_constructed (GObject *object)
{
  MrChainButton *button = MR_CHAIN_BUTTON (object);

  if (G_OBJECT_CLASS (parent_class)->constructed)
    G_OBJECT_CLASS (parent_class)->constructed (object);

  mr_chain_button_update_image (button);
}
#else
static GObject *mr_chain_button_constructor(GType gtype, guint nprop,
               GObjectConstructParam *props)
{
GObject *obj = G_OBJECT_CLASS(parent_class)->constructor (gtype, nprop, props);
return obj;
}
#endif

static void mr_chain_button_init (MrChainButton *button)
{
  button->active   = FALSE;
  button->image    = gtk_image_new ();
//  button->button   = gtk_button_new ();

  gtk_button_set_relief (GTK_BUTTON (button), GTK_RELIEF_NONE);
  gtk_container_add (GTK_CONTAINER (button), button->image);
  gtk_widget_show (button->image);

  g_signal_connect (button, "clicked",
                    G_CALLBACK (mr_chain_button_clicked_callback),
                    button);
#if GLIB_MINOR_VERSION < 24
  mr_chain_button_update_image (button);
#endif
}

GtkWidget *mr_chain_button_new ()
{
  return GTK_WIDGET(g_object_new (MR_TYPE_CHAIN_BUTTON, NULL));
}

void mr_chain_button_set_active (MrChainButton  *button,
                              gboolean          active)
{
  g_return_if_fail (MR_IS_CHAIN_BUTTON (button));

  if (button->active != active)
    {
      button->active = active ? TRUE : FALSE;

      mr_chain_button_update_image (button);
    }
}

gboolean mr_chain_button_get_active (MrChainButton *button)
{
  g_return_val_if_fail (MR_IS_CHAIN_BUTTON (button), FALSE);

  return button->active;
}

static void mr_chain_button_clicked_callback (GtkWidget *widget,
                                    MrChainButton *button)
{
  g_return_if_fail (MR_IS_CHAIN_BUTTON (button));

  mr_chain_button_set_active (button, ! button->active);

  g_signal_emit (button, mr_chain_button_signals[TOGGLED], 0);
}

static void mr_chain_button_update_image (MrChainButton *button)
{
  guint i;

  i = button->active ? 0 : 1;
  GdkPixbuf *pixb = create_pixbuf(pixmaps[i]);
  gtk_image_set_from_pixbuf (GTK_IMAGE (button->image), pixb);
}

//#if !defined(IN_GTK3) || (GTK_MINOR_VERSION < 16)
GdkColor *getBgColor(GtkWidget *w)
{
  GdkColor *bgcolor = g_new0(GdkColor, 1);
#ifdef IN_GTK3
  GtkStyleContext *c = gtk_widget_get_style_context (w);
  GdkRGBA *color_rgba;
  gtk_style_context_get(c,  GTK_STATE_FLAG_NORMAL, GTK_STYLE_PROPERTY_BACKGROUND_COLOR, &color_rgba, NULL);
  RGBAToGdk(*color_rgba, bgcolor);
#else
  *bgcolor = (gtk_widget_get_style(w))->bg[GTK_STATE_NORMAL];
#endif
  return bgcolor;
}
//#endif

void mr_type_init()
{
#if (!GLIB_CHECK_VERSION(2, 36, 0))
     g_type_init();
#endif
}  

namespace Lista {
   static std::vector<MyList *> lists;
   int     FindList (int *whichCode);
   MyList  *FindList (int whichCode);

   static void incolonna_float(GtkTreeViewColumn *col,
                               GtkCellRenderer *renderer,
                      GtkTreeModel *model, GtkTreeIter *iter, gpointer data)
   {
        gfloat  val;
        int colonna = GPOINTER_TO_INT(data);

        gtk_tree_model_get(model, iter, colonna, &val, -1);
        int pr = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(col), "precision"));
        std::string buf = fToStr2(val, pr);
        g_object_set(renderer, "text", buf.c_str(), NULL);
   }

   int FindList (int *whichCode)
   {
      for(size_t i=0; i<lists.size(); i++)
      {
          if(lists.at(i)->GetCode() == *whichCode)
             return (int)i;
      }
      return -1;
   }

   MyList *FindList (int which)
   {
      return (lists.at(which));
   }

   void DeleteList (int whichCode)
   {
      for(size_t i=0; i<lists.size(); i++)
      {
          if(lists.at(i)->GetCode() == whichCode)
             lists.erase(lists.begin()+i);
      }
   }

   MyList::MyList(int ListCode)
   {
      Code = ListCode;
      nColumns = 0;
      lists.push_back(this);
   }

   GtkWidget *MyList::Parent = NULL;

static void bool_activate_toggled (GtkCellRendererToggle *cell,
               gchar                 *path_str,
               gpointer               data)
{
using namespace Lista;
   MyList *lista = (MyList *) data;
   GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(lista->ListW()));
   GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
   GtkTreeIter iter;
   gboolean fixed;
   int column = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(cell), "column"));
   gtk_tree_model_get_iter (model, &iter, path);
   gtk_tree_model_get (model, &iter, column, &fixed, -1);
   fixed ^= 1;
   gtk_list_store_set (GTK_LIST_STORE (model), &iter, column, fixed, -1);

   int row = gtk_tree_path_get_indices (path)[0];
   int code = 1;
   if(row == -1)
      return;
   code = row + 1;
   code += lista->GetNRows();
   if(fixed == 0)
      code = -code;
   gtk_tree_path_free (path);
   lista->func(&code);
}

   MyList::MyList(int ListCode, int ncols, int coltypes[], string_t coltits[],
                  void (*cb_func)(int  *code))
   {
      Code = ListCode;
      nColumns = ncols;
      types = g_new0(GType, ncols);
      sizes = g_new0(int, ncols);
      precs = g_new0(int, ncols);
      titles = g_new0(char *, ncols);
      func   = cb_func;
      for (int i=0; i<nColumns; i++)
      {
          titles[i] = g_strdup(coltits[i]);
          switch(coltypes[i])
          {
          case 'I':
                types[i] = G_TYPE_INT;
                precs[i] = 0;
                break;
          case 'R':
                types[i] = G_TYPE_FLOAT;
                precs[i] = 3;
                break;
          default:
          case 'S':
                types[i] = G_TYPE_STRING;
                precs[i] = 0;
                break;
          case 'B':
                types[i] = G_TYPE_BOOLEAN;
                precs[i] = 0;
                break;
          }
      }
      GtkWidget *scrollwin = gtk_scrolled_window_new (NULL, NULL);
      gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                   GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
      gtk_widget_show (scrollwin);

      widget = gtk_tree_view_new();
      g_object_set_data(G_OBJECT(widget), "formato", GINT_TO_POINTER(nColumns));
      g_object_set_data(G_OBJECT(widget), "scrollwin", scrollwin);
      GtkListStore *store = gtk_list_store_newv(nColumns, types);
      for(int i=0; i<nColumns; i++)
      {
          GtkCellRenderer *renderer;
          GtkTreeViewColumn *column;
          if(types[i] == G_TYPE_BOOLEAN)
          {
             renderer = gtk_cell_renderer_toggle_new ();
             g_signal_connect (renderer, "toggled",
                    G_CALLBACK (bool_activate_toggled), (gpointer) this);
             column = gtk_tree_view_column_new_with_attributes
                (titles[i], renderer, "active", i, NULL);
          }
          else
          {
             renderer = gtk_cell_renderer_text_new ();
             column = gtk_tree_view_column_new_with_attributes
               (titles[i], renderer, "text", i, NULL);
          }
          g_object_set_data(G_OBJECT(column), "renderer", (gpointer) renderer);
          GtkWidget *label = gtk_label_new(titles[i]);
          if((types[i] == G_TYPE_FLOAT) && (precs[i] != 0))
          {
            g_object_set_data(G_OBJECT(column), "precision",
                     GINT_TO_POINTER(precs[i]));
            gtk_tree_view_column_set_cell_data_func(column, renderer,
                     incolonna_float, GINT_TO_POINTER(i), NULL);
          }
          g_object_set_data(G_OBJECT (renderer), "column", GINT_TO_POINTER (i));
          g_object_set_data(G_OBJECT (renderer), "gtype", GINT_TO_POINTER (types[i]));
          gtk_tree_view_column_set_alignment  (column, 0.5f);
          gtk_widget_show (label);
          gtk_tree_view_column_set_widget(column, label);
          gtk_tree_view_column_set_sizing(column,GTK_TREE_VIEW_COLUMN_AUTOSIZE);
          gtk_tree_view_column_set_visible(column, TRUE);
          gtk_tree_view_column_set_clickable(column, FALSE);
          gtk_tree_view_append_column (GTK_TREE_VIEW(widget), column);
      }
      gtk_tree_view_set_model(GTK_TREE_VIEW(widget), GTK_TREE_MODEL (store));
      gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(widget), TRUE);
      gtk_container_add (GTK_CONTAINER (scrollwin), widget);
   }

   void MyList::Fill(int numRows)
   {
      GtkListStore *store;
      GtkTreeIter iter;

      clear_list(widget);
      store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(widget)));
      for(int i=0; i<numRows; i++)
          gtk_list_store_append (store, &iter);
   }

   void MyList::FillColumn (int whichCol, int ivet[], float fvet[],
                                 string_t svet[])
   {
      GtkTreeIter iter;
      GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(widget));

      gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
      int i = 0;
      while (valid)
      {
          switch(types[whichCol-1])
          {
          case G_TYPE_INT:
               gtk_list_store_set (GTK_LIST_STORE(model), &iter,
                            whichCol-1, ivet[i],-1);
               break;
          case G_TYPE_FLOAT:
               gtk_list_store_set (GTK_LIST_STORE(model), &iter,
                            whichCol-1, fvet[i],-1);
               break;
          default:
          case G_TYPE_STRING:
               gtk_list_store_set (GTK_LIST_STORE(model), &iter,
                            whichCol-1, svet[i],-1);
               break;
          case G_TYPE_BOOLEAN:
               gtk_list_store_set (GTK_LIST_STORE(model), &iter,
                            whichCol-1, ivet[i],-1);
               break;
          }
          valid = gtk_tree_model_iter_next (model, &iter);
          i++;
      }
   }
   bool modal_window = true;

} // end namespace Lista

void ok_cb(GtkWidget *button, gpointer data)
{
using namespace Lista;
   MyList *lista = (MyList *) data;
   int code = 1;
   lista->func(&code);
   DeleteList(lista->GetCode());
   delete lista;
   gtk_widget_destroy(gtk_widget_get_toplevel(button));
}

void cancel_cb(GtkWidget *button, gpointer data)
{
using namespace Lista;
   MyList *lista = (MyList *) data;
   int code = 2;
   lista->func(&code);
   DeleteList(lista->GetCode());
   delete lista;
   gtk_widget_destroy(gtk_widget_get_toplevel(button));
}

static void changedselection(GtkTreeSelection  *sele, gpointer data)
{
using namespace Lista;
   int row = row_selected(sele);
   int code = 1;
   if(row == -1)
      return;
   code = -(row + 1);
   MyList *lista = (MyList *) data;
   lista->func(&code);
}

extern "C" void list_create_(int *ListCode, int *ncol, int *nrow, int ktype[],
                             string_t coltitles[], char *wintitle,
                             char *msg, int *tipowin,int *iselrow,
                             void (*func)(int  *code))
{
using namespace Lista;
   MyList *mylist;
   GtkWidget *dlg, *list;
   PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
   int lar, alt;
   get_metrics(fontlist, &lar, &alt);
   int ifCreated = FindList(ListCode);

   if(ifCreated == -1)
   {
      dlg = gtk_dialog_new();
      gtk_window_set_title (GTK_WINDOW (dlg), wintitle);
      gtk_container_set_border_width(GTK_CONTAINER(dlg), 10);
      GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
      GtkWidget *parent_w = MyList::GetParent();
      if(parent_w != NULL)
         gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(parent_w));

      GtkWidget *label = LABEL_BOLD("", NULL, 1.1f);
      gtk_box_pack_start(GTK_BOX (vbox), label, FALSE, FALSE, 10);
      set_alignment(label, 0., 0.5);
      mylist = new MyList(*ListCode, *ncol, ktype, coltitles, func);
      lists.push_back(mylist);
      list = mylist->ListW();
      g_object_set_data(G_OBJECT(list), "msg", label);
      g_object_set_data(G_OBJECT(dlg), "mylist", (gpointer) mylist);
      GtkWidget *frame = gtk_frame_new(NULL);
#if GTK_MAJOR_VERSION < 3
      GtkWidget *align = gtk_alignment_new (0.5f, 0, 0.1f, 1);
      gtk_container_add(GTK_CONTAINER (align), frame);
      gtk_box_pack_start(GTK_BOX (vbox), align, TRUE, TRUE, 10);
      gtk_widget_show(align);
#else
      gtk_widget_set_halign(frame, GTK_ALIGN_CENTER);
      gtk_widget_set_vexpand(frame, TRUE);
      gtk_box_pack_start(GTK_BOX (vbox), frame, TRUE, TRUE, 10);
#endif
      GtkTreeSelection *sele = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
      int hnd = g_signal_connect (G_OBJECT (sele), "changed",
                      G_CALLBACK (changedselection), (gpointer) mylist);
      g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));
      g_object_set_data(G_OBJECT(sele), "hnd", GINT_TO_POINTER(hnd));

      gtk_container_add(GTK_CONTAINER(frame), get_widget(list, "scrollwin"));
      g_object_set_data(G_OBJECT(dlg), "lista", list);
      g_object_set_data(G_OBJECT(list), "father", dlg);
      widget_modify_font(list, fontlist);
      gtk_widget_show_all (frame);
   }
   else
   {
      mylist = FindList(ifCreated);
      list = mylist->ListW();
      dlg = get_widget(list, "father");
   }
   if(!str_white(msg))
   {
      gtk_label_set_text(GTK_LABEL(get_widget(list, "msg")), msg);
      gtk_widget_show(get_widget(list, "msg"));
   }
   else
      gtk_widget_hide(get_widget(list, "msg"));
   mylist->SetNRows (*nrow);
   mylist->Fill (*nrow);
   if(*iselrow > 0)
      select_row(list, *iselrow - 1, true);
   gtk_widget_set_size_request(get_widget(list, "scrollwin"),
                    -1, (int) MRmin(1.5f*(*nrow+1)*alt, 20*alt));

   if(ifCreated == -1)
   {
      GtkWidget *button = OK_button();
      gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 1);
      if(!modal_window)
         (void) g_signal_connect(G_OBJECT (button), "clicked",
            G_CALLBACK(ok_cb), (gpointer) mylist);
      GtkWidget *action_area = gtk_widget_get_parent(button);
      gtk_button_box_set_layout(GTK_BUTTON_BOX(action_area), GTK_BUTTONBOX_SPREAD);

      if(*tipowin == 2)
      {
         button = CANCEL_button();
         gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 2);
         if(!modal_window)
            (void) g_signal_connect(G_OBJECT (button), "clicked",
            G_CALLBACK(cancel_cb), (gpointer) mylist);
      }

      if(!modal_window)
      {
          (void) g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
           G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
          (void) g_signal_connect (G_OBJECT (dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);
      }
      int code = 0;
      mylist->func(&code);
   }
}

extern "C" void list_set_column_(int *listCode, int *whichCol, int ivet[],
                                 float fvet[], string_t svet[])
{
using namespace Lista;
   int i = FindList(listCode);
   if(i == -1)
      return;
   MyList *mylist = FindList(i);
   mylist->FillColumn(*whichCol, ivet, fvet, svet);
   if(*whichCol == mylist->GetNColumns())
   {
      GtkWidget *list = mylist->ListW();
      GtkWidget *dlg = get_widget(list, "father");
      gtk_widget_show(dlg);
      if(modal_window)
      {
         int result = gtk_dialog_run(GTK_DIALOG(dlg));
         if(result != 1)
            result = 2;
         mylist->func(&result);
         DeleteList(mylist->GetCode());
         delete mylist;
         mylist = NULL;
         gtk_widget_destroy(dlg);
      }
   }
}

void get_row_from_val(GtkWidget *list, int col_posi, std::vector<int> &iord)
{
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GType tipo = gtk_tree_model_get_column_type(model, col_posi);
    GtkTreeIter iter;
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    int i = 0;
    while (valid)
    {
       if(tipo == G_TYPE_INT)
       {
          int val;
          gtk_tree_model_get(model, &iter, col_posi, &val, -1);
          iord.at(val-1) = i;
       }
       else if(tipo == PIX_NUM_TYPE)
       {
          PixNum *numb = g_new0(PixNum, 1);
          int val;
          gtk_tree_model_get(model, &iter, col_posi,  &numb, -1);
          val = numb->num;
          iord.at(val-1) = i;
       }
       i++;
       valid = gtk_tree_model_iter_next (model, &iter);
    }
}

void SaveSelection(GtkWidget *list, int col_posi, std::vector<int> &sel_vet)
{
    GList *rowsel = get_selections(list);
    GtkTreeIter iter;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GType tipo = gtk_tree_model_get_column_type(model, col_posi);
    int nsel = (int) g_list_length(rowsel);
    for(int i=0; i<nsel; i++)
    {
      int val;
      GtkTreePath *path =  static_cast<GtkTreePath *> (g_list_nth_data (rowsel, i));
      gtk_tree_model_get_iter (model, &iter, path);
      if(tipo == G_TYPE_INT)
         gtk_tree_model_get(model, &iter, col_posi, &val, -1);
      else if(tipo == PIX_NUM_TYPE)
      {
          PixNum *numb = g_new0(PixNum, 1);
          gtk_tree_model_get(model, &iter, col_posi,  &numb, -1);
          val = numb->num;
      }
      else
          continue;
      sel_vet.push_back(val-1);
    }
    g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
}   

void RedoSelection(GtkWidget *list, int col_posi, int num, std::vector<int> &sel_vet)
{
    std::vector<int> iord(num, 0);
    get_row_from_val(list, col_posi, iord);
    int nsel = (int) sel_vet.size();
    unselect_all(GTK_TREE_VIEW(list), true);
    for(int i=0; i<nsel; i++)
    {
        int kk = iord.at(sel_vet.at(i));
        select_row(list, kk, true);
    }
}

void chiudi_dlg(GtkWidget *button, gpointer data)
{
   chiudi_dlg_data *st = (chiudi_dlg_data *) data;

   GtkWidget *window = st->window;
   GtkWidget *dlg = gtk_widget_get_toplevel(button);
   if(GTK_IS_WIDGET(window))
      g_object_set_data(G_OBJECT(window), st->name, NULL);
   gtk_widget_destroy(dlg);
}

