!-----------------------------------------------------------------------
!     Mad / Sad related routines
!-----------------------------------------------------------------------
      MODULE MadModule
!
      common /cmad/ nWave,kAnom(8),fPrimoSecondo(8,5,2),normm(5), 
     *              nAn(8), nkAnom(8), nAnom,
     *              bWilsonM(5),scaleWilsonM(5),
     *              nWaveAct,
     *              nwl(5),numbWL,
     *              eMadMax,
     *              NumFiltri,nFiltro(10),SogFiltro(10),
     *              iks,ikess,SogEss,ifEsuSigma,ikepers,ifCreate,
     *              ifNative,ifClick
c     nWave = numero di lunghezze d'onda in input
c     kAnom = specie atomica dei diffusori (formato a2)
c     nAn = numero di atomi per ogni diffusore
c     nkAnom = puntatore (in nw, no ...) dei diffusori anomali
c     nAnom = numero di speci anomale
c     fPrimoSecondo(j,i,1) = f' dell'iesima lunghezza d'onda j-esimo scatterer
c     fPrimoSecondo(j,i,2) = f" dell'iesima lunghezza d'onda j-esimo scatterer
c     normm(i) = 1 se si vuol normalizzare rispetto alla i-esima l.d.o.
c               se si utilizza piu' di una lunghezza d'onda,
c               l'E finale e' dato dalla media dei singoli E
c     bWilsonM(i)     = B di Wilson per l'i-esima l.d.o.
c     scaleWilsonM(i) = scala di Wilson per l'i-esima l.d.o.
c     nWaveAct = n. della lunghezza d'onda attualmente normalizzata
c     nwl(i) = n. seq. di una lunghezza d'onda da usare
c     numbWL = numero totale di l. d'onda da utilizzare
c     iks   = indice della colonna di emesus contenente i sigma(E0a)
c     ikess =   "      "     "          "        "   E0a/sigma(E0a)
c     SogEss= soglia di E0a/sigma(E0a) per i riflessi strong (nstr)
c     ifEsuSigma = 0  riflessi ordinati per E0a
c                = 1     "        "     per E0a/sigma
c     ifNative = 0/1 assenza/presenza dei dati della nativa sul file hkl
c     ifClick  = 0/1 assenza/presenza della stringa "Click on graphics.."

      common /atmscatt/ f0jna(270,5),f0ja(270,8,5),fpj(270,8,5),
     *  fsj(270,8,5),f0(8),fp(8,5),fss(8,5),fpQ(8,5),fsQ(8,5)
      double precision f0jna, f0ja ,fpj , fsj,     fp, fss, fpQ, fsQ
      common /erreMAD/ numR, NumRefR(5), rfacR(5)
      common /DSR/ Dan(5),DanAbs(5),nRefDev(5),kpc,
     *             Soglia_su_d,Soglia_su_d_lowres           

      common /WLCORR/ dval(20), nrfd(10,20), correl(10,20), ninterv
      common /WLCORR_D/ dval_d(20),nrfd_d(15,20),corre_d(15,20),
     *                  ninterv_d
      common /RANGO/ Rank(31),iCombC(31),Peso3,Peso4,PercCorr,cut_d(31),
     *               n_WL_Comb,isRank(31)
      common /rejectmad/ nRej1,nRej2,nRej3,nReflInput,nRejj(10)
      common /anomalous/ kfpfs(8),fpfs(2,8), nWilsonPlots
      common /patter/ jjpatt, cutoffPatt
!
! ???? ma servono ????
!
      common /dataeora/ data_ora
      character *256 data_ora
!
      common /RESsuRAT/ ResRat(502,3),npis
      common /StrutturaTot_anomala/evero_anom(3000),fvero_anom(3000),
     *                             ipub_anom(3000)
      common /erre_phasing/Rmodulo(2,3000), Rmodulo_ord(2,3000),  !pgMAD050208     
     *                     ipun_Rmodulo(3000),ifasTot,ipub_save(3000),     
     *                     Fmodulo(2,3000), Fmodulo_ord(2,3000)
      common /pesiAngela/ PercFp
        
      END MODULE MadModule
! ----------------------------------------------------------------------
      MODULE MADStuff
             integer, allocatable :: idvet(:)
             integer, allocatable :: idvet1(:)
             integer, allocatable :: idvetP(:)
             integer, allocatable :: iordm(:,:)
             integer, allocatable :: iinr(:)
             integer, allocatable :: ipub_s(:)
             integer, allocatable :: iphaz_s(:)
             real, allocatable :: wt_s(:)
             real, allocatable :: eme(:)
             real, allocatable :: evero(:)
             real, allocatable :: fvero(:)
             real, allocatable :: emesus(:,:)
             real, allocatable :: sig_piu(:,:)
             integer, allocatable :: jcdd(:)
      END MODULE MADStuff
!-----------------------------------------------------------------------
c     read reflexions for MAD
c-----------------------------------------------------------
      subroutine madin
      USE General
      USE Symmetry
      USE Molcom
      USE MadModule
      USE MadStuff
      USE Riflessi
      USE xdataMod
      USE elements, only: numelem
c--
      character*256 fileh
      character*80 formt,filer
      character*256 line,buff
      dimension sigma_piu(5)
      dimension xf(3000), yf(3000), xftot(3000), yftot(3000)
      
      izero = 0

      call xfl01
      call xfl02
!corr-03      call xfl03
c
   20 continue
   
      itype=2
      iform=1
      
!      fileh = 'C:\EXPO2006\StruttureANOM\verapa\verapaA.li6'
!      fileh = 'C:\EXPO2006\StruttureANOM\prova\provaA.li6'
!      fileh = 'C:\EXPO2006\StruttureANOM\prova\provaA_cu.li6'
!      fileh = 'C:\EXPO2006\StruttureANOM\famo\famoA.li6'
!      fileh = 'C:\EXPO2006\StruttureANOM\nickel\nickelA.li6'
!      fileh = 'C:\EXPO2006\StruttureANOM\nickel\nickelA_cu.li6'

      ipuu = index(fname(BIN_FILE),'.')

      fileh = fname(BIN_FILE)(1:ipuu)//'li6'

      write(lo,'(/,80(1h*))')
      write(lo,'(a)') fileh
      write(lo,'(80(1h*),/)')
      jfile = 34
      if (jopen(jfile,fileh,itype,iform,ios).lt.0) go to 9000
      if (ios < 0) return

      nrefp=0
      do i=1,3
         ihmx(i) = -100
      end do
c
      call scrper(' Reading reflexions ',0,-1)
c
      rewind jfile

      e0 = 0
      nneg=0
      nnn=0
      nuobs=0
      nrmax=0
      nresm=0
      rhm=-99.9
      
      indHKL(:,:) = 0
      Mult(:) = 0
      TThet (:) = 0.0
      WHM(:) = 0.0
      SetFob(:,:) = 0.0
      puntatore(:) = 0
      ex(:) = 0.0
      fx(:) = 0.0
      fxsav(:) = 0.0
      ecx(:) = 0.0
      fcvet(:) = 0.0     
      
      sumex = 0.0
      sumecx = 0.0
      nrefex = 0
      nrefecx = 0

      nrefl = 3000
      call AllocaMAD(1)

!      PercFp = 0.030
!      write(lo,'(a,/,a,f6.3,a,/,a)')'=*=*=*=*=*=','sigma(F+) = ssii * ',
!     *                             PercFp, ' * F+','=*=*=*=*=*='
      
   25 read(jfile,'(a)',end=7000) line
      buff=line
      call shift(buff,nchar)
      if (buff(1:1) == '>') then
          goto 25
      end if
      
      ncontatore_r1 = 0
      ncontatore_r2 = 0
      amed_r1 = 0.0
      amed_r2 = 0.0
      ncontatore_f1 = 0
      ncontatore_f2 = 0
      amed_f1 = 0.0
      amed_f2 = 0.0
      
      ncR1 = 0
      ncF1 = 0
      ncF2 = 0
      amF1 = 0.
      amR1 = 0.
      amF2 = 0.
      amR2 = 0.
      
      ncR1quad = 0
      ncR2quad = 0
      amR1quad = 0.
      amR2quad = 0.
      
      
      read(line,*) scaleWilsonM(1), bWilsonM(1)
      read(jfile,'(a)',end=7000) line
      read(line,*) scaleWilsonM(2), bWilsonM(2)
!      read(jfile,'(a)',end=7000) line
      
      nline = 0
      nr = 0
      
!      resm = 1.22
      
      
   30 nline=nline+1

      nr = nr + 1

      if (knw == 0) then
          read(jfile,'(a)',end=60,err=8000,iostat=ios) line
          read(line,'(4i4,i9,i4,7f15.4)')indHKL(nr,1:5),Mult(nr),
     *                                  TThet(nr),WHM(nr),SetFob(nr,1:5)
          read(jfile,'(a)',end=60,err=8000,iostat=ios) line
          read(line,'(4x,9f15.4)')puntatore(nr),ex(nr),fx(nr),
     *                     sigma_piu(1),
     *                     fxsav(nr),ecx(nr),fcvet(nr),
     *                     sigma_piu(2)
      else
          read(jfile,'(a)',end=60,err=8000,iostat=ios) line
          read(line,'(4i4,i9,i4,7f15.4)')indHKL(nr,1:5),Mult(nr),
     *                                  TThet(nr),WHM(nr),SetFob(nr,1:5)
          read(jfile,'(a)',end=60,err=8000,iostat=ios) line
          read(line,'(4x,9f15.4)')puntatore(nr),ex(nr),fx(nr),
     *                     sigma_piu(1),
     *                     fxsav(nr),ecx(nr),fcvet(nr),
     *                     sigma_piu(2)
      end if

      if (ex(nr) < -998.) then
         goto 60
      end if
 
!!!!!!    eliminazione riflessi con almeno una osservazione nulla 
      
!      if (ex(nr) == 0.0 .or. ecx(nr) == 0.0) then
!         nr = nr - 1
!         goto 30
!      end if
      
      khl(1,nr) = indHKL(nr,1)
      khl(2,nr) = indHKL(nr,2)
      khl(3,nr) = indHKL(nr,3)
      Fmodulo(1,nr) = fx(nr)
!!      sigma_piu(1) = 0.0
!      Rmodulo(1,nr) = ex(nr)
      Fmodulo(2,nr) = fcvet(nr)
!!      sigma_piu(2) = 0.0
!      Rmodulo(2,nr) = ecx(nr)

!      ncR1 = ncR1 + 1
!      amF1 = amF1 + Fmodulo(1,nr)
!      amR1 = amR1 + Rmodulo(1,nr)
!      amF2 = amF2 + Fmodulo(2,nr)
!      amR2 = amR2 + Rmodulo(2,nr)
      
!      ncR1quad = ncR1quad + 1
!      ncR2quad = ncR2quad +1
!      amR1quad = amR1quad + Rmodulo(1,nr)**2
!      amR2quad = amR2quad + Rmodulo(2,nr)**2
!      
      
!      if (Rmodulo(1,nr) > Rmodulo(2,nr) ) then
!          ncontatore_r1 = ncontatore_r1 + 1
!          amed_r1 = amed_r1 + Rmodulo(1,nr)
!      else
!          ncontatore_r2 = ncontatore_r2 + 1
!          amed_r2 = amed_r2 + Rmodulo(2,nr)
!      end if
!      
!      if (Fmodulo(1,nr) > Fmodulo(2,nr) ) then
!          ncontatore_f1 = ncontatore_f1 + 1
!          amed_f1 = amed_f1 + Fmodulo(1,nr)
!      else
!          ncontatore_f2 = ncontatore_f2 + 1
!          amed_f2 = amed_f2 + Fmodulo(2,nr)
!      end if
      
!      sumex = sumex + ex(nr)**2
!      nrefex = nrefex + 1
!          
!      sumecx = sumecx + ecx(nr)**2
!      nrefecx = nrefecx + 1

   32 if (khl(1,nr).eq.0.and.khl(2,nr).eq.0.and.khl(3,nr).eq.0) go to 60
  
!
!     se si usano i dati calcolati ci si INVENTANO dei valori per i sigma ????????????????
!
      do i=1,nWave
!         sigma_piu(i) = 0.10* Fmodulo(i,nr)
!         sigma_piu(i) = 0.1
!         sigma_piu(i) = 0.030 * Fmodulo(i,nr)
         if (sigma_piu(i) > 0.0) then
            ssii = 1./ sqrt(sigma_piu(i))
         else
            ssii = 1.0
         endif
!         ssii = 1.0
!         sigma_piu(i) = PercFp * Fmodulo(i,nr) * ssii
         sig_piu(i,nr) = ssii
      end do

      iphi = 0

      call geneq_old(1,khl(1,nr),khl(2,nr),khl(3,nr),idelt,jcdd(nr),
     *     isgnn,id1,rhov(nr))
      
      resatt = 0.5 / sqrt(rhov(nr))

      if (resatt.lt.resm) then
         nresm=nresm+1
         nr = nr - 1
         go to 30
      endif

c
      if (rhov(nr).gt.rhm) rhm=rhov(nr)

      nrefp=nrefp+1

      go to 30

   60 nr = nr - 1
      
      nrefl=nrefp
      rhomax=rhm
      resm = 0.5/sqrt(rhm)     
      
!!!!!! riscalamento delle osservazioni

!      sumQ = 0
!      nnrrff = 0
!      do i=1,nrefl
!         sumQ = sumQ + ecx(i)*ecx(i)
!         nnrrff = nnrrff + 1
!      end do
!      sumQ = sumQ/nnrrff
!      do i=1,nrefl
!         ecx(i) = sqrt(ecx(i)**2/sumQ)
!      end do
!      sumprova =0.0
!      do i=1,nrefl
!         sumprova = sumprova + ecx(i) *ecx(i) 
!      end do
!      sumprova = sumprova /nnrrff
!     
!      sumQ = 0
!      nnrrff = 0
!      do i=1,nrefl
!         sumQ = sumQ + ex(i)*ex(i)
!         nnrrff = nnrrff + 1
!      end do
!      sumQ = sumQ/nnrrff
!      do i=1,nrefl
!         ex(i) = sqrt(ex(i)**2/sumQ)
!      end do
!      
!      sumprova =0.0
!      do i=1,nrefl
!         sumprova = sumprova + ex(i) *ex(i) 
!      end do
!      sumprova = sumprova /nnrrff
      
      
      do nr=1,nrefl
      Rmodulo(1,nr) = ex(nr)
      Rmodulo(2,nr) = ecx(nr)

      ncR1 = ncR1 + 1
      amF1 = amF1 + Fmodulo(1,nr)
      amR1 = amR1 + Rmodulo(1,nr)
      amF2 = amF2 + Fmodulo(2,nr)
      amR2 = amR2 + Rmodulo(2,nr)
      
      ncR1quad = ncR1quad + 1
      ncR2quad = ncR2quad +1
      amR1quad = amR1quad + Rmodulo(1,nr)**2
      amR2quad = amR2quad + Rmodulo(2,nr)**2
      
      
      if (Rmodulo(1,nr) > Rmodulo(2,nr) ) then
          ncontatore_r1 = ncontatore_r1 + 1
          amed_r1 = amed_r1 + Rmodulo(1,nr)
      else
          ncontatore_r2 = ncontatore_r2 + 1
          amed_r2 = amed_r2 + Rmodulo(2,nr)
      end if
      
      if (Fmodulo(1,nr) > Fmodulo(2,nr) ) then
          ncontatore_f1 = ncontatore_f1 + 1
          amed_f1 = amed_f1 + Fmodulo(1,nr)
      else
          ncontatore_f2 = ncontatore_f2 + 1
          amed_f2 = amed_f2 + Fmodulo(2,nr)
      end if
      
      sumex = sumex + ex(nr)**2
      nrefex = nrefex + 1
          
      sumecx = sumecx + ecx(nr)**2
      nrefecx = nrefecx + 1
      
      end do
      
      sumex = sumex/float(nrefex)
      sumecx = sumecx/float(nrefecx)
      
      write(lo,*)' nrefex =', nrefex,sumex,
     *           ' nrefecx =', nrefecx, sumecx
        
      amed_r1 = amed_r1 / ncontatore_r1
      amed_r2 = amed_r2 / ncontatore_r2
      amed_f1 = amed_f1 / ncontatore_f1
      amed_f2 = amed_f2 / ncontatore_f2
       
      write (lo,*) ' Somma F dip = ', amF1
      write (lo,*) ' Somma F rem = ', amF2
      
      amF1 = amF1 / ncr1
      amR1 = amR1 / ncr1
      amF2 = amF2 / ncr1
      amR2 = amR2 / ncr1

      write (lo,*) ' Media F dip = ', amF1
      write (lo,*) ' Media F rem = ', amF2
      write (lo,*) ' Media R dip = ', amR1
      write (lo,*) ' Media R rem = ', amR2
      
      amR1quad = amR1quad / ncR1quad
      amR2quad = amR2quad / ncR2quad
      write (lo,*) ' Media R**2 dip = ', amR1quad,ncR1quad
      write (lo,*) ' Media R**2 rem = ', amR2quad,ncR2quad
      
      
      

      write (lo,*) ' Rdip > Rremota = ',ncontatore_r1,amed_r1
      write (lo,*) ' Rdip < Rremota = ',ncontatore_r2,amed_r2
      write (lo,*) ' Fdip > Fremota = ',ncontatore_f1,amed_f1
      write (lo,*) ' Fdip < Fremota = ',ncontatore_f2,amed_f2
      
      
      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)
 
      write(lo,300) nrefp
      if (nrmax.gt.0) write(lo,311) nrmax,th
      if (nresm.gt.0) write(lo,315) nresm,resm
      resol = 0.5 / sqrt(rhm)
      write(lo,330) ihmx,rhm,resol
  300 format(/, 8x,i7,'  input reflections')
  311 format(10x,i5,'  rejected reflections with s**2 .GT. ',f6.3)
  315 format(10x,i5,'  rejected reflections with resolution .LT. ',f5.2,
     *              ' Angstrom')
  330 format(   3x,3i4,'  maximum  h,k,l  values',
     *       /,8x,f7.4,'  maximum s**2 = (sin(theta)/lambda)**2',
     *       /,8x,f7.4,'  Angstrom resolution                  ')


      nwl(:) = 0
      normm(:) = 0

      numbWL = nWave
      do n=1,numbWL
         nwl(n) = n
         normm(n) = 1
      end do
    
      do km=1,1
        do i=1,270
           t=0.01*float(i-1)
           tttttt=t*t
           f0jna(i,km)=0.0
           do k = 1,8
              f0ja(i,k,km)=0.0
              fpj (i,k,km)=0.0
           end do
           do j=1,numelem(celem)           
              fz = celem(j)%cl
              do jj=1,4
!corr                 zzzbst=bs(jj,j)*tttttt
!corr                 if (zzzbst.le.60.) fz=fz+al(jj,j)*exp(-zzzbst)
                 zzzbst=celem(j)%bs(jj)*tttttt
                 if (zzzbst.le.60.) fz=fz+celem(j)%al(jj)*exp(-zzzbst)
              end do
!corr              fnw=float(nw(j))
              fnw=celem(j)%nw
              ifAnomalo = 0
              do k=1,nAnom
!corr                 if (kAnom(k).eq.nalf(j)) then
                 if (kAnom(k) == celem(j)%ptab) then
                    nAn(k) = fnw
                    fpj(i,k,km) = fPrimoSecondo(k,km,1)
                    ifAnomalo = 1
                 endif
              end do
              if (ifAnomalo.eq.0) then
                 f0jna(i,km)=f0jna(i,km) + fnw * fz**2
              end if
           end do
           write(lo,'(f15.10)') f0jna(i,km)
        end do
      end do
      fpppp = formM2(rhomax,fpj,1,1)
      fpQQQQ = fpppp * fpppp
      Anumcz = nAn(1) * fpQQQQ
      Aden = formM(rhomax,f0jna,1)
      rapporto = Anumcz/Aden
      write(lo,77) Anumcz, Aden, rapporto
 77   format (' Num, Den, Deltafprimo/f0a = ',3f11.4)

      NumFiltri = 0
      do i=1,10
         if (nFiltro(i).gt.0) then
            NumFiltri = NumFiltri + 1
         end if
      end do
      
!      goto 3999

!    Calcolo correlazioni varie inizio febbraio 2009
      
      nwl(1) = 2
      nwl(2) = 1

      call SFCalc_StrutturaTot
      
      call SFCalc_StrutturaTot_Anomala
      
      
      
      sumEo = 0.0
      sumEc = 0.0
      amedqq = 0.0
      amedqqq  = 0.0
      do i=1,nrefl      
         sumEo=sumEo+ecx(i)
         amedqq = amedqq + ecx(i)**2
         amedqqq = amedqqq + evero(i) ** 2
         sumEc=sumEc+evero(i)
      end do
      amedqq  = amedqq /nrefl   
      amedqqq  = amedqqq /nrefl
      scalaEcEorem = sumEc / sumEo
      npop = 100   
      write(lo,*)' Correlazione tra E1vero e E1osservato (scalaEcEorem)'
     *            ,scalaEcEorem
      write(lo,*) ' Corr.   R      |R|               resol1     resol2'
      
      res1 = 0.5/sqrt(rhov(1))
      do i=1, nrefl, npop 
         noss = 0
         anum = 0.
         anum1 = 0.0
         denum = 0.
         do j=1,npop
               if (i+j-1 <= nrefl) then
               noss = noss + 1
               xf(noss) = evero(i+j-1)
               yf(noss) = ecx(i+j-1)
               anum = anum + xf(noss)- scalaEcEorem*yf(noss)
               anum1 = anum1 + abs(xf(noss)- scalaEcEorem*yf(noss))
               denum = denum + xf(noss)
               end if
               if (res1.lt.1.5551.and.res2.gt.1.4805)then
                  risoluz = 0.5/sqrt(rhov(i+j-1))
!                  write (lo,'(3i5,7f9.4)')khl(1:3,i+j-1),
!     *                   Rmodulo(1,i+j-1),Fmodulo(1,i+j-1),
!     *                   evero_anom(i+j-1),Rmodulo(2,i+j-1),
!     *                   Fmodulo(2,i+j-1),evero(i+j-1),risoluz     
               endif   
         end do
         call correl1(xf,yf,noss,risultato)
         erre = anum /denum * 100
         erre1 = anum1/denum * 100
         res2 = 0.5/sqrt(rhov(i+noss-1))
         write(lo,'(f7.4,2f7.1,2i6,2f9.4)')risultato,erre,erre1,i,
     *            i+noss-1,res1,res2
         res1 = res2
      end do
      
      
      
      sumEo = 0.0
      sumEc = 0.0
      amedqq = 0.0
      amedqqq  = 0.0
      do i=1,nrefl      
         sumEo=sumEo+ex(i)
         amedqq = amedqq + ex(i)**2
         amedqqq = amedqqq + evero_anom(i) ** 2
         sumEc=sumEc+evero_anom(i)
      end do
      amedqq  = amedqq /nrefl   
      amedqqq  = amedqqq /nrefl
      scalaEcEodip = sumEc / sumEo
      
      write(lo,*)' Correlazione tra E2vero e E2osservato (scalaEcEodip)'
     *            ,scalaEcEodip 
      write(lo,*) ' Corr.   R      |R|               resol1     resol2'

      res1 = 0.5/sqrt(rhov(1))
      do i=1, nrefl, npop
         noss = 0
         anum = 0.
         anum1 = 0.
         denum = 0.
         do j=1,npop
               if (i+j-1 <= nrefl) then
               noss = noss + 1
               xf(noss) = evero_anom(i+j-1)
               yf(noss) = ex(i+j-1)
               anum = anum + xf(noss)- scalaEcEodip*yf(noss)
               anum1 = anum1 + abs(xf(noss)- scalaEcEodip*yf(noss))
               denum = denum + xf(noss)
               end if
         end do
         call correl1(xf,yf,noss,risultato)
         erre = anum /denum * 100
         erre1 = anum1/denum * 100
         res2 = 0.5/sqrt(rhov(i+noss-1))
         write(lo,'(f7.4,2f7.1,2i6,2f9.4)')risultato,erre,erre1,i,
     *            i+noss-1,res1,res2
         res1 = res2
      end do
      
     
      sumEo = 0.0
      sumEc = 0.0
      amedqq = 0.0
      amedqqq  = 0.0
      do i=1,nrefl      
         sumEo=sumEo+evero(i)
         sumEc=sumEc+evero_anom(i)
         amedqq = amedqq + evero(i)**2
         amedqqq = amedqqq + evero_anom(i) ** 2
      end do
      amedqq  = amedqq /nrefl   
      amedqqq  = amedqqq /nrefl
      scalaremdiptrue = sumEo / sumEc 
      
      
      sumEo = 0.0
      sumEc = 0.0
      do i=1,nrefl      
         sumEo=sumEo+ecx(i)
         sumEc=sumEc+ex(i)
      end do
      scalaremdipobs = sumEo / sumEc
      
      write(lo,*) ' Correlazione tra (E1vero-E2vero) e  (E1oss-E2oss)'
      write(lo,*) ' scalaremdiptrue=',scalaremdiptrue,' scalaremdipobs='
     *            ,scalaremdipobs
      write(lo,*) ' Corr.   R      |R|               resol1    resol2   
     *%+   %-'
     
      
      res1 = 0.5/sqrt(rhov(1))
      do i=1, nrefl, npop
         noss = 0
         ipercentp = 0
         ipercentn = 0
         anum = 0.
         anum1 = 0.0
         denum1 = 0.0
         denum = 0.
         do j=1,npop
               if (i+j-1 <= nrefl) then
                  noss = noss + 1
             xf(noss) = evero(i+j-1) - scalaremdiptrue*evero_anom(i+j-1)
             yf(noss) = ecx(i+j-1) - scalaremdipobs*ex(i+j-1)
                  anum = anum + xf(noss)-yf(noss)
                  anum1 = anum1 + abs(xf(noss)-yf(noss))
                  denum = denum + abs(xf(noss))
                  denum1 = denum1 + abs(xf(noss))
                  if (xf(noss)*yf(noss) > 0.0) then
                     ipercentp = ipercentp + 1
                  else
                     ipercentn = ipercentn + 1
                  end if
               end if
         end do
         call correl1(xf,yf,noss,risultato)
         erre = anum /denum * 100
         erre1 = anum1/denum1 * 100
         res2 = 0.5/sqrt(rhov(i+noss-1))
         ipercentp = ipercentp*100./npop
         ipercentn = ipercentn*100./npop
         write(lo,'(f7.4,2f7.1,2i6,2f9.4,2i5)')risultato,erre,erre1,
     *   i,i+noss-1,res1,res2,ipercentp,ipercentn
         res1 = res2
      end do
           
      write(lo,*) ' Correlazione tra E1osservato e E2osservato'
      write(lo,*) ' scalaremdipobs =',scalaremdipobs
      write(lo,*) ' Corr.   R      |R|               resol1     resol2'
      
      res1 = 0.5/sqrt(rhov(1))
      do i=1, nrefl, npop
         noss = 0
         anum = 0.
         anum1 = 0.0
         denum = 0.
         do j=1,npop
               if (i+j-1 <= nrefl) then
                  noss = noss + 1
!                  xf(noss) = Rmodulo(1,i+j-1)
!!                  xf(noss) = ex(i+j-1)
!                  yf(noss) = Rmodulo(2,i+j-1)
!!                  yf(noss) = ecx(i+j-1)
                  xf(noss) = ecx(i+j-1)
                  yf(noss) = ex(i+j-1)
                  anum = anum + xf(noss)- scalaremdipobs * yf(noss)
                  anum1 = anum1 + abs(xf(noss)- scalaremdipobs*yf(noss))
                 denum = denum + xf(noss)
               end if
         end do
         call correl1(xf,yf,noss,risultato)
         erre = anum /denum * 100
         erre1 = anum1/denum * 100
         res2 = 0.5/sqrt(rhov(i+noss-1))
         write(lo,'(f7.4,2f7.1,2i6,2f9.4)')risultato,erre,erre1,i,
     *            i+noss-1,res1,res2
!         write(lo,'(f7.4,2i6,f9.4)')risultato,i,i+noss-1,tthet(i+noss-1)
         res1 = res2
      end do
      
      write(lo,*) ' Correlazione tra E1vero e E2vero '
      write(lo,*) ' scalaremdiptrue = ',scalaremdiptrue
      write(lo,*) ' Corr.   R      |R|               resol1     resol2'

      res1 = 0.5/sqrt(rhov(1))
      do i=1, nrefl, npop
         noss = 0
         anum = 0.
         anum1 = 0.0
         denum = 0.
         do j=1,npop
               if (i+j-1 <= nrefl) then
                  noss = noss + 1
                  xf(noss) = evero(i+j-1)
                  yf(noss) = evero_anom(i+j-1)
                  anum = anum + xf(noss)- scalaremdiptrue*yf(noss)
                  anum1 = anum1 + abs(xf(noss)-scalaremdiptrue*yf(noss))
                  denum = denum + xf(noss)
               end if
         end do
         call correl1(xf,yf,noss,risultato)
         erre = anum /denum * 100
         erre1 = anum1/denum * 100
         res2 = 0.5/sqrt(rhov(i+noss-1))
         write(lo,'(f7.4,2f7.1,2i6,2f9.4)')risultato,erre,erre1,i,
     *            i+noss-1,res1,res2
!         write(lo,'(f7.4,2i6,f9.4)')risultato,i,i+noss-1,tthet(i+noss-1)
         res1 = res2
      end do
      
      write(lo,3890)
 3890 format(/,15x,'     Edipobs    Ediptrue     Eremobs    Eremtrue',/)     
      do i=1,nrefl
         write(lo,3900)(indHKL(i,ng),ng=1,3),ex(i),evero_anom(i),
     *                  ecx(i),evero(i),ecx(i) - ex(i),
     *                  evero(i) - evero_anom(i)
 3900                  format(3i5,6f12.5)
      end do
                    
!      stop
 3999 continue
      
       do n=1,numbWL
         nwl(n) = n
      end do
     
      call NormalMad(nrefp,ier)    

      call frm38

      close(jfile)
      
 5900 return

 7000 continue
      write(Msg,7015) jfile
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
 7015 format(' EOF on channel #',i2,'. Reflections expected')
      go to 9020
c
c se dos ed errore allora continua
c
!corr 8000 if (kprog.lt.10 .and. ios.eq.6101) goto 60
 8000 if (ios > 0) go to 60
      write(Msg,8015) fileh(1:Lung(fileh)),ios,nline
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
 8015 format(' Read error on file ',a,' code =',i5,
     *       ' line number ',i5,'. Reflections expected')
      go to 9020

 9000 continue
      write(Msg,9015) ios,fileh(1:Lung(fileh))
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
 9015 format(' Open error, code =',i5,' file is ',a,
     *      '. Reflections expected')
 9020 continue
 9040 ier=-1
      return
      end
!-----------------------------------------------------------------------
      subroutine frm38
      USE BigStore
      USE Liste
      USE MadModule
      USE PhaseModule
!      USE PhaseComRef
!
c
c--write list 38 on disk (MAD/SAD information)
c
c  l38	location of the first parameter in  store
c  n38	current number of parameter
c  md38 number of words for parameter
c  n38a	total number of parameter
c  npre38  length of preamble
c  l38d starting address of the list in store
c  n38d length of the list in store
c
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      l38d=nfl
      kn=38
      npre38= 16
      n38a = 0
      md38 = 0
      n38  = npre38
      n38t = npre38
      call xcln(kn,store(nfl))
      l38 = nfl
      store(l38 + 5) = npre38
      store(l38 + 6) = md38
      store(l38 + 7) = n38
      store(l38 + 8) = n38a
      store(l38 + 9) = n38t
      store(l38 +10) = nMacroTot
      store(l38 +11) = nMicro
      store(l38 +12) = nBlockEDM
      store(l38 +13) = ifRidotta
      store(l38 +14) = jrecyc
      store(l38 +15) = nolsq
      store(l38 +16) = ifPatt
      l38 = l38 + npre38
!     ........................
      store(l38 + 1) = xshuttle(nWave)
      n = 1
      do i=1,8
         n = n + 1
         store(l38 + n) = xshuttle(kAnom(i))
      end do
      do i=1,8
         do j=1,5
            do k=1,2
               n = n + 1
               store(l38 + n) = fPrimoSecondo(i,j,k)
            end do
         end do
      end do
      do i=1,5
         n = n + 1
         store(l38 + n) = xshuttle(normm(i))
      end do
      do i=1,8
         n = n + 1
         store(l38 + n) = xshuttle(nAn(i))
      end do
      do i=1,8
         n = n + 1
         store(l38 + n) = xshuttle(nkAnom(i))
      end do
      n = n + 1	
      store(l38 + n) = xshuttle(nAnom)
      do i=1,5
         n = n + 1
         store(l38 + n) = bWilsonM(i)
      end do
      do i=1,5
         n = n + 1
         store(l38 + n) = scaleWilsonM(i)
      end do
      do i=1,5
         n = n + 1
         store(l38 + n) = xshuttle(nwl(i))
      end do
      n = n + 1
      store(l38 + n) = xshuttle(numbWL)
      n = n + 1
      store(l38 + n) = eMadMax
      n = n + 1
      store(l38 + n) = xshuttle(NumFiltri)
      do i=1,10
         n = n + 1
         store(l38 + n) = xshuttle(nFiltro(i))
      end do
      do i=1,10
         n = n + 1
         store(l38 + n) = SogFiltro(i)
      end do
      n = n + 1
      store(l38 + n) = xshuttle(ifEsuSigma)
      n = n + 1
      store(l38 + n) = SogEss
      n = n + 1
      store(l38 + n) = xshuttle(n_WL_Comb)
      do i=1,31
         n = n + 1
         store(l38 + n) = Rank(i) * isRank(i)
      end do
      do i=1,31
         n = n + 1
         store(l38 + n) = xshuttle(iCombC(i))
      end do
      do i=1,31
         n = n + 1
         store(l38 + n) = cut_d(i)
      end do
      n = n + 1
      store(l38 + n) = xshuttle(nReflInput)
      n = n + 1
      store(l38 + n) = xshuttle(nRej1)
      n = n + 1
      store(l38 + n) = xshuttle(nRej2)
      n = n + 1
      store(l38 + n) = xshuttle(nRej3)
      do i=1,10
         n = n + 1
         store(l38 + n) = xshuttle(nRejj(i))
      end do
!     ........................
      l38 = l38 + n                
      m38  = l38
      n38d = m38-nfl + 1        ! deve essere la lunghezza della lista
      call xfrml(kn,store(nfl),n38d)
      call xdump
c
      return
      end
c
!-----------------------------------------------------------------------
      subroutine sfl38
      USE General
      USE BigStore
      USE Liste
      USE MadModule
      USE PhaseModule
!      USE PhaseComRef
!
c
c--load in common areas list 38 from disk (MAD/SAD information)
c
c  l38	location of the first parameter in  store
c  n38	current number of parameter
c  md38 number of words for parameter
c  n38a	total number of parameter
c  npre38  length of preamble
c  l38d starting address of the list in store
c  n38d length of the list in store
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
!     call srdls(38,ly,nfl,lz,store)
      call srdls(38,ly,nfl,lz)
      l38d=nfl
      n38d=lz
      npre38 = store(l38d + 5)
      md38 = store(l38d+6)
      n38  = store(l38d+7)
      n38a = store(l38d+8)
      n38t = store(l38d+9)
      nMacroTot    = store(l38d +10)
      nMicro    = store(l38d +11)
      nBlockEDM      = store(l38d +12)
      ifRidotta = store(l38d +13)
      jrecyc    = store(l38d +14)
      nolsq     = store(l38d +15)
      ifPatt    = store(l38d +16)
      l38 = l38d + npre38
!
      nWave = kshuttle(l38 + 1)
      n = 1
      do i=1,8
         n = n + 1
         kAnom(i) = kshuttle(l38 + n)
      end do
      do i=1,8
         do j=1,5
            do k=1,2
               n = n + 1
               fPrimoSecondo(i,j,k) = store(l38 + n) 
            end do
         end do
      end do
      do i=1,5
         n = n + 1
         normm(i) = kshuttle(l38 + n)
      end do
      do i=1,8
         n = n + 1
         nAn(i) = kshuttle(l38 + n)
      end do
      do i=1,8
         n = n + 1
         nkAnom(i) =kshuttle(l38 + n)
      end do
      n = n + 1	
      nAnom = kshuttle(l38 + n)
      do i=1,5
         n = n + 1
         bWilsonM(i) = store(l38 + n) 
      end do
      do i=1,5
         n = n + 1
         scaleWilsonM(i) = store(l38 + n)
      end do
      do i=1,5
         n = n + 1
         nwl(i) = kshuttle(l38 + n)
      end do
      n = n + 1
      numbWL = kshuttle(l38 + n)
      n = n + 1
      eMadMax = store(l38 + n)
      n = n + 1
      NumFiltri = kshuttle(l38 + n)
      do i=1,10
         n = n + 1
         nFiltro(i) = kshuttle(l38 + n)
      end do
      do i=1,10
         n = n + 1
         SogFiltro(i) = store(l38 + n)
      end do
      n = n + 1
      ifEsuSigma = kshuttle(l38 + n)
      n = n + 1
      SogEss = store(l38 + n)
      n = n + 1
      n_WL_Comb = kshuttle(l38 + n)
      do i=1,31
         n = n + 1
         Rank(i) = store(l38 + n)
      end do
      do i=1,31
         n = n + 1
         iCombC(i) = kshuttle(l38 + n)
      end do
      do i=1,31
         n = n + 1
         cut_d(i) = store(l38 + n)
      end do
      n = n + 1
      nReflInput = kshuttle(l38 + n)
      nReflTot = nReflInput           !310105
      n = n + 1
      nRej1 = kshuttle(l38 + n)
      n = n + 1
      nRej2 = kshuttle(l38 + n)
      n = n + 1
      nRej3 = kshuttle(l38 + n)
      do i=1,10
         n = n + 1
         nRejj(i) = kshuttle(l38 + n)
      end do
!     ........................
      nfl=l38d+lz
      ListaOK(38)=1
      return
      end
c-----------------------------------------------------------------------
      subroutine NormalMad(nrefp, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE MADStuff
      USE MadModule
      USE PhaseModule
      USE xdataMod
!
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /DataToNormal/ jumpData, btData, nstrData
      dimension erreEP(5),erreEM(5),erreDP(5),erreDM(5)
      dimension NumRef(5)
      dimension ihk(3),evrec(6),izero(3),zero(6)
      character *255 nomefile
      character *80 filem
      character *10 WilsonString
 
      dimension SigIncr(2,20),R2Vec(20)
      dimension nstrVec(5), i1(3)
      dimension xf(200), yf(200), xftot(3000), yftot(3000)
      
      
      character*256 line,buff
      
c
      nstrData = 0
      ier = 0
      nrefl = nrefp
c

      nReflDim = nrefl
      call AllocaRiflessi(1)
      call AllocaMAD(1)
c
      idvet1(:) = 0
      
!pgMAD1011
!      Msg = "<big><b>Data Section:</b></big>" 
!      call TestoGR(Msg, color_RED, 2, 1)
!      nnnat = anat
!      if (abs(nnnat-anat) > 0.01) then
!          write(Msg,5721) anat
!      else
!          write(Msg,5720) nnnat
!      end if
!      call shift(Msg,k1)
!      Msg = Msg(1:k1)//' anomalous scatterers to locate.'
!      call TestoGR(Msg, -1, 2, 1)
! 5720 format(i3)  
! 5721 format(f6.2)  
! 5720 format(i3,' anomalous scatterers to locate.')  
! 5721 format(f6.2,' anomalous scatterers to locate.')  
!      write(Msg,5722) nWave
!      call TestoGR(Msg, -1, 2, 1)
! 5722 format('The input file contains data measured at ',i3,
!     *          ' wavelengths')
       
      if (nWave > 1) then
         write(filem,'(5i2)') (nwl(i),i=1,numbWL)
         length = Lung(filem)
         write(lo,5723) filem(1:length)
         if (knorm /= 0) then
            if (numbWL == 1) then
               write(Msg,5725) filem(1:length)
               k1 = index(Msg,'estimate') + 8
            else
               write(Msg,5726) filem(1:length)
               k1 = index(Msg,'user to') + 7
            end if
         end if
!         call AddMadMessage(Msg, 1, -1, 2)
!         call TestoGR(Msg(1:k1), -1, 2, 1)
!         call TestoGR(Msg(k1+1:), -1, 2, 1)
      end if

 5723 format(/,' The wavelengths:',a,
     *         ' will be used to estimate E0a values',/)
 5725 format('The wavelength n.',a,
     *     ' has been selected by the user to estimate ',
     *     'E<sub>0a</sub> values')
 5726 format('The wavelength combination ',a,
     *     ' has been selected by the user to estimate ',
     *     'E<sub>0a</sub> values')


      icomat = icomat + 1      

      nrefl = nrefp
      nreflold = nrefl


!!!!!!      call Caccia_i_Miette(iop, rfac, nrefp)

      
!!!!!!      stop 9988
      

      sig = 1.0
      SigInc = 2.0
      SogMin = 0.05
      SogMax = 0.0

      nR2 = 0

!pgMADPOW
!      ifNoSpeciali = 0    ! riflessi speciali ritenuti 
!      ifNoSpeciali = 1    ! riflessi speciali eliminati
      if (icent == 0) then
         ifNoSpeciali = 1
      else
         ifNoSpeciali = 0
      end if 

      ifNoSpeciali = 0
      
      write(lo,5656) ifNoSpeciali
 5656 format(/,' ifNoSpeciali = ',i5,/)
!pgMADPOW

         
  100 call AMatrice_Gen(nRefAct,neglamda,iposlamda,sig,
     *                  ifNoSpeciali)
      nrefl = nRefAct               

c       media i valori calcolati
 
      sum0 = 0.0
      nnrrff = 0
      nnrrffM = 0
      do i=1,nrefl
         if(iinr(i).gt.0) then
!            sum0 = sum0 + evet(i)
!            nnrrff = nnrrff + 1
            sum0 = sum0 + Mult(i)* evet(i)
            nnrrff = nnrrff + 1
            nnrrffM = nnrrffM + Mult(i)
         end if
      enddo
      sum0 = sum0 / float(nnrrffM)

      sum1 = sum0

      if (knw == 1) then     
         write(lo,6789) sqrt(sum1),neglamda,iposlamda
 6789    format('   scala (e=e/scala) =',e15.7,' Lambda11<0 =',i5,
     *          ' Lambda11>0 =',i7)
      end if

      sc = 0.
      bt = 0.
      do j=1,numbWL
         i = nwl(j)
         sc = sc + scaleWilsonM(i)
         bt = bt + bWilsonM(i)
      end do
      sc = sqrt(sc / numbWL)  !!!!!!<<<< controllare!!!!!

      bt = bt / numbWL

      sum2 = 0.0
      do i=1,nrefl
         evet(i) =  evet(i) / sum1 
         if (iinr(i).gt.0) then
            sum2 = sum2 + Mult(i) * evet(i) 
         end if
c-- compute F's
         rhos = rhov(i)
         arg = 0.
         do ii=1,nAnom
            nkA = nkAnom(ii)
!pgMAD            fz = ScattFact(nkA, rhos)
            fz = celem(nkA)%cl
            do jj=1,4
!corr               fz = fz +al(jj,nkA) * exp(-bs(jj,nkA)*rhos)
               fz = fz +celem(nkA)%al(jj) * exp(-celem(nkA)%bs(jj)*rhos)
            enddo
!corr            arg = arg + fz * fz * exp(-2.0*bt*rhos) * float(nw(nkA))
            arg = arg + fz * fz * exp(-2.0*bt*rhos) * celem(nkA)%nw
         end do
!!!!!!         fz = sc * sqrt(arg)
         fz = sqrt(arg)
         fovet(i) = sqrt(evet(i)) * fz
         Sigmav(i) = 0.1
c--
      enddo

      sum2 = sum2 / float(nnrrffM)

      do i=1,10
         nRejj(i) = 0
      end do 

!     eliminazione e > 5.0 e riscalatura
        
      do i=1,nrefl
         if(iinr(i).gt.0) then
           if (sqrt(evet(i)).gt.5.0) then
              iinr(i) = -1
              nRejj(1) = nRejj(1) + 1
           end if
         end if
      end do
      sum0 = 0.0
      nnrrffM = 0
      do i=1,nrefl
         if(iinr(i).gt.0) then
!            sum0 = sum0 + evet(i)
!            nnrrff = nnrrff + 1
            sum0 = sum0 + Mult(i) * evet(i)
            nnrrffM = nnrrffM + Mult(i)
        end if
      enddo
      sum0 = sum0 / float(nnrrffM)
      do i=1,nrefl
         evet(i) =  evet(i) / sum0
      end do
      
!      calcolo indici R(1) e R(2)

      numegt1 = 0
      numegt2 = 0
      nrefvero = 0
      do i=1,nrefl
         if (iinr(i).gt.0) then
            nrefvero = nrefvero + 1
            ev = sqrt(evet(i))
            if (ev.ge.1.0) then
               numegt1 = numegt1 + 1
               if (ev.ge.2.0) then 
                  numegt2 = numegt2 + 1
               end if
            end if
         end if
      end do
      R1 = float(numegt1) / nrefvero
      R2 = float(numegt2) / nrefvero

      if (knw == 1) then
         write(lo,150) sig, R1, R2
  150    format(' Fattore moltiplicativo dei sigma=',f8.4,' R(1)=',
     *          f7.4,' R(2)=',f7.4)
      end if

      nR2 = nR2 + 1
      
      if (nR2 > 20) go to 200   ! pezza
      
      R2Vec(nR2) = R2

!      if (icent == 0) then
         R2max = 0.020
!         R2max = 0.030     ! <<<<<<<<<<<<<<<<<<<<<<<<
         R2min = 0.016
!      else
!         R2max = 0.055
!         R2min = 0.045
!      end if
      
      if (R2.gt.R2max) then
         if (SogMax == 0.0) then
            sig = sig + SigInc
         else
            SigMin = sig
            SigInc = SigInc / 2.
            sig = sig + SigInc
         end if
         nrefl = nreflold
         go to 100
      else if (R2.lt.R2min) then
         if (sig <= SogMin) go to 200
         if (sig == 1.0) then
            SogMax = sig
            sig = SogMin
            SigInc = (1.-SogMin) !/2.
            nrefl = nreflold
            go to 100
         else
            SogMax = sig
            SigInc = SigInc/2.
            sig = sig - SigInc
            nrefl = nreflold
            go to 100
         end if
      end if

  200 continue
!      fine calcolo R(1)  e  R(2)

      if (nRej1 > 0) then
        write(lo,5765) nRej1
 5765   format(/,i6,' reflections rejected: only F1 or F2 was measured')
      end if

      if (nRej2 > 0) then
         write(lo,5766) nRej2
 5766    format(/,i6,' reflections with restricted phase rejected')
      end if

      if (nFiltro(1).eq.1.or.eMadMax.lt.9999.) then
         do i=1,nrefl
            if (sqrt(evet(i)).gt.eMadMax) then
               iinr(i) = -1
               nRejj(1) = nRejj(1) + 1
            end if
         end do
      end if

      if (knw.gt.0) then
          call SFCalc_C(1, rfac, nrefp)
      endif

!      if (NumFiltri.gt.0) then
!         call Filtro_2003(nRecF, npr, nrefp)
!      end if

      if (nRejj(1) > 0) then
         write(lo,5767) nRejj(1),eMadMax
 5767    format(/,i6,' reflections rejected with R0a > ',f9.2)
      end if
      if (nRejj(2) > 0) then
         write(lo,5768) nRejj(2),SogFiltro(2)
 5768 format(/,i6,' reflections rejected with a resolution higher than '
     *,f5.2)
      end if
      if (nRejj(3) > 0) then
         write(lo,15768) nRejj(3),SogFiltro(3)
15768  format(/,i6,' reflections rejected with a resolution lower than '
     * ,f7.2)
      end if

      if (knw == 1) then
         write(lo,5770) (nRejj(i),i=1,6),nrefl
 5770 format(/,'rigettati ',i6,5(' + ',i6),' su un totale di ',i7)
         write(lo,'(a)')' 1 - E > 5.0'
         write(lo,'(a)')' 2 - soglia su d'
         write(lo,'(a)')' 3 - soglia su d(lowres)'
         write(lo,'(a)')' 4 - soglia su E'
         write(lo,'(a)')' 5 - soglia su E/sigma'
         write(lo,'(a)')' 6 - soglia su Dano(E)'
      end if

      ij = 0
      do i=1,nrefl
          if(iinr(i).gt.0) then
            ij=ij+1
            khl(1,ij) = khl(1,i)
            khl(2,ij) = khl(2,i)
            khl(3,ij) = khl(3,i)
            rhov(ij) = rhov(i)
            mkang(ij) = mkang(i)
            evet(ij) = evet(i)
            fovet(ij) = fovet(i)
            fcvet(ij) = fcvet(i)
            ipub(ij) = ipub(i)
            evero(ij) = evero(i)
            iinr(ij) = iinr(i)
            
            Rmodulo(:,ij) = Rmodulo(:,i)
            Fmodulo(:,ij) = Fmodulo(:,i)
            
            do j=1,5
               emesus(ij,j) = emesus(i,j)
            end do     
         end if            
      end do

      nrefl = ij

      write(lo,5769) nrefl
 5769 format(/,i6,' reflections used to locate the anomalous ',
     *            'substructure')
     
      write(lo,470)
  470 format(//,1h ,78('+'))
  
      if (knw.gt.0) then
          call SFCalc_C(2, rfac, nrefp)
      endif


!      open(77,file='C:\EXPO2006\StruttureANOM\prova\provaA_Cu.hkl')

      ij = 0
      do i=1,nrefl
         if(iinr(i).gt.0.or.mkang(i).ne.1) then     !pgMAD2
            ij=ij+1
            khl(1,ij) = khl(1,i)
            khl(2,ij) = khl(2,i)
            khl(3,ij) = khl(3,i)
            rhov(ij) = rhov(i)
            mkang(ij) = mkang(i)
            evet(ij) = evet(i)
!!!!!!!!!!!!!!!!    imposizione di evet = evero
!!            evet(ij) = evero(i)*evero(i)
            fovet(ij) = fovet(i)
!!!!!!!!!!!!!!!!    imposizione di fovet = fcvet
!!            fovet(ij) = fcvet(i)
            fcvet(ij) = fcvet(i)

            fvero(ij) = fcvet(i)

            ipub(ij) = ipub(i)
            evero(ij) = evero(i)
            iinr(ij) = iinr(i)
            
            Rmodulo(:,ij) = Rmodulo(:,i)
            Fmodulo(:,ij) = Fmodulo(:,i)
            
            do j=1,5
               emesus(ij,j) = emesus(i,j)
            end do 
  
            sigmav(ij) = emesus(ij, iks) / sqrt(sum1)     !memorizzazione sigma(e)
            
            fovet2 = fovet(ij) ** 2
!            write(77,7788) khl(1:3,ij),fovet2,fovet(ij)
! 7788       format(3i4,2f15.4)
     
         end if            
      end do

      nrefl = ij
      
      evet_med = 0.0
      sigmav_med = 0.0
      do i=1,nrefl
         evet_med = evet_med + sqrt(evet(i))
         sigmav_med = sigmav_med + sigmav(i)
      end do
      evet_med = evet_med / nrefl
      sigmav_med = sigmav_med / nrefl
      if (knw>0) then
         write(lo,'(/,a,2f15.8,/)')' Medie in MADSAD:R0a,sigma(R0a)=',
     *                              evet_med, sigmav_med
      end if

      amed = 0
      nnrrff = 0
      do i=1,nrefl
         if(iinr(i).gt.0) then
             nnrrff = nnrrff + 1
             amed = amed + evet(i)
         end if
      end do
      amed = amed / nnrrff    

      do i=1,nrefl
         idvetP(i) = i
      enddo
      isort = 1
      iuno = 1
      do i=1,nrefl
         eme(i) = emesus(i,ikepers)
      end do
      call sortall3(isort,eme,iuno,nrefl,idvetP)
      sum_evero = 0.0
      n_evero = 0
      do i=1,nrefl
         jcris = idvetP(i)
         if (eme(i) >= 0.01) then
             pippo = 1
             exit
         end if
         sum_evero = sum_evero + evero(jcris)
         n_evero = n_evero + 1
!         write(lo,5566) khl(1,jcris),khl(2,jcris),khl(3,jcris),
!     *                  eme(i),evero(jcris),evet(jcris)
 5566    format(4x,' h,k,l=',3i3,' E*sigma=',f12.5,' Evero=',f12.5,
     *          ' Eoa=',f12.5)
      enddo
      if (n_evero > 0) then
         ave_evero = sum_evero/n_evero
!0211
         if (knw == 1) then
            write(lo,5577) ave_evero, n_evero
         end if
!0211
 5577    format(4x,' <Evero> (E*sigma)=',f12.3,' (',i4,')')
      end if

!      do i=1,nrefl
!         idvetP(i) = i
!      enddo
      do i=1,nrefl
         eme(i) = emesus(i,ikess)
      end do
!      call sortall3(isort,eme,iuno,nrefl,idvetP)


!      do i=nrefl,nrefl-9,-1
!         j = idvetP(i)
!         write(lo,6987) i,khl(1,j),khl(2,j),khl(3,j),evet(j),eme(i),
!     *                  sigmav(j)
!      end do
! 6987 format(4i4,3f10.5)


      if (n_evero > 0) then
         sum_evero = 0.0
         do i=1,n_evero
            jcris = idvetP(i)
            sum_evero = sum_evero + evero(jcris)
!            write(lo,5588) eme(i),evero(jcris),evet(jcris)
 5588       format(4x,' E/sigma=',f12.5,' Evero=',f12.5,' Eoa=',f12.5)
         enddo
         ave_evero = sum_evero/n_evero

         if (knw == 1) then
            write(lo,5599) ave_evero,n_evero
         end if

 5599    format(4x,' <Evero> (E/sigma)=',f12.3,' (',i4,')')
      end if

c
c-- Crea Lista 6
c
      bb = bt
      scb = sc

!pgMADPOW      call CreaLista6mad()

      ilist = 6
      call cancella(ilist)
      
      ij = 0
      do i=1,nrefl
         if(iinr(i).gt.0) then
            ij = ij + 1
            jpp = iinr(i)
            indHKL(ij,1) = indHKL(jpp,1)
            indHKL(ij,2) = indHKL(jpp,2)
            indHKL(ij,3) = indHKL(jpp,3)
            indHKL(ij,4) = indHKL(jpp,4)
            indHKL(ij,5) = indHKL(jpp,5)
            Mult(ij) = Mult(jpp)
            TThet(ij) =  TThet(jpp)
            WHM(ij) = WHM(jpp)
            SetFob(ij,1) = SetFob(jpp,1) 
            SetFob(ij,2) = SetFob(jpp,2) 
            SetFob(ij,3) = SetFob(jpp,3) 
            SetFob(ij,4) = SetFob(jpp,4)                  
            SetFob(ij,5) = SetFob(jpp,5)
            puntatore(ij) = puntatore(jpp)
            ex(ij) = sqrt(evet(ij))
            fx(ij) = fovet(ij)
            fxsav(ij)=  fvero(ij)
            ecx(ij) = evero(ij)
 !           fcvet(ij) = fcvet(jpp)
         end if         
      end do
      
      nrefl = ij 
      
      res1 = 0.5/sqrt(rhov(1))
      do i=1, nrefl, 50
         noss = 0
         do j=1,50
!            if (Fmodulo(1,i+j-1) > 0.0) then
               if (i+j-1 <= nrefl) then
               noss = noss + 1
!               xf(noss) = Fmodulo(1,i+j-1)**2
!               yf(noss) = Fmodulo(2,i+j-1)**2
               xf(noss) = Rmodulo(1,i+j-1)
               yf(noss) = Rmodulo(2,i+j-1)
               end if
         end do
         call correl1(xf,yf,noss,risultato)
         res2 = 0.5/sqrt(rhov(i+noss-1))
         write(lo,'(f7.4,2i6,2f9.4)')risultato,i,i+noss-1,res1,res2
!         write(lo,'(f7.4,2i6,f9.4)')risultato,i,i+noss-1,tthet(i+noss-1)
         res1 = res2
      end do
      
      do i=1,nrefl
!         xftot(i) = Fmodulo(1,i)**2
!         yftot(i) = Fmodulo(2,i)**2
         xftot(i) = Rmodulo(1,i)
         yftot(i) = Rmodulo(2,i)
      end do      
      call correl1(xftot,yftot,nrefl,risultato)
      write(lo,'(f7.4,2i6,f9.4)')risultato,nrefl

      amed = 0
      nnrrff = 0
      do i=1,nrefl
         if(iinr(i).gt.0) then
             nnrrff = nnrrff + 1
             amed = amed + evet(i)
         end if
      end do
      amed = amed / nnrrff    

      
      do i=1,nrefl
         if (indHKL(i,1).ne.khl(1,i).or.indHKL(i,2).ne.khl(2,i).or.
     *       indHKL(i,3).ne.khl(3,i)) then
            write(lo,'(a)')  '  ERRORE DI MEMORIZZAZIONE IN INDHKL  '
            stop
         end if
      end do    
      
!      do i = 1,20
!         write(lo,'(4i4,i9,i4,7f15.4)')indHKL(i,1:5),Mult(i),
!     *                     TThet(i),WHM(i),SetFob(i,1:5)
!         write(lo,'(4x,7f15.4)')puntatore(i),ex(i),fx(i),
!     *                     fxsav(i),ecx(i),fcvet(i)
!     
!         write(lo,6688) khl(1,i),khl(2,i),khl(3,i),rhov(i),mkang(i),
!     * evet(i),fovet(i),fcvet(i),fvero(i),ipub(i),evero(i),sigmav(i)
!6688   format(3i4,f15.4,i5,4f15.4,i5,2f15.4,/) 
!      end do
      
      ifCreate = 1

      call CreaListaRiflessi
      
      bt = bb
      sc = scb


      s3 = 0.
      s2 = 0.
      do ii=1,nAnom
         nkA = nkAnom(ii)
!corr         ss = float(nw(nkA))*no(nkA)*no(nkA)
         ss = celem(nkA)%nw*celem(nkA)%z*celem(nkA)%z
         s2 = s2 + ss
         s3 = s3 + ss * celem(nkA)%z
      end do
      s3s2mad=s3/sqrt(s2**3)
!

!pgMAD9
!     calculate number of reflexions for invariant searching
!                     SAD / MAD  case
!      if (nstrData == 0) then
          if (nWave > 1) then
              nat_ANOM = 0.
              do ii=1,nAnom
!corr                 nat_ANOM = nat_ANOM + float(nw(nkAnom(ii))) /
!corr     *                       (pts*float((icent+1)*nsym))
                 nat_ANOM=nat_ANOM+celem(nkAnom(ii))%nw/spacegr%nsymop
              end do
              nstrVec(1) =  500
!              nstrVec(1) =  150
              nstrVec(2) =  800
              nstrVec(3) = 1000
              nstrVec(4) = 1500
              nstrVec(5) = 2500

              ifEnve = 0
              ifRelax = 0
              select case (nat_ANOM)
              case (:10)
                 nsv = 1
              case (11:20)
                 nsv = 2
              case (21:30)
                 nsv = 3
              case (31:45)
                 nsv = 4
              case (46:)
                 nsv = 5
              end select
              if (nsv < 5) then
                  if (volume > 1500000.) then
                      nsv = nsv + 1
                  end if
              else
                  if (volume > 900000.) then
                      ksize = 4
                  end if
              end if
              if (nstrData == 0) then
                  nstr = nstrVec(nsv)
              end if
!pgMAD1011
           else
              if (nstrData == 0) then
                 nstr = 2000
              end if
           end if
!pgMAD9

!      write(Inte,'(i10)') nrefl
!      call shift(Inte,k1)
!      write(WilsonString,'(f10.2)') bt
!      call shift(WilsonString,k2)
!      write(Msg,300) Inte(1:k1), WilsonString(1:k2)
!       call AddMadMessage(Msg, 1, -1, 2)
!  300 format(a,' structure factors have been normalised.',
!      *       ' The average thermal factor (estimated by ',
!      *       'Wilson plot) is ',a)
!      call AddMadMessage(' ', 1, -1, 2)
!      k1 = index(Msg, 'lised.') + 5
!      call TestoGR(Msg(1:k1), -1, 2, 1)
!      call TestoGR(Msg(k1+2:), -1, 2, 1)
!pgMAD

      ind = 0
      do i=1,nrefl
         rhoc=rhof(pp,IndHKL(i,1),IndHKL(i,2),IndHKL(i,3))
         rhoc=rhoc*rhoc
         
         i1(1) = IndHKL(i,1)
         i1(2) = IndHKL(i,2)
         i1(3) = IndHKL(i,3)
         call cmult2002(i1,eps,multi)     !dritan
         
!         fo=sqrt(SetFob(i,4))
         fo=fovet(i)
!g!      write(6,*) 'cardin:fo',i,fo
!         eeee=0.0
         eeee = evet(i)
         ecx(i) = evero(i)
!         ifasi=IndHKL(i,5)
         ifasi=ipub(i)*32+mkang(i)
         if (fo.gt.fosog) fosog=fo
         if (rhoc.gt.rhomax) rhomax=rhoc
         jscra(1,i)=IndHKL(i,1)
         jscra(2,i)=IndHKL(i,2)
         jscra(3,i)=IndHKL(i,3)
         scrav(4,i)=fo
         scrav(5,i)=rhoc
         jscra(6,i)= Mult(i)
         jscra(7,i)=ifasi
         scrav(8,i)=eeee
         scrav(9,i)=0.0
         scrav(10,i)=0.0
         scrav(11,i)=1.0  !!!!!!! denor
         scrav(12,i)=sigmav(i)
         scrav(14,i)=fcvet(i)
         scrav(15,i)=eps
         nvv(i)=IndHKL(i,4)
         if (nvv(i).ge.0) then
             if (nvv(i).gt.0) over=nvv(i)
             we(i)=1.0/sqrt(over)
         endif
         if (nvv(i).eq.1) then
             nvn(i)=0
             if (ind.gt.0) nvn(ind)=i-1
             ind=0
         elseif (nvv(i).gt.1) then
             if (ind.gt.0) nvn(ind)=i-1
             ind=i
         elseif (nvv(i).eq.0) then
             nvn(i)=i-1
         else
             if (ind.gt.0) nvn(ind)=i-1
             ind=0
             nvn(i)=-1
             we (i)=0.0
         endif
      enddo

      if (ind.gt.0) nvn(ind)=nrefl
      do i=1,nrefl
         nvv(i)=nvn(i)*1024+int(we(i)*1000)
         jscra(13,i)=nvv(i)
      enddo
c

      call ecal(0)
      
      call PreparaRiflessiOrdinati
!
         iy=67543
!
      call CreaListaRiflessiOrdinati(iy)
      
      call xdump
      icomat = icomat - 1
c
c
      if (ier.ne.0) then
          call AllocaRiflessi(2)
      end if
!      call AllocaMAD(2)
      

c
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaMAD(iAction)
      USE General
      USE MADStuff
      USE MadModule
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(20)
!
      do i=1,20
         ierv(i) = 0
      enddo
      ierr = 0
!
      if (iAction == 1) then
!!!      nrefpp = nrefl / 2
      IF (.NOT. ALLOCATED(idvet))
     *   ALLOCATE (idvet(1:nrefl),stat = ierv(2))
      IF (.NOT. ALLOCATED(idvet1)) 
!!!     *   ALLOCATE (idvet1(1:nrefpp),stat = ierv(3))
     *   ALLOCATE (idvet1(1:nrefl),stat = ierv(3))
      IF (.NOT. ALLOCATED(iordm)) 
     *   ALLOCATE (iordm(1:nrefl,1:nWave),stat = ierv(4))
      IF (.NOT. ALLOCATED(iinr)) 
     *   ALLOCATE (iinr(1:nrefl),stat = ierv(5))
      IF (.NOT. ALLOCATED(eme)) 
     *   ALLOCATE (eme(1:nrefl),stat = ierv(6))
      IF (.NOT. ALLOCATED(idvetP)) 
     *   ALLOCATE (idvetP(1:nrefl),stat = ierv(7))
      IF (.NOT. ALLOCATED(evero)) 
     *   ALLOCATE (evero(1:nrefl),stat = ierv(8))
      IF (.NOT. ALLOCATED(fvero)) 
     *   ALLOCATE (fvero(1:nrefl),stat = ierv(9))
      IF (.NOT. ALLOCATED(emesus)) 
     *     ALLOCATE (emesus(1:nrefl,1:5) ,stat = ierv(10))
      IF (.NOT. ALLOCATED(jcdd)) 
     *     ALLOCATE (jcdd(1:nrefl) ,stat = ierv(10))
      IF (.NOT. ALLOCATED(sig_piu)) 
     *     ALLOCATE (sig_piu(1:5,1:nrefl) ,stat = ierv(10))
      IF (.NOT. ALLOCATED(wt_s)) 
     *     ALLOCATE (wt_s(1:nrefl) ,stat = ierv(10))
      IF (.NOT. ALLOCATED(iphaz_s)) 
     *     ALLOCATE (iphaz_s(1:nrefl) ,stat = ierv(10))
      IF (.NOT. ALLOCATED(ipub_s)) 
     *     ALLOCATE (ipub_s(1:nrefl) ,stat = ierv(10))


          ierr = 0
          do i=1,10
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(lo,*) 'MAD Allocation error'
              call cstop(' ')
          endif
          idvet  = 0
          idvet1 = 0
          iordm  = 0
          iinr   = 0
          eme    = 0
          idvetP = 0
          evero  = 0
          fvero  = 0
          emesus = 0
      else
          IF (ALLOCATED(idvet))
     *       DEALLOCATE (iordm,idvet,idvet1,iinr,eme,fvero,emesus,
     *                   idvetP,evero,jcdd,sig_piu,wt_s,iphaz_s,ipub_s,
     *                   stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'MAD DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
c-----------------------------------------------------------------------
      subroutine AMatrice_Gen (nRefAct,neglamda,
     *                         iposlamda,sig,ifNoSpeciali)
      USE General
      USE Riflessi
      USE MADStuff
      USE MadModule
      USE elements, only: numelem
!
      common /misurato/ misu

      common /statFC/ rhm,rhmi,emax,emin,
     *   teta(22),ncont(22),rf(22),rfs(22),
     *   Eint(22),ncontE(22),rfE(22),rfsE(22),sumfo(3),sumdf(3),
     *  cb(3),
     *  rf1(22),rfE1(22),rf2(22),
     *          ssint(22,20),ss(22,20),nnss(22,20),
     *          ss1(22,20),ssd(22,20),SRint(22),
     *          SRintD(22)

      real*8 AK(8,8),AKL(8,8),Dum(8,8), d
      real*8 formn,form,form1p,form1s,form2p,form2s
      real*8 Sig0,Siga1,SigN1,Sig0a,Siga2,SigN2
      real*8 S1,S2,S3,S4,S5,S6,S7,S8,S9,S10,S11,S12
      real *8 fz, arg, ebw1, ebw2, e2bw1, e2bw2
      real *8 Sigma1_piu, e1_piu, Sigma2_piu, e2_piu
!      real *8 Sigma1_meno, e1_meno, Sigma2_meno, e2_meno
      real*8 t,tt,bst,BMW,a
      real*8 ebw0,e2bw0,ebw(5),e2bw(5)

      real*8 soglia_2(5),soglia_1(5)

      dimension f_piu(5),sigma_piu(5),e_piu(5)
      dimension ihk(3)


      real*8 Siga(5),SigNn(5)
      real*8 SS5,SS6,SS7,SS8,SS10,sig_p(5),e_p,sig_m(5),e_m

      emesus(:,:) = 0
      nRej1 = 0
      nRej2 = 0
      nRej3 = 0
      iinr(1:nrefl) = 0

      do km=1,nWave
        do i=1,270
           t=0.01*float(i-1)
           tt=t*t
           f0jna(i,km)=0.0
           do k = 1,8
              f0ja(i,k,km)=0.0
              fpj (i,k,km)=0.0
!              fsj (i,k,km)=0.0
           end do
           do j=1,numelem(celem)
              fz = celem(j)%cl
              do jj=1,4
!corr                 bst=bs(jj,j)*tt
!corr                 if (bst.le.60.) fz=fz+al(jj,j)*exp(-bst)
                 bst=celem(j)%bs(jj)*tt
                 if (bst.le.60.) fz=fz+celem(j)%al(jj)*exp(-bst)
              end do
!corr              fnw=float(nw(j))
              fnw=celem(j)%nw
              ifAnomalo = 0
              do k=1,nAnom
!corr                 if (kAnom(k).eq.nalf(j)) then
                 if (kAnom(k) == celem(j)%ptab) then
                    nAn(k) = fnw
                    f0ja(i,k,km) = fz  
                    fpj(i,k,km) = fz + fPrimoSecondo(k,km,1)
 !                   fsj(i,k,km) = fPrimoSecondo(k,km,2)
                    ifAnomalo = 1
                 endif
              end do
              if (ifAnomalo.eq.0) then
                 f0jna(i,km)=f0jna(i,km) + fnw * fz**2
              end if
           end do
        end do
      end do

      nord = 2 * numbWL + 2 
      ndim = 8

      call scrper(' Performing E0a calculation',0,0)
      nperc=50
      iperc0=nrefl/nperc
      iperc=iperc0
      jperc=0

      neglamda = 0
      iposlamda = 0
      rhm = 0.0

      Rmodulo_ord(:,:) = 0.0
      Fmodulo_ord(:,:) = 0.0
      ij = 0
      ji = 0

      loop_nrefl : do inrc=1, nrefl
          if (inrc == 1192) then
          pippoo = 1
          end if
          inr = inrc
          ihk(1) = khl(1,inrc)
          ihk(2) = khl(2,inrc)
          ihk(3) = khl(3,inrc)
          call cmult2002(ihk,eps,multi)
          ig = 1        
          idv = 10000*multi + 100*int(eps+0.5) + ig+1

          kh = ihk(1)
          kk = ihk(2)
          kl = ihk(3)

          if (kh==0 .and. kk==0 .and. kl==0) then
             exit loop_nrefl
          end if
          
          esq = 0.0
          
          jcode = jcdd(inrc)
          rho = rhov(inrc)

!!!!          iphy = iphxi(mmo)      ! ?????????

          f_piu(1:2) = Fmodulo(1:2,inrc)
          sigma_piu(:) = sig_piu(:,inrc)
          e_piu(1:2) = Rmodulo(1:2,inrc)
                    
         
!    moltiplicazione dei valori di sigma_piu 
          do k=1,nWave
             sigma_piu(k) = sig * sigma_piu(k)
          end do

          if (inr.eq.iperc) then
              jperc=jperc+1
              iperc=iperc+iperc0
              call scrper(' ',jperc,nperc)
          endif

         multVal=idv/10000
         ie=(idv-10000*multVal)/100
         eps=float(ie)
         tmul=float(multVal)

         BWM = 0
         do k=1,numbWL
            BWM = BWM + BWilsonM(nwl(k))
         end do

         BWM = BWM / numbWL

         ebw0 = exp(-BWM*rho)
         e2bw0 = exp(-2*BWM*rho)
!   usa un B mediato per tutte le lunghezze d'onda
         do k=1,numbWL
            ebw(k) = ebw0
            e2bw(k) = e2bw0
         end do

!         do k=1,numbWL
!            if (f_piu(nwl(k)).lt.0.001) then
!               nRej1 = nRej1 + 1
!               ij = ij + 1    
!               inrB = -1    
!               goto 99     
!            end if
!         end do
!         peso1 = 1.
!         peso2 = 1.
!         if (f_pp(1,mmo) > 0) then
!            peso1 = sigma_pp(1,mmo) / (PercFp * f_pp(1,mmo))
!            if (peso1 > 0) then
!               peso1 = 1. / peso1**2
!            end if
!         end if
!         if (f_pp(2,mmo) > 0) then
!            peso2 = sigma_pp(2,mmo) / (PercFp * f_pp(2,mmo))
!            if (peso2 > 0) then
!               peso2 = 1. / peso2**2
!            end if
!         end if

         peso1 = 0.
         peso2 = 0.
         if (Fmodulo(1,inrc) > 0) then
               peso1 = 1. / sig_piu(1,inrc)**2
         end if
         if (Fmodulo(2,inrc) > 0) then
               peso2 = 1. / sig_piu(2,inrc)**2
         end if
         
!         peso1 = sig_piu(1,inrc)
!         peso2 = sig_piu(2,inrc)

!        if (peso1<0.3 .or. peso2<0.3) then
!            nRej1 = nRej1 + 1
!            ij = ij + 1    
!            inrB = -1    
!            goto 99     
!         end if

         ji = ji + 1

         formn = formM(rho,f0jna,nwl(1))
         Sig0 = formn * eps * e2bw(1)

         Sig0a = 0.0
         do i=1,nAnom
            f0(i) = formM2(rho,f0ja,i,1)
            Sig0a = Sig0a + nAn(i) * f0(i) * f0(i) * eps * e2bw(1)
         end do
         do k = 1,numbWL
            Siga(k) = 0.0
            SigNn(k) = 0.0
            do i=1,nAnom
               fp(i,k) = formM2(rho,fpj,i,nwl(k))
               fpQ(i,k) = fp(i,k) * fp(i,k)
               Siga(k) = Siga(k) + nAn(i) * fpQ(i,k) * eps*e2bw(k)
            end do
            SigNn(k) = Sig0 + Siga(k)
         end do

         i = 1
         j = 1
!definizione della prima riga parte reale
         AK(i,j) = 1.
         j = 2
         do k=1, numbWL         
            a= 0
            do ii=1,nAnom
               a = a + (nAn(ii)*f0(ii)*fp(ii,k)) *eps*ebw(1)*ebw(k)
            end do
            AK(i,j) =  a / sqrt(Sig0a*SigNn(k)) 
            j = j + 1
         end do

!  def della I riga parte immaginaria (?)
         AK(i,j) = 0
         j = j + 1
         do k=1, numbWL 
            AK(i,j) =  0. 
            j = j + 1
         end do

!definizione dalla seconda riga alla numbWL+1_esima
!      parte positivi reali x positivi reali
         do i=1, numbWL
            j = i + 1
            sig_p(nwl(i)) = (sigma_piu(nwl(i))**2) / SigNn(i)         
            e_p = 1. + sig_p(nwl(i))
            AK(i+1,j) = e_p
            j = j + 1
            do k=i+1, numbWL  
              SS5 = 0.
              SS6 = 0.
              do ii=1,nAnom
                SS5 =SS5+nAn(ii)*(fp(ii,i)*fp(ii,k))*eps*ebw(i)*ebw(k) 
              end do
              AK(i+1,j) = (Sig0 + SS5) / sqrt(SigNn(i)*SigNn(k))
              j = j + 1
            end do
         end do
         
! riempi il quarto quadrante della matrice
         ni = 2 * numbWL
         AK(ni,ni) = 1

         do i=1,numbWL
            AK(ni,ni+i) = AK(1,i+1)
         end do

         do i=1, numbWL
            do j=i, numbWL
               AK(ni+i,ni+j) = AK(i+1,j+1)
            end do
         end do

! riempi la parte simmetrica della matrice
         do k=2,nord
            do j=1,k-1
               AK(k,j) = AK(j,k)
            end do
         end do
         
         do ii=1,nord
            do jj=1,nord
               Dum(ii,jj) = AK(ii,jj)
            end do
         end do
         
         call matinv(Dum,AKL,ndim,nord)

! ================================== S T A M P E =============================
!         if (kh.eq.3.and.kk.eq.1.and.kl.eq.0)then
!             pipp = 1
!         else
             pipp = 0
!         endif

         if (pipp.eq.1) then
            write(lo,3524) inr,kh, kk, kl,
     *          (f_piu(nwl(k)), e_piu(nwl(k)),k=1,numbWL)
 3524       format(i8,')',3i4,4(2(f10.2,f10.5,2x),2x))
 
            write(lo,'(1h )')
            write(lo,203)
  203    format('   h   k  l     f+(1)    sigma+(1)  ',
     *         'f+(2)    sigma+(2)')
            write(lo,'(3i4,8f10.2)')kh,kk,kl,
     *            (f_piu(nwl(k)), sigma_piu(nwl(k)),k=1,numbWL)

            write(lo,'(1h )')
            write(lo,'(9h matrice:)')
            do k=1,nord
               write(lo,'(18e16.9)') (AK(k,j),j=1,nord)
            end do

            do ii=1,nord
               do jj=1,nord
                  Dum(ii,jj) = AK(ii,jj)
               end do
            end do
            write(lo,'(1h )')
            call det_MAD(Dum,ndim,nord,d)
            write(lo,'(4h d =,e14.7)') d
            write(lo,'(1h )')
 
            write(lo,'(8h inversa:)')
            do k=1,nord
               write(lo,'(18e16.9)') (AKL(k,j),j=1,nord)
            end do
            do ii=1,nord
               do jj=1,nord
                  Dum(ii,jj) = AKL(ii,jj)
               end do
            end do
            call det_MAD(Dum,ndim,nord,d)
            write(lo,'(4h d =,e14.7)') d
            do ii=1,nord
               do jj=1,nord
                  Dum(ii,jj) = 0.
                  do kkk=1,nord
                     Dum(ii,jj) = Dum(ii,jj) + AK(ii,kkk) * AKL(kkk,jj)
                  end do
               end do
            end do
            write(lo,'(10h prodotto:)')
            do k=1,nord
               write(lo,'(18e16.9)') (Dum(k,j),j=1,nord)
            end do
         end if
         
         if (kh.eq.7.and.kk.eq.7.and.kl.eq.-4) then
            pipp = 1
         end if
! ===========================  F I N E    S T A M P E =======================

          AL11 = 1./AKL(1,1)
          if (AL11.lt.0.0) then
             neglamda=neglamda + 1
          endif
          if (AL11.gt.0.0) then
             iposlamda = iposlamda + 1
          end if

          AL11Q = AL11 * AL11
          Q1 = 0
          nn = 1
          do i = 1,numbWL
             Q1 = Q1 + AKL(1,i+nn) * e_piu(nwl(i))
          end do
          Q1 = Q1 * Q1
          
          PRODOTTO = AKL(1,2) * AKL(1,3)
          if (PRODOTTO > 0.0) then
              write(lo,*) ' SEGNO UGUALE= ',AKL(1,2), AKL(1,3)
          endif


          if (pipp.eq.1) then
             write(lo,*) kh,kk,kl,(sigma_piu(nwl(i)),i=1,numbWL)
             write(lo,'(3hQ1 ,7e16.9)') Q1,(e_piu(nwl(i)),f_piu(nwl(i)),
     *                                      i=1,numbWL)
          end if

          AL1Q = AL11Q * Q1 

          esq = PI/4.*AL11 + AL1Q

          if (esq.lt.0.) then
             esq = 0.                  !!!!!!!!!!!!!!!!!!!!!!!
          end if

          eve = sqrt(esq)
 
          sigma_eve = sqrt((1.-PI/4.)*abs(AL11))

         if (pipp.eq.1) then
!            write(lo,'(18e16.9)') (AKL(1,j),j=1,nord)
            write(lo,'(8h emad  =, 2f10.4)') eve,sigma_eve
            write(lo,98) AL11,AL1Q
   98       format('  1/L11 = ',e14.7,'    restante parte = ',e14.7)
            write(lo,'(1h )')
            write(lo,'(1h )')
         end if
         inrB = inr

!pgMAD2
! elimina tutti quelli con Lambda11 negativo
         if (AL11.lt.0.0) then
            nRej3 = nRej3 + 1
            ij = ij + 1    
            inrB = -3
            goto 99      
         endif

         if (jcode.ne.1 .and.ifNoSpeciali.eq.1 ) then   ! elimina riflessi speciali
             nRej2 = nRej2 + 1
             ij = ij + 1    
             inrB = -3
             goto 99      
         end if

         if (nFiltro(2).eq.1) then
            res = 0.5/sqrt(rho)
            if (SogFiltro(2) /= 0) then
               if (res < SogFiltro(2)) then    
                  nRej2 = nRej2 + 1
                  ij = ij + 1    
                  inrB = -3  
                  goto 99
               end if
            end if
         end if


         ij = ij + 1
         ikess = 1
         emesus(ij,ikess) = sqrt((PI/4 + Q1*AL11)/(1.-PI/4))
         
         pesotot = (peso1+peso2)/2.
         emesus(ij,ikess) = eve * pesotot

         ikepers = 2
         emesus(ij,ikepers) = eve * sigma_eve

         iks = 3 
         emesus(ij,iks) = sigma_eve

         if(pipp.eq.1) then
           write(lo,8877) emesus(ij,ikess),emesus(ij,ikepers)
 8877      format(10x,' emesus=',2f12.6)
         endif

   99    mkang(ij) = jcode
         evet(ij)  = esq
         iinr(ij)  = inrB
         
         if (inrB > 0 .and. rho.gt.rhm) then   !cricri
             rhm = rho
         end if

      end do loop_nrefl 
      nRefAct = ij

      if (knw == 1) then
         write(lo,5765) nRej1,nRej2,nRej3,nrefl
 5765 format(/,'rigettati ',i6,' + ',i6,' + ',i6,' su un totale di ',i7)
         write(lo,'(a)')' 1 - coppia non esistente'
         write(lo,'(a)')' 2 - riflessi speciali'
         write(lo,'(a)')' 3 - lambda11 negativi'
      end if
!0211
      nReflInput = nrefl
     
      return
      end
c---------------------------------------------------
      subroutine SFCalc_C(iop, rfac, nrefp)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE MADStuff
      USE MadModule
      USE PhaseModule
      USE elements, only: pxen_from_specie,numelem
!      USE PhaseComRef
!
c----
c     structure factor calculation
c----

      common /misurato/ misu
      integer i1(3)
      dimension xo(11),xn(11),keyx(10),shi(4)
      dimension x1(3),x2(3)
      character jstep, tirang * 11,nanalf*2,nome*256
      common /statFC/ rhm,rhmi,emax,emin,
     *   teta(22),ncont(22),rf(22),rfs(22),
     *   Eint(22),ncontE(22),rfE(22),rfsE(22),sumfo(3),sumdf(3),
     *  cb(3),
     *  rf1(22),rfE1(22),rf2(22),
     *          ssint(22,20),ss(22,20),nnss(22,20),
     *          ss1(22,20),ssd(22,20),SRint(22),
     *          SRintD(22)
      dimension sumdf_e(10), sumfo_e(10), nrft_e(10), erre_e(10)
      dimension ffnk(8)

      character cisp*2
      character *80 line, dire
      dimension vet(40),ivet(40)
      dimension       hkle(4,24)
!--
!      iAction = -1
      nats = 500 * spacegr%nsymop
!      call AllocaAtomi(iAction)
      nats = 0
!--
      if (iop.eq.2) then
         goto 2222
      endif
      
      ipuu = index(fname(FC_FILE),'.')
      
!      ipu1 = index(fname(8),char(47),.TRUE.)
!      ipu2 = index(fname(8),char(92),.TRUE.)

!      if (ipu1 > 0) then
!         nome = fname(8)(ipu1+1:ipuu)//'fra'
!      elseif (ipu2 > 0) then
!         nome = fname(8)(ipu2+1:ipuu)//'fra'
!      else
          nome = fname(FC_FILE)(1:ipuu)//'fra'
!      end if
      
!      nome = 'C:\EXPO2006\StruttureANOM\verapa\verapaA.fra'
!      nome = 'C:\EXPO2006\StruttureANOM\prova\provaA.fra'
!      nome = 'C:\EXPO2006\StruttureANOM\famo\famoA.fra'
!      nome = 'C:\EXPO2006\StruttureANOM\nickel\nickelA.fra'
      
!      Lnnb = len_trim(ReflFilePath)
!      if (Lnnb > 0) then
!         nome = ReflFilePath(1:Lnnb)//nome
!      end if
c
      itype=2
      iform=1
      jop=jopen(44,nome,itype,iform,ierr)
      if (jop.lt.0) then
         return
      end if
      j = 0
      do
         j = j + 1
         read(44,'(a)',end = 20) line
         call cutst(line,lenp,dire,lend)
         call lcase(dire)
         read(dire(1:2),'(a2)') cisp
         iopt=0
         call getnum(line,vet,ivet,iv,iopt)
         if (iopt .ne. -1) then
            do i=1,iv
               xyzs(i,j)= vet(i)
            enddo
         endif
         if (iv == 3) then
            xyzs(4,j) = bt
            xyzs(5,j) = 1.0
         end if
         if (iv == 4) then
            xyzs(5,j) = 1.0
         end if

!corr         call lcase(cisp)
!corr         read(cisp,'(a2)') isp
         isp = pxen_from_specie(cisp)
         do i=1,numelem(celem)
!corr            if (isp.eq.nalf(i)) then
            if (isp.eq.celem(i)%ptab) then
               nz(j) = i
            end if
         end do
         bfac(j) = xyzs(4,j)
      end do
   20 close(44)
      nats = j - 1

      sumfor = 0.
      sumfc = 0.
!pgMAD2
      sumfor_cs = 0.
      sumfc_cs = 0.
!pgMAD2
      rhm = 0.
      rhmi = 999.
      emax = 0
      emin = 999.

      itype = 0
      do i=1,nats
         xo(1)=xyzs(1,i)
         xo(2)=xyzs(2,i)
         xo(3)=xyzs(3,i)
         iser=i
         iactn=1
         khead=0
         ksp=kspecb(newvet,xo,xn,keyx,itype,iser,khead,iactn)
         if (ksp < 0) xyzs(5, i) = 1.0/float(keyx(10))
      enddo

	loop_refl : do i=1,nrefl
	
	   if (iinr(i) <0) cycle
	   if (i == 12) then
	       pippo = 8
	   endif
         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)

         call cmult2002(i1,eps,multi)     !dritan

!
!-- compute H*R and H*T
!
         do 250 j=1,nsym
            tt=1000.0
            do 230 l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               hkle(l,j)=0

               do 240 k=1,3
  240          hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)

  230       continue
            hkle(4,j)=tt
  250    continue
         fo=fovet(i)
         rho=rhov(i)
         
         if (iinr(i).gt.0) then
            if (rho.gt.rhm) then
               rhm = rho
            end if
            if (rho.lt.rhmi) then
               rhmi = rho
            end if
            if (evet(i).gt.emax) then
               emax=evet(i)
            end if
            if (evet(i).lt.emin) then
               emin=evet(i)
            end if
         end if

         act=0.0
         bct=0.0
         
         do jj=1,nAnom
            nkA = nkAnom(jj)
            ffnk(nkA) = celem(nkA)%cl
            do ii=1,4
!corr               ffnk(nkA) = ffnk(nkA) + al(ii,nkA) * exp(-bs(ii,nkA)*rho)
               ffnk(nkA) = ffnk(nkA) + 
     *                  celem(nkA)%al(ii) * exp(-celem(nkA)%bs(ii)*rho)
            end do
         end do

         sfj = 0.
         loop_atoms : do jj=1,nats
            if (nz(jj).ne.0) then
!                arg=-bfac(jj)*rho
!                effe=pts*ffnk(nz(jj))*exp(arg)
!                tfocc=effe*xyzs(5,jj)
!                sfj = sfj + tfocc
                
                arg = -bfac(jj)*rho
                effe = ffnk(nz(jj))*exp(arg)
                tfocc = pts * effe * xyzs(5,jj)
                effeq = effe ** 2
                sfj = sfj + pts * effeq * xyzs(5,jj)
c-----------------------
                att=0.0
                btt=0.0
                do  j=1,nsym
                   arg=amod(hkle(1,j)*xyzs(1,jj)
     *                     +hkle(2,j)*xyzs(2,jj)
     *                     +hkle(3,j)*xyzs(3,jj)
     *                     +hkle(4,j),1.0)
                   iarg=int(36000.0*arg+0.5)+1
                   if (iarg.eq.36001) iarg=1
                   att=att+cost(iarg)
                   btt=btt+sint(iarg)
                enddo
                if (icent.eq.0) then
                    contc=att
                    conts=btt
                else
                    contc=2.0*att
                    conts=0.0
                endif
c-----------------------
                contc=contc*tfocc
                conts=conts*tfocc
                act=act+contc
                bct=bct+conts
            endif
         end do loop_atoms
!         sfj = sfj*sqrt(eps*nsym)  !dritan
         sfj = sqrt(sfj) * sqrt(eps*nsym)  !dritan
         args=act*act+bct*bct
         if (args.gt.0.000001) then
             fc=sqrt(args)
             faze=rtod*atan2(bct,act)+360.0
         else
             fc=0.0
             faze=0.0
         endif
         fcvet(i) = fc
         fvero(i) = fc      

         evero(i) = fc/sfj
         ipub(i) = mod(int(faze+0.5), 360)
         if (ipub(i).eq.0) then
            ipub(i) = 360
         end if

!         if (iinr(i).gt.0) then
            sumfor=sumfor+fovet(i)
            sumfc=sumfc+fc
            
            if (mkang(i).ne.1) then
               sumfor_cs=sumfor_cs+fovet(i)
               sumfc_cs=sumfc_cs+fc
            end if
!         end if


      end do loop_refl
      
      sumQ = 0
      nnrrff = 0
      do i=1,nrefl
         if (iinr(i).gt.0) then
            sumQ = sumQ + evero(i)*evero(i)
            nnrrff = nnrrff + 1
         end if
      end do
      sumQ = sumQ/nnrrff
      do i=1,nrefl
!pgMAD2          applicata scala non centro ai centro per gli evero
         if (iinr(i).gt.0.or.mkang(i).ne.1) then
!pgMAD2
            evero(i) = sqrt(evero(i)**2/sumQ)
         end if
      end do

      somma=0.0
      sommaRv = 0
      sommaRc = 0
	numRist = 0
	do i=1,nrefl
	somma = somma+evero(i)*evero(i)
	if (mkang(i).ne.1) then
	   sommaRv = sommaRv + evero(i)*evero(i)
	   sommaRc = sommaRc + evet(i)
	   numRist = numRist + 1
      end if
	end do
	somma = somma/nrefl
      if (numRist.gt.0) then
	   sommaRv = sommaRv/numRist
	   sommaRc = sommaRc/numRist
      end if

      scalan=sumfor/sumfc
      if(sumfc_cs.gt.0.00001) then
         scalan_cs=sumfor_cs/sumfc_cs
      else
         scalan_cs = 1.0
      end if

      do i=1,nrefl
         if (mkang(i).eq.1) then
            fcvet(i) = fcvet(i) * scalan       ! fc riscalato su fo
            fvero(i) = fvero(i) * scalan       ! fc riscalato su fo    !pgMAD4
         else
            fcvet(i) = fcvet(i) * scalan_cs       ! fc speciali riscalato su fo speciali
            fvero(i) = fvero(i) * scalan_cs       ! fc speciali riscalato su fo speciali   !pgMAD4
         end if
!         write(lo,'(3i5,f10.5,2x,f10.5,i6)')khl(1:3,i),
!     *                             evero(i),fvero(i),ipub(i)
         
      end do

      return
      
!===========================================================

 2222 nrft1 = 0
      nrft2 = 0
      nint = 18   

      teta(1) =  0.5/sqrt(rhm)
      teta(nint+1) = 9.0e+33
      teta(nint) = 8.0
      teta(nint-1) = 6.5
      teta(nint-2) = 4.0
      del = (teta(nint-2) - teta(1)) / 11
      do i=nint-3,7,-1
         teta(i) = teta(i+1) - del
      end do
      del = (teta(7) - teta(1))/6
      do i=2,6
         teta(i) = teta(i-1) + del
      end do

      nintE = 18
      Eint(1) = 0
      Eint(2) = 0.05
      Eint(3) = 0.1
      Eint(4) = 0.15
      Eint(5) = 0.2
      Eint(6) = 0.4
      Eint(7) = 0.6
      Eint(8) = 0.8
      Eint(9) = 1.0
      Eint(10) = 1.2
      Eint(11) = 1.4
      Eint(12) = 1.6
      Eint(13) = 1.8
      Eint(14) = 2.0
      Eint(15) = 2.4
      Eint(16) = 2.8
      Eint(17) = 3.3
      Eint(18) = 4.0
      Eint(19) = 9.e33

      jj = ikess         ! 1
      ssint(1,jj) = 1.00
      ssint(2,jj) = 1.75
      ssint(3,jj) = 2.00
      ssint(4,jj) = 2.25
      ssint(5,jj) = 2.50
      ssint(6,jj) = 2.75
      ssint(7,jj) = 3.00
      ssint(8,jj) = 3.25
      ssint(9,jj) = 3.50
      ssint(10,jj) = 4.00
      ssint(11,jj) = 4.50
      ssint(12,jj) = 5.00
      ssint(13,jj) = 6.00
      ssint(14,jj) = 8.00
      ssint(15,jj) = 11.0
      ssint(16,jj) = 15.0
      ssint(17,jj) = 20.0
      ssint(18,jj) = 30.0
      ssint(nint+1,jj) = 9.e33
      
      do i=1,19
         ssint(i,jj) = Eint(i)
      end do
      
      jj = ikepers       ! 2
      ssint(1,jj) = 0.00
      ssint(2,jj) = 0.01
      ssint(3,jj) = 0.02
      ssint(4,jj) = 0.04
      ssint(5,jj) = 0.07
      ssint(6,jj) = 0.10
      ssint(7,jj) = 0.13
      ssint(8,jj) = 0.16
      ssint(9,jj) = 0.20
      ssint(10,jj) = 0.25
      ssint(11,jj) = 0.30
      ssint(12,jj) = 0.35
      ssint(13,jj) = 0.40
      ssint(14,jj) = 0.80
      ssint(15,jj) = 1.00
      ssint(16,jj) = 15.0
      ssint(17,jj) = 20.0
      ssint(18,jj) = 30.0
      ssint(nint+1,jj) = 9.e33

      do i = 1,nint
!      x stat. sulla risoluzione           
         ncont(i) = 0
         rf(i) = 0.0
         rfs(i) = 0.0
         rf1(i) = 0.0
!      x stat. sul valore di E
         ncontE(i) = 0
         rfE(i) = 0.0
         rfsE(i) = 0.0
         rfE1(i) = 0.0
!      x tutte le altre statistiche
         do jj=1,5
            ss(i,jj) = 0.0
            ss1(i,jj) = 0.0
            ssd(i,jj) = 0.0
            nnss(i,jj) = 0
         end do
      end do
!      x R(tot) , R(Gen) ed R(ristretti)
      do j=1,3
         sumdf(j)=0.0
         sumfo(j)=0.0
      end do
!      x R su eliminati da filtri
      do j=1,10
         sumdf_e(j) = 0.0
         sumfo_e(j) = 0.0
         nrft_e(j) = 0
      end do

      sum_evero = 0.0      
      n_evero = 0
      do i=1,nrefl
         absdf = abs(fcvet(i) - fovet(i))
         rapp_erre = 0.0
         if (fovet(i) > 0.00001) then
             rapp_erre = (fcvet(i) - fovet(i))/ fovet(i)
         end if
!         write(lo,6677) iinr(i),khl(1:3,i),fcvet(i),fovet(i),absdf,
!     *                  rapp_erre
 6677    format(4i5,4f10.5)    
         df = fcvet(i) - fovet(i)
         if (iinr(i).gt.0.or.mkang(i).ne.1) then     
            sumdf(1) = sumdf(1) + absdf
            sumfo(1)=sumfo(1)+fovet(i)
            if (mkang(i).eq.1) then
               sumdf(2)=sumdf(2)+absdf
               sumfo(2)=sumfo(2)+fovet(i)
               nrft1 = nrft1 + 1
            else
               sumdf(3)=sumdf(3)+absdf
               sumfo(3)=sumfo(3)+fovet(i)
               nrft2 = nrft2 + 1
            end if
         else
            if (mkang(i).eq.1) then
               do ii1=1,6
                  if (iinr(i).eq.-ii1) then  
                     sumdf_e(ii1)=sumdf_e(ii1)+absdf
                     sumfo_e(ii1)=sumfo_e(ii1)+fovet(i)
                     nrft_e(ii1) = nrft_e(ii1) + 1
                  end if
               end do
            end if
            goto 942
         end if

!         if (mkang(i).ne.1 .and. icent.eq.0) then     !pgMADPOW
         if (ifNoSpeciali == 1) then                   !pgMad200308
            goto 942
         end if
!      accumuli x stat. sulla risoluzione
         res = 0.5/sqrt(rhov(i))
         do ind=1,nint
            if(res.ge.teta(ind).and.res.lt.teta(ind+1)) then
               rf(ind) = rf(ind) + absdf
               rf1(ind) = rf1(ind) + df
               rfs(ind) = rfs(ind) + fovet(i)
               ncont(ind) = ncont(ind) + 1
               exit 
            end if
         end do
!      accumuli x stat. sul valore di E
         ev = sqrt(evet(i))
         do ind=1,nintE
            if(ev.ge.eint(ind).and.ev.lt.eint(ind+1)) then
               rfE(ind) = rfE(ind) + absdf
               rfE1(ind) = rfE1(ind) + df
               rfsE(ind) = rfsE(ind) + fovet(i)
               ncontE(ind) = ncontE(ind) + 1
               exit
            end if
         end do

         jj = ikess
         suse = emesus(i,jj)
         do ind=1,nint
           if(suse.ge.ssint(ind,jj).and.suse.lt.ssint(ind+1,jj)) then
              ss(ind,jj) = ss(ind,jj) + absdf                
              ss1(ind,jj) = ss1(ind,jj) + df                
              ssd(ind,jj) = ssd(ind,jj) + fovet(i)                
              nnss(ind,jj) = nnss(ind,jj) + 1
              exit
           end if
         end do

         jj = ikepers
         suse = emesus(i,jj)
         do ind=1,nint
           if(suse.ge.ssint(ind,jj).and.suse.lt.ssint(ind+1,jj)) then
              ss(ind,jj) = ss(ind,jj) + absdf                
              ss1(ind,jj) = ss1(ind,jj) + df                
              ssd(ind,jj) = ssd(ind,jj) + fovet(i)                
              nnss(ind,jj) = nnss(ind,jj) + 1
              exit
           end if
         end do

  942 continue             
      end do


      erre=sumdf(1)/sumfo(1)
      erreGen=sumdf(2)/sumfo(2)
      if (sumfo(3).gt.0) then
         erreRist=sumdf(3)/sumfo(3)
      else
         erreRist=0.0
      end if
!      essMedio = essMedio/nrft1
      rfac=100.0*erre
      rfacGen=100.0*erreGen
      rfacRist=100.0*erreRist
      write(lo,200) rfac,rfacGen,rfacRist
  200 format(' R(tot) = ',f10.2,' R(Gen) = ',f10.2,' R(Ristr) = ',f10.2)

!     write(lo,200) rfac,rfacGen,essMedio,essMeds
! 200 format(' R(tot) = ',f7.2,' R(Gen) = ',f7.2,' <E/sigma> =',f7.2,
!    *        ' <E/sigma>N=',f7.2)
      write(lo,201) nrft1, nrft2
  201 format(18x,'(',i7,')',13x,'(',i7,')')

      do i=1,6
         if (sumfo_e(i).ne.0.0) then
            erre_e(i) = 100 * sumdf_e(i)/sumfo_e(i)
         else
            erre_e(i) = 0.0
         end if
      end do
      write(lo,202) (erre_e(i),i=1,6)
  202 format(' R_e(1:6) = ',7f10.2)
      write(lo,2203)
 2203 format(/,' Nelle seguenti statistiche: intervalli, num. rifl., R(|
     *Fc-Fo|/Fo), R((Fc-Fo)/Fo)',//)

      do i=1,nint
	   if (rfs(i).gt.0) then
            rf(i) = 100. * rf(i) / rfs(i)
            rf1(i) = 100. * rf1(i) / rfs(i)
         end if
	   if (rfsE(i).gt.0) then
            rfE(i) = 100. * rfE(i) / rfsE(i)
            rfE1(i) = 100. * rfE1(i) / rfsE(i)
         end if
      end do

!      calcolo x E su Sigma
      jj = ikess
      do ind=1,nint
         if (ssd(ind,jj).gt.0.) then
            ss(ind,jj) = 100.*ss(ind,jj) / ssd(ind,jj)
            ss1(ind,jj) = 100.*ss1(ind,jj) / ssd(ind,jj)
         end if
      end do
!      calcolo x E *  Sigma
      jj = ikepers
      do ind=1,nint
         if (ssd(ind,jj).gt.0.) then
            ss(ind,jj) = 100.*ss(ind,jj) / ssd(ind,jj)
            ss1(ind,jj) = 100.*ss1(ind,jj) / ssd(ind,jj)
         end if
      end do

      write(lo,'(1h )')
      write(lo,100)
  100 format(' distrib. di R in funzione di d:')
      do j=1,3
	   j1 = (j-1)*6 + 1
         write(lo,101) (teta(i),i=j1,j1+5)
         write(lo,102) (ncont(i),i=j1,j1+5)
         write(lo,103) (rf(i),i=j1,j1+5)
         write(lo,103) (rf1(i),i=j1,j1+5)
         write(lo,'(1h )')
      end do

!      write(69,'(20f10.5)') (teta(i),i=1,nint)
!      write(69,'(20i6)') (ncont(i),i=1,nint)
!      write(69,'(20f12.3)') (rf(i),i=1,nint)

      write(lo,'(1h )')
      write(lo,110)
  110 format(' distribuzione di R in funzione di E:')
      do j=1,3
	   j1 = (j-1)*6 + 1
         write(lo,103) (Eint(i),i=j1,j1+5)
         write(lo,102) (ncontE(i),i=j1,j1+5)
         write(lo,103) (rfE(i),i=j1,j1+5)
         write(lo,103) (rfE1(i),i=j1,j1+5)
         write(lo,'(1h )')
      end do
  101 format(' ',7f10.5)
  102 format('   ',7(2x,i6,2x))
  103 format(' ',7f10.2)
  104 format(' ',7e10.3) 

!      write(69,'(20f10.3)') (Eint(i),i=1,nint)
!      write(69,'(20i6)') (ncontE(i),i=1,nint)
!      write(69,'(20f12.3)') (rfE(i),i=1,nint)

      write(lo,575)
  575 format('  distribuzione in funzione di E/Sigma :')
      jj = ikess
      do j=1,3
         j1 = (j-1)*6 + 1
         write(lo,1101) (ssint(i,jj),i=j1,j1+5)
         write(lo,102) (nnss(i,jj),i=j1,j1+5)
         write(lo,103) (ss(i,jj),i=j1,j1+5)
         write(lo,103) (ss1(i,jj),i=j1,j1+5)
         write(lo,'(1h )')
      end do

!      write(69,'(20f10.2)') (ssint(i,jj),i=1,nint)
!      write(69,'(20i6)') (nnss(i,jj),i=1,nint)
!      write(69,'(20f12.3)') (ss(i,jj),i=1,nint)

      write(lo,576)
  576 format('  distribuzione in funzione di E*Sigma :')
      jj = ikepers
      do j=1,3
         j1 = (j-1)*6 + 1
         write(lo,1101) (ssint(i,jj),i=j1,j1+5)
         write(lo,102) (nnss(i,jj),i=j1,j1+5)
         write(lo,103) (ss(i,jj),i=j1,j1+5)
         write(lo,103) (ss1(i,jj),i=j1,j1+5)
         write(lo,'(1h )')
      end do

!      write(69,'(20f10.2)') (ssint(i,jj),i=1,nint)
!      write(69,'(20i6)') (nnss(i,jj),i=1,nint)
!      write(69,'(20f12.3)') (ss(i,jj),i=1,nint)

 1101 format(' ',7f10.2)


!
!      iAction = 2
!      call AllocaAtomi(iAction)
!

      return
      end 
c-----------------------------------------------------------------------
      function formM(rho,giw,k)
      real*8 giw(270,5)

      sinth = 100.0*sqrt(rho)
      ind = max0(2,int(sinth+1.5))
      frac = sinth-float(ind-1)

      bf = 0.5 * (giw(ind+1,k) - giw(ind-1,k))
      af = bf + giw(ind-1,k) - giw(ind,k)
      formM = af * frac*frac + bf * frac + giw(ind,k)
  
      return
      end
c-----------------------------------------------------------------------
      function formM2(rho,giw,i,k)
      real*8 giw(270,8,5)

      sinth = 100.0*sqrt(rho)
      ind = max0(2,int(sinth+1.5))
      frac = sinth-float(ind-1)

      bf = 0.5 * (giw(ind+1,i,k) - giw(ind-1,i,k))
      af = bf + giw(ind-1,i,k) - giw(ind,i,k)
      formM2 = af * frac*frac + bf * frac + giw(ind,i,k)
  
      return
      end
*------------------------------------
       subroutine det_MAD(a,np,n,d)

       dimension indx(np)
       real*8 a(np,np), d

       call ludcmp_MAD(a,n,np,indx,d)

       do 10 j=1,n
         d=d*a(j,j)
 10    continue

       return
       end
*-------------------------------------------------------
      subroutine matinv(a,y,np,n)

      dimension indx(np)
      real*8  a(np,np), y(np,np), d


      do 12 i=1,n
        do 11 j=1,n
         y(i,j)=0.0
 11     continue
        y(i,i)=1.0
 12   continue
      call ludcmp_MAD(a,n,np,indx,d)
      
      do 13 j=1,n
        call lubksb_MAD(a,n,np,indx,y(1,j))
c       write(6,*)y(1,j)
 13   continue

      return
      end
*------------------------------------------
      SUBROUTINE LUDCMP_MAD(A,N,NP,INDX,D)
      PARAMETER (NMAX=500,TINY=1.0E-20)
      DIMENSION INDX(N)
      real*8 A(NP,NP),VV(NMAX), D
      real*8 AAMAX, SUM, DUM
      D=1.
      DO 12 I=1,N
        AAMAX=0.
        DO 11 J=1,N
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))
11      CONTINUE
        IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'
        VV(I)=1./AAMAX
12    CONTINUE
      DO 19 J=1,N
        DO 14 I=1,J-1
          SUM=A(I,J)
          DO 13 K=1,I-1
            SUM=SUM-A(I,K)*A(K,J)
13        CONTINUE
          A(I,J)=SUM
14      CONTINUE
        AAMAX=0.
        DO 16 I=J,N
          SUM=A(I,J)
          DO 15 K=1,J-1
            SUM=SUM-A(I,K)*A(K,J)
15        CONTINUE
          A(I,J)=SUM
          DUM=VV(I)*ABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(A(J,J).EQ.0.)A(J,J)=TINY
        IF(J.NE.N)THEN
          DUM=1./A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
      RETURN
      END
*-------------------------------------------
      SUBROUTINE LUBKSB_MAD(A,N,NP,INDX,B)
      DIMENSION INDX(N)
      real*8 A(NP,NP),B(N)
      real*8 SUM
      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        DO 13 J=I+1,N
          SUM=SUM-A(I,J)*B(J)
13      CONTINUE
        B(I)=SUM/A(I,I)
14    CONTINUE
      RETURN
      END
!-----------------------------------------------------------------------
      subroutine AnomScattOnly()
      USE General
      USE Symmetry
      USE Atomi
      USE MadModule
      USE PhaseModule
      USE elements, only: numelem
!
      integer anum(18), ifScatt(18), sottrai
!
      nkel = numelem(celem)
      ifScatt(1:nkel) = 0
      lighScatt = 0
      do i=1,nkel
         do j=1,nAnom
!corr            if ( no(i) == no(nkAnom(j)) ) then
            if ( celem(i)%z == celem(nkAnom(j))%z ) then
              ifScatt(i) = 1
              if (lighScatt == 0) then
                  lighScatt = i
              endif
              exit
            endif
         enddo
      enddo
!
      nz(1:nats) = lighScatt * nzConst
      SommaScatt = 0.0
      do i=1,nkel
!corr         anum(i) = ifScatt(i) * nw(i)
         anum(i) = ifScatt(i) * celem(i)%nw
         SommaScatt = SommaScatt + anum(i)
      enddo
      SommaScatt13 = SommaScatt * 1.3
!
      do i=1,nats
         sottrai = nint( xyzs(5,i) * spacegr%nsymop )
         do ii=nkel,1,-1
            if (ifScatt(ii) == 1) then
                idiff = anum(ii) - sottrai
                if (idiff >= 0) then
                    anum(ii) = idiff
                    nz(i) = ii * nzConst + 1               !pgMADPOW
                    izpk(i) = 100 *(nkel - ii + 1) + 1       !pgMADPOW
                    exit
                endif
            endif
         enddo
         SommaScatt = SommaScatt - sottrai
         if (SommaScatt < 0.0) then
             xyzs(5,i) = xyzs(5,i) * xyzs(4,i) / xyzs(4,1)
         endif
         SommaScatt13 = SommaScatt13 - sottrai
         if (SommaScatt13 < 0.0 .and. i > 1) then    !pgmad2107
             nz(i) = 0
         endif
      enddo
!      write(lo,*) 'subroutine AnomScattOnly() - new label'
!      do i=1,nats
!         ii = nz(i) / nzConst
!         if (ii > 0) then
!             write(lo,10) i,nalf(ii),ifScatt(ii),xyzs(4,i),xyzs(5,i)
!         else
!             write(lo,20) i,                     xyzs(4,i),xyzs(5,i)
!         endif
!      enddo
   10 format(i5,')',2x,a2,i2,2f15.4)
   20 format(i5,')',2x,2x,2x,2f15.4)
!
      return
      end
c---------------------------------------------------
      subroutine Caccia_i_Miette(iop, rfac, nrefp)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE MADStuff
      USE MadModule
      USE PhaseModule
      USE elements, only: pxen_from_specie,numelem
!      USE PhaseComRef
!
c----
c     structure factor calculation
c----

      common /misurato/ misu
      integer i1(3)
      dimension xo(11),xn(11),keyx(10),shi(4)
      dimension x1(3),x2(3)
      character jstep, tirang * 11,nanalf*2,nome*256
      common /statFC/ rhm,rhmi,emax,emin,
     *   teta(22),ncont(22),rf(22),rfs(22),
     *   Eint(22),ncontE(22),rfE(22),rfsE(22),sumfo(3),sumdf(3),
     *  cb(3),
     *  rf1(22),rfE1(22),rf2(22),
     *          ssint(22,20),ss(22,20),nnss(22,20),
     *          ss1(22,20),ssd(22,20),SRint(22),
     *          SRintD(22)
      dimension sumdf_e(10), sumfo_e(10), nrft_e(10), erre_e(10)
      dimension ffnk(8)

      character cisp*2
      character *80 line, dire
      dimension vet(40),ivet(40)
      dimension       hkle(4,24)
!--
      nats = 500 * spacegr%nsymop
      nats = 0
!--

      ipuu = index(fname(FC_FILE),'.')
!      ipu1 = index(fname(8),char(47),.TRUE.)
!      ipu2 = index(fname(8),char(92),.TRUE.)

!      if (ipu1 > 0) then
!         nome = fname(8)(ipu1+1:ipuu)//'fra'
!      elseif (ipu2 > 0) then
!         nome = fname(8)(ipu2+1:ipuu)//'fra'
!      else
         nome = fname(FC_FILE)(1:ipuu-1)//'_tot.fra'
!      end if
      
!      nome = 'famo_tot.fra'       !lettura frammneto intero per calcolo evero
      
!      Lnnb = len_trim(ReflFilePath)
      if (Lnnb > 0) then
!         nome = ReflFilePath(1:Lnnb)//nome
      end if
c
      itype=2
      iform=1
      jop=jopen(44,nome,itype,iform,ierr)
      if (jop.lt.0) then
         return
      end if
      j = 0
      do
         j = j + 1
         read(44,'(a)',end = 20) line
         call cutst(line,lenp,dire,lend)
         call lcase(dire)
         read(dire(1:2),'(a2)') cisp
         iopt=0
         call getnum(line,vet,ivet,iv,iopt)
         if (iopt .ne. -1) then
            do i=1,iv
               xyzs(i,j)= vet(i)
            enddo
         endif
         if (iv == 3) then
            xyzs(4,j) = bt
            xyzs(5,j) = 1.0
         end if
         if (iv == 4) then
            xyzs(5,j) = 1.0
         end if

!corr         call lcase(cisp)
!corr         read(cisp,'(a2)') isp
         isp = pxen_from_specie(cisp)
         do i=1,numelem(celem)
!corr            if (isp.eq.nalf(i)) then
            if (isp.eq.celem(i)%ptab) then
               nz(j) = i
            end if
         end do
         bfac(j) = xyzs(4,j)
      end do
   20 close(44)
      nats = j - 1

 2323 sumfor = 0.
      sumfc = 0.
!pgMAD2
      sumfor_cs = 0.
      sumfc_cs = 0.
!pgMAD2
      rhm = 0.
      rhmi = 999.
      emax = 0
      emin = 999.

      itype = 0
      do i=1,nats
         xo(1)=xyzs(1,i)
         xo(2)=xyzs(2,i)
         xo(3)=xyzs(3,i)
         iser=i
         iactn=1
         khead=0
         ksp=kspecb(newvet,xo,xn,keyx,itype,iser,khead,iactn)
         if (ksp < 0) xyzs(5, i) = 1.0/float(keyx(10))
      enddo

	loop_refl : do i=1,nrefl
         i1(1)=indHKL(i,1)
         i1(2)=indHKL(i,2)
         i1(3)=indHKL(i,3)

         call cmult2002(i1,eps,multi)     !dritan

!
!-- compute H*R and H*T
!
         do 250 j=1,nsym
            tt=1000.0
            do 230 l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               hkle(l,j)=0

               do 240 k=1,3
  240          hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)

  230       continue
            hkle(4,j)=tt
  250    continue
         fo=fovet(i)
!         rho=rhov(i)
         rho=rhof(pp,i1(1),i1(2),i1(3))
         rho = rho * rho
         act=0.0
         bct=0.0
         
         do jj=1,numelem(celem)
            ffnk(jj) = celem(jj)%cl
            do ii=1,4
!corr               ffnk(jj) = ffnk(jj) + al(ii,jj) * exp(-bs(ii,jj)*rho)
               ffnk(jj) = ffnk(jj) + 
     *                    celem(jj)%al(ii) * exp(-celem(jj)%bs(ii)*rho)
            end do
            do k=1,nAnom
!corr               if (kAnom(k).eq.nalf(jj)) then
               if (kAnom(k) == celem(jj)%ptab) then
                  ffnk(jj) = ffnk(jj) + fPrimoSecondo(k,1,1)
               endif
            end do
         end do

         sfj = 0.
         loop_atoms : do jj=1,nats
            if (nz(jj).ne.0) then
!                arg=-bfac(jj)*rho
!                effe=pts*ffnk(nz(jj))*exp(arg)
!                tfocc=effe*xyzs(5,jj)
!                sfj = sfj + tfocc
                
                arg = -bfac(jj)*rho
                effe = ffnk(nz(jj))*exp(arg)
                tfocc = pts * effe * xyzs(5,jj)
                effeq = effe ** 2
                sfj = sfj + pts * effeq * xyzs(5,jj)
c-----------------------
                att=0.0
                btt=0.0
                do  j=1,nsym
                   arg=amod(hkle(1,j)*xyzs(1,jj)
     *                     +hkle(2,j)*xyzs(2,jj)
     *                     +hkle(3,j)*xyzs(3,jj)
     *                     +hkle(4,j),1.0)
!                   iarg=int(36000.0*arg+0.5)+1
!                   if (iarg.eq.36001) iarg=1
!                   att=att+cost(iarg)
!                   btt=btt+sint(iarg)
                   arg2pi = arg * twopi
                   att=att+cos(arg2pi)
                   btt=btt+sin(arg2pi)                 
                enddo
                if (icent.eq.0) then
                    contc=att
                    conts=btt
                else
                    contc=2.0*att
                    conts=0.0
                endif
c-----------------------
                contc=contc*tfocc
                conts=conts*tfocc
                act=act+contc
                bct=bct+conts
            endif
         end do loop_atoms
!         sfj = sfj*sqrt(eps*nsym)  !dritan
         sfj = sqrt(sfj) * sqrt(eps*nsym)  !dritan
         args=act*act+bct*bct
         if (args.gt.0.000001) then
             fc=sqrt(args)
             faze=rtod*atan2(bct,act)+360.0
         else
             fc=0.0
             faze=0.0
         endif
         fcvet(i) = fc
         fvero(i) = fc      

         evero(i) = fc/sfj
         ipub(i) = mod(int(faze+0.5), 360)
         if (ipub(i).eq.0) then
            ipub(i) = 360
         end if

      end do loop_refl
      
      sumQ = 0
      nnrrff = 0
      sumfx = 0
      sumfv = 0
      do i=1,nrefl
         sumQ = sumQ + evero(i)*evero(i)
         sumfx = sumfx + fxsav(i)
         sumfv = sumfv + fvero(i)
         nnrrff = nnrrff + 1
      end do
      sumQ = sumQ/nnrrff
      scala = sumfx / sumfv
      
      itype=0
      iform=1
      ll = len_trim(nome)
      nome = nome(1:ll-3)//'eve'
      jop=jopen(65,nome,itype,iform,ierr)
      if (jop.lt.0) then
         return
      end if

      amed = 0
      amedfx = 0
      amedfv = 0
      do i=1,nrefl
         evero(i) = sqrt(evero(i)**2/sumQ)
         fvero(i) = fvero(i) * scala
         write(65,'(3i4,3f15.7,i5)')indHKL(i,1:3),fxsav(i),fvero(i),
     *              evero(i),ipub(i)
         amed = amed+evero(i)**2
         amedfx = amedfx + fxsav(i)
         amedfv = amedfv + fvero(i)
      end do
      amed = amed / nrefl
      amedfx =amedfx / nrefl
      amedfv =amedfv / nrefl
      write(65,'(a,3f10.6)') ' media e**2 = ',amed,amedfx,amedfv
      
      return
      
      end 
c-----------------------------------------------------------------------
      subroutine AMatrice_Phasing (nRecF, npr, nRefAct,nA,neglamda,
     *                         iposlamda,sig,ifNoSpeciali)
      USE General
      USE Riflessi
      USE MADStuff
      USE MadModule
      USE Symmetry
      USE PhaseModule, only : shiftexam
      USE xdataMod, only : fx, ex
      USE elements, only: numelem
!
      common /statFC/ rhm,rhmi,emax,emin,
     *   teta(22),ncont(22),rf(22),rfs(22),
     *   Eint(22),ncontE(22),rfE(22),rfsE(22),sumfo(3),sumdf(3),
     *  cb(3),
     *  rf1(22),rfE1(22),rf2(22),
     *          ssint(22,20),ss(22,20),nnss(22,20),
     *          ss1(22,20),ssd(22,20),SRint(22),
     *          SRintD(22)

      real*8 AK(8,8),AKL(8,8),Dum(8,8), d
      real*8 AL3(8,8),d1
!      real*8 formn,form,form1p,form1s,form2p,form2s
!      real*8 Sig0,Siga1,SigN1,Sig0a,Siga2,SigN2

      real*8 form1,formh,form1H
      real*8 Sigma1_rho,SigmaH_rho,Sigma1H_rho
      real*8 Sigma2_rho,Sigma12_rho,Sigma2H_rho
      real*8 Sigma1(270,5), Sigma1H(270,8,5), SigmaH(270,8,5)
      
      real *8 Sigma2(270,5), form2,Sigma2_rho_old

!      real*8 S1,S2,S3,S4,S5,S6,S7,S8,S9,S10,S11,S12
      real *8 fz, arg, ebw1, ebw2, e2bw1, e2bw2
      real *8 Sigma1_piu, e1_piu, Sigma2_piu, e2_piu

      real*8 t,tt,bst,BMW,a
      real*8 ebw0,e2bw0,ebw(5),e2bw(5)

      real*8 soglia_2(5),soglia_1(5)

      dimension f_piu(5),sigma_piu(5),e_piu(5)


      dimension e_pp(5,40)       !, e_mm(5,40)
      dimension f_pp(5,40),sigma_pp(5,40)

      dimension kx1(40),kx2(40),kx3(40),rhh(40)
      dimension iphxi(40), idxi(40)
      
      dimension i1(3), GMad(3000),SMad(3000),iphaz_S_old(3000)
      dimension GMad_nuovo(3000),iphaz_Gnuovo(3000)
      dimension SMad_new(3000),iphaz_S_new(3000)
      
      dimension wt_segno(3000),wt_save(3000)
      
      dimension Diff_vero(3000), Diff_osse(3000),R1o(3000),R2o(3000)
      dimension R1c(3000), R2c(3000), R1pc(3000), R1po(3000)
      dimension xf(100),yf(100)
      
      character*1 iast,ias
      character*11 tirang
      character*3 ugu

!      real*8 Siga(5),SigNn(5)
!      real*8 SS5,SS6,SS7,SS8,SS10,sig_p(5),e_p,sig_m(5),e_m

      common /indhklsalvo/indHKL_save(3000,5),rhov_save(3000)       !pgMAD090203

      
      do i=1,nrefl
         indHKL(i,1:5) = indHKL_save(i,1:5)
         rhov(i) = rhov_save(i)
      end do



      call AllocaMAD(1)
      
      wt(:) = 0.
      if (fPrimoSecondo(1,1,1) > fPrimoSecondo(1,2,1))then 
         nwl(1) = 1
         nwl(2) = 2
      else
         nwl(1) = 2
         nwl(2) = 1     
      endif
  
      call SFCalc_Phasing 

!      
      if ( knw == 1 ) then
         call SFCalc_StrutturaTot
      end if
!    da scommentare per lavorare con gli E veri
!          
!      do i=1,nrefl                              !pgMAD150109
!         Rmodulo_ord(nwl(1),i)= evero(i)
!         Fmodulo_ord(nwl(1),i)= fvero(i)
!      end do
!     
       call SFCalc_StrutturaTot_Anomala
     
!      do i=1,nrefl
!         Rmodulo_ord(nwl(2),i)= evero_anom(i)
!         Fmodulo_ord(nwl(2),i)= fvero_anom(i)
!      end do 
      
      
      nugu = 0
      
      nR1maggioreR2 = 0
      
      write(lo,4200)
4200  format(/,15x,'   Eremobs  Edipobs   Esubobs  ',5x,
     *             '  Fremobs  Fdipobs   Fsubobs',/)
      do i=1,nrefl
         if (ipub(i) == iphazo(i) ) then
            nugu = nugu + 1
            ugu = ' = '
         else
            ugu = ' '
         end if
         if (Rmodulo_ord(nwl(1),i) > Rmodulo_ord(nwl(2),i) ) then
            nR1maggioreR2 = nR1maggioreR2 + 1
         end if
!         write(lo,'(3i5,(3f10.5,5x,3f10.5,5x,3i6,a3))')khl(1:3,i),
!     *   evero(i),evero_anom(i),evet(i),fvero(i),fvero_anom(i),fcvet(i),
!     *   ipub(i),ipub_anom(i),iphazo(i),ugu
     
         write(lo,'(3i5,(3f10.5,5x,3f10.5,5x,3i6,a3))')khl(1:3,i),
     *   Rmodulo_ord(nwl(1),i),Rmodulo_ord(nwl(2),i),evet(i),
     *   Fmodulo_ord(nwl(1),i),Fmodulo_ord(nwl(2),i),fcvet(i),
     *   ipub(i),ipub_anom(i),iphazo(i),ugu      
     
           
      end do
      write(6,*) ' Uguali numero = ',nugu
      write(6,*) ' Numero R1 maggiore di R2 =',nR1maggioreR2 
     
       
      do i=1,270
         t=0.01*float(i-1)
         tt=t*t
         Sigma1(i,1)=0.0
         Sigma2(i,1)=0.0     !pgMAD130109
         do k = 1,8
            Sigma1H(i,k,1)=0.0
            SigmaH(i,k,1)=0.0
         end do

         do j=1,numelem(celem)
            fz = celem(j)%cl
            do jj=1,4
!corr               bst=bs(jj,j)*tt
!corr               if (bst.le.60.) fz=fz+al(jj,j)*exp(-bst)
               bst=celem(j)%bs(jj)*tt
               if (bst.le.60.) fz=fz+celem(j)%al(jj)*exp(-bst)
            end do
!corr            fnw=float(nw(j))
            fnw=celem(j)%nw
            Sigma1(i,1)=Sigma1(i,1) + fnw * fz**2

 !pgMAD130109
            FPri = 0.0
            do k=1,nAnom                                  
!corr               if (kAnom(k).eq.nalf(j)) then
               if (kAnom(k) == celem(j)%ptab) then
                   FPri = fPrimoSecondo(k,nwl(2),1)
                   exit
               endif
            end do
             Sigma2(i,1)=Sigma2(i,1) + fnw * (fz+FPri)**2
  !pgMAD130109
    
            do k=1,nAnom
!corr               if (kAnom(k).eq.nalf(j)) then
               if (kAnom(k) == celem(j)%ptab) then
                  nAn(k) = fnw
                  Sigma1H(i,k,1)= Sigma1H(i,k,1) + 
     *                            fnw * fz * fPrimoSecondo(k,nwl(2),1)
                  SigmaH(i,k,1) = SigmaH(i,k,1) + 
     *                              fnw * fPrimoSecondo(k,nwl(2),1) ** 2
               endif
            end do

         end do
      end do
                  

      nord = 2 * numbWL + 2 
      ndim = 8

      call scrper(' Performing E0a calculation',0,0)
      nperc=50
      iperc0=nrefl/nperc
      iperc=iperc0
      jperc=0

      neglamda = 0
      iposlamda = 0
      rhm = 0.0

      f_pp(:,:) = 0.0
      e_pp(:,:) = 0.0
      sigma_pp(:,:) = 0.0
      ij = 0
      ji = 0
      
      numero_relazioni = 0
      ncount_pos = 0
      ncount_neg = 0
      non_opposto = 0
      
      fact_sig_e1 = 0.1       !per adesso!!!!!!!
      fact_sig_e2 = 0.1        !per adesso!!!!!!!
      fact_sig = 0.03           !per adesso!!!!!!!
      cutoff_e1_e2 = 1.03
!      write (lo,4254) fact_sig_e1,fact_sig_e2,fact_sig,cutoff_e1_e2
 4254 format(/,'*******',/,' mu * F per e1 = ',f5.2,
     *         ' mu * F per e2 = ',f5.2,' mu * F  per e3 = ',f5.2,
     *         ' cutoff_e1_e2 = ',f5.2,'*******',
     *         ' cutoff = 0.1 per E1','*******',/) 
  
      goto 6666
      npop = 100
      do i=1, nrefl, npop
         nr = 0
         sumE1 = 0.0 
         sumE2 = 0.0         
         do j=1,npop
            if (i+j-1 <= nrefl) then
               nr = nr + 1
               sumE1 = sumE1 + Rmodulo(nwl(1),i+j-1)**2
               sumE2 = sumE2 + Rmodulo(nwl(2),i+j-1)**2
            endif
         end do
         sumE1 = sumE1 / nr
         sumE2 = sumE2 / nr
         do j = 1,npop
            if (i+j-1 <= nrefl) then
              Rmodulo(nwl(1),i+j-1)=sqrt(Rmodulo(nwl(1),i+j-1)**2/sumE1)
              Rmodulo(nwl(2),i+j-1)=sqrt(Rmodulo(nwl(2),i+j-1)**2/sumE2)
              k = ipun_Rmodulo(i+j-1)
              Rmodulo_ord(nwl(1),k)=Rmodulo(nwl(1),i+j-1)
              Rmodulo_ord(nwl(2),k)=Rmodulo(nwl(2),i+j-1)
            end if
         end do
      end do
                
      do i=1, nrefl, npop
         nr = 0
         sumE1 = 0.0 
         sumE2 = 0.0         
         do j=1,npop
            if (i+j-1 <= nrefl) then
               nr = nr + 1
               k = ipun_Rmodulo(i+j-1)
               sumE1 = sumE1 + Rmodulo_ord(nwl(1),k)**2
               sumE2 = sumE2 + Rmodulo_ord(nwl(2),k)**2
            endif
         end do
         sumE1 = sumE1 / nr
         sumE2 = sumE2 / nr
         write(lo,*) nr,sumE1,sumE2
      end do
         
 6666 continue   
      loop_nrefl : do inrc=1, nrefl
 
          kh = khl(1,inrc)
          kk = khl(2,inrc)
          kl = khl(3,inrc)
          
          if (kh==0 .and. kk==0 .and. kl==0) then
             exit loop_nrefl
          end if
          
          esq = 0.0
          
          jcode = mkang(inrc)
          rho = rhof(pp,kh,kk,kl)
          i1(1) = kh
          i1(2) = kk
          i1(3) = kl
          call cmult2002(i1,eps,multi)     !dritan

   
          e_piu(1) = Rmodulo_ord(nwl(1),inrc)
          e_piu(2) = Rmodulo_ord(nwl(2),inrc)
          f_piu(1) = Fmodulo_ord(nwl(1),inrc)
          f_piu(2) = Fmodulo_ord(nwl(2),inrc)
          
!          if (e_piu(1) < 0.01) e_piu(1) = 0.01
!          if (e_piu(2) < 0.01) e_piu(2) = 0.01

!    moltiplicazione dei valori di sigma_piu 
          do km=1,nWave
             k = nwl(km)
!
!             sigma_piu(k) = fact_sig * f_piu(k)     !per adesso!!!!!!!
!             sigma_piu(k) = 0.05 * f_piu(k)         !per adesso!!!!!!!

          end do
          
             sigma_piu(1) = fact_sig_e1 * f_piu(1)     !per adesso!!!!!!!
             sigma_piu(2) = fact_sig_e2 * f_piu(2)     !per adesso!!!!!!!
             
             
!          sigma_piuH = fact_sig * fx(inrc)          !per adesso!!!!!!!
          sigma_piuH = fact_sig * fcvet(inrc)          !per adesso!!!!!!!

          if (inr.eq.iperc) then
              jperc=jperc+1
              iperc=iperc+iperc0
              call scrper(' ',jperc,nperc)
          endif

         BWM = 0
         do k=1,numbWL
!            ebw(k) = exp(-BWilsonM(nwl(k))*rho)   
!            e2bw(k) = exp(-2.*BWilsonM(nwl(k))*rho)   
            BWM = BWM + BWilsonM(nwl(k))
         end do

         BWM = BWM / numbWL

         ebw0 = exp(-BWM*rho)
         e2bw0 = exp(-2*BWM*rho)
!   usa un B mediato per tutte le lunghezze d'onda
         do km=1,numbWL
            k = nwl(km)
            ebw(k) = ebw0
            e2bw(k) = e2bw0
         end do

         ji = ji + 1

         form1 = formM(rho,Sigma1,1)
         Sigma1_rho = form1 * eps * e2bw(1)

 !pgMAD130109
 !        form2 = formM(rho,Sigma2,1)
 !        Sigma2_rho = form2 * eps * e2bw(1)
 !pgMAD130109

         SigmaH_rho = 0.0
         do i=1,nAnom
            formh= formM2(rho,SigmaH,i,1)       !    e' inutile il richiamo a formM2
            SigmaH_rho = SigmaH_rho + formh * eps * e2bw(1)
         end do
         
         if (inrc == 5 .or. inrc == 6) then
             pippo = 0
         endif

         Sigma1H_rho = 0.0
         do i=1,nAnom
            form1h= formM2(rho,Sigma1H,i,1)       
            Sigma1H_rho = Sigma1H_rho + form1h * eps * e2bw(1)
         end do

         Sigma2_rho = Sigma1_rho + SigmaH_rho + 2* Sigma1H_rho
         
         Sigma12_rho = Sigma1_rho + Sigma1H_rho

         Sigma2H_rho = Sigma1H_rho + SigmaH_rho

         sig12 = Sigma12_rho / sqrt(Sigma1_rho*Sigma2_rho) 
         sig1H = Sigma1H_rho / sqrt(Sigma1_rho*SigmaH_rho) 
         sig2H = Sigma2H_rho / sqrt(Sigma2_rho*SigmaH_rho) 

         e1 = 1 + (sigma_piu(1) ** 2/ Sigma1_rho)        
         e2 = 1 + (sigma_piu(2) ** 2/ Sigma2_rho)        
         eH = 1 + (sigma_piuH ** 2/ SigmaH_rho)
         
         if (e1 > cutoff_e1_e2) e1 = cutoff_e1_e2
         if (e2 > cutoff_e1_e2) e2 = cutoff_e1_e2
!         if (eH > 1.01) eH = 1.01
                 
         e1 = 1.05
         e2 = 1.05
         eH = 1.05
         
!         e1 = 1.05 *(1.+  rho**1.5)
!         e2 = 1.05 *(1.+  rho**1.5)
!         eH = 1.05 *(1.+  rho**1.5)
         
         
!         if (e_piu(1) > 2.0) then
!            e1 = 1.005
!         elseif (e_piu(1) > 1.5) then
!            e1 = 1.008
!         elseif (e_piu(1) > 1.0) then
!            e1 = 1.012
!         elseif (e_piu(1) > 0.6) then
!            e1 = 1.020
!         elseif (e_piu(1) > 0.3) then
!            e1 = 1.030
!         elseif (e_piu(1) <= 0.3) then
!!            e1 = 1.050
!            e1 = 1.030
!         end if 
!         
!         if (e_piu(2) > 2.0) then
!            e2 = 1.005
!         elseif (e_piu(2) > 1.5) then
!            e2 = 1.008
!         elseif (e_piu(2) > 1.0) then
!            e2 = 1.012
!         elseif (e_piu(2) > 0.6) then
!            e2 = 1.020
!         elseif (e_piu(2) > 0.3) then
!            e2 = 1.030
!         elseif (e_piu(2) <= 0.3) then
!!            e2 = 1.050
!            e2 = 1.030
!         end if 
!         
!         if (e_piu(1) > 2.0) then
! !           e1 = 1.050
!            e2 = 1.030
!        elseif (e_piu(1) > 1.5) then
!            e1 = 1.030
!         elseif (e_piu(1) > 1.0) then
!            e1 = 1.020
!         elseif (e_piu(1) > 0.6) then
!            e1 = 1.012
!         elseif (e_piu(1) > 0.3) then
!            e1 = 1.008
!         elseif (e_piu(1) <= 0.3) then
!            e1 = 1.005
!         end if 
!         
!         if (e_piu(2) > 2.0) then
!!            e2 = 1.050
!            e2 = 1.030
!         elseif (e_piu(2) > 1.5) then
!            e2 = 1.030
!         elseif (e_piu(2) > 1.0) then
!            e2 = 1.020
!         elseif (e_piu(2) > 0.6) then
!            e2 = 1.012
!         elseif (e_piu(2) > 0.3) then
!            e2 = 1.008
!         elseif (e_piu(2) <= 0.3) then
!            e2 = 1.005
!         end if 
         
         if (i1(1) == 6 .and. i1(2) == 7 .and. i1(3) == -2) then
             ferma = 1
         endif
         
!         if (i1(1) == 4 .and. i1(2) == 10 .and. i1(3) == -4) then
!             ferma = 1
!         endif

CCCCCCCCCC            Calcolo detL   e LAMBDA come da lavoro CCCCCCCCCCCCCCCC

         detL1 = Sigma1_rho * eH * (e1*e2-1) + 
     *           SigmaH_rho * e1 * (e2*eH-1) +
     *         2*Sigma1H_rho * (e1*e2*eH-e1-eH+1)
     
         detL2 = Sigma1_rho * (e1+e2-2) +
     *           SigmaH_rho * (e2+eH-2) + 2 * Sigma1H_rho*(e2-1)
     
         detL = Sigma1_rho * SigmaH_rho * detL1 - Sigma1H_rho**2 * detL2
         
         detL = detL / (e1*e2*eH* Sigma1_rho * Sigma2_rho * SigmaH_rho)
         
         ALAMBDA_f = 1./ (e1*e2*eH*detL)
         
         ALAMBDA12_num = Sigma1H_rho**2 + SigmaH_rho*Sigma1H_rho*(1-eH)-
     *                  Sigma1_rho*SigmaH_rho*eH
         ALAMBDA12_den = sqrt(Sigma1_rho*Sigma2_rho) * SigmaH_rho
         
         ALAMBDA12 = ALAMBDA_f * ALAMBDA12_num / ALAMBDA12_den
                  
         ALAMBDA13_num = Sigma1H_rho**2*(1-2*e2)+SigmaH_rho*Sigma1H_rho*
     *                  (1-e2)+Sigma1_rho*Sigma1H_rho*(1-e2)+
     *                  Sigma1_rho*SigmaH_rho
     
         ALAMBDA13_den = sqrt(Sigma1_rho*SigmaH_rho) * Sigma2_rho
         
         ALAMBDA13 = ALAMBDA_f * ALAMBDA13_num / ALAMBDA13_den
         
         ALAMBDA23_num = Sigma1H_rho**2+Sigma1_rho*Sigma1H_rho*(1-e1)-
     *                  Sigma1_rho*SigmaH_rho*e1
     
         ALAMBDA23_den = sqrt(Sigma2_rho*SigmaH_rho) * Sigma1_rho
         
         ALAMBDA23 = ALAMBDA_f * ALAMBDA23_num / ALAMBDA23_den
     
         
     
         AK(:,:) = 0.0
         AK(1,1) = 1.
         AK(1,2) = sig12 / sqrt(e1*e2)
         AK(1,3) = sig1H / sqrt(e1*eH)
         AK(2,3) = sig2H / sqrt(e2*eH)
         AK(2,2) = 1.
         AK(3,3) = 1.
         AK(2,1) = AK(1,2)
         AK(3,1) = AK(1,3)
         AK(3,2) = AK(2,3)
         
!    calcolo determinante matrice L
   
        detnostro = ak(1,1)*ak(2,2)*ak(3,3) + ak(1,2)*ak(2,3)*ak(3,1) +
     *              ak(2,1)*ak(3,2)*ak(1,3) - ak(1,3)*ak(2,2)*ak(3,1) -
     *              ak(1,2)*ak(2,1)*ak(3,3) - ak(2,3)*ak(3,2)*ak(1,1)
             
         do ii=1,3
            do jj=1,3
               Dum(ii,jj) = AK(ii,jj)
            end do
         end do
         nord1 = 3
         call det_MAD(Dum,ndim,nord1,d1)

         if (detL < 0.0) then
           write (lo,4255) detL, detnostro,d1
 4255      format(/,'  Valore del detL negativo =',3f20.8)
         end if
         
!    calcolo determinante matrice L
         
         do i=1,3
           do j=1,3
             AK(i+3,j+3) = AK(i,j)
           end do
         end do

        
         do ii=1,6
            do jj=1,6
               Dum(ii,jj) = AK(ii,jj)
            end do
         end do

         nord = 6
                  
         call matinv(Dum,AKL,ndim,nord)

! ================================== S T A M P E =============================
!         if (kh.eq.2.and.kk.eq.-3.and.kl.eq.2)then
!             pipp = 1
!         else
             pipp = 0
!         endif

         if (pipp.eq.1) then
            write(lo,3524) inrc,kh, kk, kl,
!     *          (f_piu(nwl(k)), e_piu(nwl(k)),k=1,numbWL)
     *          (f_piu(k), e_piu(k),k=1,numbWL)
 3524       format(i8,')',3i4,4(2(f10.2,f10.5,2x),2x))
 
            write(lo,'(1h )')
            write(lo,203)
  203       format('   h   k  l     e+(1)    sigma+(1)  ',
     *         'e+(2)    sigma+(2)')
            write(lo,'(3i4,8f10.2)')kh,kk,kl,
!     *            (e_piu(nwl(k)), sigma_piu(nwl(k)),k=1,numbWL)
     *            (e_piu(k), sigma_piu(k),k=1,numbWL)
            write(lo,'(1h )')
            write(lo,'(9h matrice:)')
            do k=1,nord
               write(lo,'(18e16.9)') (AK(k,j),j=1,nord)
            end do

            do ii=1,nord
               do jj=1,nord
                  Dum(ii,jj) = AK(ii,jj)
               end do
            end do
            write(lo,'(1h )')
            call det_MAD(Dum,ndim,nord,d)
            
            detK = (e1*e2*eH - e1*sig2H**2 - e2*sig1H**2 - eH*sig12**2
     *             + 2*sig12*sig1H*sig2H)**2 / (e1*e2*eH)**2 
                      
            write(lo,'(4h d =,2e14.7)') d, detK
            write(lo,'(1h )')
            
 
            write(lo,'(8h inversa:)')
            do k=1,nord
               write(lo,'(18e16.9)') (AKL(k,j),j=1,nord)
            end do
            do ii=1,nord
               do jj=1,nord
                  Dum(ii,jj) = AKL(ii,jj)
               end do
            end do
            call det_MAD(Dum,ndim,nord,d)
            write(lo,'(4h d =,e14.7)') d
            do ii=1,nord
               do jj=1,nord
                  Dum(ii,jj) = 0.
                  do kkk=1,nord
                     Dum(ii,jj) = Dum(ii,jj) + AK(ii,kkk) * AKL(kkk,jj)
                  end do
               end do
            end do
            write(lo,'(10h prodotto:)')
            do k=1,nord
               write(lo,'(18e16.9)') (Dum(k,j),j=1,nord)
            end do
         end if
         

! ===========================  F I N E    S T A M P E =======================


         AL12 = AKL(1,2)
         AL13 = AKL(1,3)
         AL23 = AKL(2,3)
         if (AL13*AL23 > 0.0001) then
            non_opposto = non_opposto + 1 
!            write(lo,'(a)')' AL13 non opposto ad AL23'
!            stop 9999
         else
            Diff = abs(AL13) - abs(AL23)
            Amedia = (abs(Al13) + abs(AL23)) /2.
            if (diff > 0.1*Amedia) Then
!               write (lo,1133) inrc,kh,kk,kl,AL13,AL23,diff/Amedia
! 1133           format(' (',i5,')',3i6,3f10.3)                 
            endif
         endif
         
         D12 = AL12 / sqrt(e1*e2)
         D13 = AL13 / sqrt(e1*eH)
         D23 = AL23 / sqrt(e2*eH)
         erreh = evet(inrc)
         G = -2*(D13*e_piu(1) + D23*e_piu(2))*erreh
         
         
!!!!!!     calcolo  G semplificato !!!!!!

         R2 = e_piu(2)
         R1primo = e_piu(1)* (sqrt(Sigma1_rho) / sqrt(Sigma2_rho))
         RHprimo = erreh * (sqrt(SigmaH_rho) / sqrt(Sigma2_rho))
         
         G1 = (2./(eH *(e1*e2-1)))
         G2 = (R2-R1primo)* RHprimo
         G_nuovo = G1 * G2
         
!         risoluz= 0.5/rho
!        if ( risoluz < 1.7 .and. risoluz > 1.25) then
!             fact_rid = 0.444444 *risoluz + 0.244444
!             G_nuovo = G_nuovo * fact_rid
!         else if (risoluz <= 1.25) then
!             fact_rid = 5.454545 *risoluz - 6.0181818
!             G_nuovo = G_nuovo * fact_rid
!         end if                
         
         
!!!!!!     calcolo  G semplificato !!!!!!


         GMad(inrc) = G
         
         
         GMad_nuovo(inrc) = G_nuovo
         
         
         
!!!!!!   correlazioni tra (R2 - R1primo)veri e  (R2 - R1primo)osservati

         do 8866 ii = 1,nrefl
            do k =1,3
              if (i1(k) /= indHKL(ii,k)) then
                 go to 8866
              end if
            end do
            if (i1(1) == 7 .and. i1(2) == 5 .and.i1(3)== -2)then
               pippo = 1
            end if
            R1primo_vero=evero(inrc)*(sqrt(Sigma1_rho)/sqrt(Sigma2_rho))
            Diff_vero(ii) = evero_anom(inrc) - R1primo_vero
            Diff_osse(ii) = R2 - R1primo
            R1o(ii) = e_piu(1)
            R2o(ii) = e_piu(2)
            R1c(ii) = evero(inrc)
            R2c(ii) = evero_anom(inrc)
            R1pc(ii) = R1primo_vero
            R1po(ii) = R1primo
            if (i1(1) ==2 .and.i1(2)==-5.and. i1(3)==2) then
              pii= 1
            endif
8866    continue 
                    
!!!!!!   correlazioni tra (R2 - R1primo)veri e  (R2 - R1primo)osservati
         
!         GMad (inrc) = abs(G)
         
         iphaz(inrc) = iphazo(inrc)
         iast = ' '
         if (G < 0.0) then
            iast = '*'
            iphaz(inrc) = iphazo(inrc) + 180
            iphaz(inrc) = mod(iphaz(inrc),360)
            if (iphaz(inrc).eq.0) then
               iphaz(inrc) = 360
            end if
         endif
         
         
         iphaz_Gnuovo(inrc) = iphazo(inrc)
         iast = ' '
         if (G_nuovo < 0.0) then
            iast = '*'
            iphaz_Gnuovo(inrc) = iphazo(inrc) + 180
            iphaz_Gnuovo(inrc) = mod(iphaz_Gnuovo(inrc),360)
            if (iphaz_Gnuovo(inrc).eq.0) then
               iphaz_Gnuovo(inrc) = 360
            end if
         endif        
!         if (inrc == 5 .or. inrc == 6) then
!         if (G<0.00) then
!           write (lo,2233) inrc,kh,kk,kl,ex(inrc),evet(inrc),
!     *                     iphazo(inrc),iphaz(inrc),iast
! 2233 format(' (',i5,')',3i5,' E0a=',f10.5,'  RH=',f10.5,' Phi_old(RH)='
!     *       ,i6, ' Phi_new(RH)=',i6,a1,/)
!           write (lo,2234) inrc,kh,kk,kl,e_piu(1),sigma_piu(1),e_piu(2),
!     *                     sigma_piu(2)                             
! 2234 format(' (',i5,')',3i5,' e+1/sig+1=',2f10.5,' e+2/sig+2=',2f10.5/)
!           write (lo,2236) inrc,kh,kk,kl,Sigma1_rho,Sigma2_rho,
!     *                                  SigmaH_rho,Sigma1H_rho
! 2236      format(' (',i5,')',3i5,4e15.8,/) 
!         endif

         istampa = 0
      
      
         if (AL12 > 0.0 .or. AL13 < 0.0 .or. AL23 > 0.0) istampa = 1
      
         if (abs(AL12) < abs(AL13) .or. abs(AL12) < abs(AL23))istampa=1
      
         if (abs(AL13) < abs(AL23)) istampa = 1
      
 !        if (istampa == 1) then
 !           write (lo,2239) kh,kk,kl,AL12,AL13,AL23,e_piu(1),e_piu(2),
 !    *                    evet(inrc)
 !2239       format(3i5,' La12, La13, La23=',3e15.8,' R1,R2,RH=',3f7.3)
 !        end if   
      
!BARI 14/1/08 nuova formula

         Q1 = 2 * D12 * e_piu(1) * e_piu(2)       
         Q2 = 2 * D23 * e_piu(2) * erreh
         D1Q1 = dbes(Q1)
         D1Q2 = dbes(Q2)
         D1Q = D1Q1 * D1Q2
         Q = dbesinv(D1Q)
         
!         if (Q > 99.99) then
!            Q = abs((Q1 +Q2)) / 2.
!         end if
         
         S = -2 * D13 * e_piu(1) * erreh + Q       
         iphaz_S_old(inrc) = iphazo(inrc)
         if (S < 0.0) then
            iphaz_S_old(inrc) = iphazo(inrc) + 180
            iphaz_S_old(inrc) = mod(iphaz_S_old(inrc),360)
            if (iphaz_S_old(inrc).eq.0) then
               iphaz_S_old(inrc) = 360
            end if
         endif
         SMad(inrc) = S
         
!!!!!!     calcolo  S semplificato !!!!!!
         
         Q1 = -2. / (eH*(e1*e2-1))  * R1primo * e_piu(2)       
         Q2 = -2. / (eH*(e1*e2-1))  * e_piu(2)* RHprimo 
         D1Q1 = dbes(Q1)
         D1Q2 = dbes(Q2)
         D1Q = D1Q1 * D1Q2
         Q = dbesinv(D1Q)
         S_new = -2. / (eH*(e1*e2-1))* R1primo * RHprimo + Q       
         iphaz_S_new(inrc) = iphazo(inrc)
         if (S_new < 0.0) then
            iphaz_S_new(inrc) = iphazo(inrc) + 180
            iphaz_S_new(inrc) = mod(iphaz_S_new(inrc),360)
            if (iphaz_S_new(inrc).eq.0) then
               iphaz_S_new(inrc) = 360
            end if
         endif
         SMad_new(inrc) = S_new
         
!!!!!!     calcolo  S semplificato !!!!!!
        


         wt(inrc) = 0.0
         if (erreh .ne. 0.0) then
!            wt(inrc) = 1.0
!            if (G_nuovo > 0.0) then
!               G_nuovo = G_nuovo /10.
!            end if
            wt(inrc) = dbes(abs(G_nuovo))
!            wt(inrc) = dbes(abs(S_new))
         end if 
         
        
         if (e_piu(1) < 0.1) then
             wt(inrc) = 0.0
         end if
         
       
         if (wt(inrc) == 1 ) then
         if ( D13*e_piu(1) + D23*e_piu(2) > 0.0 ) then
            ncount_pos = ncount_pos + 1
         else
            ncount_neg = ncount_neg + 1
         end if
         end if

!         
!         if (knw == 1 .and. iphaz_S_old(inrc).ne.ipub(inrc) .and.
!     *     wt(inrc) == 1.0) then                                   !pgMAD050208
!         if (knw == 1 .and. iphaz_Gnuovo(inrc).ne.ipub(inrc) .and.
!     *     wt(inrc) == 1.0) then                                    !pgMAD050208
!         if (knw == 1 .and. S_new.gt.0.0 .and.
!     *     wt(inrc) == 1.0) then                                    !pgMAD050208
         if (knw == 1 .and. G_nuovo.gt.1.4 .and.
     *     wt(inrc) > 0.0) then                                    !pgMAD050208
     
!         if (knw == 1 .and. S<0.0  .and. S > -0.65.and.
!     *      wt(inrc) == 1.0) then                                         !pgMAD050208
!         if (knw == 1 .and. iphaz_S_old(inrc).ne.ipub(inrc) .and.
!     *      wt(inrc) == 1.0) then                                         !pgMAD050208
!         if (knw == 1 .and. wt(inrc) == 1.0) then                        !pgMAD050208
     
            numero_relazioni = numero_relazioni + 1
            
            risoluz= 0.5/rho
            TwoTheta = 2*asin(1.0729/(2.*risoluz))* rtod         
            write (lo,2237) kh,kk,kl,risoluz,TwoTheta,
     *                      f_piu(1),fvero(inrc),e_piu(1),
     *                      evero(inrc),ipub(inrc),e1
 2237     format(//,3i5,f8.5,f8.3,' F1, F1vero, E1, E1vero, PHI1, e1 =',
     *             4f10.5,i6,f10.7)
            write (lo,22371) f_piu(2), fvero_anom(inrc), e_piu(2), 
     *                       evero_anom(inrc), ipub_anom(inrc),e2
22371       format(31x,' F2, F2vero, E2, E2vero, PHI2, e2 =',
     *             4f10.5,i6,f10.7)
            write (lo,22372) fcvet(inrc),erreH,iphazo(inrc),eH
22372       format(31x,' F3, E3, PHI3, e3 =',16x,2(f10.5,10x),
     *             i6,f10.7,/)

            Zc = Sigma1_rho*SigmaH_rho - Sigma1H_rho ** 2
            if (Zc < 0.0) then
                write(6,*) ' Zc negativo'
            endif 
            
!     VERIFICA FORMULA

            Formula = Sigma1_rho  + SigmaH_rho + 2 * Sigma1H_rho
            Diff = Sigma2_rho - Formula
            
            write (lo,2238) Sigma1_rho,Sigma2_rho,
     *                       SigmaH_rho,Sigma1H_rho
2238        format(' Sigma1,Sigma2,Sigma3,Sigma13=',4f12.5)
            write(lo,22382)Diff
22382       format(' Verifica formula pag 5: Differenza = ',E14.7 )

            write (lo,22381) D12,D13,D23
22381       format(' LD12,LD13,LD23 =    ',3f12.5)
            write (lo,22383) G,G_nuovo,S,S_new
22383       format(' G,Gsem,S,Ssem =          ',4f12.5)
 
!            write (lo,12239) ALAMBDA12,ALAMBDA13,ALAMBDA23
!12239       format (' LD12,LD13,LD23     =',6f12.5)
           

            write (lo,22384) R2,R1primo,RHprimo
22384       format(' R2,R1primo,R3primo =',3f12.5)
            write (lo,22385) Q1,Q2,Q
22385       format(' Q1,Q2,Q =',3f12.5)
          
            i = inrc
!            if ( iphaz_S_old(i) /= ipub(i))then
!            if ( iphaz(i) /= ipub(i))then
            if ( iphaz_Gnuovo(i) /= ipub(i))then
!            if ( iphaz_S_new(i) /= ipub(i))then
               iast = '*'
            else
               iast = ' '
            end if
            write (lo,22351) iphazo(i),iphaz(i),iphaz_Gnuovo(i),
     *               iphaz_S_old(i),iphaz_S_new(i),evero(i),ipub(i),iast
22351 format(' Phi_sub=',i6,' Phi_G=',i6,' Phi_Gnuovo=',i6,' Phi_S=',i6,
     *      ' Phi_Snuovo=',i6,' Evero=',f10.5,' Phi_vero=',i6,a1)
        
            iast = ' '
            ias = ' '
            if (icent == 1 .and. iphaz(i)/=ipub(i) ) iast ='*'
            if (icent == 1 .and. iphaz_S_old(i)/=ipub(i) ) ias ='+'
!            write (lo,22351) ex(i),evet(i),
!     *         iphazo(i),iphaz(i),iphaz_S_old(i),evero(i),ipub(i),iast,ias
!22351 format(15x,' E0a=',f10.5,'  RH=',f10.5,
!     *      ' Phi_sub=',i6,' Phi_old=',i6,' Phi_new=',i6,' Evero=',f10.5,
!     *      ' Phi_vero=',i6,2a1)
        
         end if                       !pgMAD050208

      end do loop_nrefl
      
      npop = 100
    
      write(lo,*)' Correlazione tra (E2vero-E1prvero) e (E2oss-E1pross)'
      write(lo,*) ' Corr.   R      |R|               resol1    resol2   
     *%+   %-' 
!      write(lo,*)'  h    k    l     resol    R2vero    R1prvero    diff 
!     *  R2osse    R1prosse    diff'   
      res1 = 0.5/sqrt(rhov(1))
      do i=1, nrefl, npop
         noss = 0
         anum = 0.
         anum1 = 0.0
         denum = 0.
         denum1 = 0.0
         ipercentp = 0
         ipercentn = 0
         amed_R2c = 0.0
         amed_R1pc = 0.0
         amed_R2o = 0.0
         amed_R1po = 0.0
         amed_Diff_vero = 0.0
         amed_Diff_osse = 0.0
         
         do j=1,npop
            if (i+j-1 <= nrefl) then
               noss = noss + 1
               xf(noss) = Diff_vero(i+j-1)
               yf(noss) = Diff_osse(i+j-1)
               anum = anum + xf(noss)-yf(noss)
               anum1 = anum1 + abs(xf(noss)-yf(noss))
               denum = denum + abs(xf(noss))
               denum1 = denum1 + abs(xf(noss))
               if (xf(noss)*yf(noss) > 0.0) then
                     ipercentp = ipercentp + 1
               else
                     ipercentn = ipercentn + 1
               end if
               resz = 0.5/sqrt(rhov(i+j-1))
               if (resz.lt.1.8544.and.resz.gt.1.7675 .or.
     *             resz.lt.1.4805.and.resz.gt.1.4350 .or.
     *             resz.lt.1.2843.and.resz.gt.1.2594)then
     
                   amed_R2c = amed_R2c + R2c(i+j-1)
                   amed_R1pc = amed_R1pc + R1pc(i+j-1)
                   amed_R2o = amed_R2o + R2o(i+j-1)
                   amed_R1po = amed_R1po + R1po(i+j-1)
                   amed_Diff_vero = amed_Diff_vero + Diff_vero(i+j-1)
                   amed_Diff_osse = amed_Diff_osse + Diff_osse(i+j-1)
 !    
 !               write(lo,4455)indHKL(i+j-1,1:3),resz,
 !    *                R2c(i+j-1),R1pc(i+j-1),Diff_vero(i+j-1),      
 !    *                R2o(i+j-1),R1po(i+j-1),Diff_osse(i+j-1)
 4455           format(3i5,7f10.5)
               endif
            end if
         end do
         
               
               amed_R2c = amed_R2c / npop
               amed_R1pc = amed_R1pc / npop
               amed_R2o = amed_R2o / npop
               amed_R1po = amed_R1po / npop
               amed_Diff_vero = amed_Diff_vero  / npop
               amed_Diff_osse = amed_Diff_osse / npop                 
         
         
         call correl1(xf,yf,noss,risultato)
         erre = anum /denum * 100
         erre1 = anum1/denum1 * 100
         res2 = 0.5/sqrt(rhov(i+noss-1))
         ipercentp = ipercentp*100./npop
         ipercentn = ipercentn*100./npop
         
!         write(lo,'(25x,6f10.5)') amed_R2c,amed_R1pc,amed_Diff_vero,
!     *                      amed_R2o,amed_R1po,amed_Diff_osse  
         write(lo,'(f7.4,2f7.1,2i6,2f9.4,2i5)')risultato,erre,erre1,i,
     *      i+noss-1,res1,res2,ipercentp,ipercentn
         res1 = res2
      end do

      
      write(6,*) ' NUMERO_ RELAZIONI = ', numero_relazioni
      write(6,*) ' NUMERO G POSITIVI ',ncount_neg      
      write(6,*) ' NUMERO G NEGATIVI ',ncount_pos      
      write(6,*) ' NUMERO NON OPPOSTI',non_opposto      
      
!      if (knw == 1) then           
!        do i=1,nrefl
!          iast = ' '
!          ias = ' '
!          if (icent == 1 .and. iphaz(i)/=ipub(i) ) iast ='*'
!          if (icent == 1 .and. iphaz_S_old(i)/=ipub(i) ) ias ='+'

!         write (lo,2235) i,khl(1,i),khl(2,i),khl(3,i),ex(i),evet(i),
!     *         iphazo(i),iphaz(i),iphaz_S_old(i),evero(i),ipub(i),iast,ias
! 2235 format(' (',i5,')',3i6,' E0a=',f10.5,'  RH=',f10.5,
!     *     ' Phi_sub=',i6,' Phi_old=',i6,' Phi_new=',i6,' Evero=',f10.5,
!     *     ' Phi_vero=',i6,2a1)

!       write(lo,2235) i,khl(1,i),khl(2,i),khl(3,i),Rmodulo_ord(1,i),
!     *         Fmodulo_ord(1,i),Rmodulo_ord(2,i),Fmodulo_ord(2,i),
!     *         ipub(i),iphaz_S_old(i),wt(i),evet(i)
! 2235 format(i4,')',3i3,4f10.5,2i6,2f10.5)
         
!        end do
!      end if                       

      wt_save(1:nrefl) = wt(1:nrefl)

      if (knw==1) then
!         nbru = 1
!         izero = 0
!         ifmin = 1
!         call examin(nbru,khl,iphazo,ipub,nrefl,izero,wt,ifmin)
!         call examin(nbru,khl,ipub,iphazo,nrefl,izero,wt,ifmin)
!         nbru = 2
!         call examin(nbru,khl,iphaz,ipub,nrefl,izero,wt,ifmin)
!         call examin(nbru,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
!         nbru = 3
!         call examin(nbru,khl,iphaz_S_old,ipub,nrefl,izero,wt,ifmin)
!         call examin(nbru,khl,ipub,iphaz_S_old,nrefl,izero,wt,ifmin)
      
         wt_segno(1:nrefl) = wt(1:nrefl)
         do i = 1,nrefl
           if (wt(i) /= 0.0 ) then
             if ( GMad(i) < 0.0 ) then
!                wt_segno(i) = -1.0
                wt_segno(i) = -wt(i)
             else if ( GMad(i) > 0.0 )then
!                wt_segno(i) = 1.0
                wt_segno(i) = wt(i)
            end if
           end if 
         end do           
            
         nbru = 4
         izero = 0
         ifmin = 1
         call examin(nbru,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
         tirang = 'GMad-str'
         ipher = 1
!         call pherrdisNew(tirang,GMad,khl,nrefl,izero,
!     *                    ipub,iphaz,wt,10,0.0,shiftexam,ipher)
!  statistica positiva
         do i = 1,nrefl
            if ( wt_segno(i) < 0.0 )then 
             wt(i) = 0.0
            else if (wt_segno(i) > 0.0) then
!             wt(i) = 1.0  
             wt(i) = wt_segno(i)  
            endif 
         end do
         tirang = 'GMad-pos'
         
         call pherrdisNew(tirang,GMad,khl,nrefl,izero,
     *                    ipub,iphaz,wt,10,0.0,shiftexam,ipher)
        
!  statistica negativa
  
         do i = 1,nrefl
            GMad (i) = abs(GMad(i))
            if ( wt_segno(i) > 0.0 ) then
               wt(i) = 0.0
            else if ( wt_segno(i) < 0.0) then
!               wt(i) = 1.0
               wt(i) = abs(wt_segno(i))  
            end if    
         end do
         tirang = 'GMad-neg'
         
         call pherrdisNew(tirang,GMad,khl,nrefl,izero,
     *                    ipub,iphaz,wt,10,0.0,shiftexam,ipher)
         
         wt(1:nrefl) = wt_save(1:nrefl)
          
         wt_segno(1:nrefl) = wt(1:nrefl)
         do i = 1,nrefl
           if (wt(i) /= 0.0 ) then
             if ( GMad_nuovo(i) < 0.0 ) then
!                wt_segno(i) = -1.0
                wt_segno(i) = -wt(i)
             else if ( GMad_nuovo(i) > 0.0 )then
!                wt_segno(i) = 1.0
                wt_segno(i) = wt(i)
             end if
           end if 
         end do           
         nbru = 44
         izero = 0
         ifmin = 1
         call examin(nbru,khl,ipub,iphaz_Gnuovo,nrefl,izero,wt,ifmin)
         tirang = 'Gnuo-str'
         ipher = 1
!         call pherrdisNew(tirang,GMad_nuovo,khl,nrefl,izero,
!     *                    ipub,iphaz_Gnuovo,wt,10,0.0,shiftexam,ipher)
!  statistica positiva
         do i = 1,nrefl
            if ( wt_segno(i) < 0.0 )then 
             wt(i) = 0.0
            else if (wt_segno(i) > 0.0) then
!             wt(i) = 1.0  
             wt(i) = wt_segno(i) 
            endif 
         end do
         tirang = 'Gnew-pos'
         
         call pherrdisNew(tirang,GMad_nuovo,khl,nrefl,izero,
     *                    ipub,iphaz_Gnuovo,wt,10,0.0,shiftexam,ipher)
        
!  statistica negativa
  
         do i = 1,nrefl
            GMad_nuovo (i) = abs(GMad_nuovo(i))
            if ( wt_segno(i) > 0.0 ) then
               wt(i) = 0.0
            else if ( wt_segno(i) < 0.0) then
!               wt(i) = 1.0
               wt(i) = abs(wt_segno(i))
            end if    
         end do
         tirang = 'Gnew-neg'
         
         call pherrdisNew(tirang,GMad_nuovo,khl,nrefl,izero,
     *                    ipub,iphaz_Gnuovo,wt,10,0.0,shiftexam,ipher)
     
    
         wt(1:nrefl) = wt_save(1:nrefl)
          
         wt_segno(1:nrefl) = wt(1:nrefl)
         do i = 1,nrefl
           if (wt(i) /= 0.0 ) then
             if ( SMad(i) < 0.0 ) then
                wt_segno(i) = -wt(i)
             else if ( SMad(i) > 0.0 )then
                wt_segno(i) = wt(i)
             end if
           end if 
         end do           
     
         
         nbru = 5
         izero = 0
         ifmin = 1
         call examin(nbru,khl,ipub,iphaz_S_old,nrefl,izero,wt,ifmin)
         tirang = 'SMad-str'
         ipher = 1
!         call pherrdisNew(tirang,SMad,khl,nrefl,izero,
!     *                    ipub,iphaz_S_old,wt,10,0.0,shiftexam,ipher)

!  statistica positiva
         do i = 1,nrefl
            if ( wt_segno(i) < 0.0 )then 
             wt(i) = 0.0
            else if (wt_segno(i) > 0.0) then
!             wt(i) = 1.0  
             wt(i) = wt_segno(i)  
            endif 
         end do
         tirang = 'SMad-pos'
         
         call pherrdisNew(tirang,SMad,khl,nrefl,izero,
     *                    ipub,iphaz_S_old,wt,10,0.0,shiftexam,ipher)
        
!  statistica negativa
  
         do i = 1,nrefl
            SMad (i) = abs(SMad(i))
            if ( wt_segno(i) > 0.0 ) then
               wt(i) = 0.0
            else if ( wt_segno(i) < 0.0) then
!               wt(i) = 1.0
               wt(i) = abs(wt_segno(i))  
           end if    
         end do
         tirang = 'SMad-neg'
         
         call pherrdisNew(tirang,SMad,khl,nrefl,izero,
     *                    ipub,iphaz_S_old,wt,10,0.0,shiftexam,ipher)


         wt(1:nrefl) = wt_save(1:nrefl)
          
         wt_segno(1:nrefl) = wt(1:nrefl)
         do i = 1,nrefl
           if (wt(i) /= 0.0 ) then
             if ( SMad_new(i) < 0.0 ) then
                wt_segno(i) = -wt(i)
             else if ( SMad_new(i) > 0.0 )then
                wt_segno(i) = wt(i)
             end if
           end if 
         end do           
     
         
         nbru = 55
         izero = 0
         ifmin = 1
         call examin(nbru,khl,ipub,iphaz_S_new,nrefl,izero,wt,ifmin)
         tirang = 'SMad-str'
         ipher = 1
!         call pherrdisNew(tirang,SMad,khl,nrefl,izero,
!     *                    ipub,iphaz_S,wt,10,0.0,shiftexam,ipher)

!  statistica positiva
         do i = 1,nrefl
            if ( wt_segno(i) < 0.0 )then 
             wt(i) = 0.0
            else if (wt_segno(i) > 0.0) then
!             wt(i) = 1.0  
             wt(i) = wt_segno(i)  
            endif 
         end do
         tirang = 'Snew-pos'
         
         call pherrdisNew(tirang,SMad_new,khl,nrefl,izero,
     *                    ipub,iphaz_S_new,wt,10,0.0,shiftexam,ipher)
        
!  statistica negativa
  
         do i = 1,nrefl
            SMad_new (i) = abs(SMad_new(i))
            if ( wt_segno(i) > 0.0 ) then
               wt(i) = 0.0
            else if ( wt_segno(i) < 0.0) then
!               wt(i) = 1.0
              wt(i) = abs(wt_segno(i))
            end if    
         end do
         tirang = 'Snew-neg'
         
         call pherrdisNew(tirang,SMad_new,khl,nrefl,izero,
     *                    ipub,iphaz_S_new,wt,10,0.0,shiftexam,ipher)



      endif
      
      wt(1:nrefl) = wt_save(1:nrefl)
!      iphaz(1:nrefl) = iphaz_S_old(1:nrefl)
      
!      iphaz(1:nrefl) = iphaz_S_new(1:nrefl)
      iphaz(1:nrefl) = iphaz_Gnuovo(1:nrefl)
      
!      do i=1,nrefl
!         write(lo,1213) i,khl(1:3,i),ipub(i),iphaz(i),wt(i)
! 1213    format(i5,'*',3i4,2i5,f4.1)
!      enddo        

!    da scommentare per lavorare con gli E veri e fasi vere
!      iphaz(1:nrefl) = ipub(1:nrefl)
!      do i=1,nrefl
!         Rmodulo_ord(nwl(1),i)= evero(i)
!         Fmodulo_ord(nwl(1),i)= fvero(i)
!      end do
     
!      stop
            
      return

      end
c---------------------------------------------------
      subroutine SFCalc_Phasing 
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE MADStuff
      USE MadModule
      USE PhaseModule
      
      USE xdataMod, only : fx, ex
      
!      USE PhaseComRef
!
c----
c     structure factor calculation
c----
      integer i1(3)
      dimension xo(11),xn(11),keyx(10),shi(4)
      dimension x1(3),x2(3)
      character jstep, tirang * 11,nanalf*2,nome*256

      dimension ffnk(8)

      character cisp*2
      character *80 line, dire
      dimension vet(40),ivet(40)
      dimension       hkle(4,24)
      dimension xyzs_ano(5,10),bfac_ano(10)
!--
      write(lo,*) ' SFCALC_PHASING'

      sumfor = 0.
      sumfc = 0.

      sumfor_cs = 0.
      sumfc_cs = 0.


      itype = 0
      do jj=1,nAnom
         nats_ano= 0
         if (nAn(jj).ne.0) then
            do i=1,nats
              if (nkAnom(jj) == nz(i)/100) then
                 xo(1)=xyzs(1,i) 
                 xo(2)=xyzs(2,i)
                 xo(3)=xyzs(3,i)
                 iser=i
                 iactn=1
                 khead=0
                 ksp=kspecb(newvet,xo,xn,keyx,itype,iser,khead,iactn)
                 if (ksp < 0) then
                      xyzs_ano(5, i) = 1.0/float(keyx(10))
                 else
                      xyzs_ano(5, i) = xyzs(5, i)
                 endif      
                 nats_ano = nats_ano+1
                 xyzs_ano(1:4,nats_ano) =xyzs(1:4,i)
                 bfac_ano(nats_ano) = bfac(i)
              end if
            enddo
         endif
      enddo
      
!coordinate vere del frammento VERAPA      
!      xyzs_ano(1,nats_ano) = .1798
!      xyzs_ano(2,nats_ano) = .4565
!      xyzs_ano(3,nats_ano) = .8836

!coordinate vere del frammento NICKEL
!      nats_ano = 1      
!      xyzs_ano(1,nats_ano) = .5
!      xyzs_ano(2,nats_ano) = .28635
!      xyzs_ano(3,nats_ano) = .75
!      xyzs_ano(5,nats_ano) = 0.5

!coordinate vere del frammento PROVA   
!      xyzs_ano(1,nats_ano) = .3410
!      xyzs_ano(2,nats_ano) = .5980
!      xyzs_ano(3,nats_ano) = .2530
     
!coordinate vere del frammento Ferro 
!      xyzs_ano(1,nats_ano) = .0
!      xyzs_ano(2,nats_ano) = .0
!      xyzs_ano(3,nats_ano) = .0

!coordinate vere del frammento Platino        
!      xyzs_ano(1,nats_ano) = 0.66687 
!      xyzs_ano(2,nats_ano) = 0.31138
!      xyzs_ano(3,nats_ano) = 0.04895
!    
      loop_refl : do i=1,nrefl

         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)

         call cmult2002(i1,eps,multi)     !dritan

         rho=rhof(pp,i1(1),i1(2),i1(3))
         
!
!-- compute H*R and H*T
!
         do 250 j=1,nsym
            tt=1000.0
            do 230 l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               hkle(l,j)=0

               do 240 k=1,3
  240          hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)

  230       continue
            hkle(4,j)=tt
  250    continue

         fo=fx(i)
         fovet(i) = fx(i)
         
         act=0.0
         bct=0.0
         
         do jj=1,nAnom
            nkA = nkAnom(jj)
            ffnk(nkA) = fPrimoSecondo(jj,nwl(2),1)
!            ffnk(nkA) = cl(nkA)
!            do ii=1,4
!               ffnk(nkA) = ffnk(nkA) + al(ii,nkA) * exp(-bs(ii,nkA)*rho)
!            end do   
         end do

         sfj = 0.
         loop_atoms : do jj=1,nats_ano
            if (nz(jj).ne.0) then
                arg = -bfac_ano(jj)*rho
                effe = ffnk(nz(jj)/100)*exp(arg)
                tfocc = pts * effe * xyzs_ano(5,jj)
!                effe=pts*ffnk(nz(jj)/100)*exp(arg)
!                tfocc=effe*xyzs_ano(5,jj)
!                sfj = sfj + tfocc
                effeq = effe ** 2
                sfj = sfj + pts * effeq * xyzs_ano(5,jj)
c-----------------------
                att=0.0
                btt=0.0
                do  j=1,nsym
                   arg=amod(hkle(1,j)*xyzs_ano(1,jj)
     *                     +hkle(2,j)*xyzs_ano(2,jj)
     *                     +hkle(3,j)*xyzs_ano(3,jj)
     *                     +hkle(4,j),1.0)
                   iarg=int(36000.0*arg+0.5)+1
                   if (iarg.eq.36001) iarg=1
                   att=att+cost(iarg)
                   btt=btt+sint(iarg)
                enddo
                if (icent.eq.0) then
                    contc=att
                    conts=btt
                else
                    contc=2.0*att
                    conts=0.0
                endif
c-----------------------
                contc=contc*tfocc
                conts=conts*tfocc
                act=act+contc
                bct=bct+conts
            endif
         end do loop_atoms
!         sfj = sfj*sqrt(eps*nsym)  !dritan
         sfj = sqrt(sfj) * sqrt(eps*nsym)  !dritan
         args=act*act+bct*bct
         if (args.gt.0.000001) then
             fc=sqrt(args)
             faze=rtod*atan2(bct,act)+360.0
         else
             fc=0.0
             faze=0.0
         endif
        
         fcvet(i) = fc
!         fvero(i) = fc       

!         evero(i) = fc/sfj    
         evet(i) = fc/sfj
         

         iphazo(i) = mod(int(faze+0.5), 360)
         if (iphazo(i).eq.0) then
            iphazo(i) = 360
         end if


         sumfor=sumfor+fovet(i)
         sumfc=sumfc+fc
            
         if (mkang(i).ne.1) then
            sumfor_cs=sumfor_cs+fovet(i)
            sumfc_cs=sumfc_cs+fc
         end if

      end do loop_refl
      
      sumQ = 0
      nnrrff = 0
      do i=1,nrefl
         sumQ = sumQ + evet(i)*evet(i)
         nnrrff = nnrrff + 1
      end do
      sumQ = sumQ/nnrrff
      do i=1,nrefl
         evet(i) = sqrt(evet(i)**2/sumQ)
      end do
     
      scalan=sumfor/sumfc
      if(sumfc_cs.gt.0.00001) then
         scalan_cs=sumfor_cs/sumfc_cs
      else
         scalan_cs = 1.0
      end if

!      do i=1,nrefl
!         if (mkang(i).eq.1) then
!            fcvet(i) = fcvet(i) * scalan       ! fc riscalato su fo
!!           fvero(i) = fvero(i) * scalan       ! fc riscalato su fo    !pgMAD4     !
!         else
!            fcvet(i) = fcvet(i) * scalan_cs       ! fc speciali riscalato su fo speciali
!!            fvero(i) = fvero(i) * scalan_cs       ! fc speciali riscalato su fo speciali   !pgMAD4
!         end if
!!         write(lo,'(3i5,4f10.5,2x,i6)')khl(1:3,i),ex(i),fx(i),
!!     *                              evet(i),fcvet(i),iphazo(i)
!      end do

      n0 = 0
      n1 = 0
      n2 = 0
      do i=1,nrefl
         if (evet(i) <0.001) then
            n0 = n0 + 1
!            write(6,*) 'n0,e',n0,evet(i)
         else if(evet(i) < 1.1) then
            n1 = n1 + 1
!            write(6,*) 'n1,e',n1,evet(i)
         else
            n2 = n2 + 1
!            write(6,*) 'n2,e',n2,evet(i)
         end if
      end do
      

      return
      end 
c---------------------------------------------------
      subroutine SFCalc_StrutturaTot
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE MADStuff
      USE MadModule
      USE PhaseModule
      USE elements, only: pxen_from_specie,numelem
!
c----
c     structure factor calculation
c----
      integer i1(3)
      dimension xo(11),xn(11),keyx(10),shi(4)
      dimension x1(3),x2(3)
      character jstep, tirang * 11,nanalf*2,nome*256

      dimension ffnk(8)

      character cisp*2
      
      character *80 line, dire
      dimension vet(40),ivet(40)
      dimension       hkle(4,24)
      dimension xyzs_tot(5,300),bfac_tot(300),nz_tot(300)
!--
      write(lo,*) ' SFCAL_StrutturaTot'
      nats_tot = 0
      
!      nome = '\EXPO2007\StruttureANOM\prova\prova_tot.fra'
!      nome = '\EXPO2007\StruttureANOM\verapa\verapa_tot.fra'
!      nome = '\EXPO2007\StruttureANOM\nickel\nickel_tot.fra'
!      nome = '\EXPO2007\StruttureANOM\copper\copper_tot.fra'

      ipuu = index(fname(FC_FILE),'.')
      nome = fname(FC_FILE)(1:ipuu-1)//'_tot.fra'
      

c
      itype=2
      iform=1
      jop=jopen(44,nome,itype,iform,ierr)
      if (jop.lt.0) then
         return
      end if
      j = 0
      do
         j = j + 1
         read(44,'(a)',end = 20) line
         call cutst(line,lenp,dire,lend)
         call lcase(dire)
         read(dire(1:2),'(a2)') cisp
         iopt=0
         call getnum(line,vet,ivet,iv,iopt)
         if (iopt .ne. -1) then
            do i=1,iv
               xyzs_tot(i,j)= vet(i)
            enddo
         endif
         if (iv == 3) then
            xyzs_tot(4,j) = bt
            xyzs_tot(5,j) = 1.0
         end if
         if (iv == 4) then
            xyzs_tot(5,j) = 1.0
         end if

!corr         call lcase(cisp)
!corr         read(cisp,'(a2)') isp
         isp = pxen_from_specie(cisp)
         do i=1,numelem(celem)
!corr            if (isp.eq.nalf(i)) then
            if (isp.eq.celem(i)%ptab) then
               nz_tot(j) = i
            end if
         end do
         bfac_tot(j) = xyzs_tot(4,j)
      end do
   20 close(44)
      nats_tot = j - 1

      sumfor = 0.
      sumfc = 0.
      sumfor_cs = 0.
      sumfc_cs = 0.


      itype = 0
      do i=1,nats_tot
         xo(1)=xyzs_tot(1,i)
         xo(2)=xyzs_tot(2,i)
         xo(3)=xyzs_tot(3,i)
         iser=i
         iactn=1
         khead=0
         ksp=kspecb(newvet,xo,xn,keyx,itype,iser,khead,iactn)
         if (ksp < 0) xyzs_tot(5, i) = 1.0/float(keyx(10))
      enddo

	loop_refl : do i=1,nrefl
	
         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)

         call cmult2002(i1,eps,multi)     !dritan
         rho=rhof(pp,i1(1),i1(2),i1(3))

!
!-- compute H*R and H*T
!
         do 250 j=1,nsym
            tt=1000.0
            do 230 l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               hkle(l,j)=0

               do 240 k=1,3
  240          hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)

  230       continue
            hkle(4,j)=tt
  250    continue
      
         act=0.0
         bct=0.0
         
         do jj=1,numelem(celem)
            ffnk(jj) = celem(jj)%cl
            do ii=1,4
!corr               ffnk(jj) = ffnk(jj) + al(ii,jj) * exp(-bs(ii,jj)*rho)
               ffnk(jj) = ffnk(jj) 
     *                  + celem(jj)%al(ii) * exp(-celem(jj)%bs(ii)*rho)
            end do
         end do
        

         sfj = 0.
         loop_atoms : do jj=1,nats_tot
            if (nz_tot(jj).ne.0) then
                arg=-bfac_tot(jj)*rho
                effe=ffnk(nz_tot(jj))*exp(arg)
                tfocc=pts*effe*xyzs_tot(5,jj)
                effeq = effe ** 2
                sfj = sfj + pts * effeq * xyzs_tot(5,jj)
                
!                effe=pts*ffnk(nz_tot(jj))*exp(arg)
!                tfocc=effe*xyzs_tot(5,jj)
!                sfj = sfj + tfocc
c-----------------------
                att=0.0
                btt=0.0
                do  j=1,nsym
                   arg=amod(hkle(1,j)*xyzs_tot(1,jj)
     *                     +hkle(2,j)*xyzs_tot(2,jj)
     *                     +hkle(3,j)*xyzs_tot(3,jj)
     *                     +hkle(4,j),1.0)
                   iarg=int(36000.0*arg+0.5)+1
                   if (iarg.eq.36001) iarg=1
                   att=att+cost(iarg)
                   btt=btt+sint(iarg)
                enddo
                if (icent.eq.0) then
                    contc=att
                    conts=btt
                else
                    contc=2.0*att
                    conts=0.0
                endif
c-----------------------
                contc=contc*tfocc
                conts=conts*tfocc
                act=act+contc
                bct=bct+conts
            endif
         end do loop_atoms
!         sfj = sfj*sqrt(eps*nsym)  !dritan
         sfj = sqrt(sfj) * sqrt(eps*nsym)  !dritan
         args=act*act+bct*bct
         if (args.gt.0.000001) then
             fc=sqrt(args)
             faze=rtod*atan2(bct,act)+360.0
         else
             fc=0.0
             faze=0.0
         endif
         fvero(i) = fc      

         evero(i) = fc/sfj
         ipub(i) = mod(int(faze+0.5), 360)
         if (ipub(i).eq.0) then
            ipub(i) = 360
         end if
    

      end do loop_refl
      
      sumQ = 0
      nnrrff = 0
      do i=1,nrefl
         sumQ = sumQ + evero(i)*evero(i)
         nnrrff = nnrrff + 1
      end do
      sumQ = sumQ/nnrrff
      do i=1,nrefl
         evero(i) = sqrt(evero(i)**2/sumQ)
      end do

      return
      end
      
c---------------------------------------------------
      subroutine SFCalc_StrutturaTot_Anomala
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE MADStuff
      USE MadModule
      USE PhaseModule
      USE elements, only: pxen_from_specie,numelem
!      USE PhaseComRef
!
c----
c     structure factor calculation
c----
      integer i1(3)
      dimension xo(11),xn(11),keyx(10),shi(4)
      dimension x1(3),x2(3)
      character jstep, tirang * 11,nanalf*2,nome*256

      dimension ffnk(8)

      character cisp*2
      character *80 line, dire
      dimension vet(40),ivet(40)
      dimension       hkle(4,24)
      dimension xyzs_tot(5,300),bfac_tot(300),nz_tot(300)
!--
      write(lo,*) ' SFCAL_StrutturaTot_Anomala'
      nats_tot = 0
      
!      nome = '\EXPO2007\StruttureANOM\prova\prova_tot.fra'
!      nome = '\EXPO2007\StruttureANOM\verapa\verapa_tot.fra'
!      nome = '\EXPO2007\StruttureANOM\nickel\nickel_tot.fra'
!      nome = '\EXPO2007\StruttureANOM\copper\copper_tot.fra'

      ipuu = index(fname(FC_FILE),'.')
      nome = fname(FC_FILE)(1:ipuu-1)//'_tot.fra'

c
      itype=2
      iform=1
      jop=jopen(44,nome,itype,iform,ierr)
      if (jop.lt.0) then
         return
      end if
      j = 0
      do
         j = j + 1
         read(44,'(a)',end = 20) line
         call cutst(line,lenp,dire,lend)
         call lcase(dire)
         read(dire(1:2),'(a2)') cisp
         iopt=0
         call getnum(line,vet,ivet,iv,iopt)
         if (iopt .ne. -1) then
            do i=1,iv
               xyzs_tot(i,j)= vet(i)
            enddo
         endif
         if (iv == 3) then
            xyzs_tot(4,j) = bt
            xyzs_tot(5,j) = 1.0
         end if
         if (iv == 4) then
            xyzs_tot(5,j) = 1.0
         end if

!corr         call lcase(cisp)
!corr         read(cisp,'(a2)') isp
         isp = pxen_from_specie(cisp)
         do i=1,numelem(celem)
!corr            if (isp.eq.nalf(i)) then
            if (isp.eq.celem(i)%ptab) then
               nz_tot(j) = i
            end if
         end do
         bfac_tot(j) = xyzs_tot(4,j)
      end do
   20 close(44)
      nats_tot = j - 1

      sumfor = 0.
      sumfc = 0.
      sumfor_cs = 0.
      sumfc_cs = 0.


      itype = 0
      do i=1,nats_tot
         xo(1)=xyzs_tot(1,i)
         xo(2)=xyzs_tot(2,i)
         xo(3)=xyzs_tot(3,i)
         iser=i
         iactn=1
         khead=0
         ksp=kspecb(newvet,xo,xn,keyx,itype,iser,khead,iactn)
         if (ksp < 0) xyzs_tot(5, i) = 1.0/float(keyx(10))
      enddo

	loop_refl : do i=1,nrefl
	
         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)

         call cmult2002(i1,eps,multi)     !dritan
         rho=rhof(pp,i1(1),i1(2),i1(3))

!
!-- compute H*R and H*T
!
         do 250 j=1,nsym
            tt=1000.0
            do 230 l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               hkle(l,j)=0

               do 240 k=1,3
  240          hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)

  230       continue
            hkle(4,j)=tt
  250    continue
      
         act=0.0
         bct=0.0
         
         do jj=1,numelem(celem)
            ffnk(jj) = celem(jj)%cl
            do ii=1,4
!corr               ffnk(jj) = ffnk(jj) + al(ii,jj) * exp(-bs(ii,jj)*rho)
               ffnk(jj) = ffnk(jj) + 
     *                    celem(jj)%al(ii) * exp(-celem(jj)%bs(ii)*rho)
            end do
            do k=1,nAnom
!corr               if (kAnom(k).eq.nalf(jj)) then
               if (kAnom(k) == celem(jj)%ptab) then
                  ffnk(jj) = ffnk(jj) +  fPrimoSecondo(k,nwl(2),1)
               endif
            end do      
         end do

         sfj = 0.
         loop_atoms : do jj=1,nats_tot
            if (nz_tot(jj).ne.0) then
                arg=-bfac_tot(jj)*rho
                effe=ffnk(nz_tot(jj))*exp(arg)
                tfocc=pts*effe*xyzs_tot(5,jj)
                effeq = effe ** 2
                sfj = sfj + pts * effeq * xyzs_tot(5,jj)
                
!                effe=pts*ffnk(nz_tot(jj))*exp(arg)
!                tfocc=effe*xyzs_tot(5,jj)
!                sfj = sfj + tfocc
c-----------------------
                att=0.0
                btt=0.0
                do  j=1,nsym
                   arg=amod(hkle(1,j)*xyzs_tot(1,jj)
     *                     +hkle(2,j)*xyzs_tot(2,jj)
     *                     +hkle(3,j)*xyzs_tot(3,jj)
     *                     +hkle(4,j),1.0)
                   iarg=int(36000.0*arg+0.5)+1
                   if (iarg.eq.36001) iarg=1
                   att=att+cost(iarg)
                   btt=btt+sint(iarg)
                enddo
                if (icent.eq.0) then
                    contc=att
                    conts=btt
                else
                    contc=2.0*att
                    conts=0.0
                endif
c-----------------------
                contc=contc*tfocc
                conts=conts*tfocc
                act=act+contc
                bct=bct+conts
            endif
         end do loop_atoms
!         sfj = sfj*sqrt(eps*nsym)  !dritan
         sfj = sqrt(sfj) * sqrt(eps*nsym)  !dritan
         args=act*act+bct*bct
         if (args.gt.0.000001) then
             fc=sqrt(args)
             faze=rtod*atan2(bct,act)+360.0
         else
             fc=0.0
             faze=0.0
         endif
         fvero_anom(i) = fc      

         evero_anom(i) = fc/sfj
         ipub_anom(i) = mod(int(faze+0.5), 360)
         if (ipub_anom(i).eq.0) then
            ipub_anom(i) = 360
         end if
    

      end do loop_refl
      
      sumQ = 0
      nnrrff = 0
      do i=1,nrefl
         sumQ = sumQ + evero_anom(i)*evero_anom(i)
         nnrrff = nnrrff + 1
      end do
      sumQ = sumQ/nnrrff
      do i=1,nrefl
         evero_anom(i) = sqrt(evero_anom(i)**2/sumQ)
      end do
      

!      do i=1,nrefl
!         write(lo,'(3i5,2(f10.5,2x,f10.5,i6))')khl(1:3,i),
!     *             evero_anom(i),fvero_anom(i),ipub_anom(i)      
!      end do

      return
      end          
!-----------------------------------------------------------------------
      function dbes(x)
      real *8 dx1, dx2, dy1, dy2, dm, dp
      is=1
      if(x.lt.0.0) is=-1
      x1=abs(x)
      if(x1.lt.0.000001)  go to 200
      if(x1.le.2.9) go to 180
      if(x1.le.7.5) go to 160
      if(x1.le.20.) go to 140
      if(x1.le.39.) go to 120
      if(x1.le.45.) go to 100
      if(x1.le.55.) go to  80
      if(x1.le.65.) go to  60
      if(x1.le.80.) go to  40
      if(x1.le.99.) go to  20
!!!!!!!!!!!!      bes=1.*is
      dx1 = 99.0
      dx2 = 700.
      dy1 = 0.994937625172
      dy2 = 0.999285771579
      dm = (dy2-dy1) / (dx2-dx1)
      dp = dy1 - dx1 *dm
      dbes = dm * x1 + dp
      dbes = dbes * is
      return
   20 dbes=0.0000631*x1+.988652
      dbes=abs(dbes)*is
      return
   40 dbes=0.0000933*x1+.9862355
      dbes=abs(dbes)*is
      return
   60 dbes=0.00014*x1+.9832
      dbes=abs(dbes)*is
      return
   80 dbes=0.00021*x1+.97935
      dbes=abs(dbes)*is
      return
  100 dbes=0.0000666*x1+.9858026
      dbes=abs(dbes)*is
      return
  120 dbes=0.9459 +0.00187*x1-0.00002*x1*x1
      dbes=abs(dbes)*is
      return
  140 dbes=0.82227+0.02189*x1-0.00114*x1*x1+0.00002*x1*x1*x1
      dbes=abs(dbes)*is
      return
  160 dbes=0.444+0.19096*x1-0.02697*x1*x1+0.00135*x1*x1*x1
      dbes=abs(dbes)*is
      return
  180 dbes=-0.00718+0.5668*x1-0.12287*x1*x1 +0.008*x1*x1*x1
      dbes=abs(dbes)*is
      return
  200 dbes=0.
      return
      end
! ----------------------------------------------------------------------
      function dbesinv(y)
      real *8 dx1, dx2, dy1, dy2, dm, dp
      
      if (abs(y).lt.0.000001)  go to  200
      if (y.le.0.6989)  go to 180
      if (y.le.0.8666) go to 160
      if (y.le.0.9259)  go to 140
      if (y.le.0.9553)  go to 120
      if (y.le.0.9635)  go to 100
      if (y.le.0.9884) go to 90
      if (y.le.0.9888) go to 80
      if (y.le.0.9909) go to 70
      if (y.le.0.9923) go to 60
      if (y.le.0.9937) go to 50
      if (y.le.0.9949) go to 40
!!!!!!!!!!!!      besinv=100.
      dx1 = 99.0
      dx2 = 700.
      dy1 = 0.994937625172
      dy2 = 0.999285771579
      dm =  (dx2-dx1) / (dy2-dy1)
      dp = dx1 - dy1 * dm
      dbesinv = y * dm + dp
      return
   40 dbesinv=15833.333*y-15653.583
      return
   50 dbesinv=10714.285*y-10566.785
      return
   60 dbesinv=7142.8571*y-7022.8571
      return
   70 dbesinv=4761.9047*y-4663.5713
      return
   80 dbesinv=15000*y-14787
      return
   90 dbesinv=49773.46954-102737.23532*y+53033.83171*y*y
      return
  100 dbesinv=77576.4096-162332.52722*y+84935.62155*y*y
      return
  120 dbesinv=3117.15834-6767.58257*y+3681.64105*y*y
      return
  140 dbesinv=486.69735-1127.7574*y+658.80603*y*y
      return
  160 dbesinv=-82.06253+344.25645*y-478.71058*y*y+226.35886*y*y*y
      return
  180 dbesinv=-0.00252+2.1065*y-1.12674*y*y+3.09414*y*y*y
      return
  200 dbesinv=0
      return
      end
! ----------------------------------------------------------------------
      subroutine AggiornaMadSad()
!--read calc. phases from list 6 and fetch ipub
!
      USE General
      USE Liste
      USE MadModule
      USE Riflessi
!
!
      common/ylimi/nfl,lfl,nlx,dummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
!
      integer CalcPhase
      dimension vett(64),ivett(64)
      equivalence (vett,ivett)
      
!      write(lo,*) 'Aggiorna'
!--
      call xfl06
      ind = 1
      icontata = 0
!--fetch the next reflection
      do
         if (kldnr(in,vett) >= 0) then   ! legge tutti              
             vett(4) = Rmodulo(nwl(1),ind)
             vett(5) = FModulo(nwl(1),ind) ** 2
             vett(9) = ipub(ipun_Rmodulo(ind))                           !pgMAD200308
             ind = ind + 1
             
             if (vett(4) > 0.8) then
                icontata = icontata + 1
             endif
             
             
!             write(lo,12) ind-1,ivett(1:3),vett(4),sqrt(vett(5)),vett(9)
! 12          format(i5,'*',3i4,3f7.2)            
!--store the last reflection (da richiamare solo se si storizza su disco)
             call xslr(in,vett)
         else
             exit
         endif
      enddo
      
      
!      write(lo,*) ' numero di e>0.8  = ', icontata
      
!--da richiamare solo se si storizza su disco
      call xert
!
      return
      end
c     ------------------------------------------------------------------
c     sort on eme
      subroutine sortMAD(a,b,ic,ix,ew,ed,jp,wp,n)
      USE MadStuff, only: eme
      dimension a(n),ic(n),b(n),ix(n),ew(n),ed(n),jp(n),wp(n)
      int=2
   10 int=2*int
      if(int.lt.n) go to 10
      int=min0(n,(3*int)/4-1)
   20 int=int/2
      ifin=n-int
      do 70 ii=1,ifin
      i=ii
      j=i+int
      if(eme(i).ge.eme(j)) go to 70
      ee = eme(j)
      t=a(j)
      x=b(j)
      l=ix(j)
      id=ic(j)
      wb=ew(j)
      db=ed(j)
      ww=wp(j)
      jj=jp(j)
   40 eme(j) = eme(i)
      a(j)=a(i)
      b(j)=b(i)
      ix(j)=ix(i)
      ic(j)=ic(i)
      ew(j)=ew(i)
      ed(j)=ed(i)
      wp(j)=wp(i)
      jp(j)=jp(i)
      j=i
      i=i-int
      if(i.le.0) go to 60
      if(eme(i).lt.ee) go to 40
   60 eme(j) = ee
      a(j)=t
      b(j)=x
      ix(j)=l
      ic(j)=id
      ew(j)=wb
      ed(j)=db
      wp(j)=ww
      jp(j)=jj
   70 continue
      if(int.gt.1) go to 20
      return
      end
!     ------------------------------------------------------------------
      subroutine RileggiLi6
      USE General
      USE Symmetry
      USE Molcom
      USE MadModule
      USE MadStuff
      USE Riflessi
      USE xdataMod
c--
      character*256 fileh
      character*80 formt,filer
      character*256 line,buff
      dimension sigma_piu(5)
      
      dimension xf(3000), yf(3000)
           
      integer, allocatable :: jx(:)
      ALLOCATE (jx(1:3000),stat = ier3)
      
      jx(:) = 0
      do i=1,nrefl
         jx(i) = (khl(1,i) + 512) * ifat512a +
     *           (khl(2,i) + 512) * ifat512b +
     *           (khl(3,i) + 512)
      end do
      ipub_s(:) = 0
      iphaz_s(:) = 0
      wt_s(:) = 0
      ipub_s(1:nrefl) = ipub(1:nrefl)
      iphaz_s(1:nrefl) = iphaz(1:nrefl)
      wt_s(1:nrefl) = wt(1:nrefl)

!      do i=1,nrefl
!         write(lo,7193)i,khl(1:3,i),Rmodulo_ord(1,i),Fmodulo_ord(1,i),
!     *         Rmodulo_ord(2,i),Fmodulo_ord(2,i),ipub(i),iphaz(i),wt(i)
!      end do
 7193 format( i5,') ',3i3,4f10.5,2i6,f10.5)

      call AllocaRiflessi(2)
      nreflsav = nrefl
      nrefl = 3000
      call AllocaRiflessi(1)
      nrefl = nreflsav
      
      izero = 0

      ipub(:) = 0
      iphaz(:) = 0
      wt(:) = 0.
c
   20 continue
   
      itype=2
      iform=1
      
      ipuu = index(fname(BIN_FILE),'.')

      fileh = fname(BIN_FILE)(1:ipuu)//'li6'

      write(lo,'(/,80(1h*))')
      write(lo,'(a)') fileh
      write(lo,'(a)') ' Memorizzazione dei dati per la w.l. remota '
      write(lo,'(80(1h*),/)')
      jfile = 34
      if (jopen(jfile,fileh,itype,iform,ios).lt.0) go to 9000
      if (ios < 0) return

      nrefp=0
      do i=1,3
         ihmx(i) = -100
      end do
c
      call scrper(' Reading reflexions ',0,-1)
c
      rewind jfile

      nrmax=0
      nresm=0
      rhm=-99.9
      
     
      indHKL(:,:) = 0
      Mult(:) = 0
      TThet (:) = 0.0
      WHM(:) = 0.0
      SetFob(:,:) = 0.0
      puntatore(:) = 0
      ex(:) = 0.0
      fx(:) = 0.0
      fxsav(:) = 0.0
      ecx(:) = 0.0
      fcvet(:) = 0.0
      
   25 read(jfile,'(a)',end=7000) line
      buff=line
      call shift(buff,nchar)
      if (buff(1:1) == '>') then
          goto 25
      end if
      
      read(line,*) scaleWilsonM(1), bWilsonM(1)
      read(jfile,'(a)',end=7000) line
      read(line,*) scaleWilsonM(2), bWilsonM(2)
      
      nline = 0
      nr = 0
   30 nline=nline+1

      nr = nr + 1

      if (knw == 0) then
          read(jfile,'(a)',end=60,err=8000,iostat=ios) line
          read(line,'(4i4,i9,i4,7f15.4)')indHKL(nr,1:5),Mult(nr),
     *                                  TThet(nr),WHM(nr),SetFob(nr,1:5)
          read(jfile,'(a)',end=60,err=8000,iostat=ios) line
          read(line,'(4x,9f15.4)')puntatore(nr),ex_dum,fx_dum,
     *                     sigma_piu(1),
     *                     fxsav(nr),ex(nr),fx(nr),
     *                     sigma_piu(2)
      else
          read(jfile,'(a)',end=60,err=8000,iostat=ios) line
          read(line,'(4i4,i9,i4,7f15.4)')indHKL(nr,1:5),Mult(nr),
     *                                  TThet(nr),WHM(nr),SetFob(nr,1:5)
          read(jfile,'(a)',end=60,err=8000,iostat=ios) line
          read(line,'(4x,9f15.4)')puntatore(nr),ex_dum,fx_dum,
     *                     sigma_piu(1),
     *                     fxsav(nr),ex(nr),fx(nr),
     *                     sigma_piu(2)
      end if

   32 if (indHKL(nr,1).eq.0 .and.
     *    indHKL(nr,2).eq.0 .and.
     *    indHKL(nr,3).eq.0) go to 60
  
!      mkang(nr) = indHKL(nr,5)
      
      call geneq_old(1,indHKL(nr,1),indHKL(nr,2),indHKL(nr,3),idelt,
     *           mkang(nr),isgnn,id1,rhov(nr))
      
      resatt = 0.5 / sqrt(rhov(nr))

!      if (resatt.lt.resm) then
!         nresm=nresm+1
!         nr = nr - 1
!         go to 30
!      endif

c
      if (rhov(nr).gt.rhm) rhm=rhov(nr)

      nrefp=nrefp+1

      go to 30

   60 nr = nr - 1

!      do j= 1,nr
!         do i=1,nrefl
!            if (indHKL(j,1) == khl(1,i).and.indHKL(j,2) == khl(2,i).and.
!     *          indHKL(j,3) == khl(3,i)) then
!               iphaz(j) = iphaz_s(i)
!               wt(j) = wt_s(i)
!               exit
!            end if
!         end do
!      end do    
      
!      open(66,file='FeA_mio.hkl')
!      do i=1,nrefp
!         write(66,'(3i4,f8.2)')indHKL(i,1:3),fx(i)
!      end do
!      close (66)

      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)
 
      write(lo,300) nrefp
      if (nrmax.gt.0) write(lo,311) nrmax,th
      if (nresm.gt.0) write(lo,315) nresm,resm
      resol = 0.5 / sqrt(rhm)
      write(lo,330) ihmx,rhm,resol
  300 format(/, 8x,i7,'  input reflections')
  311 format(10x,i5,'  rejected reflections with s**2 .GT. ',f6.3)
  315 format(10x,i5,'  rejected reflections with resolution .LT. ',f5.2,
     *              ' Angstrom')
  330 format(   3x,3i4,'  maximum  h,k,l  values',
     *       /,8x,f7.4,'  maximum s**2 = (sin(theta)/lambda)**2',
     *       /,8x,f7.4,'  Angstrom resolution                  ')

      nrefl=nrefp
      rhomax=rhm

      resm = 0.5/sqrt(rhm)     

      do i=1, nrefl
         khl(1:3,i) = indHKL(i,1:3)
      end do

      if (knw == 1) then
         call SFCalc_StrutturaTot
      end if
      
      sumEo = 0.0
      sumEc = 0.0
      amedqq = 0.0
      amedqqq  = 0.0
      do i=1,nrefl      
         sumEo=sumEo+ex(i)
         amedqq = amedqq + ex(i)**2
         amedqqq = amedqqq + evero(i) ** 2
         sumEc=sumEc+evero(i)
      end do
      amedqq  = amedqq /nrefl   
      amedqqq  = amedqqq /nrefl
      scalaEcEorem = sumEc / sumEo
      npop = 100   
      write(lo,*)' Correlazione tra E1vero e E1osservato (scalaEcEorem)'
     *            ,scalaEcEorem
      write(lo,*) ' Corr.   R      |R|               resol1     resol2'
      
      res1 = 0.5/sqrt(rhov(1))
      do i=1, nrefl, npop 
         noss = 0
         anum = 0.
         anum1 = 0.0
         denum = 0.
         do j=1,npop
               if (i+j-1 <= nrefl) then
               noss = noss + 1
               xf(noss) = evero(i+j-1)
               yf(noss) = ex(i+j-1)
               anum = anum + xf(noss)- scalaEcEorem*yf(noss)
               anum1 = anum1 + abs(xf(noss)- scalaEcEorem*yf(noss))
               denum = denum + xf(noss)
               end if
               if (res1.lt.1.5551.and.res2.gt.1.4805)then
                  risoluz = 0.5/sqrt(rhov(i+j-1))
!                  write (lo,'(3i5,7f9.4)')khl(1:3,i+j-1),
!     *                   Rmodulo(1,i+j-1),Fmodulo(1,i+j-1),
!     *                   evero_anom(i+j-1),Rmodulo(2,i+j-1),
!     *                   Fmodulo(2,i+j-1),evero(i+j-1),risoluz     
               endif   
         end do
         call correl1(xf,yf,noss,risultato)
         erre = anum /denum * 100
         erre1 = anum1/denum * 100
         res2 = 0.5/sqrt(rhov(i+noss-1))
         write(lo,'(f7.4,2f7.1,2i6,2f9.4)')risultato,erre,erre1,i,
     *            i+noss-1,res1,res2
         res1 = res2
      end do     
       
      fxsav(1:nrefl) = fvero(1:nrefl)
      fcvet(1:nrefl) = fvero(1:nrefl)
      ecx(1:nrefl) = evero(1:nrefl)
      
      write(lo,'(80(1h*),/)')
      
!      fx(1:nrefl) = fvero(1:nrefl)            !per adesso
!      ex(1:nrefl) = evero(1:nrefl)
!      SetFob(1:nrefl,4) = fx(1:nrefl) ** 2
      
      ilist = 6
      call cancella(ilist)
      ifCreate = 1
      call CreaListaRiflessi
      
      ind = 0
      do i=1,nrefl      
         inp = (khl(1,i) + 512) * ifat512a +
     *         (khl(2,i) + 512) * ifat512b +
     *         (khl(3,i) + 512)
         ix(i)=inp
         iphi(i)=ipub(i)*32+mkang(i)
         ewx(i)=ex(i)
         edx(i)=ex(i)
   
         nvv(i)=IndHKL(i,4)
         if (nvv(i).ge.0) then
             if (nvv(i).gt.0) over=nvv(i)
             we(i)=1.0/sqrt(over)
         endif
         if (nvv(i).eq.1) then
             nvn(i)=0
             if (ind.gt.0) nvn(ind)=i-1
             ind=0
         elseif (nvv(i).gt.1) then
             if (ind.gt.0) nvn(ind)=i-1
             ind=i
         elseif (nvv(i).eq.0) then
             nvn(i)=i-1
         else
             if (ind.gt.0) nvn(ind)=i-1
             ind=0
             nvn(i)=-1
             we (i)=0.0
         endif
      end do
      if (ind.gt.0) nvn(ind)=nrefl
      do i=1,nrefl
         nvv(i)=nvn(i)*1024+int(we(i)*1000)
      enddo
      
      do i=1,nrefl
         jpunt(i)=i
      end do
      call sort(ex,fx,iphi,ix,ewx,ecx,jpunt,we,nrefl)

      call PreparaRiflessiOrdinati
!
         iy=67543
!
      call CreaListaRiflessiOrdinati(iy)

      call LeggiRiflessiOrdinati
            
      do i=1, nrefl
         inp = (khl(1,i) + 512) * ifat512a +
     *         (khl(2,i) + 512) * ifat512b +
     *         (khl(3,i) + 512)
         do j=1,nrefl
            if (jx(j)==inp) then
               iphaz(i) = iphaz_s(j)
!               iphaz(i) = ipub_s(j)         ! per adesso
               wt(i) = wt_s(j)
               exit
            end if
         end do
      enddo
!      ii = 0
!      do i=1,nrefl
!         if (wt(i) > 0.0 ) then
!         ii =  ii + 1
!         write(lo,7195)ii,khl(1:3,i),ex(i),fx(i),ipub(i),iphaz(i),wt(i)
!         endif
!      end do
! 7195 format( i5,') ',3i3,2f10.5,2i6,f10.5)

      return
 7000 continue
      write(Msg,7015) jfile
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
 7015 format(' EOF on channel #',i2,'. Reflections expected')
      go to 9020
c
c se dos ed errore allora continua
c
!corr 8000 if (kprog.lt.10 .and. ios.eq.6101) goto 60
 8000 if (ios > 0) goto 60
      write(Msg,8015) fileh(1:Lung(fileh)),ios,nline
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
 8015 format(' Read error on file ',a,' code =',i5,
     *       ' line number ',i5,'. Reflections expected')
      go to 9020

 9000 continue
      write(Msg,9015) ios,fileh(1:Lung(fileh))
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
 9015 format(' Open error, code =',i5,' file is ',a,
     *      '. Reflections expected')
 9020 continue
 9040 ier=-1
      return
      end
